



/* ControlTag Loader for Wiley 5c9d7251-7b10-4260-8df4-d859510ca122 */
(function(w, cs) {
  
  if (/Twitter for iPhone/.test(w.navigator.userAgent || '')) {
    return;
  }

  var debugging = /kxdebug/.test(w.location);
  var log = function() {
    
    debugging && w.console && w.console.log([].slice.call(arguments).join(' '));
  };

  var load = function(url, callback) {
    log('Loading script from:', url);
    var node = w.document.createElement('script');
    node.async = true;  
    node.src = url;

    
    node.onload = node.onreadystatechange = function () {
      var state = node.readyState;
      if (!callback.done && (!state || /loaded|complete/.test(state))) {
        log('Script loaded from:', url);
        callback.done = true;  
        callback();
      }
    };

    
    var sibling = w.document.getElementsByTagName('script')[0];
    sibling.parentNode.insertBefore(node, sibling);
  };

  var config = {"app":{"name":"krux-scala-config-webservice","version":"3.36.0","schema_version":3},"confid":"JMOONjNh","context_terms":[{"id":"JbN7AHD6","value":"Cancer Patient"},{"id":"JWriDk8Q","value":"Sedimentation Rate, Erythrocyte (ESR)"},{"id":"LXb4GyA7","value":"Compliance"},{"id":"JYFqh92C","value":"proteomic data analysis"},{"id":"JYFqh63u","value":"infection"},{"id":"JYtd22bi","value":"Radiation Therapy"},{"id":"JZlUFqxz","value":"Motor Cortex"},{"id":"JYDqkj0m","value":"Early tourniquet release"},{"id":"JWriDOvn","value":"Myeloblast"},{"id":"JYDqhtqn","value":"Basement Membrane"},{"id":"JpZWaJW1","value":"Transcriptomics"},{"id":"LXb4F3oD","value":"Advanced Planning and Scheduling (APS)"},{"id":"JWriBmZd","value":"Angiotensin Converting Enzyme Inhibitor"},{"id":"JYtd1hI1","value":"QUIPPS II"},{"id":"LXb4G9ZH","value":"Final Assembly Schedule"},{"id":"JYtd2587","value":"throat"},{"id":"JYDqkOoj","value":"Insulin Secretion"},{"id":"KHXCywBj","value":"Cholesterol/High Cholesterol"},{"id":"LXb4H1W6","value":"SAE"},{"id":"JY9Y-7u8","value":"G Protein Coupled Receptor"},{"id":"J9qqTp8J","value":"Rhythmia"},{"id":"JWriC6QN","value":"L.E. Cell"},{"id":"JWriAYj-","value":"Sarcoma symptoms"},{"id":"JpZWZsFX","value":"Immunology"},{"id":"JcX8BDiG","value":"Stint"},{"id":"JYtdzmja","value":"tissue culture "},{"id":"JYtd1dya","value":"functional mapping"},{"id":"JYtd0TXv","value":"antisense "},{"id":"JWriCjoO","value":"Hematin"},{"id":"JYDqkQm9","value":"Impaired Glucose Tolerance"},{"id":"JY9Y-6Zn","value":"N Methyl D Aspartate"},{"id":"JYtd0m1E","value":"Carbon Dioxide"},{"id":"JWriAiBU","value":"Nucleotides"},{"id":"JYtdzk6E","value":"plant "},{"id":"JX1LgERV","value":"actin cytoskeleton"},{"id":"JYtd1qNb","value":"Analytical Method"},{"id":"JYtdzg4b","value":"fragile bones"},{"id":"JYtdz-q6","value":"Instrumentation "},{"id":"J9ih3XHf","value":"Adiabatic"},{"id":"JpZWZ3cp","value":"Parasitology"},{"id":"J9ihpnVV","value":"Annihilation"},{"id":"Jf1pTsCA","value":"pathologists"},{"id":"JYtd2Mxp","value":"Viral Infection"},{"id":"JcX9GeRP","value":"Lensmeter"},{"id":"JYtd1FQB","value":"UAG"},{"id":"JYtdzap2","value":"semiology"},{"id":"JYtd0DY-","value":"surgical navigation "},{"id":"JcX8BeCH","value":"Module"},{"id":"LXb4Gbfb","value":"Booking"},{"id":"JYtd0qDI","value":"Cervical Spine"},{"id":"JYFqh48K","value":"plevic adhesion"},{"id":"JWriAFYg","value":"Cytoreductive therapy"},{"id":"JWrh_-Yl","value":"Adenosarcoma symptoms"},{"id":"JYtd1RU4","value":"Aspartic"},{"id":"JYtd0lvE","value":"Systemic Inflammatory Response Syndrome"},{"id":"JX1LgOHz","value":"ADSC"},{"id":"Jb7jXv23","value":"Basic Commodity  Chemicals"},{"id":"JWriBhos","value":"Heart Transplantation"},{"id":"LXb4FwgD","value":"Accumulation Bin"},{"id":"LXb4FqKg","value":"Accelerated Commercial Release Operations Support System"},{"id":"JYtdzple","value":"Computer "},{"id":"LXb4GJCg","value":"Audit"},{"id":"JpZWZb_u","value":"Computational modelling"},{"id":"JWriArKm","value":"Secondary Structure"},{"id":"JX1LgVCS","value":"African American"},{"id":"JYDqjbo0","value":"Preterm Birth"},{"id":"JYtd0K42","value":"HTS "},{"id":"JYtd2txu","value":"Retinal Pigment Epithelium"},{"id":"J9qqTyOB","value":"FlexiblFlexible workflow facilitates mapping and modeling with any catheter"},{"id":"JYFqh2QX","value":"Haemodialysis"},{"id":"JWriDUL8","value":"Nucleolus"},{"id":"JYtd0xZG","value":"Multivisceral transplantation"},{"id":"JWriASeu","value":"Palliative treatment"},{"id":"JYtd1cEf","value":"hypercapnia"},{"id":"JWriAf59","value":"Indexing Terms"},{"id":"JcX8BLth","value":"Endocervical Curettes"},{"id":"JWriDiW3","value":"Reticulocyte"},{"id":"JcX8BkyD","value":"Extraoral source"},{"id":"JWriBO-I","value":"Ventricular Tachycardia"},{"id":"JbeWP4th","value":""},{"id":"LXb4HonJ","value":"Quality"},{"id":"JWriCd5Q","value":"Extrinsic"},{"id":"Jgd_HQgt","value":"panel"},{"id":"KHcl5d1s","value":"Infection - GENERAL"},{"id":"JX1Lgb_O","value":"Alcoholic hepatitis"},{"id":"JYtd17Wi","value":"Innate Immunity"},{"id":"JYtdzeme","value":"metabolic neuroimaging"},{"id":"Jf1pTtyN","value":"neuroscience"},{"id":"JYtd1oPn","value":"Sample Preparation"},{"id":"JYFrIArR","value":"imaging techniques"},{"id":"JlBiPTnl","value":"vision loss"},{"id":"JYDqkh8W","value":"Attempted CSE but no CSF"},{"id":"JYtd0UtN","value":"drug design "},{"id":"JWriBkzF","value":"implantable cardioverter defibrillator"},{"id":"JX1LgNCm","value":"adjuvant arthritis"},{"id":"JYtdzt6E","value":"elisa "},{"id":"JpZWaOFh","value":"Veterinary Science"},{"id":"JYtd20vi","value":"Visual Impairment"},{"id":"JYFrH5rV","value":"azathioprine"},{"id":"JYtd0kKl","value":"Controlled Trial"},{"id":"JYDqko27","value":"airway management"},{"id":"Jf1pTmcZ","value":"cytochemistry"},{"id":"JYDqkZcb","value":"type 2 diabetes mellitus"},{"id":"J9ihQyi8","value":"Albedo"},{"id":"JYtd1Kg9","value":"Proline"},{"id":"JYtd0dRf","value":"Chronic Obstructive Pulmonary Disease"},{"id":"JYFrICFp","value":"myositis"},{"id":"JYFqhwZs","value":"Hemodialysis"},{"id":"JYtd1XiE","value":"Asparagine"},{"id":"Lb8_sg16","value":"blood thinner"},{"id":"KHXCys2N","value":"Back Pain"},{"id":"JWrh-47v","value":"Fatty Acid"},{"id":"JWrh_TSP","value":"Skim Milk"},{"id":"J9ihPRbN","value":"Adiabatic"},{"id":"JYtd13br","value":"Limit of Quantitation"},{"id":"JYtdz6uj","value":"non-invasive device "},{"id":"JYFqhupw","value":"Effects Lithotomy position"},{"id":"JYFrH0P-","value":"anticardiolipin"},{"id":"Jb7jhxRp","value":"Energy Transfer"},{"id":"JYtd1khf","value":"Capillary Electrophoresis"},{"id":"JWriCllf","value":"Hematopoietic (Hemopoietic)"},{"id":"JWriAdFC","value":"Dna Microarray"},{"id":"LXb4HPW7","value":"Load Factor"},{"id":"JX1LgQZ5","value":"Advanced neoplasm"},{"id":"JYtd0Yw3","value":"Mechanical Ventilation"},{"id":"JYtd0uJh","value":"Hypogammaglobulinemia"},{"id":"JWrh_NbB","value":"Food Processing"},{"id":"JYtd2-GD","value":"facial plastics"},{"id":"JY9Y_mHG","value":"Resin Composite"},{"id":"JWriCXXs","value":"Eosinophilia"},{"id":"JYtd0Jg3","value":"directed evolution "},{"id":"JYtd2Htl","value":"Signal Transduction"},{"id":"Jbj4Rjpw","value":"Diseases"},{"id":"JYtd2AXv","value":"cd4+ t cell"},{"id":"LXb4H6cN","value":"SCOR"},{"id":"JWriDvz5","value":"Venipuncture"},{"id":"JWriBJd9","value":"Coronary Heart Disease"},{"id":"JcX8BWjY","value":"ENT Treatment Cabinets"},{"id":"JYtd2FuC","value":"Central Nervous System"},{"id":"JWriAuI7","value":"Population Genetics"},{"id":"JWrh_Hya","value":"Starter Culture"},{"id":"JWriC8p2","value":"Leukocytosis"},{"id":"JWriDFhh","value":"Megakaryoblast."},{"id":"JYtdzio5","value":"calcium lactate"},{"id":"LXb4IP7r","value":"ULD"},{"id":"JWriA-o7","value":"Heterogeneous Data"},{"id":"JX1LghjF","value":"alosetron-placebo treatments"},{"id":"JYtdz2RB","value":"homologue "},{"id":"JYDqiisb","value":"Spectrum"},{"id":"JWriDfSR","value":"Prorubricyte"},{"id":"JWriCtZm","value":"Hyperplasia"},{"id":"JYtd1CM5","value":"Phenylalanine UCU"},{"id":"JWrh_Z-5","value":"Raw Materials"},{"id":"JWriA7kw","value":"Data Type"},{"id":"JYFrH6Ij","value":"calcinosis"},{"id":"JpZWaAcm","value":"Salmonella"},{"id":"Jb7jcVdU","value":"Speciality Chemicals"},{"id":"JZlUFjD-","value":"Frontal Cortex"},{"id":"JYtd2v02","value":"Electroretinogram"},{"id":"JX1LgYcB","value":"AIH"},{"id":"JWriBNG_","value":"Left Ventricular Function"},{"id":"JX1Lgbwi","value":"Alcoholic"},{"id":"JYtd24Nb","value":"Retinopathy of Prematurity"},{"id":"LXb4GtK6","value":"Collective Paper"},{"id":"JWrh_f25","value":"Publications"},{"id":"JWriAxHE","value":"Evolutionary History"},{"id":"JYDqkT0y","value":"Glucose Tolerance"},{"id":"LQPQV0mR","value":"imunometabolism assay"},{"id":"JYtdzZVb","value":"convulsion"},{"id":"JYtd1t5M","value":"Liquid Liquid Extraction"},{"id":"JYtd1a7R","value":"magnetic resonance Imaging"},{"id":"JX1LgWIk","value":"Age threshold"},{"id":"JYtd1PZg","value":"GCA"},{"id":"JWriDMpi","value":"Monoblast"},{"id":"KD94oYnY","value":"constipation"},{"id":"JYtd2LVB","value":"Mononuclear Cell"},{"id":"JbN7Ag6s","value":"Accident and Emergency"},{"id":"Jb7jgaB0","value":"Catalyst Inhibitors"},{"id":"JY9Y_wiz","value":"porphyromonas gingivalis"},{"id":"JYDqjxOI","value":"Indexation"},{"id":"JWrh_oBR","value":"Poly Vinyl Chloride"},{"id":"JWrh_BnM","value":"Body Weight"},{"id":"LXb4Ibq0","value":"Vendor"},{"id":"JWriDmzI","value":"Sickle Cell"},{"id":"JWriCq5U","value":"Hemeostasis"},{"id":"JYtdzj7Y","value":"Life Science "},{"id":"JWriDTwh","value":"NRBC"},{"id":"JcX8Bafw","value":"Electrosurgical Units"},{"id":"JYtd0GY0","value":"oligonucleotide synthesis "},{"id":"JX1LgIqx","value":"acute stress"},{"id":"LXb4HCAO","value":"Fulfillment"},{"id":"Jb7jewtm","value":"Inks"},{"id":"KHcl5V4R","value":"Psoriasis"},{"id":"JYDqjhnP","value":"United States"},{"id":"JYtd0hNS","value":"Acute Respiratory Failure"},{"id":"JX1LgAb8","value":"achalasia"},{"id":"JpZWZpPv","value":"Herpes simplex virus"},{"id":"JYtd1_DK","value":"Antibody Response"},{"id":"JYFrH3zG","value":"autoantigens"},{"id":"JWriCFID","value":"Anomaly"},{"id":"Jb7jcGP_","value":"Pesticides"},{"id":"JX1LgC-V","value":"acid regurgitation"},{"id":"JbN7AnFs","value":"Length of Stay"},{"id":"J9qqTck_","value":"interventional electropyhsiology problems"},{"id":"JYtdz9V8","value":"acoustic "},{"id":"JX1LgCe_","value":"acid pump antagonist"},{"id":"JWriBtx2","value":"Myocardial Perfusion"},{"id":"JWriALuN","value":"Intestinal cancer symptoms"},{"id":"JWriAgQG","value":"Software Package"},{"id":"JYtdzf4A","value":"calcium consumption"},{"id":"JcX40YKj","value":"Orthopaedics"},{"id":"JYtd1EIj","value":"Arginine"},{"id":"JYFqh-kG","value":"isotopic correction"},{"id":"JbN7ACWF","value":"Social Support"},{"id":"JYtdzbwo","value":"nervous system"},{"id":"JYtdznzc","value":"pesticides "},{"id":"JeGRHFMo","value":"taxable"},{"id":"JYtdzvgk","value":"MRI "},{"id":"JWriDASy","value":"Lymphopenia"},{"id":"JWriBZK3","value":"Coronary Artery Bypass Graft"},{"id":"JYtd0Bxi","value":"compression"},{"id":"Jbj4RjK-","value":"animal husbandry"},{"id":"JpZWZe43","value":"Disease vectors"},{"id":"JbN7ARtR","value":"Home Care"},{"id":"JWriBgGO","value":"Odd Ratio"},{"id":"JWriAwB2","value":"Expression Profile"},{"id":"JYtd1Sce","value":"GGC"},{"id":"JlBiPSLW","value":"body"},{"id":"JYtd2sn-","value":"Visual Acuity"},{"id":"JX1LgPBo","value":"ADV"},{"id":"JYtd14sN","value":"Affinity Chromatography"},{"id":"JY9Y_7Jp","value":"Tooth Loss"},{"id":"JYDqjZRl","value":"Birth Weight"},{"id":"JYtd2RK7","value":"systemic lupus erythematosus"},{"id":"JYtd0g7T","value":"Ventilator Associated Pneumonia"},{"id":"JYFqh3Ux","value":"Stress Urinary Incontinence"},{"id":"JYtd1f0b","value":"magnetic field measurement"},{"id":"JYFqhyaZ","value":"Urinary Tract"},{"id":"JcX8BcAj","value":"Surgical Tables"},{"id":"JWriDWbQ","value":"Organoid"},{"id":"JYtd0wAy","value":"heart"},{"id":"JWriC1RD","value":"Intrinsic"},{"id":"JYDqjSx3","value":"Connective Tissue"},{"id":"JYFqh74K","value":"small-bowel obstruction"},{"id":"JWrh_S8H","value":"Potassium"},{"id":"JYtd0Xab","value":"anesthetic "},{"id":"JYtdzoj1","value":"veterinary "},{"id":"LXb4GDuj","value":"All-Cargo Carrier"},{"id":"J9ihtWvq","value":"Absolute zero"},{"id":"JYDqkat-","value":"Diabetic Neuropathy"},{"id":"LQPQV3at","value":"activate T cell"},{"id":"LXb4HK4M","value":"Heijunka"},{"id":"JYDqizRw","value":"epidermolysis bullosa"},{"id":"JYtdzs7B","value":"immunoassay "},{"id":"JcX9GdSi","value":"Ophthalmic Surgery Microscope"},{"id":"KKnXXVTo","value":"SharePoint"},{"id":"JcX8BNp6","value":"Biopsy Punch"},{"id":"JWrh_4gV","value":"Progenitor cells"},{"id":"JYFqhtRf","value":"Position nerve injury"},{"id":"LQPQWEF4","value":"t cell analysis"},{"id":"JYtd0Pz4","value":"imaging"},{"id":"JWriCvu_","value":"Hypotonic"},{"id":"Jbj42U8O","value":"Zoo"},{"id":"JWriBaq8","value":"Ventricular Arrhythmia"},{"id":"JYtdzdlC","value":"localization"},{"id":"KSxpmCer","value":"immune"},{"id":"KHXCyqTA","value":"Alzheimers"},{"id":"JYtd2HbX","value":"Peripheral Blood Mononuclear Cell"},{"id":"JYFrID2y","value":"osteoporosis"},{"id":"Jf1pTkB_","value":"light microscopy"},{"id":"JWriDsBH","value":"Thrombocyte"},{"id":"JWrh_lfZ","value":"Power System"},{"id":"JWriCT8k","value":"Differential Coun"},{"id":"JWrh_qPK","value":"Differential Scanning Calorimetry"},{"id":"JWriAKxb","value":"Infusion"},{"id":"LXb4Ggbt","value":"Bullwhip Effect"},{"id":"J9ihx7W6","value":"Acceleration due to gravity"},{"id":"Jb7jiWCs","value":"Momentum Transfer"},{"id":"JYtd1mOZ","value":"Limit of Detection"},{"id":"JbN7AbG4","value":"Cultural Competence"},{"id":"JcX9GkHl","value":"scalpel"},{"id":"JWriCTL6","value":"Cytoplasm"},{"id":"JWrh_U9A","value":"Acetic Acid"},{"id":"J9qL7f9G","value":"AF treatment"},{"id":"JYtdz5Kv","value":"management "},{"id":"Jgd_HM2t","value":"mutation"},{"id":"LXb4HkIO","value":"PBIT"},{"id":"JYDqkm_r","value":"Preop findings Lactated Ringer's"},{"id":"JYtd1MIi","value":"Glutamine"},{"id":"JX1Lgddo","value":"allele frequency"},{"id":"JY9Y_o18","value":"Dentin Bonding"},{"id":"JWrh_9Ck","value":"Adenocarcinoma"},{"id":"JX1LgGe7","value":"Acute enteritis"},{"id":"JbN7AsCR","value":"Low Income"},{"id":"JWrh_PA8","value":"Lactating Cows"},{"id":"JWriCnma","value":"Hemolytic Anemia"},{"id":"JYtdzrqa","value":"copyrighted content "},{"id":"JYFqhsa0","value":"Position Change"},{"id":"JYtd0Vfw","value":"proteins "},{"id":"JWrh_Fwc","value":"Chemical Composition"},{"id":"JWriDDJl","value":"Maturation Factor"},{"id":"JYtd1vTk","value":"Silica Gel"},{"id":"Lb8_sk4z","value":"james alex fields"},{"id":"JYtd2JOV","value":"Mhc Class Ii"},{"id":"JYtd0yL7","value":"Pharmacokinetics"},{"id":"JYFqhmNz","value":"Blocker effect LMA indications"},{"id":"JYtd27x1","value":"oral cavity"},{"id":"JWriBLMl","value":"Electrocardiogram"},{"id":"JbN6_-1v","value":"Health Care"},{"id":"LXb4IKwW","value":"Taguchi Method"},{"id":"JYtd0j4P","value":"Brain Injury"},{"id":"JYFqhm_B","value":"Hypoxemia in lateral position"},{"id":"JWrh_bmc","value":"Low Fat"},{"id":"JYtd1jbA","value":"High Performance"},{"id":"LQPQV8PX","value":"T cell differentiation"},{"id":"JYtd0AQN","value":"computer aided detection "},{"id":"JWriAQTU","value":"Multicentric breast cancer"},{"id":"JWriDRyW","value":"Neutrophil (Polymorphonuclear Neutrophil or Segmented Neutrophil)"},{"id":"JYDqejDW","value":"Hair Follicle"},{"id":"JWriDdX6","value":"Polychromasia"},{"id":"JcX8BUei","value":"ENT Workstations"},{"id":"JWriCH_L","value":"Azurophilic Granule"},{"id":"JpZWaKKe","value":"Trypanosomes"},{"id":"JYFrH-wh","value":"glomerulonephritis"},{"id":"JWriCZKM","value":"Erythrocyte"},{"id":"JWrh_wj5","value":"Process Parameters"},{"id":"Jf1pTwDN","value":"biophysics"},{"id":"JbN7AGk-","value":"Postpartum Depression"},{"id":"JYFrH779","value":"cryoglobulinemia"},{"id":"JWriCESV","value":"Anemia"},{"id":"JYtd1GFM","value":"UGU"},{"id":"JWriA9h9","value":"Three Dimensional"},{"id":"JWriBUU-","value":"Endothelial Cell"},{"id":"JYtdz31W","value":"allele "},{"id":"JWrh_mkK","value":"Glass Fiber"},{"id":"JYDqkRYJ","value":"insulin dependent diabetes mellitus"},{"id":"JYtd2N1k","value":"Infectious Disease"},{"id":"LXb4Gkxd","value":"Can-Order Point"},{"id":"JYtd0qUG","value":"Classification System"},{"id":"JYtd0u9J","value":"Intestinal transplantation"},{"id":"JY9Y-06t","value":"Drug Release"},{"id":"JYtd2NEY","value":"Molecular Mechanics"},{"id":"JX1LgCwX","value":"Acid Reflux"},{"id":"JbN7AB2L","value":"Preterm Infant"},{"id":"JYtd0tGy","value":"anastomatic healing"},{"id":"JpZWZYYX","value":"Bacteriology"},{"id":"JYtdzoDX","value":"fermentation "},{"id":"Jf1pTpPf","value":"Anatomists"},{"id":"J9ih1kDV","value":"Acoustic shielding"},{"id":"JeGRHGdX","value":"accruals"},{"id":"JYtdzz55","value":"polymerase "},{"id":"JWriDI5W","value":"Metarubricyte"},{"id":"JYtd0Z2h","value":"Critical Care"},{"id":"JWriA1ld","value":"Evolutionary Model"},{"id":"JWrh_hfm","value":"Injection Molding"},{"id":"LXb4Gn8r","value":"Center-of-Gravity Approach"},{"id":"JY9Y_rtq","value":"Glass Ionomer Cement"},{"id":"JX1LgJiO","value":"adefovir"},{"id":"Jgd_HIed","value":"identification"},{"id":"JYDqjpBA","value":"Body Mass Index"},{"id":"JWriAugI","value":"Amino Acid Sequence"},{"id":"JYtd2Jhx","value":"Cell Proliferation"},{"id":"JYtd1QfT","value":"GAC"},{"id":"KHXCywp5","value":"Cold Sores"},{"id":"JWrh_9ZL","value":"Adenosarcoma"},{"id":"JWrh-__C","value":"Nitrogen"},{"id":"JYDqi4oC","value":"Growth Factor"},{"id":"JWriBqNA","value":"Risk Stratification"},{"id":"JWrh_SkM","value":"Essential Oil"},{"id":"JWriC161","value":"In Vitro"},{"id":"JWriCGlt","value":"Aplasia"},{"id":"JYtdz8SB","value":"CAD/PACS application "},{"id":"JZlUFgM4","value":"Basal Ganglia"},{"id":"JWrh_1jQ","value":"nanoparticle"},{"id":"JcX9GgrO","value":"Slit Lamp"},{"id":"LXb4HyBi","value":"RMA"},{"id":"JYFqh_5_","value":"spectra mergring"},{"id":"JYtdz-8T","value":"navigational -- GPS "},{"id":"Lb8_srK7","value":"virginia counter protests"},{"id":"Jb7jfiDy","value":"Electrocatalysts"},{"id":"JX1LgXSh","value":"agreement"},{"id":"JpZWaFtD","value":"Streptococcus"},{"id":"JcX9Gbm8","value":"film holder"},{"id":"JWriANl-","value":"Lymph node cancer treatment"},{"id":"JYDqjWfH","value":"OBGYN"},{"id":"JX1LgabT","value":"akt"},{"id":"JYFrIEXJ","value":"pediatric rheumatology"},{"id":"JX1Lf9EF","value":"3D HRM"},{"id":"JWrh_RbH","value":"Meat Quality"},{"id":"JYDqkVIH","value":"Streptozotocin"},{"id":"JWriDkJ0","value":"Rouleaux Formation"},{"id":"JX1Lgeqo","value":"Allergy"},{"id":"JWriC3mH","value":"Jaundice"},{"id":"JYtd1nWb","value":"Flow Rate"},{"id":"JWriBXrZ","value":"Computed Tomography"},{"id":"JWriAjU2","value":"Genome Sequence"},{"id":"JcX40SLi","value":"Dental"},{"id":"Jb7jeXpO","value":"Detergents"},{"id":"JWrh_LuI","value":"High Performance Liquid Chromatography"},{"id":"JWriA_eh","value":"Statistical Model"},{"id":"LXb4FfmU","value":"ABC Inventory Control"},{"id":"JY9Y_rPH","value":"Dental Pulp"},{"id":"JWriBmxJ","value":"Doppler Echocardiography"},{"id":"JYFqh0Lz","value":"Serum Creatinine"},{"id":"JWrh_uB0","value":"Condition Based Maintenance"},{"id":"Jgd_HJC0","value":"inherited"},{"id":"JYtd0gYo","value":"Blunt Trauma"},{"id":"JYtd1PIe","value":"GCC"},{"id":"LXb4IfzD","value":"VOI"},{"id":"JYtd1UIu","value":"AUA"},{"id":"JYDqjiDO","value":"Pre Eclampsia"},{"id":"JYtd11X3","value":"Correlation Coefficient"},{"id":"JYtd0fUe","value":"Traumatic Brain Injury"},{"id":"LXb4F_tZ","value":"Agglomeration"},{"id":"Jbj42Tb5","value":"Structures"},{"id":"JYtd0iSv","value":"Injury Severity Score"},{"id":"JYDqkch5","value":"Homeostasis Model Assessment"},{"id":"JbN7AsiY","value":"Health Professionals"},{"id":"JYtdznX_","value":"forestry "},{"id":"LQPQWBO9","value":"CAR-T cell activation assay"},{"id":"JYtd1LVG","value":"CAA"},{"id":"JWrh_Dvh","value":"Meat Products"},{"id":"JcX8BG5q","value":"Rhythm control ICD"},{"id":"JWrh_yTg","value":"Electromagnetic Interference"},{"id":"JY9Y-rPJ","value":"Dopamine Receptor"},{"id":"JWriDbRF","value":"Plasma Cell"},{"id":"JWriAdbm","value":"Dna Sequence"},{"id":"JWriCWPN","value":"Endothelial Leukocyte"},{"id":"JpZWZxd5","value":"MHC"},{"id":"JcX8Bfjw","value":"Anesthesia Workstation"},{"id":"JYtd2EQG","value":"T Cell Activation"},{"id":"Jb7jann6","value":"Pharmaceuticals"},{"id":"JYtdzxVP","value":"viral "},{"id":"JWrh_fFB","value":"Total Phenolic Content"},{"id":"JWrh_KR9","value":"Tomato"},{"id":"JWriAJo3","value":"Hyperthermia therapy"},{"id":"JWrh_r79","value":"Water Absorption"},{"id":"JYDqjRLq","value":"Polymerase Chain Reaction"},{"id":"JWriCRWr","value":"Color Index"},{"id":"JYFqhpww","value":"IV vs. epidural morphine PONV prophylaxis"},{"id":"J9ihuPXC","value":"Atomic mass unit"},{"id":"JYtd1iAi","value":"suspeptibility contrast"},{"id":"JWriBCGI","value":"Feature Selection"},{"id":"JYDqfBf8","value":"Monoclonal Antibody"},{"id":"JX1Lf--M","value":"Ablatin"},{"id":"JYtd1DAP","value":"UCG"},{"id":"JWriAJBV","value":"Hematopoietic growth factors"},{"id":"JWrh_j3e","value":"Composite Material"},{"id":"JWriDspj","value":"Thrombocytopenia"},{"id":"JZlUFl_6","value":"Frontal Lobe"},{"id":"JYtdzw0y","value":"autoimmunity "},{"id":"Lb8_sebY","value":"hector balderas"},{"id":"JWriDTT2","value":"Normocyte (Erythrocyte)"},{"id":"JWriAZdp","value":"Subcutaneous injection"},{"id":"JX1LgFn_","value":"Acute abdominal pain"},{"id":"JWrh_6L2","value":"Embryonic stem cells"},{"id":"JX1LgQI7","value":"advanced neoplasia"},{"id":"JYtd1x-D","value":"Cation Exchange"},{"id":"JYtd1AOC","value":"transcription"},{"id":"JWriCuEe","value":"Hypertonic"},{"id":"JYtd1NNG","value":"CGG"},{"id":"LXb4HL83","value":"Hierarchy of Cost Assignability"},{"id":"J9qqTy9x","value":"Module takes the art out of lesion marking, using parameters based on proven clinical data you trust"},{"id":"JWriAXBc","value":"Refractory"},{"id":"KHcl5YiX","value":"Spinal Health - GENERAL"},{"id":"LXb4GTas","value":"Benchmarking"},{"id":"JbN7AWEL","value":"Case Study"},{"id":"JYtd17qX","value":"Autoimmune Disease"},{"id":"JY9Y_0rz","value":"Oral Cancer"},{"id":"JZlUFtpU","value":"Tyrosine Hydroxylase"},{"id":"JWriDciU","value":"Poikilocyte"},{"id":"JWriBQDk","value":"Left Ventricular Ejection Fraction"},{"id":"JYtd0TGv","value":"antifungal "},{"id":"Jb7jhD_O","value":"Chemical Plant Design"},{"id":"LXb4G4gY","value":"Duty Drawback"},{"id":"KHXCyj6e","value":"Conditions"},{"id":"JpZWZ-Xx","value":"Rhabdovirus"},{"id":"JYtd0WlW","value":"stem cell "},{"id":"J9qL7mvV","value":"Cardiac Arrhythmia solution"},{"id":"Jf1pTdHO","value":"Super Resolution Microscopy"},{"id":"JYtd1Jte","value":"CCC"},{"id":"JYtd2yZB","value":"Open Angle Glaucoma"},{"id":"J9ihyU_e","value":"Avogadro number"},{"id":"JYtd0BhA","value":"search tools "},{"id":"JYFqhpEA","value":"Interpretation: ABG Nasogastric tube"},{"id":"JcX40USB","value":"General Hospital and"},{"id":"JYDqdHbb","value":"langerhans cell"},{"id":"Jgd_HTxb","value":"SNP's"},{"id":"JX1LgIdL","value":"acute rejection"},{"id":"JWriDqey","value":"Synchronous"},{"id":"JYtd0nm7","value":"Retrospective Study"},{"id":"JYtd0JPg","value":"protease "},{"id":"JWrh-85s","value":"Milk Products"},{"id":"JYFrH0ti","value":"antigen-presenting cells"},{"id":"J9ihZKtR","value":"Amplitude"},{"id":"Jb7jhJcv","value":"Pilot Chemical Plants"},{"id":"Jbei9uHJ","value":"food"},{"id":"LQPQV_HS","value":"T cell subtypes"},{"id":"JpZWZnBb","value":"Genome packaging"},{"id":"JWriBWg1","value":"diabetes mellitus"},{"id":"JYDqg9uD","value":"Basal Cell Carcinoma"},{"id":"JWriCiPE","value":"Granulocytopenia (Granulopenia)"},{"id":"JYtd1YGR","value":"AGU"},{"id":"JYtd1GWg","value":"UGC"},{"id":"J9ihJSJH","value":"Acceleration"},{"id":"JeGRHKvb","value":"expenditure"},{"id":"JWriCCa5","value":"Catheter Ablation"},{"id":"JWriA5dO","value":"Functional Annotation"},{"id":"JWrh_79S","value":"Absolute neutrophil count"},{"id":"JWrh_YW5","value":"Antimicrobial Activity"},{"id":"JYtd2uHX","value":"Optical Coherence Tomography"},{"id":"JWrh_sUp","value":"Electrical Machine"},{"id":"JWriDLkZ","value":"Mitochondria"},{"id":"KHXCyteb","value":"Birth Control"},{"id":"JYtd0rgL","value":"neovascularization"},{"id":"JWriA0J5","value":"Cancer Classification"},{"id":"JcX8BejD","value":"MRI Monitor"},{"id":"JbN7Ah17","value":"Reliability and Validity"},{"id":"JYtdz__e","value":"spectroscopy "},{"id":"JlBiPRH7","value":"24 hour"},{"id":"JWriBojI","value":"New York Heart Association"},{"id":"JYtd2Bxx","value":"Regulatory T Cell"},{"id":"JpZWZ68f","value":"Plant infection"},{"id":"JpZWZbZO","value":"Chronic Infection"},{"id":"JYDqjluH","value":"Randomized Controlled Trial"},{"id":"JYtd1e6Y","value":"impulse response"},{"id":"J9ihgeAp","value":"Angle of repose"},{"id":"JWriA4E1","value":"multigene family"},{"id":"JYtdzhIY","value":"strong bones"},{"id":"JX1LgDZl","value":"acid suppression"},{"id":"JYtd0Ucd","value":"fertility "},{"id":"JWriCCzw","value":"Agranulocyte"},{"id":"JWrh_zeN","value":"Mesenchymal"},{"id":"JWrh_XDN","value":"Early Lactation"},{"id":"LXb4Hr9w","value":"RFID"},{"id":"JWriAHBs","value":"Glioblastoma"},{"id":"JZlUFsPR","value":"Healthy Control"},{"id":"JWriAxdf","value":"Protein Function"},{"id":"JYDqbgsf","value":"Skin Disease"},{"id":"JYFqh8pC","value":"abdominal"},{"id":"JWrh_d98","value":"Protein Content"},{"id":"LQPQV5mh","value":"T cell transition"},{"id":"LXb4F148","value":"Advance Material Request"},{"id":"LXb4GWn6","value":"Bill of Resources"},{"id":"Jb7jdtyk","value":"Cleaning Chemicals"},{"id":"JcX8BhSA","value":"Portable Anesthesia Machine"},{"id":"JX1LgYN8","value":"AIEC"},{"id":"JYFrIAMz","value":"imaging of rheumatic diseases"},{"id":"JYDqkjZF","value":"Bier block"},{"id":"JYFqh6H5","value":"sticky guts"},{"id":"JYtd0Zl3","value":"Intensive Care"},{"id":"JYDqjntU","value":"Cervical Cancer"},{"id":"JWrh_E2M","value":"High Pressure"},{"id":"JY9Y-jBY","value":"Glutamate"},{"id":"JcX8BKLl","value":"Heart Valve Disease"},{"id":"JYDqkYH-","value":"Adipose Tissue"},{"id":"JWriCsuj","value":"Hygroscopic"},{"id":"JZlUFcZt","value":"Rat Brain"},{"id":"KHcl5bNY","value":"HepatitisÊ"},{"id":"LXb4HGDZ","value":"Granger Laws"},{"id":"JX1LgV6M","value":"Age factors"},{"id":"JWriBGCD","value":"Atrial Fibrillation"},{"id":"JWriBaS2","value":"Oxidant Stress"},{"id":"JcX8BYCl","value":"Exam Tables"},{"id":"JbN7AY0s","value":"Self Efficacy"},{"id":"JZlUFpC5","value":"Oscillations"},{"id":"JYtdz6-x","value":"X-Ray "},{"id":"JYDqjj1b","value":"Prenatal Diagnosis"},{"id":"JY9Y-d6R","value":"Dopamine"},{"id":"LXb4HYTf","value":"Nationalization"},{"id":"JWriAook","value":"Phylogenetic Analysis"},{"id":"Jbj4RnCT","value":"Physiological"},{"id":"JY9Y_haO","value":"Periodontal Disease"},{"id":"JWriAT_D","value":"Pituitary gland cancer symptoms"},{"id":"JbN7AmnB","value":"Cross Section"},{"id":"LXb4GxDK","value":"Complete Manufacture to Ship Time"},{"id":"JWriAs1T","value":"Cluster Algorithm"},{"id":"JYtd1c6r","value":"cerebral hemodynamics"},{"id":"JpZWZopQ","value":"Hepatitis C"},{"id":"JWrh__zU","value":"Appendiceal carcinoma"},{"id":"JWriCOMB","value":"Centriole"},{"id":"JpZWZ0Cv","value":"Mathematical modelling"},{"id":"JWriBNex","value":"Enzyme"},{"id":"JYFqhrLb","value":"GA: Heat loss prevention"},{"id":"JX1LgN56","value":"adrenalectomy"},{"id":"JX1LgbFy","value":"albumin gradient"},{"id":"JX1LgHjt","value":"acute leukemia"},{"id":"JYFrHykY","value":"anti-ccp antibodies"},{"id":"JYtd1pYb","value":"Kinetics"},{"id":"KSxpl34B","value":"ITP"},{"id":"JX1Lf-HR","value":"abdominal symptom"},{"id":"JYtdz1OY","value":"gene "},{"id":"JbN7AvcJ","value":"Participatory Action Research"},{"id":"JYtd1TT5","value":"Isoleucine"},{"id":"JYtdzqER","value":"data storage "},{"id":"JYDqkfOv","value":"Glucose Intolerance"},{"id":"JYDqjOun","value":"Mycosis Fungoides"},{"id":"JWriDCD3","value":"Macrocytosis"},{"id":"KHcl5U9p","value":"Parkinson's Disease"},{"id":"JYtdzyXU","value":"remediation "},{"id":"JYtd1mxW","value":"Internal Standard"},{"id":"JY9Y_4Uh","value":"Flexural Strength"},{"id":"LXb4H-UF","value":"SKU"},{"id":"JYDqh7oX","value":"Contact Dermatitis"},{"id":"LXb4GMoO","value":"Automated Broker Interface"},{"id":"JWriBHQr","value":"Ejection Fraction"},{"id":"JYDqjdV3","value":"Pregnancy Complication"},{"id":"JYtd0H5_","value":"culture "},{"id":"JYtd1WZD","value":"AAU"},{"id":"JYtd29V6","value":"balance"},{"id":"JY9Y-t6n","value":"p-glycoprotein"},{"id":"J9qqT4nn","value":"Ensite Velocity Cardiac Mapping System"},{"id":"LXb4IUCJ","value":"Upsell"},{"id":"JYFqhxlf","value":"Bladder Cancer"},{"id":"JYtd1BX3","value":"UUC"},{"id":"JYtd0_Bt","value":"Amino Acid"},{"id":"JcX8BQ8V","value":"Tenaculum"},{"id":"JWriBDtp","value":"Coronary Artery Disease"},{"id":"JYFqhqq1","value":"Airway exch cath advantages"},{"id":"JYDqjVG3","value":"lichen planus"},{"id":"JYFqh1ef","value":"Peritoneal Dialysis"},{"id":"JpZWaSly","value":"Zoonoses"},{"id":"JY9Y_kOo","value":"Temporomandibular Joint"},{"id":"JYtd2PpQ","value":"Dna Vaccine"},{"id":"JcX9Gf_R","value":"Rotatable Beamsplitter"},{"id":"JWriAbkH","value":"Phylogenetic Tree"},{"id":"JYtd14_a","value":"Ion Trap"},{"id":"JYtdz5r7","value":"informatics "},{"id":"JWriDtqa","value":"Thromboplastin"},{"id":"JYtd0Xrn","value":"pathogen"},{"id":"JpZWZXUW","value":"Autoimmunity"},{"id":"KHXCyzvb","value":"Epilepsy"},{"id":"JWriAevC","value":"Gene Ontology"},{"id":"JYtd0SDA","value":"anti-inflammatory "},{"id":"JYtd1sN5","value":"Reversed Phase Liquid Chromatography"},{"id":"JbN7AxsT","value":"Functional Status"},{"id":"JZlUFge6","value":"White Matter"},{"id":"JYtd1zhR","value":"Capillary Gas Chromatography"},{"id":"JYtd2xik","value":"Vascular Endothelial Growth Factor"},{"id":"LXb4HUQP","value":"Mar Ad"},{"id":"JX1LgRoz","value":"adverse reactions"},{"id":"JYtd0Kmh","value":"combinatorial chemistry "},{"id":"JYtd1IWj","value":"CUC"},{"id":"JWrh--iz","value":"listeria monocytogenes"},{"id":"JpZWZh4K","value":"Ecology"},{"id":"JWriAY6l","value":"Squamous cell carcinoma"},{"id":"JWriDKZF","value":"Microcytosis"},{"id":"JYtdzeV6","value":"cellular hypoperfusion"},{"id":"JYtd1OSg","value":"GUA"},{"id":"JbN7AMAw","value":"Patient Care"},{"id":"JYtd26Qm","value":"head"},{"id":"JYDqkqOq","value":"Epidural anes test dose"},{"id":"JYDqjd0P","value":"Cesarean Section"},{"id":"JYtd0E80","value":"expression system "},{"id":"JWriBRfI","value":"Left Ventricle"},{"id":"JYtd1ZyD","value":"Speckle"},{"id":"JYtd0yeV","value":"renal"},{"id":"JcX8BPdH","value":"Speculum"},{"id":"JYtdzynt","value":"sensing"},{"id":"JYtd0OdL","value":"graphics "},{"id":"JWriALXf","value":"Institutional review board"},{"id":"JZlUFuve","value":"Neurotrophic Factor"},{"id":"JWriDZwa","value":"Petichiae"},{"id":"JX1LgZUb","value":"air insufflation CT"},{"id":"JY9Y-uYI","value":"Dose Response"},{"id":"JpZWZwha","value":"Listeriosis"},{"id":"JYFqhu88","value":"Basil Infusions"},{"id":"KECpzSFC","value":"digestive disorder"},{"id":"JYtd1xFs","value":"Metal Ion"},{"id":"J9qqTrGL","value":"Improved navigation and visualization"},{"id":"JWrh_6j4","value":"Regenerative medicine"},{"id":"JYtd2-Zv","value":"facial cancer"},{"id":"JWrh_DAM","value":"Dairy Products"},{"id":"JYDqkVnU","value":"Plasma Glucose"},{"id":"JYtd2vid","value":"Endometrial Cancer"},{"id":"JY9Y_mlt","value":"Soft Tissue"},{"id":"JWrh_Pfu","value":"Dry Matter Intake"},{"id":"JWrh_xkQ","value":"Distributed Generators"},{"id":"Lb8_shwD","value":"sanofi"},{"id":"JYtdza6d","value":"pathophysiologies"},{"id":"JYtd0EsS","value":"cell line "},{"id":"JYtd1vnY","value":"Quantitative Analysis"},{"id":"Jbj4RlGY","value":"Suckling"},{"id":"JWrh_IMk","value":"Food Safety"},{"id":"JWriADby","value":"Carcinoma"},{"id":"JYDqcEb8","value":"Ultraviolet"},{"id":"LXb4HcEk","value":"Ordering Cost"},{"id":"JbN6__V1","value":"Nursing Education"},{"id":"JYtd1J-c","value":"CCA"},{"id":"JYtd1SwF","value":"GGA"},{"id":"JpZWZdvg","value":"Dairy cows"},{"id":"JYtd0x6-","value":"reinfection"},{"id":"JYtd0BQw","value":"file sharing "},{"id":"JWriC45t","value":"Karyolysis"},{"id":"JYtdz2ho","value":"DNA "},{"id":"LXb4ICFN","value":"Small Group Improvement Activity"},{"id":"JWriDfuh","value":"Prothrombin"},{"id":"JY9Y_7os","value":"Oral Mucositis"},{"id":"JX1LgSng","value":"AEF"},{"id":"JWrh_5d9","value":"Hematopoietic"},{"id":"JWriA94X","value":"Hierarchical Clustering"},{"id":"JX1LgU0V","value":"Africa"},{"id":"JWriAyod","value":"Biological Process"},{"id":"JYtd0eCd","value":"Tidal Volume"},{"id":"JcX8BcgE","value":"Capnography Monitor"},{"id":"J9qqT93j","value":"FlexAbility"},{"id":"JYFrH6nG","value":"carpal tunnel syndrome"},{"id":"JYtdziZT","value":"elemental calcium"},{"id":"JX1LgZGO","value":"AIP relapse"},{"id":"JWriDlVL","value":"Serum"},{"id":"JWriBT9f","value":"Magnetic Resonance Image"},{"id":"JcX8BMMj","value":"Endocervical Speculum"},{"id":"JYFqh9ms","value":"PTM characterization"},{"id":"LXb4Hnb0","value":"QR"},{"id":"JX1LgceG","value":"ALD"},{"id":"JYtd22H0","value":"Retinal Ganglion Cell"},{"id":"JWriBvRE","value":"Systolic Function"},{"id":"J9qL7jpK","value":"Platform technology for AF"},{"id":"Jgd_HPuM","value":"oncogenomics"},{"id":"LXb4GrwC","value":"Collect Freight"},{"id":"JcX8BjRY","value":"Electrode gel for pulp testers"},{"id":"JWriCyuO","value":"Idiopathic"},{"id":"JYtdzfFf","value":"bone mass"},{"id":"JX1LgKOV","value":"Adenoma detection"},{"id":"KSxpmB9T","value":"idiopathic thrombocytopenic purpura"},{"id":"JYDqkid0","value":"Autonomic drugs"},{"id":"JYDqkPag","value":"non insulin dependent diabetes mellitus"},{"id":"JWriDNN6","value":"Monocyte"},{"id":"JX1LgM0l","value":"adiponectin"},{"id":"Jf1pTkyS","value":"scanning microscopy"},{"id":"LXb4FY5n","value":"ABC Analysis"},{"id":"JWriA2B9","value":"Prediction Accuracy"},{"id":"JbN7AeNC","value":"Primary Care"},{"id":"JWriCKyQ","value":"Basophilia"},{"id":"Jb7jgfV-","value":"Catalyst Poisons"},{"id":"JYtd0a9C","value":"Cardiac Arrest"},{"id":"JYtd1T20","value":"AUC"},{"id":"JWriAmxt","value":"Protein Interaction"},{"id":"JWrh_16k","value":"marrow"},{"id":"KHXCyvZF","value":"Cancer - Lung"},{"id":"KHcl5Www","value":"Restless legs syndrome (RLS)"},{"id":"JWriAu6z","value":"Protein Family"},{"id":"JWriBCe_","value":"Genetic Network"},{"id":"JY9Y-8NQ","value":"Delivery System"},{"id":"JYtdz58c","value":"rehabilitation "},{"id":"JWrh_AVc","value":"Potato"},{"id":"JYtd1KPg","value":"CCG"},{"id":"KECpzQ1v","value":"digestive issue"},{"id":"JpZWZrDl","value":"Immune evasion"},{"id":"JYFqhxVf","value":"Renal Function"},{"id":"JX1LgAOF","value":"ACHADOS"},{"id":"JYtd1Wqk","value":"AAC"},{"id":"JWrh-4no","value":"Lactic Acid Bacteria"},{"id":"JWriBrgX","value":"Adrenergic"},{"id":"JWriCQFf","value":"Clot Retraction"},{"id":"JbN7Aota","value":"Low Birthweight"},{"id":"JYtd0X86","value":"Intensive Care Unit"},{"id":"JX1LgCRd","value":"Achalasia with DES"},{"id":"JWriAVOx","value":"Pseudomyxoma peritonei"},{"id":"JX1LgGsj","value":"acute event"},{"id":"JWriANC4","value":"Lymph node cancer symptoms"},{"id":"J9qL7WXO","value":"3D mapping electrophysiology issues"},{"id":"JYtdzrYd","value":"printers"},{"id":"JWriAgmc","value":"Computational Method"},{"id":"J9ihiGib","value":"Angstrom:"},{"id":"JWriCmRm","value":"Hemoglobinuria"},{"id":"JWriDEFI","value":"Mean Corpuscular Hemoglobin (MCH)"},{"id":"JcX9Gen1","value":"Autorefractor"},{"id":"JWriBZjs","value":"Prospective Study"},{"id":"JYtd0zRK","value":"Xenotransplantation"},{"id":"JWriBLjh","value":"Confidence Interval"},{"id":"JWriAwYM","value":"Expression Pattern"},{"id":"JYDqjf9V","value":"Postmenopausal Women"},{"id":"JYFqhl97","value":"Epidural test dose"},{"id":"JWriDwMZ","value":"Viscous Metamorphosis"},{"id":"JYtd27eP","value":"voice box"},{"id":"J9qL7aZL","value":"3D mapping electrophysiology problems"},{"id":"JpZWZ231","value":"Neglected Tropical Diseases"},{"id":"JYtd1NfB","value":"Valine Glycine"},{"id":"Jb7jXd7F","value":"Industrial Chemistry"},{"id":"JWrh_b8O","value":"Water Soluble"},{"id":"JX1LgOVu","value":"adult"},{"id":"LXb4IOW2","value":"TOFC"},{"id":"LXb4GHm6","value":"Any-Quantity (AQ) rate"},{"id":"JYFrIBK3","value":"inflammation"},{"id":"JWriCNj2","value":"Cabot's Rings"},{"id":"JX1Lghxk","value":"alpha-fetoprotein"},{"id":"LQPQV7hq","value":"in vitro t cell function"},{"id":"JYDqjktF","value":"Ovarian Cancer"},{"id":"JcX8BS6M","value":"Electrosurgery Unit"},{"id":"JYtd0LKS","value":"cellular assay "},{"id":"JYDqjcEW","value":"Preterm Labor"},{"id":"JWriAQpr","value":"Nadir"},{"id":"Jb7jdBkb","value":"Adhesives"},{"id":"JWriC0Ba","value":"Intravascular"},{"id":"JWriDW1s","value":"Ovalocyte"},{"id":"Jf1pTvdb","value":"tissue culture"},{"id":"JWriCgca","value":"Fulminating"},{"id":"JYtd1LD8","value":"CAC"},{"id":"JYtd1Fzd","value":"Stop"},{"id":"JWriCZmA","value":"Erythrocytosis"},{"id":"JZlUFjW1","value":"neuronal activity"},{"id":"JYtd2Q4s","value":"th2 cells"},{"id":"JYFqh2hD","value":"Kidney Transplant"},{"id":"JYtd0OMc","value":"Software "},{"id":"JYtdztK_","value":"antibody "},{"id":"Jgd_HNzl","value":"NGS"},{"id":"JYtd1bND","value":"Cat Scan"},{"id":"JbN7AznL","value":"Work Environment"},{"id":"JbN7AO34","value":"Premature Infant"},{"id":"JYtd1tm8","value":"electrospray ionization"},{"id":"JYtdzxlb","value":"cholesterol "},{"id":"JZlUFrGp","value":"Learning and Memory"},{"id":"JYtd0QFK","value":"CNS "},{"id":"JYFqhtkA","value":"DDx Poor larynx visualization"},{"id":"Jf1pTl6E","value":"histochemistry"},{"id":"JYDqjPw8","value":"lupus erythematosus"},{"id":"JYtd0qqV","value":"Cardiac allograft vasculopathy "},{"id":"JY9Y-sGt","value":"Oral Administration"},{"id":"JY9Y_xDD","value":"Mineral Trioxide Aggregate"},{"id":"JWrh_oXn","value":"Reactive Power Control"},{"id":"JWrh_lJT","value":"Active Filter"},{"id":"JpZWaO5C","value":"Viral pathogenicity"},{"id":"KRyWT79m","value":"Hyperactivity Disorder"},{"id":"JYDqiGFI","value":"Ultraviolet Radiation"},{"id":"Jb7jh7jZ","value":"Biochemical Conversion"},{"id":"JYtd1AzQ","value":"anti condon"},{"id":"JX1LgEfI","value":"Actin microfilaments"},{"id":"JcX9GlLH","value":"Neurostimulators"},{"id":"JWriC6-c","value":"Leukemia"},{"id":"JYtd0Gpf","value":"protein synthesis "},{"id":"Jb7jeq9y","value":"Coatings"},{"id":"JYtd1lD5","value":"Stationary Phase"},{"id":"JcX8BEAx","value":"Pace Maker"},{"id":"LQPQWE1j","value":"t cell stimulation with anti cd3 anti cd28"},{"id":"JWriCGOc","value":"Anticoagulant"},{"id":"JYtd1HQj","value":"Cysteine"},{"id":"JYDqjKDL","value":"Immune Response"},{"id":"JYDqkQL8","value":"Blood Glucose"},{"id":"JYtdzlJr","value":"aquaculture "},{"id":"JYFqhq6S","value":"Endobronchial intubation"},{"id":"JWriAa1_","value":"Gene Expression Data"},{"id":"JWrh_T4f","value":"Antioxidant Capacity"},{"id":"JX1LgWke","value":"ageing"},{"id":"JpZWZ1sZ","value":"Molecular epidemiology"},{"id":"JYtd1I5-","value":"CUA"},{"id":"JWrh_GVH","value":"Staphylococcus Aureus"},{"id":"JYtdz9oQ","value":"camera "},{"id":"JWriAFCZ","value":"Creatinine"},{"id":"JYtd0f04","value":"Positive End Expiratory Pressure"},{"id":"Lb8_smM3","value":"nazi"},{"id":"JYFqh-z9","value":"isobaric labeling"},{"id":"JYtd0Dpo","value":"prosthetics/rehabilitation"},{"id":"KSxpl_6N","value":"bleeding disorder"},{"id":"JWrh_Nx_","value":"Microstructures"},{"id":"JZlUFiL7","value":"Brain Activation"},{"id":"JYtdzcAo","value":"phenomenology"},{"id":"JWriBta3","value":"Exercise Test"},{"id":"JYtd0CCT","value":"medical devices "},{"id":"LXb4GOYM","value":"Automated Guided Vehicle System"},{"id":"J9qqT6NL","value":"ViewMate Z"},{"id":"JYtd2BNI","value":"Wild Type"},{"id":"JWrh_uYD","value":"Motor Current Signature Analysis"},{"id":"JWriA77v","value":"Protein Domains"},{"id":"JYDqkM60","value":"Insulin Resistant"},{"id":"JX1LgT8N","value":"AFLP"},{"id":"JYtdz3kx","value":"epidemiology "},{"id":"JYDqkTFF","value":"Diabetic Nephropathy"},{"id":"JWriDd8z","value":"Polychromatophilia"},{"id":"JcX8BlTI","value":"Intraoral source"},{"id":"JWrh__ck","value":"Anticancer antibiotics"},{"id":"JYtd0o8y","value":"Cardiac Index"},{"id":"JbN7ADz7","value":"Mental Health"},{"id":"JYFqh8I9","value":"pelvic pain"},{"id":"LXb4Gm33","value":"Carrier"},{"id":"JYDqiuaf","value":"Malignant Melanoma"},{"id":"JWriA0g-","value":"Biological Data"},{"id":"JX1LggSS","value":"Allorecognition"},{"id":"JX1Lgd-T","value":"Allergic purpura"},{"id":"JWrh_339","value":"Induced pluripotent"},{"id":"JYtdzYrs","value":"seizure emergencies"},{"id":"JcX9Gc9M","value":"Corneal Topographer"},{"id":"JcX8BOJB","value":"Forceps"},{"id":"JYFrH8a4","value":"cutaneous lupus"},{"id":"JYtd0NIp","value":"chemical sensors "},{"id":"JX1LgWWg","value":"Aged patient"},{"id":"JpZWaBQF","value":"Schistosomiasis"},{"id":"JWrh_B9p","value":"Dairy Cattle"},{"id":"JYtd2LC6","value":"Host Defense"},{"id":"JlBiPTRY","value":"blind"},{"id":"LXb4G8A4","value":"Fabricator"},{"id":"JWriAlEI","value":"Protein Structure"},{"id":"JYtd1hbX","value":"Partial Epilepsy"},{"id":"KECpzS7m","value":"IBS"},{"id":"JWriDroZ","value":"Thrombin"},{"id":"JWriBkbS","value":"Metabolic Syndrome"},{"id":"JYtd0diC","value":"Cardiopulmonary Resuscitation"},{"id":"JYFqhzqZ","value":"Renal Transplantation"},{"id":"JWriCRum","value":"Congenital"},{"id":"JX1Lf806","value":"3D culture"},{"id":"JbN7AanV","value":"Patient Safety"},{"id":"LXb4Ghtm","value":"Burn Rate"},{"id":"JpZWZ502","value":"Picornavirus"},{"id":"JWriBEF0","value":"Acute Myocardial Infarction"},{"id":"JcX9GkeF","value":"INTRATHECAL MEDICATION PUMPS"},{"id":"JX1LgLlN","value":"Adenoviruses"},{"id":"LXb4Fk9q","value":"ABM"},{"id":"JYtd1VeE","value":"ACA"},{"id":"JYtd1pHA","value":"Relative Standard Deviation"},{"id":"Jb7jgEvl","value":"Biocatalysts"},{"id":"J9qqTXQX","value":"electrophysiology issues"},{"id":"LXb4HjJ_","value":"Pallet"},{"id":"JYFrH9yj","value":"fibromyalgia"},{"id":"Jb7jcE8Y","value":"Food Additives"},{"id":"JWriCoCN","value":"Hemophilia"},{"id":"JYtd13IN","value":"Molecular Mass"},{"id":"JY9Y_pVB","value":"Hydroxyapatite"},{"id":"JYDqkaS3","value":"Diabetic Complication"},{"id":"JX1LgFV4","value":"acupressure/acupuncture"},{"id":"JY9Y-3TU","value":"5-ht1a receptor"},{"id":"JYtd2Fbo","value":"Peripheral Blood"},{"id":"JYtd1rqF","value":"Organic Solvent"},{"id":"JWriAin7","value":"Sequence Analysis"},{"id":"LXb4HOSN","value":"LASH Vessel"},{"id":"JWriBQaQ","value":"Lipoprotein"},{"id":"JWriApO0","value":"Multiple Alignment"},{"id":"JWriCgA0","value":"Fragility Test (Osmotic)"},{"id":"JWriC9Ee","value":"Leukopenia"},{"id":"JYtdz0b3","value":"proteomics "},{"id":"JX1LgPPk","value":"advanced adenoma"},{"id":"Jbj4Riqu","value":"epidemiology"},{"id":"JX1LgZw4","value":"Aixplorer"},{"id":"JpZWZckC","value":"Cross-species transmission"},{"id":"JcX8BVFq","value":"Otoscopes"},{"id":"JWriBAp4","value":"Graphical Programming"},{"id":"JWriDF8j","value":"Megakaryocyte"},{"id":"Jb7jZEyC","value":"Plastics"},{"id":"JYtd0KU-","value":"screen "},{"id":"LXb4GZ-p","value":"Blanket Rate"},{"id":"JYFqh3mu","value":"Interstitial Cystitis"},{"id":"JpZWaLru","value":"Typhoid fever"},{"id":"JYFrH20j","value":"atherosclerosis"},{"id":"JYDqjieF","value":"Perinatal Outcome"},{"id":"JWrh_aUa","value":"Free Fatty Acid"},{"id":"JlBiPSjE","value":"clock"},{"id":"JWriBJ6J","value":"Chronic Heart Failure"},{"id":"LXb4Foqo","value":"Absorption Costing"},{"id":"JYDqjaUt","value":"Pregnancy Outcome"},{"id":"JbN7ASmQ","value":"Pain Management"},{"id":"JZlUFj_G","value":"Cognitive Function"},{"id":"JWriASHL","value":"Osteosarcoma"},{"id":"JYtd1-fE","value":"Major Histocompatibility Complex"},{"id":"JWrh_wL5","value":"Power Electronics"},{"id":"JWriDUmW","value":"Occult Blood"},{"id":"LXb4GCHN","value":"Air Waybill (AWB)"},{"id":"JZlUFwNf","value":"Peripheral Nerve"},{"id":"JWrh_gM9","value":"Mechanical Property"},{"id":"KHcm1luM","value":"Hepatitis"},{"id":"JWriC_NN","value":"Lymphocyte"},{"id":"LQPQV4Hr","value":"activation T cell"},{"id":"JYtd1cWb","value":"activation volume"},{"id":"JWriAUsv","value":"Prophylactic surgery"},{"id":"Jf1pTuVw","value":"bioengineering"},{"id":"JY9Y_yv0","value":"matrix metalloproteinase"},{"id":"JYtd0rz8","value":"bone marrow"},{"id":"JYDqjR1K","value":"pemphigus vulgaris"},{"id":"JYDqipoH","value":"Electron Microscopy"},{"id":"JYtdzwTM","value":"metabolism "},{"id":"JYtd0U-I","value":"cell signalling "},{"id":"JWriAHut","value":"Glioblastoma treatment"},{"id":"LXb4IJtJ","value":"Tact Time"},{"id":"JY9Y-l8n","value":"Locomotor Activity"},{"id":"JWrh_p2k","value":"Low Density"},{"id":"JYtdzkK_","value":"Agriculture "},{"id":"J9ihSk3b","value":"Alpha particle"},{"id":"JYtd1-xJ","value":"Antigen Presenting Cell"},{"id":"J9ihLmmo","value":"Achromatic"},{"id":"JYtd1MZu","value":"CGU"},{"id":"JWrh_VSj","value":"Crude Protein"},{"id":"JcX40ZHT","value":"Physical Medicine"},{"id":"JpZWZp2I","value":"HIV"},{"id":"JWriBOnB","value":"Myocardial Ischemia"},{"id":"JcX8BixK","value":"Pulp tester"},{"id":"LXb4H0Jh","value":"S&OP"},{"id":"LXb4GzB7","value":"Component"},{"id":"Jb7jhpEd","value":"Chemical Purification"},{"id":"JYtd0_UR","value":"polypeptide"},{"id":"JYFrH3TT","value":"autoantibodies"},{"id":"Jbei9q5Q","value":"Medicine"},{"id":"JX1LgJUg","value":"adaptive biofeedback"},{"id":"JYtd0UKH","value":"disease model "},{"id":"JWriBu35","value":"Low Density Lipoprotein"},{"id":"JYtd1ZTh","value":"Laser"},{"id":"JWrh_Wro","value":"Sensory Analysis"},{"id":"JYtdzgIA","value":"vitamin D"},{"id":"JWriA3t3","value":"Regulatory Network"},{"id":"JcX9GbRs","value":"Sulfide detection device"},{"id":"JpZWaCwr","value":"Shigella"},{"id":"JY9Y_28Z","value":"Sodium Hypochlorite"},{"id":"JYFrH_m4","value":"gout"},{"id":"LXb4Fmbq","value":"ABP"},{"id":"JZlUFtXS","value":"Neurodegenerative Disease"},{"id":"LXb4G1bP","value":"Container Freight Station (CFS)"},{"id":"JYtd0Ck5","value":"pain management "},{"id":"JWriAGrN","value":"Epidemeology"},{"id":"JY9Y-ihs","value":"Mechanism of Action"},{"id":"JWriDjT4","value":"RNA"},{"id":"JYtd120-","value":"Extraction Method"},{"id":"JYtd28cz","value":"mouth"},{"id":"LXb4HHjx","value":"Hawthorne Effect"},{"id":"JWrh_LON","value":"Lactic Acid"},{"id":"Jbj42R7m","value":"Laboratory"},{"id":"JWriDphM","value":"Supravital Stain"},{"id":"JcX40Tlq","value":"EarNose and Throat"},{"id":"Jb7jatcx","value":"Veterinary Products"},{"id":"Jb7jgB2a","value":"Biocatalysis"},{"id":"LXb4Fs3M","value":"Accessibility"},{"id":"JYtd2s6g","value":"Intraocular Pressure"},{"id":"JbN7AwbP","value":"Neonatal Intensive Care Unit"},{"id":"JYFqh7H6","value":"incision"},{"id":"KECpzRp2","value":"abdominal issue"},{"id":"JbN7AX0R","value":"Mental Health Nursing"},{"id":"JYFrH-Ti","value":"fibromyalgia and soft tissue disorders"},{"id":"JpZWZjiu","value":"Epidemic control"},{"id":"LXb4GA7H","value":"Air Cargo"},{"id":"JX1LgTEQ","value":"aerophagia"},{"id":"JYtd0wSb","value":"Isoantibodies"},{"id":"JYtd0mSp","value":"Adverse Effect"},{"id":"JYtd2wZQ","value":"Anterior Chamber"},{"id":"JYtdz4pp","value":"Healthcare "},{"id":"JWrh_DYC","value":"Whey Protein"},{"id":"JeGRHJpa","value":"investment"},{"id":"KHcl5etv","value":"Lupus"},{"id":"JX1Lf-Uw","value":"abdominal symptoms"},{"id":"JYtd0sFd","value":"stem cell"},{"id":"JWrh_sq_","value":"Scanning Electron Microscope"},{"id":"JWriDRHr","value":"Neutropenia"},{"id":"JX1LgKuO","value":"adenomatous polyps"},{"id":"JYtd1gHk","value":"neuronal metabolism"},{"id":"JYtdzsMB","value":"self-managed healthcare"},{"id":"KHXCyq7g","value":"Arthritis - GENERAL"},{"id":"JYtd2Dsx","value":"Glycoprotein"},{"id":"J9ihwRAj","value":"Atomic number"},{"id":"JpZWZ8Iw","value":"Public Health"},{"id":"J9qqTfDD","value":"localization issues electropyhsiology"},{"id":"JYtd0N61","value":"biosensor"},{"id":"LXb4HA5O","value":"Flexible-Path Equipment"},{"id":"JWriCqOT","value":"Heterozygous"},{"id":"JYtd1ht8","value":"visual cortex"},{"id":"JlBiPPfA","value":"circadian rhythms"},{"id":"J9qqT5sE","value":"MediGuide"},{"id":"JpZWZyQ6","value":"MRSA"},{"id":"JY9Y_jWY","value":"Bond Strength"},{"id":"JYtd1eoR","value":"hypoxia"},{"id":"JYDqknde","value":"Metabolic effects"},{"id":"JYtdz8A4","value":"stents "},{"id":"LXb4HTA5","value":"LO/LO"},{"id":"JpZWZhT5","value":"Dysentery"},{"id":"JWriDSoQ","value":"Normoblast"},{"id":"JWrh_50Y","value":"ES"},{"id":"JX1LgP6l","value":"advanced lesions"},{"id":"JcX8BaAh","value":"ESU"},{"id":"JWriBb03","value":"Left Atrial"},{"id":"JYtdzjMp","value":"calcium carbonate"},{"id":"Jf1pThWp","value":"Structured Illumination Microscopy (SIM)"},{"id":"JWriC_5G","value":"Lymphocytosis"},{"id":"JX1LgaNG","value":"AKI"},{"id":"JYFqhsKt","value":"Auscultation"},{"id":"JYtd1r78","value":"Solvent Extraction"},{"id":"KHXCy0X4","value":"Flu - Adults"},{"id":"J9qL7lM2","value":"Cardiac Arrhythmia treatment"},{"id":"JYtd1_yq","value":"Nk Cell"},{"id":"LXb4H5Jg","value":"SCM"},{"id":"LXb4GVlU","value":"Bill of Material Accuracy"},{"id":"JX1Lf9sR","value":"abdominal mass"},{"id":"JYFqhyqZ","value":"Renal Cell Carcinoma"},{"id":"Jb7jg-s1","value":"Thermodynamics"},{"id":"Jb7jdxrb","value":"Catalysts"},{"id":"JYtd1VFm","value":"ACC"},{"id":"JWriBR_L","value":"Cardiovascular Events"},{"id":"JY9Y_qwh","value":"Salivary Gland"},{"id":"JWriBiPX","value":"Cardiovascular Risk"},{"id":"JYtd1Eaw","value":"UAU"},{"id":"JYFrH4xv","value":"autologous transplantation"},{"id":"JcX8BXih","value":"Surgical Headlights"},{"id":"JX1LgeSx","value":"allergies"},{"id":"JYtdzoz-","value":"fertilizer "},{"id":"JWriBFhV","value":"Risk Factors"},{"id":"JYDqklHc","value":"Comp epidural anes"},{"id":"JYDqkcGc","value":"Glucose Metabolism"},{"id":"JYtd0Lsd","value":"combinatorial biology "},{"id":"JWriAnS3","value":"Maximum Likelihood"},{"id":"JYtd0gGI","value":"Respiratory Failure"},{"id":"LQPQV1UF","value":"stimulate T cell"},{"id":"JWriATni","value":"Pituitary gland cancer"},{"id":"LXb4HZw-","value":"Transportation"},{"id":"Jbei9urN","value":"fiber"},{"id":"LXb4GQc7","value":"Bar Code"},{"id":"JYtd1qe6","value":"Capillary Zone Electrophoresis"},{"id":"Jgd_HJlf","value":"mapping"},{"id":"JY9Y-zrT","value":"Positron Emission Tomography"},{"id":"J9ihHzcl","value":"Absorptance"},{"id":"JYtd2Oa-","value":"Mycobacterium Tuberculosis"},{"id":"JWrh_h1W","value":"Induction Motor"},{"id":"JYtdznFD","value":"bioremediation "},{"id":"JWriDBp0","value":"Macrocyte"},{"id":"JWriCfkV","value":"Fibrinogen"},{"id":"JWrh_rkZ","value":"Adjustable Speed Drive"},{"id":"JYtd25ET","value":"Ciliary Body"},{"id":"JWriBBuh","value":"Biological Systems"},{"id":"JYtdzdUY","value":"cerebral"},{"id":"JWriDIgi","value":"Metamyelocyte"},{"id":"JcX8BfDR","value":"Invertertube Surgical Microscope"},{"id":"LXb4Glzb","value":"Capacity Management"},{"id":"JYtdzznn","value":"polymorphism "},{"id":"JZlUFodd","value":"Temporal Lobe"},{"id":"Jgd_HH7O","value":"genomics"},{"id":"JYtd0ZU9","value":"Critically Ill"},{"id":"JWriDJ_z","value":"Microcyte"},{"id":"JYtdzwBn","value":"in situ "},{"id":"JYtdzvQN","value":"contrast agent "},{"id":"JWriARw5","value":"Oat cell cancer symptoms"},{"id":"JcX8BSbD","value":"Lletz Instruments"},{"id":"Jf1pTqW-","value":"immunocytochemists"},{"id":"JcX9GgVV","value":"Fast Pulse Laser Photocoagulator"},{"id":"KRyWT5tM","value":"Attention deficit"},{"id":"JX1LgGRL","value":"acute decompensation"},{"id":"JWrh_Edn","value":"Food Industry"},{"id":"Lb8_sqE6","value":"unite the right"},{"id":"JYtd0t4g","value":"Flowcytometry crossmatching"},{"id":"Jb7jfaP0","value":"Heterogeneous Catalysts"},{"id":"Lb8_sdPB","value":"new mexico"},{"id":"JWrh--MU","value":"Milk Fat"},{"id":"JWrh_REZ","value":"Corn Silage"},{"id":"JWriAma_","value":"Nucleic Acid"},{"id":"JX1LgMms","value":"adipokine"},{"id":"JX1LgX_i","value":"AIDS"},{"id":"JcX40RZ_","value":"Cardiovascular"},{"id":"JWriACDX","value":"Blood cancers"},{"id":"JYtd2IAk","value":"Lymph Node"},{"id":"JYDqkYlU","value":"Fasting Plasma Glucose"},{"id":"JYtd0FuU","value":"PCR "},{"id":"JWrh_Jsi","value":"Fatty Acid Composition"},{"id":"JWriDrPl","value":"Triturate"},{"id":"LXb4FgzY","value":"ABC Model"},{"id":"JYDqjnR6","value":"Oxytocin"},{"id":"LXb4Fx8L","value":"Actual to Theoretical Cycle Time"},{"id":"JY9Y--DR","value":"Drug Development"},{"id":"JYtdzeFj","value":"perioperative neurophysiology"},{"id":"JWriDhiy","value":"Reduced Hemoglobin"},{"id":"JcX8BOpN","value":"Emmet Hook"},{"id":"JWriBV5l","value":"Cardiac Surgery"},{"id":"JYtd1RmB","value":"acid"},{"id":"JpZWZv7E","value":"Lentivirus"},{"id":"JYtd11EB","value":"Ionic Strength"},{"id":"JX1LgVsR","value":"age"},{"id":"JYtd0I-b","value":"equipment "},{"id":"JWrh_x7D","value":"Distributed System"},{"id":"JYtd1X0F","value":"Lysine"},{"id":"JpZWZ0oe","value":"Melioidosis"},{"id":"JWriDnL2","value":"Sickle Cell Anemia"},{"id":"J9qqTvRq","value":"Reduce and better manage case costs through the ability to use either sensor enabled or impedance catheters"},{"id":"JX1LgNsO","value":"ADRB"},{"id":"JYDqkgSN","value":"Glucose Uptake"},{"id":"JpZWZZLr","value":"Bioinformatics"},{"id":"JWriDa5G","value":"Plasma"},{"id":"JWriDPKl","value":"Myelocyte"},{"id":"KD94oTUr","value":"stomach ache"},{"id":"JYtdz1ev","value":"pharmacogenomics "},{"id":"JYtd0Ebs","value":"reagent "},{"id":"JWriCImm","value":"Band Form"},{"id":"JbN7At0q","value":"Very Low Birth Weight"},{"id":"JpZWaIHi","value":"Toxoplasma"},{"id":"JYtd1B7b","value":"UUG"},{"id":"LXb4GNkk","value":"Automated Call Distribution"},{"id":"JYDqjcfS","value":"Amniotic Fluid"},{"id":"JY9Y_vf9","value":"Gingival Crevicular Fluid"},{"id":"JYtd0krD","value":"Mean Arterial Pressure"},{"id":"JWriBo6y","value":"Cardiac Function"},{"id":"JYDqkpTA","value":"Epi + local anes"},{"id":"JYFqh1Oy","value":"Transitional Cell Carcinoma"},{"id":"JYtdz_u9","value":"robotics "},{"id":"JYtd2Cax","value":"Mhc Class I"},{"id":"JYFqh52K","value":"intrauterine"},{"id":"JYFrICgP","value":"osteoarthritis"},{"id":"JX1Lf_Lz","value":"abscess"},{"id":"JZlUFfXC","value":"Functional Magnetic Resonance Images"},{"id":"J9qL7er6","value":"3D mapping localization issues electropyhsiology"},{"id":"JYDqjUfM","value":"Epithelial Cell"},{"id":"JYDqZuY8","value":"Human Skin"},{"id":"JYtd10H7","value":"Polycyclic Aromatic Hydrocarbon"},{"id":"JYtd1BF4","value":"UUU"},{"id":"JWriCufq","value":"Hypertrophy"},{"id":"JbN7AH84","value":"Nurse Practitioner"},{"id":"JWrh_z_Z","value":"Hematopietic"},{"id":"JYtd1QNe","value":"GAU"},{"id":"J9ihqcY1","value":"Absolute humidity"},{"id":"JX1LgRM4","value":"adverse events"},{"id":"LXb4Htam","value":"RFP"},{"id":"JWriDZXz","value":"Pernicious Anemia"},{"id":"JYtdzZ2I","value":"meningitis"},{"id":"JpZWaEkS","value":"Simulation"},{"id":"JWriBYC-","value":"Left Ventricular Hypertrophy"},{"id":"JWrh_deX","value":"Cell Wall"},{"id":"JWriC3CL","value":"Isotonic"},{"id":"JYtd0S2C","value":"antibiotic "},{"id":"JYDqki9O","value":"Gastric emptying"},{"id":"JYtd20KY","value":"Cervical Carcinoma"},{"id":"JpZWZWgT","value":"Antigenic cartography"},{"id":"JcX8BJRc","value":"Heart Attack"},{"id":"JWriDuDg","value":"Thrombopoiesis"},{"id":"LQPQV-bN","value":"immunometabolism"},{"id":"JYtd1jJB","value":"stimulus duration"},{"id":"JYtd0PQX","value":"bioinformatics "},{"id":"JYtd2yrM","value":"indocyanine green"},{"id":"JWriCPoA","value":"Chromatin"},{"id":"JYtd1O25","value":"GCU"},{"id":"JbN7ALdx","value":"Pressure Ulcer"},{"id":"J9ihX4_L","value":"Ampere"},{"id":"LXb4IeoC","value":"VMI"},{"id":"JX1LgIMo","value":"acute pancreatitis"},{"id":"Jb7jhbPm","value":"Chemical Process Design"},{"id":"Jgd_HTOZ","value":"sequencing"},{"id":"JWriBgdk","value":"Polymorphism"},{"id":"JWriCXvJ","value":"Eosinophilic"},{"id":"JZlUFow8","value":"Blood Brain Barrier"},{"id":"JbN7AmH6","value":"Family Caregiver"},{"id":"JWriCsTt","value":"Howell-Jolly Bodie."},{"id":"JWriAPQW","value":"Metastatic bladder cancer"},{"id":"JcX8BGY5","value":"X ray"},{"id":"KSxpl_XB","value":"immune thrombocytopenic purpura"},{"id":"JWriCdeL","value":"Extravascular"},{"id":"JYtdzuLw","value":"detection "},{"id":"JWrh_X9W","value":"Functional Food"},{"id":"LQPQWB7e","value":"T cell fate"},{"id":"JYtd2_RK","value":"rhinology"},{"id":"JWriAEsF","value":"Colony stimulating factors"},{"id":"LXb4H_c0","value":"Skills Matrix"},{"id":"Jf1pTopX","value":"receptor localization"},{"id":"JYtd1TB3","value":"GGG"},{"id":"JY9Y_3b0","value":"Temporomandibular Disorder"},{"id":"JWrh_evX","value":"Somatic Cell Count"},{"id":"JWrh_m8p","value":"maleic anhydride"},{"id":"JYFqhp_R","value":"Laparoscopy hypoxemia"},{"id":"JbN7AiXX","value":"Health Care Provider"},{"id":"LXb4IVMe","value":"Upside Production Flexibility"},{"id":"JWrh_kjY","value":"Industrial Application"},{"id":"JWrh_jgm","value":"Natural Rubber"},{"id":"JWriCV2j","value":"Ecchymosis"},{"id":"JX1LgUmW","value":"AFP negative"},{"id":"JYtd2MMF","value":"Enzyme Linked Immunosorbent Assay"},{"id":"JbN7AT3Y","value":"End-of-life Care"},{"id":"Jbj42UdJ","value":"Newborn"},{"id":"J9ihfXAh","value":"Angle of refraction"},{"id":"JYFrHy-o","value":"anti-dna"},{"id":"JpZWaRyn","value":"X ray Crystallography"},{"id":"JX1LgDoa","value":"ACLF"},{"id":"JYtd15Ub","value":"Optimality Condition"},{"id":"JWrh_SOK","value":"Sensory Evaluation"},{"id":"JYtd2PW9","value":"Inflammatory Cytokine"},{"id":"JYtdzmTX","value":"seeds "},{"id":"JYtd2GlI","value":"B Lymphocyte"},{"id":"JcX8BjxM","value":"Caries detection device"},{"id":"LQPQV40a","value":"T cell populations"},{"id":"KHcl5Zb4","value":"Women's Health - GENERAL"},{"id":"JcX8BMr1","value":"Hysteroscopic Instruments"},{"id":"JYtdzx2U","value":"lipid"},{"id":"JYtdzlzK","value":"nitrogen fixation "},{"id":"JWriC-dY","value":"Lymphoblast"},{"id":"JYFqhvO3","value":"Phrenic paralysis (PCA)"},{"id":"KHXCyrk_","value":"Asthma"},{"id":"Jbei9qM_","value":"Internal"},{"id":"JX1LgNeY","value":"Adoptive transfer"},{"id":"JlBiPS5G","value":"cues"},{"id":"JYDqkhFk","value":"ASA PS classification"},{"id":"JY9Y-slQ","value":"nmda receptor"},{"id":"JYDqjQRr","value":"Barrier Function"},{"id":"JWrh_pgO","value":"Operant Conditioning"},{"id":"JYtd0VPI","value":"analgesic "},{"id":"LXb4HI1j","value":"Hazardous Goods"},{"id":"LXb4IIbG","value":"Supply Chain"},{"id":"JYtdz1vM","value":"microarray software "},{"id":"Jb7jiDz_","value":"Thermochemical Conversion"},{"id":"JWriAKFK","value":"In situ non-invasive cancer"},{"id":"JWriBEcq","value":"Left Ventricular"},{"id":"JWriCVOU","value":"Dyscrasia"},{"id":"JYDqkpuy","value":"B-blockade effect Laryngospasm complications"},{"id":"JcX9Gk1S","value":"Narrator"},{"id":"JWriCSGy","value":"Cooley&rsquo;s Anemia (Mediterranean Disease or Thalassemia"},{"id":"JYFqh0-v","value":"Acute Renal Failure"},{"id":"LXb4GeEU","value":"Buffer"},{"id":"JYtdz6Nl","value":"laser "},{"id":"JbN7AcIo","value":"Chronic Illness"},{"id":"JX1Lf_Ze","value":"access to care"},{"id":"JYDqaVui","value":"Atopic Dermatitis"},{"id":"JYtd1W88","value":"AAA"},{"id":"JYFqhqNy","value":"Lat fem cutan nerve block anatomy"},{"id":"JWrh_Vpk","value":"Sensory Properties"},{"id":"JWriCu6M","value":"Hypochromia"},{"id":"JY9Y_nd3","value":"Composite Resin"},{"id":"Jgd_HOq9","value":"nucleotide"},{"id":"JX1LgHxZ","value":"acute liver failure"},{"id":"JYtd0KDi","value":"Screening "},{"id":"JbN7Apch","value":"Critical Thinking"},{"id":"JWriBQxd","value":"C Reactive Protein"},{"id":"LXb4HdTw","value":"Origin"},{"id":"JWriDufD","value":"Thrombosis"},{"id":"JWriDEgX","value":"Mean Corpuscular Hemoglobin Concentration (MHC)"},{"id":"JWriABj5","value":"Bilirubin"},{"id":"JYtdzutY","value":"imaging "},{"id":"KSxpmAa1","value":"blood platelets"},{"id":"JWrh_OM1","value":"Model System"},{"id":"JWriBMty","value":"Coronary Angiography"},{"id":"JYDqjfh2","value":"Maternal Age"},{"id":"JWrh_qll","value":"Electric Drive"},{"id":"JYtd1NwT","value":"GUU"},{"id":"JYtd0ikM","value":"Inflammatory Response"},{"id":"JpZWaMfb","value":"Ubiquitin"},{"id":"JWrh_cSA","value":"Sensory Quality"},{"id":"JYtd1CvZ","value":"UCA"},{"id":"JbN7AA-k","value":"Nursing Care"},{"id":"JcX8BTaF","value":"Catheter"},{"id":"JWriA8kX","value":"Cdna Microarray"},{"id":"JbN7AEzy","value":"Evidence Based Practice"},{"id":"JX1LgXgu","value":"AhR and DIM"},{"id":"JWriAO51","value":"Metastasis"},{"id":"Jb7jc598","value":"Industrial Gases"},{"id":"Jf1pTu4Y","value":"systems biology"},{"id":"JYtd1FhK","value":"Tyrosine"},{"id":"LXb4HugF","value":"RFQ"},{"id":"JX1LgF1l","value":"acute appendicitis"},{"id":"JX1LgY4H","value":"AIP"},{"id":"JZlUFjoy","value":"Synaptic Plasticity"},{"id":"LXb4GwA_","value":"Complete and On-Time Delivery (COTD)"},{"id":"JWrh_gjq","value":"Polypropylene"},{"id":"JWriDltn","value":"Shift to the Left"},{"id":"JbN7AOZ1","value":"Qualitative Research"},{"id":"LXb4IYGL","value":"Variable Cost"},{"id":"JYtd21y4","value":"Best Corrected Visual Acuity"},{"id":"JZlUFp8K","value":"embryonics"},{"id":"JYtd1cpG","value":"AmygalA"},{"id":"JYtd0WUI","value":"small molecule "},{"id":"LXb4G64r","value":"End-of-Life Inventory"},{"id":"JX1LgKgg","value":"adenomas"},{"id":"JbN7Aeyh","value":"Qualitative Study"},{"id":"JWriA04a","value":"Mixed Model"},{"id":"JWrh_owC","value":"Doubly Fed Induction Generator"},{"id":"JWrh_2yK","value":"gene expression"},{"id":"JX1LgD2M","value":"acoustic stress"},{"id":"JYtdzzX1","value":"bioinformatic "},{"id":"KHcl5Xp_","value":"Sleep Disorders - GENERAL"},{"id":"JWriAvSY","value":"False Positive"},{"id":"KHXCyuwY","value":"Cancer - GENERAL"},{"id":"LXb4Fjdy","value":"ABI"},{"id":"JWrh_ArW","value":"Dry Matter"},{"id":"JcX40aR0","value":"Radiology"},{"id":"J9qqTn2g","value":"Carto Univu Biosense Webster"},{"id":"Jb7jgKqF","value":"Enzymes"},{"id":"JpZWZqe2","value":"Host pathogen interactions"},{"id":"JYtd0h_5","value":"Multiple Organ Failure"},{"id":"JY9Y-wLo","value":"Reactive Oxygen Specie"},{"id":"JWriCF2-","value":"Antecubital Space"},{"id":"JWriBr4e","value":"Sudden Cardiac Death"},{"id":"JbN7AoOj","value":"Chronic Lung Disease"},{"id":"JYtd0T5b","value":"angiogenesis "},{"id":"Jb7jbzMn","value":"Vitamins"},{"id":"JpZWZ4o7","value":"Pathogenesis"},{"id":"JYtdz_NK","value":"atomic probe microscopy "},{"id":"JX1LgFIO","value":"actuating range"},{"id":"JWriAhFE","value":"Statistical Method"},{"id":"JWrh_Cp3","value":"Ascorbic Acid"},{"id":"JYDqkWDY","value":"Type Ii Diabetes"},{"id":"JWriAMrY","value":"Locally advanced cancer"},{"id":"JYtd1pp3","value":"Liquid Chromatographic"},{"id":"JcX9Gdma","value":"Auto Tonometer"},{"id":"JWriDoJY","value":"Spherocyte"},{"id":"JWriBZ7X","value":"Essential Hypertension"},{"id":"JWriAGVJ","value":"Edema"},{"id":"J9qL7cK2","value":"3D mapping interventional electropyhsiology problems"},{"id":"JYDqcmHh","value":"Epidermal Cells"},{"id":"JbN7ADTM","value":"Palliative Care"},{"id":"JYtd0CS6","value":"surgical "},{"id":"J9ih0YI_","value":"Acoustics"},{"id":"LXb4GYn5","value":"Blanket Purchase Order"},{"id":"JpZWZgEn","value":"Drug Discovery"},{"id":"JWriBimj","value":"Congenital Heart Disease"},{"id":"LXb4GLnL","value":"Audit Trail"},{"id":"Jb7jYxLL","value":"Polymers"},{"id":"JYtd14Bp","value":"Ion Chromatography"},{"id":"JY9Y_6LE","value":"Surface Roughness"},{"id":"JYtd1R3R","value":"Glutamic"},{"id":"JWriCNLq","value":"Buffy Coat"},{"id":"JWriCpIQ","value":"Hemostasis"},{"id":"JYtd1fPd","value":"image segmentation"},{"id":"LXb4IDJO","value":"SOP"},{"id":"JWrh_uv_","value":"Health Monitoring"},{"id":"JWriBG0z","value":"Congestive Heart Failure"},{"id":"JbN7APv4","value":"Older Adult"},{"id":"JYDqjlRt","value":"Human Papillomavirus"},{"id":"JYtd0W2J","value":"pro-drug "},{"id":"JWriAzzp","value":"bayesian network"},{"id":"JWrh_43b","value":"HSC"},{"id":"JX1LgVeO","value":"african-americans"},{"id":"JWriAnqt","value":"saccharomyces cerevisiae"},{"id":"JWriDX9o","value":"Oxyhemoglobin"},{"id":"JYtd2Qlm","value":"Innate Immune Response"},{"id":"J9ihrMzt","value":"Antineutrino"},{"id":"JYtd0Lbt","value":"target "},{"id":"JcX8BbA8","value":"Patient Transport"},{"id":"JWrh_3ej","value":"iPS"},{"id":"Jgd_HRqw","value":"polymorphic"},{"id":"JYFqh8ZQ","value":"general adhesion"},{"id":"JWriBPsh","value":"Nitric Oxide"},{"id":"JcX8BmOy","value":"Cephalometer"},{"id":"JYtd2E1N","value":"Cytotoxic T Lymphocyte"},{"id":"JWrh_vdz","value":"Epoxy Resin"},{"id":"Jf1pTsl_","value":"stem cell biology"},{"id":"KHXCyzGy","value":"Digestive/Gastro Health - GENERAL"},{"id":"JYDqjWB3","value":"Cell Surface"},{"id":"JWriAeJh","value":"Sequence Alignment"},{"id":"JWriBbdP","value":"Endothelial Function"},{"id":"JWriCzLC","value":"Inclusion"},{"id":"JYDqjSTa","value":"Cutaneous T Cell Lymphoma"},{"id":"JY9Y_5rk","value":"Clinical Application"},{"id":"JWriDHQP","value":"M.E. Ratio"},{"id":"JcX8BKsY","value":"High Blood Pressure"},{"id":"JpZWaP8U","value":"Virion assembly"},{"id":"Jf1pTlXc","value":"histology"},{"id":"JWriCLKn","value":"Basophilic"},{"id":"JcX9GiyM","value":"Gamma Edging Equipment"},{"id":"JY9Y-mzK","value":"nucleus accumbens"},{"id":"JYtd2SR5","value":"Innate Immune System"},{"id":"JWrh_UOg","value":"Total Phenolics"},{"id":"JWriAD9k","value":"Carcinoma in situ"},{"id":"LQPQVz3s","value":"Immune cell activation assay"},{"id":"JYDqkc83","value":"Glucagon Like Peptide"},{"id":"JYFqhpSu","value":"Interscalene block: Phrenic paralysis PCA"},{"id":"Jbj4Rlk-","value":"Anionsy"},{"id":"J9ihTtPj","value":"Alternating current"},{"id":"JYDqgejn","value":"Skin Lesion"},{"id":"J9ihMLfq","value":"Acoustics"},{"id":"JpZWZgrY","value":"Dynamics"},{"id":"JYtd1V0V","value":"ACG"},{"id":"JYtd1Mqn","value":"CGC"},{"id":"JWriAseV","value":"Graphic User Interface"},{"id":"JYtd0SUc","value":"hormone "},{"id":"JYtd0vOe","value":"kidney"},{"id":"JYtd1xq0","value":"Organic Compound"},{"id":"LXb4Hh7H","value":"Packing List"},{"id":"Jb7jhrb8","value":"Chemical Separation"},{"id":"JWriBC1l","value":"Myocardial Infarct"},{"id":"Jb7jZpbZ","value":"Derivatives"},{"id":"JWriAVwl","value":"Radiofrequency ablation"},{"id":"JY9Y_lLC","value":"Oral Health"},{"id":"JWriAi-q","value":"Data Mining"},{"id":"LXb4HM-O","value":"Indirect/Distributor Channel"},{"id":"JYtd2-r-","value":"facial trauma"},{"id":"JYtd2FIJ","value":"Flow Cytometry"},{"id":"JX1LgUKO","value":"AFM"},{"id":"Lb8_snY2","value":"white nationalist"},{"id":"JZlUFkRl","value":"Glutamate Receptor"},{"id":"JYtd0usA","value":"Interleukin-2 receptor"},{"id":"JWrh_GsA","value":"Heat Treatment"},{"id":"JYtd263H","value":"sinuses"},{"id":"JYFqhr7g","value":"Double lumen tube"},{"id":"Jbj4Rknr","value":"Phenomena"},{"id":"JYtdz0Kr","value":"receptor "},{"id":"JYtd0zAI","value":"complication"},{"id":"JWriDGnn","value":"Megaloblast"},{"id":"JcX8BVlP","value":"ENT Chairs"},{"id":"JYFrH2YN","value":"antiphospholipid syndrome"},{"id":"JYtdz0sr","value":"library "},{"id":"JWrh_ap_","value":"Sterilization"},{"id":"JX1LgZ_D","value":"ajulemic acid"},{"id":"JYtd0O_O","value":"sound synthesis "},{"id":"LXb4INOh","value":"TOC"},{"id":"JWriBKSP","value":"High Risk"},{"id":"JWriCDY2","value":"Agranulocytosis"},{"id":"JX1LgS19","value":"Aeroallergen"},{"id":"JYtd0oqS","value":"Activated Protein C"},{"id":"JYDqkSlD","value":"Control Subjects"},{"id":"JWriARAu","value":"Neoplasm"},{"id":"JWriChHC","value":"Golgi Apparatus"},{"id":"JWrh_8Ug","value":"Acute granulocytic leukemia"},{"id":"JpZWZvVR","value":"Leishmania"},{"id":"JZlUFv6l","value":"Action Potential"},{"id":"JWriCafF","value":"Erythrogenic"},{"id":"JYtdz7wK","value":"microscopy "},{"id":"JX1Lgfo6","value":"Allocation"},{"id":"JYtdz3Ue","value":"genotype "},{"id":"JWrh-3vs","value":"Dairy Cow"},{"id":"Jb7jdEjg","value":"Sealants"},{"id":"JWrh_CUE","value":"Milk Protein"},{"id":"JWriA2oP","value":"Protein Sequence Analysis"},{"id":"JY9Y_zOV","value":"Oral Mucosa"},{"id":"JY9Y-kUC","value":"Guinea Pig"},{"id":"JYtd0IMv","value":"protein sequencing "},{"id":"JWriAcuJ","value":"High Throughput"},{"id":"JYtdzc0D","value":"dysautonomias"},{"id":"Jb7jgj3_","value":"Catalyst Promoters"},{"id":"JYtd0ao2","value":"Emergency Medicine"},{"id":"JY9Y_yQz","value":"Analysis of Variance"},{"id":"JYtd1gY5","value":"physiological noise"},{"id":"JYtd1DSG","value":"Serine"},{"id":"JYFqhz6q","value":"Chronic Renal Failure"},{"id":"JY9Y-8rv","value":"Breast Cancer"},{"id":"JpZWZ5Ph","value":"Pharmacology"},{"id":"JX1LgLy9","value":"adhesion"},{"id":"JY9Y-4J1","value":"Drug Metabolism"},{"id":"LXb4HzIL","value":"ROA"},{"id":"JWriAXoS","value":"Salivary gland cancer symptoms"},{"id":"JYtd1G94","value":"UGG"},{"id":"JYDqjH-9","value":"Skin Biopsy"},{"id":"JX1LgAAX","value":"acetylcholine"},{"id":"JYtd2ust","value":"Optic Nerve"},{"id":"JYFqh_TK","value":"spectra filtering"},{"id":"JcX8BEgs","value":"left ventricular assist device"},{"id":"Jbei9ren","value":"Surgeons"},{"id":"JWriCiqV","value":"Granulopoiesis"},{"id":"LXb4G0ZB","value":"Computer-Aided Engineering (CAE)"},{"id":"J9ihjX3W","value":"Angular momentum"},{"id":"JX1LgW0M","value":"AGEs"},{"id":"JpZWZ2Rr","value":"NF kB"},{"id":"JYFrIFTz","value":"psoriatic arthritis"},{"id":"JX1Lga3l","value":"Alarm feature"},{"id":"JWriA4yj","value":"Sequence Similarity"},{"id":"JYtd1nEH","value":"Tandem Mass Spectrometry"},{"id":"JWriBtCc","value":"Intravascular Ultrasound"},{"id":"LXb4GUgy","value":"Benefit-Cost Ratio"},{"id":"JWriApmu","value":"Cross Validation"},{"id":"JYtd0C3m","value":"minimally/non-invasive "},{"id":"JWriAwus","value":"Differential Expression"},{"id":"JYtd23B_","value":"Surgical Treatment"},{"id":"JX1LgfWM","value":"Alloantigens"},{"id":"JWriDxoL","value":"Meschininal stem cells"},{"id":"LXb4GPfB","value":"Automated Storage/Retrieval System"},{"id":"JY9Y_8IJ","value":"Literature Review"},{"id":"J9qqT3XW","value":"Velocity"},{"id":"JYDqji5e","value":"Logistic Regression"},{"id":"JYtd12hp","value":"electroosmotic flow"},{"id":"JX1LgPdx","value":"advanced cancer"},{"id":"JpZWZdJi","value":"Cytomegalovirus"},{"id":"JcX8BdBz","value":"DRE Integra Anesthesia System"},{"id":"JZlUFpoT","value":"Cortical Neurons"},{"id":"JYFqh34f","value":"Renal Biopsy"},{"id":"JYDqjolD","value":"Systematic Review"},{"id":"LXb4Fnn4","value":"Abnormal Demand"},{"id":"JYtdz8ic","value":"syringe/needles "},{"id":"JYtd0L9v","value":"phage display "},{"id":"JcX9Ge8R","value":"Keratometer"},{"id":"J9qqT_W4","value":"TactiCath"},{"id":"JYFqiALo","value":"artefactual chemical modifications"},{"id":"JWriDVBW","value":"Oligochromemia"},{"id":"JYtd1qzL","value":"Ion Exchange"},{"id":"JYtd1QwW","value":"GAA"},{"id":"JZlUFrY1","value":"Brain Derived Neurotrophic Factor"},{"id":"LXb4Hmak","value":"QFD"},{"id":"JWriBOO2","value":"Right Ventricular"},{"id":"KHXCy2Gv","value":"Heart/CardioVascular - GENERAL"},{"id":"KRyWT86N","value":"ADHD"},{"id":"JWriBVUP","value":"Angiotensin Ii"},{"id":"LQPQWCrx","value":"regulation of T cell differentiation"},{"id":"JYtdzr8P","value":"gaming "},{"id":"JWriCfJG","value":"Fibrin"},{"id":"JYDqjhMR","value":"Pelvic Organ Prolapse"},{"id":"JWriBBXm","value":"World Wide Web"},{"id":"JYtdzdEX","value":"sleep"},{"id":"JWriCJOX","value":"Basket Cell"},{"id":"JYtdzsbs","value":"Diagnostic "},{"id":"JYtd2GBG","value":"Multiple Sclerosis"},{"id":"JWriAkah","value":"Protein Protein Interaction"},{"id":"JcX8Bgyf","value":"Anesthesia Machine"},{"id":"JWriBIV4","value":"Arrhythmia"},{"id":"JpZWZ8u0","value":"RNA virus"},{"id":"JZlUFoLb","value":"Nerve Growth Factor"},{"id":"JYtd0_qc","value":"messenger RNA"},{"id":"JYtd0NqB","value":"gas sensors "},{"id":"JcX8BR7c","value":"Dressing Forceps"},{"id":"JYtd1lVW","value":"Detection Limit"},{"id":"JpZWZy15","value":"Macrophage"},{"id":"JYtd28wg","value":"pediatric"},{"id":"JWriBfu5","value":"Hypertrophic Cardiomyopathy"},{"id":"JYtd1v56","value":"Liquid Chromatography Mass Spectrometry"},{"id":"JY9Y_i0b","value":"Dental Caries"},{"id":"JX1LgGDa","value":"acute cholecystitis"},{"id":"JYtd1yoR","value":"Supercritical Fluid"},{"id":"JWriAcXI","value":"Large Scale"},{"id":"JYtd2Ruq","value":"Chemokine Receptor"},{"id":"JYtd0QVZ","value":"apoptosis "},{"id":"JpZWZVUM","value":"Antibody"},{"id":"JYtd0Qmz","value":"gene therapy "},{"id":"LXb4F7r2","value":"Aerodynamic Drag"},{"id":"JWriDY-_","value":"Pathologic Increase (Or Decrease)"},{"id":"Lb8_sjEg","value":"charlottesville"},{"id":"LXb4HRig","value":"Council of Supply Chain Management"},{"id":"KHXCy1AX","value":"GERD"},{"id":"J9qqT2JX","value":"EnSite"},{"id":"JbN7Av70","value":"Best Practice"},{"id":"JYtd0Fd8","value":"electrophoresis "},{"id":"JWriACZU","value":"Biomarkers"},{"id":"JWriCTky","value":"DNA"},{"id":"JYtd1H06","value":"Start"},{"id":"LXb4H3mp","value":"SCEM"},{"id":"JZlUFtEn","value":"Cerebral Ischemia"},{"id":"JYtd1ZBz","value":"AG"},{"id":"JZlUFho-","value":"Glial Cell"},{"id":"JWrh_IkQ","value":"Water Activity"},{"id":"JYFqhs-l","value":"mechanisms"},{"id":"JpZWaQ_I","value":"Virulence"},{"id":"J9ihv37L","value":"Acceleration"},{"id":"JYtd2y9_","value":"Contact Lenses"},{"id":"JWriDout","value":"Stasis"},{"id":"JYFrH4Wl","value":"autoimmune diseases"},{"id":"JbN7AKo4","value":"Job Satisfaction"},{"id":"Jb7ja6MH","value":"Biotechnology"},{"id":"JYFqhmur","value":"Anesthetic management MAO"},{"id":"JWriCYJ0","value":"Epigastric"},{"id":"JYtd0Ita","value":"RNAi "},{"id":"JWriCEwb","value":"Anisocytosis"},{"id":"JX1LgTSS","value":"Af-Gc globulin"},{"id":"LQPQV9ur","value":"T cell exhaustion"},{"id":"JYtd1wf3","value":"Fused Silica"},{"id":"JWriAPmg","value":"Metastatic ovarian cancer"},{"id":"LXb4GRZB","value":"Basing-Point Pricing"},{"id":"JYtd0BAU","value":"video "},{"id":"JWrh_66E","value":"Cancer stem cells"},{"id":"JcX8BQcm","value":"Loop Electrodes"},{"id":"JY9Y-vtg","value":"multidrug resistance"},{"id":"JYFrIFxA","value":"rheumatoid arthritis (ra)"},{"id":"JpZWZZ_3","value":"Burkholderia"},{"id":"JWriBvoX","value":"Aortic Valve"},{"id":"JpZWaHZh","value":"Toll like receptors"},{"id":"JWrh_ZDQ","value":"Human Health"},{"id":"JYtd0EKt","value":"vector "},{"id":"JWriA6PH","value":"High Resolution"},{"id":"JYtd2OuG","value":"plasmodium falciparum"},{"id":"JYtdz4Yv","value":"positional cloning"},{"id":"JYFqh4qh","value":"Kidney Disease"},{"id":"JX1LgK74","value":"adenosine receptors"},{"id":"JYFqh-Uj","value":"peak list processing"},{"id":"J9ihGos3","value":"Absolute zero"},{"id":"JbN7Ai43","value":"Patient Satisfaction"},{"id":"JYtd23U2","value":"Uterine Cervix"},{"id":"JYtd2Kfi","value":"Natural Killer"},{"id":"JYtd0ZEi","value":"Septic Shock"},{"id":"JcX9GiDq","value":"Edging Equipment"},{"id":"JYtd0G6D","value":"hybridization "},{"id":"JlBiPQbZ","value":"wake"},{"id":"JWriCplW","value":"Hepatic"},{"id":"LXb4IEkE","value":"SOW"},{"id":"JX1LgUYe","value":"AFP"},{"id":"KHXCyx65","value":"Dermatology/Skin Care"},{"id":"Jf1pTq51","value":"instrumentation specialists"},{"id":"J9iheEy0","value":"Angle of reflection"},{"id":"JcX8BiRV","value":"Gingival fluid measurer"},{"id":"JYtd10be","value":"Supercritical Carbon Dioxide"},{"id":"JYtdzjcL","value":"chelated calcuim"},{"id":"JYtd0mAw","value":"Antibiotic Therapy"},{"id":"JbN7AIbX","value":"Pilot Study"},{"id":"JYtdz80l","value":"neonatology/pediatrics"},{"id":"JYtdzi82","value":"gluconate"},{"id":"JYtd1P8S","value":"Alanine"},{"id":"JZlUFdwn","value":"Cerebral Cortex"},{"id":"KKnXXeHK","value":"SharePoint Services"},{"id":"JX1LgJGS","value":"adalimumab"},{"id":"JYFrH9Wt","value":"fibroblasts"},{"id":"JYtdzZlt","value":"epilepticus"},{"id":"JZlUFrq7","value":"Brain Damage"},{"id":"JWrh_WVM","value":"Gas Chromatography"},{"id":"JYtdzgYL","value":"bone loss"},{"id":"JWrh_dIy","value":"Mass Spectrometry"},{"id":"JcX9Ga8C","value":"Lead lined position indicator"},{"id":"JWriCzmS","value":"Inhibitor"},{"id":"JYDqkbpu","value":"Metabolic Control"},{"id":"JX1LghUd","value":"Alopecia"},{"id":"JY9Y-iDv","value":"Plasma Concentration"},{"id":"JYtd2DDT","value":"cd8+ t cell"},{"id":"JYtd22u4","value":"retinitis pigmentosa"},{"id":"Jb7jdSAq","value":"Paints"},{"id":"JcX8BIxt","value":"Diabetes"},{"id":"JYtd1Dky","value":"Leucine Arginine"},{"id":"JYtd1n9T","value":"Gas Chromatography Mass Spectrometry"},{"id":"JYFqhy6L","value":"Benign Prostate Hyperplasia"},{"id":"JWriBugd","value":"Ventricular Fibrillation"},{"id":"JX1Lf9e5","value":"ABCD stratification"},{"id":"JYFqh2yh","value":"Nephrotic Syndrome"},{"id":"JYDqkNw_","value":"type 1 diabetes"},{"id":"LXb4FuBa","value":"Accessorial Charges"},{"id":"JYDqjXXK","value":"Gestational Age"},{"id":"JWriBlyN","value":"meta analysis"},{"id":"JYtd13uV","value":"Mass Spectrometer"},{"id":"JcX8BXDG","value":"Video Endoscopes"},{"id":"JWrh__Gx","value":"Adrenal cancer"},{"id":"JYFqhzKO","value":"Erectile Dysfunction"},{"id":"Jbj42Scl","value":"Wild"},{"id":"JX1LgOjt","value":"adult-onset still's disease"},{"id":"LXb4F840","value":"After-Sale Service"},{"id":"LXb4IdHZ","value":"Vendor Code"},{"id":"LXb4HDHo","value":"General-Commodities Carrier"},{"id":"KHcl5c92","value":"IBD (Irritable Bowel Disease) - GENERAL"},{"id":"JX1LgLJp","value":"adenosine triphosphate"},{"id":"JYtd2tM5","value":"Age Related Macular Degeneration"},{"id":"JYDqkkrM","value":"Ketorolac"},{"id":"JbN7AXAZ","value":"Health Promotion"},{"id":"JWrh_Qtc","value":"Fat Content"},{"id":"J9qqT7hc","value":"WorkMate Claris"},{"id":"JYFqh_Dr","value":"label free"},{"id":"JYFqhwIe","value":"Prostate Cancer"},{"id":"JYtd1dgj","value":"fMRI"},{"id":"JYFqh7X6","value":"trauma"},{"id":"JbN7Alni","value":"Conceptual Framework"},{"id":"JYtd0wjN","value":"Islets"},{"id":"JWriCczP","value":"Etiology"},{"id":"JcX8BFgB","value":"EKG"},{"id":"JcX9Gcm_","value":"Retinoscope"},{"id":"JYtd1L3o","value":"Histidine"},{"id":"Jb7jZ7SV","value":"Fertilizers"},{"id":"JX1Lgcw3","value":"Alginates"},{"id":"J9qL7iQj","value":"AF therapy"},{"id":"Jbj42T-L","value":"Domestic"},{"id":"JWriDQsc","value":"Necrosis"},{"id":"JX1Lf-iX","value":"abdominal ultrasound"},{"id":"JWriDhKO","value":"Pyknosis"},{"id":"JWriDYmG","value":"Pancytopenia"},{"id":"JYFqht52","value":"cardiac effects"},{"id":"JWriCW_0","value":"Eosinophil"},{"id":"JYtdztam","value":"assay "},{"id":"JbN7AuUs","value":"Assessment Tool"},{"id":"JZlUFk0n","value":"substantia nigra"},{"id":"JYDqiQrx","value":"Allergic Contact Dermatitis"},{"id":"KHcl5fmL","value":"Mens Health - GENERAL"},{"id":"JWrh_eZw","value":"Feed Intake"},{"id":"LXb4IAu2","value":"Slotting"},{"id":"JWriDAtX","value":"Lysis"},{"id":"JWrh_q74","value":"Active Power Filter"},{"id":"JWriCQhb","value":"Coagulation Time"},{"id":"Jb7jgx-y","value":"Chemical Reactor Design"},{"id":"JWrh_jK9","value":"Scanning Electron Microscopy"},{"id":"JYtd0k8i","value":"Intracranial Pressure"},{"id":"JYFqh1_L","value":"Lower Urinary Tract Symptoms"},{"id":"JYFrHxgw","value":"ankylosing spondylitis (as)"},{"id":"JWrh-_RR","value":"Food Products"},{"id":"JYtd1o1M","value":"Mass Spectrometric"},{"id":"JWriAIEz","value":"Hairy cell leukemia symptoms"},{"id":"JYFrIC8i","value":"osteomyelitis"},{"id":"JYFqhxCF","value":"Prostate Specific Antigen"},{"id":"JbN7AU2T","value":"Focus Group"},{"id":"JYDqkn52","value":"Endotracheal tube"},{"id":"LXb4IRj-","value":"UOM"},{"id":"JX1LgG6V","value":"acute experiment"},{"id":"JYFrHzZc","value":"anti-tnf drugs"},{"id":"JYtd16du","value":"Immune System"},{"id":"JYtdzmDh","value":"biopesticides "},{"id":"JWriDSNX","value":"Neutrophilia"},{"id":"JWriAaeA","value":"Protein Sequence"},{"id":"JYtd0YOi","value":"Emergency Department"},{"id":"Jf1pTh5F","value":"Stochastic Optical Reconstruction Microscopy (STORM)"},{"id":"JX1LgQ4w","value":"adverse event"},{"id":"JY9Y_2dm","value":"Fixed Partial Denture"},{"id":"J9ihC2Ua","value":"Absolute humidity"},{"id":"JWrh_P7B","value":"Lactating Dairy Cow"},{"id":"JcX9GVFK","value":"FM Monitor"},{"id":"JWriCmta","value":"Hemogram"},{"id":"JYtd18k3","value":"T Cell Receptor"},{"id":"JWriC7Zx","value":"Leukemoid Crisis or Reaction"},{"id":"JYtd0Skx","value":"vaccine "},{"id":"LXb4G2Zi","value":"Continuous Flow Distribution (CFD)"},{"id":"JYtd1JLL","value":"CUG"},{"id":"JYtd2Ikj","value":"Natural Killer Cell"},{"id":"JYtd0xqE","value":"rejection"},{"id":"JWriAffu","value":"Source Code"},{"id":"JWriBSmn","value":"Ultrasound"},{"id":"J9ihzvbT","value":"Avogadro's law"},{"id":"JYtd27J7","value":"larynx"},{"id":"JWriDeW8","value":"Polycythemia"},{"id":"J9ihVMtO","value":"Amorphous"},{"id":"JcX40W9G","value":"Ophthalmology"},{"id":"JYtdzrIB","value":"virtual reality "},{"id":"JYtdziIz","value":"supplements"},{"id":"JWriA-R0","value":"Clustering Method"},{"id":"Jb7jhVGL","value":"Chemical Plant Modification"},{"id":"Jbei9vPy","value":"animals"},{"id":"Jgd_HSOf","value":"recessive"},{"id":"JpZWZks-","value":"Evolution"},{"id":"JYDqjNzz","value":"Dendritic Cell"},{"id":"JYtd2vQK","value":"Contact Lens"},{"id":"JYtd1i18","value":"surface coil"},{"id":"JYFrH7B_","value":"cartilage"},{"id":"JYtd1tVb","value":"Fluorescence Detection"},{"id":"JYFqh9XE","value":"quantification"},{"id":"JWrh_iQA","value":"Fiber Reinforcement"},{"id":"LXb4GqQ9","value":"Civil Aeronautics Board"},{"id":"JWriDnky","value":"Smudge Cell"},{"id":"LXb4Giuz","value":"Business Application"},{"id":"JeGRHI9J","value":"capital"},{"id":"JWrh_tDN","value":"Glass Transition Temperature"},{"id":"JWriDN4i","value":"Monocytosis"},{"id":"JYtd1bf2","value":"CT"},{"id":"JYtd0q8A","value":"perioperative"},{"id":"JYtd25YM","value":"ear"},{"id":"KECpzP7f","value":"stomach issue"},{"id":"Jf1pToHA","value":"autoradiography"},{"id":"LXb4G_v3","value":"Finance Lease"},{"id":"JWrh_nT8","value":"Dynamic Model"},{"id":"JcX8BZhM","value":"Autoclaves Sterilizers"},{"id":"JYtd2KJn","value":"Tumor Cells"},{"id":"Jgd_HG6B","value":"gene"},{"id":"JYtdzu94","value":"radioisotope "},{"id":"JWriBpVJ","value":"Diastolic Function"},{"id":"JWriDHo6","value":"Mesentery"},{"id":"JYtdz_eH","value":"analytical "},{"id":"Jbj4Rfqk","value":"muscle disease"},{"id":"JY9Y_t0y","value":"Bone Formation"},{"id":"JYFqh5nV","value":"pericardial adhesion"},{"id":"JWriCHms","value":"Asynchronous"},{"id":"Jb7jeoVB","value":"Cosmetics"},{"id":"JYtd1eWh","value":"degluition"},{"id":"JWriCkMT","value":"Hematology"},{"id":"JWrh_0lF","value":"homing"},{"id":"JWriAzdd","value":"Gene Expression Pattern"},{"id":"JWrh_RxW","value":"Maize"},{"id":"JYtdzka3","value":"transgenic "},{"id":"JYtdz3Dg","value":"EST "},{"id":"Lb8_spKW","value":"alt right"},{"id":"JX1LgMZA","value":"Adipogenic"},{"id":"JWrh_EGa","value":"Functional Properties"},{"id":"JWriBYa8","value":"Randomized Trial"},{"id":"Jb7jfxuR","value":"Organocatalysts"},{"id":"JpZWaD_8","value":"Signalling"},{"id":"JWriAOjM","value":"Lymphocytes"},{"id":"LXb4HptP","value":"Ramp Rate"},{"id":"JWriAmET","value":"Gene Expression Profile"},{"id":"LXb4IWVv","value":"VAN"},{"id":"JWriAyMO","value":"Cluster Analysis"},{"id":"J9qL7YnU","value":"3D mapping interventional electropyhsiology issues"},{"id":"JcX40QDq","value":"Anaesthesiology"},{"id":"JWriBAL1","value":"Gene Selection"},{"id":"LXb4FzUF","value":"Administrative Monetary Penalty System"},{"id":"JYtdzbLK","value":"hypoperfusion"},{"id":"Jb7jd7Po","value":"Consumer Chemicals"},{"id":"JYDqkZAc","value":"Type I Diabetes"},{"id":"JWriDiwa","value":"Reticulocytosis"},{"id":"JYtd1Oj7","value":"GUG"},{"id":"JYtd1UvV","value":"ACU"},{"id":"JWrh_JSf","value":"Seasonality"},{"id":"JYtd1Esf","value":"UAC"},{"id":"LXb4Fdfr","value":"ABC Classification"},{"id":"LXb4GGmS","value":"Anti-Dumping Duty"},{"id":"JY9Y_qSM","value":"Periodontal Ligament"},{"id":"JYtdzpDt","value":"growth "},{"id":"JWriAtiO","value":"Transcription Factor"},{"id":"JWriATQp","value":"Photodynamic therapy"},{"id":"JWriBg1V","value":"Blood Flow"},{"id":"Jgd_HKN3","value":"markers"},{"id":"JYDqjazK","value":"Preterm Delivery"},{"id":"JYtdz-Hd","value":"guidance "},{"id":"JYtd0eTb","value":"Mortality"},{"id":"J9qqTuAM","value":"more comprehensive view and better precision"},{"id":"JWriAAoi","value":"Autologous bone marrow transplant"},{"id":"JWriCPOV","value":"Chemotaxis"},{"id":"JWriCrrb","value":"Homozygous"},{"id":"JX1Lf_m_","value":"acetaminophen"},{"id":"LQPQV2Al","value":"expand T cell"},{"id":"LXb4Ha1j","value":"Order Processing"},{"id":"JX1LgQoU","value":"Adverse effects"},{"id":"JWriCnK_","value":"Hemolysis"},{"id":"JpZWZ4BX","value":"Pathogen evolution"},{"id":"LXb4HQic","value":"Logistics"},{"id":"JbN7AqSI","value":"Self Esteem"},{"id":"JYtd1p8B","value":"Aqueous Solution"},{"id":"JYtd1M7n","value":"CGA"},{"id":"JWriAMVD","value":"Leptomeningeal cancer"},{"id":"JWriBRIG","value":"Clinical Outcome"},{"id":"JYtd0jme","value":"Endotracheal Intubation"},{"id":"JWriBYy_","value":"Dilated Cardiomyopathy"},{"id":"JYtdzudo","value":"biochip "},{"id":"LXb4Gcw7","value":"Bottleneck"},{"id":"J9qL7djZ","value":"invasive mapping in electrophysiology"},{"id":"J9ihmnYd","value":"Angular velocity"},{"id":"JcX9Gd8E","value":"Ophthalmoscope"},{"id":"JWriDxOi","value":"Xanthochromia"},{"id":"Jf1pTidl","value":"Confocal Microscopy"},{"id":"JYtd28Gv","value":"upper pharynx"},{"id":"JYtd0yvH","value":"tolerance"},{"id":"Jb7jYGwO","value":"Petrochemicals"},{"id":"JYFqhyJa","value":"Prostatic Neoplasm"},{"id":"JYtd1ikh","value":"T1 Mapping"},{"id":"JYtd14WL","value":"micellar electrokinetic"},{"id":"LQPQV9Av","value":"immune cell differentiation"},{"id":"JWriBjNL","value":"Cardiopulmonary Bypass"},{"id":"JYtdzpUR","value":"ornamental"},{"id":"JbN7ARPA","value":"Clinical Practice"},{"id":"JYtd1Cdq","value":"UCC"},{"id":"LXb4GKQh","value":"Auditing"},{"id":"JYtd2zUb","value":"Eye Disease"},{"id":"JWrh_Zov","value":"Microbiology"},{"id":"JWriDagt","value":"Phagocytosis"},{"id":"JYtd0XIr","value":"natural product "},{"id":"Jb7jckZJ","value":"Electronic Chemicals"},{"id":"JpZWZ_Y1","value":"Rotavirus"},{"id":"JWriAoRd","value":"Evolutionary Genetics"},{"id":"JZlUFix6","value":"Dentate Gyrus"},{"id":"JX1LgbiR","value":"alcohol use"},{"id":"JWriAS58","value":"Peritoneal mesothelioma"},{"id":"JYtd1byZ","value":"MRI"},{"id":"JYFqhvjA","value":"hypoventilation"},{"id":"J9ihKqo8","value":"Acceleration due to gravity"},{"id":"JWrh_g5S","value":"Tensile Strength"},{"id":"JYtd2PAl","value":"Allergic Rhinitis"},{"id":"JZlUFqOv","value":"Brain"},{"id":"JlBiPR1K","value":"light"},{"id":"JWriCUmu","value":"Discrete"},{"id":"JYDqheo8","value":"bullous pemphigoid"},{"id":"LXb4HJzh","value":"Hazardous Material"},{"id":"JYtd1syi","value":"Chiral Stationary Phase"},{"id":"JYtd2HJP","value":"Signaling Pathway"},{"id":"JWriDJkU","value":"Methemoglobin"},{"id":"JYtdzzH8","value":"RNA "},{"id":"Jbei9s-r","value":"oncology"},{"id":"JYFrH5Ok","value":"autonomic disorders"},{"id":"JcX8BWEO","value":"ENT Microscopes"},{"id":"JYDqkZ33","value":"Diabetic Retinopathy"},{"id":"LXb4H7x3","value":"SET"},{"id":"JYtd0GDJ","value":"enzyme "},{"id":"JYtd1_f-","value":"Adaptive Immunity"},{"id":"JWriAEUq","value":"Chronic myelogenous leukemia"},{"id":"JY9Y_zuZ","value":"Shear Bond Strength"},{"id":"J9ihQOr-","value":"Afocal lens"},{"id":"LQPQWDZl","value":"monitoring T cell activation"},{"id":"JcX8BDCn","value":"Personal Use"},{"id":"JYtd1j-x","value":"Reversed Phase"},{"id":"JWriCFfn","value":"Anoxemia"},{"id":"JYDqjmKR","value":"case-control study"},{"id":"JWriAX-5","value":"Sarcoma"},{"id":"JWrh_UmG","value":"Latin Square"},{"id":"JY9Y-nqF","value":"Glutathione"},{"id":"JYFqhqcJ","value":"Local anesthetic reactions"},{"id":"JYtd0Tok","value":"antiviral "},{"id":"J9ihONPj","value":"Acoustic shielding"},{"id":"JYFrHz1R","value":"antibodies"},{"id":"JX1LgH-_","value":"acute lung injury"},{"id":"JWriCjGy","value":"Hemacytometer"},{"id":"Jb7jhvsG","value":"Chemical Recycling"},{"id":"JWriDP1K","value":"Myeloid Cells"},{"id":"JYtdzgov","value":"nutrient"},{"id":"JYtd0pwP","value":"Acute Physiology and Chronic Health Evaluation"},{"id":"JYtd0uat","value":"Immunoglobulins"},{"id":"JWrh_NES","value":"Volatile Compounds"},{"id":"JbN7AyMc","value":"Main Outcome Measure"},{"id":"JYtd2MfG","value":"proinflammatory cytokine"},{"id":"Jbj4RkIl","value":"Welfare"},{"id":"JYtd2AFD","value":"Hiv Infection"},{"id":"JYtd1umG","value":"Limit of Quantification"},{"id":"JbN7AC0V","value":"Nursing Student"},{"id":"JYtd26jQ","value":"neck"},{"id":"KSxpmA7s","value":"clotting"},{"id":"JYFqh5NH","value":"heart ahesion"},{"id":"JWriAjq4","value":"Molecular Biology"},{"id":"JWriAF-7","value":"Dysphagia"},{"id":"JWriBsrX","value":"Mortality Rate"},{"id":"JZlUFwyB","value":"Pyramidal Neuron"},{"id":"LXb4FvFR","value":"Accredited Standards Committee (ASC)"},{"id":"JYtd1SJz","value":"GGU"},{"id":"JY9Y_6qQ","value":"Head and Neck"},{"id":"J9qqUAS-","value":"TactiCath Quartz Contact Force Ablation Catheter"},{"id":"JWriBcNL","value":"Control Group"},{"id":"JpZWZfe3","value":"Drosophila"},{"id":"JYDqjoJD","value":"Prostaglandin"},{"id":"JWriDc7c","value":"Poikilocytosis"},{"id":"JYtd1fiY","value":"linearity"},{"id":"JYtdzlib","value":"food "},{"id":"JX1LgXuq","value":"AICAR"},{"id":"JYtdz-Yt","value":"CAD/PACS application"},{"id":"JYtd2wG-","value":"Fluorescein Angiography"},{"id":"JcX8Bbg0","value":"Portable Suction"},{"id":"JYFqiBAC","value":"post-translational modifications"},{"id":"JWrh_8sh","value":"Acute granulocytic leukemia symptoms"},{"id":"LXb4HvjX","value":"RGA"},{"id":"JcX8BNKm","value":"Colposcope"},{"id":"JWriCDxr","value":"Aleukemic Leukemia"},{"id":"JX1LgNQc","value":"adolescent patients"},{"id":"JYtdz7f2","value":"microarrays "},{"id":"JWriDMM-","value":"Mitosis"},{"id":"JYDqkkP7","value":"Cervical plexus block Cx Hiatal hernia"},{"id":"LXb4GucT","value":"Combi Aircraft"},{"id":"Jb7jgOdq","value":"Catalytic Activity"},{"id":"JYFqh6nW","value":"surgery"},{"id":"JX1Lf-v2","value":"abetimus"},{"id":"JWrh_vGJ","value":"Online Monitoring"},{"id":"KECpzPDf","value":"stomach pain"},{"id":"JYtd2LnP","value":"balb/c mice"},{"id":"LXb4G5gq","value":"EDI Interchange"},{"id":"JYDqkhhN","value":"Tube in trachea"},{"id":"JpZWZTj2","value":"Aedes aegypti"},{"id":"JYtdzqTz","value":"displays "},{"id":"JYFrIDYP","value":"osteonecrosis"},{"id":"JWrh_MtL","value":"Iron"},{"id":"LXb4F425","value":"Advanced Shipment Notice (ASN)"},{"id":"JYtdz2Am","value":"cDNA "},{"id":"JYtdzaHY","value":"febrile seizures"},{"id":"JYFqh9IA","value":"Protien indentification"},{"id":"JYtd2Bf0","value":"Toll Like Receptor"},{"id":"JY9Y-hNj","value":"Drug Delivery"},{"id":"J9qqTowh","value":"Confidence V4.2Module, Biosense Webster"},{"id":"JWriBEzU","value":"Coronary Artery"},{"id":"JYFqh0uX","value":"Chronic Kidney Disease"},{"id":"JYDqkoY5","value":"Respiratory rate"},{"id":"LXb4FiSk","value":"ABC System"},{"id":"JYtd0cvX","value":"Head Injury"},{"id":"JWriBTlm","value":"Percutaneous Coronary Intervention"},{"id":"LXb4Gfcq","value":"Bulk Cargo"},{"id":"JYtd1WGr","value":"Threonine"},{"id":"JpZWZtIp","value":"Immunopathogenesis"},{"id":"JbN7AblM","value":"Data Collection"},{"id":"JY9Y-9KR","value":"Biological Activity"},{"id":"JYFqhwt0","value":"Radical Prostatectomy"},{"id":"JY9Y_oW3","value":"streptococcus mutans"},{"id":"JWriBp14","value":"Sinus Rhythm"},{"id":"JWrh_7nE","value":"MSC (mesenchymal)"},{"id":"JYtd10vm","value":"Supercritical Fluid Extraction"},{"id":"JWriCkqI","value":"Hematoma"},{"id":"JpZWZUtS","value":"Anthropology"},{"id":"JWriAWp_","value":"Red blood cells"},{"id":"JWriAqNZ","value":"Computer Program"},{"id":"JX1Lgapg","value":"Akt pathway"},{"id":"JWriBXQH","value":"Left Ventricular Dysfunction"},{"id":"JWriCSfB","value":"Crenation"},{"id":"JWriDvHa","value":"Vacuole"},{"id":"JYFqhrr-","value":"Carbon monoxide poisoning"},{"id":"JYtd1lo1","value":"Solid Phase Extraction"},{"id":"JX1Lge-T","value":"Alloantibodies"},{"id":"JYtd1OBR","value":"GUC"},{"id":"JcX8BT6C","value":"Uterine Sounds"},{"id":"LQPQV_1I","value":"T cell plasticity"},{"id":"JWrh_bAo","value":"Lipid Peroxide"},{"id":"JX1LgPsM","value":"advanced gastric"},{"id":"LXb4FrZm","value":"Acceptance Sampling"},{"id":"JZlUFpWG","value":"Hippocampal Neuron"},{"id":"JpZWaNSg","value":"Vaccine development"},{"id":"JYtd0MPw","value":"protease"},{"id":"JWriCMzJ","value":"Blood Dyscrasia"},{"id":"JYFqh4J4","value":"Urinary Tract Infection"},{"id":"JYtd2x1I","value":"Primary Open Angle Glaucoma"},{"id":"JWriARZ9","value":"Oat cell cancer"},{"id":"JYtd0-er","value":"Protein systhesis"},{"id":"JWriA3W6","value":"Probabilistic Model"},{"id":"Jgd_HFUa","value":"analysis"},{"id":"J9ihsUbg","value":"Archimedes principle"},{"id":"JWrh_xL4","value":"Point of Common Coupling"},{"id":"JYtd1rGl","value":"Retention Time"},{"id":"JYtdzoTH","value":"vegetable "},{"id":"JWriCbEK","value":"Erythroleukemia"},{"id":"JcX9GfSc","value":"Perimeter"},{"id":"JWriBU9Z","value":"Coronary Disease"},{"id":"JWriChy8","value":"Granulocyte"},{"id":"JWrh-4Sy","value":"Antioxidant Activity"},{"id":"JWriBPVp","value":"Coronary Angioplasty"},{"id":"JYtd1aok","value":"biomedical imaging"},{"id":"JYtd2wrg","value":"Degeneration"},{"id":"JYtd2NW8","value":"Adhesion Molecule"},{"id":"Jf1pTtJt","value":"neurobiology"},{"id":"JYtd0Pjs","value":"optimization "},{"id":"Jbei9phz","value":"Veterinary"},{"id":"Jbj42Vdu","value":"Anovulation"},{"id":"JY9Y-tD_","value":"Drug Interaction"},{"id":"LQPQWAh9","value":"immune cell plasticity"},{"id":"JYtd0WCp","value":"wound healing "},{"id":"JWrh_pJn","value":"Flame Retardant"},{"id":"JbN7AN7a","value":"Acute Care"},{"id":"JWrh_l2X","value":"Tensile Properties"},{"id":"LXb4IZcL","value":"VBR"},{"id":"JWriAKbe","value":"Infiltrating cancer"},{"id":"LXb4IHPr","value":"SPC"},{"id":"JYtd0HKz","value":"DNA/RNA synthesis "},{"id":"JWriCcYn","value":"Erythropoiesis"},{"id":"JYtdzd0u","value":"hyperperfusion"},{"id":"JY9Y_wCy","value":"Dental Material"},{"id":"Jb7jfLpV","value":"Catalysis"},{"id":"LXb4H2h7","value":"SCE"},{"id":"JYtd21B7","value":"Macular Degeneration"},{"id":"JWriC8PG","value":"Leukocyte"},{"id":"Jf1pTnAv","value":"immunocytochemistry"},{"id":"JX1LgI4h","value":"acute-phase reactants"},{"id":"Jb7jiJeJ","value":"Transport Phenomena"},{"id":"JYDqklmk","value":"Prevention"},{"id":"JYtd1Gqi","value":"UGA"},{"id":"JYDqgJt_","value":"Wound Healing"},{"id":"JYFqhphi","value":"Intravenous regional nerve block"},{"id":"JYtdzmzA","value":"breeding "},{"id":"JcX8BFAB","value":"implantable"},{"id":"JX1LgE6e","value":"Actual measurement"},{"id":"Jgd_HL-I","value":"multiallelic"},{"id":"JYtd2P8D","value":"Mrna Expression"},{"id":"JWrh_OpM","value":"Cheddar Cheese"},{"id":"JYtdzfon","value":"low bone mass"},{"id":"JYtdz9FQ","value":"CT "},{"id":"JYtd1BqK","value":"UUA"},{"id":"JY9Y_lpH","value":"Dental Plaque"},{"id":"JWrh_HDp","value":"Phenolic Compound"},{"id":"Lb8_soTE","value":"white supremacist"},{"id":"LXb4HebV","value":"Original Equipment Manufacturer (OEM)"},{"id":"JYtd0DIN","value":"drug delivery "},{"id":"JYtd1YvT","value":"AGA"},{"id":"JYDqjqRB","value":"In Vitro Fertilization"},{"id":"JYtdzvwz","value":"ultrasound "},{"id":"JWriDq3M","value":"Target Cell (Leptocyte)."},{"id":"JYtd1RBx","value":"GAG"},{"id":"JY9Y_9BC","value":"Maxillary Sinus"},{"id":"JpZWZuxB","value":"Latency"},{"id":"JWriDe59","value":"Promyelocyte"},{"id":"JYtdz097","value":"target validation "},{"id":"JWrh_-uS","value":"Adenosarcoma treatment"},{"id":"JX1LgTgN","value":"afferent"},{"id":"JcX8Bdhe","value":"FM Monitor from GE Healthcare"},{"id":"JWriArh_","value":"Binding Site"},{"id":"JbN7AGD_","value":"Decision Making"},{"id":"JYFqh7nw","value":"scar tissue"},{"id":"JYFrH_Lc","value":"glucocorticoids"},{"id":"JYDqjTjn","value":"Extracellular Matrix"},{"id":"JYtd0n4R","value":"Oxygen Saturation"},{"id":"J9qqTsxt","value":"Faster automated analysis tools"},{"id":"LXb4Hg_0","value":"P2P"},{"id":"JcX8BLNh","value":"Peripheral Artery Disease"},{"id":"JWriDOUV","value":"Mucosa"},{"id":"JYDqkUQr","value":"Diabetic Rat"},{"id":"JWrh_3IL","value":"Pluripotent"},{"id":"JWriA1O4","value":"Cell Cycle"},{"id":"JcX8BkQk","value":"Laser fluorescence caries detection device"},{"id":"JWriBbFJ","value":"Endothelial Dysfunction"},{"id":"Jgd_HRIB","value":"pathogenic"},{"id":"JYDqjVkH","value":"Electron Microscope"},{"id":"Jf1pTjB0","value":"Microscopy"},{"id":"JYDqkeGR","value":"Oral Glucose Tolerance Test"},{"id":"JWrh_BBY","value":"Moisture Content"},{"id":"JWriBla8","value":"Multivariate Analysis"},{"id":"JYtd1gq0","value":"pulsed ASL"},{"id":"Jb7jguYE","value":"Chemical Engineering"},{"id":"JbN7AgJI","value":"Mental Illness"},{"id":"JYtd0aXK","value":"Acute Respiratory Distress Syndrome"},{"id":"KHXCyuG-","value":"Cancer - Breast Cancer"},{"id":"J9qqTbai","value":"electrophysiology problems"},{"id":"JcX9Gjx1","value":"syringe"},{"id":"JWriCLxm","value":"Binary Fission"},{"id":"JYtd2S1m","value":"Murine Model"},{"id":"JYtd2DZ3","value":"Animal Model"},{"id":"JWriC2nc","value":"In Vivo"},{"id":"JYtd1Kyd","value":"CAU"},{"id":"Jbj4RmDk","value":"Antacids"},{"id":"JYtd0hdz","value":"Hemorrhagic Shock"},{"id":"JWriBn-h","value":"Chest Pain"},{"id":"KHXCysNz","value":"Autism"},{"id":"JX1Lf95w","value":"abdominal pain"},{"id":"JYtdz46Y","value":"education "},{"id":"JY9Y_iWU","value":"Titanium"},{"id":"JYtd1XPI","value":"AAG"},{"id":"JYtd0vfF","value":"liver"},{"id":"JbN7AnvP","value":"Concept Analysis"},{"id":"JY9Y-5Iu","value":"Prefrontal Cortex"},{"id":"JYDqkmio","value":"Cor pulmonale"},{"id":"JWriBDWR","value":"Heart Failure"},{"id":"JWriDtCG","value":"Thrombocytosis"},{"id":"JYFqhssS","value":"DDx postop hoarseness"},{"id":"JYtd1HjL","value":"Tryptophan"},{"id":"LXb4GSeg","value":"Batch Picking"},{"id":"Jbei9vxo","value":"endocrinology"},{"id":"JYtd1sgB","value":"Thin Layer Chromatography"},{"id":"JX1LgLXZ","value":"adenovirus"},{"id":"JYtd179m","value":"Lipopolysaccharide"},{"id":"JX1Lgg6R","value":"Aloe-emodin"},{"id":"JYDqkbLU","value":"glycaemic control"},{"id":"JYFrIE33","value":"polyarthritis"},{"id":"JYtd2xQQ","value":"Optic Nerve Head"},{"id":"JYtd0Vwg","value":"peptides "},{"id":"JWrh_czW","value":"Vitamin C"},{"id":"JWriDE5C","value":"Mean Corpuscular Volume (MCV)"},{"id":"JbN7ANdF","value":"End of Life"},{"id":"J9qL7n-5","value":"Cardiac Arrhythmia therapy"},{"id":"Jb7jeBhf","value":"Soaps"},{"id":"JpZWZ9VB","value":"Receptors"},{"id":"JcX8BISU","value":"Cholesterol"},{"id":"JWriBJFi","value":"Cardiology"},{"id":"JYFqhmeN","value":"inhibitor-pressor interaction"},{"id":"JWriCOlk","value":"Centrosome"},{"id":"Jf1pTnjH","value":"material science"},{"id":"JYFqh3Df","value":"radical retropubic prostatectomy"},{"id":"JYtd1Tll","value":"AUU"},{"id":"JWriAP8p","value":"Metastatic pancreatic cancer"},{"id":"LXb4Igsb","value":"Zone Price"},{"id":"JcX8BYhw","value":"Vital Signs Monitors"},{"id":"LXb4ILxd","value":"TMS"},{"id":"JX1LgOzm","value":"adults"},{"id":"JYtd1E-Q","value":"UAA"},{"id":"JYtd1UbE","value":"AUG"},{"id":"JYDqkmGM","value":"Pneumocephalus Intraop hypothermia"},{"id":"KHcl5cF3","value":"HIV/AIDS"},{"id":"JYDqjjYS","value":"Relative Risk"},{"id":"JWriDQQn","value":"Myeloproliferative"},{"id":"J9iha289","value":"Angle of contact"},{"id":"JYFrH195","value":"antimalarial drugs"},{"id":"JWrh-9Ub","value":"Milk Yield"},{"id":"Jgd_HUWq","value":"testing"},{"id":"JWriDVr-","value":"Oligocythemia"},{"id":"Jb7jhT28","value":"Chemical Plant Construction"},{"id":"JYDqjY1R","value":"Pregnant Women"},{"id":"JWriCos8","value":"Hemoptysis"},{"id":"LQPQV2t8","value":"expansion T cell"},{"id":"JWriCYxW","value":"Erythremia"},{"id":"JWriBN2w","value":"Acute Coronary Syndrome"},{"id":"JWriBsUP","value":"Pulmonary Hypertension"},{"id":"JbN7AlGd","value":"Response Rate"},{"id":"JWrh_Ysr","value":"Low Temperature"},{"id":"JYtd17DV","value":"Immunoglobulin"},{"id":"KKnXXdTI","value":"SharePoint Hosting"},{"id":"JY9Y_4y9","value":"Guided Tissue Regeneration"},{"id":"JYtd1LmF","value":"CAG"},{"id":"JWriA50T","value":"Comparative Genomics"},{"id":"JcX8BHzF","value":"Caregiver"},{"id":"JWriAdyn","value":"Support Vector Machine"},{"id":"JWriCee5","value":"Fibril"},{"id":"JYFqhzZx","value":"Renal Failure"},{"id":"JWrh_nqT","value":"Thermal Properties"},{"id":"JYtd25qb","value":"nose"},{"id":"JYFqh4ae","value":"Creatinine Clearance"},{"id":"JYtdzxFJ","value":"lipoprotein "},{"id":"JWrh_faY","value":"Free Radical Scavenger"},{"id":"JYtdzsra","value":"DNA probe "},{"id":"JYtd0HjL","value":"chromatography "},{"id":"JWriC9zE","value":"Leukopoiesis"},{"id":"JYDqjQuH","value":"T Lymphocyte"},{"id":"JYtdzjr7","value":"calcium intake"},{"id":"JZlUFnoi","value":"Electric Stimulation"},{"id":"JWriC5v0","value":"Karyorrhexis"},{"id":"JbN7AjZx","value":"Grounded Theory"},{"id":"JX1LgKAs","value":"adenoma"},{"id":"JWriCMZZ","value":"Bleeding Time"},{"id":"JWriBHw1","value":"Heart Rate"},{"id":"JYtd2J16","value":"Cell Death"},{"id":"JWriAIq0","value":"Hematologic malignancy"},{"id":"JYtd0-w9","value":"Condon"},{"id":"LQPQVzCD","value":"T cell activation assay"},{"id":"JYDqjp11","value":"Hormone Replacement Therapy"},{"id":"JYtdzwj0","value":"inflammation "},{"id":"JWrh_kNh","value":"Thermal Stability"},{"id":"LXb4IGGa","value":"Spam"},{"id":"JYDqi-Hp","value":"Side Effect"},{"id":"J9ihcHjk","value":"Angle of incidence"},{"id":"JWriA4bP","value":"Open Source"},{"id":"JX1LgEDt","value":"Acte pancreatitis"},{"id":"LXb4ISkf","value":"UPC"},{"id":"JzWaT7jz","value":"MS"},{"id":"JcX9GhVK","value":"Auto lensmeter"},{"id":"JWriAy-o","value":"Phylogenetic Inference"},{"id":"JWriAb-f","value":"Microarray Data"},{"id":"JYFqh_oG","value":"charge-state deconstruction"},{"id":"JYtd1aEz","value":"Contrast"},{"id":"JYtd0Rx3","value":"immunotherapy "},{"id":"JX1LgXEg","value":"aging group"},{"id":"Lb8_sj-0","value":"heather heyer"},{"id":"JYDqjW7I","value":"Study Design"},{"id":"JY9Y_1lM","value":"Chronic Periodontitis"},{"id":"JcX9Gb8q","value":"sonography device"},{"id":"JYFrH87G","value":"dexamethasone"},{"id":"JbN7AVkS","value":"Quality of Care"},{"id":"J9qqT0wU","value":"EnSite Velocity"},{"id":"JZlUFsyP","value":"neuronal death"},{"id":"JYtd1IF0","value":"CUU"},{"id":"LXb4G3WK","value":"Cost-of-Goods Sold (COGS)"},{"id":"JYDqkUsY","value":"glycemic control"},{"id":"JWrh_I69","value":"Soybean"},{"id":"JWriCKPC","value":"Basophil"},{"id":"JYtdzbdz","value":"ischemia"},{"id":"JWriACvA","value":"Cancer in situ"},{"id":"JYtd1noy","value":"Gas Chromatograph"},{"id":"LXb4F6PM","value":"Advanced Shipping Notice (ASN)"},{"id":"JYtd0ldQ","value":"Adult Respiratory Distress Syndrome"},{"id":"JYtd29uY","value":"tinnitus"},{"id":"JYtd2I5Z","value":"Tuberculosis"},{"id":"JWriBnnx","value":"Quality of Life"},{"id":"JYtd0Av8","value":"Internet "},{"id":"JYFqh0da","value":"Renal Disease"},{"id":"JWriAqka","value":"Neural Network"},{"id":"JWriAARE","value":"Astrocytoma"},{"id":"JYtdzcRw","value":"syncope"},{"id":"JYDqeC0Z","value":"Skin Cancer"},{"id":"JcX40S2W","value":"Ear Nose and Throat"},{"id":"Jb7jbYo5","value":"Nanotechnology"},{"id":"LXb4HEtc","value":"GPS"},{"id":"JWrh_QW_","value":"Fruit and Vegetables"},{"id":"JY9Y-eyB","value":"Serotonin"},{"id":"JWriAx0f","value":"Data Analysis"},{"id":"JYtd2tfa","value":"Cataract Surgery"},{"id":"JWriA6-S","value":"Structural Model"},{"id":"JcX8BP9D","value":"Monsels Solution"},{"id":"JpZWZlV8","value":"Filariasis"},{"id":"JWriBW4I","value":"Sudden Death"},{"id":"Jbj42S79","value":"Antelopes"},{"id":"JX1LgZim","value":"air swallow"},{"id":"JYtd1wzM","value":"Molecular Weight"},{"id":"KECpzSfl","value":"bloating"},{"id":"JWriAtME","value":"Statistical Significance"},{"id":"JYFqhrbq","value":"Brachial artery cannulation Cx"},{"id":"JYDqkRz_","value":"Skeletal Muscle"},{"id":"JYtd0xIY","value":"Mycophenolate mofetil"},{"id":"JYtdz4Gk","value":"isogene "},{"id":"LXb4HlLl","value":"PDCA"},{"id":"JWrh_yrB","value":"Silica"},{"id":"JYtd1Yc3","value":"AGC"},{"id":"JX1LgCD3","value":"achalasia of cardia"},{"id":"JYtd0D6G","value":"research tool "},{"id":"JpZWaG06","value":"T cell"},{"id":"JpZWZaxQ","value":"Campylobacter"},{"id":"JWriADFO","value":"Cancer symptoms"},{"id":"JY9Y_h4J","value":"Root Canal"},{"id":"JWriDb6A","value":"Platelet"},{"id":"LXb4Hfxp","value":"OS&D"},{"id":"JWriDghn","value":"Purpura"},{"id":"JYDqjgv_","value":"Cohort Study"},{"id":"JbN7Auzh","value":"Newborn Infant"},{"id":"JYtd0ziV","value":"Transfer RNA"},{"id":"JWriDkiu","value":"Rubricyte"},{"id":"JYDqjqsk","value":"Oral Contraceptive"},{"id":"JWriA2_l","value":"Gene Structure"},{"id":"JWriAkD4","value":"Machine Learning"},{"id":"JWriCJ2P","value":"Basopenia"},{"id":"JY9Y_tWh","value":"Calcium Hydroxide"},{"id":"JpZWZzdX","value":"Malaria"},{"id":"JYtd29Dd","value":"neurology"},{"id":"JWriBfK1","value":"Unstable Angina"},{"id":"JWriAsH5","value":"Molecular Evolution"},{"id":"JX1LgTuJ","value":"afferents"},{"id":"JWrh-_ny","value":"Shelf Life"},{"id":"JWriCQ81","value":"Cocatalyst"},{"id":"JYtd0NZD","value":"optical sensors "},{"id":"JYtd1iTE","value":"saccadic eye movements"},{"id":"JWrh_07n","value":"adhesion molecules"},{"id":"LXb4Hw36","value":"RM"},{"id":"JY9Y_ks0","value":"Dental Implant"},{"id":"JYtd0YgP","value":"Critically Ill Patient"},{"id":"JZlUFcr8","value":"Astrocyte"},{"id":"JYtdz5bK","value":"diagnostic tool "},{"id":"JbN7AI_1","value":"Registered Nurse"},{"id":"JYtd1PrP","value":"GCG"},{"id":"JWriDCfg","value":"Mast Cell"},{"id":"JYDqjbOA","value":"Ultrasonography"},{"id":"LXb4Hq8e","value":"RF"},{"id":"JZlUFr9P","value":"Synaptic Transmission"},{"id":"JWriAhrR","value":"Hidden Markov Model"},{"id":"JYtd1D2T","value":"Leucine"},{"id":"JpZWaGRJ","value":"Structural biology"},{"id":"JYFqh84I","value":"Data Processing"},{"id":"JYtd0cea","value":"Cardiac Output"},{"id":"KSxpmBco","value":"Immune thrombocytopenia"},{"id":"LXb4HVfx","value":"NAFTA"},{"id":"Jf1pTrel","value":"physiologists"},{"id":"JcX8Bhx7","value":"Microstream SmartPod"},{"id":"JX1LgSZk","value":"advocacy/public policy"},{"id":"JY9Y_0NG","value":"mutans streptococci"},{"id":"Jb7jdddB","value":"Pigments"},{"id":"LXb4GXnO","value":"Bin Center"},{"id":"JYtd0Mh8","value":"Sensors "},{"id":"JWriAN81","value":"Lymph nodes"},{"id":"JWriDLLQ","value":"Micron"},{"id":"JYtd0JyO","value":"mouse model"},{"id":"JWriC4BX","value":"Juvenile Cell"},{"id":"KECpzTXr","value":"irritable bowel syndrome"},{"id":"JlBiPRd4","value":"percieved"},{"id":"JYDqjfGR","value":"Urinary Incontinence"},{"id":"JWriBS91","value":"Clinical Trial"},{"id":"JWriAvrF","value":"Computational Biology"},{"id":"JX1Lf9Ri","value":"abatacept"},{"id":"JWriBKpY","value":"Heart Disease"},{"id":"JWriBGYk","value":"Cardiovascular Disease"},{"id":"JYtd0gp3","value":"Surgical Intensive Care Unit"},{"id":"JWriA_1H","value":"Differentially Expressed Gene"},{"id":"JbN7AJhG","value":"Nursing Home"},{"id":"JYtd21aD","value":"pars plana vitrectomy"},{"id":"J9ihzVRH","value":"Achromatic"},{"id":"JYtdzqju","value":"hardware "},{"id":"JYtdz7PV","value":"therapeutic "},{"id":"JYtd2QPF","value":"Western Blot"},{"id":"JYDqjMMb","value":"Immunohistochemistry"},{"id":"JYtdzy36","value":"Genomics "},{"id":"JWriBhMZ","value":"percutaneous transluminal coronary angioplasty"},{"id":"JYtd0OuY","value":"CAD "},{"id":"JWriAUWN","value":"Platelets"},{"id":"Jgd_HK0G","value":"megalencephaly"},{"id":"JYtd1jsw","value":"Liquid Chromatography"},{"id":"LXb4GFiI","value":"All Water"},{"id":"LQPQWFiJ","value":"live cell t-cell activation assay"},{"id":"JZlUFvnD","value":"Parietal Cortex"},{"id":"Jbei9tlG","value":"equines"},{"id":"JY9Y-vPN","value":"Opioid Receptor"},{"id":"LXb4HW5H","value":"National Industrial Transportation League"},{"id":"JYtd1dMe","value":"field strength"},{"id":"JWrh_mMi","value":"Induction Motor Drive"},{"id":"JWrh_ilr","value":"Polyethylene"},{"id":"LXb4Gjvo","value":"Buyer Behavior"},{"id":"JX1LgHV-","value":"acute hepatitis B"},{"id":"JYFrHx8s","value":"annexins"},{"id":"KRyWT90n","value":"ADD"},{"id":"JYFqhuPq","value":"PONS injury"},{"id":"JYtd1rYR","value":"solid phase microextraction"},{"id":"JY9Y-2Db","value":"Cyclooxygenase"},{"id":"JWriDw1N","value":"Vitamin K"},{"id":"JX1LgEs3","value":"active GI bleeding"},{"id":"JWriBBBG","value":"bayesian inference"},{"id":"JYtd1uQs","value":"Thermal Degradation"},{"id":"JWriCWnT","value":"Eosinopenia"},{"id":"Jf1pTpyp","value":"cell biologists"},{"id":"JYtdztqY","value":"marker "},{"id":"JY9Y_pzl","value":"Oral Hygiene"},{"id":"JX1LgbUG","value":"Alcohol"},{"id":"JYtd23nc","value":"Diabetic Macular Edema"},{"id":"LXb4H9Oz","value":"SG&A"},{"id":"JYDqjORe","value":"Tumor Necrosis Factor"},{"id":"JYtdzyGb","value":"Environment "},{"id":"JcX8BgDo","value":"EtCO2"},{"id":"JYtd0rNN","value":"donor pool"},{"id":"JX1LgDL4","value":"acid secretion"},{"id":"Jgd_HF4z","value":"cancer"},{"id":"JYDqiZ2h","value":"Cell Line"},{"id":"JWriCG9b","value":"Aplastic Anemia"},{"id":"LQPQV6S-","value":"T cell responses"},{"id":"JX1LgHIU","value":"acute hepatic injury"},{"id":"JWrh_V_V","value":"Free Radical"},{"id":"JWriBFJz","value":"Blood Pressure"},{"id":"JYtd0_8z","value":"Neucleotide"},{"id":"JcX8BRb6","value":"Smoke Evacuator"},{"id":"JWriAaEh","value":"White blood cells"},{"id":"JYFqiBQx","value":"peptide"},{"id":"JYtdz2yV","value":"transgenic animals "},{"id":"JYtdzkqX","value":"resistance "},{"id":"JcX9Gfqc","value":"Videonystagmograph"},{"id":"KKnXXduP","value":"SharePoint Cloud"},{"id":"JWriAHYt","value":"Glioblastoma symptoms"},{"id":"JYtdzaYG","value":"seizer disorder"},{"id":"Jb7jfphj","value":"Homogeneous Catalysts"},{"id":"JYDqa6tc","value":"Stratum Corneum"},{"id":"JWriCb9R","value":"Erythropenia"},{"id":"JWriAltg","value":"Human Genome"},{"id":"JZlUFgwv","value":"Cerebrospinal Fluid"},{"id":"JYFqh6Xx","value":"tissue disturbance"},{"id":"JYtd1zNY","value":"Mass Transfer"},{"id":"Lb8_sfiH","value":"plavix"},{"id":"JcX9GamM","value":"position indicating device"},{"id":"JpZWZic8","value":"Emerging viral diseases"},{"id":"JWrh--5s","value":"Escherichia Coli"},{"id":"JWrh_MWc","value":"linoleic acid"},{"id":"LXb4F0gN","value":"Ad Valorem Duty"},{"id":"JWriAfHQ","value":"Multiple Sequence Alignment"},{"id":"JWrh_FXl","value":"Lipid Oxidation"},{"id":"JWriBuJT","value":"Heart Rate Variability"},{"id":"JWriDgJe","value":"Punctate Basophilia"},{"id":"JYDqkWiP","value":"Pancreatic Islets"},{"id":"JYtd1JcO","value":"CCU"},{"id":"JYtd0FNW","value":"DNA/RNA sequencing "},{"id":"JYtd2--a","value":"laryngeal clef"},{"id":"JcX40WJO","value":"Obstetrics and Gynaecology"},{"id":"JZlUFaMO","value":"Spinal Cord"},{"id":"JWriBjkp","value":"Systolic Blood Pressure"},{"id":"JYFqhk__","value":"Epidural hematoma Dx LMA cuff leak Rx"},{"id":"LXb4FekQ","value":"ABC Costing"},{"id":"JYDqkOMz","value":"Insulin Sensitive"},{"id":"JWrh_K4c","value":"Rheological Properties"},{"id":"JbN7AaIZ","value":"Bronchopulmonary Dysplasia"},{"id":"JYFqhv2j","value":"thorac epidural"},{"id":"JYtd11rL","value":"Ethyl Acetate"},{"id":"JYtdzh3S","value":"absorption"},{"id":"JWrh_7Qd","value":"Epigenetics"},{"id":"JX1LgVQO","value":"African-American"},{"id":"LXb4F-Oz","value":"Agency Tariff"},{"id":"JYtd0fDz","value":"Case Report"},{"id":"Jbj4Rmi0","value":"Feed"},{"id":"JYtd0vvz","value":"lung"},{"id":"JX1LgYqE","value":"AILD"},{"id":"JYDqhPGY","value":"Genetics"},{"id":"J9qqTaBf","value":"interventional electropyhsiology issues"},{"id":"JYFrH7dK","value":"cryofibrinogen"},{"id":"JpZWZoFJ","value":"Helminths"},{"id":"JYtd2TH8","value":"Transgenic Mice"},{"id":"JWriCvUv","value":"Hypoplasia"},{"id":"Jb7jaWX-","value":"Life Science Chemicals"},{"id":"JX1LgdGK","value":"alkB gene"},{"id":"JWriA87x","value":"Monte Carlo"},{"id":"LXb4GpNP","value":"Chain of Customers"},{"id":"JWriBwp5","value":"Natriuretic Peptide"},{"id":"J9qL7g1y","value":"AF solution"},{"id":"JeGRHHnH","value":"income"},{"id":"JYtd0tXy","value":"graft"},{"id":"JYtd2uaO","value":"Retinal Detachment"},{"id":"JWrh_tdl","value":"thermogravimetric analysis"},{"id":"JYFqh-Fr","value":"OLVA scoring schemes"},{"id":"JYtd1oin","value":"High Performance Liquid Chromatograph"},{"id":"JZlUFlHE","value":"Long Term Potentiation"},{"id":"JWriDmGy","value":"Shift to the Right"},{"id":"J9ihuxTE","value":"Absorptance"},{"id":"LXb4G-wE","value":"Final Destination"},{"id":"KHcl5UU5","value":"Migraines"},{"id":"JcX9GcSM","value":"Jaw tracking device"},{"id":"JYtd2Eim","value":"Antigen Presentation"},{"id":"JY9Y-7Q0","value":"Drug Resistance"},{"id":"JcX8BZBD","value":"Surgical Lights"},{"id":"JlBiPQxs","value":"disorder"},{"id":"JYFqh1uI","value":"Glomerular Filtration Rate"},{"id":"Jb7jgwk3","value":"Chemical Reaction Engineering"},{"id":"Jbei9wTt","value":"gastroenterology"},{"id":"JYFqhx1C","value":"End Stage Renal Disease"},{"id":"KHXCyxSY","value":"COPD (Chronic Obstructive Pulmonary Disease)"},{"id":"JpZWZ7jK","value":"Plant viruses"},{"id":"JYFrIBoX","value":"magnetic resonance imaging (mri)"},{"id":"JYtd0pN0","value":"Continuous Infusion"},{"id":"JYtd1eE7","value":"deoxyhemoglobin"},{"id":"Jb7jblvN","value":"Waste Management"},{"id":"JYtdz6eP","value":"CT scanning "},{"id":"JYtdzhYY","value":"calcium loss"},{"id":"JWrh_XYd","value":"Raw Milk"},{"id":"JYtd1ySU","value":"Particle Size"},{"id":"JWrh_zBx","value":"Compressive Strength"}],"publisher":{"name":"Wiley","active":true,"uuid":"5c9d7251-7b10-4260-8df4-d859510ca122","version_bucket":"steady","id":1623},"params":{"link_header_bidder":false,"site_level_supertag_config":"site","recommend":false,"control_tag_pixel_throttle":100,"fingerprint":false,"optout_button_optout_text":"Browser Opt Out","user_data_timing":"load","use_central_usermatch":true,"store_realtime_segments":false,"tag_source":false,"link_hb_start_event":"ready","optout_button_optin_text":"Browser Opt In","first_party_uid":false,"link_hb_timeout":2000,"link_hb_adserver_subordinate":true,"optimize_realtime_segments":false,"link_hb_adserver":"dfp","target_fingerprint":false,"context_terms":true,"optout_button_id":"kx-optout-button","dfp_premium":true},"prioritized_segments":[],"realtime_segments":[],"services":{"userdata":"//cdn.krxd.net/userdata/get","contentConnector":"https://connector.krxd.net/content_connector","stats":"//apiservices.krxd.net/stats","optout":"//cdn.krxd.net/userdata/optout/status","event":"//beacon.krxd.net/event.gif","set_optout":"https://consumer.krxd.net/consumer/optout","data":"//beacon.krxd.net/data.gif","link_hb_stats":"//beacon.krxd.net/link_bidder_stats.gif","userData":"//cdn.krxd.net/userdata/get","link_hb_mas":"https://link.krxd.net/hb","config":"//cdn.krxd.net/controltag/{{ confid }}.js","social":"//beacon.krxd.net/social.gif","addSegment":"//cdn.krxd.net/userdata/add","pixel":"//beacon.krxd.net/pixel.gif","um":"https://usermatch.krxd.net/um/v2","controltag":"//cdn.krxd.net/ctjs/controltag.js.{hash}","loopback":"https://consumer.krxd.net/consumer/tmp_cookie","remove":"https://consumer.krxd.net/consumer/remove/5c9d7251-7b10-4260-8df4-d859510ca122","click":"https://apiservices.krxd.net/click_tracker/track","stats_export":"//beacon.krxd.net/controltag_stats.gif","userdataApi":"//cdn.krxd.net/userdata/v1/segments/get","cookie":"//beacon.krxd.net/cookie2json","proxy":"//cdn.krxd.net/partnerjs/xdi","consent_get":"https://consumer.krxd.net/consent/get/5c9d7251-7b10-4260-8df4-d859510ca122","consent_set":"https://consumer.krxd.net/consent/set/5c9d7251-7b10-4260-8df4-d859510ca122","is_optout":"https://beacon.krxd.net/optout_check","impression":"//beacon.krxd.net/ad_impression.gif","transaction":"//beacon.krxd.net/transaction.gif","log":"//jslog.krxd.net/jslog.gif","portability":"https://consumer.krxd.net/consumer/portability/5c9d7251-7b10-4260-8df4-d859510ca122","set_optin":"https://consumer.krxd.net/consumer/optin","usermatch":"//beacon.krxd.net/usermatch.gif"},"experiments":[],"site":{"name":"Wiley","cap":255,"id":20959,"organization_id":1623,"uid":"JMOONjNh"},"tags":[{"id":20226,"name":"Technographic Data provider tag","content":"<script>\r\n// this tag is intentionally blank\r\n</script>","target":null,"target_action":"append","timing":"onload","method":"document","priority":null,"template_replacement":true,"internal":true,"criteria":["and",["and",["and",["<=","$frequency",3]]]]},{"id":20227,"name":"Krux Geographic Data provider tag","content":null,"target":null,"target_action":"append","timing":"onload","method":"document","priority":null,"template_replacement":true,"internal":true,"criteria":["and",["and",["and",["<=","$frequency",3]]]]},{"id":20229,"name":"AdAdvisor S2S provider tag","content":"<script>\r\n(function() {\r\n  // adadvisor redirects to http://logger... so it's not https safe\r\n  if (location.protocol == \"http:\") {\r\n     var u = \"https://aa.agkn.com/adscores/g.js?sid=9212244187&_kdpid=2111c0af-fc3a-446f-ab07-63aa74fbde8e\";\r\n     (new Image()).src = u;\r\n   }\r\n})();\r\n</script>","target":null,"target_action":"append","timing":"onload","method":"document","priority":null,"template_replacement":true,"internal":true,"criteria":["and",["and",["and",["<=","$frequency",3]]]]},{"id":20234,"name":"Wiley Data Transfer Code ","content":"<script type=\"text/javascript\">\r\nvar findPh = document.getElementsByTagName(\"h1\")[0]\r\nif(findPh != null) { var pageheader = document.getElementsByTagName(\"h1\")[0].innerHTML }\r\n\r\n// Using Omniture prop1 to produce page attribute Page Type\r\nKrux('set', 'page_attr_omniture_prop1', typeof window.s =='object' && window.s['prop1']);\r\n\r\n// Using Omniture prop2 to produce page attribute Page Subtype\r\nKrux('set', 'page_attr_omniture_prop2', typeof window.s =='object' && window.s['prop2']);\r\n\r\n// Using Omniture prop3 to produce page attribute Title\r\nKrux('set', 'page_attr_omniture_prop3', typeof window.s =='object' && window.s['prop3']);\r\n\r\n// Using Omniture prop4 to produce page attribute Subject Codes\r\nKrux('set', 'page_attr_omniture_prop4', typeof window.s =='object' && window.s['prop4']);\r\n\r\n// Using Omniture prop7 to produce page attribute Article Title\r\nKrux('set', 'page_attr_omniture_prop7', typeof window.s =='object' && window.s['prop7']);\r\n\r\n// Using Omniture prop8 to produce page attribute Journal Volume and Issue\r\nKrux('set', 'page_attr_omniture_prop8', typeof window.s =='object' && window.s['prop8']);\r\n\r\n// Using Omniture prop9 to produce page attribute Article Access State\r\nKrux('set', 'page_attr_omniture_prop9', typeof window.s =='object' && window.s['prop9']);\r\n\r\n// Using Omniture prop10 to produce page attribute Publication Access Status\r\nKrux('set', 'page_attr_omniture_prop10', typeof window.s =='object' && window.s['prop10']);\r\n\r\n// Using Omniture prop13 to produce page attribute Journal DOI\r\nKrux('set', 'page_attr_omniture_prop13', typeof window.s =='object' && window.s['prop13']);\r\n\r\n// Using Omniture prop14 to produce page attribute Article / Chapter DOI\r\nKrux('set', 'page_attr_omniture_prop14', typeof window.s =='object' && window.s['prop14']);\r\n\r\n// Using Omniture prop15 to produce page attribute Issue DOI\r\nKrux('set', 'page_attr_omniture_prop15', typeof window.s =='object' && window.s['prop15']);\r\n\r\n// Using Omniture prop16 to produce page attribute MRW Chapter\r\nKrux('set', 'page_attr_omniture_prop16', typeof window.s =='object' && window.s['prop16']);\r\n\r\n// Using Omniture prop20 to produce page attribute Site Search Query\r\nKrux('set', 'page_attr_omniture_prop20', typeof window.s =='object' && window.s['prop20']);\r\n\r\n// Using Omniture prop26 to produce page attribute Logged In or Out\r\nKrux('set', 'user_attr_omniture_prop26', typeof window.s =='object' && window.s['prop26']);\r\n\r\n// Using Omniture channel to produce page attribute Channel\r\nKrux('set', 'page_attr_omniture_channel', typeof window.s =='object' && window.s['channel']);\r\n\r\n// Using Omniture prop33 to produce page attribute Primary Subject Code\r\nKrux('set', 'page_attr_omniture_prop33', typeof window.s =='object' && window.s['prop33']);\r\n\r\n// Using pageheader to produce page attribute Page Header\r\nKrux('scrape', { 'page_attr_wileyonlinelib_pageheader': {javascript: 'pageheader'}});\r\n\r\n</script>","target":"","target_action":"append","timing":"onload","method":"document","priority":null,"template_replacement":true,"internal":true,"criteria":[]},{"id":20238,"name":"Dun & Bradstreet provider tag","content":null,"target":null,"target_action":"append","timing":"onload","method":"document","priority":null,"template_replacement":true,"internal":true,"criteria":["and",["and",["and",["<=","$frequency",3]]]]},{"id":20241,"name":"DataLogix - (Kelloggs)","content":"<script>\n    (function() {\n        var kuid = Krux('get', 'user');\n        if (kuid) {\n            var prefix = location.protocol == 'https:' ? \"https:\" : \"http:\";\n            var kurl_params = encodeURIComponent(\"_kuid=\" + kuid + \"&_kdpid=d7158cb7-a851-4e3c-b7ab-cc9e815b2399&dlxid=<na_id>&dlxdata=<na_da>\");\n            var kurl = prefix + \"//beacon.krxd.net/data.gif?\" + kurl_params;\n            var dlx_url = '//r.nexac.com/e/getdata.xgi?dt=br&pkey=gwjn34gwjnh86&ru=' + kurl;\n            var i = new Image();\n            i.src = dlx_url;\n        }\n    })();\n</script>","target":"","target_action":"append","timing":"onload","method":"document","priority":null,"template_replacement":true,"internal":true,"criteria":["and",["and",["and",["<=","$frequency",1]]]]},{"id":20243,"name":"TubeMogul Custom Connect","content":"","target":"","target_action":"append","timing":"onload","method":"document","priority":null,"template_replacement":true,"internal":true,"criteria":["and",["and",["and",["<=","$frequency",1]]]]},{"id":20247,"name":"Neustar Custom Connect","content":"<script type=\"text/javascript\">\r\n(function() {\r\n    (new Image()).src = '//aa.agkn.com/adscores/g.js?sid=9212244187&_kdpid=2111c0af-fc3a-446f-ab07-63aa74fbde8e';\r\n})();\r\n</script>","target":"","target_action":"append","timing":"onload","method":"document","priority":null,"template_replacement":true,"internal":true,"criteria":["and",["and",["and",["<=","$frequency",1]]]]},{"id":20248,"name":"BrightRoll User Match","content":"<script>\r\n(function(){\r\n        var kuid = Krux('get', 'user');\r\n        var prefix = window.location.protocol == 'https:' ? 'https:' : 'http:';\r\n        if (kuid) {\r\n           var url = prefix + '//pix.btrll.com/partner/868092.png';\r\n           (new Image()).src = url;\r\n        }\r\n})();\r\n</script>","target":"","target_action":"append","timing":"onload","method":"document","priority":null,"template_replacement":true,"internal":true,"criteria":["and",["and",["and",["<=","$frequency",1]]]]},{"id":20251,"name":"DataLogix (Meredith Pepperidge Farms) library tag","content":"<script>\r\n    (function() {\r\n        var kuid = Krux('get', 'user');\r\n        if (kuid) {\r\n            var prefix = location.protocol == 'https:' ? \"https:\" : \"http:\";\r\n            var kurl_params = encodeURIComponent(\"_kuid=\" + kuid + \"&_kdpid=8da8b14d-5569-4bec-bcea-722864ee8d06&dlxid=<na_id>&dlxdata=<na_da>\");\r\n            var kurl = prefix + \"//beacon.krxd.net/data.gif?\" + kurl_params;\r\n            var dlx_url = '//r.nexac.com/e/getdata.xgi?dt=br&pkey=iefs40iefsj26&ru=' + kurl;\r\n            var i = new Image();\r\n            i.src = dlx_url;\r\n        }\r\n    })();\r\n</script>","target":"","target_action":"append","timing":"onload","method":"document","priority":null,"template_replacement":true,"internal":true,"criteria":[]},{"id":20252,"name":"DataLogix (Meredith VRC) library tag","content":"<script>\r\n    (function() {\r\n        var kuid = Krux('get', 'user');\r\n        if (kuid) {\r\n            var prefix = location.protocol == 'https:' ? \"https:\" : \"http:\";\r\n            var kurl_params = encodeURIComponent(\"_kuid=\" + kuid + \"&_kdpid=bef9f122-393d-4c45-8d8d-32d8be7ac433&dlxid=<na_id>&dlxdata=<na_da>\");\r\n            var kurl = prefix + \"//beacon.krxd.net/data.gif?\" + kurl_params;\r\n            var dlx_url = '//r.nexac.com/e/getdata.xgi?dt=br&pkey=iyzu39iyzud95&ru=' + kurl;\r\n            var i = new Image();\r\n            i.src = dlx_url;\r\n        }\r\n    })();\r\n</script>","target":"","target_action":"append","timing":"onload","method":"document","priority":null,"template_replacement":true,"internal":true,"criteria":[]},{"id":20253,"name":"DataLogix (Heineken) library tag","content":"<script>\r\n    (function() {\r\n        var allowUserMatch = function() {\r\n            var GDN_SITE_ID = '1282650';\r\n \r\n            if (Krux('get', 'config').params.client_type === 'marketer') {\r\n                try {\r\n                    var params = Krux('require:marketer').getParams(\r\n                            Krux('require:sizzle').find('script[src*=\"' + Krux('get', 'confid') + '\"]')\r\n                    );\r\n                    return GDN_SITE_ID !== (params.siteid || params.kxsiteid);\r\n                }\r\n                catch (e) {\r\n                    // In case we don't find the script tag or the URL parser fails, just allow matching.\r\n                }\r\n            }\r\n            return true;\r\n        };\r\n         \r\n        var kuid = Krux('get', 'user');\r\n        if (allowUserMatch() && kuid) {\r\n            var prefix = location.protocol == 'https:' ? \"https:\" : \"http:\";\r\n            var kurl_params = encodeURIComponent(\"_kuid=\" + kuid + \"&_kdpid=8bf57916-aac8-4f01-a386-4baf103b3e1f&dlxid=<na_id>&dlxdata=<na_da>\");\r\n            var kurl = prefix + \"//beacon.krxd.net/data.gif?\" + kurl_params;\r\n            var dlx_url = '//r.nexac.com/e/getdata.xgi?dt=br&pkey=bckw15bckwu20&ru=' + kurl;\r\n            var i = new Image();\r\n            i.src = dlx_url;\r\n        }\r\n    })();\r\n</script>","target":"","target_action":"append","timing":"onload","method":"document","priority":null,"template_replacement":true,"internal":true,"criteria":["and",["and",["and",["<=","$frequency",3]]]]},{"id":20254,"name":"DataLogix (Kelloggs) library tag","content":"<script>\r\n    (function() {\r\n        var allowUserMatch = function() {\r\n            var GDN_SITE_ID = '1282650';\r\n\r\n            if (Krux('get', 'config').params.client_type === 'marketer') {\r\n                try {\r\n                    var params = Krux('require:marketer').getParams(\r\n                            Krux('require:sizzle').find('script[src*=\"' + Krux('get', 'confid') + '\"]')\r\n                    );\r\n                    return GDN_SITE_ID !== (params.siteid || params.kxsiteid);\r\n                }\r\n                catch (e) {\r\n                    // In case we don't find the script tag or the URL parser fails, just allow matching.\r\n                }\r\n            }\r\n            return true;\r\n        };\r\n\r\n        var kuid = Krux('get', 'user');\r\n        if (allowUserMatch() && kuid) {\r\n            var prefix = location.protocol == 'https:' ? \"https:\" : \"http:\";\r\n            var kurl_params = encodeURIComponent(\"_kuid=\" + kuid + \"&_kdpid=d7158cb7-a851-4e3c-b7ab-cc9e815b2399&dlxid=<na_id>&dlxdata=<na_da>\");\r\n            var kurl = prefix + \"//beacon.krxd.net/data.gif?\" + kurl_params;\r\n            var dlx_url = '//r.nexac.com/e/getdata.xgi?dt=br&pkey=gwjn34gwjnh86&ru=' + kurl;\r\n            var i = new Image();\r\n            i.src = dlx_url;\r\n        }\r\n    })();\r\n</script>","target":"","target_action":"append","timing":"onload","method":"document","priority":null,"template_replacement":true,"internal":true,"criteria":["and",["and",["and",["<=","$frequency",3]]]]},{"id":20255,"name":"DataLogix (Meredith CVS) library tag","content":"<script>\r\n    (function() {\r\n        var kuid = Krux('get', 'user');\r\n        if (kuid) {\r\n            var prefix = location.protocol == 'https:' ? \"https:\" : \"http:\";\r\n            var kurl_params = encodeURIComponent(\"_kuid=\" + kuid + \"&_kdpid=536f0daa-aaaa-4d9e-9a25-dde40646786a&dlxid=<na_id>&dlxdata=<na_da>\");\r\n            var kurl = prefix + \"//beacon.krxd.net/data.gif?\" + kurl_params;\r\n            var dlx_url = '//r.nexac.com/e/getdata.xgi?dt=br&pkey=iefs40iefsj26&ru=' + kurl;\r\n            var i = new Image();\r\n            i.src = dlx_url;\r\n        }\r\n    })();\r\n</script>","target":"","target_action":"append","timing":"onload","method":"document","priority":null,"template_replacement":true,"internal":true,"criteria":[]},{"id":20256,"name":"DataLogix (Tribune) library tag","content":"<script>\r\n    (function() {\r\n        var kuid = Krux('get', 'user');\r\n        if (kuid) {\r\n            var prefix = location.protocol == 'https:' ? \"https:\" : \"http:\";\r\n            var kurl_params = encodeURIComponent(\"_kuid=\" + kuid + \"&_kdpid=7c6392c9-e878-492c-8b14-bf06e3828ebd&dlxid=<na_id>&dlxdata=<na_da>\");\r\n            var kurl = prefix + \"//beacon.krxd.net/data.gif?\" + kurl_params;\r\n            var dlx_url = '//r.nexac.com/e/getdata.xgi?dt=br&pkey=rowp70rowpu60&ru=' + kurl;\r\n            var i = new Image();\r\n            i.src = dlx_url;\r\n        }\r\n    })();\r\n</script>","target":"","target_action":"append","timing":"onload","method":"document","priority":null,"template_replacement":true,"internal":true,"criteria":[]},{"id":20257,"name":"KRM_Datalogix_RFP (Kelloggs) library tag","content":"<script>\r\n    (function() {\r\n        var allowUserMatch = function() {\r\n            var GDN_SITE_ID = '1282650';\r\n\r\n            if (Krux('get', 'config').params.client_type === 'marketer') {\r\n                try {\r\n                    var params = Krux('require:marketer').getParams(\r\n                            Krux('require:sizzle').find('script[src*=\"' + Krux('get', 'confid') + '\"]')\r\n                    );\r\n                    return GDN_SITE_ID !== (params.siteid || params.kxsiteid);\r\n                }\r\n                catch (e) {\r\n                    // In case we don't find the script tag or the URL parser fails, just allow matching.\r\n                }\r\n            }\r\n            return true;\r\n        };\r\n        \r\n        var kuid = Krux('get', 'user');\r\n        if (allowUserMatch() && kuid) {\r\n            var prefix = location.protocol == 'https:' ? \"https:\" : \"http:\";\r\n            var kurl_params = encodeURIComponent(\"_kuid=\" + kuid + \"&_kdpid=bb8ae0e2-9cd7-45b2-ad37-7737269627d8&dlxid=<na_id>&dlxdata=<na_da>\");\r\n            var kurl = prefix + \"//beacon.krxd.net/data.gif?\" + kurl_params;\r\n            var dlx_url = '//r.nexac.com/e/getdata.xgi?dt=br&pkey=rsxs71rsxsk73&ru=' + kurl;\r\n            var i = new Image();\r\n            i.src = dlx_url;\r\n        }\r\n    })();\r\n</script>","target":"","target_action":"append","timing":"onload","method":"document","priority":null,"template_replacement":true,"internal":true,"criteria":["and",["and",["and",["<=","$frequency",3]]]]}],"usermatch_tags":[{"id":6,"name":"Google User Match","content":"<script>\n(function() {\n  if (Krux('get', 'user') != null) {\n      new Image().src = 'https://usermatch.krxd.net/um/v2?partner=google';\n  }\n})();\n</script>","target":null,"target_action":"append","timing":"onload","method":"document","priority":1,"template_replacement":false,"internal":true,"criteria":[]},{"id":21,"name":"Acxiom","content":"<script>\n(function(){\n  var kuid = Krux('get', 'user');\n  if (kuid) {\n      var liveramp_url = 'https://idsync.rlcdn.com/379708.gif?partner_uid=' + kuid;\n      var i = new Image();\n      i.src = liveramp_url;      \n  }\n})();\n</script>","target":null,"target_action":"append","timing":"onload","method":"document","priority":1,"template_replacement":false,"internal":true,"criteria":[]},{"id":55,"name":"Acxiom APAC Usermatch","content":"<script>\n(function(){\n\tvar liveramp_url = '//s.acxiomapac.com/sci',\n\tdata = {\n\t\tpid: 90010,\n\t\tuid: Krux('get','user')\n\t};\n\tif(data.uid){\n\t\tKrux('require:http').pixel({\n\t\t\turl: liveramp_url,\n\t\t\tdata: data\n\t\t});\n\t}\n})();\n</script>","target":null,"target_action":"append","timing":"onload","method":"document","priority":1,"template_replacement":false,"internal":true,"criteria":[]},{"id":76,"name":"LiveRamp User Matching","content":"<script>\r\n(function(){\r\n  var kuid = Krux('get', 'user');\r\n  if (kuid) {\r\n      var liveramp_url = 'https://idsync.rlcdn.com/379708.gif?partner_uid=' + kuid;\r\n      var i = new Image();\r\n      i.src = liveramp_url;     \r\n  }\r\n})();\r\n</script>","target":null,"target_action":"append","timing":"onload","method":"document","priority":1,"template_replacement":false,"internal":true,"criteria":[]},{"id":25,"name":"eXelate Media","content":"<script>\n(function(){\n  var kuid = Krux('get', 'user');\n  if (kuid) {\n    Krux('require:http').pixel({\n      url: \"//loadm.exelator.com/load\",\n      data: {\n          _kdpid: 'e4942ff0-4070-4896-a7ef-e6a5a30ce9f9',\n          buid: kuid,\n          p: '204',\n          g: '270',\n          j: '0'\n      }});\n  }\n  })();\n</script>","target":null,"target_action":"append","timing":"onload","method":"document","priority":3,"template_replacement":false,"internal":true,"criteria":[]},{"id":65,"name":"Weborama User Match","content":"<script>\n(function(){\n\n   var kuid = Krux('get', 'user');\n   var krux_url = encodeURIComponent('://beacon.krxd.net/usermatch.gif?partner=weborama&partner_uid=');\n   if (kuid) {\n      new Image().src = 'https://dx.bigsea.weborama.com/collect?r=https' + krux_url + '{UUID}';\n   }\n\n})();\n</script>","target":null,"target_action":"append","timing":"onload","method":"document","priority":3,"template_replacement":false,"internal":true,"criteria":[]},{"id":73,"name":"DataLogix - (Kelloggs)","content":"<script>\n    (function() {\n        var kuid = Krux('get', 'user');\n        if (kuid) {\n            var prefix = location.protocol == 'https:' ? \"https:\" : \"http:\";\n            var kurl_params = encodeURIComponent(\"_kuid=\" + kuid + \"&_kdpid=d7158cb7-a851-4e3c-b7ab-cc9e815b2399&dlxid=<na_id>&dlxdata=<na_da>\");\n            var kurl = prefix + \"//beacon.krxd.net/data.gif?\" + kurl_params;\n            var dlx_url = '//r.nexac.com/e/getdata.xgi?dt=br&pkey=gwjn34gwjnh86&ru=' + kurl;\n            var i = new Image();\n            i.src = dlx_url;\n        }\n    })();\n</script>","target":null,"target_action":"append","timing":"onload","method":"document","priority":3,"template_replacement":false,"internal":true,"criteria":[]},{"id":82,"name":"DataLogix - Legacy","content":"<script>\r\n    (function() {\r\n        var kuid = Krux('get', 'user');\r\n        if (kuid) {\r\n            var prefix = location.protocol == 'https:' ? \"https:\" : \"http:\";\r\n            var kurl_params = encodeURIComponent(\"_kuid=\" + kuid + \"&_kdpid=2dd640a6-6ebd-4d4f-af30-af8baa441a0d&dlxid=<na_id>&dlxdata=<na_da>\");\r\n            var kurl = prefix + \"//beacon.krxd.net/data.gif?\" + kurl_params;\r\n            var dlx_url = '//r.nexac.com/e/getdata.xgi?dt=br&pkey=gpwn29rvapq62&ru=' + kurl;\r\n            var i = new Image();\r\n            i.src = dlx_url;\r\n        }\r\n    })();\r\n</script>","target":null,"target_action":"append","timing":"onload","method":"document","priority":3,"template_replacement":false,"internal":true,"criteria":[]},{"id":85,"name":"IXI Digital Open Market","content":"<script>\n(function(){\n    var prefix = window.location.protocol == 'https:' ? 'https:' : 'http:';\n    new Image().src = prefix + '//kr.ixiaa.com/C726AB29-0470-440B-B8D2-D552CED3A3DC/a.gif';\n})();\n</script>","target":null,"target_action":"append","timing":"onload","method":"document","priority":3,"template_replacement":false,"internal":true,"criteria":[]},{"id":86,"name":"Neustar AdAdvisor S2S","content":"<script>\r\n(function(){\r\nvar kuid = Krux('get', 'user');\r\nvar prefix = window.location.protocol == 'https:' ? 'https:' : 'http:';\r\nif (kuid) {\r\n    new Image().src = prefix + '//aa.agkn.com/adscores/g.js?sid=9212244187&_kdpid=2111c0af-fc3a-446f-ab07-63aa74fbde8e';\r\n     }\r\n})();\r\n</script>","target":null,"target_action":"append","timing":"onload","method":"document","priority":3,"template_replacement":false,"internal":true,"criteria":[]}],"link":{"adslots":{},"bidders":{}}};
  
  for (var i = 0, tags = config.tags, len = tags.length, tag; (tag = tags[i]); ++i) {
    if (String(tag.id) in cs) {
      tag.content = cs[tag.id];
    }
  }

  
  var esiGeo = String(function(){/*
   <esi:include src="/geoip_esi"/>
  */}).replace(/^.*\/\*[^{]+|[^}]+\*\/.*$/g, '');

  if (esiGeo) {
    log('Got a request for:', esiGeo, 'adding geo to config.');
    try {
      config.geo = w.JSON.parse(esiGeo);
    } catch (__) {
      
      log('Unable to parse geo from:', config.geo);
      config.geo = {};
    }
  }



  var proxy = (window.Krux && window.Krux.q && window.Krux.q[0] && window.Krux.q[0][0] === 'proxy');

  if (!proxy || true) {
    

  load('//cdn.krxd.net/ctjs/controltag.js.93f35b9b9881afd24d882ee537cf5cdd', function() {
    log('Loaded steady controltag resource');
    Krux('config', config);
  });

  }

})(window, (function() {
  var obj = {};
  
  return obj;
})());
