(function () {
// create global namespace for all JS modules
window.UX = {};

UX.grid = {
  // Deprecated `$screen-xs` as of v3.0.1
  screenXs: "532",
  // Deprecated `$screen-sm` as of v3.0.1
  screenSm: "768",
  // Deprecated `$screen-md` as of v3.0.1
  screenMd: "992",
  // Deprecated `$screen-md` as of v3.0.1
  screenLg: "1200",
  // Small screen / phone
  containerMobile: "500",
  // For `$screen-sm-min` and up
  containerXs: "",
  // Small screen / tablet
  containerTablet: "736",
  // For `$screen-sm-min` and up
  containerSm: "",
  // Medium screen / desktop
  containerDesktop: "960",
  // For `$screen-md-min` and up
  containerMd: "",
  // Large screen / wide desktop
  containerLargeDesktop: "1080",
  // For `$screen-lg-min` and up
  containerLg: ""
};

// import './services-variables.js'

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _AwaitValue(value) {
  this.wrapped = value;
}

function _AsyncGenerator(gen) {
  var front, back;

  function send(key, arg) {
    return new Promise(function (resolve, reject) {
      var request = {
        key: key,
        arg: arg,
        resolve: resolve,
        reject: reject,
        next: null
      };

      if (back) {
        back = back.next = request;
      } else {
        front = back = request;
        resume(key, arg);
      }
    });
  }

  function resume(key, arg) {
    try {
      var result = gen[key](arg);
      var value = result.value;
      var wrappedAwait = value instanceof _AwaitValue;
      Promise.resolve(wrappedAwait ? value.wrapped : value).then(function (arg) {
        if (wrappedAwait) {
          resume("next", arg);
          return;
        }

        settle(result.done ? "return" : "normal", arg);
      }, function (err) {
        resume("throw", err);
      });
    } catch (err) {
      settle("throw", err);
    }
  }

  function settle(type, value) {
    switch (type) {
      case "return":
        front.resolve({
          value: value,
          done: true
        });
        break;

      case "throw":
        front.reject(value);
        break;

      default:
        front.resolve({
          value: value,
          done: false
        });
        break;
    }

    front = front.next;

    if (front) {
      resume(front.key, front.arg);
    } else {
      back = null;
    }
  }

  this._invoke = send;

  if (typeof gen.return !== "function") {
    this.return = undefined;
  }
}

if (typeof Symbol === "function" && Symbol.asyncIterator) {
  _AsyncGenerator.prototype[Symbol.asyncIterator] = function () {
    return this;
  };
}

_AsyncGenerator.prototype.next = function (arg) {
  return this._invoke("next", arg);
};

_AsyncGenerator.prototype.throw = function (arg) {
  return this._invoke("throw", arg);
};

_AsyncGenerator.prototype.return = function (arg) {
  return this._invoke("return", arg);
};

/*!
 * jQuery JavaScript Library v3.1.1
 * https://jquery.com/
 *
 * Includes Sizzle.js
 * https://sizzlejs.com/
 *
 * Copyright jQuery Foundation and other contributors
 * Released under the MIT license
 *
 * Date: 2016-09-22T22:30Z
 */
(function (global, factory) {
  "use strict";

  if ((typeof module === "undefined" ? "undefined" : _typeof(module)) === "object" && _typeof(module.exports) === "object") {
    // For CommonJS and CommonJS-like environments where a proper `window`
    // is present, execute the factory and get jQuery.
    // For environments that do not have a `window` with a `document`
    // (such as Node.js), expose a factory as module.exports.
    // This accentuates the need for the creation of a real `window`.
    // e.g. var jQuery = require("jquery")(window);
    // See ticket #14549 for more info.
    module.exports = global.document ? factory(global, true) : function (w) {
      if (!w.document) {
        throw new Error("jQuery requires a window with a document");
      }

      return factory(w);
    };
  } else {
    factory(global);
  } // Pass this if window is not defined yet

})(typeof window !== "undefined" ? window : window, function (window, noGlobal) {
  // Edge <= 12 - 13+, Firefox <=18 - 45+, IE 10 - 11, Safari 5.1 - 9+, iOS 6 - 9.1
  // throw exceptions when non-strict code (e.g., ASP.NET 4.5) accesses strict mode
  // arguments.callee.caller (trac-13335). But as of jQuery 3.0 (2016), strict mode should be common
  // enough that all such attempts are guarded in a try block.
  "use strict";

  var arr = [];
  var document = window.document;
  var getProto = Object.getPrototypeOf;
  var _slice = arr.slice;
  var concat = arr.concat;
  var push = arr.push;
  var indexOf = arr.indexOf;
  var class2type = {};
  var toString = class2type.toString;
  var hasOwn = class2type.hasOwnProperty;
  var fnToString = hasOwn.toString;
  var ObjectFunctionString = fnToString.call(Object);
  var support = {};

  function DOMEval(code, doc) {
    doc = doc || document;
    var script = doc.createElement("script");
    script.text = code;
    doc.head.appendChild(script).parentNode.removeChild(script);
  }
  /* global Symbol */
  // Defining this global in .eslintrc.json would create a danger of using the global
  // unguarded in another place, it seems safer to define global only for this module


  var version = "3.1.1",
      // Define a local copy of jQuery
  jQuery = function jQuery(selector, context) {
    // The jQuery object is actually just the init constructor 'enhanced'
    // Need init if jQuery is called (just allow error to be thrown if not included)
    return new jQuery.fn.init(selector, context);
  },
      // Support: Android <=4.0 only
  // Make sure we trim BOM and NBSP
  rtrim = /^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,
      // Matches dashed string for camelizing
  rmsPrefix = /^-ms-/,
      rdashAlpha = /-([a-z])/g,
      // Used by jQuery.camelCase as callback to replace()
  fcamelCase = function fcamelCase(all, letter) {
    return letter.toUpperCase();
  };

  jQuery.fn = jQuery.prototype = {
    // The current version of jQuery being used
    jquery: version,
    constructor: jQuery,
    // The default length of a jQuery object is 0
    length: 0,
    toArray: function toArray() {
      return _slice.call(this);
    },
    // Get the Nth element in the matched element set OR
    // Get the whole matched element set as a clean array
    get: function get(num) {
      // Return all the elements in a clean array
      if (num == null) {
        return _slice.call(this);
      } // Return just the one element from the set


      return num < 0 ? this[num + this.length] : this[num];
    },
    // Take an array of elements and push it onto the stack
    // (returning the new matched element set)
    pushStack: function pushStack(elems) {
      // Build a new jQuery matched element set
      var ret = jQuery.merge(this.constructor(), elems); // Add the old object onto the stack (as a reference)

      ret.prevObject = this; // Return the newly-formed element set

      return ret;
    },
    // Execute a callback for every element in the matched set.
    each: function each(callback) {
      return jQuery.each(this, callback);
    },
    map: function map(callback) {
      return this.pushStack(jQuery.map(this, function (elem, i) {
        return callback.call(elem, i, elem);
      }));
    },
    slice: function slice() {
      return this.pushStack(_slice.apply(this, arguments));
    },
    first: function first() {
      return this.eq(0);
    },
    last: function last() {
      return this.eq(-1);
    },
    eq: function eq(i) {
      var len = this.length,
          j = +i + (i < 0 ? len : 0);
      return this.pushStack(j >= 0 && j < len ? [this[j]] : []);
    },
    end: function end() {
      return this.prevObject || this.constructor();
    },
    // For internal use only.
    // Behaves like an Array's method, not like a jQuery method.
    push: push,
    sort: arr.sort,
    splice: arr.splice
  };

  jQuery.extend = jQuery.fn.extend = function () {
    var options,
        name,
        src,
        copy,
        copyIsArray,
        clone,
        target = arguments[0] || {},
        i = 1,
        length = arguments.length,
        deep = false; // Handle a deep copy situation

    if (typeof target === "boolean") {
      deep = target; // Skip the boolean and the target

      target = arguments[i] || {};
      i++;
    } // Handle case when target is a string or something (possible in deep copy)


    if (_typeof(target) !== "object" && !jQuery.isFunction(target)) {
      target = {};
    } // Extend jQuery itself if only one argument is passed


    if (i === length) {
      target = this;
      i--;
    }

    for (; i < length; i++) {
      // Only deal with non-null/undefined values
      if ((options = arguments[i]) != null) {
        // Extend the base object
        for (name in options) {
          src = target[name];
          copy = options[name]; // Prevent never-ending loop

          if (target === copy) {
            continue;
          } // Recurse if we're merging plain objects or arrays


          if (deep && copy && (jQuery.isPlainObject(copy) || (copyIsArray = jQuery.isArray(copy)))) {
            if (copyIsArray) {
              copyIsArray = false;
              clone = src && jQuery.isArray(src) ? src : [];
            } else {
              clone = src && jQuery.isPlainObject(src) ? src : {};
            } // Never move original objects, clone them


            target[name] = jQuery.extend(deep, clone, copy); // Don't bring in undefined values
          } else if (copy !== undefined) {
            target[name] = copy;
          }
        }
      }
    } // Return the modified object


    return target;
  };

  jQuery.extend({
    // Unique for each copy of jQuery on the page
    expando: "jQuery" + (version + Math.random()).replace(/\D/g, ""),
    // Assume jQuery is ready without the ready module
    isReady: true,
    error: function error(msg) {
      throw new Error(msg);
    },
    noop: function noop() {},
    isFunction: function isFunction(obj) {
      return jQuery.type(obj) === "function";
    },
    isArray: Array.isArray,
    isWindow: function isWindow(obj) {
      return obj != null && obj === obj.window;
    },
    isNumeric: function isNumeric(obj) {
      // As of jQuery 3.0, isNumeric is limited to
      // strings and numbers (primitives or objects)
      // that can be coerced to finite numbers (gh-2662)
      var type = jQuery.type(obj);
      return (type === "number" || type === "string") && // parseFloat NaNs numeric-cast false positives ("")
      // ...but misinterprets leading-number strings, particularly hex literals ("0x...")
      // subtraction forces infinities to NaN
      !isNaN(obj - parseFloat(obj));
    },
    isPlainObject: function isPlainObject(obj) {
      var proto, Ctor; // Detect obvious negatives
      // Use toString instead of jQuery.type to catch host objects

      if (!obj || toString.call(obj) !== "[object Object]") {
        return false;
      }

      proto = getProto(obj); // Objects with no prototype (e.g., `Object.create( null )`) are plain

      if (!proto) {
        return true;
      } // Objects with prototype are plain iff they were constructed by a global Object function


      Ctor = hasOwn.call(proto, "constructor") && proto.constructor;
      return typeof Ctor === "function" && fnToString.call(Ctor) === ObjectFunctionString;
    },
    isEmptyObject: function isEmptyObject(obj) {
      /* eslint-disable no-unused-vars */
      // See https://github.com/eslint/eslint/issues/6125
      var name;

      for (name in obj) {
        return false;
      }

      return true;
    },
    type: function type(obj) {
      if (obj == null) {
        return obj + "";
      } // Support: Android <=2.3 only (functionish RegExp)


      return _typeof(obj) === "object" || typeof obj === "function" ? class2type[toString.call(obj)] || "object" : _typeof(obj);
    },
    // Evaluates a script in a global context
    globalEval: function globalEval(code) {
      DOMEval(code);
    },
    // Convert dashed to camelCase; used by the css and data modules
    // Support: IE <=9 - 11, Edge 12 - 13
    // Microsoft forgot to hump their vendor prefix (#9572)
    camelCase: function camelCase(string) {
      return string.replace(rmsPrefix, "ms-").replace(rdashAlpha, fcamelCase);
    },
    nodeName: function nodeName(elem, name) {
      return elem.nodeName && elem.nodeName.toLowerCase() === name.toLowerCase();
    },
    each: function each(obj, callback) {
      var length,
          i = 0;

      if (isArrayLike(obj)) {
        length = obj.length;

        for (; i < length; i++) {
          if (callback.call(obj[i], i, obj[i]) === false) {
            break;
          }
        }
      } else {
        for (i in obj) {
          if (callback.call(obj[i], i, obj[i]) === false) {
            break;
          }
        }
      }

      return obj;
    },
    // Support: Android <=4.0 only
    trim: function trim(text) {
      return text == null ? "" : (text + "").replace(rtrim, "");
    },
    // results is for internal usage only
    makeArray: function makeArray(arr, results) {
      var ret = results || [];

      if (arr != null) {
        if (isArrayLike(Object(arr))) {
          jQuery.merge(ret, typeof arr === "string" ? [arr] : arr);
        } else {
          push.call(ret, arr);
        }
      }

      return ret;
    },
    inArray: function inArray(elem, arr, i) {
      return arr == null ? -1 : indexOf.call(arr, elem, i);
    },
    // Support: Android <=4.0 only, PhantomJS 1 only
    // push.apply(_, arraylike) throws on ancient WebKit
    merge: function merge(first, second) {
      var len = +second.length,
          j = 0,
          i = first.length;

      for (; j < len; j++) {
        first[i++] = second[j];
      }

      first.length = i;
      return first;
    },
    grep: function grep(elems, callback, invert) {
      var callbackInverse,
          matches = [],
          i = 0,
          length = elems.length,
          callbackExpect = !invert; // Go through the array, only saving the items
      // that pass the validator function

      for (; i < length; i++) {
        callbackInverse = !callback(elems[i], i);

        if (callbackInverse !== callbackExpect) {
          matches.push(elems[i]);
        }
      }

      return matches;
    },
    // arg is for internal usage only
    map: function map(elems, callback, arg) {
      var length,
          value,
          i = 0,
          ret = []; // Go through the array, translating each of the items to their new values

      if (isArrayLike(elems)) {
        length = elems.length;

        for (; i < length; i++) {
          value = callback(elems[i], i, arg);

          if (value != null) {
            ret.push(value);
          }
        } // Go through every key on the object,

      } else {
        for (i in elems) {
          value = callback(elems[i], i, arg);

          if (value != null) {
            ret.push(value);
          }
        }
      } // Flatten any nested arrays


      return concat.apply([], ret);
    },
    // A global GUID counter for objects
    guid: 1,
    // Bind a function to a context, optionally partially applying any
    // arguments.
    proxy: function proxy(fn, context) {
      var tmp, args, proxy;

      if (typeof context === "string") {
        tmp = fn[context];
        context = fn;
        fn = tmp;
      } // Quick check to determine if target is callable, in the spec
      // this throws a TypeError, but we will just return undefined.


      if (!jQuery.isFunction(fn)) {
        return undefined;
      } // Simulated bind


      args = _slice.call(arguments, 2);

      proxy = function proxy() {
        return fn.apply(context || this, args.concat(_slice.call(arguments)));
      }; // Set the guid of unique handler to the same of original handler, so it can be removed


      proxy.guid = fn.guid = fn.guid || jQuery.guid++;
      return proxy;
    },
    now: Date.now,
    // jQuery.support is not used in Core but other projects attach their
    // properties to it so it needs to exist.
    support: support
  });

  if (typeof Symbol === "function") {
    jQuery.fn[Symbol.iterator] = arr[Symbol.iterator];
  } // Populate the class2type map


  jQuery.each("Boolean Number String Function Array Date RegExp Object Error Symbol".split(" "), function (i, name) {
    class2type["[object " + name + "]"] = name.toLowerCase();
  });

  function isArrayLike(obj) {
    // Support: real iOS 8.2 only (not reproducible in simulator)
    // `in` check used to prevent JIT error (gh-2145)
    // hasOwn isn't used here due to false negatives
    // regarding Nodelist length in IE
    var length = !!obj && "length" in obj && obj.length,
        type = jQuery.type(obj);

    if (type === "function" || jQuery.isWindow(obj)) {
      return false;
    }

    return type === "array" || length === 0 || typeof length === "number" && length > 0 && length - 1 in obj;
  }

  var Sizzle =
  /*!
   * Sizzle CSS Selector Engine v2.3.3
   * https://sizzlejs.com/
   *
   * Copyright jQuery Foundation and other contributors
   * Released under the MIT license
   * http://jquery.org/license
   *
   * Date: 2016-08-08
   */
  function (window) {
    var i,
        support,
        Expr,
        getText,
        isXML,
        tokenize,
        compile,
        select,
        outermostContext,
        sortInput,
        hasDuplicate,
        // Local document vars
    setDocument,
        document,
        docElem,
        documentIsHTML,
        rbuggyQSA,
        rbuggyMatches,
        matches,
        contains,
        // Instance-specific data
    expando = "sizzle" + 1 * new Date(),
        preferredDoc = window.document,
        dirruns = 0,
        done = 0,
        classCache = createCache(),
        tokenCache = createCache(),
        compilerCache = createCache(),
        sortOrder = function sortOrder(a, b) {
      if (a === b) {
        hasDuplicate = true;
      }

      return 0;
    },
        // Instance methods
    hasOwn = {}.hasOwnProperty,
        arr = [],
        pop = arr.pop,
        push_native = arr.push,
        push = arr.push,
        slice = arr.slice,
        // Use a stripped-down indexOf as it's faster than native
    // https://jsperf.com/thor-indexof-vs-for/5
    indexOf = function indexOf(list, elem) {
      var i = 0,
          len = list.length;

      for (; i < len; i++) {
        if (list[i] === elem) {
          return i;
        }
      }

      return -1;
    },
        booleans = "checked|selected|async|autofocus|autoplay|controls|defer|disabled|hidden|ismap|loop|multiple|open|readonly|required|scoped",
        // Regular expressions
    // http://www.w3.org/TR/css3-selectors/#whitespace
    whitespace = "[\\x20\\t\\r\\n\\f]",
        // http://www.w3.org/TR/CSS21/syndata.html#value-def-identifier
    identifier = "(?:\\\\.|[\\w-]|[^\0-\\xa0])+",
        // Attribute selectors: http://www.w3.org/TR/selectors/#attribute-selectors
    attributes = "\\[" + whitespace + "*(" + identifier + ")(?:" + whitespace + // Operator (capture 2)
    "*([*^$|!~]?=)" + whitespace + // "Attribute values must be CSS identifiers [capture 5] or strings [capture 3 or capture 4]"
    "*(?:'((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\"|(" + identifier + "))|)" + whitespace + "*\\]",
        pseudos = ":(" + identifier + ")(?:\\((" + // To reduce the number of selectors needing tokenize in the preFilter, prefer arguments:
    // 1. quoted (capture 3; capture 4 or capture 5)
    "('((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\")|" + // 2. simple (capture 6)
    "((?:\\\\.|[^\\\\()[\\]]|" + attributes + ")*)|" + // 3. anything else (capture 2)
    ".*" + ")\\)|)",
        // Leading and non-escaped trailing whitespace, capturing some non-whitespace characters preceding the latter
    rwhitespace = new RegExp(whitespace + "+", "g"),
        rtrim = new RegExp("^" + whitespace + "+|((?:^|[^\\\\])(?:\\\\.)*)" + whitespace + "+$", "g"),
        rcomma = new RegExp("^" + whitespace + "*," + whitespace + "*"),
        rcombinators = new RegExp("^" + whitespace + "*([>+~]|" + whitespace + ")" + whitespace + "*"),
        rattributeQuotes = new RegExp("=" + whitespace + "*([^\\]'\"]*?)" + whitespace + "*\\]", "g"),
        rpseudo = new RegExp(pseudos),
        ridentifier = new RegExp("^" + identifier + "$"),
        matchExpr = {
      "ID": new RegExp("^#(" + identifier + ")"),
      "CLASS": new RegExp("^\\.(" + identifier + ")"),
      "TAG": new RegExp("^(" + identifier + "|[*])"),
      "ATTR": new RegExp("^" + attributes),
      "PSEUDO": new RegExp("^" + pseudos),
      "CHILD": new RegExp("^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\(" + whitespace + "*(even|odd|(([+-]|)(\\d*)n|)" + whitespace + "*(?:([+-]|)" + whitespace + "*(\\d+)|))" + whitespace + "*\\)|)", "i"),
      "bool": new RegExp("^(?:" + booleans + ")$", "i"),
      // For use in libraries implementing .is()
      // We use this for POS matching in `select`
      "needsContext": new RegExp("^" + whitespace + "*[>+~]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\(" + whitespace + "*((?:-\\d)?\\d*)" + whitespace + "*\\)|)(?=[^-]|$)", "i")
    },
        rinputs = /^(?:input|select|textarea|button)$/i,
        rheader = /^h\d$/i,
        rnative = /^[^{]+\{\s*\[native \w/,
        // Easily-parseable/retrievable ID or TAG or CLASS selectors
    rquickExpr = /^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/,
        rsibling = /[+~]/,
        // CSS escapes
    // http://www.w3.org/TR/CSS21/syndata.html#escaped-characters
    runescape = new RegExp("\\\\([\\da-f]{1,6}" + whitespace + "?|(" + whitespace + ")|.)", "ig"),
        funescape = function funescape(_, escaped, escapedWhitespace) {
      var high = "0x" + escaped - 0x10000; // NaN means non-codepoint
      // Support: Firefox<24
      // Workaround erroneous numeric interpretation of +"0x"

      return high !== high || escapedWhitespace ? escaped : high < 0 ? // BMP codepoint
      String.fromCharCode(high + 0x10000) : // Supplemental Plane codepoint (surrogate pair)
      String.fromCharCode(high >> 10 | 0xD800, high & 0x3FF | 0xDC00);
    },
        // CSS string/identifier serialization
    // https://drafts.csswg.org/cssom/#common-serializing-idioms
    rcssescape = /([\0-\x1f\x7f]|^-?\d)|^-$|[^\0-\x1f\x7f-\uFFFF\w-]/g,
        fcssescape = function fcssescape(ch, asCodePoint) {
      if (asCodePoint) {
        // U+0000 NULL becomes U+FFFD REPLACEMENT CHARACTER
        if (ch === "\0") {
          return "\uFFFD";
        } // Control characters and (dependent upon position) numbers get escaped as code points


        return ch.slice(0, -1) + "\\" + ch.charCodeAt(ch.length - 1).toString(16) + " ";
      } // Other potentially-special ASCII characters get backslash-escaped


      return "\\" + ch;
    },
        // Used for iframes
    // See setDocument()
    // Removing the function wrapper causes a "Permission Denied"
    // error in IE
    unloadHandler = function unloadHandler() {
      setDocument();
    },
        disabledAncestor = addCombinator(function (elem) {
      return elem.disabled === true && ("form" in elem || "label" in elem);
    }, {
      dir: "parentNode",
      next: "legend"
    }); // Optimize for push.apply( _, NodeList )


    try {
      push.apply(arr = slice.call(preferredDoc.childNodes), preferredDoc.childNodes); // Support: Android<4.0
      // Detect silently failing push.apply

      arr[preferredDoc.childNodes.length].nodeType;
    } catch (e) {
      push = {
        apply: arr.length ? // Leverage slice if possible
        function (target, els) {
          push_native.apply(target, slice.call(els));
        } : // Support: IE<9
        // Otherwise append directly
        function (target, els) {
          var j = target.length,
              i = 0; // Can't trust NodeList.length

          while (target[j++] = els[i++]) {}

          target.length = j - 1;
        }
      };
    }

    function Sizzle(selector, context, results, seed) {
      var m,
          i,
          elem,
          nid,
          match,
          groups,
          newSelector,
          newContext = context && context.ownerDocument,
          // nodeType defaults to 9, since context defaults to document
      nodeType = context ? context.nodeType : 9;
      results = results || []; // Return early from calls with invalid selector or context

      if (typeof selector !== "string" || !selector || nodeType !== 1 && nodeType !== 9 && nodeType !== 11) {
        return results;
      } // Try to shortcut find operations (as opposed to filters) in HTML documents


      if (!seed) {
        if ((context ? context.ownerDocument || context : preferredDoc) !== document) {
          setDocument(context);
        }

        context = context || document;

        if (documentIsHTML) {
          // If the selector is sufficiently simple, try using a "get*By*" DOM method
          // (excepting DocumentFragment context, where the methods don't exist)
          if (nodeType !== 11 && (match = rquickExpr.exec(selector))) {
            // ID selector
            if (m = match[1]) {
              // Document context
              if (nodeType === 9) {
                if (elem = context.getElementById(m)) {
                  // Support: IE, Opera, Webkit
                  // TODO: identify versions
                  // getElementById can match elements by name instead of ID
                  if (elem.id === m) {
                    results.push(elem);
                    return results;
                  }
                } else {
                  return results;
                } // Element context

              } else {
                // Support: IE, Opera, Webkit
                // TODO: identify versions
                // getElementById can match elements by name instead of ID
                if (newContext && (elem = newContext.getElementById(m)) && contains(context, elem) && elem.id === m) {
                  results.push(elem);
                  return results;
                }
              } // Type selector

            } else if (match[2]) {
              push.apply(results, context.getElementsByTagName(selector));
              return results; // Class selector
            } else if ((m = match[3]) && support.getElementsByClassName && context.getElementsByClassName) {
              push.apply(results, context.getElementsByClassName(m));
              return results;
            }
          } // Take advantage of querySelectorAll


          if (support.qsa && !compilerCache[selector + " "] && (!rbuggyQSA || !rbuggyQSA.test(selector))) {
            if (nodeType !== 1) {
              newContext = context;
              newSelector = selector; // qSA looks outside Element context, which is not what we want
              // Thanks to Andrew Dupont for this workaround technique
              // Support: IE <=8
              // Exclude object elements
            } else if (context.nodeName.toLowerCase() !== "object") {
              // Capture the context ID, setting it first if necessary
              if (nid = context.getAttribute("id")) {
                nid = nid.replace(rcssescape, fcssescape);
              } else {
                context.setAttribute("id", nid = expando);
              } // Prefix every selector in the list


              groups = tokenize(selector);
              i = groups.length;

              while (i--) {
                groups[i] = "#" + nid + " " + toSelector(groups[i]);
              }

              newSelector = groups.join(","); // Expand context for sibling selectors

              newContext = rsibling.test(selector) && testContext(context.parentNode) || context;
            }

            if (newSelector) {
              try {
                push.apply(results, newContext.querySelectorAll(newSelector));
                return results;
              } catch (qsaError) {} finally {
                if (nid === expando) {
                  context.removeAttribute("id");
                }
              }
            }
          }
        }
      } // All others


      return select(selector.replace(rtrim, "$1"), context, results, seed);
    }
    /**
     * Create key-value caches of limited size
     * @returns {function(string, object)} Returns the Object data after storing it on itself with
     *	property name the (space-suffixed) string and (if the cache is larger than Expr.cacheLength)
     *	deleting the oldest entry
     */


    function createCache() {
      var keys = [];

      function cache(key, value) {
        // Use (key + " ") to avoid collision with native prototype properties (see Issue #157)
        if (keys.push(key + " ") > Expr.cacheLength) {
          // Only keep the most recent entries
          delete cache[keys.shift()];
        }

        return cache[key + " "] = value;
      }

      return cache;
    }
    /**
     * Mark a function for special use by Sizzle
     * @param {Function} fn The function to mark
     */


    function markFunction(fn) {
      fn[expando] = true;
      return fn;
    }
    /**
     * Support testing using an element
     * @param {Function} fn Passed the created element and returns a boolean result
     */


    function assert(fn) {
      var el = document.createElement("fieldset");

      try {
        return !!fn(el);
      } catch (e) {
        return false;
      } finally {
        // Remove from its parent by default
        if (el.parentNode) {
          el.parentNode.removeChild(el);
        } // release memory in IE


        el = null;
      }
    }
    /**
     * Adds the same handler for all of the specified attrs
     * @param {String} attrs Pipe-separated list of attributes
     * @param {Function} handler The method that will be applied
     */


    function addHandle(attrs, handler) {
      var arr = attrs.split("|"),
          i = arr.length;

      while (i--) {
        Expr.attrHandle[arr[i]] = handler;
      }
    }
    /**
     * Checks document order of two siblings
     * @param {Element} a
     * @param {Element} b
     * @returns {Number} Returns less than 0 if a precedes b, greater than 0 if a follows b
     */


    function siblingCheck(a, b) {
      var cur = b && a,
          diff = cur && a.nodeType === 1 && b.nodeType === 1 && a.sourceIndex - b.sourceIndex; // Use IE sourceIndex if available on both nodes

      if (diff) {
        return diff;
      } // Check if b follows a


      if (cur) {
        while (cur = cur.nextSibling) {
          if (cur === b) {
            return -1;
          }
        }
      }

      return a ? 1 : -1;
    }
    /**
     * Returns a function to use in pseudos for input types
     * @param {String} type
     */


    function createInputPseudo(type) {
      return function (elem) {
        var name = elem.nodeName.toLowerCase();
        return name === "input" && elem.type === type;
      };
    }
    /**
     * Returns a function to use in pseudos for buttons
     * @param {String} type
     */


    function createButtonPseudo(type) {
      return function (elem) {
        var name = elem.nodeName.toLowerCase();
        return (name === "input" || name === "button") && elem.type === type;
      };
    }
    /**
     * Returns a function to use in pseudos for :enabled/:disabled
     * @param {Boolean} disabled true for :disabled; false for :enabled
     */


    function createDisabledPseudo(disabled) {
      // Known :disabled false positives: fieldset[disabled] > legend:nth-of-type(n+2) :can-disable
      return function (elem) {
        // Only certain elements can match :enabled or :disabled
        // https://html.spec.whatwg.org/multipage/scripting.html#selector-enabled
        // https://html.spec.whatwg.org/multipage/scripting.html#selector-disabled
        if ("form" in elem) {
          // Check for inherited disabledness on relevant non-disabled elements:
          // * listed form-associated elements in a disabled fieldset
          //   https://html.spec.whatwg.org/multipage/forms.html#category-listed
          //   https://html.spec.whatwg.org/multipage/forms.html#concept-fe-disabled
          // * option elements in a disabled optgroup
          //   https://html.spec.whatwg.org/multipage/forms.html#concept-option-disabled
          // All such elements have a "form" property.
          if (elem.parentNode && elem.disabled === false) {
            // Option elements defer to a parent optgroup if present
            if ("label" in elem) {
              if ("label" in elem.parentNode) {
                return elem.parentNode.disabled === disabled;
              } else {
                return elem.disabled === disabled;
              }
            } // Support: IE 6 - 11
            // Use the isDisabled shortcut property to check for disabled fieldset ancestors


            return elem.isDisabled === disabled || // Where there is no isDisabled, check manually

            /* jshint -W018 */
            elem.isDisabled !== !disabled && disabledAncestor(elem) === disabled;
          }

          return elem.disabled === disabled; // Try to winnow out elements that can't be disabled before trusting the disabled property.
          // Some victims get caught in our net (label, legend, menu, track), but it shouldn't
          // even exist on them, let alone have a boolean value.
        } else if ("label" in elem) {
          return elem.disabled === disabled;
        } // Remaining elements are neither :enabled nor :disabled


        return false;
      };
    }
    /**
     * Returns a function to use in pseudos for positionals
     * @param {Function} fn
     */


    function createPositionalPseudo(fn) {
      return markFunction(function (argument) {
        argument = +argument;
        return markFunction(function (seed, matches) {
          var j,
              matchIndexes = fn([], seed.length, argument),
              i = matchIndexes.length; // Match elements found at the specified indexes

          while (i--) {
            if (seed[j = matchIndexes[i]]) {
              seed[j] = !(matches[j] = seed[j]);
            }
          }
        });
      });
    }
    /**
     * Checks a node for validity as a Sizzle context
     * @param {Element|Object=} context
     * @returns {Element|Object|Boolean} The input node if acceptable, otherwise a falsy value
     */


    function testContext(context) {
      return context && typeof context.getElementsByTagName !== "undefined" && context;
    } // Expose support vars for convenience


    support = Sizzle.support = {};
    /**
     * Detects XML nodes
     * @param {Element|Object} elem An element or a document
     * @returns {Boolean} True iff elem is a non-HTML XML node
     */

    isXML = Sizzle.isXML = function (elem) {
      // documentElement is verified for cases where it doesn't yet exist
      // (such as loading iframes in IE - #4833)
      var documentElement = elem && (elem.ownerDocument || elem).documentElement;
      return documentElement ? documentElement.nodeName !== "HTML" : false;
    };
    /**
     * Sets document-related variables once based on the current document
     * @param {Element|Object} [doc] An element or document object to use to set the document
     * @returns {Object} Returns the current document
     */


    setDocument = Sizzle.setDocument = function (node) {
      var hasCompare,
          subWindow,
          doc = node ? node.ownerDocument || node : preferredDoc; // Return early if doc is invalid or already selected

      if (doc === document || doc.nodeType !== 9 || !doc.documentElement) {
        return document;
      } // Update global variables


      document = doc;
      docElem = document.documentElement;
      documentIsHTML = !isXML(document); // Support: IE 9-11, Edge
      // Accessing iframe documents after unload throws "permission denied" errors (jQuery #13936)

      if (preferredDoc !== document && (subWindow = document.defaultView) && subWindow.top !== subWindow) {
        // Support: IE 11, Edge
        if (subWindow.addEventListener) {
          subWindow.addEventListener("unload", unloadHandler, false); // Support: IE 9 - 10 only
        } else if (subWindow.attachEvent) {
          subWindow.attachEvent("onunload", unloadHandler);
        }
      }
      /* Attributes
      ---------------------------------------------------------------------- */
      // Support: IE<8
      // Verify that getAttribute really returns attributes and not properties
      // (excepting IE8 booleans)


      support.attributes = assert(function (el) {
        el.className = "i";
        return !el.getAttribute("className");
      });
      /* getElement(s)By*
      ---------------------------------------------------------------------- */
      // Check if getElementsByTagName("*") returns only elements

      support.getElementsByTagName = assert(function (el) {
        el.appendChild(document.createComment(""));
        return !el.getElementsByTagName("*").length;
      }); // Support: IE<9

      support.getElementsByClassName = rnative.test(document.getElementsByClassName); // Support: IE<10
      // Check if getElementById returns elements by name
      // The broken getElementById methods don't pick up programmatically-set names,
      // so use a roundabout getElementsByName test

      support.getById = assert(function (el) {
        docElem.appendChild(el).id = expando;
        return !document.getElementsByName || !document.getElementsByName(expando).length;
      }); // ID filter and find

      if (support.getById) {
        Expr.filter["ID"] = function (id) {
          var attrId = id.replace(runescape, funescape);
          return function (elem) {
            return elem.getAttribute("id") === attrId;
          };
        };

        Expr.find["ID"] = function (id, context) {
          if (typeof context.getElementById !== "undefined" && documentIsHTML) {
            var elem = context.getElementById(id);
            return elem ? [elem] : [];
          }
        };
      } else {
        Expr.filter["ID"] = function (id) {
          var attrId = id.replace(runescape, funescape);
          return function (elem) {
            var node = typeof elem.getAttributeNode !== "undefined" && elem.getAttributeNode("id");
            return node && node.value === attrId;
          };
        }; // Support: IE 6 - 7 only
        // getElementById is not reliable as a find shortcut


        Expr.find["ID"] = function (id, context) {
          if (typeof context.getElementById !== "undefined" && documentIsHTML) {
            var node,
                i,
                elems,
                elem = context.getElementById(id);

            if (elem) {
              // Verify the id attribute
              node = elem.getAttributeNode("id");

              if (node && node.value === id) {
                return [elem];
              } // Fall back on getElementsByName


              elems = context.getElementsByName(id);
              i = 0;

              while (elem = elems[i++]) {
                node = elem.getAttributeNode("id");

                if (node && node.value === id) {
                  return [elem];
                }
              }
            }

            return [];
          }
        };
      } // Tag


      Expr.find["TAG"] = support.getElementsByTagName ? function (tag, context) {
        if (typeof context.getElementsByTagName !== "undefined") {
          return context.getElementsByTagName(tag); // DocumentFragment nodes don't have gEBTN
        } else if (support.qsa) {
          return context.querySelectorAll(tag);
        }
      } : function (tag, context) {
        var elem,
            tmp = [],
            i = 0,
            // By happy coincidence, a (broken) gEBTN appears on DocumentFragment nodes too
        results = context.getElementsByTagName(tag); // Filter out possible comments

        if (tag === "*") {
          while (elem = results[i++]) {
            if (elem.nodeType === 1) {
              tmp.push(elem);
            }
          }

          return tmp;
        }

        return results;
      }; // Class

      Expr.find["CLASS"] = support.getElementsByClassName && function (className, context) {
        if (typeof context.getElementsByClassName !== "undefined" && documentIsHTML) {
          return context.getElementsByClassName(className);
        }
      };
      /* QSA/matchesSelector
      ---------------------------------------------------------------------- */
      // QSA and matchesSelector support
      // matchesSelector(:active) reports false when true (IE9/Opera 11.5)


      rbuggyMatches = []; // qSa(:focus) reports false when true (Chrome 21)
      // We allow this because of a bug in IE8/9 that throws an error
      // whenever `document.activeElement` is accessed on an iframe
      // So, we allow :focus to pass through QSA all the time to avoid the IE error
      // See https://bugs.jquery.com/ticket/13378

      rbuggyQSA = [];

      if (support.qsa = rnative.test(document.querySelectorAll)) {
        // Build QSA regex
        // Regex strategy adopted from Diego Perini
        assert(function (el) {
          // Select is set to empty string on purpose
          // This is to test IE's treatment of not explicitly
          // setting a boolean content attribute,
          // since its presence should be enough
          // https://bugs.jquery.com/ticket/12359
          docElem.appendChild(el).innerHTML = "<a id='" + expando + "'></a>" + "<select id='" + expando + "-\r\\' msallowcapture=''>" + "<option selected=''></option></select>"; // Support: IE8, Opera 11-12.16
          // Nothing should be selected when empty strings follow ^= or $= or *=
          // The test attribute must be unknown in Opera but "safe" for WinRT
          // https://msdn.microsoft.com/en-us/library/ie/hh465388.aspx#attribute_section

          if (el.querySelectorAll("[msallowcapture^='']").length) {
            rbuggyQSA.push("[*^$]=" + whitespace + "*(?:''|\"\")");
          } // Support: IE8
          // Boolean attributes and "value" are not treated correctly


          if (!el.querySelectorAll("[selected]").length) {
            rbuggyQSA.push("\\[" + whitespace + "*(?:value|" + booleans + ")");
          } // Support: Chrome<29, Android<4.4, Safari<7.0+, iOS<7.0+, PhantomJS<1.9.8+


          if (!el.querySelectorAll("[id~=" + expando + "-]").length) {
            rbuggyQSA.push("~=");
          } // Webkit/Opera - :checked should return selected option elements
          // http://www.w3.org/TR/2011/REC-css3-selectors-20110929/#checked
          // IE8 throws error here and will not see later tests


          if (!el.querySelectorAll(":checked").length) {
            rbuggyQSA.push(":checked");
          } // Support: Safari 8+, iOS 8+
          // https://bugs.webkit.org/show_bug.cgi?id=136851
          // In-page `selector#id sibling-combinator selector` fails


          if (!el.querySelectorAll("a#" + expando + "+*").length) {
            rbuggyQSA.push(".#.+[+~]");
          }
        });
        assert(function (el) {
          el.innerHTML = "<a href='' disabled='disabled'></a>" + "<select disabled='disabled'><option/></select>"; // Support: Windows 8 Native Apps
          // The type and name attributes are restricted during .innerHTML assignment

          var input = document.createElement("input");
          input.setAttribute("type", "hidden");
          el.appendChild(input).setAttribute("name", "D"); // Support: IE8
          // Enforce case-sensitivity of name attribute

          if (el.querySelectorAll("[name=d]").length) {
            rbuggyQSA.push("name" + whitespace + "*[*^$|!~]?=");
          } // FF 3.5 - :enabled/:disabled and hidden elements (hidden elements are still enabled)
          // IE8 throws error here and will not see later tests


          if (el.querySelectorAll(":enabled").length !== 2) {
            rbuggyQSA.push(":enabled", ":disabled");
          } // Support: IE9-11+
          // IE's :disabled selector does not pick up the children of disabled fieldsets


          docElem.appendChild(el).disabled = true;

          if (el.querySelectorAll(":disabled").length !== 2) {
            rbuggyQSA.push(":enabled", ":disabled");
          } // Opera 10-11 does not throw on post-comma invalid pseudos


          el.querySelectorAll("*,:x");
          rbuggyQSA.push(",.*:");
        });
      }

      if (support.matchesSelector = rnative.test(matches = docElem.matches || docElem.webkitMatchesSelector || docElem.mozMatchesSelector || docElem.oMatchesSelector || docElem.msMatchesSelector)) {
        assert(function (el) {
          // Check to see if it's possible to do matchesSelector
          // on a disconnected node (IE 9)
          support.disconnectedMatch = matches.call(el, "*"); // This should fail with an exception
          // Gecko does not error, returns false instead

          matches.call(el, "[s!='']:x");
          rbuggyMatches.push("!=", pseudos);
        });
      }

      rbuggyQSA = rbuggyQSA.length && new RegExp(rbuggyQSA.join("|"));
      rbuggyMatches = rbuggyMatches.length && new RegExp(rbuggyMatches.join("|"));
      /* Contains
      ---------------------------------------------------------------------- */

      hasCompare = rnative.test(docElem.compareDocumentPosition); // Element contains another
      // Purposefully self-exclusive
      // As in, an element does not contain itself

      contains = hasCompare || rnative.test(docElem.contains) ? function (a, b) {
        var adown = a.nodeType === 9 ? a.documentElement : a,
            bup = b && b.parentNode;
        return a === bup || !!(bup && bup.nodeType === 1 && (adown.contains ? adown.contains(bup) : a.compareDocumentPosition && a.compareDocumentPosition(bup) & 16));
      } : function (a, b) {
        if (b) {
          while (b = b.parentNode) {
            if (b === a) {
              return true;
            }
          }
        }

        return false;
      };
      /* Sorting
      ---------------------------------------------------------------------- */
      // Document order sorting

      sortOrder = hasCompare ? function (a, b) {
        // Flag for duplicate removal
        if (a === b) {
          hasDuplicate = true;
          return 0;
        } // Sort on method existence if only one input has compareDocumentPosition


        var compare = !a.compareDocumentPosition - !b.compareDocumentPosition;

        if (compare) {
          return compare;
        } // Calculate position if both inputs belong to the same document


        compare = (a.ownerDocument || a) === (b.ownerDocument || b) ? a.compareDocumentPosition(b) : // Otherwise we know they are disconnected
        1; // Disconnected nodes

        if (compare & 1 || !support.sortDetached && b.compareDocumentPosition(a) === compare) {
          // Choose the first element that is related to our preferred document
          if (a === document || a.ownerDocument === preferredDoc && contains(preferredDoc, a)) {
            return -1;
          }

          if (b === document || b.ownerDocument === preferredDoc && contains(preferredDoc, b)) {
            return 1;
          } // Maintain original order


          return sortInput ? indexOf(sortInput, a) - indexOf(sortInput, b) : 0;
        }

        return compare & 4 ? -1 : 1;
      } : function (a, b) {
        // Exit early if the nodes are identical
        if (a === b) {
          hasDuplicate = true;
          return 0;
        }

        var cur,
            i = 0,
            aup = a.parentNode,
            bup = b.parentNode,
            ap = [a],
            bp = [b]; // Parentless nodes are either documents or disconnected

        if (!aup || !bup) {
          return a === document ? -1 : b === document ? 1 : aup ? -1 : bup ? 1 : sortInput ? indexOf(sortInput, a) - indexOf(sortInput, b) : 0; // If the nodes are siblings, we can do a quick check
        } else if (aup === bup) {
          return siblingCheck(a, b);
        } // Otherwise we need full lists of their ancestors for comparison


        cur = a;

        while (cur = cur.parentNode) {
          ap.unshift(cur);
        }

        cur = b;

        while (cur = cur.parentNode) {
          bp.unshift(cur);
        } // Walk down the tree looking for a discrepancy


        while (ap[i] === bp[i]) {
          i++;
        }

        return i ? // Do a sibling check if the nodes have a common ancestor
        siblingCheck(ap[i], bp[i]) : // Otherwise nodes in our document sort first
        ap[i] === preferredDoc ? -1 : bp[i] === preferredDoc ? 1 : 0;
      };
      return document;
    };

    Sizzle.matches = function (expr, elements) {
      return Sizzle(expr, null, null, elements);
    };

    Sizzle.matchesSelector = function (elem, expr) {
      // Set document vars if needed
      if ((elem.ownerDocument || elem) !== document) {
        setDocument(elem);
      } // Make sure that attribute selectors are quoted


      expr = expr.replace(rattributeQuotes, "='$1']");

      if (support.matchesSelector && documentIsHTML && !compilerCache[expr + " "] && (!rbuggyMatches || !rbuggyMatches.test(expr)) && (!rbuggyQSA || !rbuggyQSA.test(expr))) {
        try {
          var ret = matches.call(elem, expr); // IE 9's matchesSelector returns false on disconnected nodes

          if (ret || support.disconnectedMatch || // As well, disconnected nodes are said to be in a document
          // fragment in IE 9
          elem.document && elem.document.nodeType !== 11) {
            return ret;
          }
        } catch (e) {}
      }

      return Sizzle(expr, document, null, [elem]).length > 0;
    };

    Sizzle.contains = function (context, elem) {
      // Set document vars if needed
      if ((context.ownerDocument || context) !== document) {
        setDocument(context);
      }

      return contains(context, elem);
    };

    Sizzle.attr = function (elem, name) {
      // Set document vars if needed
      if ((elem.ownerDocument || elem) !== document) {
        setDocument(elem);
      }

      var fn = Expr.attrHandle[name.toLowerCase()],
          // Don't get fooled by Object.prototype properties (jQuery #13807)
      val = fn && hasOwn.call(Expr.attrHandle, name.toLowerCase()) ? fn(elem, name, !documentIsHTML) : undefined;
      return val !== undefined ? val : support.attributes || !documentIsHTML ? elem.getAttribute(name) : (val = elem.getAttributeNode(name)) && val.specified ? val.value : null;
    };

    Sizzle.escape = function (sel) {
      return (sel + "").replace(rcssescape, fcssescape);
    };

    Sizzle.error = function (msg) {
      throw new Error("Syntax error, unrecognized expression: " + msg);
    };
    /**
     * Document sorting and removing duplicates
     * @param {ArrayLike} results
     */


    Sizzle.uniqueSort = function (results) {
      var elem,
          duplicates = [],
          j = 0,
          i = 0; // Unless we *know* we can detect duplicates, assume their presence

      hasDuplicate = !support.detectDuplicates;
      sortInput = !support.sortStable && results.slice(0);
      results.sort(sortOrder);

      if (hasDuplicate) {
        while (elem = results[i++]) {
          if (elem === results[i]) {
            j = duplicates.push(i);
          }
        }

        while (j--) {
          results.splice(duplicates[j], 1);
        }
      } // Clear input after sorting to release objects
      // See https://github.com/jquery/sizzle/pull/225


      sortInput = null;
      return results;
    };
    /**
     * Utility function for retrieving the text value of an array of DOM nodes
     * @param {Array|Element} elem
     */


    getText = Sizzle.getText = function (elem) {
      var node,
          ret = "",
          i = 0,
          nodeType = elem.nodeType;

      if (!nodeType) {
        // If no nodeType, this is expected to be an array
        while (node = elem[i++]) {
          // Do not traverse comment nodes
          ret += getText(node);
        }
      } else if (nodeType === 1 || nodeType === 9 || nodeType === 11) {
        // Use textContent for elements
        // innerText usage removed for consistency of new lines (jQuery #11153)
        if (typeof elem.textContent === "string") {
          return elem.textContent;
        } else {
          // Traverse its children
          for (elem = elem.firstChild; elem; elem = elem.nextSibling) {
            ret += getText(elem);
          }
        }
      } else if (nodeType === 3 || nodeType === 4) {
        return elem.nodeValue;
      } // Do not include comment or processing instruction nodes


      return ret;
    };

    Expr = Sizzle.selectors = {
      // Can be adjusted by the user
      cacheLength: 50,
      createPseudo: markFunction,
      match: matchExpr,
      attrHandle: {},
      find: {},
      relative: {
        ">": {
          dir: "parentNode",
          first: true
        },
        " ": {
          dir: "parentNode"
        },
        "+": {
          dir: "previousSibling",
          first: true
        },
        "~": {
          dir: "previousSibling"
        }
      },
      preFilter: {
        "ATTR": function ATTR(match) {
          match[1] = match[1].replace(runescape, funescape); // Move the given value to match[3] whether quoted or unquoted

          match[3] = (match[3] || match[4] || match[5] || "").replace(runescape, funescape);

          if (match[2] === "~=") {
            match[3] = " " + match[3] + " ";
          }

          return match.slice(0, 4);
        },
        "CHILD": function CHILD(match) {
          /* matches from matchExpr["CHILD"]
          	1 type (only|nth|...)
          	2 what (child|of-type)
          	3 argument (even|odd|\d*|\d*n([+-]\d+)?|...)
          	4 xn-component of xn+y argument ([+-]?\d*n|)
          	5 sign of xn-component
          	6 x of xn-component
          	7 sign of y-component
          	8 y of y-component
          */
          match[1] = match[1].toLowerCase();

          if (match[1].slice(0, 3) === "nth") {
            // nth-* requires argument
            if (!match[3]) {
              Sizzle.error(match[0]);
            } // numeric x and y parameters for Expr.filter.CHILD
            // remember that false/true cast respectively to 0/1


            match[4] = +(match[4] ? match[5] + (match[6] || 1) : 2 * (match[3] === "even" || match[3] === "odd"));
            match[5] = +(match[7] + match[8] || match[3] === "odd"); // other types prohibit arguments
          } else if (match[3]) {
            Sizzle.error(match[0]);
          }

          return match;
        },
        "PSEUDO": function PSEUDO(match) {
          var excess,
              unquoted = !match[6] && match[2];

          if (matchExpr["CHILD"].test(match[0])) {
            return null;
          } // Accept quoted arguments as-is


          if (match[3]) {
            match[2] = match[4] || match[5] || ""; // Strip excess characters from unquoted arguments
          } else if (unquoted && rpseudo.test(unquoted) && ( // Get excess from tokenize (recursively)
          excess = tokenize(unquoted, true)) && ( // advance to the next closing parenthesis
          excess = unquoted.indexOf(")", unquoted.length - excess) - unquoted.length)) {
            // excess is a negative index
            match[0] = match[0].slice(0, excess);
            match[2] = unquoted.slice(0, excess);
          } // Return only captures needed by the pseudo filter method (type and argument)


          return match.slice(0, 3);
        }
      },
      filter: {
        "TAG": function TAG(nodeNameSelector) {
          var nodeName = nodeNameSelector.replace(runescape, funescape).toLowerCase();
          return nodeNameSelector === "*" ? function () {
            return true;
          } : function (elem) {
            return elem.nodeName && elem.nodeName.toLowerCase() === nodeName;
          };
        },
        "CLASS": function CLASS(className) {
          var pattern = classCache[className + " "];
          return pattern || (pattern = new RegExp("(^|" + whitespace + ")" + className + "(" + whitespace + "|$)")) && classCache(className, function (elem) {
            return pattern.test(typeof elem.className === "string" && elem.className || typeof elem.getAttribute !== "undefined" && elem.getAttribute("class") || "");
          });
        },
        "ATTR": function ATTR(name, operator, check) {
          return function (elem) {
            var result = Sizzle.attr(elem, name);

            if (result == null) {
              return operator === "!=";
            }

            if (!operator) {
              return true;
            }

            result += "";
            return operator === "=" ? result === check : operator === "!=" ? result !== check : operator === "^=" ? check && result.indexOf(check) === 0 : operator === "*=" ? check && result.indexOf(check) > -1 : operator === "$=" ? check && result.slice(-check.length) === check : operator === "~=" ? (" " + result.replace(rwhitespace, " ") + " ").indexOf(check) > -1 : operator === "|=" ? result === check || result.slice(0, check.length + 1) === check + "-" : false;
          };
        },
        "CHILD": function CHILD(type, what, argument, first, last) {
          var simple = type.slice(0, 3) !== "nth",
              forward = type.slice(-4) !== "last",
              ofType = what === "of-type";
          return first === 1 && last === 0 ? // Shortcut for :nth-*(n)
          function (elem) {
            return !!elem.parentNode;
          } : function (elem, context, xml) {
            var cache,
                uniqueCache,
                outerCache,
                node,
                nodeIndex,
                start,
                dir = simple !== forward ? "nextSibling" : "previousSibling",
                parent = elem.parentNode,
                name = ofType && elem.nodeName.toLowerCase(),
                useCache = !xml && !ofType,
                diff = false;

            if (parent) {
              // :(first|last|only)-(child|of-type)
              if (simple) {
                while (dir) {
                  node = elem;

                  while (node = node[dir]) {
                    if (ofType ? node.nodeName.toLowerCase() === name : node.nodeType === 1) {
                      return false;
                    }
                  } // Reverse direction for :only-* (if we haven't yet done so)


                  start = dir = type === "only" && !start && "nextSibling";
                }

                return true;
              }

              start = [forward ? parent.firstChild : parent.lastChild]; // non-xml :nth-child(...) stores cache data on `parent`

              if (forward && useCache) {
                // Seek `elem` from a previously-cached index
                // ...in a gzip-friendly way
                node = parent;
                outerCache = node[expando] || (node[expando] = {}); // Support: IE <9 only
                // Defend against cloned attroperties (jQuery gh-1709)

                uniqueCache = outerCache[node.uniqueID] || (outerCache[node.uniqueID] = {});
                cache = uniqueCache[type] || [];
                nodeIndex = cache[0] === dirruns && cache[1];
                diff = nodeIndex && cache[2];
                node = nodeIndex && parent.childNodes[nodeIndex];

                while (node = ++nodeIndex && node && node[dir] || ( // Fallback to seeking `elem` from the start
                diff = nodeIndex = 0) || start.pop()) {
                  // When found, cache indexes on `parent` and break
                  if (node.nodeType === 1 && ++diff && node === elem) {
                    uniqueCache[type] = [dirruns, nodeIndex, diff];
                    break;
                  }
                }
              } else {
                // Use previously-cached element index if available
                if (useCache) {
                  // ...in a gzip-friendly way
                  node = elem;
                  outerCache = node[expando] || (node[expando] = {}); // Support: IE <9 only
                  // Defend against cloned attroperties (jQuery gh-1709)

                  uniqueCache = outerCache[node.uniqueID] || (outerCache[node.uniqueID] = {});
                  cache = uniqueCache[type] || [];
                  nodeIndex = cache[0] === dirruns && cache[1];
                  diff = nodeIndex;
                } // xml :nth-child(...)
                // or :nth-last-child(...) or :nth(-last)?-of-type(...)


                if (diff === false) {
                  // Use the same loop as above to seek `elem` from the start
                  while (node = ++nodeIndex && node && node[dir] || (diff = nodeIndex = 0) || start.pop()) {
                    if ((ofType ? node.nodeName.toLowerCase() === name : node.nodeType === 1) && ++diff) {
                      // Cache the index of each encountered element
                      if (useCache) {
                        outerCache = node[expando] || (node[expando] = {}); // Support: IE <9 only
                        // Defend against cloned attroperties (jQuery gh-1709)

                        uniqueCache = outerCache[node.uniqueID] || (outerCache[node.uniqueID] = {});
                        uniqueCache[type] = [dirruns, diff];
                      }

                      if (node === elem) {
                        break;
                      }
                    }
                  }
                }
              } // Incorporate the offset, then check against cycle size


              diff -= last;
              return diff === first || diff % first === 0 && diff / first >= 0;
            }
          };
        },
        "PSEUDO": function PSEUDO(pseudo, argument) {
          // pseudo-class names are case-insensitive
          // http://www.w3.org/TR/selectors/#pseudo-classes
          // Prioritize by case sensitivity in case custom pseudos are added with uppercase letters
          // Remember that setFilters inherits from pseudos
          var args,
              fn = Expr.pseudos[pseudo] || Expr.setFilters[pseudo.toLowerCase()] || Sizzle.error("unsupported pseudo: " + pseudo); // The user may use createPseudo to indicate that
          // arguments are needed to create the filter function
          // just as Sizzle does

          if (fn[expando]) {
            return fn(argument);
          } // But maintain support for old signatures


          if (fn.length > 1) {
            args = [pseudo, pseudo, "", argument];
            return Expr.setFilters.hasOwnProperty(pseudo.toLowerCase()) ? markFunction(function (seed, matches) {
              var idx,
                  matched = fn(seed, argument),
                  i = matched.length;

              while (i--) {
                idx = indexOf(seed, matched[i]);
                seed[idx] = !(matches[idx] = matched[i]);
              }
            }) : function (elem) {
              return fn(elem, 0, args);
            };
          }

          return fn;
        }
      },
      pseudos: {
        // Potentially complex pseudos
        "not": markFunction(function (selector) {
          // Trim the selector passed to compile
          // to avoid treating leading and trailing
          // spaces as combinators
          var input = [],
              results = [],
              matcher = compile(selector.replace(rtrim, "$1"));
          return matcher[expando] ? markFunction(function (seed, matches, context, xml) {
            var elem,
                unmatched = matcher(seed, null, xml, []),
                i = seed.length; // Match elements unmatched by `matcher`

            while (i--) {
              if (elem = unmatched[i]) {
                seed[i] = !(matches[i] = elem);
              }
            }
          }) : function (elem, context, xml) {
            input[0] = elem;
            matcher(input, null, xml, results); // Don't keep the element (issue #299)

            input[0] = null;
            return !results.pop();
          };
        }),
        "has": markFunction(function (selector) {
          return function (elem) {
            return Sizzle(selector, elem).length > 0;
          };
        }),
        "contains": markFunction(function (text) {
          text = text.replace(runescape, funescape);
          return function (elem) {
            return (elem.textContent || elem.innerText || getText(elem)).indexOf(text) > -1;
          };
        }),
        // "Whether an element is represented by a :lang() selector
        // is based solely on the element's language value
        // being equal to the identifier C,
        // or beginning with the identifier C immediately followed by "-".
        // The matching of C against the element's language value is performed case-insensitively.
        // The identifier C does not have to be a valid language name."
        // http://www.w3.org/TR/selectors/#lang-pseudo
        "lang": markFunction(function (lang) {
          // lang value must be a valid identifier
          if (!ridentifier.test(lang || "")) {
            Sizzle.error("unsupported lang: " + lang);
          }

          lang = lang.replace(runescape, funescape).toLowerCase();
          return function (elem) {
            var elemLang;

            do {
              if (elemLang = documentIsHTML ? elem.lang : elem.getAttribute("xml:lang") || elem.getAttribute("lang")) {
                elemLang = elemLang.toLowerCase();
                return elemLang === lang || elemLang.indexOf(lang + "-") === 0;
              }
            } while ((elem = elem.parentNode) && elem.nodeType === 1);

            return false;
          };
        }),
        // Miscellaneous
        "target": function target(elem) {
          var hash = window.location && window.location.hash;
          return hash && hash.slice(1) === elem.id;
        },
        "root": function root(elem) {
          return elem === docElem;
        },
        "focus": function focus(elem) {
          return elem === document.activeElement && (!document.hasFocus || document.hasFocus()) && !!(elem.type || elem.href || ~elem.tabIndex);
        },
        // Boolean properties
        "enabled": createDisabledPseudo(false),
        "disabled": createDisabledPseudo(true),
        "checked": function checked(elem) {
          // In CSS3, :checked should return both checked and selected elements
          // http://www.w3.org/TR/2011/REC-css3-selectors-20110929/#checked
          var nodeName = elem.nodeName.toLowerCase();
          return nodeName === "input" && !!elem.checked || nodeName === "option" && !!elem.selected;
        },
        "selected": function selected(elem) {
          // Accessing this property makes selected-by-default
          // options in Safari work properly
          if (elem.parentNode) {
            elem.parentNode.selectedIndex;
          }

          return elem.selected === true;
        },
        // Contents
        "empty": function empty(elem) {
          // http://www.w3.org/TR/selectors/#empty-pseudo
          // :empty is negated by element (1) or content nodes (text: 3; cdata: 4; entity ref: 5),
          //   but not by others (comment: 8; processing instruction: 7; etc.)
          // nodeType < 6 works because attributes (2) do not appear as children
          for (elem = elem.firstChild; elem; elem = elem.nextSibling) {
            if (elem.nodeType < 6) {
              return false;
            }
          }

          return true;
        },
        "parent": function parent(elem) {
          return !Expr.pseudos["empty"](elem);
        },
        // Element/input types
        "header": function header(elem) {
          return rheader.test(elem.nodeName);
        },
        "input": function input(elem) {
          return rinputs.test(elem.nodeName);
        },
        "button": function button(elem) {
          var name = elem.nodeName.toLowerCase();
          return name === "input" && elem.type === "button" || name === "button";
        },
        "text": function text(elem) {
          var attr;
          return elem.nodeName.toLowerCase() === "input" && elem.type === "text" && ( // Support: IE<8
          // New HTML5 attribute values (e.g., "search") appear with elem.type === "text"
          (attr = elem.getAttribute("type")) == null || attr.toLowerCase() === "text");
        },
        // Position-in-collection
        "first": createPositionalPseudo(function () {
          return [0];
        }),
        "last": createPositionalPseudo(function (matchIndexes, length) {
          return [length - 1];
        }),
        "eq": createPositionalPseudo(function (matchIndexes, length, argument) {
          return [argument < 0 ? argument + length : argument];
        }),
        "even": createPositionalPseudo(function (matchIndexes, length) {
          var i = 0;

          for (; i < length; i += 2) {
            matchIndexes.push(i);
          }

          return matchIndexes;
        }),
        "odd": createPositionalPseudo(function (matchIndexes, length) {
          var i = 1;

          for (; i < length; i += 2) {
            matchIndexes.push(i);
          }

          return matchIndexes;
        }),
        "lt": createPositionalPseudo(function (matchIndexes, length, argument) {
          var i = argument < 0 ? argument + length : argument;

          for (; --i >= 0;) {
            matchIndexes.push(i);
          }

          return matchIndexes;
        }),
        "gt": createPositionalPseudo(function (matchIndexes, length, argument) {
          var i = argument < 0 ? argument + length : argument;

          for (; ++i < length;) {
            matchIndexes.push(i);
          }

          return matchIndexes;
        })
      }
    };
    Expr.pseudos["nth"] = Expr.pseudos["eq"]; // Add button/input type pseudos

    for (i in {
      radio: true,
      checkbox: true,
      file: true,
      password: true,
      image: true
    }) {
      Expr.pseudos[i] = createInputPseudo(i);
    }

    for (i in {
      submit: true,
      reset: true
    }) {
      Expr.pseudos[i] = createButtonPseudo(i);
    } // Easy API for creating new setFilters


    function setFilters() {}

    setFilters.prototype = Expr.filters = Expr.pseudos;
    Expr.setFilters = new setFilters();

    tokenize = Sizzle.tokenize = function (selector, parseOnly) {
      var matched,
          match,
          tokens,
          type,
          soFar,
          groups,
          preFilters,
          cached = tokenCache[selector + " "];

      if (cached) {
        return parseOnly ? 0 : cached.slice(0);
      }

      soFar = selector;
      groups = [];
      preFilters = Expr.preFilter;

      while (soFar) {
        // Comma and first run
        if (!matched || (match = rcomma.exec(soFar))) {
          if (match) {
            // Don't consume trailing commas as valid
            soFar = soFar.slice(match[0].length) || soFar;
          }

          groups.push(tokens = []);
        }

        matched = false; // Combinators

        if (match = rcombinators.exec(soFar)) {
          matched = match.shift();
          tokens.push({
            value: matched,
            // Cast descendant combinators to space
            type: match[0].replace(rtrim, " ")
          });
          soFar = soFar.slice(matched.length);
        } // Filters


        for (type in Expr.filter) {
          if ((match = matchExpr[type].exec(soFar)) && (!preFilters[type] || (match = preFilters[type](match)))) {
            matched = match.shift();
            tokens.push({
              value: matched,
              type: type,
              matches: match
            });
            soFar = soFar.slice(matched.length);
          }
        }

        if (!matched) {
          break;
        }
      } // Return the length of the invalid excess
      // if we're just parsing
      // Otherwise, throw an error or return tokens


      return parseOnly ? soFar.length : soFar ? Sizzle.error(selector) : // Cache the tokens
      tokenCache(selector, groups).slice(0);
    };

    function toSelector(tokens) {
      var i = 0,
          len = tokens.length,
          selector = "";

      for (; i < len; i++) {
        selector += tokens[i].value;
      }

      return selector;
    }

    function addCombinator(matcher, combinator, base) {
      var dir = combinator.dir,
          skip = combinator.next,
          key = skip || dir,
          checkNonElements = base && key === "parentNode",
          doneName = done++;
      return combinator.first ? // Check against closest ancestor/preceding element
      function (elem, context, xml) {
        while (elem = elem[dir]) {
          if (elem.nodeType === 1 || checkNonElements) {
            return matcher(elem, context, xml);
          }
        }

        return false;
      } : // Check against all ancestor/preceding elements
      function (elem, context, xml) {
        var oldCache,
            uniqueCache,
            outerCache,
            newCache = [dirruns, doneName]; // We can't set arbitrary data on XML nodes, so they don't benefit from combinator caching

        if (xml) {
          while (elem = elem[dir]) {
            if (elem.nodeType === 1 || checkNonElements) {
              if (matcher(elem, context, xml)) {
                return true;
              }
            }
          }
        } else {
          while (elem = elem[dir]) {
            if (elem.nodeType === 1 || checkNonElements) {
              outerCache = elem[expando] || (elem[expando] = {}); // Support: IE <9 only
              // Defend against cloned attroperties (jQuery gh-1709)

              uniqueCache = outerCache[elem.uniqueID] || (outerCache[elem.uniqueID] = {});

              if (skip && skip === elem.nodeName.toLowerCase()) {
                elem = elem[dir] || elem;
              } else if ((oldCache = uniqueCache[key]) && oldCache[0] === dirruns && oldCache[1] === doneName) {
                // Assign to newCache so results back-propagate to previous elements
                return newCache[2] = oldCache[2];
              } else {
                // Reuse newcache so results back-propagate to previous elements
                uniqueCache[key] = newCache; // A match means we're done; a fail means we have to keep checking

                if (newCache[2] = matcher(elem, context, xml)) {
                  return true;
                }
              }
            }
          }
        }

        return false;
      };
    }

    function elementMatcher(matchers) {
      return matchers.length > 1 ? function (elem, context, xml) {
        var i = matchers.length;

        while (i--) {
          if (!matchers[i](elem, context, xml)) {
            return false;
          }
        }

        return true;
      } : matchers[0];
    }

    function multipleContexts(selector, contexts, results) {
      var i = 0,
          len = contexts.length;

      for (; i < len; i++) {
        Sizzle(selector, contexts[i], results);
      }

      return results;
    }

    function condense(unmatched, map, filter, context, xml) {
      var elem,
          newUnmatched = [],
          i = 0,
          len = unmatched.length,
          mapped = map != null;

      for (; i < len; i++) {
        if (elem = unmatched[i]) {
          if (!filter || filter(elem, context, xml)) {
            newUnmatched.push(elem);

            if (mapped) {
              map.push(i);
            }
          }
        }
      }

      return newUnmatched;
    }

    function setMatcher(preFilter, selector, matcher, postFilter, postFinder, postSelector) {
      if (postFilter && !postFilter[expando]) {
        postFilter = setMatcher(postFilter);
      }

      if (postFinder && !postFinder[expando]) {
        postFinder = setMatcher(postFinder, postSelector);
      }

      return markFunction(function (seed, results, context, xml) {
        var temp,
            i,
            elem,
            preMap = [],
            postMap = [],
            preexisting = results.length,
            // Get initial elements from seed or context
        elems = seed || multipleContexts(selector || "*", context.nodeType ? [context] : context, []),
            // Prefilter to get matcher input, preserving a map for seed-results synchronization
        matcherIn = preFilter && (seed || !selector) ? condense(elems, preMap, preFilter, context, xml) : elems,
            matcherOut = matcher ? // If we have a postFinder, or filtered seed, or non-seed postFilter or preexisting results,
        postFinder || (seed ? preFilter : preexisting || postFilter) ? // ...intermediate processing is necessary
        [] : // ...otherwise use results directly
        results : matcherIn; // Find primary matches

        if (matcher) {
          matcher(matcherIn, matcherOut, context, xml);
        } // Apply postFilter


        if (postFilter) {
          temp = condense(matcherOut, postMap);
          postFilter(temp, [], context, xml); // Un-match failing elements by moving them back to matcherIn

          i = temp.length;

          while (i--) {
            if (elem = temp[i]) {
              matcherOut[postMap[i]] = !(matcherIn[postMap[i]] = elem);
            }
          }
        }

        if (seed) {
          if (postFinder || preFilter) {
            if (postFinder) {
              // Get the final matcherOut by condensing this intermediate into postFinder contexts
              temp = [];
              i = matcherOut.length;

              while (i--) {
                if (elem = matcherOut[i]) {
                  // Restore matcherIn since elem is not yet a final match
                  temp.push(matcherIn[i] = elem);
                }
              }

              postFinder(null, matcherOut = [], temp, xml);
            } // Move matched elements from seed to results to keep them synchronized


            i = matcherOut.length;

            while (i--) {
              if ((elem = matcherOut[i]) && (temp = postFinder ? indexOf(seed, elem) : preMap[i]) > -1) {
                seed[temp] = !(results[temp] = elem);
              }
            }
          } // Add elements to results, through postFinder if defined

        } else {
          matcherOut = condense(matcherOut === results ? matcherOut.splice(preexisting, matcherOut.length) : matcherOut);

          if (postFinder) {
            postFinder(null, results, matcherOut, xml);
          } else {
            push.apply(results, matcherOut);
          }
        }
      });
    }

    function matcherFromTokens(tokens) {
      var checkContext,
          matcher,
          j,
          len = tokens.length,
          leadingRelative = Expr.relative[tokens[0].type],
          implicitRelative = leadingRelative || Expr.relative[" "],
          i = leadingRelative ? 1 : 0,
          // The foundational matcher ensures that elements are reachable from top-level context(s)
      matchContext = addCombinator(function (elem) {
        return elem === checkContext;
      }, implicitRelative, true),
          matchAnyContext = addCombinator(function (elem) {
        return indexOf(checkContext, elem) > -1;
      }, implicitRelative, true),
          matchers = [function (elem, context, xml) {
        var ret = !leadingRelative && (xml || context !== outermostContext) || ((checkContext = context).nodeType ? matchContext(elem, context, xml) : matchAnyContext(elem, context, xml)); // Avoid hanging onto element (issue #299)

        checkContext = null;
        return ret;
      }];

      for (; i < len; i++) {
        if (matcher = Expr.relative[tokens[i].type]) {
          matchers = [addCombinator(elementMatcher(matchers), matcher)];
        } else {
          matcher = Expr.filter[tokens[i].type].apply(null, tokens[i].matches); // Return special upon seeing a positional matcher

          if (matcher[expando]) {
            // Find the next relative operator (if any) for proper handling
            j = ++i;

            for (; j < len; j++) {
              if (Expr.relative[tokens[j].type]) {
                break;
              }
            }

            return setMatcher(i > 1 && elementMatcher(matchers), i > 1 && toSelector( // If the preceding token was a descendant combinator, insert an implicit any-element `*`
            tokens.slice(0, i - 1).concat({
              value: tokens[i - 2].type === " " ? "*" : ""
            })).replace(rtrim, "$1"), matcher, i < j && matcherFromTokens(tokens.slice(i, j)), j < len && matcherFromTokens(tokens = tokens.slice(j)), j < len && toSelector(tokens));
          }

          matchers.push(matcher);
        }
      }

      return elementMatcher(matchers);
    }

    function matcherFromGroupMatchers(elementMatchers, setMatchers) {
      var bySet = setMatchers.length > 0,
          byElement = elementMatchers.length > 0,
          superMatcher = function superMatcher(seed, context, xml, results, outermost) {
        var elem,
            j,
            matcher,
            matchedCount = 0,
            i = "0",
            unmatched = seed && [],
            setMatched = [],
            contextBackup = outermostContext,
            // We must always have either seed elements or outermost context
        elems = seed || byElement && Expr.find["TAG"]("*", outermost),
            // Use integer dirruns iff this is the outermost matcher
        dirrunsUnique = dirruns += contextBackup == null ? 1 : Math.random() || 0.1,
            len = elems.length;

        if (outermost) {
          outermostContext = context === document || context || outermost;
        } // Add elements passing elementMatchers directly to results
        // Support: IE<9, Safari
        // Tolerate NodeList properties (IE: "length"; Safari: <number>) matching elements by id


        for (; i !== len && (elem = elems[i]) != null; i++) {
          if (byElement && elem) {
            j = 0;

            if (!context && elem.ownerDocument !== document) {
              setDocument(elem);
              xml = !documentIsHTML;
            }

            while (matcher = elementMatchers[j++]) {
              if (matcher(elem, context || document, xml)) {
                results.push(elem);
                break;
              }
            }

            if (outermost) {
              dirruns = dirrunsUnique;
            }
          } // Track unmatched elements for set filters


          if (bySet) {
            // They will have gone through all possible matchers
            if (elem = !matcher && elem) {
              matchedCount--;
            } // Lengthen the array for every element, matched or not


            if (seed) {
              unmatched.push(elem);
            }
          }
        } // `i` is now the count of elements visited above, and adding it to `matchedCount`
        // makes the latter nonnegative.


        matchedCount += i; // Apply set filters to unmatched elements
        // NOTE: This can be skipped if there are no unmatched elements (i.e., `matchedCount`
        // equals `i`), unless we didn't visit _any_ elements in the above loop because we have
        // no element matchers and no seed.
        // Incrementing an initially-string "0" `i` allows `i` to remain a string only in that
        // case, which will result in a "00" `matchedCount` that differs from `i` but is also
        // numerically zero.

        if (bySet && i !== matchedCount) {
          j = 0;

          while (matcher = setMatchers[j++]) {
            matcher(unmatched, setMatched, context, xml);
          }

          if (seed) {
            // Reintegrate element matches to eliminate the need for sorting
            if (matchedCount > 0) {
              while (i--) {
                if (!(unmatched[i] || setMatched[i])) {
                  setMatched[i] = pop.call(results);
                }
              }
            } // Discard index placeholder values to get only actual matches


            setMatched = condense(setMatched);
          } // Add matches to results


          push.apply(results, setMatched); // Seedless set matches succeeding multiple successful matchers stipulate sorting

          if (outermost && !seed && setMatched.length > 0 && matchedCount + setMatchers.length > 1) {
            Sizzle.uniqueSort(results);
          }
        } // Override manipulation of globals by nested matchers


        if (outermost) {
          dirruns = dirrunsUnique;
          outermostContext = contextBackup;
        }

        return unmatched;
      };

      return bySet ? markFunction(superMatcher) : superMatcher;
    }

    compile = Sizzle.compile = function (selector, match
    /* Internal Use Only */
    ) {
      var i,
          setMatchers = [],
          elementMatchers = [],
          cached = compilerCache[selector + " "];

      if (!cached) {
        // Generate a function of recursive functions that can be used to check each element
        if (!match) {
          match = tokenize(selector);
        }

        i = match.length;

        while (i--) {
          cached = matcherFromTokens(match[i]);

          if (cached[expando]) {
            setMatchers.push(cached);
          } else {
            elementMatchers.push(cached);
          }
        } // Cache the compiled function


        cached = compilerCache(selector, matcherFromGroupMatchers(elementMatchers, setMatchers)); // Save selector and tokenization

        cached.selector = selector;
      }

      return cached;
    };
    /**
     * A low-level selection function that works with Sizzle's compiled
     *  selector functions
     * @param {String|Function} selector A selector or a pre-compiled
     *  selector function built with Sizzle.compile
     * @param {Element} context
     * @param {Array} [results]
     * @param {Array} [seed] A set of elements to match against
     */


    select = Sizzle.select = function (selector, context, results, seed) {
      var i,
          tokens,
          token,
          type,
          find,
          compiled = typeof selector === "function" && selector,
          match = !seed && tokenize(selector = compiled.selector || selector);
      results = results || []; // Try to minimize operations if there is only one selector in the list and no seed
      // (the latter of which guarantees us context)

      if (match.length === 1) {
        // Reduce context if the leading compound selector is an ID
        tokens = match[0] = match[0].slice(0);

        if (tokens.length > 2 && (token = tokens[0]).type === "ID" && context.nodeType === 9 && documentIsHTML && Expr.relative[tokens[1].type]) {
          context = (Expr.find["ID"](token.matches[0].replace(runescape, funescape), context) || [])[0];

          if (!context) {
            return results; // Precompiled matchers will still verify ancestry, so step up a level
          } else if (compiled) {
            context = context.parentNode;
          }

          selector = selector.slice(tokens.shift().value.length);
        } // Fetch a seed set for right-to-left matching


        i = matchExpr["needsContext"].test(selector) ? 0 : tokens.length;

        while (i--) {
          token = tokens[i]; // Abort if we hit a combinator

          if (Expr.relative[type = token.type]) {
            break;
          }

          if (find = Expr.find[type]) {
            // Search, expanding context for leading sibling combinators
            if (seed = find(token.matches[0].replace(runescape, funescape), rsibling.test(tokens[0].type) && testContext(context.parentNode) || context)) {
              // If seed is empty or no tokens remain, we can return early
              tokens.splice(i, 1);
              selector = seed.length && toSelector(tokens);

              if (!selector) {
                push.apply(results, seed);
                return results;
              }

              break;
            }
          }
        }
      } // Compile and execute a filtering function if one is not provided
      // Provide `match` to avoid retokenization if we modified the selector above


      (compiled || compile(selector, match))(seed, context, !documentIsHTML, results, !context || rsibling.test(selector) && testContext(context.parentNode) || context);
      return results;
    }; // One-time assignments
    // Sort stability


    support.sortStable = expando.split("").sort(sortOrder).join("") === expando; // Support: Chrome 14-35+
    // Always assume duplicates if they aren't passed to the comparison function

    support.detectDuplicates = !!hasDuplicate; // Initialize against the default document

    setDocument(); // Support: Webkit<537.32 - Safari 6.0.3/Chrome 25 (fixed in Chrome 27)
    // Detached nodes confoundingly follow *each other*

    support.sortDetached = assert(function (el) {
      // Should return 1, but returns 4 (following)
      return el.compareDocumentPosition(document.createElement("fieldset")) & 1;
    }); // Support: IE<8
    // Prevent attribute/property "interpolation"
    // https://msdn.microsoft.com/en-us/library/ms536429%28VS.85%29.aspx

    if (!assert(function (el) {
      el.innerHTML = "<a href='#'></a>";
      return el.firstChild.getAttribute("href") === "#";
    })) {
      addHandle("type|href|height|width", function (elem, name, isXML) {
        if (!isXML) {
          return elem.getAttribute(name, name.toLowerCase() === "type" ? 1 : 2);
        }
      });
    } // Support: IE<9
    // Use defaultValue in place of getAttribute("value")


    if (!support.attributes || !assert(function (el) {
      el.innerHTML = "<input/>";
      el.firstChild.setAttribute("value", "");
      return el.firstChild.getAttribute("value") === "";
    })) {
      addHandle("value", function (elem, name, isXML) {
        if (!isXML && elem.nodeName.toLowerCase() === "input") {
          return elem.defaultValue;
        }
      });
    } // Support: IE<9
    // Use getAttributeNode to fetch booleans when getAttribute lies


    if (!assert(function (el) {
      return el.getAttribute("disabled") == null;
    })) {
      addHandle(booleans, function (elem, name, isXML) {
        var val;

        if (!isXML) {
          return elem[name] === true ? name.toLowerCase() : (val = elem.getAttributeNode(name)) && val.specified ? val.value : null;
        }
      });
    }

    return Sizzle;
  }(window);

  jQuery.find = Sizzle;
  jQuery.expr = Sizzle.selectors; // Deprecated

  jQuery.expr[":"] = jQuery.expr.pseudos;
  jQuery.uniqueSort = jQuery.unique = Sizzle.uniqueSort;
  jQuery.text = Sizzle.getText;
  jQuery.isXMLDoc = Sizzle.isXML;
  jQuery.contains = Sizzle.contains;
  jQuery.escapeSelector = Sizzle.escape;

  var dir = function dir(elem, _dir, until) {
    var matched = [],
        truncate = until !== undefined;

    while ((elem = elem[_dir]) && elem.nodeType !== 9) {
      if (elem.nodeType === 1) {
        if (truncate && jQuery(elem).is(until)) {
          break;
        }

        matched.push(elem);
      }
    }

    return matched;
  };

  var _siblings = function siblings(n, elem) {
    var matched = [];

    for (; n; n = n.nextSibling) {
      if (n.nodeType === 1 && n !== elem) {
        matched.push(n);
      }
    }

    return matched;
  };

  var rneedsContext = jQuery.expr.match.needsContext;
  var rsingleTag = /^<([a-z][^\/\0>:\x20\t\r\n\f]*)[\x20\t\r\n\f]*\/?>(?:<\/\1>|)$/i;
  var risSimple = /^.[^:#\[\.,]*$/; // Implement the identical functionality for filter and not

  function winnow(elements, qualifier, not) {
    if (jQuery.isFunction(qualifier)) {
      return jQuery.grep(elements, function (elem, i) {
        return !!qualifier.call(elem, i, elem) !== not;
      });
    } // Single element


    if (qualifier.nodeType) {
      return jQuery.grep(elements, function (elem) {
        return elem === qualifier !== not;
      });
    } // Arraylike of elements (jQuery, arguments, Array)


    if (typeof qualifier !== "string") {
      return jQuery.grep(elements, function (elem) {
        return indexOf.call(qualifier, elem) > -1 !== not;
      });
    } // Simple selector that can be filtered directly, removing non-Elements


    if (risSimple.test(qualifier)) {
      return jQuery.filter(qualifier, elements, not);
    } // Complex selector, compare the two sets, removing non-Elements


    qualifier = jQuery.filter(qualifier, elements);
    return jQuery.grep(elements, function (elem) {
      return indexOf.call(qualifier, elem) > -1 !== not && elem.nodeType === 1;
    });
  }

  jQuery.filter = function (expr, elems, not) {
    var elem = elems[0];

    if (not) {
      expr = ":not(" + expr + ")";
    }

    if (elems.length === 1 && elem.nodeType === 1) {
      return jQuery.find.matchesSelector(elem, expr) ? [elem] : [];
    }

    return jQuery.find.matches(expr, jQuery.grep(elems, function (elem) {
      return elem.nodeType === 1;
    }));
  };

  jQuery.fn.extend({
    find: function find(selector) {
      var i,
          ret,
          len = this.length,
          self = this;

      if (typeof selector !== "string") {
        return this.pushStack(jQuery(selector).filter(function () {
          for (i = 0; i < len; i++) {
            if (jQuery.contains(self[i], this)) {
              return true;
            }
          }
        }));
      }

      ret = this.pushStack([]);

      for (i = 0; i < len; i++) {
        jQuery.find(selector, self[i], ret);
      }

      return len > 1 ? jQuery.uniqueSort(ret) : ret;
    },
    filter: function filter(selector) {
      return this.pushStack(winnow(this, selector || [], false));
    },
    not: function not(selector) {
      return this.pushStack(winnow(this, selector || [], true));
    },
    is: function is(selector) {
      return !!winnow(this, // If this is a positional/relative selector, check membership in the returned set
      // so $("p:first").is("p:last") won't return true for a doc with two "p".
      typeof selector === "string" && rneedsContext.test(selector) ? jQuery(selector) : selector || [], false).length;
    }
  }); // Initialize a jQuery object
  // A central reference to the root jQuery(document)

  var rootjQuery,
      // A simple way to check for HTML strings
  // Prioritize #id over <tag> to avoid XSS via location.hash (#9521)
  // Strict HTML recognition (#11290: must start with <)
  // Shortcut simple #id case for speed
  rquickExpr = /^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]+))$/,
      init = jQuery.fn.init = function (selector, context, root) {
    var match, elem; // HANDLE: $(""), $(null), $(undefined), $(false)

    if (!selector) {
      return this;
    } // Method init() accepts an alternate rootjQuery
    // so migrate can support jQuery.sub (gh-2101)


    root = root || rootjQuery; // Handle HTML strings

    if (typeof selector === "string") {
      if (selector[0] === "<" && selector[selector.length - 1] === ">" && selector.length >= 3) {
        // Assume that strings that start and end with <> are HTML and skip the regex check
        match = [null, selector, null];
      } else {
        match = rquickExpr.exec(selector);
      } // Match html or make sure no context is specified for #id


      if (match && (match[1] || !context)) {
        // HANDLE: $(html) -> $(array)
        if (match[1]) {
          context = context instanceof jQuery ? context[0] : context; // Option to run scripts is true for back-compat
          // Intentionally let the error be thrown if parseHTML is not present

          jQuery.merge(this, jQuery.parseHTML(match[1], context && context.nodeType ? context.ownerDocument || context : document, true)); // HANDLE: $(html, props)

          if (rsingleTag.test(match[1]) && jQuery.isPlainObject(context)) {
            for (match in context) {
              // Properties of context are called as methods if possible
              if (jQuery.isFunction(this[match])) {
                this[match](context[match]); // ...and otherwise set as attributes
              } else {
                this.attr(match, context[match]);
              }
            }
          }

          return this; // HANDLE: $(#id)
        } else {
          elem = document.getElementById(match[2]);

          if (elem) {
            // Inject the element directly into the jQuery object
            this[0] = elem;
            this.length = 1;
          }

          return this;
        } // HANDLE: $(expr, $(...))

      } else if (!context || context.jquery) {
        return (context || root).find(selector); // HANDLE: $(expr, context)
        // (which is just equivalent to: $(context).find(expr)
      } else {
        return this.constructor(context).find(selector);
      } // HANDLE: $(DOMElement)

    } else if (selector.nodeType) {
      this[0] = selector;
      this.length = 1;
      return this; // HANDLE: $(function)
      // Shortcut for document ready
    } else if (jQuery.isFunction(selector)) {
      return root.ready !== undefined ? root.ready(selector) : // Execute immediately if ready is not present
      selector(jQuery);
    }

    return jQuery.makeArray(selector, this);
  }; // Give the init function the jQuery prototype for later instantiation


  init.prototype = jQuery.fn; // Initialize central reference

  rootjQuery = jQuery(document);
  var rparentsprev = /^(?:parents|prev(?:Until|All))/,
      // Methods guaranteed to produce a unique set when starting from a unique set
  guaranteedUnique = {
    children: true,
    contents: true,
    next: true,
    prev: true
  };
  jQuery.fn.extend({
    has: function has(target) {
      var targets = jQuery(target, this),
          l = targets.length;
      return this.filter(function () {
        var i = 0;

        for (; i < l; i++) {
          if (jQuery.contains(this, targets[i])) {
            return true;
          }
        }
      });
    },
    closest: function closest(selectors, context) {
      var cur,
          i = 0,
          l = this.length,
          matched = [],
          targets = typeof selectors !== "string" && jQuery(selectors); // Positional selectors never match, since there's no _selection_ context

      if (!rneedsContext.test(selectors)) {
        for (; i < l; i++) {
          for (cur = this[i]; cur && cur !== context; cur = cur.parentNode) {
            // Always skip document fragments
            if (cur.nodeType < 11 && (targets ? targets.index(cur) > -1 : // Don't pass non-elements to Sizzle
            cur.nodeType === 1 && jQuery.find.matchesSelector(cur, selectors))) {
              matched.push(cur);
              break;
            }
          }
        }
      }

      return this.pushStack(matched.length > 1 ? jQuery.uniqueSort(matched) : matched);
    },
    // Determine the position of an element within the set
    index: function index(elem) {
      // No argument, return index in parent
      if (!elem) {
        return this[0] && this[0].parentNode ? this.first().prevAll().length : -1;
      } // Index in selector


      if (typeof elem === "string") {
        return indexOf.call(jQuery(elem), this[0]);
      } // Locate the position of the desired element


      return indexOf.call(this, // If it receives a jQuery object, the first element is used
      elem.jquery ? elem[0] : elem);
    },
    add: function add(selector, context) {
      return this.pushStack(jQuery.uniqueSort(jQuery.merge(this.get(), jQuery(selector, context))));
    },
    addBack: function addBack(selector) {
      return this.add(selector == null ? this.prevObject : this.prevObject.filter(selector));
    }
  });

  function sibling(cur, dir) {
    while ((cur = cur[dir]) && cur.nodeType !== 1) {}

    return cur;
  }

  jQuery.each({
    parent: function parent(elem) {
      var parent = elem.parentNode;
      return parent && parent.nodeType !== 11 ? parent : null;
    },
    parents: function parents(elem) {
      return dir(elem, "parentNode");
    },
    parentsUntil: function parentsUntil(elem, i, until) {
      return dir(elem, "parentNode", until);
    },
    next: function next(elem) {
      return sibling(elem, "nextSibling");
    },
    prev: function prev(elem) {
      return sibling(elem, "previousSibling");
    },
    nextAll: function nextAll(elem) {
      return dir(elem, "nextSibling");
    },
    prevAll: function prevAll(elem) {
      return dir(elem, "previousSibling");
    },
    nextUntil: function nextUntil(elem, i, until) {
      return dir(elem, "nextSibling", until);
    },
    prevUntil: function prevUntil(elem, i, until) {
      return dir(elem, "previousSibling", until);
    },
    siblings: function siblings(elem) {
      return _siblings((elem.parentNode || {}).firstChild, elem);
    },
    children: function children(elem) {
      return _siblings(elem.firstChild);
    },
    contents: function contents(elem) {
      return elem.contentDocument || jQuery.merge([], elem.childNodes);
    }
  }, function (name, fn) {
    jQuery.fn[name] = function (until, selector) {
      var matched = jQuery.map(this, fn, until);

      if (name.slice(-5) !== "Until") {
        selector = until;
      }

      if (selector && typeof selector === "string") {
        matched = jQuery.filter(selector, matched);
      }

      if (this.length > 1) {
        // Remove duplicates
        if (!guaranteedUnique[name]) {
          jQuery.uniqueSort(matched);
        } // Reverse order for parents* and prev-derivatives


        if (rparentsprev.test(name)) {
          matched.reverse();
        }
      }

      return this.pushStack(matched);
    };
  });
  var rnothtmlwhite = /[^\x20\t\r\n\f]+/g; // Convert String-formatted options into Object-formatted ones

  function createOptions(options) {
    var object = {};
    jQuery.each(options.match(rnothtmlwhite) || [], function (_, flag) {
      object[flag] = true;
    });
    return object;
  }
  /*
   * Create a callback list using the following parameters:
   *
   *	options: an optional list of space-separated options that will change how
   *			the callback list behaves or a more traditional option object
   *
   * By default a callback list will act like an event callback list and can be
   * "fired" multiple times.
   *
   * Possible options:
   *
   *	once:			will ensure the callback list can only be fired once (like a Deferred)
   *
   *	memory:			will keep track of previous values and will call any callback added
   *					after the list has been fired right away with the latest "memorized"
   *					values (like a Deferred)
   *
   *	unique:			will ensure a callback can only be added once (no duplicate in the list)
   *
   *	stopOnFalse:	interrupt callings when a callback returns false
   *
   */


  jQuery.Callbacks = function (options) {
    // Convert options from String-formatted to Object-formatted if needed
    // (we check in cache first)
    options = typeof options === "string" ? createOptions(options) : jQuery.extend({}, options);

    var // Flag to know if list is currently firing
    firing,
        // Last fire value for non-forgettable lists
    memory,
        // Flag to know if list was already fired
    _fired,
        // Flag to prevent firing
    _locked,
        // Actual callback list
    list = [],
        // Queue of execution data for repeatable lists
    queue = [],
        // Index of currently firing callback (modified by add/remove as needed)
    firingIndex = -1,
        // Fire callbacks
    fire = function fire() {
      // Enforce single-firing
      _locked = options.once; // Execute callbacks for all pending executions,
      // respecting firingIndex overrides and runtime changes

      _fired = firing = true;

      for (; queue.length; firingIndex = -1) {
        memory = queue.shift();

        while (++firingIndex < list.length) {
          // Run callback and check for early termination
          if (list[firingIndex].apply(memory[0], memory[1]) === false && options.stopOnFalse) {
            // Jump to end and forget the data so .add doesn't re-fire
            firingIndex = list.length;
            memory = false;
          }
        }
      } // Forget the data if we're done with it


      if (!options.memory) {
        memory = false;
      }

      firing = false; // Clean up if we're done firing for good

      if (_locked) {
        // Keep an empty list if we have data for future add calls
        if (memory) {
          list = []; // Otherwise, this object is spent
        } else {
          list = "";
        }
      }
    },
        // Actual Callbacks object
    self = {
      // Add a callback or a collection of callbacks to the list
      add: function add() {
        if (list) {
          // If we have memory from a past run, we should fire after adding
          if (memory && !firing) {
            firingIndex = list.length - 1;
            queue.push(memory);
          }

          (function add(args) {
            jQuery.each(args, function (_, arg) {
              if (jQuery.isFunction(arg)) {
                if (!options.unique || !self.has(arg)) {
                  list.push(arg);
                }
              } else if (arg && arg.length && jQuery.type(arg) !== "string") {
                // Inspect recursively
                add(arg);
              }
            });
          })(arguments);

          if (memory && !firing) {
            fire();
          }
        }

        return this;
      },
      // Remove a callback from the list
      remove: function remove() {
        jQuery.each(arguments, function (_, arg) {
          var index;

          while ((index = jQuery.inArray(arg, list, index)) > -1) {
            list.splice(index, 1); // Handle firing indexes

            if (index <= firingIndex) {
              firingIndex--;
            }
          }
        });
        return this;
      },
      // Check if a given callback is in the list.
      // If no argument is given, return whether or not list has callbacks attached.
      has: function has(fn) {
        return fn ? jQuery.inArray(fn, list) > -1 : list.length > 0;
      },
      // Remove all callbacks from the list
      empty: function empty() {
        if (list) {
          list = [];
        }

        return this;
      },
      // Disable .fire and .add
      // Abort any current/pending executions
      // Clear all callbacks and values
      disable: function disable() {
        _locked = queue = [];
        list = memory = "";
        return this;
      },
      disabled: function disabled() {
        return !list;
      },
      // Disable .fire
      // Also disable .add unless we have memory (since it would have no effect)
      // Abort any pending executions
      lock: function lock() {
        _locked = queue = [];

        if (!memory && !firing) {
          list = memory = "";
        }

        return this;
      },
      locked: function locked() {
        return !!_locked;
      },
      // Call all callbacks with the given context and arguments
      fireWith: function fireWith(context, args) {
        if (!_locked) {
          args = args || [];
          args = [context, args.slice ? args.slice() : args];
          queue.push(args);

          if (!firing) {
            fire();
          }
        }

        return this;
      },
      // Call all the callbacks with the given arguments
      fire: function fire() {
        self.fireWith(this, arguments);
        return this;
      },
      // To know if the callbacks have already been called at least once
      fired: function fired() {
        return !!_fired;
      }
    };

    return self;
  };

  function Identity(v) {
    return v;
  }

  function Thrower(ex) {
    throw ex;
  }

  function adoptValue(value, resolve, reject) {
    var method;

    try {
      // Check for promise aspect first to privilege synchronous behavior
      if (value && jQuery.isFunction(method = value.promise)) {
        method.call(value).done(resolve).fail(reject); // Other thenables
      } else if (value && jQuery.isFunction(method = value.then)) {
        method.call(value, resolve, reject); // Other non-thenables
      } else {
        // Support: Android 4.0 only
        // Strict mode functions invoked without .call/.apply get global-object context
        resolve.call(undefined, value);
      } // For Promises/A+, convert exceptions into rejections
      // Since jQuery.when doesn't unwrap thenables, we can skip the extra checks appearing in
      // Deferred#then to conditionally suppress rejection.

    } catch (value) {
      // Support: Android 4.0 only
      // Strict mode functions invoked without .call/.apply get global-object context
      reject.call(undefined, value);
    }
  }

  jQuery.extend({
    Deferred: function Deferred(func) {
      var tuples = [// action, add listener, callbacks,
      // ... .then handlers, argument index, [final state]
      ["notify", "progress", jQuery.Callbacks("memory"), jQuery.Callbacks("memory"), 2], ["resolve", "done", jQuery.Callbacks("once memory"), jQuery.Callbacks("once memory"), 0, "resolved"], ["reject", "fail", jQuery.Callbacks("once memory"), jQuery.Callbacks("once memory"), 1, "rejected"]],
          _state = "pending",
          _promise = {
        state: function state() {
          return _state;
        },
        always: function always() {
          deferred.done(arguments).fail(arguments);
          return this;
        },
        "catch": function _catch(fn) {
          return _promise.then(null, fn);
        },
        // Keep pipe for back-compat
        pipe: function pipe()
        /* fnDone, fnFail, fnProgress */
        {
          var fns = arguments;
          return jQuery.Deferred(function (newDefer) {
            jQuery.each(tuples, function (i, tuple) {
              // Map tuples (progress, done, fail) to arguments (done, fail, progress)
              var fn = jQuery.isFunction(fns[tuple[4]]) && fns[tuple[4]]; // deferred.progress(function() { bind to newDefer or newDefer.notify })
              // deferred.done(function() { bind to newDefer or newDefer.resolve })
              // deferred.fail(function() { bind to newDefer or newDefer.reject })

              deferred[tuple[1]](function () {
                var returned = fn && fn.apply(this, arguments);

                if (returned && jQuery.isFunction(returned.promise)) {
                  returned.promise().progress(newDefer.notify).done(newDefer.resolve).fail(newDefer.reject);
                } else {
                  newDefer[tuple[0] + "With"](this, fn ? [returned] : arguments);
                }
              });
            });
            fns = null;
          }).promise();
        },
        then: function then(onFulfilled, onRejected, onProgress) {
          var maxDepth = 0;

          function resolve(depth, deferred, handler, special) {
            return function () {
              var that = this,
                  args = arguments,
                  mightThrow = function mightThrow() {
                var returned, then; // Support: Promises/A+ section 2.3.3.3.3
                // https://promisesaplus.com/#point-59
                // Ignore double-resolution attempts

                if (depth < maxDepth) {
                  return;
                }

                returned = handler.apply(that, args); // Support: Promises/A+ section 2.3.1
                // https://promisesaplus.com/#point-48

                if (returned === deferred.promise()) {
                  throw new TypeError("Thenable self-resolution");
                } // Support: Promises/A+ sections 2.3.3.1, 3.5
                // https://promisesaplus.com/#point-54
                // https://promisesaplus.com/#point-75
                // Retrieve `then` only once


                then = returned && ( // Support: Promises/A+ section 2.3.4
                // https://promisesaplus.com/#point-64
                // Only check objects and functions for thenability
                _typeof(returned) === "object" || typeof returned === "function") && returned.then; // Handle a returned thenable

                if (jQuery.isFunction(then)) {
                  // Special processors (notify) just wait for resolution
                  if (special) {
                    then.call(returned, resolve(maxDepth, deferred, Identity, special), resolve(maxDepth, deferred, Thrower, special)); // Normal processors (resolve) also hook into progress
                  } else {
                    // ...and disregard older resolution values
                    maxDepth++;
                    then.call(returned, resolve(maxDepth, deferred, Identity, special), resolve(maxDepth, deferred, Thrower, special), resolve(maxDepth, deferred, Identity, deferred.notifyWith));
                  } // Handle all other returned values

                } else {
                  // Only substitute handlers pass on context
                  // and multiple values (non-spec behavior)
                  if (handler !== Identity) {
                    that = undefined;
                    args = [returned];
                  } // Process the value(s)
                  // Default process is resolve


                  (special || deferred.resolveWith)(that, args);
                }
              },
                  // Only normal processors (resolve) catch and reject exceptions
              process = special ? mightThrow : function () {
                try {
                  mightThrow();
                } catch (e) {
                  if (jQuery.Deferred.exceptionHook) {
                    jQuery.Deferred.exceptionHook(e, process.stackTrace);
                  } // Support: Promises/A+ section 2.3.3.3.4.1
                  // https://promisesaplus.com/#point-61
                  // Ignore post-resolution exceptions


                  if (depth + 1 >= maxDepth) {
                    // Only substitute handlers pass on context
                    // and multiple values (non-spec behavior)
                    if (handler !== Thrower) {
                      that = undefined;
                      args = [e];
                    }

                    deferred.rejectWith(that, args);
                  }
                }
              }; // Support: Promises/A+ section 2.3.3.3.1
              // https://promisesaplus.com/#point-57
              // Re-resolve promises immediately to dodge false rejection from
              // subsequent errors


              if (depth) {
                process();
              } else {
                // Call an optional hook to record the stack, in case of exception
                // since it's otherwise lost when execution goes async
                if (jQuery.Deferred.getStackHook) {
                  process.stackTrace = jQuery.Deferred.getStackHook();
                }

                window.setTimeout(process);
              }
            };
          }

          return jQuery.Deferred(function (newDefer) {
            // progress_handlers.add( ... )
            tuples[0][3].add(resolve(0, newDefer, jQuery.isFunction(onProgress) ? onProgress : Identity, newDefer.notifyWith)); // fulfilled_handlers.add( ... )

            tuples[1][3].add(resolve(0, newDefer, jQuery.isFunction(onFulfilled) ? onFulfilled : Identity)); // rejected_handlers.add( ... )

            tuples[2][3].add(resolve(0, newDefer, jQuery.isFunction(onRejected) ? onRejected : Thrower));
          }).promise();
        },
        // Get a promise for this deferred
        // If obj is provided, the promise aspect is added to the object
        promise: function promise(obj) {
          return obj != null ? jQuery.extend(obj, _promise) : _promise;
        }
      },
          deferred = {}; // Add list-specific methods

      jQuery.each(tuples, function (i, tuple) {
        var list = tuple[2],
            stateString = tuple[5]; // promise.progress = list.add
        // promise.done = list.add
        // promise.fail = list.add

        _promise[tuple[1]] = list.add; // Handle state

        if (stateString) {
          list.add(function () {
            // state = "resolved" (i.e., fulfilled)
            // state = "rejected"
            _state = stateString;
          }, // rejected_callbacks.disable
          // fulfilled_callbacks.disable
          tuples[3 - i][2].disable, // progress_callbacks.lock
          tuples[0][2].lock);
        } // progress_handlers.fire
        // fulfilled_handlers.fire
        // rejected_handlers.fire


        list.add(tuple[3].fire); // deferred.notify = function() { deferred.notifyWith(...) }
        // deferred.resolve = function() { deferred.resolveWith(...) }
        // deferred.reject = function() { deferred.rejectWith(...) }

        deferred[tuple[0]] = function () {
          deferred[tuple[0] + "With"](this === deferred ? undefined : this, arguments);
          return this;
        }; // deferred.notifyWith = list.fireWith
        // deferred.resolveWith = list.fireWith
        // deferred.rejectWith = list.fireWith


        deferred[tuple[0] + "With"] = list.fireWith;
      }); // Make the deferred a promise

      _promise.promise(deferred); // Call given func if any


      if (func) {
        func.call(deferred, deferred);
      } // All done!


      return deferred;
    },
    // Deferred helper
    when: function when(singleValue) {
      var // count of uncompleted subordinates
      remaining = arguments.length,
          // count of unprocessed arguments
      i = remaining,
          // subordinate fulfillment data
      resolveContexts = Array(i),
          resolveValues = _slice.call(arguments),
          // the master Deferred
      master = jQuery.Deferred(),
          // subordinate callback factory
      updateFunc = function updateFunc(i) {
        return function (value) {
          resolveContexts[i] = this;
          resolveValues[i] = arguments.length > 1 ? _slice.call(arguments) : value;

          if (! --remaining) {
            master.resolveWith(resolveContexts, resolveValues);
          }
        };
      }; // Single- and empty arguments are adopted like Promise.resolve


      if (remaining <= 1) {
        adoptValue(singleValue, master.done(updateFunc(i)).resolve, master.reject); // Use .then() to unwrap secondary thenables (cf. gh-3000)

        if (master.state() === "pending" || jQuery.isFunction(resolveValues[i] && resolveValues[i].then)) {
          return master.then();
        }
      } // Multiple arguments are aggregated like Promise.all array elements


      while (i--) {
        adoptValue(resolveValues[i], updateFunc(i), master.reject);
      }

      return master.promise();
    }
  }); // These usually indicate a programmer mistake during development,
  // warn about them ASAP rather than swallowing them by default.

  var rerrorNames = /^(Eval|Internal|Range|Reference|Syntax|Type|URI)Error$/;

  jQuery.Deferred.exceptionHook = function (error, stack) {
    // Support: IE 8 - 9 only
    // Console exists when dev tools are open, which can happen at any time
    if (window.console && window.console.warn && error && rerrorNames.test(error.name)) {
      window.console.warn("jQuery.Deferred exception: " + error.message, error.stack, stack);
    }
  };

  jQuery.readyException = function (error) {
    window.setTimeout(function () {
      throw error;
    });
  }; // The deferred used on DOM ready


  var readyList = jQuery.Deferred();

  jQuery.fn.ready = function (fn) {
    readyList.then(fn) // Wrap jQuery.readyException in a function so that the lookup
    // happens at the time of error handling instead of callback
    // registration.
    .catch(function (error) {
      jQuery.readyException(error);
    });
    return this;
  };

  jQuery.extend({
    // Is the DOM ready to be used? Set to true once it occurs.
    isReady: false,
    // A counter to track how many items to wait for before
    // the ready event fires. See #6781
    readyWait: 1,
    // Hold (or release) the ready event
    holdReady: function holdReady(hold) {
      if (hold) {
        jQuery.readyWait++;
      } else {
        jQuery.ready(true);
      }
    },
    // Handle when the DOM is ready
    ready: function ready(wait) {
      // Abort if there are pending holds or we're already ready
      if (wait === true ? --jQuery.readyWait : jQuery.isReady) {
        return;
      } // Remember that the DOM is ready


      jQuery.isReady = true; // If a normal DOM Ready event fired, decrement, and wait if need be

      if (wait !== true && --jQuery.readyWait > 0) {
        return;
      } // If there are functions bound, to execute


      readyList.resolveWith(document, [jQuery]);
    }
  });
  jQuery.ready.then = readyList.then; // The ready event handler and self cleanup method

  function completed() {
    document.removeEventListener("DOMContentLoaded", completed);
    window.removeEventListener("load", completed);
    jQuery.ready();
  } // Catch cases where $(document).ready() is called
  // after the browser event has already occurred.
  // Support: IE <=9 - 10 only
  // Older IE sometimes signals "interactive" too soon


  if (document.readyState === "complete" || document.readyState !== "loading" && !document.documentElement.doScroll) {
    // Handle it asynchronously to allow scripts the opportunity to delay ready
    window.setTimeout(jQuery.ready);
  } else {
    // Use the handy event callback
    document.addEventListener("DOMContentLoaded", completed); // A fallback to window.onload, that will always work

    window.addEventListener("load", completed);
  } // Multifunctional method to get and set values of a collection
  // The value/s can optionally be executed if it's a function


  var access = function access(elems, fn, key, value, chainable, emptyGet, raw) {
    var i = 0,
        len = elems.length,
        bulk = key == null; // Sets many values

    if (jQuery.type(key) === "object") {
      chainable = true;

      for (i in key) {
        access(elems, fn, i, key[i], true, emptyGet, raw);
      } // Sets one value

    } else if (value !== undefined) {
      chainable = true;

      if (!jQuery.isFunction(value)) {
        raw = true;
      }

      if (bulk) {
        // Bulk operations run against the entire set
        if (raw) {
          fn.call(elems, value);
          fn = null; // ...except when executing function values
        } else {
          bulk = fn;

          fn = function fn(elem, key, value) {
            return bulk.call(jQuery(elem), value);
          };
        }
      }

      if (fn) {
        for (; i < len; i++) {
          fn(elems[i], key, raw ? value : value.call(elems[i], i, fn(elems[i], key)));
        }
      }
    }

    if (chainable) {
      return elems;
    } // Gets


    if (bulk) {
      return fn.call(elems);
    }

    return len ? fn(elems[0], key) : emptyGet;
  };

  var acceptData = function acceptData(owner) {
    // Accepts only:
    //  - Node
    //    - Node.ELEMENT_NODE
    //    - Node.DOCUMENT_NODE
    //  - Object
    //    - Any
    return owner.nodeType === 1 || owner.nodeType === 9 || !+owner.nodeType;
  };

  function Data() {
    this.expando = jQuery.expando + Data.uid++;
  }

  Data.uid = 1;
  Data.prototype = {
    cache: function cache(owner) {
      // Check if the owner object already has a cache
      var value = owner[this.expando]; // If not, create one

      if (!value) {
        value = {}; // We can accept data for non-element nodes in modern browsers,
        // but we should not, see #8335.
        // Always return an empty object.

        if (acceptData(owner)) {
          // If it is a node unlikely to be stringify-ed or looped over
          // use plain assignment
          if (owner.nodeType) {
            owner[this.expando] = value; // Otherwise secure it in a non-enumerable property
            // configurable must be true to allow the property to be
            // deleted when data is removed
          } else {
            Object.defineProperty(owner, this.expando, {
              value: value,
              configurable: true
            });
          }
        }
      }

      return value;
    },
    set: function set(owner, data, value) {
      var prop,
          cache = this.cache(owner); // Handle: [ owner, key, value ] args
      // Always use camelCase key (gh-2257)

      if (typeof data === "string") {
        cache[jQuery.camelCase(data)] = value; // Handle: [ owner, { properties } ] args
      } else {
        // Copy the properties one-by-one to the cache object
        for (prop in data) {
          cache[jQuery.camelCase(prop)] = data[prop];
        }
      }

      return cache;
    },
    get: function get(owner, key) {
      return key === undefined ? this.cache(owner) : // Always use camelCase key (gh-2257)
      owner[this.expando] && owner[this.expando][jQuery.camelCase(key)];
    },
    access: function access(owner, key, value) {
      // In cases where either:
      //
      //   1. No key was specified
      //   2. A string key was specified, but no value provided
      //
      // Take the "read" path and allow the get method to determine
      // which value to return, respectively either:
      //
      //   1. The entire cache object
      //   2. The data stored at the key
      //
      if (key === undefined || key && typeof key === "string" && value === undefined) {
        return this.get(owner, key);
      } // When the key is not a string, or both a key and value
      // are specified, set or extend (existing objects) with either:
      //
      //   1. An object of properties
      //   2. A key and value
      //


      this.set(owner, key, value); // Since the "set" path can have two possible entry points
      // return the expected data based on which path was taken[*]

      return value !== undefined ? value : key;
    },
    remove: function remove(owner, key) {
      var i,
          cache = owner[this.expando];

      if (cache === undefined) {
        return;
      }

      if (key !== undefined) {
        // Support array or space separated string of keys
        if (jQuery.isArray(key)) {
          // If key is an array of keys...
          // We always set camelCase keys, so remove that.
          key = key.map(jQuery.camelCase);
        } else {
          key = jQuery.camelCase(key); // If a key with the spaces exists, use it.
          // Otherwise, create an array by matching non-whitespace

          key = key in cache ? [key] : key.match(rnothtmlwhite) || [];
        }

        i = key.length;

        while (i--) {
          delete cache[key[i]];
        }
      } // Remove the expando if there's no more data


      if (key === undefined || jQuery.isEmptyObject(cache)) {
        // Support: Chrome <=35 - 45
        // Webkit & Blink performance suffers when deleting properties
        // from DOM nodes, so set to undefined instead
        // https://bugs.chromium.org/p/chromium/issues/detail?id=378607 (bug restricted)
        if (owner.nodeType) {
          owner[this.expando] = undefined;
        } else {
          delete owner[this.expando];
        }
      }
    },
    hasData: function hasData(owner) {
      var cache = owner[this.expando];
      return cache !== undefined && !jQuery.isEmptyObject(cache);
    }
  };
  var dataPriv = new Data();
  var dataUser = new Data(); //	Implementation Summary
  //
  //	1. Enforce API surface and semantic compatibility with 1.9.x branch
  //	2. Improve the module's maintainability by reducing the storage
  //		paths to a single mechanism.
  //	3. Use the same single mechanism to support "private" and "user" data.
  //	4. _Never_ expose "private" data to user code (TODO: Drop _data, _removeData)
  //	5. Avoid exposing implementation details on user objects (eg. expando properties)
  //	6. Provide a clear path for implementation upgrade to WeakMap in 2014

  var rbrace = /^(?:\{[\w\W]*\}|\[[\w\W]*\])$/,
      rmultiDash = /[A-Z]/g;

  function getData(data) {
    if (data === "true") {
      return true;
    }

    if (data === "false") {
      return false;
    }

    if (data === "null") {
      return null;
    } // Only convert to a number if it doesn't change the string


    if (data === +data + "") {
      return +data;
    }

    if (rbrace.test(data)) {
      return JSON.parse(data);
    }

    return data;
  }

  function dataAttr(elem, key, data) {
    var name; // If nothing was found internally, try to fetch any
    // data from the HTML5 data-* attribute

    if (data === undefined && elem.nodeType === 1) {
      name = "data-" + key.replace(rmultiDash, "-$&").toLowerCase();
      data = elem.getAttribute(name);

      if (typeof data === "string") {
        try {
          data = getData(data);
        } catch (e) {} // Make sure we set the data so it isn't changed later


        dataUser.set(elem, key, data);
      } else {
        data = undefined;
      }
    }

    return data;
  }

  jQuery.extend({
    hasData: function hasData(elem) {
      return dataUser.hasData(elem) || dataPriv.hasData(elem);
    },
    data: function data(elem, name, _data) {
      return dataUser.access(elem, name, _data);
    },
    removeData: function removeData(elem, name) {
      dataUser.remove(elem, name);
    },
    // TODO: Now that all calls to _data and _removeData have been replaced
    // with direct calls to dataPriv methods, these can be deprecated.
    _data: function _data(elem, name, data) {
      return dataPriv.access(elem, name, data);
    },
    _removeData: function _removeData(elem, name) {
      dataPriv.remove(elem, name);
    }
  });
  jQuery.fn.extend({
    data: function data(key, value) {
      var i,
          name,
          data,
          elem = this[0],
          attrs = elem && elem.attributes; // Gets all values

      if (key === undefined) {
        if (this.length) {
          data = dataUser.get(elem);

          if (elem.nodeType === 1 && !dataPriv.get(elem, "hasDataAttrs")) {
            i = attrs.length;

            while (i--) {
              // Support: IE 11 only
              // The attrs elements can be null (#14894)
              if (attrs[i]) {
                name = attrs[i].name;

                if (name.indexOf("data-") === 0) {
                  name = jQuery.camelCase(name.slice(5));
                  dataAttr(elem, name, data[name]);
                }
              }
            }

            dataPriv.set(elem, "hasDataAttrs", true);
          }
        }

        return data;
      } // Sets multiple values


      if (_typeof(key) === "object") {
        return this.each(function () {
          dataUser.set(this, key);
        });
      }

      return access(this, function (value) {
        var data; // The calling jQuery object (element matches) is not empty
        // (and therefore has an element appears at this[ 0 ]) and the
        // `value` parameter was not undefined. An empty jQuery object
        // will result in `undefined` for elem = this[ 0 ] which will
        // throw an exception if an attempt to read a data cache is made.

        if (elem && value === undefined) {
          // Attempt to get data from the cache
          // The key will always be camelCased in Data
          data = dataUser.get(elem, key);

          if (data !== undefined) {
            return data;
          } // Attempt to "discover" the data in
          // HTML5 custom data-* attrs


          data = dataAttr(elem, key);

          if (data !== undefined) {
            return data;
          } // We tried really hard, but the data doesn't exist.


          return;
        } // Set the data...


        this.each(function () {
          // We always store the camelCased key
          dataUser.set(this, key, value);
        });
      }, null, value, arguments.length > 1, null, true);
    },
    removeData: function removeData(key) {
      return this.each(function () {
        dataUser.remove(this, key);
      });
    }
  });
  jQuery.extend({
    queue: function queue(elem, type, data) {
      var queue;

      if (elem) {
        type = (type || "fx") + "queue";
        queue = dataPriv.get(elem, type); // Speed up dequeue by getting out quickly if this is just a lookup

        if (data) {
          if (!queue || jQuery.isArray(data)) {
            queue = dataPriv.access(elem, type, jQuery.makeArray(data));
          } else {
            queue.push(data);
          }
        }

        return queue || [];
      }
    },
    dequeue: function dequeue(elem, type) {
      type = type || "fx";

      var queue = jQuery.queue(elem, type),
          startLength = queue.length,
          fn = queue.shift(),
          hooks = jQuery._queueHooks(elem, type),
          next = function next() {
        jQuery.dequeue(elem, type);
      }; // If the fx queue is dequeued, always remove the progress sentinel


      if (fn === "inprogress") {
        fn = queue.shift();
        startLength--;
      }

      if (fn) {
        // Add a progress sentinel to prevent the fx queue from being
        // automatically dequeued
        if (type === "fx") {
          queue.unshift("inprogress");
        } // Clear up the last queue stop function


        delete hooks.stop;
        fn.call(elem, next, hooks);
      }

      if (!startLength && hooks) {
        hooks.empty.fire();
      }
    },
    // Not public - generate a queueHooks object, or return the current one
    _queueHooks: function _queueHooks(elem, type) {
      var key = type + "queueHooks";
      return dataPriv.get(elem, key) || dataPriv.access(elem, key, {
        empty: jQuery.Callbacks("once memory").add(function () {
          dataPriv.remove(elem, [type + "queue", key]);
        })
      });
    }
  });
  jQuery.fn.extend({
    queue: function queue(type, data) {
      var setter = 2;

      if (typeof type !== "string") {
        data = type;
        type = "fx";
        setter--;
      }

      if (arguments.length < setter) {
        return jQuery.queue(this[0], type);
      }

      return data === undefined ? this : this.each(function () {
        var queue = jQuery.queue(this, type, data); // Ensure a hooks for this queue

        jQuery._queueHooks(this, type);

        if (type === "fx" && queue[0] !== "inprogress") {
          jQuery.dequeue(this, type);
        }
      });
    },
    dequeue: function dequeue(type) {
      return this.each(function () {
        jQuery.dequeue(this, type);
      });
    },
    clearQueue: function clearQueue(type) {
      return this.queue(type || "fx", []);
    },
    // Get a promise resolved when queues of a certain type
    // are emptied (fx is the type by default)
    promise: function promise(type, obj) {
      var tmp,
          count = 1,
          defer = jQuery.Deferred(),
          elements = this,
          i = this.length,
          resolve = function resolve() {
        if (! --count) {
          defer.resolveWith(elements, [elements]);
        }
      };

      if (typeof type !== "string") {
        obj = type;
        type = undefined;
      }

      type = type || "fx";

      while (i--) {
        tmp = dataPriv.get(elements[i], type + "queueHooks");

        if (tmp && tmp.empty) {
          count++;
          tmp.empty.add(resolve);
        }
      }

      resolve();
      return defer.promise(obj);
    }
  });
  var pnum = /[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/.source;
  var rcssNum = new RegExp("^(?:([+-])=|)(" + pnum + ")([a-z%]*)$", "i");
  var cssExpand = ["Top", "Right", "Bottom", "Left"];

  var isHiddenWithinTree = function isHiddenWithinTree(elem, el) {
    // isHiddenWithinTree might be called from jQuery#filter function;
    // in that case, element will be second argument
    elem = el || elem; // Inline style trumps all

    return elem.style.display === "none" || elem.style.display === "" && // Otherwise, check computed style
    // Support: Firefox <=43 - 45
    // Disconnected elements can have computed display: none, so first confirm that elem is
    // in the document.
    jQuery.contains(elem.ownerDocument, elem) && jQuery.css(elem, "display") === "none";
  };

  var swap = function swap(elem, options, callback, args) {
    var ret,
        name,
        old = {}; // Remember the old values, and insert the new ones

    for (name in options) {
      old[name] = elem.style[name];
      elem.style[name] = options[name];
    }

    ret = callback.apply(elem, args || []); // Revert the old values

    for (name in options) {
      elem.style[name] = old[name];
    }

    return ret;
  };

  function adjustCSS(elem, prop, valueParts, tween) {
    var adjusted,
        scale = 1,
        maxIterations = 20,
        currentValue = tween ? function () {
      return tween.cur();
    } : function () {
      return jQuery.css(elem, prop, "");
    },
        initial = currentValue(),
        unit = valueParts && valueParts[3] || (jQuery.cssNumber[prop] ? "" : "px"),
        // Starting value computation is required for potential unit mismatches
    initialInUnit = (jQuery.cssNumber[prop] || unit !== "px" && +initial) && rcssNum.exec(jQuery.css(elem, prop));

    if (initialInUnit && initialInUnit[3] !== unit) {
      // Trust units reported by jQuery.css
      unit = unit || initialInUnit[3]; // Make sure we update the tween properties later on

      valueParts = valueParts || []; // Iteratively approximate from a nonzero starting point

      initialInUnit = +initial || 1;

      do {
        // If previous iteration zeroed out, double until we get *something*.
        // Use string for doubling so we don't accidentally see scale as unchanged below
        scale = scale || ".5"; // Adjust and apply

        initialInUnit = initialInUnit / scale;
        jQuery.style(elem, prop, initialInUnit + unit); // Update scale, tolerating zero or NaN from tween.cur()
        // Break the loop if scale is unchanged or perfect, or if we've just had enough.
      } while (scale !== (scale = currentValue() / initial) && scale !== 1 && --maxIterations);
    }

    if (valueParts) {
      initialInUnit = +initialInUnit || +initial || 0; // Apply relative offset (+=/-=) if specified

      adjusted = valueParts[1] ? initialInUnit + (valueParts[1] + 1) * valueParts[2] : +valueParts[2];

      if (tween) {
        tween.unit = unit;
        tween.start = initialInUnit;
        tween.end = adjusted;
      }
    }

    return adjusted;
  }

  var defaultDisplayMap = {};

  function getDefaultDisplay(elem) {
    var temp,
        doc = elem.ownerDocument,
        nodeName = elem.nodeName,
        display = defaultDisplayMap[nodeName];

    if (display) {
      return display;
    }

    temp = doc.body.appendChild(doc.createElement(nodeName));
    display = jQuery.css(temp, "display");
    temp.parentNode.removeChild(temp);

    if (display === "none") {
      display = "block";
    }

    defaultDisplayMap[nodeName] = display;
    return display;
  }

  function showHide(elements, show) {
    var display,
        elem,
        values = [],
        index = 0,
        length = elements.length; // Determine new display value for elements that need to change

    for (; index < length; index++) {
      elem = elements[index];

      if (!elem.style) {
        continue;
      }

      display = elem.style.display;

      if (show) {
        // Since we force visibility upon cascade-hidden elements, an immediate (and slow)
        // check is required in this first loop unless we have a nonempty display value (either
        // inline or about-to-be-restored)
        if (display === "none") {
          values[index] = dataPriv.get(elem, "display") || null;

          if (!values[index]) {
            elem.style.display = "";
          }
        }

        if (elem.style.display === "" && isHiddenWithinTree(elem)) {
          values[index] = getDefaultDisplay(elem);
        }
      } else {
        if (display !== "none") {
          values[index] = "none"; // Remember what we're overwriting

          dataPriv.set(elem, "display", display);
        }
      }
    } // Set the display of the elements in a second loop to avoid constant reflow


    for (index = 0; index < length; index++) {
      if (values[index] != null) {
        elements[index].style.display = values[index];
      }
    }

    return elements;
  }

  jQuery.fn.extend({
    show: function show() {
      return showHide(this, true);
    },
    hide: function hide() {
      return showHide(this);
    },
    toggle: function toggle(state) {
      if (typeof state === "boolean") {
        return state ? this.show() : this.hide();
      }

      return this.each(function () {
        if (isHiddenWithinTree(this)) {
          jQuery(this).show();
        } else {
          jQuery(this).hide();
        }
      });
    }
  });
  var rcheckableType = /^(?:checkbox|radio)$/i;
  var rtagName = /<([a-z][^\/\0>\x20\t\r\n\f]+)/i;
  var rscriptType = /^$|\/(?:java|ecma)script/i; // We have to close these tags to support XHTML (#13200)

  var wrapMap = {
    // Support: IE <=9 only
    option: [1, "<select multiple='multiple'>", "</select>"],
    // XHTML parsers do not magically insert elements in the
    // same way that tag soup parsers do. So we cannot shorten
    // this by omitting <tbody> or other required elements.
    thead: [1, "<table>", "</table>"],
    col: [2, "<table><colgroup>", "</colgroup></table>"],
    tr: [2, "<table><tbody>", "</tbody></table>"],
    td: [3, "<table><tbody><tr>", "</tr></tbody></table>"],
    _default: [0, "", ""]
  }; // Support: IE <=9 only

  wrapMap.optgroup = wrapMap.option;
  wrapMap.tbody = wrapMap.tfoot = wrapMap.colgroup = wrapMap.caption = wrapMap.thead;
  wrapMap.th = wrapMap.td;

  function getAll(context, tag) {
    // Support: IE <=9 - 11 only
    // Use typeof to avoid zero-argument method invocation on host objects (#15151)
    var ret;

    if (typeof context.getElementsByTagName !== "undefined") {
      ret = context.getElementsByTagName(tag || "*");
    } else if (typeof context.querySelectorAll !== "undefined") {
      ret = context.querySelectorAll(tag || "*");
    } else {
      ret = [];
    }

    if (tag === undefined || tag && jQuery.nodeName(context, tag)) {
      return jQuery.merge([context], ret);
    }

    return ret;
  } // Mark scripts as having already been evaluated


  function setGlobalEval(elems, refElements) {
    var i = 0,
        l = elems.length;

    for (; i < l; i++) {
      dataPriv.set(elems[i], "globalEval", !refElements || dataPriv.get(refElements[i], "globalEval"));
    }
  }

  var rhtml = /<|&#?\w+;/;

  function buildFragment(elems, context, scripts, selection, ignored) {
    var elem,
        tmp,
        tag,
        wrap,
        contains,
        j,
        fragment = context.createDocumentFragment(),
        nodes = [],
        i = 0,
        l = elems.length;

    for (; i < l; i++) {
      elem = elems[i];

      if (elem || elem === 0) {
        // Add nodes directly
        if (jQuery.type(elem) === "object") {
          // Support: Android <=4.0 only, PhantomJS 1 only
          // push.apply(_, arraylike) throws on ancient WebKit
          jQuery.merge(nodes, elem.nodeType ? [elem] : elem); // Convert non-html into a text node
        } else if (!rhtml.test(elem)) {
          nodes.push(context.createTextNode(elem)); // Convert html into DOM nodes
        } else {
          tmp = tmp || fragment.appendChild(context.createElement("div")); // Deserialize a standard representation

          tag = (rtagName.exec(elem) || ["", ""])[1].toLowerCase();
          wrap = wrapMap[tag] || wrapMap._default;
          tmp.innerHTML = wrap[1] + jQuery.htmlPrefilter(elem) + wrap[2]; // Descend through wrappers to the right content

          j = wrap[0];

          while (j--) {
            tmp = tmp.lastChild;
          } // Support: Android <=4.0 only, PhantomJS 1 only
          // push.apply(_, arraylike) throws on ancient WebKit


          jQuery.merge(nodes, tmp.childNodes); // Remember the top-level container

          tmp = fragment.firstChild; // Ensure the created nodes are orphaned (#12392)

          tmp.textContent = "";
        }
      }
    } // Remove wrapper from fragment


    fragment.textContent = "";
    i = 0;

    while (elem = nodes[i++]) {
      // Skip elements already in the context collection (trac-4087)
      if (selection && jQuery.inArray(elem, selection) > -1) {
        if (ignored) {
          ignored.push(elem);
        }

        continue;
      }

      contains = jQuery.contains(elem.ownerDocument, elem); // Append to fragment

      tmp = getAll(fragment.appendChild(elem), "script"); // Preserve script evaluation history

      if (contains) {
        setGlobalEval(tmp);
      } // Capture executables


      if (scripts) {
        j = 0;

        while (elem = tmp[j++]) {
          if (rscriptType.test(elem.type || "")) {
            scripts.push(elem);
          }
        }
      }
    }

    return fragment;
  }

  (function () {
    var fragment = document.createDocumentFragment(),
        div = fragment.appendChild(document.createElement("div")),
        input = document.createElement("input"); // Support: Android 4.0 - 4.3 only
    // Check state lost if the name is set (#11217)
    // Support: Windows Web Apps (WWA)
    // `name` and `type` must use .setAttribute for WWA (#14901)

    input.setAttribute("type", "radio");
    input.setAttribute("checked", "checked");
    input.setAttribute("name", "t");
    div.appendChild(input); // Support: Android <=4.1 only
    // Older WebKit doesn't clone checked state correctly in fragments

    support.checkClone = div.cloneNode(true).cloneNode(true).lastChild.checked; // Support: IE <=11 only
    // Make sure textarea (and checkbox) defaultValue is properly cloned

    div.innerHTML = "<textarea>x</textarea>";
    support.noCloneChecked = !!div.cloneNode(true).lastChild.defaultValue;
  })();

  var documentElement = document.documentElement;
  var rkeyEvent = /^key/,
      rmouseEvent = /^(?:mouse|pointer|contextmenu|drag|drop)|click/,
      rtypenamespace = /^([^.]*)(?:\.(.+)|)/;

  function returnTrue() {
    return true;
  }

  function returnFalse() {
    return false;
  } // Support: IE <=9 only
  // See #13393 for more info


  function safeActiveElement() {
    try {
      return document.activeElement;
    } catch (err) {}
  }

  function _on(elem, types, selector, data, fn, one) {
    var origFn, type; // Types can be a map of types/handlers

    if (_typeof(types) === "object") {
      // ( types-Object, selector, data )
      if (typeof selector !== "string") {
        // ( types-Object, data )
        data = data || selector;
        selector = undefined;
      }

      for (type in types) {
        _on(elem, type, selector, data, types[type], one);
      }

      return elem;
    }

    if (data == null && fn == null) {
      // ( types, fn )
      fn = selector;
      data = selector = undefined;
    } else if (fn == null) {
      if (typeof selector === "string") {
        // ( types, selector, fn )
        fn = data;
        data = undefined;
      } else {
        // ( types, data, fn )
        fn = data;
        data = selector;
        selector = undefined;
      }
    }

    if (fn === false) {
      fn = returnFalse;
    } else if (!fn) {
      return elem;
    }

    if (one === 1) {
      origFn = fn;

      fn = function fn(event) {
        // Can use an empty set, since event contains the info
        jQuery().off(event);
        return origFn.apply(this, arguments);
      }; // Use same guid so caller can remove using origFn


      fn.guid = origFn.guid || (origFn.guid = jQuery.guid++);
    }

    return elem.each(function () {
      jQuery.event.add(this, types, fn, data, selector);
    });
  }
  /*
   * Helper functions for managing events -- not part of the public interface.
   * Props to Dean Edwards' addEvent library for many of the ideas.
   */


  jQuery.event = {
    global: {},
    add: function add(elem, types, handler, data, selector) {
      var handleObjIn,
          eventHandle,
          tmp,
          events,
          t,
          handleObj,
          special,
          handlers,
          type,
          namespaces,
          origType,
          elemData = dataPriv.get(elem); // Don't attach events to noData or text/comment nodes (but allow plain objects)

      if (!elemData) {
        return;
      } // Caller can pass in an object of custom data in lieu of the handler


      if (handler.handler) {
        handleObjIn = handler;
        handler = handleObjIn.handler;
        selector = handleObjIn.selector;
      } // Ensure that invalid selectors throw exceptions at attach time
      // Evaluate against documentElement in case elem is a non-element node (e.g., document)


      if (selector) {
        jQuery.find.matchesSelector(documentElement, selector);
      } // Make sure that the handler has a unique ID, used to find/remove it later


      if (!handler.guid) {
        handler.guid = jQuery.guid++;
      } // Init the element's event structure and main handler, if this is the first


      if (!(events = elemData.events)) {
        events = elemData.events = {};
      }

      if (!(eventHandle = elemData.handle)) {
        eventHandle = elemData.handle = function (e) {
          // Discard the second event of a jQuery.event.trigger() and
          // when an event is called after a page has unloaded
          return typeof jQuery !== "undefined" && jQuery.event.triggered !== e.type ? jQuery.event.dispatch.apply(elem, arguments) : undefined;
        };
      } // Handle multiple events separated by a space


      types = (types || "").match(rnothtmlwhite) || [""];
      t = types.length;

      while (t--) {
        tmp = rtypenamespace.exec(types[t]) || [];
        type = origType = tmp[1];
        namespaces = (tmp[2] || "").split(".").sort(); // There *must* be a type, no attaching namespace-only handlers

        if (!type) {
          continue;
        } // If event changes its type, use the special event handlers for the changed type


        special = jQuery.event.special[type] || {}; // If selector defined, determine special event api type, otherwise given type

        type = (selector ? special.delegateType : special.bindType) || type; // Update special based on newly reset type

        special = jQuery.event.special[type] || {}; // handleObj is passed to all event handlers

        handleObj = jQuery.extend({
          type: type,
          origType: origType,
          data: data,
          handler: handler,
          guid: handler.guid,
          selector: selector,
          needsContext: selector && jQuery.expr.match.needsContext.test(selector),
          namespace: namespaces.join(".")
        }, handleObjIn); // Init the event handler queue if we're the first

        if (!(handlers = events[type])) {
          handlers = events[type] = [];
          handlers.delegateCount = 0; // Only use addEventListener if the special events handler returns false

          if (!special.setup || special.setup.call(elem, data, namespaces, eventHandle) === false) {
            if (elem.addEventListener) {
              elem.addEventListener(type, eventHandle);
            }
          }
        }

        if (special.add) {
          special.add.call(elem, handleObj);

          if (!handleObj.handler.guid) {
            handleObj.handler.guid = handler.guid;
          }
        } // Add to the element's handler list, delegates in front


        if (selector) {
          handlers.splice(handlers.delegateCount++, 0, handleObj);
        } else {
          handlers.push(handleObj);
        } // Keep track of which events have ever been used, for event optimization


        jQuery.event.global[type] = true;
      }
    },
    // Detach an event or set of events from an element
    remove: function remove(elem, types, handler, selector, mappedTypes) {
      var j,
          origCount,
          tmp,
          events,
          t,
          handleObj,
          special,
          handlers,
          type,
          namespaces,
          origType,
          elemData = dataPriv.hasData(elem) && dataPriv.get(elem);

      if (!elemData || !(events = elemData.events)) {
        return;
      } // Once for each type.namespace in types; type may be omitted


      types = (types || "").match(rnothtmlwhite) || [""];
      t = types.length;

      while (t--) {
        tmp = rtypenamespace.exec(types[t]) || [];
        type = origType = tmp[1];
        namespaces = (tmp[2] || "").split(".").sort(); // Unbind all events (on this namespace, if provided) for the element

        if (!type) {
          for (type in events) {
            jQuery.event.remove(elem, type + types[t], handler, selector, true);
          }

          continue;
        }

        special = jQuery.event.special[type] || {};
        type = (selector ? special.delegateType : special.bindType) || type;
        handlers = events[type] || [];
        tmp = tmp[2] && new RegExp("(^|\\.)" + namespaces.join("\\.(?:.*\\.|)") + "(\\.|$)"); // Remove matching events

        origCount = j = handlers.length;

        while (j--) {
          handleObj = handlers[j];

          if ((mappedTypes || origType === handleObj.origType) && (!handler || handler.guid === handleObj.guid) && (!tmp || tmp.test(handleObj.namespace)) && (!selector || selector === handleObj.selector || selector === "**" && handleObj.selector)) {
            handlers.splice(j, 1);

            if (handleObj.selector) {
              handlers.delegateCount--;
            }

            if (special.remove) {
              special.remove.call(elem, handleObj);
            }
          }
        } // Remove generic event handler if we removed something and no more handlers exist
        // (avoids potential for endless recursion during removal of special event handlers)


        if (origCount && !handlers.length) {
          if (!special.teardown || special.teardown.call(elem, namespaces, elemData.handle) === false) {
            jQuery.removeEvent(elem, type, elemData.handle);
          }

          delete events[type];
        }
      } // Remove data and the expando if it's no longer used


      if (jQuery.isEmptyObject(events)) {
        dataPriv.remove(elem, "handle events");
      }
    },
    dispatch: function dispatch(nativeEvent) {
      // Make a writable jQuery.Event from the native event object
      var event = jQuery.event.fix(nativeEvent);
      var i,
          j,
          ret,
          matched,
          handleObj,
          handlerQueue,
          args = new Array(arguments.length),
          handlers = (dataPriv.get(this, "events") || {})[event.type] || [],
          special = jQuery.event.special[event.type] || {}; // Use the fix-ed jQuery.Event rather than the (read-only) native event

      args[0] = event;

      for (i = 1; i < arguments.length; i++) {
        args[i] = arguments[i];
      }

      event.delegateTarget = this; // Call the preDispatch hook for the mapped type, and let it bail if desired

      if (special.preDispatch && special.preDispatch.call(this, event) === false) {
        return;
      } // Determine handlers


      handlerQueue = jQuery.event.handlers.call(this, event, handlers); // Run delegates first; they may want to stop propagation beneath us

      i = 0;

      while ((matched = handlerQueue[i++]) && !event.isPropagationStopped()) {
        event.currentTarget = matched.elem;
        j = 0;

        while ((handleObj = matched.handlers[j++]) && !event.isImmediatePropagationStopped()) {
          // Triggered event must either 1) have no namespace, or 2) have namespace(s)
          // a subset or equal to those in the bound event (both can have no namespace).
          if (!event.rnamespace || event.rnamespace.test(handleObj.namespace)) {
            event.handleObj = handleObj;
            event.data = handleObj.data;
            ret = ((jQuery.event.special[handleObj.origType] || {}).handle || handleObj.handler).apply(matched.elem, args);

            if (ret !== undefined) {
              if ((event.result = ret) === false) {
                event.preventDefault();
                event.stopPropagation();
              }
            }
          }
        }
      } // Call the postDispatch hook for the mapped type


      if (special.postDispatch) {
        special.postDispatch.call(this, event);
      }

      return event.result;
    },
    handlers: function handlers(event, _handlers) {
      var i,
          handleObj,
          sel,
          matchedHandlers,
          matchedSelectors,
          handlerQueue = [],
          delegateCount = _handlers.delegateCount,
          cur = event.target; // Find delegate handlers

      if (delegateCount && // Support: IE <=9
      // Black-hole SVG <use> instance trees (trac-13180)
      cur.nodeType && // Support: Firefox <=42
      // Suppress spec-violating clicks indicating a non-primary pointer button (trac-3861)
      // https://www.w3.org/TR/DOM-Level-3-Events/#event-type-click
      // Support: IE 11 only
      // ...but not arrow key "clicks" of radio inputs, which can have `button` -1 (gh-2343)
      !(event.type === "click" && event.button >= 1)) {
        for (; cur !== this; cur = cur.parentNode || this) {
          // Don't check non-elements (#13208)
          // Don't process clicks on disabled elements (#6911, #8165, #11382, #11764)
          if (cur.nodeType === 1 && !(event.type === "click" && cur.disabled === true)) {
            matchedHandlers = [];
            matchedSelectors = {};

            for (i = 0; i < delegateCount; i++) {
              handleObj = _handlers[i]; // Don't conflict with Object.prototype properties (#13203)

              sel = handleObj.selector + " ";

              if (matchedSelectors[sel] === undefined) {
                matchedSelectors[sel] = handleObj.needsContext ? jQuery(sel, this).index(cur) > -1 : jQuery.find(sel, this, null, [cur]).length;
              }

              if (matchedSelectors[sel]) {
                matchedHandlers.push(handleObj);
              }
            }

            if (matchedHandlers.length) {
              handlerQueue.push({
                elem: cur,
                handlers: matchedHandlers
              });
            }
          }
        }
      } // Add the remaining (directly-bound) handlers


      cur = this;

      if (delegateCount < _handlers.length) {
        handlerQueue.push({
          elem: cur,
          handlers: _handlers.slice(delegateCount)
        });
      }

      return handlerQueue;
    },
    addProp: function addProp(name, hook) {
      Object.defineProperty(jQuery.Event.prototype, name, {
        enumerable: true,
        configurable: true,
        get: jQuery.isFunction(hook) ? function () {
          if (this.originalEvent) {
            return hook(this.originalEvent);
          }
        } : function () {
          if (this.originalEvent) {
            return this.originalEvent[name];
          }
        },
        set: function set(value) {
          Object.defineProperty(this, name, {
            enumerable: true,
            configurable: true,
            writable: true,
            value: value
          });
        }
      });
    },
    fix: function fix(originalEvent) {
      return originalEvent[jQuery.expando] ? originalEvent : new jQuery.Event(originalEvent);
    },
    special: {
      load: {
        // Prevent triggered image.load events from bubbling to window.load
        noBubble: true
      },
      focus: {
        // Fire native event if possible so blur/focus sequence is correct
        trigger: function trigger() {
          if (this !== safeActiveElement() && this.focus) {
            this.focus();
            return false;
          }
        },
        delegateType: "focusin"
      },
      blur: {
        trigger: function trigger() {
          if (this === safeActiveElement() && this.blur) {
            this.blur();
            return false;
          }
        },
        delegateType: "focusout"
      },
      click: {
        // For checkbox, fire native event so checked state will be right
        trigger: function trigger() {
          if (this.type === "checkbox" && this.click && jQuery.nodeName(this, "input")) {
            this.click();
            return false;
          }
        },
        // For cross-browser consistency, don't fire native .click() on links
        _default: function _default(event) {
          return jQuery.nodeName(event.target, "a");
        }
      },
      beforeunload: {
        postDispatch: function postDispatch(event) {
          // Support: Firefox 20+
          // Firefox doesn't alert if the returnValue field is not set.
          if (event.result !== undefined && event.originalEvent) {
            event.originalEvent.returnValue = event.result;
          }
        }
      }
    }
  };

  jQuery.removeEvent = function (elem, type, handle) {
    // This "if" is needed for plain objects
    if (elem.removeEventListener) {
      elem.removeEventListener(type, handle);
    }
  };

  jQuery.Event = function (src, props) {
    // Allow instantiation without the 'new' keyword
    if (!(this instanceof jQuery.Event)) {
      return new jQuery.Event(src, props);
    } // Event object


    if (src && src.type) {
      this.originalEvent = src;
      this.type = src.type; // Events bubbling up the document may have been marked as prevented
      // by a handler lower down the tree; reflect the correct value.

      this.isDefaultPrevented = src.defaultPrevented || src.defaultPrevented === undefined && // Support: Android <=2.3 only
      src.returnValue === false ? returnTrue : returnFalse; // Create target properties
      // Support: Safari <=6 - 7 only
      // Target should not be a text node (#504, #13143)

      this.target = src.target && src.target.nodeType === 3 ? src.target.parentNode : src.target;
      this.currentTarget = src.currentTarget;
      this.relatedTarget = src.relatedTarget; // Event type
    } else {
      this.type = src;
    } // Put explicitly provided properties onto the event object


    if (props) {
      jQuery.extend(this, props);
    } // Create a timestamp if incoming event doesn't have one


    this.timeStamp = src && src.timeStamp || jQuery.now(); // Mark it as fixed

    this[jQuery.expando] = true;
  }; // jQuery.Event is based on DOM3 Events as specified by the ECMAScript Language Binding
  // https://www.w3.org/TR/2003/WD-DOM-Level-3-Events-20030331/ecma-script-binding.html


  jQuery.Event.prototype = {
    constructor: jQuery.Event,
    isDefaultPrevented: returnFalse,
    isPropagationStopped: returnFalse,
    isImmediatePropagationStopped: returnFalse,
    isSimulated: false,
    preventDefault: function preventDefault() {
      var e = this.originalEvent;
      this.isDefaultPrevented = returnTrue;

      if (e && !this.isSimulated) {
        e.preventDefault();
      }
    },
    stopPropagation: function stopPropagation() {
      var e = this.originalEvent;
      this.isPropagationStopped = returnTrue;

      if (e && !this.isSimulated) {
        e.stopPropagation();
      }
    },
    stopImmediatePropagation: function stopImmediatePropagation() {
      var e = this.originalEvent;
      this.isImmediatePropagationStopped = returnTrue;

      if (e && !this.isSimulated) {
        e.stopImmediatePropagation();
      }

      this.stopPropagation();
    }
  }; // Includes all common event props including KeyEvent and MouseEvent specific props

  jQuery.each({
    altKey: true,
    bubbles: true,
    cancelable: true,
    changedTouches: true,
    ctrlKey: true,
    detail: true,
    eventPhase: true,
    metaKey: true,
    pageX: true,
    pageY: true,
    shiftKey: true,
    view: true,
    "char": true,
    charCode: true,
    key: true,
    keyCode: true,
    button: true,
    buttons: true,
    clientX: true,
    clientY: true,
    offsetX: true,
    offsetY: true,
    pointerId: true,
    pointerType: true,
    screenX: true,
    screenY: true,
    targetTouches: true,
    toElement: true,
    touches: true,
    which: function which(event) {
      var button = event.button; // Add which for key events

      if (event.which == null && rkeyEvent.test(event.type)) {
        return event.charCode != null ? event.charCode : event.keyCode;
      } // Add which for click: 1 === left; 2 === middle; 3 === right


      if (!event.which && button !== undefined && rmouseEvent.test(event.type)) {
        if (button & 1) {
          return 1;
        }

        if (button & 2) {
          return 3;
        }

        if (button & 4) {
          return 2;
        }

        return 0;
      }

      return event.which;
    }
  }, jQuery.event.addProp); // Create mouseenter/leave events using mouseover/out and event-time checks
  // so that event delegation works in jQuery.
  // Do the same for pointerenter/pointerleave and pointerover/pointerout
  //
  // Support: Safari 7 only
  // Safari sends mouseenter too often; see:
  // https://bugs.chromium.org/p/chromium/issues/detail?id=470258
  // for the description of the bug (it existed in older Chrome versions as well).

  jQuery.each({
    mouseenter: "mouseover",
    mouseleave: "mouseout",
    pointerenter: "pointerover",
    pointerleave: "pointerout"
  }, function (orig, fix) {
    jQuery.event.special[orig] = {
      delegateType: fix,
      bindType: fix,
      handle: function handle(event) {
        var ret,
            target = this,
            related = event.relatedTarget,
            handleObj = event.handleObj; // For mouseenter/leave call the handler if related is outside the target.
        // NB: No relatedTarget if the mouse left/entered the browser window

        if (!related || related !== target && !jQuery.contains(target, related)) {
          event.type = handleObj.origType;
          ret = handleObj.handler.apply(this, arguments);
          event.type = fix;
        }

        return ret;
      }
    };
  });
  jQuery.fn.extend({
    on: function on(types, selector, data, fn) {
      return _on(this, types, selector, data, fn);
    },
    one: function one(types, selector, data, fn) {
      return _on(this, types, selector, data, fn, 1);
    },
    off: function off(types, selector, fn) {
      var handleObj, type;

      if (types && types.preventDefault && types.handleObj) {
        // ( event )  dispatched jQuery.Event
        handleObj = types.handleObj;
        jQuery(types.delegateTarget).off(handleObj.namespace ? handleObj.origType + "." + handleObj.namespace : handleObj.origType, handleObj.selector, handleObj.handler);
        return this;
      }

      if (_typeof(types) === "object") {
        // ( types-object [, selector] )
        for (type in types) {
          this.off(type, selector, types[type]);
        }

        return this;
      }

      if (selector === false || typeof selector === "function") {
        // ( types [, fn] )
        fn = selector;
        selector = undefined;
      }

      if (fn === false) {
        fn = returnFalse;
      }

      return this.each(function () {
        jQuery.event.remove(this, types, fn, selector);
      });
    }
  });
  var
  /* eslint-disable max-len */
  // See https://github.com/eslint/eslint/issues/3229
  rxhtmlTag = /<(?!area|br|col|embed|hr|img|input|link|meta|param)(([a-z][^\/\0>\x20\t\r\n\f]*)[^>]*)\/>/gi,

  /* eslint-enable */
  // Support: IE <=10 - 11, Edge 12 - 13
  // In IE/Edge using regex groups here causes severe slowdowns.
  // See https://connect.microsoft.com/IE/feedback/details/1736512/
  rnoInnerhtml = /<script|<style|<link/i,
      // checked="checked" or checked
  rchecked = /checked\s*(?:[^=]|=\s*.checked.)/i,
      rscriptTypeMasked = /^true\/(.*)/,
      rcleanScript = /^\s*<!(?:\[CDATA\[|--)|(?:\]\]|--)>\s*$/g;

  function manipulationTarget(elem, content) {
    if (jQuery.nodeName(elem, "table") && jQuery.nodeName(content.nodeType !== 11 ? content : content.firstChild, "tr")) {
      return elem.getElementsByTagName("tbody")[0] || elem;
    }

    return elem;
  } // Replace/restore the type attribute of script elements for safe DOM manipulation


  function disableScript(elem) {
    elem.type = (elem.getAttribute("type") !== null) + "/" + elem.type;
    return elem;
  }

  function restoreScript(elem) {
    var match = rscriptTypeMasked.exec(elem.type);

    if (match) {
      elem.type = match[1];
    } else {
      elem.removeAttribute("type");
    }

    return elem;
  }

  function cloneCopyEvent(src, dest) {
    var i, l, type, pdataOld, pdataCur, udataOld, udataCur, events;

    if (dest.nodeType !== 1) {
      return;
    } // 1. Copy private data: events, handlers, etc.


    if (dataPriv.hasData(src)) {
      pdataOld = dataPriv.access(src);
      pdataCur = dataPriv.set(dest, pdataOld);
      events = pdataOld.events;

      if (events) {
        delete pdataCur.handle;
        pdataCur.events = {};

        for (type in events) {
          for (i = 0, l = events[type].length; i < l; i++) {
            jQuery.event.add(dest, type, events[type][i]);
          }
        }
      }
    } // 2. Copy user data


    if (dataUser.hasData(src)) {
      udataOld = dataUser.access(src);
      udataCur = jQuery.extend({}, udataOld);
      dataUser.set(dest, udataCur);
    }
  } // Fix IE bugs, see support tests


  function fixInput(src, dest) {
    var nodeName = dest.nodeName.toLowerCase(); // Fails to persist the checked state of a cloned checkbox or radio button.

    if (nodeName === "input" && rcheckableType.test(src.type)) {
      dest.checked = src.checked; // Fails to return the selected option to the default selected state when cloning options
    } else if (nodeName === "input" || nodeName === "textarea") {
      dest.defaultValue = src.defaultValue;
    }
  }

  function domManip(collection, args, callback, ignored) {
    // Flatten any nested arrays
    args = concat.apply([], args);
    var fragment,
        first,
        scripts,
        hasScripts,
        node,
        doc,
        i = 0,
        l = collection.length,
        iNoClone = l - 1,
        value = args[0],
        isFunction = jQuery.isFunction(value); // We can't cloneNode fragments that contain checked, in WebKit

    if (isFunction || l > 1 && typeof value === "string" && !support.checkClone && rchecked.test(value)) {
      return collection.each(function (index) {
        var self = collection.eq(index);

        if (isFunction) {
          args[0] = value.call(this, index, self.html());
        }

        domManip(self, args, callback, ignored);
      });
    }

    if (l) {
      fragment = buildFragment(args, collection[0].ownerDocument, false, collection, ignored);
      first = fragment.firstChild;

      if (fragment.childNodes.length === 1) {
        fragment = first;
      } // Require either new content or an interest in ignored elements to invoke the callback


      if (first || ignored) {
        scripts = jQuery.map(getAll(fragment, "script"), disableScript);
        hasScripts = scripts.length; // Use the original fragment for the last item
        // instead of the first because it can end up
        // being emptied incorrectly in certain situations (#8070).

        for (; i < l; i++) {
          node = fragment;

          if (i !== iNoClone) {
            node = jQuery.clone(node, true, true); // Keep references to cloned scripts for later restoration

            if (hasScripts) {
              // Support: Android <=4.0 only, PhantomJS 1 only
              // push.apply(_, arraylike) throws on ancient WebKit
              jQuery.merge(scripts, getAll(node, "script"));
            }
          }

          callback.call(collection[i], node, i);
        }

        if (hasScripts) {
          doc = scripts[scripts.length - 1].ownerDocument; // Reenable scripts

          jQuery.map(scripts, restoreScript); // Evaluate executable scripts on first document insertion

          for (i = 0; i < hasScripts; i++) {
            node = scripts[i];

            if (rscriptType.test(node.type || "") && !dataPriv.access(node, "globalEval") && jQuery.contains(doc, node)) {
              if (node.src) {
                // Optional AJAX dependency, but won't run scripts if not present
                if (jQuery._evalUrl) {
                  jQuery._evalUrl(node.src);
                }
              } else {
                DOMEval(node.textContent.replace(rcleanScript, ""), doc);
              }
            }
          }
        }
      }
    }

    return collection;
  }

  function _remove(elem, selector, keepData) {
    var node,
        nodes = selector ? jQuery.filter(selector, elem) : elem,
        i = 0;

    for (; (node = nodes[i]) != null; i++) {
      if (!keepData && node.nodeType === 1) {
        jQuery.cleanData(getAll(node));
      }

      if (node.parentNode) {
        if (keepData && jQuery.contains(node.ownerDocument, node)) {
          setGlobalEval(getAll(node, "script"));
        }

        node.parentNode.removeChild(node);
      }
    }

    return elem;
  }

  jQuery.extend({
    htmlPrefilter: function htmlPrefilter(html) {
      return html.replace(rxhtmlTag, "<$1></$2>");
    },
    clone: function clone(elem, dataAndEvents, deepDataAndEvents) {
      var i,
          l,
          srcElements,
          destElements,
          clone = elem.cloneNode(true),
          inPage = jQuery.contains(elem.ownerDocument, elem); // Fix IE cloning issues

      if (!support.noCloneChecked && (elem.nodeType === 1 || elem.nodeType === 11) && !jQuery.isXMLDoc(elem)) {
        // We eschew Sizzle here for performance reasons: https://jsperf.com/getall-vs-sizzle/2
        destElements = getAll(clone);
        srcElements = getAll(elem);

        for (i = 0, l = srcElements.length; i < l; i++) {
          fixInput(srcElements[i], destElements[i]);
        }
      } // Copy the events from the original to the clone


      if (dataAndEvents) {
        if (deepDataAndEvents) {
          srcElements = srcElements || getAll(elem);
          destElements = destElements || getAll(clone);

          for (i = 0, l = srcElements.length; i < l; i++) {
            cloneCopyEvent(srcElements[i], destElements[i]);
          }
        } else {
          cloneCopyEvent(elem, clone);
        }
      } // Preserve script evaluation history


      destElements = getAll(clone, "script");

      if (destElements.length > 0) {
        setGlobalEval(destElements, !inPage && getAll(elem, "script"));
      } // Return the cloned set


      return clone;
    },
    cleanData: function cleanData(elems) {
      var data,
          elem,
          type,
          special = jQuery.event.special,
          i = 0;

      for (; (elem = elems[i]) !== undefined; i++) {
        if (acceptData(elem)) {
          if (data = elem[dataPriv.expando]) {
            if (data.events) {
              for (type in data.events) {
                if (special[type]) {
                  jQuery.event.remove(elem, type); // This is a shortcut to avoid jQuery.event.remove's overhead
                } else {
                  jQuery.removeEvent(elem, type, data.handle);
                }
              }
            } // Support: Chrome <=35 - 45+
            // Assign undefined instead of using delete, see Data#remove


            elem[dataPriv.expando] = undefined;
          }

          if (elem[dataUser.expando]) {
            // Support: Chrome <=35 - 45+
            // Assign undefined instead of using delete, see Data#remove
            elem[dataUser.expando] = undefined;
          }
        }
      }
    }
  });
  jQuery.fn.extend({
    detach: function detach(selector) {
      return _remove(this, selector, true);
    },
    remove: function remove(selector) {
      return _remove(this, selector);
    },
    text: function text(value) {
      return access(this, function (value) {
        return value === undefined ? jQuery.text(this) : this.empty().each(function () {
          if (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) {
            this.textContent = value;
          }
        });
      }, null, value, arguments.length);
    },
    append: function append() {
      return domManip(this, arguments, function (elem) {
        if (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) {
          var target = manipulationTarget(this, elem);
          target.appendChild(elem);
        }
      });
    },
    prepend: function prepend() {
      return domManip(this, arguments, function (elem) {
        if (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) {
          var target = manipulationTarget(this, elem);
          target.insertBefore(elem, target.firstChild);
        }
      });
    },
    before: function before() {
      return domManip(this, arguments, function (elem) {
        if (this.parentNode) {
          this.parentNode.insertBefore(elem, this);
        }
      });
    },
    after: function after() {
      return domManip(this, arguments, function (elem) {
        if (this.parentNode) {
          this.parentNode.insertBefore(elem, this.nextSibling);
        }
      });
    },
    empty: function empty() {
      var elem,
          i = 0;

      for (; (elem = this[i]) != null; i++) {
        if (elem.nodeType === 1) {
          // Prevent memory leaks
          jQuery.cleanData(getAll(elem, false)); // Remove any remaining nodes

          elem.textContent = "";
        }
      }

      return this;
    },
    clone: function clone(dataAndEvents, deepDataAndEvents) {
      dataAndEvents = dataAndEvents == null ? false : dataAndEvents;
      deepDataAndEvents = deepDataAndEvents == null ? dataAndEvents : deepDataAndEvents;
      return this.map(function () {
        return jQuery.clone(this, dataAndEvents, deepDataAndEvents);
      });
    },
    html: function html(value) {
      return access(this, function (value) {
        var elem = this[0] || {},
            i = 0,
            l = this.length;

        if (value === undefined && elem.nodeType === 1) {
          return elem.innerHTML;
        } // See if we can take a shortcut and just use innerHTML


        if (typeof value === "string" && !rnoInnerhtml.test(value) && !wrapMap[(rtagName.exec(value) || ["", ""])[1].toLowerCase()]) {
          value = jQuery.htmlPrefilter(value);

          try {
            for (; i < l; i++) {
              elem = this[i] || {}; // Remove element nodes and prevent memory leaks

              if (elem.nodeType === 1) {
                jQuery.cleanData(getAll(elem, false));
                elem.innerHTML = value;
              }
            }

            elem = 0; // If using innerHTML throws an exception, use the fallback method
          } catch (e) {}
        }

        if (elem) {
          this.empty().append(value);
        }
      }, null, value, arguments.length);
    },
    replaceWith: function replaceWith() {
      var ignored = []; // Make the changes, replacing each non-ignored context element with the new content

      return domManip(this, arguments, function (elem) {
        var parent = this.parentNode;

        if (jQuery.inArray(this, ignored) < 0) {
          jQuery.cleanData(getAll(this));

          if (parent) {
            parent.replaceChild(elem, this);
          }
        } // Force callback invocation

      }, ignored);
    }
  });
  jQuery.each({
    appendTo: "append",
    prependTo: "prepend",
    insertBefore: "before",
    insertAfter: "after",
    replaceAll: "replaceWith"
  }, function (name, original) {
    jQuery.fn[name] = function (selector) {
      var elems,
          ret = [],
          insert = jQuery(selector),
          last = insert.length - 1,
          i = 0;

      for (; i <= last; i++) {
        elems = i === last ? this : this.clone(true);
        jQuery(insert[i])[original](elems); // Support: Android <=4.0 only, PhantomJS 1 only
        // .get() because push.apply(_, arraylike) throws on ancient WebKit

        push.apply(ret, elems.get());
      }

      return this.pushStack(ret);
    };
  });
  var rmargin = /^margin/;
  var rnumnonpx = new RegExp("^(" + pnum + ")(?!px)[a-z%]+$", "i");

  var getStyles = function getStyles(elem) {
    // Support: IE <=11 only, Firefox <=30 (#15098, #14150)
    // IE throws on elements created in popups
    // FF meanwhile throws on frame elements through "defaultView.getComputedStyle"
    var view = elem.ownerDocument.defaultView;

    if (!view || !view.opener) {
      view = window;
    }

    return view.getComputedStyle(elem);
  };

  (function () {
    // Executing both pixelPosition & boxSizingReliable tests require only one layout
    // so they're executed at the same time to save the second computation.
    function computeStyleTests() {
      // This is a singleton, we need to execute it only once
      if (!div) {
        return;
      }

      div.style.cssText = "box-sizing:border-box;" + "position:relative;display:block;" + "margin:auto;border:1px;padding:1px;" + "top:1%;width:50%";
      div.innerHTML = "";
      documentElement.appendChild(container);
      var divStyle = window.getComputedStyle(div);
      pixelPositionVal = divStyle.top !== "1%"; // Support: Android 4.0 - 4.3 only, Firefox <=3 - 44

      reliableMarginLeftVal = divStyle.marginLeft === "2px";
      boxSizingReliableVal = divStyle.width === "4px"; // Support: Android 4.0 - 4.3 only
      // Some styles come back with percentage values, even though they shouldn't

      div.style.marginRight = "50%";
      pixelMarginRightVal = divStyle.marginRight === "4px";
      documentElement.removeChild(container); // Nullify the div so it wouldn't be stored in the memory and
      // it will also be a sign that checks already performed

      div = null;
    }

    var pixelPositionVal,
        boxSizingReliableVal,
        pixelMarginRightVal,
        reliableMarginLeftVal,
        container = document.createElement("div"),
        div = document.createElement("div"); // Finish early in limited (non-browser) environments

    if (!div.style) {
      return;
    } // Support: IE <=9 - 11 only
    // Style of cloned element affects source element cloned (#8908)


    div.style.backgroundClip = "content-box";
    div.cloneNode(true).style.backgroundClip = "";
    support.clearCloneStyle = div.style.backgroundClip === "content-box";
    container.style.cssText = "border:0;width:8px;height:0;top:0;left:-9999px;" + "padding:0;margin-top:1px;position:absolute";
    container.appendChild(div);
    jQuery.extend(support, {
      pixelPosition: function pixelPosition() {
        computeStyleTests();
        return pixelPositionVal;
      },
      boxSizingReliable: function boxSizingReliable() {
        computeStyleTests();
        return boxSizingReliableVal;
      },
      pixelMarginRight: function pixelMarginRight() {
        computeStyleTests();
        return pixelMarginRightVal;
      },
      reliableMarginLeft: function reliableMarginLeft() {
        computeStyleTests();
        return reliableMarginLeftVal;
      }
    });
  })();

  function curCSS(elem, name, computed) {
    var width,
        minWidth,
        maxWidth,
        ret,
        style = elem.style;
    computed = computed || getStyles(elem); // Support: IE <=9 only
    // getPropertyValue is only needed for .css('filter') (#12537)

    if (computed) {
      ret = computed.getPropertyValue(name) || computed[name];

      if (ret === "" && !jQuery.contains(elem.ownerDocument, elem)) {
        ret = jQuery.style(elem, name);
      } // A tribute to the "awesome hack by Dean Edwards"
      // Android Browser returns percentage for some values,
      // but width seems to be reliably pixels.
      // This is against the CSSOM draft spec:
      // https://drafts.csswg.org/cssom/#resolved-values


      if (!support.pixelMarginRight() && rnumnonpx.test(ret) && rmargin.test(name)) {
        // Remember the original values
        width = style.width;
        minWidth = style.minWidth;
        maxWidth = style.maxWidth; // Put in the new values to get a computed value out

        style.minWidth = style.maxWidth = style.width = ret;
        ret = computed.width; // Revert the changed values

        style.width = width;
        style.minWidth = minWidth;
        style.maxWidth = maxWidth;
      }
    }

    return ret !== undefined ? // Support: IE <=9 - 11 only
    // IE returns zIndex value as an integer.
    ret + "" : ret;
  }

  function addGetHookIf(conditionFn, hookFn) {
    // Define the hook, we'll check on the first run if it's really needed.
    return {
      get: function get() {
        if (conditionFn()) {
          // Hook not needed (or it's not possible to use it due
          // to missing dependency), remove it.
          delete this.get;
          return;
        } // Hook needed; redefine it so that the support test is not executed again.


        return (this.get = hookFn).apply(this, arguments);
      }
    };
  }

  var // Swappable if display is none or starts with table
  // except "table", "table-cell", or "table-caption"
  // See here for display values: https://developer.mozilla.org/en-US/docs/CSS/display
  rdisplayswap = /^(none|table(?!-c[ea]).+)/,
      cssShow = {
    position: "absolute",
    visibility: "hidden",
    display: "block"
  },
      cssNormalTransform = {
    letterSpacing: "0",
    fontWeight: "400"
  },
      cssPrefixes = ["Webkit", "Moz", "ms"],
      emptyStyle = document.createElement("div").style; // Return a css property mapped to a potentially vendor prefixed property

  function vendorPropName(name) {
    // Shortcut for names that are not vendor prefixed
    if (name in emptyStyle) {
      return name;
    } // Check for vendor prefixed names


    var capName = name[0].toUpperCase() + name.slice(1),
        i = cssPrefixes.length;

    while (i--) {
      name = cssPrefixes[i] + capName;

      if (name in emptyStyle) {
        return name;
      }
    }
  }

  function setPositiveNumber(elem, value, subtract) {
    // Any relative (+/-) values have already been
    // normalized at this point
    var matches = rcssNum.exec(value);
    return matches ? // Guard against undefined "subtract", e.g., when used as in cssHooks
    Math.max(0, matches[2] - (subtract || 0)) + (matches[3] || "px") : value;
  }

  function augmentWidthOrHeight(elem, name, extra, isBorderBox, styles) {
    var i,
        val = 0; // If we already have the right measurement, avoid augmentation

    if (extra === (isBorderBox ? "border" : "content")) {
      i = 4; // Otherwise initialize for horizontal or vertical properties
    } else {
      i = name === "width" ? 1 : 0;
    }

    for (; i < 4; i += 2) {
      // Both box models exclude margin, so add it if we want it
      if (extra === "margin") {
        val += jQuery.css(elem, extra + cssExpand[i], true, styles);
      }

      if (isBorderBox) {
        // border-box includes padding, so remove it if we want content
        if (extra === "content") {
          val -= jQuery.css(elem, "padding" + cssExpand[i], true, styles);
        } // At this point, extra isn't border nor margin, so remove border


        if (extra !== "margin") {
          val -= jQuery.css(elem, "border" + cssExpand[i] + "Width", true, styles);
        }
      } else {
        // At this point, extra isn't content, so add padding
        val += jQuery.css(elem, "padding" + cssExpand[i], true, styles); // At this point, extra isn't content nor padding, so add border

        if (extra !== "padding") {
          val += jQuery.css(elem, "border" + cssExpand[i] + "Width", true, styles);
        }
      }
    }

    return val;
  }

  function getWidthOrHeight(elem, name, extra) {
    // Start with offset property, which is equivalent to the border-box value
    var val,
        valueIsBorderBox = true,
        styles = getStyles(elem),
        isBorderBox = jQuery.css(elem, "boxSizing", false, styles) === "border-box"; // Support: IE <=11 only
    // Running getBoundingClientRect on a disconnected node
    // in IE throws an error.

    if (elem.getClientRects().length) {
      val = elem.getBoundingClientRect()[name];
    } // Some non-html elements return undefined for offsetWidth, so check for null/undefined
    // svg - https://bugzilla.mozilla.org/show_bug.cgi?id=649285
    // MathML - https://bugzilla.mozilla.org/show_bug.cgi?id=491668


    if (val <= 0 || val == null) {
      // Fall back to computed then uncomputed css if necessary
      val = curCSS(elem, name, styles);

      if (val < 0 || val == null) {
        val = elem.style[name];
      } // Computed unit is not pixels. Stop here and return.


      if (rnumnonpx.test(val)) {
        return val;
      } // Check for style in case a browser which returns unreliable values
      // for getComputedStyle silently falls back to the reliable elem.style


      valueIsBorderBox = isBorderBox && (support.boxSizingReliable() || val === elem.style[name]); // Normalize "", auto, and prepare for extra

      val = parseFloat(val) || 0;
    } // Use the active box-sizing model to add/subtract irrelevant styles


    return val + augmentWidthOrHeight(elem, name, extra || (isBorderBox ? "border" : "content"), valueIsBorderBox, styles) + "px";
  }

  jQuery.extend({
    // Add in style property hooks for overriding the default
    // behavior of getting and setting a style property
    cssHooks: {
      opacity: {
        get: function get(elem, computed) {
          if (computed) {
            // We should always get a number back from opacity
            var ret = curCSS(elem, "opacity");
            return ret === "" ? "1" : ret;
          }
        }
      }
    },
    // Don't automatically add "px" to these possibly-unitless properties
    cssNumber: {
      "animationIterationCount": true,
      "columnCount": true,
      "fillOpacity": true,
      "flexGrow": true,
      "flexShrink": true,
      "fontWeight": true,
      "lineHeight": true,
      "opacity": true,
      "order": true,
      "orphans": true,
      "widows": true,
      "zIndex": true,
      "zoom": true
    },
    // Add in properties whose names you wish to fix before
    // setting or getting the value
    cssProps: {
      "float": "cssFloat"
    },
    // Get and set the style property on a DOM Node
    style: function style(elem, name, value, extra) {
      // Don't set styles on text and comment nodes
      if (!elem || elem.nodeType === 3 || elem.nodeType === 8 || !elem.style) {
        return;
      } // Make sure that we're working with the right name


      var ret,
          type,
          hooks,
          origName = jQuery.camelCase(name),
          style = elem.style;
      name = jQuery.cssProps[origName] || (jQuery.cssProps[origName] = vendorPropName(origName) || origName); // Gets hook for the prefixed version, then unprefixed version

      hooks = jQuery.cssHooks[name] || jQuery.cssHooks[origName]; // Check if we're setting a value

      if (value !== undefined) {
        type = _typeof(value); // Convert "+=" or "-=" to relative numbers (#7345)

        if (type === "string" && (ret = rcssNum.exec(value)) && ret[1]) {
          value = adjustCSS(elem, name, ret); // Fixes bug #9237

          type = "number";
        } // Make sure that null and NaN values aren't set (#7116)


        if (value == null || value !== value) {
          return;
        } // If a number was passed in, add the unit (except for certain CSS properties)


        if (type === "number") {
          value += ret && ret[3] || (jQuery.cssNumber[origName] ? "" : "px");
        } // background-* props affect original clone's values


        if (!support.clearCloneStyle && value === "" && name.indexOf("background") === 0) {
          style[name] = "inherit";
        } // If a hook was provided, use that value, otherwise just set the specified value


        if (!hooks || !("set" in hooks) || (value = hooks.set(elem, value, extra)) !== undefined) {
          style[name] = value;
        }
      } else {
        // If a hook was provided get the non-computed value from there
        if (hooks && "get" in hooks && (ret = hooks.get(elem, false, extra)) !== undefined) {
          return ret;
        } // Otherwise just get the value from the style object


        return style[name];
      }
    },
    css: function css(elem, name, extra, styles) {
      var val,
          num,
          hooks,
          origName = jQuery.camelCase(name); // Make sure that we're working with the right name

      name = jQuery.cssProps[origName] || (jQuery.cssProps[origName] = vendorPropName(origName) || origName); // Try prefixed name followed by the unprefixed name

      hooks = jQuery.cssHooks[name] || jQuery.cssHooks[origName]; // If a hook was provided get the computed value from there

      if (hooks && "get" in hooks) {
        val = hooks.get(elem, true, extra);
      } // Otherwise, if a way to get the computed value exists, use that


      if (val === undefined) {
        val = curCSS(elem, name, styles);
      } // Convert "normal" to computed value


      if (val === "normal" && name in cssNormalTransform) {
        val = cssNormalTransform[name];
      } // Make numeric if forced or a qualifier was provided and val looks numeric


      if (extra === "" || extra) {
        num = parseFloat(val);
        return extra === true || isFinite(num) ? num || 0 : val;
      }

      return val;
    }
  });
  jQuery.each(["height", "width"], function (i, name) {
    jQuery.cssHooks[name] = {
      get: function get(elem, computed, extra) {
        if (computed) {
          // Certain elements can have dimension info if we invisibly show them
          // but it must have a current display style that would benefit
          return rdisplayswap.test(jQuery.css(elem, "display")) && ( // Support: Safari 8+
          // Table columns in Safari have non-zero offsetWidth & zero
          // getBoundingClientRect().width unless display is changed.
          // Support: IE <=11 only
          // Running getBoundingClientRect on a disconnected node
          // in IE throws an error.
          !elem.getClientRects().length || !elem.getBoundingClientRect().width) ? swap(elem, cssShow, function () {
            return getWidthOrHeight(elem, name, extra);
          }) : getWidthOrHeight(elem, name, extra);
        }
      },
      set: function set(elem, value, extra) {
        var matches,
            styles = extra && getStyles(elem),
            subtract = extra && augmentWidthOrHeight(elem, name, extra, jQuery.css(elem, "boxSizing", false, styles) === "border-box", styles); // Convert to pixels if value adjustment is needed

        if (subtract && (matches = rcssNum.exec(value)) && (matches[3] || "px") !== "px") {
          elem.style[name] = value;
          value = jQuery.css(elem, name);
        }

        return setPositiveNumber(elem, value, subtract);
      }
    };
  });
  jQuery.cssHooks.marginLeft = addGetHookIf(support.reliableMarginLeft, function (elem, computed) {
    if (computed) {
      return (parseFloat(curCSS(elem, "marginLeft")) || elem.getBoundingClientRect().left - swap(elem, {
        marginLeft: 0
      }, function () {
        return elem.getBoundingClientRect().left;
      })) + "px";
    }
  }); // These hooks are used by animate to expand properties

  jQuery.each({
    margin: "",
    padding: "",
    border: "Width"
  }, function (prefix, suffix) {
    jQuery.cssHooks[prefix + suffix] = {
      expand: function expand(value) {
        var i = 0,
            expanded = {},
            // Assumes a single number if not a string
        parts = typeof value === "string" ? value.split(" ") : [value];

        for (; i < 4; i++) {
          expanded[prefix + cssExpand[i] + suffix] = parts[i] || parts[i - 2] || parts[0];
        }

        return expanded;
      }
    };

    if (!rmargin.test(prefix)) {
      jQuery.cssHooks[prefix + suffix].set = setPositiveNumber;
    }
  });
  jQuery.fn.extend({
    css: function css(name, value) {
      return access(this, function (elem, name, value) {
        var styles,
            len,
            map = {},
            i = 0;

        if (jQuery.isArray(name)) {
          styles = getStyles(elem);
          len = name.length;

          for (; i < len; i++) {
            map[name[i]] = jQuery.css(elem, name[i], false, styles);
          }

          return map;
        }

        return value !== undefined ? jQuery.style(elem, name, value) : jQuery.css(elem, name);
      }, name, value, arguments.length > 1);
    }
  });

  function Tween(elem, options, prop, end, easing) {
    return new Tween.prototype.init(elem, options, prop, end, easing);
  }

  jQuery.Tween = Tween;
  Tween.prototype = {
    constructor: Tween,
    init: function init(elem, options, prop, end, easing, unit) {
      this.elem = elem;
      this.prop = prop;
      this.easing = easing || jQuery.easing._default;
      this.options = options;
      this.start = this.now = this.cur();
      this.end = end;
      this.unit = unit || (jQuery.cssNumber[prop] ? "" : "px");
    },
    cur: function cur() {
      var hooks = Tween.propHooks[this.prop];
      return hooks && hooks.get ? hooks.get(this) : Tween.propHooks._default.get(this);
    },
    run: function run(percent) {
      var eased,
          hooks = Tween.propHooks[this.prop];

      if (this.options.duration) {
        this.pos = eased = jQuery.easing[this.easing](percent, this.options.duration * percent, 0, 1, this.options.duration);
      } else {
        this.pos = eased = percent;
      }

      this.now = (this.end - this.start) * eased + this.start;

      if (this.options.step) {
        this.options.step.call(this.elem, this.now, this);
      }

      if (hooks && hooks.set) {
        hooks.set(this);
      } else {
        Tween.propHooks._default.set(this);
      }

      return this;
    }
  };
  Tween.prototype.init.prototype = Tween.prototype;
  Tween.propHooks = {
    _default: {
      get: function get(tween) {
        var result; // Use a property on the element directly when it is not a DOM element,
        // or when there is no matching style property that exists.

        if (tween.elem.nodeType !== 1 || tween.elem[tween.prop] != null && tween.elem.style[tween.prop] == null) {
          return tween.elem[tween.prop];
        } // Passing an empty string as a 3rd parameter to .css will automatically
        // attempt a parseFloat and fallback to a string if the parse fails.
        // Simple values such as "10px" are parsed to Float;
        // complex values such as "rotate(1rad)" are returned as-is.


        result = jQuery.css(tween.elem, tween.prop, ""); // Empty strings, null, undefined and "auto" are converted to 0.

        return !result || result === "auto" ? 0 : result;
      },
      set: function set(tween) {
        // Use step hook for back compat.
        // Use cssHook if its there.
        // Use .style if available and use plain properties where available.
        if (jQuery.fx.step[tween.prop]) {
          jQuery.fx.step[tween.prop](tween);
        } else if (tween.elem.nodeType === 1 && (tween.elem.style[jQuery.cssProps[tween.prop]] != null || jQuery.cssHooks[tween.prop])) {
          jQuery.style(tween.elem, tween.prop, tween.now + tween.unit);
        } else {
          tween.elem[tween.prop] = tween.now;
        }
      }
    }
  }; // Support: IE <=9 only
  // Panic based approach to setting things on disconnected nodes

  Tween.propHooks.scrollTop = Tween.propHooks.scrollLeft = {
    set: function set(tween) {
      if (tween.elem.nodeType && tween.elem.parentNode) {
        tween.elem[tween.prop] = tween.now;
      }
    }
  };
  jQuery.easing = {
    linear: function linear(p) {
      return p;
    },
    swing: function swing(p) {
      return 0.5 - Math.cos(p * Math.PI) / 2;
    },
    _default: "swing"
  };
  jQuery.fx = Tween.prototype.init; // Back compat <1.8 extension point

  jQuery.fx.step = {};
  var fxNow,
      timerId,
      rfxtypes = /^(?:toggle|show|hide)$/,
      rrun = /queueHooks$/;

  function raf() {
    if (timerId) {
      window.requestAnimationFrame(raf);
      jQuery.fx.tick();
    }
  } // Animations created synchronously will run synchronously


  function createFxNow() {
    window.setTimeout(function () {
      fxNow = undefined;
    });
    return fxNow = jQuery.now();
  } // Generate parameters to create a standard animation


  function genFx(type, includeWidth) {
    var which,
        i = 0,
        attrs = {
      height: type
    }; // If we include width, step value is 1 to do all cssExpand values,
    // otherwise step value is 2 to skip over Left and Right

    includeWidth = includeWidth ? 1 : 0;

    for (; i < 4; i += 2 - includeWidth) {
      which = cssExpand[i];
      attrs["margin" + which] = attrs["padding" + which] = type;
    }

    if (includeWidth) {
      attrs.opacity = attrs.width = type;
    }

    return attrs;
  }

  function createTween(value, prop, animation) {
    var tween,
        collection = (Animation.tweeners[prop] || []).concat(Animation.tweeners["*"]),
        index = 0,
        length = collection.length;

    for (; index < length; index++) {
      if (tween = collection[index].call(animation, prop, value)) {
        // We're done with this property
        return tween;
      }
    }
  }

  function defaultPrefilter(elem, props, opts) {
    var prop,
        value,
        toggle,
        hooks,
        oldfire,
        propTween,
        restoreDisplay,
        display,
        isBox = "width" in props || "height" in props,
        anim = this,
        orig = {},
        style = elem.style,
        hidden = elem.nodeType && isHiddenWithinTree(elem),
        dataShow = dataPriv.get(elem, "fxshow"); // Queue-skipping animations hijack the fx hooks

    if (!opts.queue) {
      hooks = jQuery._queueHooks(elem, "fx");

      if (hooks.unqueued == null) {
        hooks.unqueued = 0;
        oldfire = hooks.empty.fire;

        hooks.empty.fire = function () {
          if (!hooks.unqueued) {
            oldfire();
          }
        };
      }

      hooks.unqueued++;
      anim.always(function () {
        // Ensure the complete handler is called before this completes
        anim.always(function () {
          hooks.unqueued--;

          if (!jQuery.queue(elem, "fx").length) {
            hooks.empty.fire();
          }
        });
      });
    } // Detect show/hide animations


    for (prop in props) {
      value = props[prop];

      if (rfxtypes.test(value)) {
        delete props[prop];
        toggle = toggle || value === "toggle";

        if (value === (hidden ? "hide" : "show")) {
          // Pretend to be hidden if this is a "show" and
          // there is still data from a stopped show/hide
          if (value === "show" && dataShow && dataShow[prop] !== undefined) {
            hidden = true; // Ignore all other no-op show/hide data
          } else {
            continue;
          }
        }

        orig[prop] = dataShow && dataShow[prop] || jQuery.style(elem, prop);
      }
    } // Bail out if this is a no-op like .hide().hide()


    propTween = !jQuery.isEmptyObject(props);

    if (!propTween && jQuery.isEmptyObject(orig)) {
      return;
    } // Restrict "overflow" and "display" styles during box animations


    if (isBox && elem.nodeType === 1) {
      // Support: IE <=9 - 11, Edge 12 - 13
      // Record all 3 overflow attributes because IE does not infer the shorthand
      // from identically-valued overflowX and overflowY
      opts.overflow = [style.overflow, style.overflowX, style.overflowY]; // Identify a display type, preferring old show/hide data over the CSS cascade

      restoreDisplay = dataShow && dataShow.display;

      if (restoreDisplay == null) {
        restoreDisplay = dataPriv.get(elem, "display");
      }

      display = jQuery.css(elem, "display");

      if (display === "none") {
        if (restoreDisplay) {
          display = restoreDisplay;
        } else {
          // Get nonempty value(s) by temporarily forcing visibility
          showHide([elem], true);
          restoreDisplay = elem.style.display || restoreDisplay;
          display = jQuery.css(elem, "display");
          showHide([elem]);
        }
      } // Animate inline elements as inline-block


      if (display === "inline" || display === "inline-block" && restoreDisplay != null) {
        if (jQuery.css(elem, "float") === "none") {
          // Restore the original display value at the end of pure show/hide animations
          if (!propTween) {
            anim.done(function () {
              style.display = restoreDisplay;
            });

            if (restoreDisplay == null) {
              display = style.display;
              restoreDisplay = display === "none" ? "" : display;
            }
          }

          style.display = "inline-block";
        }
      }
    }

    if (opts.overflow) {
      style.overflow = "hidden";
      anim.always(function () {
        style.overflow = opts.overflow[0];
        style.overflowX = opts.overflow[1];
        style.overflowY = opts.overflow[2];
      });
    } // Implement show/hide animations


    propTween = false;

    for (prop in orig) {
      // General show/hide setup for this element animation
      if (!propTween) {
        if (dataShow) {
          if ("hidden" in dataShow) {
            hidden = dataShow.hidden;
          }
        } else {
          dataShow = dataPriv.access(elem, "fxshow", {
            display: restoreDisplay
          });
        } // Store hidden/visible for toggle so `.stop().toggle()` "reverses"


        if (toggle) {
          dataShow.hidden = !hidden;
        } // Show elements before animating them


        if (hidden) {
          showHide([elem], true);
        }
        /* eslint-disable no-loop-func */


        anim.done(function () {
          /* eslint-enable no-loop-func */
          // The final step of a "hide" animation is actually hiding the element
          if (!hidden) {
            showHide([elem]);
          }

          dataPriv.remove(elem, "fxshow");

          for (prop in orig) {
            jQuery.style(elem, prop, orig[prop]);
          }
        });
      } // Per-property setup


      propTween = createTween(hidden ? dataShow[prop] : 0, prop, anim);

      if (!(prop in dataShow)) {
        dataShow[prop] = propTween.start;

        if (hidden) {
          propTween.end = propTween.start;
          propTween.start = 0;
        }
      }
    }
  }

  function propFilter(props, specialEasing) {
    var index, name, easing, value, hooks; // camelCase, specialEasing and expand cssHook pass

    for (index in props) {
      name = jQuery.camelCase(index);
      easing = specialEasing[name];
      value = props[index];

      if (jQuery.isArray(value)) {
        easing = value[1];
        value = props[index] = value[0];
      }

      if (index !== name) {
        props[name] = value;
        delete props[index];
      }

      hooks = jQuery.cssHooks[name];

      if (hooks && "expand" in hooks) {
        value = hooks.expand(value);
        delete props[name]; // Not quite $.extend, this won't overwrite existing keys.
        // Reusing 'index' because we have the correct "name"

        for (index in value) {
          if (!(index in props)) {
            props[index] = value[index];
            specialEasing[index] = easing;
          }
        }
      } else {
        specialEasing[name] = easing;
      }
    }
  }

  function Animation(elem, properties, options) {
    var result,
        stopped,
        index = 0,
        length = Animation.prefilters.length,
        deferred = jQuery.Deferred().always(function () {
      // Don't match elem in the :animated selector
      delete tick.elem;
    }),
        tick = function tick() {
      if (stopped) {
        return false;
      }

      var currentTime = fxNow || createFxNow(),
          remaining = Math.max(0, animation.startTime + animation.duration - currentTime),
          // Support: Android 2.3 only
      // Archaic crash bug won't allow us to use `1 - ( 0.5 || 0 )` (#12497)
      temp = remaining / animation.duration || 0,
          percent = 1 - temp,
          index = 0,
          length = animation.tweens.length;

      for (; index < length; index++) {
        animation.tweens[index].run(percent);
      }

      deferred.notifyWith(elem, [animation, percent, remaining]);

      if (percent < 1 && length) {
        return remaining;
      } else {
        deferred.resolveWith(elem, [animation]);
        return false;
      }
    },
        animation = deferred.promise({
      elem: elem,
      props: jQuery.extend({}, properties),
      opts: jQuery.extend(true, {
        specialEasing: {},
        easing: jQuery.easing._default
      }, options),
      originalProperties: properties,
      originalOptions: options,
      startTime: fxNow || createFxNow(),
      duration: options.duration,
      tweens: [],
      createTween: function createTween(prop, end) {
        var tween = jQuery.Tween(elem, animation.opts, prop, end, animation.opts.specialEasing[prop] || animation.opts.easing);
        animation.tweens.push(tween);
        return tween;
      },
      stop: function stop(gotoEnd) {
        var index = 0,
            // If we are going to the end, we want to run all the tweens
        // otherwise we skip this part
        length = gotoEnd ? animation.tweens.length : 0;

        if (stopped) {
          return this;
        }

        stopped = true;

        for (; index < length; index++) {
          animation.tweens[index].run(1);
        } // Resolve when we played the last frame; otherwise, reject


        if (gotoEnd) {
          deferred.notifyWith(elem, [animation, 1, 0]);
          deferred.resolveWith(elem, [animation, gotoEnd]);
        } else {
          deferred.rejectWith(elem, [animation, gotoEnd]);
        }

        return this;
      }
    }),
        props = animation.props;

    propFilter(props, animation.opts.specialEasing);

    for (; index < length; index++) {
      result = Animation.prefilters[index].call(animation, elem, props, animation.opts);

      if (result) {
        if (jQuery.isFunction(result.stop)) {
          jQuery._queueHooks(animation.elem, animation.opts.queue).stop = jQuery.proxy(result.stop, result);
        }

        return result;
      }
    }

    jQuery.map(props, createTween, animation);

    if (jQuery.isFunction(animation.opts.start)) {
      animation.opts.start.call(elem, animation);
    }

    jQuery.fx.timer(jQuery.extend(tick, {
      elem: elem,
      anim: animation,
      queue: animation.opts.queue
    })); // attach callbacks from options

    return animation.progress(animation.opts.progress).done(animation.opts.done, animation.opts.complete).fail(animation.opts.fail).always(animation.opts.always);
  }

  jQuery.Animation = jQuery.extend(Animation, {
    tweeners: {
      "*": [function (prop, value) {
        var tween = this.createTween(prop, value);
        adjustCSS(tween.elem, prop, rcssNum.exec(value), tween);
        return tween;
      }]
    },
    tweener: function tweener(props, callback) {
      if (jQuery.isFunction(props)) {
        callback = props;
        props = ["*"];
      } else {
        props = props.match(rnothtmlwhite);
      }

      var prop,
          index = 0,
          length = props.length;

      for (; index < length; index++) {
        prop = props[index];
        Animation.tweeners[prop] = Animation.tweeners[prop] || [];
        Animation.tweeners[prop].unshift(callback);
      }
    },
    prefilters: [defaultPrefilter],
    prefilter: function prefilter(callback, prepend) {
      if (prepend) {
        Animation.prefilters.unshift(callback);
      } else {
        Animation.prefilters.push(callback);
      }
    }
  });

  jQuery.speed = function (speed, easing, fn) {
    var opt = speed && _typeof(speed) === "object" ? jQuery.extend({}, speed) : {
      complete: fn || !fn && easing || jQuery.isFunction(speed) && speed,
      duration: speed,
      easing: fn && easing || easing && !jQuery.isFunction(easing) && easing
    }; // Go to the end state if fx are off or if document is hidden

    if (jQuery.fx.off || document.hidden) {
      opt.duration = 0;
    } else {
      if (typeof opt.duration !== "number") {
        if (opt.duration in jQuery.fx.speeds) {
          opt.duration = jQuery.fx.speeds[opt.duration];
        } else {
          opt.duration = jQuery.fx.speeds._default;
        }
      }
    } // Normalize opt.queue - true/undefined/null -> "fx"


    if (opt.queue == null || opt.queue === true) {
      opt.queue = "fx";
    } // Queueing


    opt.old = opt.complete;

    opt.complete = function () {
      if (jQuery.isFunction(opt.old)) {
        opt.old.call(this);
      }

      if (opt.queue) {
        jQuery.dequeue(this, opt.queue);
      }
    };

    return opt;
  };

  jQuery.fn.extend({
    fadeTo: function fadeTo(speed, to, easing, callback) {
      // Show any hidden elements after setting opacity to 0
      return this.filter(isHiddenWithinTree).css("opacity", 0).show() // Animate to the value specified
      .end().animate({
        opacity: to
      }, speed, easing, callback);
    },
    animate: function animate(prop, speed, easing, callback) {
      var empty = jQuery.isEmptyObject(prop),
          optall = jQuery.speed(speed, easing, callback),
          doAnimation = function doAnimation() {
        // Operate on a copy of prop so per-property easing won't be lost
        var anim = Animation(this, jQuery.extend({}, prop), optall); // Empty animations, or finishing resolves immediately

        if (empty || dataPriv.get(this, "finish")) {
          anim.stop(true);
        }
      };

      doAnimation.finish = doAnimation;
      return empty || optall.queue === false ? this.each(doAnimation) : this.queue(optall.queue, doAnimation);
    },
    stop: function stop(type, clearQueue, gotoEnd) {
      var stopQueue = function stopQueue(hooks) {
        var stop = hooks.stop;
        delete hooks.stop;
        stop(gotoEnd);
      };

      if (typeof type !== "string") {
        gotoEnd = clearQueue;
        clearQueue = type;
        type = undefined;
      }

      if (clearQueue && type !== false) {
        this.queue(type || "fx", []);
      }

      return this.each(function () {
        var dequeue = true,
            index = type != null && type + "queueHooks",
            timers = jQuery.timers,
            data = dataPriv.get(this);

        if (index) {
          if (data[index] && data[index].stop) {
            stopQueue(data[index]);
          }
        } else {
          for (index in data) {
            if (data[index] && data[index].stop && rrun.test(index)) {
              stopQueue(data[index]);
            }
          }
        }

        for (index = timers.length; index--;) {
          if (timers[index].elem === this && (type == null || timers[index].queue === type)) {
            timers[index].anim.stop(gotoEnd);
            dequeue = false;
            timers.splice(index, 1);
          }
        } // Start the next in the queue if the last step wasn't forced.
        // Timers currently will call their complete callbacks, which
        // will dequeue but only if they were gotoEnd.


        if (dequeue || !gotoEnd) {
          jQuery.dequeue(this, type);
        }
      });
    },
    finish: function finish(type) {
      if (type !== false) {
        type = type || "fx";
      }

      return this.each(function () {
        var index,
            data = dataPriv.get(this),
            queue = data[type + "queue"],
            hooks = data[type + "queueHooks"],
            timers = jQuery.timers,
            length = queue ? queue.length : 0; // Enable finishing flag on private data

        data.finish = true; // Empty the queue first

        jQuery.queue(this, type, []);

        if (hooks && hooks.stop) {
          hooks.stop.call(this, true);
        } // Look for any active animations, and finish them


        for (index = timers.length; index--;) {
          if (timers[index].elem === this && timers[index].queue === type) {
            timers[index].anim.stop(true);
            timers.splice(index, 1);
          }
        } // Look for any animations in the old queue and finish them


        for (index = 0; index < length; index++) {
          if (queue[index] && queue[index].finish) {
            queue[index].finish.call(this);
          }
        } // Turn off finishing flag


        delete data.finish;
      });
    }
  });
  jQuery.each(["toggle", "show", "hide"], function (i, name) {
    var cssFn = jQuery.fn[name];

    jQuery.fn[name] = function (speed, easing, callback) {
      return speed == null || typeof speed === "boolean" ? cssFn.apply(this, arguments) : this.animate(genFx(name, true), speed, easing, callback);
    };
  }); // Generate shortcuts for custom animations

  jQuery.each({
    slideDown: genFx("show"),
    slideUp: genFx("hide"),
    slideToggle: genFx("toggle"),
    fadeIn: {
      opacity: "show"
    },
    fadeOut: {
      opacity: "hide"
    },
    fadeToggle: {
      opacity: "toggle"
    }
  }, function (name, props) {
    jQuery.fn[name] = function (speed, easing, callback) {
      return this.animate(props, speed, easing, callback);
    };
  });
  jQuery.timers = [];

  jQuery.fx.tick = function () {
    var timer,
        i = 0,
        timers = jQuery.timers;
    fxNow = jQuery.now();

    for (; i < timers.length; i++) {
      timer = timers[i]; // Checks the timer has not already been removed

      if (!timer() && timers[i] === timer) {
        timers.splice(i--, 1);
      }
    }

    if (!timers.length) {
      jQuery.fx.stop();
    }

    fxNow = undefined;
  };

  jQuery.fx.timer = function (timer) {
    jQuery.timers.push(timer);

    if (timer()) {
      jQuery.fx.start();
    } else {
      jQuery.timers.pop();
    }
  };

  jQuery.fx.interval = 13;

  jQuery.fx.start = function () {
    if (!timerId) {
      timerId = window.requestAnimationFrame ? window.requestAnimationFrame(raf) : window.setInterval(jQuery.fx.tick, jQuery.fx.interval);
    }
  };

  jQuery.fx.stop = function () {
    if (window.cancelAnimationFrame) {
      window.cancelAnimationFrame(timerId);
    } else {
      window.clearInterval(timerId);
    }

    timerId = null;
  };

  jQuery.fx.speeds = {
    slow: 600,
    fast: 200,
    // Default speed
    _default: 400
  }; // Based off of the plugin by Clint Helfers, with permission.
  // https://web.archive.org/web/20100324014747/http://blindsignals.com/index.php/2009/07/jquery-delay/

  jQuery.fn.delay = function (time, type) {
    time = jQuery.fx ? jQuery.fx.speeds[time] || time : time;
    type = type || "fx";
    return this.queue(type, function (next, hooks) {
      var timeout = window.setTimeout(next, time);

      hooks.stop = function () {
        window.clearTimeout(timeout);
      };
    });
  };

  (function () {
    var input = document.createElement("input"),
        select = document.createElement("select"),
        opt = select.appendChild(document.createElement("option"));
    input.type = "checkbox"; // Support: Android <=4.3 only
    // Default value for a checkbox should be "on"

    support.checkOn = input.value !== ""; // Support: IE <=11 only
    // Must access selectedIndex to make default options select

    support.optSelected = opt.selected; // Support: IE <=11 only
    // An input loses its value after becoming a radio

    input = document.createElement("input");
    input.value = "t";
    input.type = "radio";
    support.radioValue = input.value === "t";
  })();

  var boolHook,
      attrHandle = jQuery.expr.attrHandle;
  jQuery.fn.extend({
    attr: function attr(name, value) {
      return access(this, jQuery.attr, name, value, arguments.length > 1);
    },
    removeAttr: function removeAttr(name) {
      return this.each(function () {
        jQuery.removeAttr(this, name);
      });
    }
  });
  jQuery.extend({
    attr: function attr(elem, name, value) {
      var ret,
          hooks,
          nType = elem.nodeType; // Don't get/set attributes on text, comment and attribute nodes

      if (nType === 3 || nType === 8 || nType === 2) {
        return;
      } // Fallback to prop when attributes are not supported


      if (typeof elem.getAttribute === "undefined") {
        return jQuery.prop(elem, name, value);
      } // Attribute hooks are determined by the lowercase version
      // Grab necessary hook if one is defined


      if (nType !== 1 || !jQuery.isXMLDoc(elem)) {
        hooks = jQuery.attrHooks[name.toLowerCase()] || (jQuery.expr.match.bool.test(name) ? boolHook : undefined);
      }

      if (value !== undefined) {
        if (value === null) {
          jQuery.removeAttr(elem, name);
          return;
        }

        if (hooks && "set" in hooks && (ret = hooks.set(elem, value, name)) !== undefined) {
          return ret;
        }

        elem.setAttribute(name, value + "");
        return value;
      }

      if (hooks && "get" in hooks && (ret = hooks.get(elem, name)) !== null) {
        return ret;
      }

      ret = jQuery.find.attr(elem, name); // Non-existent attributes return null, we normalize to undefined

      return ret == null ? undefined : ret;
    },
    attrHooks: {
      type: {
        set: function set(elem, value) {
          if (!support.radioValue && value === "radio" && jQuery.nodeName(elem, "input")) {
            var val = elem.value;
            elem.setAttribute("type", value);

            if (val) {
              elem.value = val;
            }

            return value;
          }
        }
      }
    },
    removeAttr: function removeAttr(elem, value) {
      var name,
          i = 0,
          // Attribute names can contain non-HTML whitespace characters
      // https://html.spec.whatwg.org/multipage/syntax.html#attributes-2
      attrNames = value && value.match(rnothtmlwhite);

      if (attrNames && elem.nodeType === 1) {
        while (name = attrNames[i++]) {
          elem.removeAttribute(name);
        }
      }
    }
  }); // Hooks for boolean attributes

  boolHook = {
    set: function set(elem, value, name) {
      if (value === false) {
        // Remove boolean attributes when set to false
        jQuery.removeAttr(elem, name);
      } else {
        elem.setAttribute(name, name);
      }

      return name;
    }
  };
  jQuery.each(jQuery.expr.match.bool.source.match(/\w+/g), function (i, name) {
    var getter = attrHandle[name] || jQuery.find.attr;

    attrHandle[name] = function (elem, name, isXML) {
      var ret,
          handle,
          lowercaseName = name.toLowerCase();

      if (!isXML) {
        // Avoid an infinite loop by temporarily removing this function from the getter
        handle = attrHandle[lowercaseName];
        attrHandle[lowercaseName] = ret;
        ret = getter(elem, name, isXML) != null ? lowercaseName : null;
        attrHandle[lowercaseName] = handle;
      }

      return ret;
    };
  });
  var rfocusable = /^(?:input|select|textarea|button)$/i,
      rclickable = /^(?:a|area)$/i;
  jQuery.fn.extend({
    prop: function prop(name, value) {
      return access(this, jQuery.prop, name, value, arguments.length > 1);
    },
    removeProp: function removeProp(name) {
      return this.each(function () {
        delete this[jQuery.propFix[name] || name];
      });
    }
  });
  jQuery.extend({
    prop: function prop(elem, name, value) {
      var ret,
          hooks,
          nType = elem.nodeType; // Don't get/set properties on text, comment and attribute nodes

      if (nType === 3 || nType === 8 || nType === 2) {
        return;
      }

      if (nType !== 1 || !jQuery.isXMLDoc(elem)) {
        // Fix name and attach hooks
        name = jQuery.propFix[name] || name;
        hooks = jQuery.propHooks[name];
      }

      if (value !== undefined) {
        if (hooks && "set" in hooks && (ret = hooks.set(elem, value, name)) !== undefined) {
          return ret;
        }

        return elem[name] = value;
      }

      if (hooks && "get" in hooks && (ret = hooks.get(elem, name)) !== null) {
        return ret;
      }

      return elem[name];
    },
    propHooks: {
      tabIndex: {
        get: function get(elem) {
          // Support: IE <=9 - 11 only
          // elem.tabIndex doesn't always return the
          // correct value when it hasn't been explicitly set
          // https://web.archive.org/web/20141116233347/http://fluidproject.org/blog/2008/01/09/getting-setting-and-removing-tabindex-values-with-javascript/
          // Use proper attribute retrieval(#12072)
          var tabindex = jQuery.find.attr(elem, "tabindex");

          if (tabindex) {
            return parseInt(tabindex, 10);
          }

          if (rfocusable.test(elem.nodeName) || rclickable.test(elem.nodeName) && elem.href) {
            return 0;
          }

          return -1;
        }
      }
    },
    propFix: {
      "for": "htmlFor",
      "class": "className"
    }
  }); // Support: IE <=11 only
  // Accessing the selectedIndex property
  // forces the browser to respect setting selected
  // on the option
  // The getter ensures a default option is selected
  // when in an optgroup
  // eslint rule "no-unused-expressions" is disabled for this code
  // since it considers such accessions noop

  if (!support.optSelected) {
    jQuery.propHooks.selected = {
      get: function get(elem) {
        /* eslint no-unused-expressions: "off" */
        var parent = elem.parentNode;

        if (parent && parent.parentNode) {
          parent.parentNode.selectedIndex;
        }

        return null;
      },
      set: function set(elem) {
        /* eslint no-unused-expressions: "off" */
        var parent = elem.parentNode;

        if (parent) {
          parent.selectedIndex;

          if (parent.parentNode) {
            parent.parentNode.selectedIndex;
          }
        }
      }
    };
  }

  jQuery.each(["tabIndex", "readOnly", "maxLength", "cellSpacing", "cellPadding", "rowSpan", "colSpan", "useMap", "frameBorder", "contentEditable"], function () {
    jQuery.propFix[this.toLowerCase()] = this;
  }); // Strip and collapse whitespace according to HTML spec
  // https://html.spec.whatwg.org/multipage/infrastructure.html#strip-and-collapse-whitespace

  function stripAndCollapse(value) {
    var tokens = value.match(rnothtmlwhite) || [];
    return tokens.join(" ");
  }

  function getClass(elem) {
    return elem.getAttribute && elem.getAttribute("class") || "";
  }

  jQuery.fn.extend({
    addClass: function addClass(value) {
      var classes,
          elem,
          cur,
          curValue,
          clazz,
          j,
          finalValue,
          i = 0;

      if (jQuery.isFunction(value)) {
        return this.each(function (j) {
          jQuery(this).addClass(value.call(this, j, getClass(this)));
        });
      }

      if (typeof value === "string" && value) {
        classes = value.match(rnothtmlwhite) || [];

        while (elem = this[i++]) {
          curValue = getClass(elem);
          cur = elem.nodeType === 1 && " " + stripAndCollapse(curValue) + " ";

          if (cur) {
            j = 0;

            while (clazz = classes[j++]) {
              if (cur.indexOf(" " + clazz + " ") < 0) {
                cur += clazz + " ";
              }
            } // Only assign if different to avoid unneeded rendering.


            finalValue = stripAndCollapse(cur);

            if (curValue !== finalValue) {
              elem.setAttribute("class", finalValue);
            }
          }
        }
      }

      return this;
    },
    removeClass: function removeClass(value) {
      var classes,
          elem,
          cur,
          curValue,
          clazz,
          j,
          finalValue,
          i = 0;

      if (jQuery.isFunction(value)) {
        return this.each(function (j) {
          jQuery(this).removeClass(value.call(this, j, getClass(this)));
        });
      }

      if (!arguments.length) {
        return this.attr("class", "");
      }

      if (typeof value === "string" && value) {
        classes = value.match(rnothtmlwhite) || [];

        while (elem = this[i++]) {
          curValue = getClass(elem); // This expression is here for better compressibility (see addClass)

          cur = elem.nodeType === 1 && " " + stripAndCollapse(curValue) + " ";

          if (cur) {
            j = 0;

            while (clazz = classes[j++]) {
              // Remove *all* instances
              while (cur.indexOf(" " + clazz + " ") > -1) {
                cur = cur.replace(" " + clazz + " ", " ");
              }
            } // Only assign if different to avoid unneeded rendering.


            finalValue = stripAndCollapse(cur);

            if (curValue !== finalValue) {
              elem.setAttribute("class", finalValue);
            }
          }
        }
      }

      return this;
    },
    toggleClass: function toggleClass(value, stateVal) {
      var type = _typeof(value);

      if (typeof stateVal === "boolean" && type === "string") {
        return stateVal ? this.addClass(value) : this.removeClass(value);
      }

      if (jQuery.isFunction(value)) {
        return this.each(function (i) {
          jQuery(this).toggleClass(value.call(this, i, getClass(this), stateVal), stateVal);
        });
      }

      return this.each(function () {
        var className, i, self, classNames;

        if (type === "string") {
          // Toggle individual class names
          i = 0;
          self = jQuery(this);
          classNames = value.match(rnothtmlwhite) || [];

          while (className = classNames[i++]) {
            // Check each className given, space separated list
            if (self.hasClass(className)) {
              self.removeClass(className);
            } else {
              self.addClass(className);
            }
          } // Toggle whole class name

        } else if (value === undefined || type === "boolean") {
          className = getClass(this);

          if (className) {
            // Store className if set
            dataPriv.set(this, "__className__", className);
          } // If the element has a class name or if we're passed `false`,
          // then remove the whole classname (if there was one, the above saved it).
          // Otherwise bring back whatever was previously saved (if anything),
          // falling back to the empty string if nothing was stored.


          if (this.setAttribute) {
            this.setAttribute("class", className || value === false ? "" : dataPriv.get(this, "__className__") || "");
          }
        }
      });
    },
    hasClass: function hasClass(selector) {
      var className,
          elem,
          i = 0;
      className = " " + selector + " ";

      while (elem = this[i++]) {
        if (elem.nodeType === 1 && (" " + stripAndCollapse(getClass(elem)) + " ").indexOf(className) > -1) {
          return true;
        }
      }

      return false;
    }
  });
  var rreturn = /\r/g;
  jQuery.fn.extend({
    val: function val(value) {
      var hooks,
          ret,
          isFunction,
          elem = this[0];

      if (!arguments.length) {
        if (elem) {
          hooks = jQuery.valHooks[elem.type] || jQuery.valHooks[elem.nodeName.toLowerCase()];

          if (hooks && "get" in hooks && (ret = hooks.get(elem, "value")) !== undefined) {
            return ret;
          }

          ret = elem.value; // Handle most common string cases

          if (typeof ret === "string") {
            return ret.replace(rreturn, "");
          } // Handle cases where value is null/undef or number


          return ret == null ? "" : ret;
        }

        return;
      }

      isFunction = jQuery.isFunction(value);
      return this.each(function (i) {
        var val;

        if (this.nodeType !== 1) {
          return;
        }

        if (isFunction) {
          val = value.call(this, i, jQuery(this).val());
        } else {
          val = value;
        } // Treat null/undefined as ""; convert numbers to string


        if (val == null) {
          val = "";
        } else if (typeof val === "number") {
          val += "";
        } else if (jQuery.isArray(val)) {
          val = jQuery.map(val, function (value) {
            return value == null ? "" : value + "";
          });
        }

        hooks = jQuery.valHooks[this.type] || jQuery.valHooks[this.nodeName.toLowerCase()]; // If set returns undefined, fall back to normal setting

        if (!hooks || !("set" in hooks) || hooks.set(this, val, "value") === undefined) {
          this.value = val;
        }
      });
    }
  });
  jQuery.extend({
    valHooks: {
      option: {
        get: function get(elem) {
          var val = jQuery.find.attr(elem, "value");
          return val != null ? val : // Support: IE <=10 - 11 only
          // option.text throws exceptions (#14686, #14858)
          // Strip and collapse whitespace
          // https://html.spec.whatwg.org/#strip-and-collapse-whitespace
          stripAndCollapse(jQuery.text(elem));
        }
      },
      select: {
        get: function get(elem) {
          var value,
              option,
              i,
              options = elem.options,
              index = elem.selectedIndex,
              one = elem.type === "select-one",
              values = one ? null : [],
              max = one ? index + 1 : options.length;

          if (index < 0) {
            i = max;
          } else {
            i = one ? index : 0;
          } // Loop through all the selected options


          for (; i < max; i++) {
            option = options[i]; // Support: IE <=9 only
            // IE8-9 doesn't update selected after form reset (#2551)

            if ((option.selected || i === index) && // Don't return options that are disabled or in a disabled optgroup
            !option.disabled && (!option.parentNode.disabled || !jQuery.nodeName(option.parentNode, "optgroup"))) {
              // Get the specific value for the option
              value = jQuery(option).val(); // We don't need an array for one selects

              if (one) {
                return value;
              } // Multi-Selects return an array


              values.push(value);
            }
          }

          return values;
        },
        set: function set(elem, value) {
          var optionSet,
              option,
              options = elem.options,
              values = jQuery.makeArray(value),
              i = options.length;

          while (i--) {
            option = options[i];
            /* eslint-disable no-cond-assign */

            if (option.selected = jQuery.inArray(jQuery.valHooks.option.get(option), values) > -1) {
              optionSet = true;
            }
            /* eslint-enable no-cond-assign */

          } // Force browsers to behave consistently when non-matching value is set


          if (!optionSet) {
            elem.selectedIndex = -1;
          }

          return values;
        }
      }
    }
  }); // Radios and checkboxes getter/setter

  jQuery.each(["radio", "checkbox"], function () {
    jQuery.valHooks[this] = {
      set: function set(elem, value) {
        if (jQuery.isArray(value)) {
          return elem.checked = jQuery.inArray(jQuery(elem).val(), value) > -1;
        }
      }
    };

    if (!support.checkOn) {
      jQuery.valHooks[this].get = function (elem) {
        return elem.getAttribute("value") === null ? "on" : elem.value;
      };
    }
  }); // Return jQuery for attributes-only inclusion

  var rfocusMorph = /^(?:focusinfocus|focusoutblur)$/;
  jQuery.extend(jQuery.event, {
    trigger: function trigger(event, data, elem, onlyHandlers) {
      var i,
          cur,
          tmp,
          bubbleType,
          ontype,
          handle,
          special,
          eventPath = [elem || document],
          type = hasOwn.call(event, "type") ? event.type : event,
          namespaces = hasOwn.call(event, "namespace") ? event.namespace.split(".") : [];
      cur = tmp = elem = elem || document; // Don't do events on text and comment nodes

      if (elem.nodeType === 3 || elem.nodeType === 8) {
        return;
      } // focus/blur morphs to focusin/out; ensure we're not firing them right now


      if (rfocusMorph.test(type + jQuery.event.triggered)) {
        return;
      }

      if (type.indexOf(".") > -1) {
        // Namespaced trigger; create a regexp to match event type in handle()
        namespaces = type.split(".");
        type = namespaces.shift();
        namespaces.sort();
      }

      ontype = type.indexOf(":") < 0 && "on" + type; // Caller can pass in a jQuery.Event object, Object, or just an event type string

      event = event[jQuery.expando] ? event : new jQuery.Event(type, _typeof(event) === "object" && event); // Trigger bitmask: & 1 for native handlers; & 2 for jQuery (always true)

      event.isTrigger = onlyHandlers ? 2 : 3;
      event.namespace = namespaces.join(".");
      event.rnamespace = event.namespace ? new RegExp("(^|\\.)" + namespaces.join("\\.(?:.*\\.|)") + "(\\.|$)") : null; // Clean up the event in case it is being reused

      event.result = undefined;

      if (!event.target) {
        event.target = elem;
      } // Clone any incoming data and prepend the event, creating the handler arg list


      data = data == null ? [event] : jQuery.makeArray(data, [event]); // Allow special events to draw outside the lines

      special = jQuery.event.special[type] || {};

      if (!onlyHandlers && special.trigger && special.trigger.apply(elem, data) === false) {
        return;
      } // Determine event propagation path in advance, per W3C events spec (#9951)
      // Bubble up to document, then to window; watch for a global ownerDocument var (#9724)


      if (!onlyHandlers && !special.noBubble && !jQuery.isWindow(elem)) {
        bubbleType = special.delegateType || type;

        if (!rfocusMorph.test(bubbleType + type)) {
          cur = cur.parentNode;
        }

        for (; cur; cur = cur.parentNode) {
          eventPath.push(cur);
          tmp = cur;
        } // Only add window if we got to document (e.g., not plain obj or detached DOM)


        if (tmp === (elem.ownerDocument || document)) {
          eventPath.push(tmp.defaultView || tmp.parentWindow || window);
        }
      } // Fire handlers on the event path


      i = 0;

      while ((cur = eventPath[i++]) && !event.isPropagationStopped()) {
        event.type = i > 1 ? bubbleType : special.bindType || type; // jQuery handler

        handle = (dataPriv.get(cur, "events") || {})[event.type] && dataPriv.get(cur, "handle");

        if (handle) {
          handle.apply(cur, data);
        } // Native handler


        handle = ontype && cur[ontype];

        if (handle && handle.apply && acceptData(cur)) {
          event.result = handle.apply(cur, data);

          if (event.result === false) {
            event.preventDefault();
          }
        }
      }

      event.type = type; // If nobody prevented the default action, do it now

      if (!onlyHandlers && !event.isDefaultPrevented()) {
        if ((!special._default || special._default.apply(eventPath.pop(), data) === false) && acceptData(elem)) {
          // Call a native DOM method on the target with the same name as the event.
          // Don't do default actions on window, that's where global variables be (#6170)
          if (ontype && jQuery.isFunction(elem[type]) && !jQuery.isWindow(elem)) {
            // Don't re-trigger an onFOO event when we call its FOO() method
            tmp = elem[ontype];

            if (tmp) {
              elem[ontype] = null;
            } // Prevent re-triggering of the same event, since we already bubbled it above


            jQuery.event.triggered = type;
            elem[type]();
            jQuery.event.triggered = undefined;

            if (tmp) {
              elem[ontype] = tmp;
            }
          }
        }
      }

      return event.result;
    },
    // Piggyback on a donor event to simulate a different one
    // Used only for `focus(in | out)` events
    simulate: function simulate(type, elem, event) {
      var e = jQuery.extend(new jQuery.Event(), event, {
        type: type,
        isSimulated: true
      });
      jQuery.event.trigger(e, null, elem);
    }
  });
  jQuery.fn.extend({
    trigger: function trigger(type, data) {
      return this.each(function () {
        jQuery.event.trigger(type, data, this);
      });
    },
    triggerHandler: function triggerHandler(type, data) {
      var elem = this[0];

      if (elem) {
        return jQuery.event.trigger(type, data, elem, true);
      }
    }
  });
  jQuery.each(("blur focus focusin focusout resize scroll click dblclick " + "mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave " + "change select submit keydown keypress keyup contextmenu").split(" "), function (i, name) {
    // Handle event binding
    jQuery.fn[name] = function (data, fn) {
      return arguments.length > 0 ? this.on(name, null, data, fn) : this.trigger(name);
    };
  });
  jQuery.fn.extend({
    hover: function hover(fnOver, fnOut) {
      return this.mouseenter(fnOver).mouseleave(fnOut || fnOver);
    }
  });
  support.focusin = "onfocusin" in window; // Support: Firefox <=44
  // Firefox doesn't have focus(in | out) events
  // Related ticket - https://bugzilla.mozilla.org/show_bug.cgi?id=687787
  //
  // Support: Chrome <=48 - 49, Safari <=9.0 - 9.1
  // focus(in | out) events fire after focus & blur events,
  // which is spec violation - http://www.w3.org/TR/DOM-Level-3-Events/#events-focusevent-event-order
  // Related ticket - https://bugs.chromium.org/p/chromium/issues/detail?id=449857

  if (!support.focusin) {
    jQuery.each({
      focus: "focusin",
      blur: "focusout"
    }, function (orig, fix) {
      // Attach a single capturing handler on the document while someone wants focusin/focusout
      var handler = function handler(event) {
        jQuery.event.simulate(fix, event.target, jQuery.event.fix(event));
      };

      jQuery.event.special[fix] = {
        setup: function setup() {
          var doc = this.ownerDocument || this,
              attaches = dataPriv.access(doc, fix);

          if (!attaches) {
            doc.addEventListener(orig, handler, true);
          }

          dataPriv.access(doc, fix, (attaches || 0) + 1);
        },
        teardown: function teardown() {
          var doc = this.ownerDocument || this,
              attaches = dataPriv.access(doc, fix) - 1;

          if (!attaches) {
            doc.removeEventListener(orig, handler, true);
            dataPriv.remove(doc, fix);
          } else {
            dataPriv.access(doc, fix, attaches);
          }
        }
      };
    });
  }

  var location = window.location;
  var nonce = jQuery.now();
  var rquery = /\?/; // Cross-browser xml parsing

  jQuery.parseXML = function (data) {
    var xml;

    if (!data || typeof data !== "string") {
      return null;
    } // Support: IE 9 - 11 only
    // IE throws on parseFromString with invalid input.


    try {
      xml = new window.DOMParser().parseFromString(data, "text/xml");
    } catch (e) {
      xml = undefined;
    }

    if (!xml || xml.getElementsByTagName("parsererror").length) {
      jQuery.error("Invalid XML: " + data);
    }

    return xml;
  };

  var rbracket = /\[\]$/,
      rCRLF = /\r?\n/g,
      rsubmitterTypes = /^(?:submit|button|image|reset|file)$/i,
      rsubmittable = /^(?:input|select|textarea|keygen)/i;

  function buildParams(prefix, obj, traditional, add) {
    var name;

    if (jQuery.isArray(obj)) {
      // Serialize array item.
      jQuery.each(obj, function (i, v) {
        if (traditional || rbracket.test(prefix)) {
          // Treat each array item as a scalar.
          add(prefix, v);
        } else {
          // Item is non-scalar (array or object), encode its numeric index.
          buildParams(prefix + "[" + (_typeof(v) === "object" && v != null ? i : "") + "]", v, traditional, add);
        }
      });
    } else if (!traditional && jQuery.type(obj) === "object") {
      // Serialize object item.
      for (name in obj) {
        buildParams(prefix + "[" + name + "]", obj[name], traditional, add);
      }
    } else {
      // Serialize scalar item.
      add(prefix, obj);
    }
  } // Serialize an array of form elements or a set of
  // key/values into a query string


  jQuery.param = function (a, traditional) {
    var prefix,
        s = [],
        add = function add(key, valueOrFunction) {
      // If value is a function, invoke it and use its return value
      var value = jQuery.isFunction(valueOrFunction) ? valueOrFunction() : valueOrFunction;
      s[s.length] = encodeURIComponent(key) + "=" + encodeURIComponent(value == null ? "" : value);
    }; // If an array was passed in, assume that it is an array of form elements.


    if (jQuery.isArray(a) || a.jquery && !jQuery.isPlainObject(a)) {
      // Serialize the form elements
      jQuery.each(a, function () {
        add(this.name, this.value);
      });
    } else {
      // If traditional, encode the "old" way (the way 1.3.2 or older
      // did it), otherwise encode params recursively.
      for (prefix in a) {
        buildParams(prefix, a[prefix], traditional, add);
      }
    } // Return the resulting serialization


    return s.join("&");
  };

  jQuery.fn.extend({
    serialize: function serialize() {
      return jQuery.param(this.serializeArray());
    },
    serializeArray: function serializeArray() {
      return this.map(function () {
        // Can add propHook for "elements" to filter or add form elements
        var elements = jQuery.prop(this, "elements");
        return elements ? jQuery.makeArray(elements) : this;
      }).filter(function () {
        var type = this.type; // Use .is( ":disabled" ) so that fieldset[disabled] works

        return this.name && !jQuery(this).is(":disabled") && rsubmittable.test(this.nodeName) && !rsubmitterTypes.test(type) && (this.checked || !rcheckableType.test(type));
      }).map(function (i, elem) {
        var val = jQuery(this).val();

        if (val == null) {
          return null;
        }

        if (jQuery.isArray(val)) {
          return jQuery.map(val, function (val) {
            return {
              name: elem.name,
              value: val.replace(rCRLF, "\r\n")
            };
          });
        }

        return {
          name: elem.name,
          value: val.replace(rCRLF, "\r\n")
        };
      }).get();
    }
  });
  var r20 = /%20/g,
      rhash = /#.*$/,
      rantiCache = /([?&])_=[^&]*/,
      rheaders = /^(.*?):[ \t]*([^\r\n]*)$/mg,
      // #7653, #8125, #8152: local protocol detection
  rlocalProtocol = /^(?:about|app|app-storage|.+-extension|file|res|widget):$/,
      rnoContent = /^(?:GET|HEAD)$/,
      rprotocol = /^\/\//,

  /* Prefilters
   * 1) They are useful to introduce custom dataTypes (see ajax/jsonp.js for an example)
   * 2) These are called:
   *    - BEFORE asking for a transport
   *    - AFTER param serialization (s.data is a string if s.processData is true)
   * 3) key is the dataType
   * 4) the catchall symbol "*" can be used
   * 5) execution will start with transport dataType and THEN continue down to "*" if needed
   */
  prefilters = {},

  /* Transports bindings
   * 1) key is the dataType
   * 2) the catchall symbol "*" can be used
   * 3) selection will start with transport dataType and THEN go to "*" if needed
   */
  transports = {},
      // Avoid comment-prolog char sequence (#10098); must appease lint and evade compression
  allTypes = "*/".concat("*"),
      // Anchor tag for parsing the document origin
  originAnchor = document.createElement("a");
  originAnchor.href = location.href; // Base "constructor" for jQuery.ajaxPrefilter and jQuery.ajaxTransport

  function addToPrefiltersOrTransports(structure) {
    // dataTypeExpression is optional and defaults to "*"
    return function (dataTypeExpression, func) {
      if (typeof dataTypeExpression !== "string") {
        func = dataTypeExpression;
        dataTypeExpression = "*";
      }

      var dataType,
          i = 0,
          dataTypes = dataTypeExpression.toLowerCase().match(rnothtmlwhite) || [];

      if (jQuery.isFunction(func)) {
        // For each dataType in the dataTypeExpression
        while (dataType = dataTypes[i++]) {
          // Prepend if requested
          if (dataType[0] === "+") {
            dataType = dataType.slice(1) || "*";
            (structure[dataType] = structure[dataType] || []).unshift(func); // Otherwise append
          } else {
            (structure[dataType] = structure[dataType] || []).push(func);
          }
        }
      }
    };
  } // Base inspection function for prefilters and transports


  function inspectPrefiltersOrTransports(structure, options, originalOptions, jqXHR) {
    var inspected = {},
        seekingTransport = structure === transports;

    function inspect(dataType) {
      var selected;
      inspected[dataType] = true;
      jQuery.each(structure[dataType] || [], function (_, prefilterOrFactory) {
        var dataTypeOrTransport = prefilterOrFactory(options, originalOptions, jqXHR);

        if (typeof dataTypeOrTransport === "string" && !seekingTransport && !inspected[dataTypeOrTransport]) {
          options.dataTypes.unshift(dataTypeOrTransport);
          inspect(dataTypeOrTransport);
          return false;
        } else if (seekingTransport) {
          return !(selected = dataTypeOrTransport);
        }
      });
      return selected;
    }

    return inspect(options.dataTypes[0]) || !inspected["*"] && inspect("*");
  } // A special extend for ajax options
  // that takes "flat" options (not to be deep extended)
  // Fixes #9887


  function ajaxExtend(target, src) {
    var key,
        deep,
        flatOptions = jQuery.ajaxSettings.flatOptions || {};

    for (key in src) {
      if (src[key] !== undefined) {
        (flatOptions[key] ? target : deep || (deep = {}))[key] = src[key];
      }
    }

    if (deep) {
      jQuery.extend(true, target, deep);
    }

    return target;
  }
  /* Handles responses to an ajax request:
   * - finds the right dataType (mediates between content-type and expected dataType)
   * - returns the corresponding response
   */


  function ajaxHandleResponses(s, jqXHR, responses) {
    var ct,
        type,
        finalDataType,
        firstDataType,
        contents = s.contents,
        dataTypes = s.dataTypes; // Remove auto dataType and get content-type in the process

    while (dataTypes[0] === "*") {
      dataTypes.shift();

      if (ct === undefined) {
        ct = s.mimeType || jqXHR.getResponseHeader("Content-Type");
      }
    } // Check if we're dealing with a known content-type


    if (ct) {
      for (type in contents) {
        if (contents[type] && contents[type].test(ct)) {
          dataTypes.unshift(type);
          break;
        }
      }
    } // Check to see if we have a response for the expected dataType


    if (dataTypes[0] in responses) {
      finalDataType = dataTypes[0];
    } else {
      // Try convertible dataTypes
      for (type in responses) {
        if (!dataTypes[0] || s.converters[type + " " + dataTypes[0]]) {
          finalDataType = type;
          break;
        }

        if (!firstDataType) {
          firstDataType = type;
        }
      } // Or just use first one


      finalDataType = finalDataType || firstDataType;
    } // If we found a dataType
    // We add the dataType to the list if needed
    // and return the corresponding response


    if (finalDataType) {
      if (finalDataType !== dataTypes[0]) {
        dataTypes.unshift(finalDataType);
      }

      return responses[finalDataType];
    }
  }
  /* Chain conversions given the request and the original response
   * Also sets the responseXXX fields on the jqXHR instance
   */


  function ajaxConvert(s, response, jqXHR, isSuccess) {
    var conv2,
        current,
        conv,
        tmp,
        prev,
        converters = {},
        // Work with a copy of dataTypes in case we need to modify it for conversion
    dataTypes = s.dataTypes.slice(); // Create converters map with lowercased keys

    if (dataTypes[1]) {
      for (conv in s.converters) {
        converters[conv.toLowerCase()] = s.converters[conv];
      }
    }

    current = dataTypes.shift(); // Convert to each sequential dataType

    while (current) {
      if (s.responseFields[current]) {
        jqXHR[s.responseFields[current]] = response;
      } // Apply the dataFilter if provided


      if (!prev && isSuccess && s.dataFilter) {
        response = s.dataFilter(response, s.dataType);
      }

      prev = current;
      current = dataTypes.shift();

      if (current) {
        // There's only work to do if current dataType is non-auto
        if (current === "*") {
          current = prev; // Convert response if prev dataType is non-auto and differs from current
        } else if (prev !== "*" && prev !== current) {
          // Seek a direct converter
          conv = converters[prev + " " + current] || converters["* " + current]; // If none found, seek a pair

          if (!conv) {
            for (conv2 in converters) {
              // If conv2 outputs current
              tmp = conv2.split(" ");

              if (tmp[1] === current) {
                // If prev can be converted to accepted input
                conv = converters[prev + " " + tmp[0]] || converters["* " + tmp[0]];

                if (conv) {
                  // Condense equivalence converters
                  if (conv === true) {
                    conv = converters[conv2]; // Otherwise, insert the intermediate dataType
                  } else if (converters[conv2] !== true) {
                    current = tmp[0];
                    dataTypes.unshift(tmp[1]);
                  }

                  break;
                }
              }
            }
          } // Apply converter (if not an equivalence)


          if (conv !== true) {
            // Unless errors are allowed to bubble, catch and return them
            if (conv && s.throws) {
              response = conv(response);
            } else {
              try {
                response = conv(response);
              } catch (e) {
                return {
                  state: "parsererror",
                  error: conv ? e : "No conversion from " + prev + " to " + current
                };
              }
            }
          }
        }
      }
    }

    return {
      state: "success",
      data: response
    };
  }

  jQuery.extend({
    // Counter for holding the number of active queries
    active: 0,
    // Last-Modified header cache for next request
    lastModified: {},
    etag: {},
    ajaxSettings: {
      url: location.href,
      type: "GET",
      isLocal: rlocalProtocol.test(location.protocol),
      global: true,
      processData: true,
      async: true,
      contentType: "application/x-www-form-urlencoded; charset=UTF-8",

      /*
      timeout: 0,
      data: null,
      dataType: null,
      username: null,
      password: null,
      cache: null,
      throws: false,
      traditional: false,
      headers: {},
      */
      accepts: {
        "*": allTypes,
        text: "text/plain",
        html: "text/html",
        xml: "application/xml, text/xml",
        json: "application/json, text/javascript"
      },
      contents: {
        xml: /\bxml\b/,
        html: /\bhtml/,
        json: /\bjson\b/
      },
      responseFields: {
        xml: "responseXML",
        text: "responseText",
        json: "responseJSON"
      },
      // Data converters
      // Keys separate source (or catchall "*") and destination types with a single space
      converters: {
        // Convert anything to text
        "* text": String,
        // Text to html (true = no transformation)
        "text html": true,
        // Evaluate text as a json expression
        "text json": JSON.parse,
        // Parse text as xml
        "text xml": jQuery.parseXML
      },
      // For options that shouldn't be deep extended:
      // you can add your own custom options here if
      // and when you create one that shouldn't be
      // deep extended (see ajaxExtend)
      flatOptions: {
        url: true,
        context: true
      }
    },
    // Creates a full fledged settings object into target
    // with both ajaxSettings and settings fields.
    // If target is omitted, writes into ajaxSettings.
    ajaxSetup: function ajaxSetup(target, settings) {
      return settings ? // Building a settings object
      ajaxExtend(ajaxExtend(target, jQuery.ajaxSettings), settings) : // Extending ajaxSettings
      ajaxExtend(jQuery.ajaxSettings, target);
    },
    ajaxPrefilter: addToPrefiltersOrTransports(prefilters),
    ajaxTransport: addToPrefiltersOrTransports(transports),
    // Main method
    ajax: function ajax(url, options) {
      // If url is an object, simulate pre-1.5 signature
      if (_typeof(url) === "object") {
        options = url;
        url = undefined;
      } // Force options to be an object


      options = options || {};

      var transport,
          // URL without anti-cache param
      cacheURL,
          // Response headers
      responseHeadersString,
          responseHeaders,
          // timeout handle
      timeoutTimer,
          // Url cleanup var
      urlAnchor,
          // Request state (becomes false upon send and true upon completion)
      completed,
          // To know if global events are to be dispatched
      fireGlobals,
          // Loop variable
      i,
          // uncached part of the url
      uncached,
          // Create the final options object
      s = jQuery.ajaxSetup({}, options),
          // Callbacks context
      callbackContext = s.context || s,
          // Context for global events is callbackContext if it is a DOM node or jQuery collection
      globalEventContext = s.context && (callbackContext.nodeType || callbackContext.jquery) ? jQuery(callbackContext) : jQuery.event,
          // Deferreds
      deferred = jQuery.Deferred(),
          completeDeferred = jQuery.Callbacks("once memory"),
          // Status-dependent callbacks
      _statusCode = s.statusCode || {},
          // Headers (they are sent all at once)
      requestHeaders = {},
          requestHeadersNames = {},
          // Default abort message
      strAbort = "canceled",
          // Fake xhr
      jqXHR = {
        readyState: 0,
        // Builds headers hashtable if needed
        getResponseHeader: function getResponseHeader(key) {
          var match;

          if (completed) {
            if (!responseHeaders) {
              responseHeaders = {};

              while (match = rheaders.exec(responseHeadersString)) {
                responseHeaders[match[1].toLowerCase()] = match[2];
              }
            }

            match = responseHeaders[key.toLowerCase()];
          }

          return match == null ? null : match;
        },
        // Raw string
        getAllResponseHeaders: function getAllResponseHeaders() {
          return completed ? responseHeadersString : null;
        },
        // Caches the header
        setRequestHeader: function setRequestHeader(name, value) {
          if (completed == null) {
            name = requestHeadersNames[name.toLowerCase()] = requestHeadersNames[name.toLowerCase()] || name;
            requestHeaders[name] = value;
          }

          return this;
        },
        // Overrides response content-type header
        overrideMimeType: function overrideMimeType(type) {
          if (completed == null) {
            s.mimeType = type;
          }

          return this;
        },
        // Status-dependent callbacks
        statusCode: function statusCode(map) {
          var code;

          if (map) {
            if (completed) {
              // Execute the appropriate callbacks
              jqXHR.always(map[jqXHR.status]);
            } else {
              // Lazy-add the new callbacks in a way that preserves old ones
              for (code in map) {
                _statusCode[code] = [_statusCode[code], map[code]];
              }
            }
          }

          return this;
        },
        // Cancel the request
        abort: function abort(statusText) {
          var finalText = statusText || strAbort;

          if (transport) {
            transport.abort(finalText);
          }

          done(0, finalText);
          return this;
        }
      }; // Attach deferreds


      deferred.promise(jqXHR); // Add protocol if not provided (prefilters might expect it)
      // Handle falsy url in the settings object (#10093: consistency with old signature)
      // We also use the url parameter if available

      s.url = ((url || s.url || location.href) + "").replace(rprotocol, location.protocol + "//"); // Alias method option to type as per ticket #12004

      s.type = options.method || options.type || s.method || s.type; // Extract dataTypes list

      s.dataTypes = (s.dataType || "*").toLowerCase().match(rnothtmlwhite) || [""]; // A cross-domain request is in order when the origin doesn't match the current origin.

      if (s.crossDomain == null) {
        urlAnchor = document.createElement("a"); // Support: IE <=8 - 11, Edge 12 - 13
        // IE throws exception on accessing the href property if url is malformed,
        // e.g. http://example.com:80x/

        try {
          urlAnchor.href = s.url; // Support: IE <=8 - 11 only
          // Anchor's host property isn't correctly set when s.url is relative

          urlAnchor.href = urlAnchor.href;
          s.crossDomain = originAnchor.protocol + "//" + originAnchor.host !== urlAnchor.protocol + "//" + urlAnchor.host;
        } catch (e) {
          // If there is an error parsing the URL, assume it is crossDomain,
          // it can be rejected by the transport if it is invalid
          s.crossDomain = true;
        }
      } // Convert data if not already a string


      if (s.data && s.processData && typeof s.data !== "string") {
        s.data = jQuery.param(s.data, s.traditional);
      } // Apply prefilters


      inspectPrefiltersOrTransports(prefilters, s, options, jqXHR); // If request was aborted inside a prefilter, stop there

      if (completed) {
        return jqXHR;
      } // We can fire global events as of now if asked to
      // Don't fire events if jQuery.event is undefined in an AMD-usage scenario (#15118)


      fireGlobals = jQuery.event && s.global; // Watch for a new set of requests

      if (fireGlobals && jQuery.active++ === 0) {
        jQuery.event.trigger("ajaxStart");
      } // Uppercase the type


      s.type = s.type.toUpperCase(); // Determine if request has content

      s.hasContent = !rnoContent.test(s.type); // Save the URL in case we're toying with the If-Modified-Since
      // and/or If-None-Match header later on
      // Remove hash to simplify url manipulation

      cacheURL = s.url.replace(rhash, ""); // More options handling for requests with no content

      if (!s.hasContent) {
        // Remember the hash so we can put it back
        uncached = s.url.slice(cacheURL.length); // If data is available, append data to url

        if (s.data) {
          cacheURL += (rquery.test(cacheURL) ? "&" : "?") + s.data; // #9682: remove data so that it's not used in an eventual retry

          delete s.data;
        } // Add or update anti-cache param if needed


        if (s.cache === false) {
          cacheURL = cacheURL.replace(rantiCache, "$1");
          uncached = (rquery.test(cacheURL) ? "&" : "?") + "_=" + nonce++ + uncached;
        } // Put hash and anti-cache on the URL that will be requested (gh-1732)


        s.url = cacheURL + uncached; // Change '%20' to '+' if this is encoded form body content (gh-2658)
      } else if (s.data && s.processData && (s.contentType || "").indexOf("application/x-www-form-urlencoded") === 0) {
        s.data = s.data.replace(r20, "+");
      } // Set the If-Modified-Since and/or If-None-Match header, if in ifModified mode.


      if (s.ifModified) {
        if (jQuery.lastModified[cacheURL]) {
          jqXHR.setRequestHeader("If-Modified-Since", jQuery.lastModified[cacheURL]);
        }

        if (jQuery.etag[cacheURL]) {
          jqXHR.setRequestHeader("If-None-Match", jQuery.etag[cacheURL]);
        }
      } // Set the correct header, if data is being sent


      if (s.data && s.hasContent && s.contentType !== false || options.contentType) {
        jqXHR.setRequestHeader("Content-Type", s.contentType);
      } // Set the Accepts header for the server, depending on the dataType


      jqXHR.setRequestHeader("Accept", s.dataTypes[0] && s.accepts[s.dataTypes[0]] ? s.accepts[s.dataTypes[0]] + (s.dataTypes[0] !== "*" ? ", " + allTypes + "; q=0.01" : "") : s.accepts["*"]); // Check for headers option

      for (i in s.headers) {
        jqXHR.setRequestHeader(i, s.headers[i]);
      } // Allow custom headers/mimetypes and early abort


      if (s.beforeSend && (s.beforeSend.call(callbackContext, jqXHR, s) === false || completed)) {
        // Abort if not done already and return
        return jqXHR.abort();
      } // Aborting is no longer a cancellation


      strAbort = "abort"; // Install callbacks on deferreds

      completeDeferred.add(s.complete);
      jqXHR.done(s.success);
      jqXHR.fail(s.error); // Get transport

      transport = inspectPrefiltersOrTransports(transports, s, options, jqXHR); // If no transport, we auto-abort

      if (!transport) {
        done(-1, "No Transport");
      } else {
        jqXHR.readyState = 1; // Send global event

        if (fireGlobals) {
          globalEventContext.trigger("ajaxSend", [jqXHR, s]);
        } // If request was aborted inside ajaxSend, stop there


        if (completed) {
          return jqXHR;
        } // Timeout


        if (s.async && s.timeout > 0) {
          timeoutTimer = window.setTimeout(function () {
            jqXHR.abort("timeout");
          }, s.timeout);
        }

        try {
          completed = false;
          transport.send(requestHeaders, done);
        } catch (e) {
          // Rethrow post-completion exceptions
          if (completed) {
            throw e;
          } // Propagate others as results


          done(-1, e);
        }
      } // Callback for when everything is done


      function done(status, nativeStatusText, responses, headers) {
        var isSuccess,
            success,
            error,
            response,
            modified,
            statusText = nativeStatusText; // Ignore repeat invocations

        if (completed) {
          return;
        }

        completed = true; // Clear timeout if it exists

        if (timeoutTimer) {
          window.clearTimeout(timeoutTimer);
        } // Dereference transport for early garbage collection
        // (no matter how long the jqXHR object will be used)


        transport = undefined; // Cache response headers

        responseHeadersString = headers || ""; // Set readyState

        jqXHR.readyState = status > 0 ? 4 : 0; // Determine if successful

        isSuccess = status >= 200 && status < 300 || status === 304; // Get response data

        if (responses) {
          response = ajaxHandleResponses(s, jqXHR, responses);
        } // Convert no matter what (that way responseXXX fields are always set)


        response = ajaxConvert(s, response, jqXHR, isSuccess); // If successful, handle type chaining

        if (isSuccess) {
          // Set the If-Modified-Since and/or If-None-Match header, if in ifModified mode.
          if (s.ifModified) {
            modified = jqXHR.getResponseHeader("Last-Modified");

            if (modified) {
              jQuery.lastModified[cacheURL] = modified;
            }

            modified = jqXHR.getResponseHeader("etag");

            if (modified) {
              jQuery.etag[cacheURL] = modified;
            }
          } // if no content


          if (status === 204 || s.type === "HEAD") {
            statusText = "nocontent"; // if not modified
          } else if (status === 304) {
            statusText = "notmodified"; // If we have data, let's convert it
          } else {
            statusText = response.state;
            success = response.data;
            error = response.error;
            isSuccess = !error;
          }
        } else {
          // Extract error from statusText and normalize for non-aborts
          error = statusText;

          if (status || !statusText) {
            statusText = "error";

            if (status < 0) {
              status = 0;
            }
          }
        } // Set data for the fake xhr object


        jqXHR.status = status;
        jqXHR.statusText = (nativeStatusText || statusText) + ""; // Success/Error

        if (isSuccess) {
          deferred.resolveWith(callbackContext, [success, statusText, jqXHR]);
        } else {
          deferred.rejectWith(callbackContext, [jqXHR, statusText, error]);
        } // Status-dependent callbacks


        jqXHR.statusCode(_statusCode);
        _statusCode = undefined;

        if (fireGlobals) {
          globalEventContext.trigger(isSuccess ? "ajaxSuccess" : "ajaxError", [jqXHR, s, isSuccess ? success : error]);
        } // Complete


        completeDeferred.fireWith(callbackContext, [jqXHR, statusText]);

        if (fireGlobals) {
          globalEventContext.trigger("ajaxComplete", [jqXHR, s]); // Handle the global AJAX counter

          if (! --jQuery.active) {
            jQuery.event.trigger("ajaxStop");
          }
        }
      }

      return jqXHR;
    },
    getJSON: function getJSON(url, data, callback) {
      return jQuery.get(url, data, callback, "json");
    },
    getScript: function getScript(url, callback) {
      return jQuery.get(url, undefined, callback, "script");
    }
  });
  jQuery.each(["get", "post"], function (i, method) {
    jQuery[method] = function (url, data, callback, type) {
      // Shift arguments if data argument was omitted
      if (jQuery.isFunction(data)) {
        type = type || callback;
        callback = data;
        data = undefined;
      } // The url can be an options object (which then must have .url)


      return jQuery.ajax(jQuery.extend({
        url: url,
        type: method,
        dataType: type,
        data: data,
        success: callback
      }, jQuery.isPlainObject(url) && url));
    };
  });

  jQuery._evalUrl = function (url) {
    return jQuery.ajax({
      url: url,
      // Make this explicit, since user can override this through ajaxSetup (#11264)
      type: "GET",
      dataType: "script",
      cache: true,
      async: false,
      global: false,
      "throws": true
    });
  };

  jQuery.fn.extend({
    wrapAll: function wrapAll(html) {
      var wrap;

      if (this[0]) {
        if (jQuery.isFunction(html)) {
          html = html.call(this[0]);
        } // The elements to wrap the target around


        wrap = jQuery(html, this[0].ownerDocument).eq(0).clone(true);

        if (this[0].parentNode) {
          wrap.insertBefore(this[0]);
        }

        wrap.map(function () {
          var elem = this;

          while (elem.firstElementChild) {
            elem = elem.firstElementChild;
          }

          return elem;
        }).append(this);
      }

      return this;
    },
    wrapInner: function wrapInner(html) {
      if (jQuery.isFunction(html)) {
        return this.each(function (i) {
          jQuery(this).wrapInner(html.call(this, i));
        });
      }

      return this.each(function () {
        var self = jQuery(this),
            contents = self.contents();

        if (contents.length) {
          contents.wrapAll(html);
        } else {
          self.append(html);
        }
      });
    },
    wrap: function wrap(html) {
      var isFunction = jQuery.isFunction(html);
      return this.each(function (i) {
        jQuery(this).wrapAll(isFunction ? html.call(this, i) : html);
      });
    },
    unwrap: function unwrap(selector) {
      this.parent(selector).not("body").each(function () {
        jQuery(this).replaceWith(this.childNodes);
      });
      return this;
    }
  });

  jQuery.expr.pseudos.hidden = function (elem) {
    return !jQuery.expr.pseudos.visible(elem);
  };

  jQuery.expr.pseudos.visible = function (elem) {
    return !!(elem.offsetWidth || elem.offsetHeight || elem.getClientRects().length);
  };

  jQuery.ajaxSettings.xhr = function () {
    try {
      return new window.XMLHttpRequest();
    } catch (e) {}
  };

  var xhrSuccessStatus = {
    // File protocol always yields status code 0, assume 200
    0: 200,
    // Support: IE <=9 only
    // #1450: sometimes IE returns 1223 when it should be 204
    1223: 204
  },
      xhrSupported = jQuery.ajaxSettings.xhr();
  support.cors = !!xhrSupported && "withCredentials" in xhrSupported;
  support.ajax = xhrSupported = !!xhrSupported;
  jQuery.ajaxTransport(function (options) {
    var _callback, errorCallback; // Cross domain only allowed if supported through XMLHttpRequest


    if (support.cors || xhrSupported && !options.crossDomain) {
      return {
        send: function send(headers, complete) {
          var i,
              xhr = options.xhr();
          xhr.open(options.type, options.url, options.async, options.username, options.password); // Apply custom fields if provided

          if (options.xhrFields) {
            for (i in options.xhrFields) {
              xhr[i] = options.xhrFields[i];
            }
          } // Override mime type if needed


          if (options.mimeType && xhr.overrideMimeType) {
            xhr.overrideMimeType(options.mimeType);
          } // X-Requested-With header
          // For cross-domain requests, seeing as conditions for a preflight are
          // akin to a jigsaw puzzle, we simply never set it to be sure.
          // (it can always be set on a per-request basis or even using ajaxSetup)
          // For same-domain requests, won't change header if already provided.


          if (!options.crossDomain && !headers["X-Requested-With"]) {
            headers["X-Requested-With"] = "XMLHttpRequest";
          } // Set headers


          for (i in headers) {
            xhr.setRequestHeader(i, headers[i]);
          } // Callback


          _callback = function callback(type) {
            return function () {
              if (_callback) {
                _callback = errorCallback = xhr.onload = xhr.onerror = xhr.onabort = xhr.onreadystatechange = null;

                if (type === "abort") {
                  xhr.abort();
                } else if (type === "error") {
                  // Support: IE <=9 only
                  // On a manual native abort, IE9 throws
                  // errors on any property access that is not readyState
                  if (typeof xhr.status !== "number") {
                    complete(0, "error");
                  } else {
                    complete( // File: protocol always yields status 0; see #8605, #14207
                    xhr.status, xhr.statusText);
                  }
                } else {
                  complete(xhrSuccessStatus[xhr.status] || xhr.status, xhr.statusText, // Support: IE <=9 only
                  // IE9 has no XHR2 but throws on binary (trac-11426)
                  // For XHR2 non-text, let the caller handle it (gh-2498)
                  (xhr.responseType || "text") !== "text" || typeof xhr.responseText !== "string" ? {
                    binary: xhr.response
                  } : {
                    text: xhr.responseText
                  }, xhr.getAllResponseHeaders());
                }
              }
            };
          }; // Listen to events


          xhr.onload = _callback();
          errorCallback = xhr.onerror = _callback("error"); // Support: IE 9 only
          // Use onreadystatechange to replace onabort
          // to handle uncaught aborts

          if (xhr.onabort !== undefined) {
            xhr.onabort = errorCallback;
          } else {
            xhr.onreadystatechange = function () {
              // Check readyState before timeout as it changes
              if (xhr.readyState === 4) {
                // Allow onerror to be called first,
                // but that will not handle a native abort
                // Also, save errorCallback to a variable
                // as xhr.onerror cannot be accessed
                window.setTimeout(function () {
                  if (_callback) {
                    errorCallback();
                  }
                });
              }
            };
          } // Create the abort callback


          _callback = _callback("abort");

          try {
            // Do send the request (this may raise an exception)
            xhr.send(options.hasContent && options.data || null);
          } catch (e) {
            // #14683: Only rethrow if this hasn't been notified as an error yet
            if (_callback) {
              throw e;
            }
          }
        },
        abort: function abort() {
          if (_callback) {
            _callback();
          }
        }
      };
    }
  }); // Prevent auto-execution of scripts when no explicit dataType was provided (See gh-2432)

  jQuery.ajaxPrefilter(function (s) {
    if (s.crossDomain) {
      s.contents.script = false;
    }
  }); // Install script dataType

  jQuery.ajaxSetup({
    accepts: {
      script: "text/javascript, application/javascript, " + "application/ecmascript, application/x-ecmascript"
    },
    contents: {
      script: /\b(?:java|ecma)script\b/
    },
    converters: {
      "text script": function textScript(text) {
        jQuery.globalEval(text);
        return text;
      }
    }
  }); // Handle cache's special case and crossDomain

  jQuery.ajaxPrefilter("script", function (s) {
    if (s.cache === undefined) {
      s.cache = false;
    }

    if (s.crossDomain) {
      s.type = "GET";
    }
  }); // Bind script tag hack transport

  jQuery.ajaxTransport("script", function (s) {
    // This transport only deals with cross domain requests
    if (s.crossDomain) {
      var script, _callback2;

      return {
        send: function send(_, complete) {
          script = jQuery("<script>").prop({
            charset: s.scriptCharset,
            src: s.url
          }).on("load error", _callback2 = function callback(evt) {
            script.remove();
            _callback2 = null;

            if (evt) {
              complete(evt.type === "error" ? 404 : 200, evt.type);
            }
          }); // Use native DOM manipulation to avoid our domManip AJAX trickery

          document.head.appendChild(script[0]);
        },
        abort: function abort() {
          if (_callback2) {
            _callback2();
          }
        }
      };
    }
  });
  var oldCallbacks = [],
      rjsonp = /(=)\?(?=&|$)|\?\?/; // Default jsonp settings

  jQuery.ajaxSetup({
    jsonp: "callback",
    jsonpCallback: function jsonpCallback() {
      var callback = oldCallbacks.pop() || jQuery.expando + "_" + nonce++;
      this[callback] = true;
      return callback;
    }
  }); // Detect, normalize options and install callbacks for jsonp requests

  jQuery.ajaxPrefilter("json jsonp", function (s, originalSettings, jqXHR) {
    var callbackName,
        overwritten,
        responseContainer,
        jsonProp = s.jsonp !== false && (rjsonp.test(s.url) ? "url" : typeof s.data === "string" && (s.contentType || "").indexOf("application/x-www-form-urlencoded") === 0 && rjsonp.test(s.data) && "data"); // Handle iff the expected data type is "jsonp" or we have a parameter to set

    if (jsonProp || s.dataTypes[0] === "jsonp") {
      // Get callback name, remembering preexisting value associated with it
      callbackName = s.jsonpCallback = jQuery.isFunction(s.jsonpCallback) ? s.jsonpCallback() : s.jsonpCallback; // Insert callback into url or form data

      if (jsonProp) {
        s[jsonProp] = s[jsonProp].replace(rjsonp, "$1" + callbackName);
      } else if (s.jsonp !== false) {
        s.url += (rquery.test(s.url) ? "&" : "?") + s.jsonp + "=" + callbackName;
      } // Use data converter to retrieve json after script execution


      s.converters["script json"] = function () {
        if (!responseContainer) {
          jQuery.error(callbackName + " was not called");
        }

        return responseContainer[0];
      }; // Force json dataType


      s.dataTypes[0] = "json"; // Install callback

      overwritten = window[callbackName];

      window[callbackName] = function () {
        responseContainer = arguments;
      }; // Clean-up function (fires after converters)


      jqXHR.always(function () {
        // If previous value didn't exist - remove it
        if (overwritten === undefined) {
          jQuery(window).removeProp(callbackName); // Otherwise restore preexisting value
        } else {
          window[callbackName] = overwritten;
        } // Save back as free


        if (s[callbackName]) {
          // Make sure that re-using the options doesn't screw things around
          s.jsonpCallback = originalSettings.jsonpCallback; // Save the callback name for future use

          oldCallbacks.push(callbackName);
        } // Call if it was a function and we have a response


        if (responseContainer && jQuery.isFunction(overwritten)) {
          overwritten(responseContainer[0]);
        }

        responseContainer = overwritten = undefined;
      }); // Delegate to script

      return "script";
    }
  }); // Support: Safari 8 only
  // In Safari 8 documents created via document.implementation.createHTMLDocument
  // collapse sibling forms: the second one becomes a child of the first one.
  // Because of that, this security measure has to be disabled in Safari 8.
  // https://bugs.webkit.org/show_bug.cgi?id=137337

  support.createHTMLDocument = function () {
    var body = document.implementation.createHTMLDocument("").body;
    body.innerHTML = "<form></form><form></form>";
    return body.childNodes.length === 2;
  }(); // Argument "data" should be string of html
  // context (optional): If specified, the fragment will be created in this context,
  // defaults to document
  // keepScripts (optional): If true, will include scripts passed in the html string


  jQuery.parseHTML = function (data, context, keepScripts) {
    if (typeof data !== "string") {
      return [];
    }

    if (typeof context === "boolean") {
      keepScripts = context;
      context = false;
    }

    var base, parsed, scripts;

    if (!context) {
      // Stop scripts or inline event handlers from being executed immediately
      // by using document.implementation
      if (support.createHTMLDocument) {
        context = document.implementation.createHTMLDocument(""); // Set the base href for the created document
        // so any parsed elements with URLs
        // are based on the document's URL (gh-2965)

        base = context.createElement("base");
        base.href = document.location.href;
        context.head.appendChild(base);
      } else {
        context = document;
      }
    }

    parsed = rsingleTag.exec(data);
    scripts = !keepScripts && []; // Single tag

    if (parsed) {
      return [context.createElement(parsed[1])];
    }

    parsed = buildFragment([data], context, scripts);

    if (scripts && scripts.length) {
      jQuery(scripts).remove();
    }

    return jQuery.merge([], parsed.childNodes);
  };
  /**
   * Load a url into a page
   */


  jQuery.fn.load = function (url, params, callback) {
    var selector,
        type,
        response,
        self = this,
        off = url.indexOf(" ");

    if (off > -1) {
      selector = stripAndCollapse(url.slice(off));
      url = url.slice(0, off);
    } // If it's a function


    if (jQuery.isFunction(params)) {
      // We assume that it's the callback
      callback = params;
      params = undefined; // Otherwise, build a param string
    } else if (params && _typeof(params) === "object") {
      type = "POST";
    } // If we have elements to modify, make the request


    if (self.length > 0) {
      jQuery.ajax({
        url: url,
        // If "type" variable is undefined, then "GET" method will be used.
        // Make value of this field explicit since
        // user can override it through ajaxSetup method
        type: type || "GET",
        dataType: "html",
        data: params
      }).done(function (responseText) {
        // Save response for use in complete callback
        response = arguments;
        self.html(selector ? // If a selector was specified, locate the right elements in a dummy div
        // Exclude scripts to avoid IE 'Permission Denied' errors
        jQuery("<div>").append(jQuery.parseHTML(responseText)).find(selector) : // Otherwise use the full result
        responseText); // If the request succeeds, this function gets "data", "status", "jqXHR"
        // but they are ignored because response was set above.
        // If it fails, this function gets "jqXHR", "status", "error"
      }).always(callback && function (jqXHR, status) {
        self.each(function () {
          callback.apply(this, response || [jqXHR.responseText, status, jqXHR]);
        });
      });
    }

    return this;
  }; // Attach a bunch of functions for handling common AJAX events


  jQuery.each(["ajaxStart", "ajaxStop", "ajaxComplete", "ajaxError", "ajaxSuccess", "ajaxSend"], function (i, type) {
    jQuery.fn[type] = function (fn) {
      return this.on(type, fn);
    };
  });

  jQuery.expr.pseudos.animated = function (elem) {
    return jQuery.grep(jQuery.timers, function (fn) {
      return elem === fn.elem;
    }).length;
  };
  /**
   * Gets a window from an element
   */


  function getWindow(elem) {
    return jQuery.isWindow(elem) ? elem : elem.nodeType === 9 && elem.defaultView;
  }

  jQuery.offset = {
    setOffset: function setOffset(elem, options, i) {
      var curPosition,
          curLeft,
          curCSSTop,
          curTop,
          curOffset,
          curCSSLeft,
          calculatePosition,
          position = jQuery.css(elem, "position"),
          curElem = jQuery(elem),
          props = {}; // Set position first, in-case top/left are set even on static elem

      if (position === "static") {
        elem.style.position = "relative";
      }

      curOffset = curElem.offset();
      curCSSTop = jQuery.css(elem, "top");
      curCSSLeft = jQuery.css(elem, "left");
      calculatePosition = (position === "absolute" || position === "fixed") && (curCSSTop + curCSSLeft).indexOf("auto") > -1; // Need to be able to calculate position if either
      // top or left is auto and position is either absolute or fixed

      if (calculatePosition) {
        curPosition = curElem.position();
        curTop = curPosition.top;
        curLeft = curPosition.left;
      } else {
        curTop = parseFloat(curCSSTop) || 0;
        curLeft = parseFloat(curCSSLeft) || 0;
      }

      if (jQuery.isFunction(options)) {
        // Use jQuery.extend here to allow modification of coordinates argument (gh-1848)
        options = options.call(elem, i, jQuery.extend({}, curOffset));
      }

      if (options.top != null) {
        props.top = options.top - curOffset.top + curTop;
      }

      if (options.left != null) {
        props.left = options.left - curOffset.left + curLeft;
      }

      if ("using" in options) {
        options.using.call(elem, props);
      } else {
        curElem.css(props);
      }
    }
  };
  jQuery.fn.extend({
    offset: function offset(options) {
      // Preserve chaining for setter
      if (arguments.length) {
        return options === undefined ? this : this.each(function (i) {
          jQuery.offset.setOffset(this, options, i);
        });
      }

      var docElem,
          win,
          rect,
          doc,
          elem = this[0];

      if (!elem) {
        return;
      } // Support: IE <=11 only
      // Running getBoundingClientRect on a
      // disconnected node in IE throws an error


      if (!elem.getClientRects().length) {
        return {
          top: 0,
          left: 0
        };
      }

      rect = elem.getBoundingClientRect(); // Make sure element is not hidden (display: none)

      if (rect.width || rect.height) {
        doc = elem.ownerDocument;
        win = getWindow(doc);
        docElem = doc.documentElement;
        return {
          top: rect.top + win.pageYOffset - docElem.clientTop,
          left: rect.left + win.pageXOffset - docElem.clientLeft
        };
      } // Return zeros for disconnected and hidden elements (gh-2310)


      return rect;
    },
    position: function position() {
      if (!this[0]) {
        return;
      }

      var offsetParent,
          offset,
          elem = this[0],
          parentOffset = {
        top: 0,
        left: 0
      }; // Fixed elements are offset from window (parentOffset = {top:0, left: 0},
      // because it is its only offset parent

      if (jQuery.css(elem, "position") === "fixed") {
        // Assume getBoundingClientRect is there when computed position is fixed
        offset = elem.getBoundingClientRect();
      } else {
        // Get *real* offsetParent
        offsetParent = this.offsetParent(); // Get correct offsets

        offset = this.offset();

        if (!jQuery.nodeName(offsetParent[0], "html")) {
          parentOffset = offsetParent.offset();
        } // Add offsetParent borders


        parentOffset = {
          top: parentOffset.top + jQuery.css(offsetParent[0], "borderTopWidth", true),
          left: parentOffset.left + jQuery.css(offsetParent[0], "borderLeftWidth", true)
        };
      } // Subtract parent offsets and element margins


      return {
        top: offset.top - parentOffset.top - jQuery.css(elem, "marginTop", true),
        left: offset.left - parentOffset.left - jQuery.css(elem, "marginLeft", true)
      };
    },
    // This method will return documentElement in the following cases:
    // 1) For the element inside the iframe without offsetParent, this method will return
    //    documentElement of the parent window
    // 2) For the hidden or detached element
    // 3) For body or html element, i.e. in case of the html node - it will return itself
    //
    // but those exceptions were never presented as a real life use-cases
    // and might be considered as more preferable results.
    //
    // This logic, however, is not guaranteed and can change at any point in the future
    offsetParent: function offsetParent() {
      return this.map(function () {
        var offsetParent = this.offsetParent;

        while (offsetParent && jQuery.css(offsetParent, "position") === "static") {
          offsetParent = offsetParent.offsetParent;
        }

        return offsetParent || documentElement;
      });
    }
  }); // Create scrollLeft and scrollTop methods

  jQuery.each({
    scrollLeft: "pageXOffset",
    scrollTop: "pageYOffset"
  }, function (method, prop) {
    var top = "pageYOffset" === prop;

    jQuery.fn[method] = function (val) {
      return access(this, function (elem, method, val) {
        var win = getWindow(elem);

        if (val === undefined) {
          return win ? win[prop] : elem[method];
        }

        if (win) {
          win.scrollTo(!top ? val : win.pageXOffset, top ? val : win.pageYOffset);
        } else {
          elem[method] = val;
        }
      }, method, val, arguments.length);
    };
  }); // Support: Safari <=7 - 9.1, Chrome <=37 - 49
  // Add the top/left cssHooks using jQuery.fn.position
  // Webkit bug: https://bugs.webkit.org/show_bug.cgi?id=29084
  // Blink bug: https://bugs.chromium.org/p/chromium/issues/detail?id=589347
  // getComputedStyle returns percent when specified for top/left/bottom/right;
  // rather than make the css module depend on the offset module, just check for it here

  jQuery.each(["top", "left"], function (i, prop) {
    jQuery.cssHooks[prop] = addGetHookIf(support.pixelPosition, function (elem, computed) {
      if (computed) {
        computed = curCSS(elem, prop); // If curCSS returns percentage, fallback to offset

        return rnumnonpx.test(computed) ? jQuery(elem).position()[prop] + "px" : computed;
      }
    });
  }); // Create innerHeight, innerWidth, height, width, outerHeight and outerWidth methods

  jQuery.each({
    Height: "height",
    Width: "width"
  }, function (name, type) {
    jQuery.each({
      padding: "inner" + name,
      content: type,
      "": "outer" + name
    }, function (defaultExtra, funcName) {
      // Margin is only for outerHeight, outerWidth
      jQuery.fn[funcName] = function (margin, value) {
        var chainable = arguments.length && (defaultExtra || typeof margin !== "boolean"),
            extra = defaultExtra || (margin === true || value === true ? "margin" : "border");
        return access(this, function (elem, type, value) {
          var doc;

          if (jQuery.isWindow(elem)) {
            // $( window ).outerWidth/Height return w/h including scrollbars (gh-1729)
            return funcName.indexOf("outer") === 0 ? elem["inner" + name] : elem.document.documentElement["client" + name];
          } // Get document width or height


          if (elem.nodeType === 9) {
            doc = elem.documentElement; // Either scroll[Width/Height] or offset[Width/Height] or client[Width/Height],
            // whichever is greatest

            return Math.max(elem.body["scroll" + name], doc["scroll" + name], elem.body["offset" + name], doc["offset" + name], doc["client" + name]);
          }

          return value === undefined ? // Get width or height on the element, requesting but not forcing parseFloat
          jQuery.css(elem, type, extra) : // Set width or height on the element
          jQuery.style(elem, type, value, extra);
        }, type, chainable ? margin : undefined, chainable);
      };
    });
  });
  jQuery.fn.extend({
    bind: function bind(types, data, fn) {
      return this.on(types, null, data, fn);
    },
    unbind: function unbind(types, fn) {
      return this.off(types, null, fn);
    },
    delegate: function delegate(selector, types, data, fn) {
      return this.on(types, selector, data, fn);
    },
    undelegate: function undelegate(selector, types, fn) {
      // ( namespace ) or ( selector, types [, fn] )
      return arguments.length === 1 ? this.off(selector, "**") : this.off(types, selector || "**", fn);
    }
  });
  jQuery.parseJSON = JSON.parse; // Register as a named AMD module, since jQuery can be concatenated with other
  // files that may use define, but not via a proper concatenation script that
  // understands anonymous AMD modules. A named AMD is safest and most robust
  // way to register. Lowercase jquery is used because AMD module names are
  // derived from file names, and jQuery is normally delivered in a lowercase
  // file name. Do this after creating the global so that if an AMD module wants
  // to call noConflict to hide this version of jQuery, it will work.
  // Note that for maximum portability, libraries that are not jQuery should
  // declare themselves as anonymous modules, and avoid setting a global if an
  // AMD loader is present. jQuery is a special case. For more information, see
  // https://github.com/jrburke/requirejs/wiki/Updating-existing-libraries#wiki-anon

  if (typeof define === "function" && define.amd) {
    define("jquery", [], function () {
      return jQuery;
    });
  }

  var // Map over jQuery in case of overwrite
  _jQuery = window.jQuery,
      // Map over the $ in case of overwrite
  _$ = window.$;

  jQuery.noConflict = function (deep) {
    if (window.$ === jQuery) {
      window.$ = _$;
    }

    if (deep && window.jQuery === jQuery) {
      window.jQuery = _jQuery;
    }

    return jQuery;
  }; // Expose jQuery and $ identifiers, even in AMD
  // (#7102#comment:10, https://github.com/jquery/jquery/pull/557)
  // and CommonJS for browser emulators (#13566)


  if (!noGlobal) {
    window.jQuery = window.$ = jQuery;
  }

  return jQuery;
});

/*! jQuery Migrate v3.0.0 | (c) jQuery Foundation and other contributors | jquery.org/license */
"undefined" == typeof jQuery.migrateMute && (jQuery.migrateMute = !0), function (a, b) {
  "use strict";

  function c(c) {
    var d = b.console;
    e[c] || (e[c] = !0, a.migrateWarnings.push(c), d && d.warn && !a.migrateMute && (d.warn("JQMIGRATE: " + c), a.migrateTrace && d.trace && d.trace()));
  }

  function d(a, b, d, e) {
    Object.defineProperty(a, b, {
      configurable: !0,
      enumerable: !0,
      get: function get() {
        return c(e), d;
      }
    });
  }

  a.migrateVersion = "3.0.0", function () {
    var c = b.console && b.console.log && function () {
      b.console.log.apply(b.console, arguments);
    },
        d = /^[12]\./;

    c && (a && !d.test(a.fn.jquery) || c("JQMIGRATE: jQuery 3.0.0+ REQUIRED"), a.migrateWarnings && c("JQMIGRATE: Migrate plugin loaded multiple times"), c("JQMIGRATE: Migrate is installed" + (a.migrateMute ? "" : " with logging active") + ", version " + a.migrateVersion));
  }();
  var e = {};
  a.migrateWarnings = [], void 0 === a.migrateTrace && (a.migrateTrace = !0), a.migrateReset = function () {
    e = {}, a.migrateWarnings.length = 0;
  }, "BackCompat" === document.compatMode && c("jQuery is not compatible with Quirks Mode");
  var f = a.fn.init,
      g = a.isNumeric,
      h = a.find,
      i = /\[(\s*[-\w]+\s*)([~|^$*]?=)\s*([-\w#]*?#[-\w#]*)\s*\]/,
      j = /\[(\s*[-\w]+\s*)([~|^$*]?=)\s*([-\w#]*?#[-\w#]*)\s*\]/g;
  a.fn.init = function (a) {
    var b = Array.prototype.slice.call(arguments);
    return "string" == typeof a && "#" === a && (c("jQuery( '#' ) is not a valid selector"), b[0] = []), f.apply(this, b);
  }, a.fn.init.prototype = a.fn, a.find = function (a) {
    var b = Array.prototype.slice.call(arguments);
    if ("string" == typeof a && i.test(a)) try {
      document.querySelector(a);
    } catch (d) {
      a = a.replace(j, function (a, b, c, d) {
        return "[" + b + c + '"' + d + '"]';
      });

      try {
        document.querySelector(a), c("Attribute selector with '#' must be quoted: " + b[0]), b[0] = a;
      } catch (e) {
        c("Attribute selector with '#' was not fixed: " + b[0]);
      }
    }
    return h.apply(this, b);
  };
  var k;

  for (k in h) {
    Object.prototype.hasOwnProperty.call(h, k) && (a.find[k] = h[k]);
  }

  a.fn.size = function () {
    return c("jQuery.fn.size() is deprecated; use the .length property"), this.length;
  }, a.parseJSON = function () {
    return c("jQuery.parseJSON is deprecated; use JSON.parse"), JSON.parse.apply(null, arguments);
  }, a.isNumeric = function (b) {
    function d(b) {
      var c = b && b.toString();
      return !a.isArray(b) && c - parseFloat(c) + 1 >= 0;
    }

    var e = g(b),
        f = d(b);
    return e !== f && c("jQuery.isNumeric() should not be called on constructed objects"), f;
  }, d(a, "unique", a.uniqueSort, "jQuery.unique is deprecated, use jQuery.uniqueSort"), d(a.expr, "filters", a.expr.pseudos, "jQuery.expr.filters is now jQuery.expr.pseudos"), d(a.expr, ":", a.expr.pseudos, 'jQuery.expr[":"] is now jQuery.expr.pseudos');
  var l = a.ajax;

  a.ajax = function () {
    var a = l.apply(this, arguments);
    return a.promise && (d(a, "success", a.done, "jQXHR.success is deprecated and removed"), d(a, "error", a.fail, "jQXHR.error is deprecated and removed"), d(a, "complete", a.always, "jQXHR.complete is deprecated and removed")), a;
  };

  var m = a.fn.removeAttr,
      n = a.fn.toggleClass,
      o = /\S+/g;
  a.fn.removeAttr = function (b) {
    var d = this;
    return a.each(b.match(o), function (b, e) {
      a.expr.match.bool.test(e) && (c("jQuery.fn.removeAttr no longer sets boolean properties: " + e), d.prop(e, !1));
    }), m.apply(this, arguments);
  }, a.fn.toggleClass = function (b) {
    return void 0 !== b && "boolean" != typeof b ? n.apply(this, arguments) : (c("jQuery.fn.toggleClass( boolean ) is deprecated"), this.each(function () {
      var c = this.getAttribute && this.getAttribute("class") || "";
      c && a.data(this, "__className__", c), this.setAttribute && this.setAttribute("class", c || b === !1 ? "" : a.data(this, "__className__") || "");
    }));
  };
  var p = !1;
  a.swap && a.each(["height", "width", "reliableMarginRight"], function (b, c) {
    var d = a.cssHooks[c] && a.cssHooks[c].get;
    d && (a.cssHooks[c].get = function () {
      var a;
      return p = !0, a = d.apply(this, arguments), p = !1, a;
    });
  }), a.swap = function (a, b, d, e) {
    var f,
        g,
        h = {};
    p || c("jQuery.swap() is undocumented and deprecated");

    for (g in b) {
      h[g] = a.style[g], a.style[g] = b[g];
    }

    f = d.apply(a, e || []);

    for (g in b) {
      a.style[g] = h[g];
    }

    return f;
  };
  var q = a.data;

  a.data = function (b, d, e) {
    var f;
    return d && d !== a.camelCase(d) && (f = a.hasData(b) && q.call(this, b), f && d in f) ? (c("jQuery.data() always sets/gets camelCased names: " + d), arguments.length > 2 && (f[d] = e), f[d]) : q.apply(this, arguments);
  };

  var r = a.Tween.prototype.run;

  a.Tween.prototype.run = function (b) {
    a.easing[this.easing].length > 1 && (c('easing function "jQuery.easing.' + this.easing.toString() + '" should use only first argument'), a.easing[this.easing] = a.easing[this.easing].bind(a.easing, b, this.options.duration * b, 0, 1, this.options.duration)), r.apply(this, arguments);
  };

  var s = a.fn.load,
      t = a.event.fix;
  a.event.props = [], a.event.fixHooks = {}, a.event.fix = function (b) {
    var d,
        e = b.type,
        f = this.fixHooks[e],
        g = a.event.props;
    if (g.length) for (c("jQuery.event.props are deprecated and removed: " + g.join()); g.length;) {
      a.event.addProp(g.pop());
    }
    if (f && !f._migrated_ && (f._migrated_ = !0, c("jQuery.event.fixHooks are deprecated and removed: " + e), (g = f.props) && g.length)) for (; g.length;) {
      a.event.addProp(g.pop());
    }
    return d = t.call(this, b), f && f.filter ? f.filter(d, b) : d;
  }, a.each(["load", "unload", "error"], function (b, d) {
    a.fn[d] = function () {
      var a = Array.prototype.slice.call(arguments, 0);
      return "load" === d && "string" == typeof a[0] ? s.apply(this, a) : (c("jQuery.fn." + d + "() is deprecated"), a.splice(0, 0, d), arguments.length ? this.on.apply(this, a) : (this.triggerHandler.apply(this, a), this));
    };
  }), a(function () {
    a(document).triggerHandler("ready");
  }), a.event.special.ready = {
    setup: function setup() {
      this === document && c("'ready' event is deprecated");
    }
  }, a.fn.extend({
    bind: function bind(a, b, d) {
      return c("jQuery.fn.bind() is deprecated"), this.on(a, null, b, d);
    },
    unbind: function unbind(a, b) {
      return c("jQuery.fn.unbind() is deprecated"), this.off(a, null, b);
    },
    delegate: function delegate(a, b, d, e) {
      return c("jQuery.fn.delegate() is deprecated"), this.on(b, a, d, e);
    },
    undelegate: function undelegate(a, b, d) {
      return c("jQuery.fn.undelegate() is deprecated"), 1 === arguments.length ? this.off(a, "**") : this.off(b, a || "**", d);
    }
  });
  var u = a.fn.offset;

  a.fn.offset = function () {
    var b,
        d = this[0],
        e = {
      top: 0,
      left: 0
    };
    return d && d.nodeType ? (b = (d.ownerDocument || document).documentElement, a.contains(b, d) ? u.apply(this, arguments) : (c("jQuery.fn.offset() requires an element connected to a document"), e)) : (c("jQuery.fn.offset() requires a valid DOM element"), e);
  };

  var v = a.param;

  a.param = function (b, d) {
    var e = a.ajaxSettings && a.ajaxSettings.traditional;
    return void 0 === d && e && (c("jQuery.param() no longer uses jQuery.ajaxSettings.traditional"), d = e), v.call(this, b, d);
  };

  var w = a.fn.andSelf || a.fn.addBack;

  a.fn.andSelf = function () {
    return c("jQuery.fn.andSelf() replaced by jQuery.fn.addBack()"), w.apply(this, arguments);
  };

  var x = a.Deferred,
      y = [["resolve", "done", a.Callbacks("once memory"), a.Callbacks("once memory"), "resolved"], ["reject", "fail", a.Callbacks("once memory"), a.Callbacks("once memory"), "rejected"], ["notify", "progress", a.Callbacks("memory"), a.Callbacks("memory")]];

  a.Deferred = function (b) {
    var d = x(),
        e = d.promise();
    return d.pipe = e.pipe = function () {
      var b = arguments;
      return c("deferred.pipe() is deprecated"), a.Deferred(function (c) {
        a.each(y, function (f, g) {
          var h = a.isFunction(b[f]) && b[f];
          d[g[1]](function () {
            var b = h && h.apply(this, arguments);
            b && a.isFunction(b.promise) ? b.promise().done(c.resolve).fail(c.reject).progress(c.notify) : c[g[0] + "With"](this === e ? c.promise() : this, h ? [b] : arguments);
          });
        }), b = null;
      }).promise();
    }, b && b.call(d, d), d;
  };
}(jQuery, window);

(function (UX) {
  /**
   * UX namespace for basic utils
   * @namespace
   * @type {*|{}}
   */
  UX.utils = UX.utils || {};
  /**
   * Generate unique ID suffix
   * @returns {string}
   */

  UX.utils.generateId = function () {
    // Math.random should be unique because of its seeding algorithm.
    // Convert it to base 36 (numbers + letters), and grab the first 9 characters
    // after the decimal.
    return '_' + Math.random().toString(36).substr(2, 9);
  };
  /**
   * Capitalize first letter
   * @param {string} string
   * @returns {string}
   */


  UX.utils.capitalizeFirstLetter = function (string) {
    if (typeof string == "string") {
      return string.charAt(0).toUpperCase() + string.slice(1);
    } else {
      return "";
    }
  };
})(UX);

(function (UX) {
  /**
   * UX Namespace for tests
   * @namespace
   * @type {*|{}}
   */
  UX.test = UX.test || {};
  /**
   * Test browser support for input[type=date]
   * @returns {boolean}
   */

  UX.test.inputDate = function () {
    // test for input|type=date support
    // it could be better, when tests are separated and used globally - Modernizr test for this issue is much more sofisticated for example
    var hasDateInputSupport = false;

    function checkInput(type) {
      var input = document.createElement("input");
      input.setAttribute("type", type);
      return input.type === type;
    }

    function checkDateInput() {
      var input = document.createElement('input');
      input.setAttribute('type', 'date');
      var notADateValue = 'not-a-date';
      input.setAttribute('value', notADateValue);
      return input.value !== notADateValue;
    }

    if (checkInput('date') && checkDateInput()) {
      hasDateInputSupport = true;
    }

    return hasDateInputSupport;
  };
})(UX);

(function ($) {
  // Focusable pseoudo selector
  $.extend($.expr[':'], {
    focusable: function focusable(el, index, selector) {
      var $el = $(el);
      return $el.is('button, [href], input, select, textarea, object, [tabindex]:not([tabindex="-1"])') // we don't need to check "area" tag, while it is focusable only when it has href attr
      && $el.is(':not(:disabled)') // disabled elements are not focusable
      && $el.is(':visible');
    }
  }); // Tabbable pseudo selector

  $.extend($.expr[':'], {
    tabbable: function tabbable(el, index, selector) {
      var $el = $(el);
      return $el.is(':focusable') && $el.is(':not([tabindex="-1"])');
    }
  });
})(jQuery);

/*!
 * enquire.js v2.1.2 - Awesome Media Queries in JavaScript
 * Copyright (c) 2014 Nick Williams - http://wicky.nillia.ms/enquire.js
 * License: MIT (http://www.opensource.org/licenses/mit-license.php)
 */


(function (name, context, factory) {
  var matchMedia = window.matchMedia;
  /*if (typeof module !== 'undefined' && module.exports) {
  	module.exports = factory(matchMedia);
  }
  else if (typeof define === 'function' && define.amd) {
  	define(function() {
  		return (context[name] = factory(matchMedia));
  	});
  }
  else {
  	context[name] = factory(matchMedia);
  }*/

  context[name] = factory(matchMedia);
})('enquire', window, function (matchMedia) {
  'use strict';
  /*jshint unused:false */

  /**
   * Helper function for iterating over a collection
   *
   * @param collection
   * @param fn
   */

  function each(collection, fn) {
    var i = 0,
        length = collection.length,
        cont;

    for (i; i < length; i++) {
      cont = fn(collection[i], i);

      if (cont === false) {
        break; //allow early exit
      }
    }
  }
  /**
   * Helper function for determining whether target object is an array
   *
   * @param target the object under test
   * @return {Boolean} true if array, false otherwise
   */


  function isArray(target) {
    return Object.prototype.toString.apply(target) === '[object Array]';
  }
  /**
   * Helper function for determining whether target object is a function
   *
   * @param target the object under test
   * @return {Boolean} true if function, false otherwise
   */


  function isFunction(target) {
    return typeof target === 'function';
  }
  /**
   * Delegate to handle a media query being matched and unmatched.
   *
   * @param {object} options
   * @param {function} options.match callback for when the media query is matched
   * @param {function} [options.unmatch] callback for when the media query is unmatched
   * @param {function} [options.setup] one-time callback triggered the first time a query is matched
   * @param {boolean} [options.deferSetup=false] should the setup callback be run immediately, rather than first time query is matched?
   * @constructor
   */


  function QueryHandler(options) {
    this.options = options;
    !options.deferSetup && this.setup();
  }

  QueryHandler.prototype = {
    /**
     * coordinates setup of the handler
     *
     * @function
     */
    setup: function setup() {
      if (this.options.setup) {
        this.options.setup();
      }

      this.initialised = true;
    },

    /**
     * coordinates setup and triggering of the handler
     *
     * @function
     */
    on: function on() {
      !this.initialised && this.setup();
      this.options.match && this.options.match();
    },

    /**
     * coordinates the unmatch event for the handler
     *
     * @function
     */
    off: function off() {
      this.options.unmatch && this.options.unmatch();
    },

    /**
     * called when a handler is to be destroyed.
     * delegates to the destroy or unmatch callbacks, depending on availability.
     *
     * @function
     */
    destroy: function destroy() {
      this.options.destroy ? this.options.destroy() : this.off();
    },

    /**
     * determines equality by reference.
     * if object is supplied compare options, if function, compare match callback
     *
     * @function
     * @param {object || function} [target] the target for comparison
     */
    equals: function equals(target) {
      return this.options === target || this.options.match === target;
    }
  };
  /**
   * Represents a single media query, manages it's state and registered handlers for this query
   *
   * @constructor
   * @param {string} query the media query string
   * @param {boolean} [isUnconditional=false] whether the media query should run regardless of whether the conditions are met. Primarily for helping older browsers deal with mobile-first design
   */

  function MediaQuery(query, isUnconditional) {
    this.query = query;
    this.isUnconditional = isUnconditional;
    this.handlers = [];
    this.mql = matchMedia(query);
    var self = this;

    this.listener = function (mql) {
      self.mql = mql;
      self.assess();
    };

    this.mql.addListener(this.listener);
  }

  MediaQuery.prototype = {
    /**
     * add a handler for this query, triggering if already active
     *
     * @param {object} handler
     * @param {function} handler.match callback for when query is activated
     * @param {function} [handler.unmatch] callback for when query is deactivated
     * @param {function} [handler.setup] callback for immediate execution when a query handler is registered
     * @param {boolean} [handler.deferSetup=false] should the setup callback be deferred until the first time the handler is matched?
     */
    addHandler: function addHandler(handler) {
      var qh = new QueryHandler(handler);
      this.handlers.push(qh);
      this.matches() && qh.on();
    },

    /**
     * removes the given handler from the collection, and calls it's destroy methods
     * 
     * @param {object || function} handler the handler to remove
     */
    removeHandler: function removeHandler(handler) {
      var handlers = this.handlers;
      each(handlers, function (h, i) {
        if (h.equals(handler)) {
          h.destroy();
          return !handlers.splice(i, 1); //remove from array and exit each early
        }
      });
    },

    /**
     * Determine whether the media query should be considered a match
     * 
     * @return {Boolean} true if media query can be considered a match, false otherwise
     */
    matches: function matches() {
      return this.mql.matches || this.isUnconditional;
    },

    /**
     * Clears all handlers and unbinds events
     */
    clear: function clear() {
      each(this.handlers, function (handler) {
        handler.destroy();
      });
      this.mql.removeListener(this.listener);
      this.handlers.length = 0; //clear array
    },

    /*
     * Assesses the query, turning on all handlers if it matches, turning them off if it doesn't match
     */
    assess: function assess() {
      var action = this.matches() ? 'on' : 'off';
      each(this.handlers, function (handler) {
        handler[action]();
      });
    }
  };
  /**
   * Allows for registration of query handlers.
   * Manages the query handler's state and is responsible for wiring up browser events
   *
   * @constructor
   */

  function MediaQueryDispatch() {
    if (!matchMedia) {
      throw new Error('matchMedia not present, legacy browsers require a polyfill');
    }

    this.queries = {};
    this.browserIsIncapable = !matchMedia('only all').matches;
  }

  MediaQueryDispatch.prototype = {
    /**
     * Registers a handler for the given media query
     *
     * @param {string} q the media query
     * @param {object || Array || Function} options either a single query handler object, a function, or an array of query handlers
     * @param {function} options.match fired when query matched
     * @param {function} [options.unmatch] fired when a query is no longer matched
     * @param {function} [options.setup] fired when handler first triggered
     * @param {boolean} [options.deferSetup=false] whether setup should be run immediately or deferred until query is first matched
     * @param {boolean} [shouldDegrade=false] whether this particular media query should always run on incapable browsers
     */
    register: function register(q, options, shouldDegrade) {
      var queries = this.queries,
          isUnconditional = shouldDegrade && this.browserIsIncapable;

      if (!queries[q]) {
        queries[q] = new MediaQuery(q, isUnconditional);
      } //normalise to object in an array


      if (isFunction(options)) {
        options = {
          match: options
        };
      }

      if (!isArray(options)) {
        options = [options];
      }

      each(options, function (handler) {
        if (isFunction(handler)) {
          handler = {
            match: handler
          };
        }

        queries[q].addHandler(handler);
      });
      return this;
    },

    /**
     * unregisters a query and all it's handlers, or a specific handler for a query
     *
     * @param {string} q the media query to target
     * @param {object || function} [handler] specific handler to unregister
     */
    unregister: function unregister(q, handler) {
      var query = this.queries[q];

      if (query) {
        if (handler) {
          query.removeHandler(handler);
        } else {
          query.clear();
          delete this.queries[q];
        }
      }

      return this;
    }
  };
  return new MediaQueryDispatch();
});

/**
 * @license jquery.panzoom.js v3.2.2
 * Updated: Sat Aug 27 2016
 * Add pan and zoom functionality to any element
 * Copyright (c) timmy willison
 * Released under the MIT license
 * https://github.com/timmywil/jquery.panzoom/blob/master/MIT-License.txt
 */
(function (global, factory) {
  // AMD

  /*if (typeof define === 'function' && define.amd) {
  	define([ 'jquery' ], function(jQuery) {
  		return factory(global, jQuery);
  	});
  // CommonJS/Browserify
  } else if (typeof exports === 'object') {
  	factory(global, require('jquery'));
  // Global
  } else {
  	factory(global, global.jQuery);
  }*/
  factory(global, global.jQuery);
})(typeof window !== 'undefined' ? window : window, function (window, $) {
  'use strict';

  var document = window.document;
  var datakey = '__pz__';
  var slice = Array.prototype.slice;
  var rIE11 = /trident\/7./i;

  var supportsInputEvent = function () {
    // IE11 returns a false positive
    if (rIE11.test(navigator.userAgent)) {
      return false;
    }

    var input = document.createElement('input');
    input.setAttribute('oninput', 'return');
    return typeof input.oninput === 'function';
  }(); // Regex


  var rupper = /([A-Z])/g;
  var rsvg = /^http:[\w\.\/]+svg$/;
  var floating = '(\\-?\\d[\\d\\.e-]*)';
  var commaSpace = '\\,?\\s*';
  var rmatrix = new RegExp('^matrix\\(' + floating + commaSpace + floating + commaSpace + floating + commaSpace + floating + commaSpace + floating + commaSpace + floating + '\\)$');
  /**
   * Utility for determining transform matrix equality
   * Checks backwards to test translation first
   * @param {Array} first
   * @param {Array} second
   */

  function matrixEquals(first, second) {
    var i = first.length;

    while (--i) {
      if (Math.round(+first[i]) !== Math.round(+second[i])) {
        return false;
      }
    }

    return true;
  }
  /**
   * Creates the options object for reset functions
   * @param {Boolean|Object} opts See reset methods
   * @returns {Object} Returns the newly-created options object
   */


  function createResetOptions(opts) {
    var options = {
      range: true,
      animate: true
    };

    if (typeof opts === 'boolean') {
      options.animate = opts;
    } else {
      $.extend(options, opts);
    }

    return options;
  }
  /**
   * Represent a transformation matrix with a 3x3 matrix for calculations
   * Matrix functions adapted from Louis Remi's jQuery.transform (https://github.com/louisremi/jquery.transform.js)
   * @param {Array|Number} a An array of six values representing a 2d transformation matrix
   */


  function Matrix(a, b, c, d, e, f, g, h, i) {
    if ($.type(a) === 'array') {
      this.elements = [+a[0], +a[2], +a[4], +a[1], +a[3], +a[5], 0, 0, 1];
    } else {
      this.elements = [a, b, c, d, e, f, g || 0, h || 0, i || 1];
    }
  }

  Matrix.prototype = {
    /**
     * Multiply a 3x3 matrix by a similar matrix or a vector
     * @param {Matrix|Vector} matrix
     * @return {Matrix|Vector} Returns a vector if multiplying by a vector
     */
    x: function x(matrix) {
      var isVector = matrix instanceof Vector;
      var a = this.elements,
          b = matrix.elements;

      if (isVector && b.length === 3) {
        // b is actually a vector
        return new Vector(a[0] * b[0] + a[1] * b[1] + a[2] * b[2], a[3] * b[0] + a[4] * b[1] + a[5] * b[2], a[6] * b[0] + a[7] * b[1] + a[8] * b[2]);
      } else if (b.length === a.length) {
        // b is a 3x3 matrix
        return new Matrix(a[0] * b[0] + a[1] * b[3] + a[2] * b[6], a[0] * b[1] + a[1] * b[4] + a[2] * b[7], a[0] * b[2] + a[1] * b[5] + a[2] * b[8], a[3] * b[0] + a[4] * b[3] + a[5] * b[6], a[3] * b[1] + a[4] * b[4] + a[5] * b[7], a[3] * b[2] + a[4] * b[5] + a[5] * b[8], a[6] * b[0] + a[7] * b[3] + a[8] * b[6], a[6] * b[1] + a[7] * b[4] + a[8] * b[7], a[6] * b[2] + a[7] * b[5] + a[8] * b[8]);
      }

      return false; // fail
    },

    /**
     * Generates an inverse of the current matrix
     * @returns {Matrix}
     */
    inverse: function inverse() {
      var d = 1 / this.determinant(),
          a = this.elements;
      return new Matrix(d * (a[8] * a[4] - a[7] * a[5]), d * -(a[8] * a[1] - a[7] * a[2]), d * (a[5] * a[1] - a[4] * a[2]), d * -(a[8] * a[3] - a[6] * a[5]), d * (a[8] * a[0] - a[6] * a[2]), d * -(a[5] * a[0] - a[3] * a[2]), d * (a[7] * a[3] - a[6] * a[4]), d * -(a[7] * a[0] - a[6] * a[1]), d * (a[4] * a[0] - a[3] * a[1]));
    },

    /**
     * Calculates the determinant of the current matrix
     * @returns {Number}
     */
    determinant: function determinant() {
      var a = this.elements;
      return a[0] * (a[8] * a[4] - a[7] * a[5]) - a[3] * (a[8] * a[1] - a[7] * a[2]) + a[6] * (a[5] * a[1] - a[4] * a[2]);
    }
  };
  /**
   * Create a vector containing three values
   */

  function Vector(x, y, z) {
    this.elements = [x, y, z];
  }
  /**
   * Get the element at zero-indexed index i
   * @param {Number} i
   */


  Vector.prototype.e = Matrix.prototype.e = function (i) {
    return this.elements[i];
  };
  /**
   * Create a Panzoom object for a given element
   * @constructor
   * @param {Element} elem - Element to use pan and zoom
   * @param {Object} [options] - An object literal containing options to override default options
   *  (See Panzoom.defaults for ones not listed below)
   * @param {jQuery} [options.$zoomIn] - zoom in buttons/links collection (you can also bind these yourself
   *  e.g. $button.on('click', function(e) { e.preventDefault(); $elem.panzoom('zoomIn'); });)
   * @param {jQuery} [options.$zoomOut] - zoom out buttons/links collection on which to bind zoomOut
   * @param {jQuery} [options.$zoomRange] - zoom in/out with this range control
   * @param {jQuery} [options.$reset] - Reset buttons/links collection on which to bind the reset method
   * @param {Function} [options.on[Start|Change|Zoom|Pan|End|Reset] - Optional callbacks for panzoom events
   */


  function Panzoom(elem, options) {
    // Allow instantiation without `new` keyword
    if (!(this instanceof Panzoom)) {
      return new Panzoom(elem, options);
    } // Sanity checks


    if (elem.nodeType !== 1) {
      $.error('Panzoom called on non-Element node');
    }

    if (!$.contains(document, elem)) {
      $.error('Panzoom element must be attached to the document');
    } // Don't remake


    var d = $.data(elem, datakey);

    if (d) {
      return d;
    } // Extend default with given object literal
    // Each instance gets its own options


    this.options = options = $.extend({}, Panzoom.defaults, options);
    this.elem = elem;
    var $elem = this.$elem = $(elem);
    this.$set = options.$set && options.$set.length ? options.$set : $elem;
    this.$doc = $(elem.ownerDocument || document);
    this.$parent = $elem.parent();
    this.parent = this.$parent[0]; // This is SVG if the namespace is SVG
    // However, while <svg> elements are SVG, we want to treat those like other elements

    this.isSVG = rsvg.test(elem.namespaceURI) && elem.nodeName.toLowerCase() !== 'svg';
    this.panning = false; // Save the original transform value
    // Save the prefixed transform style key
    // Set the starting transform

    this._buildTransform(); // Build the appropriately-prefixed transform style property name
    // De-camelcase


    this._transform = $.cssProps.transform.replace(rupper, '-$1').toLowerCase(); // Build the transition value

    this._buildTransition(); // Build containment dimensions


    this.resetDimensions(); // Add zoom and reset buttons to `this`

    var $empty = $();
    var self = this;
    $.each(['$zoomIn', '$zoomOut', '$zoomRange', '$reset'], function (i, name) {
      self[name] = options[name] || $empty;
    });
    this.enable();
    this.scale = this.getMatrix()[0];

    this._checkPanWhenZoomed(); // Save the instance


    $.data(elem, datakey, this);
  } // Attach regex for possible use (immutable)


  Panzoom.rmatrix = rmatrix;
  Panzoom.defaults = {
    // Should always be non-empty
    // Used to bind jQuery events without collisions
    // A guid is not added here as different instantiations/versions of panzoom
    // on the same element is not supported, so don't do it.
    eventNamespace: '.panzoom',
    // Whether or not to transition the scale
    transition: true,
    // Default cursor style for the element
    cursor: 'move',
    // There may be some use cases for zooming without panning or vice versa
    disablePan: false,
    disableZoom: false,
    // Pan only on the X or Y axes
    disableXAxis: false,
    disableYAxis: false,
    // Set whether you'd like to pan on left (1), middle (2), or right click (3)
    which: 1,
    // The increment at which to zoom
    // adds/subtracts to the scale each time zoomIn/Out is called
    increment: 0.3,
    // Turns on exponential zooming
    // If false, zooming will be incremented linearly
    exponential: true,
    // Pan only when the scale is greater than minScale
    panOnlyWhenZoomed: false,
    // min and max zoom scales
    minScale: 0.3,
    maxScale: 6,
    // The default step for the range input
    // Precendence: default < HTML attribute < option setting
    rangeStep: 0.05,
    // Animation duration (ms)
    duration: 200,
    // CSS easing used for scale transition
    easing: 'ease-in-out',
    // Indicate that the element should be contained within it's parent when panning
    // Note: this does not affect zooming outside of the parent
    // Set this value to 'invert' to only allow panning outside of the parent element (basically the opposite of the normal use of contain)
    // 'invert' is useful for a large panzoom element where you don't want to show anything behind it
    contain: false
  };
  Panzoom.prototype = {
    constructor: Panzoom,

    /**
     * @returns {Panzoom} Returns the instance
     */
    instance: function instance() {
      return this;
    },

    /**
     * Enable or re-enable the panzoom instance
     */
    enable: function enable() {
      // Unbind first
      this._initStyle();

      this._bind();

      this.disabled = false;
    },

    /**
     * Disable panzoom
     */
    disable: function disable() {
      this.disabled = true;

      this._resetStyle();

      this._unbind();
    },

    /**
     * @returns {Boolean} Returns whether the current panzoom instance is disabled
     */
    isDisabled: function isDisabled() {
      return this.disabled;
    },

    /**
     * Destroy the panzoom instance
     */
    destroy: function destroy() {
      this.disable();
      $.removeData(this.elem, datakey);
    },

    /**
     * Builds the restricing dimensions from the containment element
     * Also used with focal points
     * Call this method whenever the dimensions of the element or parent are changed
     */
    resetDimensions: function resetDimensions() {
      // Reset container properties
      this.container = this.parent.getBoundingClientRect(); // Set element properties

      var elem = this.elem; // getBoundingClientRect() works with SVG, offsetWidth does not

      var dims = elem.getBoundingClientRect();
      var absScale = Math.abs(this.scale);
      this.dimensions = {
        width: dims.width,
        height: dims.height,
        left: $.css(elem, 'left', true) || 0,
        top: $.css(elem, 'top', true) || 0,
        // Borders and margins are scaled
        border: {
          top: $.css(elem, 'borderTopWidth', true) * absScale || 0,
          bottom: $.css(elem, 'borderBottomWidth', true) * absScale || 0,
          left: $.css(elem, 'borderLeftWidth', true) * absScale || 0,
          right: $.css(elem, 'borderRightWidth', true) * absScale || 0
        },
        margin: {
          top: $.css(elem, 'marginTop', true) * absScale || 0,
          left: $.css(elem, 'marginLeft', true) * absScale || 0
        }
      };
    },

    /**
     * Return the element to it's original transform matrix
     * @param {Boolean} [options] If a boolean is passed, animate the reset (default: true). If an options object is passed, simply pass that along to setMatrix.
     * @param {Boolean} [options.silent] Silence the reset event
     */
    reset: function reset(options) {
      options = createResetOptions(options); // Reset the transform to its original value

      var matrix = this.setMatrix(this._origTransform, options);

      if (!options.silent) {
        this._trigger('reset', matrix);
      }
    },

    /**
     * Only resets zoom level
     * @param {Boolean|Object} [options] Whether to animate the reset (default: true) or an object of options to pass to zoom()
     */
    resetZoom: function resetZoom(options) {
      options = createResetOptions(options);
      var origMatrix = this.getMatrix(this._origTransform);
      options.dValue = origMatrix[3];
      this.zoom(origMatrix[0], options);
    },

    /**
     * Only reset panning
     * @param {Boolean|Object} [options] Whether to animate the reset (default: true) or an object of options to pass to pan()
     */
    resetPan: function resetPan(options) {
      var origMatrix = this.getMatrix(this._origTransform);
      this.pan(origMatrix[4], origMatrix[5], createResetOptions(options));
    },

    /**
     * Sets a transform on the $set
     * For SVG, the style attribute takes precedence
     * and allows us to animate
     * @param {String} transform
     */
    setTransform: function setTransform(transform) {
      var $set = this.$set;
      var i = $set.length;

      while (i--) {
        $.style($set[i], 'transform', transform); // Support IE9-11, Edge 13-14+
        // Set attribute alongside style attribute
        // since IE and Edge do not respect style settings on SVG
        // See https://css-tricks.com/transforms-on-svg-elements/

        if (this.isSVG) {
          $set[i].setAttribute('transform', transform);
        }
      }
    },

    /**
     * Retrieving the transform is different for SVG
     *  (unless a style transform is already present)
     * Uses the $set collection for retrieving the transform
     * @param {String} [transform] Pass in an transform value (like 'scale(1.1)')
     *  to have it formatted into matrix format for use by Panzoom
     * @returns {String} Returns the current transform value of the element
     */
    getTransform: function getTransform(transform) {
      var $set = this.$set;
      var transformElem = $set[0];

      if (transform) {
        this.setTransform(transform);
      } else {
        // IE and Edge still set the transform style properly
        // They just don't render it on SVG
        // So we get a correct value here
        transform = $.style(transformElem, 'transform');

        if (this.isSVG && (!transform || transform === 'none')) {
          transform = $.attr(transformElem, 'transform') || 'none';
        }
      } // Convert any transforms set by the user to matrix format
      // by setting to computed


      if (transform !== 'none' && !rmatrix.test(transform)) {
        // Get computed and set for next time
        this.setTransform(transform = $.css(transformElem, 'transform'));
      }

      return transform || 'none';
    },

    /**
     * Retrieve the current transform matrix for $elem (or turn a transform into it's array values)
     * @param {String} [transform] matrix-formatted transform value
     * @returns {Array} Returns the current transform matrix split up into it's parts, or a default matrix
     */
    getMatrix: function getMatrix(transform) {
      var matrix = rmatrix.exec(transform || this.getTransform());

      if (matrix) {
        matrix.shift();
      }

      return matrix || [1, 0, 0, 1, 0, 0];
    },

    /**
     * Given a matrix object, quickly set the current matrix of the element
     * @param {Array|String} matrix
     * @param {Object} [options]
     * @param {Boolean|String} [options.animate] Whether to animate the transform change, or 'skip' indicating that it is unnecessary to set
     * @param {Boolean} [options.contain] Override the global contain option
     * @param {Boolean} [options.range] If true, $zoomRange's value will be updated.
     * @param {Boolean} [options.silent] If true, the change event will not be triggered
     * @returns {Array} Returns the newly-set matrix
     */
    setMatrix: function setMatrix(matrix, options) {
      if (this.disabled) {
        return;
      }

      if (!options) {
        options = {};
      } // Convert to array


      if (typeof matrix === 'string') {
        matrix = this.getMatrix(matrix);
      }

      var scale = +matrix[0];
      var contain = typeof options.contain !== 'undefined' ? options.contain : this.options.contain; // Apply containment

      if (contain) {
        var dims = options.dims;

        if (!dims) {
          this.resetDimensions();
          dims = this.dimensions;
        }

        var spaceWLeft, spaceWRight, scaleDiff;
        var container = this.container;
        var width = dims.width;
        var height = dims.height;
        var conWidth = container.width;
        var conHeight = container.height;
        var zoomAspectW = conWidth / width;
        var zoomAspectH = conHeight / height; // If the element is not naturally centered,
        // assume full space right

        if (this.$parent.css('textAlign') !== 'center' || $.css(this.elem, 'display') !== 'inline') {
          // offsetWidth gets us the width without the transform
          scaleDiff = (width - this.elem.offsetWidth) / 2;
          spaceWLeft = scaleDiff - dims.border.left;
          spaceWRight = width - conWidth - scaleDiff + dims.border.right;
        } else {
          spaceWLeft = spaceWRight = (width - conWidth) / 2;
        }

        var spaceHTop = (height - conHeight) / 2 + dims.border.top;
        var spaceHBottom = (height - conHeight) / 2 - dims.border.top - dims.border.bottom;

        if (contain === 'invert' || contain === 'automatic' && zoomAspectW < 1.01) {
          matrix[4] = Math.max(Math.min(matrix[4], spaceWLeft - dims.border.left), -spaceWRight);
        } else {
          matrix[4] = Math.min(Math.max(matrix[4], spaceWLeft), -spaceWRight);
        }

        if (contain === 'invert' || contain === 'automatic' && zoomAspectH < 1.01) {
          matrix[5] = Math.max(Math.min(matrix[5], spaceHTop - dims.border.top), -spaceHBottom);
        } else {
          matrix[5] = Math.min(Math.max(matrix[5], spaceHTop), -spaceHBottom);
        }
      } // Animate


      if (options.animate !== 'skip') {
        // Set transition
        this.transition(!options.animate);
      } // Update range element


      if (options.range) {
        this.$zoomRange.val(scale);
      } // Set the matrix on this.$set


      if (this.options.disableXAxis || this.options.disableYAxis) {
        var originalMatrix = this.getMatrix();

        if (this.options.disableXAxis) {
          matrix[4] = originalMatrix[4];
        }

        if (this.options.disableYAxis) {
          matrix[5] = originalMatrix[5];
        }
      }

      this.setTransform('matrix(' + matrix.join(',') + ')');
      this.scale = scale; // Disable/enable panning if zooming is at minimum and panOnlyWhenZoomed is true

      this._checkPanWhenZoomed(scale);

      if (!options.silent) {
        this._trigger('change', matrix);
      }

      return matrix;
    },

    /**
     * @returns {Boolean} Returns whether the panzoom element is currently being dragged
     */
    isPanning: function isPanning() {
      return this.panning;
    },

    /**
     * Apply the current transition to the element, if allowed
     * @param {Boolean} [off] Indicates that the transition should be turned off
     */
    transition: function transition(off) {
      if (!this._transition) {
        return;
      }

      var transition = off || !this.options.transition ? 'none' : this._transition;
      var $set = this.$set;
      var i = $set.length;

      while (i--) {
        // Avoid reflows when zooming
        if ($.style($set[i], 'transition') !== transition) {
          $.style($set[i], 'transition', transition);
        }
      }
    },

    /**
     * Pan the element to the specified translation X and Y
     * Note: this is not the same as setting jQuery#offset() or jQuery#position()
     * @param {Number} x
     * @param {Number} y
     * @param {Object} [options] These options are passed along to setMatrix
     * @param {Array} [options.matrix] The matrix being manipulated (if already known so it doesn't have to be retrieved again)
     * @param {Boolean} [options.silent] Silence the pan event. Note that this will also silence the setMatrix change event.
     * @param {Boolean} [options.relative] Make the x and y values relative to the existing matrix
     */
    pan: function pan(x, y, options) {
      if (this.options.disablePan) {
        return;
      }

      if (!options) {
        options = {};
      }

      var matrix = options.matrix;

      if (!matrix) {
        matrix = this.getMatrix();
      } // Cast existing matrix values to numbers


      if (options.relative) {
        x += +matrix[4];
        y += +matrix[5];
      }

      matrix[4] = x;
      matrix[5] = y;
      this.setMatrix(matrix, options);

      if (!options.silent) {
        this._trigger('pan', matrix[4], matrix[5]);
      }
    },

    /**
     * Zoom in/out the element using the scale properties of a transform matrix
     * @param {Number|Boolean} [scale] The scale to which to zoom or a boolean indicating to transition a zoom out
     * @param {Object} [opts] All global options can be overwritten by this options object. For example, override the default increment.
     * @param {Boolean} [opts.noSetRange] Specify that the method should not set the $zoomRange value (as is the case when $zoomRange is calling zoom on change)
     * @param {jQuery.Event|Object} [opts.focal] A focal point on the panzoom element on which to zoom.
     *  If an object, set the clientX and clientY properties to the position relative to the parent
     * @param {Boolean} [opts.animate] Whether to animate the zoom (defaults to true if scale is not a number, false otherwise)
     * @param {Boolean} [opts.silent] Silence the zoom event
     * @param {Array} [opts.matrix] Optionally pass the current matrix so it doesn't need to be retrieved
     * @param {Number} [opts.dValue] Think of a transform matrix as four values a, b, c, d
     *  where a/d are the horizontal/vertical scale values and b/c are the skew values
     *  (5 and 6 of matrix array are the tx/ty transform values).
     *  Normally, the scale is set to both the a and d values of the matrix.
     *  This option allows you to specify a different d value for the zoom.
     *  For instance, to flip vertically, you could set -1 as the dValue.
     */
    zoom: function zoom(scale, opts) {
      // Shuffle arguments
      if (_typeof(scale) === 'object') {
        opts = scale;
        scale = null;
      } else if (!opts) {
        opts = {};
      }

      var options = $.extend({}, this.options, opts); // Check if disabled

      if (options.disableZoom) {
        return;
      }

      var animate = false;
      var matrix = options.matrix || this.getMatrix();
      var startScale = +matrix[0]; // Calculate zoom based on increment

      if (typeof scale !== 'number') {
        // Just use a number a little greater than 1
        // Below 1 can use normal increments
        if (options.exponential && startScale - options.increment >= 1) {
          scale = Math[scale ? 'sqrt' : 'pow'](startScale, 2);
        } else {
          scale = startScale + options.increment * (scale ? -1 : 1);
        }

        animate = true;
      } // Constrain scale


      if (scale > options.maxScale) {
        scale = options.maxScale;
      } else if (scale < options.minScale) {
        scale = options.minScale;
      } // Calculate focal point based on scale


      var focal = options.focal;

      if (focal && !options.disablePan) {
        // Adapted from code by Florian Günther
        // https://github.com/florianguenther/zui53
        this.resetDimensions();
        var dims = options.dims = this.dimensions;
        var clientX = focal.clientX;
        var clientY = focal.clientY; // Adjust the focal point for transform-origin 50% 50%
        // SVG elements have a transform origin of 0 0

        if (!this.isSVG) {
          clientX -= dims.width / startScale / 2;
          clientY -= dims.height / startScale / 2;
        }

        var clientV = new Vector(clientX, clientY, 1);
        var surfaceM = new Matrix(matrix); // Supply an offset manually if necessary

        var o = this.parentOffset || this.$parent.offset();
        var offsetM = new Matrix(1, 0, o.left - this.$doc.scrollLeft(), 0, 1, o.top - this.$doc.scrollTop());
        var surfaceV = surfaceM.inverse().x(offsetM.inverse().x(clientV));
        var scaleBy = scale / matrix[0];
        surfaceM = surfaceM.x(new Matrix([scaleBy, 0, 0, scaleBy, 0, 0]));
        clientV = offsetM.x(surfaceM.x(surfaceV));
        matrix[4] = +matrix[4] + (clientX - clientV.e(0));
        matrix[5] = +matrix[5] + (clientY - clientV.e(1));
      } // Set the scale


      matrix[0] = scale;
      matrix[3] = typeof options.dValue === 'number' ? options.dValue : scale; // Calling zoom may still pan the element

      this.setMatrix(matrix, {
        animate: typeof options.animate !== 'undefined' ? options.animate : animate,
        // Set the zoomRange value
        range: !options.noSetRange
      }); // Trigger zoom event

      if (!options.silent) {
        this._trigger('zoom', matrix[0], options);
      }
    },

    /**
     * Get/set option on an existing instance
     * @returns {Array|undefined} If getting, returns an array of all values
     *   on each instance for a given key. If setting, continue chaining by returning undefined.
     */
    option: function option(key, value) {
      var options;

      if (!key) {
        // Avoids returning direct reference
        return $.extend({}, this.options);
      }

      if (typeof key === 'string') {
        if (arguments.length === 1) {
          return this.options[key] !== undefined ? this.options[key] : null;
        }

        options = {};
        options[key] = value;
      } else {
        options = key;
      }

      this._setOptions(options);
    },

    /**
     * Internally sets options
     * @param {Object} options - An object literal of options to set
     * @private
     */
    _setOptions: function _setOptions(options) {
      $.each(options, $.proxy(function (key, value) {
        switch (key) {
          case 'disablePan':
            this._resetStyle();

          /* falls through */

          case '$zoomIn':
          case '$zoomOut':
          case '$zoomRange':
          case '$reset':
          case 'disableZoom':
          case 'onStart':
          case 'onChange':
          case 'onZoom':
          case 'onPan':
          case 'onEnd':
          case 'onReset':
          case 'eventNamespace':
            this._unbind();

        }

        this.options[key] = value;

        switch (key) {
          case 'disablePan':
            this._initStyle();

          /* falls through */

          case '$zoomIn':
          case '$zoomOut':
          case '$zoomRange':
          case '$reset':
            // Set these on the instance
            this[key] = value;

          /* falls through */

          case 'disableZoom':
          case 'onStart':
          case 'onChange':
          case 'onZoom':
          case 'onPan':
          case 'onEnd':
          case 'onReset':
          case 'eventNamespace':
            this._bind();

            break;

          case 'cursor':
            $.style(this.elem, 'cursor', value);
            break;

          case 'minScale':
            this.$zoomRange.attr('min', value);
            break;

          case 'maxScale':
            this.$zoomRange.attr('max', value);
            break;

          case 'rangeStep':
            this.$zoomRange.attr('step', value);
            break;

          case 'startTransform':
            this._buildTransform();

            break;

          case 'duration':
          case 'easing':
            this._buildTransition();

          /* falls through */

          case 'transition':
            this.transition();
            break;

          case 'panOnlyWhenZoomed':
            this._checkPanWhenZoomed();

            break;

          case '$set':
            if (value instanceof $ && value.length) {
              this.$set = value; // Reset styles

              this._initStyle();

              this._buildTransform();
            }

        }
      }, this));
    },

    /**
     * Disable/enable panning depending on whether the current scale
     * matches the minimum
     * @param {Number} [scale]
     * @private
     */
    _checkPanWhenZoomed: function _checkPanWhenZoomed(scale) {
      var options = this.options;

      if (options.panOnlyWhenZoomed) {
        if (!scale) {
          scale = this.getMatrix()[0];
        }

        var toDisable = scale <= options.minScale;

        if (options.disablePan !== toDisable) {
          this.option('disablePan', toDisable);
        }
      }
    },

    /**
     * Initialize base styles for the element and its parent
     * @private
     */
    _initStyle: function _initStyle() {
      var styles = {
        // Set the same default whether SVG or HTML
        // transform-origin cannot be changed to 50% 50% in IE9-11 or Edge 13-14+
        'transform-origin': this.isSVG ? '0 0' : '50% 50%'
      }; // Set elem styles

      if (!this.options.disablePan) {
        styles.cursor = this.options.cursor;
      }

      this.$set.css(styles); // Set parent to relative if set to static

      var $parent = this.$parent; // No need to add styles to the body

      if ($parent.length && !$.nodeName(this.parent, 'body')) {
        styles = {
          overflow: 'hidden'
        };

        if ($parent.css('position') === 'static') {
          styles.position = 'relative';
        }

        $parent.css(styles);
      }
    },

    /**
     * Undo any styles attached in this plugin
     * @private
     */
    _resetStyle: function _resetStyle() {
      this.$elem.css({
        'cursor': '',
        'transition': ''
      });
      this.$parent.css({
        'overflow': '',
        'position': ''
      });
    },

    /**
     * Binds all necessary events
     * @private
     */
    _bind: function _bind() {
      var self = this;
      var options = this.options;
      var ns = options.eventNamespace;
      var str_down = 'mousedown' + ns + ' pointerdown' + ns + ' MSPointerDown' + ns;
      var str_start = 'touchstart' + ns + ' ' + str_down;
      var str_click = 'touchend' + ns + ' click' + ns + ' pointerup' + ns + ' MSPointerUp' + ns;
      var events = {};
      var $reset = this.$reset;
      var $zoomRange = this.$zoomRange; // Bind panzoom events from options

      $.each(['Start', 'Change', 'Zoom', 'Pan', 'End', 'Reset'], function () {
        var m = options['on' + this];

        if ($.isFunction(m)) {
          events['panzoom' + this.toLowerCase() + ns] = m;
        }
      }); // Bind $elem drag and click/touchdown events
      // Bind touchstart if either panning or zooming is enabled

      if (!options.disablePan || !options.disableZoom) {
        events[str_start] = function (e) {
          var touches;

          if (e.type === 'touchstart' ? // Touch
          (touches = e.touches || e.originalEvent.touches) && (touches.length === 1 && !options.disablePan || touches.length === 2) : // Mouse/Pointer: Ignore unexpected click types
          // Support: IE10 only
          // IE10 does not support e.button for MSPointerDown, but does have e.which
          !options.disablePan && (e.which || e.originalEvent.which) === options.which) {
            e.preventDefault();
            e.stopPropagation();

            self._startMove(e, touches);
          }
        }; // Prevent the contextmenu event
        // if we're binding to right-click


        if (options.which === 3) {
          events.contextmenu = false;
        }
      }

      this.$elem.on(events); // Bind reset

      if ($reset.length) {
        $reset.on(str_click, function (e) {
          e.preventDefault();
          self.reset();
        });
      } // Set default attributes for the range input


      if ($zoomRange.length) {
        $zoomRange.attr({
          // Only set the range step if explicit or
          // set the default if there is no attribute present
          step: options.rangeStep === Panzoom.defaults.rangeStep && $zoomRange.attr('step') || options.rangeStep,
          min: options.minScale,
          max: options.maxScale
        }).prop({
          value: this.getMatrix()[0]
        });
      } // No bindings if zooming is disabled


      if (options.disableZoom) {
        return;
      }

      var $zoomIn = this.$zoomIn;
      var $zoomOut = this.$zoomOut; // Bind zoom in/out
      // Don't bind one without the other

      if ($zoomIn.length && $zoomOut.length) {
        // preventDefault cancels future mouse events on touch events
        $zoomIn.on(str_click, function (e) {
          e.preventDefault();
          self.zoom();
        });
        $zoomOut.on(str_click, function (e) {
          e.preventDefault();
          self.zoom(true);
        });
      }

      if ($zoomRange.length) {
        events = {}; // Cannot prevent default action here

        events[str_down] = function () {
          self.transition(true);
        }; // Zoom on input events if available and change events
        // See https://github.com/timmywil/jquery.panzoom/issues/90


        events[(supportsInputEvent ? 'input' : 'change') + ns] = function () {
          self.zoom(+this.value, {
            noSetRange: true
          });
        };

        $zoomRange.on(events);
      }
    },

    /**
     * Unbind all events
     * @private
     */
    _unbind: function _unbind() {
      this.$elem.add(this.$zoomIn).add(this.$zoomOut).add(this.$reset).off(this.options.eventNamespace);
    },

    /**
     * Builds the original transform value
     * @private
     */
    _buildTransform: function _buildTransform() {
      // Save the original transform
      // Retrieving this also adds the correct prefixed style name
      // to jQuery's internal $.cssProps
      return this._origTransform = this.getTransform(this.options.startTransform);
    },

    /**
     * Set transition property for later use when zooming
     * @private
     */
    _buildTransition: function _buildTransition() {
      if (this._transform) {
        var options = this.options;
        this._transition = this._transform + ' ' + options.duration + 'ms ' + options.easing;
      }
    },

    /**
     * Calculates the distance between two touch points
     * Remember pythagorean?
     * @param {Array} touches
     * @returns {Number} Returns the distance
     * @private
     */
    _getDistance: function _getDistance(touches) {
      var touch1 = touches[0];
      var touch2 = touches[1];
      return Math.sqrt(Math.pow(Math.abs(touch2.clientX - touch1.clientX), 2) + Math.pow(Math.abs(touch2.clientY - touch1.clientY), 2));
    },

    /**
     * Constructs an approximated point in the middle of two touch points
     * @returns {Object} Returns an object containing pageX and pageY
     * @private
     */
    _getMiddle: function _getMiddle(touches) {
      var touch1 = touches[0];
      var touch2 = touches[1];
      return {
        clientX: (touch2.clientX - touch1.clientX) / 2 + touch1.clientX,
        clientY: (touch2.clientY - touch1.clientY) / 2 + touch1.clientY
      };
    },

    /**
     * Trigger a panzoom event on our element
     * The event is passed the Panzoom instance
     * @param {String|jQuery.Event} event
     * @param {Mixed} arg1[, arg2, arg3, ...] Arguments to append to the trigger
     * @private
     */
    _trigger: function _trigger(event) {
      if (typeof event === 'string') {
        event = 'panzoom' + event;
      }

      this.$elem.triggerHandler(event, [this].concat(slice.call(arguments, 1)));
    },

    /**
     * Starts the pan
     * This is bound to mouse/touchmove on the element
     * @param {jQuery.Event} event An event with pageX, pageY, and possibly the touches list
     * @param {TouchList} [touches] The touches list if present
     * @private
     */
    _startMove: function _startMove(event, touches) {
      if (this.panning) {
        return;
      }

      var moveEvent, endEvent, startDistance, startScale, startMiddle, startPageX, startPageY, touch;
      var self = this;
      var options = this.options;
      var ns = options.eventNamespace;
      var matrix = this.getMatrix();
      var original = matrix.slice(0);
      var origPageX = +original[4];
      var origPageY = +original[5];
      var panOptions = {
        matrix: matrix,
        animate: 'skip'
      };
      var type = event.type; // Use proper events

      if (type === 'pointerdown') {
        moveEvent = 'pointermove';
        endEvent = 'pointerup';
      } else if (type === 'touchstart') {
        moveEvent = 'touchmove';
        endEvent = 'touchend';
      } else if (type === 'MSPointerDown') {
        moveEvent = 'MSPointerMove';
        endEvent = 'MSPointerUp';
      } else {
        moveEvent = 'mousemove';
        endEvent = 'mouseup';
      } // Add namespace


      moveEvent += ns;
      endEvent += ns; // Remove any transitions happening

      this.transition(true); // Indicate that we are currently panning

      this.panning = true; // Trigger start event

      this._trigger('start', event, touches);

      var setStart = function setStart(event, touches) {
        if (touches) {
          if (touches.length === 2) {
            if (startDistance != null) {
              return;
            }

            startDistance = self._getDistance(touches);
            startScale = +matrix[0];
            startMiddle = self._getMiddle(touches);
            return;
          }

          if (startPageX != null) {
            return;
          }

          if (touch = touches[0]) {
            startPageX = touch.pageX;
            startPageY = touch.pageY;
          }
        }

        if (startPageX != null) {
          return;
        }

        startPageX = event.pageX;
        startPageY = event.pageY;
      };

      setStart(event, touches);

      var move = function move(e) {
        var coords;
        e.preventDefault();
        touches = e.touches || e.originalEvent.touches;
        setStart(e, touches);

        if (touches) {
          if (touches.length === 2) {
            // Calculate move on middle point
            var middle = self._getMiddle(touches);

            var diff = self._getDistance(touches) - startDistance; // Set zoom

            self.zoom(diff * (options.increment / 100) + startScale, {
              focal: middle,
              matrix: matrix,
              animate: 'skip'
            }); // Set pan

            self.pan(+matrix[4] + middle.clientX - startMiddle.clientX, +matrix[5] + middle.clientY - startMiddle.clientY, panOptions);
            startMiddle = middle;
            return;
          }

          coords = touches[0] || {
            pageX: 0,
            pageY: 0
          };
        }

        if (!coords) {
          coords = e;
        }

        self.pan(origPageX + coords.pageX - startPageX, origPageY + coords.pageY - startPageY, panOptions);
      }; // Bind the handlers


      $(document).off(ns).on(moveEvent, move).on(endEvent, function (e) {
        e.preventDefault(); // Unbind all document events

        $(this).off(ns);
        self.panning = false; // Trigger our end event
        // Simply set the type to "panzoomend" to pass through all end properties
        // jQuery's `not` is used here to compare Array equality

        e.type = 'panzoomend';

        self._trigger(e, matrix, !matrixEquals(matrix, original));
      });
    }
  }; // Add Panzoom as a static property

  $.Panzoom = Panzoom;
  /**
   * Extend jQuery
   * @param {Object|String} options - The name of a method to call on the prototype
   *  or an object literal of options
   * @returns {jQuery|Mixed} jQuery instance for regular chaining or the return value(s) of a panzoom method call
   */

  $.fn.panzoom = function (options) {
    var instance, args, m, ret; // Call methods widget-style

    if (typeof options === 'string') {
      ret = [];
      args = slice.call(arguments, 1);
      this.each(function () {
        instance = $.data(this, datakey);

        if (!instance) {
          ret.push(undefined); // Ignore methods beginning with `_`
        } else if (options.charAt(0) !== '_' && typeof (m = instance[options]) === 'function' && // If nothing is returned, do not add to return values
        (m = m.apply(instance, args)) !== undefined) {
          ret.push(m);
        }
      }); // Return an array of values for the jQuery instances
      // Or the value itself if there is only one
      // Or keep chaining

      return ret.length ? ret.length === 1 ? ret[0] : ret : this;
    }

    return this.each(function () {
      new Panzoom(this, options);
    });
  };

  return Panzoom;
});

/*!
 * @fileOverview TouchSwipe - jQuery Plugin
 * @version 1.6.18
 *
 * @author Matt Bryson http://www.github.com/mattbryson
 * @see https://github.com/mattbryson/TouchSwipe-Jquery-Plugin
 * @see http://labs.rampinteractive.co.uk/touchSwipe/
 * @see http://plugins.jquery.com/project/touchSwipe
 * @license
 * Copyright (c) 2010-2015 Matt Bryson
 * Dual licensed under the MIT or GPL Version 2 licenses.
 *
 */

/*
 *
 * Changelog
 * $Date: 2010-12-12 (Wed, 12 Dec 2010) $
 * $version: 1.0.0
 * $version: 1.0.1 - removed multibyte comments
 *
 * $Date: 2011-21-02 (Mon, 21 Feb 2011) $
 * $version: 1.1.0 	- added allowPageScroll property to allow swiping and scrolling of page
 *					- changed handler signatures so one handler can be used for multiple events
 * $Date: 2011-23-02 (Wed, 23 Feb 2011) $
 * $version: 1.2.0 	- added click handler. This is fired if the user simply clicks and does not swipe. The event object and click target are passed to handler.
 *					- If you use the http://code.google.com/p/jquery-ui-for-ipad-and-iphone/ plugin, you can also assign jQuery mouse events to children of a touchSwipe object.
 * $version: 1.2.1 	- removed console log!
 *
 * $version: 1.2.2 	- Fixed bug where scope was not preserved in callback methods.
 *
 * $Date: 2011-28-04 (Thurs, 28 April 2011) $
 * $version: 1.2.4 	- Changed licence terms to be MIT or GPL inline with jQuery. Added check for support of touch events to stop non compatible browsers erroring.
 *
 * $Date: 2011-27-09 (Tues, 27 September 2011) $
 * $version: 1.2.5 	- Added support for testing swipes with mouse on desktop browser (thanks to https://github.com/joelhy)
 *
 * $Date: 2012-14-05 (Mon, 14 May 2012) $
 * $version: 1.2.6 	- Added timeThreshold between start and end touch, so user can ignore slow swipes (thanks to Mark Chase). Default is null, all swipes are detected
 *
 * $Date: 2012-05-06 (Tues, 05 June 2012) $
 * $version: 1.2.7 	- Changed time threshold to have null default for backwards compatibility. Added duration param passed back in events, and refactored how time is handled.
 *
 * $Date: 2012-05-06 (Tues, 05 June 2012) $
 * $version: 1.2.8 	- Added the possibility to return a value like null or false in the trigger callback. In that way we can control when the touch start/move should take effect or not (simply by returning in some cases return null; or return false;) This effects the ontouchstart/ontouchmove event.
 *
 * $Date: 2012-06-06 (Wed, 06 June 2012) $
 * $version: 1.3.0 	- Refactored whole plugin to allow for methods to be executed, as well as exposed defaults for user override. Added 'enable', 'disable', and 'destroy' methods
 *
 * $Date: 2012-05-06 (Fri, 05 June 2012) $
 * $version: 1.3.1 	- Bug fixes  - bind() with false as last argument is no longer supported in jQuery 1.6, also, if you just click, the duration is now returned correctly.
 *
 * $Date: 2012-29-07 (Sun, 29 July 2012) $
 * $version: 1.3.2	- Added fallbackToMouseEvents option to NOT capture mouse events on non touch devices.
 * 			- Added "all" fingers value to the fingers property, so any combination of fingers triggers the swipe, allowing event handlers to check the finger count
 *
 * $Date: 2012-09-08 (Thurs, 9 Aug 2012) $
 * $version: 1.3.3	- Code tidy prep for minefied version
 *
 * $Date: 2012-04-10 (wed, 4 Oct 2012) $
 * $version: 1.4.0	- Added pinch support, pinchIn and pinchOut
 *
 * $Date: 2012-11-10 (Thurs, 11 Oct 2012) $
 * $version: 1.5.0	- Added excludedElements, a jquery selector that specifies child elements that do NOT trigger swipes. By default, this is .noSwipe
 *
 * $Date: 2012-22-10 (Mon, 22 Oct 2012) $
 * $version: 1.5.1	- Fixed bug with jQuery 1.8 and trailing comma in excludedElements
 *					- Fixed bug with IE and eventPreventDefault()
 * $Date: 2013-01-12 (Fri, 12 Jan 2013) $
 * $version: 1.6.0	- Fixed bugs with pinching, mainly when both pinch and swipe enabled, as well as adding time threshold for multifinger gestures, so releasing one finger beofre the other doesnt trigger as single finger gesture.
 *					- made the demo site all static local HTML pages so they can be run locally by a developer
 *					- added jsDoc comments and added documentation for the plugin
 *					- code tidy
 *					- added triggerOnTouchLeave property that will end the event when the user swipes off the element.
 * $Date: 2013-03-23 (Sat, 23 Mar 2013) $
 * $version: 1.6.1	- Added support for ie8 touch events
 * $version: 1.6.2	- Added support for events binding with on / off / bind in jQ for all callback names.
 *                   - Deprecated the 'click' handler in favour of tap.
 *                   - added cancelThreshold property
 *                   - added option method to update init options at runtime
 * $version 1.6.3    - added doubletap, longtap events and longTapThreshold, doubleTapThreshold property
 *
 * $Date: 2013-04-04 (Thurs, 04 April 2013) $
 * $version 1.6.4    - Fixed bug with cancelThreshold introduced in 1.6.3, where swipe status no longer fired start event, and stopped once swiping back.
 *
 * $Date: 2013-08-24 (Sat, 24 Aug 2013) $
 * $version 1.6.5    - Merged a few pull requests fixing various bugs, added AMD support.
 *
 * $Date: 2014-06-04 (Wed, 04 June 2014) $
 * $version 1.6.6 	- Merge of pull requests.
 *    				- IE10 touch support
 *    				- Only prevent default event handling on valid swipe
 *    				- Separate license/changelog comment
 *    				- Detect if the swipe is valid at the end of the touch event.
 *    				- Pass fingerdata to event handlers.
 *    				- Add 'hold' gesture
 *    				- Be more tolerant about the tap distance
 *    				- Typos and minor fixes
 *
 * $Date: 2015-22-01 (Thurs, 22 Jan 2015) $
 * $version 1.6.7    - Added patch from https://github.com/mattbryson/TouchSwipe-Jquery-Plugin/issues/206 to fix memory leak
 *
 * $Date: 2015-2-2 (Mon, 2 Feb 2015) $
 * $version 1.6.8    - Added preventDefaultEvents option to proxy events regardless.
 *					- Fixed issue with swipe and pinch not triggering at the same time
 *
 * $Date: 2015-9-6 (Tues, 9 June 2015) $
 * $version 1.6.9    - Added PR from jdalton/hybrid to fix pointer events
 *					- Added scrolling demo
 *					- Added version property to plugin
 *
 * $Date: 2015-1-10 (Wed, 1 October 2015) $
 * $version 1.6.10    - Added PR from beatspace to fix tap events
 * $version 1.6.11    - Added PRs from indri-indri ( Doc tidyup), kkirsche ( Bower tidy up ), UziTech (preventDefaultEvents fixes )
 *					 - Allowed setting multiple options via .swipe("options", options_hash) and more simply .swipe(options_hash) or exisitng instances
 * $version 1.6.12    - Fixed bug with multi finger releases above 2 not triggering events
 *
 * $Date: 2015-12-18 (Fri, 18 December 2015) $
 * $version 1.6.13    - Added PRs
 *                    - Fixed #267 allowPageScroll not working correctly
 * $version 1.6.14    - Fixed #220 / #248 doubletap not firing with swipes, #223 commonJS compatible
 * $version 1.6.15    - More bug fixes
 *
 * $Date: 2016-04-29 (Fri, 29 April 2016) $
 * $version 1.6.16    - Swipes with 0 distance now allow default events to trigger.  So tapping any form elements or A tags will allow default interaction, but swiping will trigger a swipe.
                        Removed the a, input, select etc from the excluded Children list as the 0 distance tap solves that issue.
* $Date: 2016-05-19  (Fri, 29 April 2016) $
* $version 1.6.17     - Fixed context issue when calling instance methods via $("selector").swipe("method");
* $version 1.6.18     - now honors fallbackToMouseEvents=false for MS Pointer events when a Mouse is used.

 */

/**
 * See (http://jquery.com/).
 * @name $
 * @class
 * See the jQuery Library  (http://jquery.com/) for full details.  This just
 * documents the function and classes that are added to jQuery by this plug-in.
 */

/**
 * See (http://jquery.com/)
 * @name fn
 * @class
 * See the jQuery Library  (http://jquery.com/) for full details.  This just
 * documents the function and classes that are added to jQuery by this plug-in.
 * @memberOf $
 */
(function (factory) {
  if (typeof module !== 'undefined' && module.exports) {
    // CommonJS Module
    factory(require("jquery"));
  } else {
    // Browser globals.
    factory(jQuery);
  }
})(function ($) {
  "use strict"; //Constants

  var VERSION = "1.6.18",
      LEFT = "left",
      RIGHT = "right",
      UP = "up",
      DOWN = "down",
      IN = "in",
      OUT = "out",
      NONE = "none",
      AUTO = "auto",
      SWIPE = "swipe",
      PINCH = "pinch",
      TAP = "tap",
      DOUBLE_TAP = "doubletap",
      LONG_TAP = "longtap",
      HOLD = "hold",
      HORIZONTAL = "horizontal",
      VERTICAL = "vertical",
      ALL_FINGERS = "all",
      DOUBLE_TAP_THRESHOLD = 10,
      PHASE_START = "start",
      PHASE_MOVE = "move",
      PHASE_END = "end",
      PHASE_CANCEL = "cancel",
      SUPPORTS_TOUCH = 'ontouchstart' in window,
      SUPPORTS_POINTER_IE10 = window.navigator.msPointerEnabled && !window.navigator.pointerEnabled && !SUPPORTS_TOUCH,
      SUPPORTS_POINTER = (window.navigator.pointerEnabled || window.navigator.msPointerEnabled) && !SUPPORTS_TOUCH,
      PLUGIN_NS = 'TouchSwipe';
  /**
  * The default configuration, and available options to configure touch swipe with.
  * You can set the default values by updating any of the properties prior to instantiation.
  * @name $.fn.swipe.defaults
  * @namespace
  * @property {int} [fingers=1] The number of fingers to detect in a swipe. Any swipes that do not meet this requirement will NOT trigger swipe handlers.
  * @property {int} [threshold=75] The number of pixels that the user must move their finger by before it is considered a swipe.
  * @property {int} [cancelThreshold=null] The number of pixels that the user must move their finger back from the original swipe direction to cancel the gesture.
  * @property {int} [pinchThreshold=20] The number of pixels that the user must pinch their finger by before it is considered a pinch.
  * @property {int} [maxTimeThreshold=null] Time, in milliseconds, between touchStart and touchEnd must NOT exceed in order to be considered a swipe.
  * @property {int} [fingerReleaseThreshold=250] Time in milliseconds between releasing multiple fingers.  If 2 fingers are down, and are released one after the other, if they are within this threshold, it counts as a simultaneous release.
  * @property {int} [longTapThreshold=500] Time in milliseconds between tap and release for a long tap
  * @property {int} [doubleTapThreshold=200] Time in milliseconds between 2 taps to count as a double tap
  * @property {function} [swipe=null] A handler to catch all swipes. See {@link $.fn.swipe#event:swipe}
  * @property {function} [swipeLeft=null] A handler that is triggered for "left" swipes. See {@link $.fn.swipe#event:swipeLeft}
  * @property {function} [swipeRight=null] A handler that is triggered for "right" swipes. See {@link $.fn.swipe#event:swipeRight}
  * @property {function} [swipeUp=null] A handler that is triggered for "up" swipes. See {@link $.fn.swipe#event:swipeUp}
  * @property {function} [swipeDown=null] A handler that is triggered for "down" swipes. See {@link $.fn.swipe#event:swipeDown}
  * @property {function} [swipeStatus=null] A handler triggered for every phase of the swipe. See {@link $.fn.swipe#event:swipeStatus}
  * @property {function} [pinchIn=null] A handler triggered for pinch in events. See {@link $.fn.swipe#event:pinchIn}
  * @property {function} [pinchOut=null] A handler triggered for pinch out events. See {@link $.fn.swipe#event:pinchOut}
  * @property {function} [pinchStatus=null] A handler triggered for every phase of a pinch. See {@link $.fn.swipe#event:pinchStatus}
  * @property {function} [tap=null] A handler triggered when a user just taps on the item, rather than swipes it. If they do not move, tap is triggered, if they do move, it is not.
  * @property {function} [doubleTap=null] A handler triggered when a user double taps on the item. The delay between taps can be set with the doubleTapThreshold property. See {@link $.fn.swipe.defaults#doubleTapThreshold}
  * @property {function} [longTap=null] A handler triggered when a user long taps on the item. The delay between start and end can be set with the longTapThreshold property. See {@link $.fn.swipe.defaults#longTapThreshold}
  * @property (function) [hold=null] A handler triggered when a user reaches longTapThreshold on the item. See {@link $.fn.swipe.defaults#longTapThreshold}
  * @property {boolean} [triggerOnTouchEnd=true] If true, the swipe events are triggered when the touch end event is received (user releases finger).  If false, it will be triggered on reaching the threshold, and then cancel the touch event automatically.
  * @property {boolean} [triggerOnTouchLeave=false] If true, then when the user leaves the swipe object, the swipe will end and trigger appropriate handlers.
  * @property {string|undefined} [allowPageScroll='auto'] How the browser handles page scrolls when the user is swiping on a touchSwipe object. See {@link $.fn.swipe.pageScroll}.  <br/><br/>
  									<code>"auto"</code> : all undefined swipes will cause the page to scroll in that direction. <br/>
  									<code>"none"</code> : the page will not scroll when user swipes. <br/>
  									<code>"horizontal"</code> : will force page to scroll on horizontal swipes. <br/>
  									<code>"vertical"</code> : will force page to scroll on vertical swipes. <br/>
  * @property {boolean} [fallbackToMouseEvents=true] If true mouse events are used when run on a non touch device, false will stop swipes being triggered by mouse events on non touch devices.
  * @property {string} [excludedElements=".noSwipe"] A jquery selector that specifies child elements that do NOT trigger swipes. By default this excludes elements with the class .noSwipe .
  * @property {boolean} [preventDefaultEvents=true] by default default events are cancelled, so the page doesn't move.  You can disable this so both native events fire as well as your handlers.
   */

  var defaults = {
    fingers: 1,
    threshold: 75,
    cancelThreshold: null,
    pinchThreshold: 20,
    maxTimeThreshold: null,
    fingerReleaseThreshold: 250,
    longTapThreshold: 500,
    doubleTapThreshold: 200,
    swipe: null,
    swipeLeft: null,
    swipeRight: null,
    swipeUp: null,
    swipeDown: null,
    swipeStatus: null,
    pinchIn: null,
    pinchOut: null,
    pinchStatus: null,
    click: null,
    //Deprecated since 1.6.2
    tap: null,
    doubleTap: null,
    longTap: null,
    hold: null,
    triggerOnTouchEnd: true,
    triggerOnTouchLeave: false,
    allowPageScroll: "auto",
    fallbackToMouseEvents: true,
    excludedElements: ".noSwipe",
    preventDefaultEvents: true
  };
  /**
   * Applies TouchSwipe behaviour to one or more jQuery objects.
   * The TouchSwipe plugin can be instantiated via this method, or methods within
   * TouchSwipe can be executed via this method as per jQuery plugin architecture.
   * An existing plugin can have its options changed simply by re calling .swipe(options)
   * @see TouchSwipe
   * @class
   * @param {Mixed} method If the current DOMNode is a TouchSwipe object, and <code>method</code> is a TouchSwipe method, then
   * the <code>method</code> is executed, and any following arguments are passed to the TouchSwipe method.
   * If <code>method</code> is an object, then the TouchSwipe class is instantiated on the current DOMNode, passing the
   * configuration properties defined in the object. See TouchSwipe
   *
   */

  $.fn.swipe = function (method) {
    var $this = $(this),
        plugin = $this.data(PLUGIN_NS); //Check if we are already instantiated and trying to execute a method

    if (plugin && typeof method === 'string') {
      if (plugin[method]) {
        return plugin[method].apply(plugin, Array.prototype.slice.call(arguments, 1));
      } else {
        $.error('Method ' + method + ' does not exist on jQuery.swipe');
      }
    } //Else update existing plugin with new options hash
    else if (plugin && _typeof(method) === 'object') {
        plugin['option'].apply(plugin, arguments);
      } //Else not instantiated and trying to pass init object (or nothing)
      else if (!plugin && (_typeof(method) === 'object' || !method)) {
          return init.apply(this, arguments);
        }

    return $this;
  };
  /**
   * The version of the plugin
   * @readonly
   */


  $.fn.swipe.version = VERSION; //Expose our defaults so a user could override the plugin defaults

  $.fn.swipe.defaults = defaults;
  /**
   * The phases that a touch event goes through.  The <code>phase</code> is passed to the event handlers.
   * These properties are read only, attempting to change them will not alter the values passed to the event handlers.
   * @namespace
   * @readonly
   * @property {string} PHASE_START Constant indicating the start phase of the touch event. Value is <code>"start"</code>.
   * @property {string} PHASE_MOVE Constant indicating the move phase of the touch event. Value is <code>"move"</code>.
   * @property {string} PHASE_END Constant indicating the end phase of the touch event. Value is <code>"end"</code>.
   * @property {string} PHASE_CANCEL Constant indicating the cancel phase of the touch event. Value is <code>"cancel"</code>.
   */

  $.fn.swipe.phases = {
    PHASE_START: PHASE_START,
    PHASE_MOVE: PHASE_MOVE,
    PHASE_END: PHASE_END,
    PHASE_CANCEL: PHASE_CANCEL
  };
  /**
   * The direction constants that are passed to the event handlers.
   * These properties are read only, attempting to change them will not alter the values passed to the event handlers.
   * @namespace
   * @readonly
   * @property {string} LEFT Constant indicating the left direction. Value is <code>"left"</code>.
   * @property {string} RIGHT Constant indicating the right direction. Value is <code>"right"</code>.
   * @property {string} UP Constant indicating the up direction. Value is <code>"up"</code>.
   * @property {string} DOWN Constant indicating the down direction. Value is <code>"cancel"</code>.
   * @property {string} IN Constant indicating the in direction. Value is <code>"in"</code>.
   * @property {string} OUT Constant indicating the out direction. Value is <code>"out"</code>.
   */

  $.fn.swipe.directions = {
    LEFT: LEFT,
    RIGHT: RIGHT,
    UP: UP,
    DOWN: DOWN,
    IN: IN,
    OUT: OUT
  };
  /**
   * The page scroll constants that can be used to set the value of <code>allowPageScroll</code> option
   * These properties are read only
   * @namespace
   * @readonly
   * @see $.fn.swipe.defaults#allowPageScroll
   * @property {string} NONE Constant indicating no page scrolling is allowed. Value is <code>"none"</code>.
   * @property {string} HORIZONTAL Constant indicating horizontal page scrolling is allowed. Value is <code>"horizontal"</code>.
   * @property {string} VERTICAL Constant indicating vertical page scrolling is allowed. Value is <code>"vertical"</code>.
   * @property {string} AUTO Constant indicating either horizontal or vertical will be allowed, depending on the swipe handlers registered. Value is <code>"auto"</code>.
   */

  $.fn.swipe.pageScroll = {
    NONE: NONE,
    HORIZONTAL: HORIZONTAL,
    VERTICAL: VERTICAL,
    AUTO: AUTO
  };
  /**
   * Constants representing the number of fingers used in a swipe.  These are used to set both the value of <code>fingers</code> in the
   * options object, as well as the value of the <code>fingers</code> event property.
   * These properties are read only, attempting to change them will not alter the values passed to the event handlers.
   * @namespace
   * @readonly
   * @see $.fn.swipe.defaults#fingers
   * @property {string} ONE Constant indicating 1 finger is to be detected / was detected. Value is <code>1</code>.
   * @property {string} TWO Constant indicating 2 fingers are to be detected / were detected. Value is <code>2</code>.
   * @property {string} THREE Constant indicating 3 finger are to be detected / were detected. Value is <code>3</code>.
   * @property {string} FOUR Constant indicating 4 finger are to be detected / were detected. Not all devices support this. Value is <code>4</code>.
   * @property {string} FIVE Constant indicating 5 finger are to be detected / were detected. Not all devices support this. Value is <code>5</code>.
   * @property {string} ALL Constant indicating any combination of finger are to be detected.  Value is <code>"all"</code>.
   */

  $.fn.swipe.fingers = {
    ONE: 1,
    TWO: 2,
    THREE: 3,
    FOUR: 4,
    FIVE: 5,
    ALL: ALL_FINGERS
  };
  /**
   * Initialise the plugin for each DOM element matched
   * This creates a new instance of the main TouchSwipe class for each DOM element, and then
   * saves a reference to that instance in the elements data property.
   * @internal
   */

  function init(options) {
    //Prep and extend the options
    if (options && options.allowPageScroll === undefined && (options.swipe !== undefined || options.swipeStatus !== undefined)) {
      options.allowPageScroll = NONE;
    } //Check for deprecated options
    //Ensure that any old click handlers are assigned to the new tap, unless we have a tap


    if (options.click !== undefined && options.tap === undefined) {
      options.tap = options.click;
    }

    if (!options) {
      options = {};
    } //pass empty object so we dont modify the defaults


    options = $.extend({}, $.fn.swipe.defaults, options); //For each element instantiate the plugin

    return this.each(function () {
      var $this = $(this); //Check we havent already initialised the plugin

      var plugin = $this.data(PLUGIN_NS);

      if (!plugin) {
        plugin = new TouchSwipe(this, options);
        $this.data(PLUGIN_NS, plugin);
      }
    });
  }
  /**
   * Main TouchSwipe Plugin Class.
   * Do not use this to construct your TouchSwipe object, use the jQuery plugin method $.fn.swipe(); {@link $.fn.swipe}
   * @private
   * @name TouchSwipe
   * @param {DOMNode} element The HTML DOM object to apply to plugin to
   * @param {Object} options The options to configure the plugin with.  @link {$.fn.swipe.defaults}
   * @see $.fh.swipe.defaults
   * @see $.fh.swipe
   * @class
   */


  function TouchSwipe(element, options) {
    //take a local/instacne level copy of the options - should make it this.options really...
    var options = $.extend({}, options);
    var useTouchEvents = SUPPORTS_TOUCH || SUPPORTS_POINTER || !options.fallbackToMouseEvents,
        START_EV = useTouchEvents ? SUPPORTS_POINTER ? SUPPORTS_POINTER_IE10 ? 'MSPointerDown' : 'pointerdown' : 'touchstart' : 'mousedown',
        MOVE_EV = useTouchEvents ? SUPPORTS_POINTER ? SUPPORTS_POINTER_IE10 ? 'MSPointerMove' : 'pointermove' : 'touchmove' : 'mousemove',
        END_EV = useTouchEvents ? SUPPORTS_POINTER ? SUPPORTS_POINTER_IE10 ? 'MSPointerUp' : 'pointerup' : 'touchend' : 'mouseup',
        LEAVE_EV = useTouchEvents ? SUPPORTS_POINTER ? 'mouseleave' : null : 'mouseleave',
        //we manually detect leave on touch devices, so null event here
    CANCEL_EV = SUPPORTS_POINTER ? SUPPORTS_POINTER_IE10 ? 'MSPointerCancel' : 'pointercancel' : 'touchcancel'; //touch properties

    var distance = 0,
        direction = null,
        currentDirection = null,
        duration = 0,
        startTouchesDistance = 0,
        endTouchesDistance = 0,
        pinchZoom = 1,
        pinchDistance = 0,
        pinchDirection = 0,
        maximumsMap = null; //jQuery wrapped element for this instance

    var $element = $(element); //Current phase of th touch cycle

    var phase = "start"; // the current number of fingers being used.

    var fingerCount = 0; //track mouse points / delta

    var fingerData = {}; //track times

    var startTime = 0,
        endTime = 0,
        previousTouchEndTime = 0,
        fingerCountAtRelease = 0,
        doubleTapStartTime = 0; //Timeouts

    var singleTapTimeout = null,
        holdTimeout = null; // Add gestures to all swipable areas if supported

    try {
      $element.bind(START_EV, touchStart);
      $element.bind(CANCEL_EV, touchCancel);
    } catch (e) {
      $.error('events not supported ' + START_EV + ',' + CANCEL_EV + ' on jQuery.swipe');
    } //
    //Public methods
    //

    /**
     * re-enables the swipe plugin with the previous configuration
     * @function
     * @name $.fn.swipe#enable
     * @return {DOMNode} The Dom element that was registered with TouchSwipe
     * @example $("#element").swipe("enable");
     */


    this.enable = function () {
      //Incase we are already enabled, clean up...
      this.disable();
      $element.bind(START_EV, touchStart);
      $element.bind(CANCEL_EV, touchCancel);
      return $element;
    };
    /**
     * disables the swipe plugin
     * @function
     * @name $.fn.swipe#disable
     * @return {DOMNode} The Dom element that is now registered with TouchSwipe
     * @example $("#element").swipe("disable");
     */


    this.disable = function () {
      removeListeners();
      return $element;
    };
    /**
     * Destroy the swipe plugin completely. To use any swipe methods, you must re initialise the plugin.
     * @function
     * @name $.fn.swipe#destroy
     * @example $("#element").swipe("destroy");
     */


    this.destroy = function () {
      removeListeners();
      $element.data(PLUGIN_NS, null);
      $element = null;
    };
    /**
     * Allows run time updating of the swipe configuration options.
     * @function
     * @name $.fn.swipe#option
     * @param {String} property The option property to get or set, or a has of multiple options to set
     * @param {Object} [value] The value to set the property to
     * @return {Object} If only a property name is passed, then that property value is returned. If nothing is passed the current options hash is returned.
     * @example $("#element").swipe("option", "threshold"); // return the threshold
     * @example $("#element").swipe("option", "threshold", 100); // set the threshold after init
     * @example $("#element").swipe("option", {threshold:100, fingers:3} ); // set multiple properties after init
     * @example $("#element").swipe({threshold:100, fingers:3} ); // set multiple properties after init - the "option" method is optional!
     * @example $("#element").swipe("option"); // Return the current options hash
     * @see $.fn.swipe.defaults
     *
     */


    this.option = function (property, value) {
      if (_typeof(property) === 'object') {
        options = $.extend(options, property);
      } else if (options[property] !== undefined) {
        if (value === undefined) {
          return options[property];
        } else {
          options[property] = value;
        }
      } else if (!property) {
        return options;
      } else {
        $.error('Option ' + property + ' does not exist on jQuery.swipe.options');
      }

      return null;
    }; //
    // Private methods
    //
    //
    // EVENTS
    //

    /**
     * Event handler for a touch start event.
     * Stops the default click event from triggering and stores where we touched
     * @inner
     * @param {object} jqEvent The normalised jQuery event object.
     */


    function touchStart(jqEvent) {
      //If we already in a touch event (a finger already in use) then ignore subsequent ones..
      if (getTouchInProgress()) {
        return;
      } //Check if this element matches any in the excluded elements selectors,  or its parent is excluded, if so, DON'T swipe


      if ($(jqEvent.target).closest(options.excludedElements, $element).length > 0) {
        return;
      } //As we use Jquery bind for events, we need to target the original event object
      //If these events are being programmatically triggered, we don't have an original event object, so use the Jq one.


      var event = jqEvent.originalEvent ? jqEvent.originalEvent : jqEvent; //If we have a pointer event, whoes type is 'mouse' and we have said NO mouse events, then dont do anything.

      if (event.pointerType && event.pointerType == "mouse" && options.fallbackToMouseEvents == false) {
        return;
      }

      
      var ret,
          touches = event.touches,
          evt = touches ? touches[0] : event;
      phase = PHASE_START; //If we support touches, get the finger count

      if (touches) {
        // get the total number of fingers touching the screen
        fingerCount = touches.length;
      } //Else this is the desktop, so stop the browser from dragging content
      else if (options.preventDefaultEvents !== false) {
          jqEvent.preventDefault(); //call this on jq event so we are cross browser
        } //clear vars..


      distance = 0;
      direction = null;
      currentDirection = null;
      pinchDirection = null;
      duration = 0;
      startTouchesDistance = 0;
      endTouchesDistance = 0;
      pinchZoom = 1;
      pinchDistance = 0;
      maximumsMap = createMaximumsData();
      cancelMultiFingerRelease(); //Create the default finger data

      createFingerData(0, evt); // check the number of fingers is what we are looking for, or we are capturing pinches

      if (!touches || fingerCount === options.fingers || options.fingers === ALL_FINGERS || hasPinches()) {
        // get the coordinates of the touch
        startTime = getTimeStamp();

        if (fingerCount == 2) {
          //Keep track of the initial pinch distance, so we can calculate the diff later
          //Store second finger data as start
          createFingerData(1, touches[1]);
          startTouchesDistance = endTouchesDistance = calculateTouchesDistance(fingerData[0].start, fingerData[1].start);
        }

        if (options.swipeStatus || options.pinchStatus) {
          ret = triggerHandler(event, phase);
        }
      } else {
        //A touch with more or less than the fingers we are looking for, so cancel
        ret = false;
      } //If we have a return value from the users handler, then return and cancel


      if (ret === false) {
        phase = PHASE_CANCEL;
        triggerHandler(event, phase);
        return ret;
      } else {
        if (options.hold) {
          holdTimeout = setTimeout($.proxy(function () {
            //Trigger the event
            $element.trigger('hold', [event.target]); //Fire the callback

            if (options.hold) {
              ret = options.hold.call($element, event, event.target);
            }
          }, this), options.longTapThreshold);
        }

        setTouchInProgress(true);
      }

      return null;
    }

    
    /**
     * Event handler for a touch move event.
     * If we change fingers during move, then cancel the event
     * @inner
     * @param {object} jqEvent The normalised jQuery event object.
     */

    function touchMove(jqEvent) {
      //As we use Jquery bind for events, we need to target the original event object
      //If these events are being programmatically triggered, we don't have an original event object, so use the Jq one.
      var event = jqEvent.originalEvent ? jqEvent.originalEvent : jqEvent; //If we are ending, cancelling, or within the threshold of 2 fingers being released, don't track anything..

      if (phase === PHASE_END || phase === PHASE_CANCEL || inMultiFingerRelease()) return;
      var ret,
          touches = event.touches,
          evt = touches ? touches[0] : event; //Update the  finger data

      var currentFinger = updateFingerData(evt);
      endTime = getTimeStamp();

      if (touches) {
        fingerCount = touches.length;
      }

      if (options.hold) {
        clearTimeout(holdTimeout);
      }

      phase = PHASE_MOVE; //If we have 2 fingers get Touches distance as well

      if (fingerCount == 2) {
        //Keep track of the initial pinch distance, so we can calculate the diff later
        //We do this here as well as the start event, in case they start with 1 finger, and the press 2 fingers
        if (startTouchesDistance == 0) {
          //Create second finger if this is the first time...
          createFingerData(1, touches[1]);
          startTouchesDistance = endTouchesDistance = calculateTouchesDistance(fingerData[0].start, fingerData[1].start);
        } else {
          //Else just update the second finger
          updateFingerData(touches[1]);
          endTouchesDistance = calculateTouchesDistance(fingerData[0].end, fingerData[1].end);
          pinchDirection = calculatePinchDirection(fingerData[0].end, fingerData[1].end);
        }

        pinchZoom = calculatePinchZoom(startTouchesDistance, endTouchesDistance);
        pinchDistance = Math.abs(startTouchesDistance - endTouchesDistance);
      }

      if (fingerCount === options.fingers || options.fingers === ALL_FINGERS || !touches || hasPinches()) {
        //The overall direction of the swipe. From start to now.
        direction = calculateDirection(currentFinger.start, currentFinger.end); //The immediate direction of the swipe, direction between the last movement and this one.

        currentDirection = calculateDirection(currentFinger.last, currentFinger.end); //Check if we need to prevent default event (page scroll / pinch zoom) or not

        validateDefaultEvent(jqEvent, currentDirection); //Distance and duration are all off the main finger

        distance = calculateDistance(currentFinger.start, currentFinger.end);
        duration = calculateDuration(); //Cache the maximum distance we made in this direction

        setMaxDistance(direction, distance); //Trigger status handler

        ret = triggerHandler(event, phase); //If we trigger end events when threshold are met, or trigger events when touch leaves element

        if (!options.triggerOnTouchEnd || options.triggerOnTouchLeave) {
          var inBounds = true; //If checking if we leave the element, run the bounds check (we can use touchleave as its not supported on webkit)

          if (options.triggerOnTouchLeave) {
            var bounds = getbounds(this);
            inBounds = isInBounds(currentFinger.end, bounds);
          } //Trigger end handles as we swipe if thresholds met or if we have left the element if the user has asked to check these..


          if (!options.triggerOnTouchEnd && inBounds) {
            phase = getNextPhase(PHASE_MOVE);
          } //We end if out of bounds here, so set current phase to END, and check if its modified
          else if (options.triggerOnTouchLeave && !inBounds) {
              phase = getNextPhase(PHASE_END);
            }

          if (phase == PHASE_CANCEL || phase == PHASE_END) {
            triggerHandler(event, phase);
          }
        }
      } else {
        phase = PHASE_CANCEL;
        triggerHandler(event, phase);
      }

      if (ret === false) {
        phase = PHASE_CANCEL;
        triggerHandler(event, phase);
      }
    }
    /**
     * Event handler for a touch end event.
     * Calculate the direction and trigger events
     * @inner
     * @param {object} jqEvent The normalised jQuery event object.
     */


    function touchEnd(jqEvent) {
      //As we use Jquery bind for events, we need to target the original event object
      //If these events are being programmatically triggered, we don't have an original event object, so use the Jq one.
      var event = jqEvent.originalEvent ? jqEvent.originalEvent : jqEvent,
          touches = event.touches; //If we are still in a touch with the device wait a fraction and see if the other finger comes up
      //if it does within the threshold, then we treat it as a multi release, not a single release and end the touch / swipe

      if (touches) {
        if (touches.length && !inMultiFingerRelease()) {
          startMultiFingerRelease(event);
          return true;
        } else if (touches.length && inMultiFingerRelease()) {
          return true;
        }
      } //If a previous finger has been released, check how long ago, if within the threshold, then assume it was a multifinger release.
      //This is used to allow 2 fingers to release fractionally after each other, whilst maintaining the event as containing 2 fingers, not 1


      if (inMultiFingerRelease()) {
        fingerCount = fingerCountAtRelease;
      } //Set end of swipe


      endTime = getTimeStamp(); //Get duration incase move was never fired

      duration = calculateDuration(); //If we trigger handlers at end of swipe OR, we trigger during, but they didnt trigger and we are still in the move phase

      if (didSwipeBackToCancel() || !validateSwipeDistance()) {
        phase = PHASE_CANCEL;
        triggerHandler(event, phase);
      } else if (options.triggerOnTouchEnd || options.triggerOnTouchEnd === false && phase === PHASE_MOVE) {
        //call this on jq event so we are cross browser
        if (options.preventDefaultEvents !== false) {
          jqEvent.preventDefault();
        }

        phase = PHASE_END;
        triggerHandler(event, phase);
      } //Special cases - A tap should always fire on touch end regardless,
      //So here we manually trigger the tap end handler by itself
      //We dont run trigger handler as it will re-trigger events that may have fired already
      else if (!options.triggerOnTouchEnd && hasTap()) {
          //Trigger the pinch events...
          phase = PHASE_END;
          triggerHandlerForGesture(event, phase, TAP);
        } else if (phase === PHASE_MOVE) {
          phase = PHASE_CANCEL;
          triggerHandler(event, phase);
        }

      setTouchInProgress(false);
      return null;
    }
    /**
     * Event handler for a touch cancel event.
     * Clears current vars
     * @inner
     */


    function touchCancel() {
      // reset the variables back to default values
      fingerCount = 0;
      endTime = 0;
      startTime = 0;
      startTouchesDistance = 0;
      endTouchesDistance = 0;
      pinchZoom = 1; //If we were in progress of tracking a possible multi touch end, then re set it.

      cancelMultiFingerRelease();
      setTouchInProgress(false);
    }
    /**
     * Event handler for a touch leave event.
     * This is only triggered on desktops, in touch we work this out manually
     * as the touchleave event is not supported in webkit
     * @inner
     */


    function touchLeave(jqEvent) {
      //If these events are being programmatically triggered, we don't have an original event object, so use the Jq one.
      var event = jqEvent.originalEvent ? jqEvent.originalEvent : jqEvent; //If we have the trigger on leave property set....

      if (options.triggerOnTouchLeave) {
        phase = getNextPhase(PHASE_END);
        triggerHandler(event, phase);
      }
    }
    /**
     * Removes all listeners that were associated with the plugin
     * @inner
     */


    function removeListeners() {
      $element.unbind(START_EV, touchStart);
      $element.unbind(CANCEL_EV, touchCancel);
      $element.unbind(MOVE_EV, touchMove);
      $element.unbind(END_EV, touchEnd); //we only have leave events on desktop, we manually calculate leave on touch as its not supported in webkit

      if (LEAVE_EV) {
        $element.unbind(LEAVE_EV, touchLeave);
      }

      setTouchInProgress(false);
    }
    /**
     * Checks if the time and distance thresholds have been met, and if so then the appropriate handlers are fired.
     */


    function getNextPhase(currentPhase) {
      var nextPhase = currentPhase; // Ensure we have valid swipe (under time and over distance  and check if we are out of bound...)

      var validTime = validateSwipeTime();
      var validDistance = validateSwipeDistance();
      var didCancel = didSwipeBackToCancel(); //If we have exceeded our time, then cancel

      if (!validTime || didCancel) {
        nextPhase = PHASE_CANCEL;
      } //Else if we are moving, and have reached distance then end
      else if (validDistance && currentPhase == PHASE_MOVE && (!options.triggerOnTouchEnd || options.triggerOnTouchLeave)) {
          nextPhase = PHASE_END;
        } //Else if we have ended by leaving and didn't reach distance, then cancel
        else if (!validDistance && currentPhase == PHASE_END && options.triggerOnTouchLeave) {
            nextPhase = PHASE_CANCEL;
          }

      return nextPhase;
    }
    /**
     * Trigger the relevant event handler
     * The handlers are passed the original event, the element that was swiped, and in the case of the catch all handler, the direction that was swiped, "left", "right", "up", or "down"
     * @param {object} event the original event object
     * @param {string} phase the phase of the swipe (start, end cancel etc) {@link $.fn.swipe.phases}
     * @inner
     */


    function triggerHandler(event, phase) {
      var ret,
          touches = event.touches; // SWIPE GESTURES

      if (didSwipe() || hasSwipes()) {
        ret = triggerHandlerForGesture(event, phase, SWIPE);
      } // PINCH GESTURES (if the above didn't cancel)


      if ((didPinch() || hasPinches()) && ret !== false) {
        ret = triggerHandlerForGesture(event, phase, PINCH);
      } // CLICK / TAP (if the above didn't cancel)


      if (didDoubleTap() && ret !== false) {
        //Trigger the tap events...
        ret = triggerHandlerForGesture(event, phase, DOUBLE_TAP);
      } // CLICK / TAP (if the above didn't cancel)
      else if (didLongTap() && ret !== false) {
          //Trigger the tap events...
          ret = triggerHandlerForGesture(event, phase, LONG_TAP);
        } // CLICK / TAP (if the above didn't cancel)
        else if (didTap() && ret !== false) {
            //Trigger the tap event..
            ret = triggerHandlerForGesture(event, phase, TAP);
          } // If we are cancelling the gesture, then manually trigger the reset handler


      if (phase === PHASE_CANCEL) {
        touchCancel(event);
      } // If we are ending the gesture, then manually trigger the reset handler IF all fingers are off


      if (phase === PHASE_END) {
        //If we support touch, then check that all fingers are off before we cancel
        if (touches) {
          if (!touches.length) {
            touchCancel(event);
          }
        } else {
          touchCancel(event);
        }
      }

      return ret;
    }
    /**
     * Trigger the relevant event handler
     * The handlers are passed the original event, the element that was swiped, and in the case of the catch all handler, the direction that was swiped, "left", "right", "up", or "down"
     * @param {object} event the original event object
     * @param {string} phase the phase of the swipe (start, end cancel etc) {@link $.fn.swipe.phases}
     * @param {string} gesture the gesture to trigger a handler for : PINCH or SWIPE {@link $.fn.swipe.gestures}
     * @return Boolean False, to indicate that the event should stop propagation, or void.
     * @inner
     */


    function triggerHandlerForGesture(event, phase, gesture) {
      var ret; //SWIPES....

      if (gesture == SWIPE) {
        //Trigger status every time..
        $element.trigger('swipeStatus', [phase, direction || null, distance || 0, duration || 0, fingerCount, fingerData, currentDirection]);

        if (options.swipeStatus) {
          ret = options.swipeStatus.call($element, event, phase, direction || null, distance || 0, duration || 0, fingerCount, fingerData, currentDirection); //If the status cancels, then dont run the subsequent event handlers..

          if (ret === false) return false;
        }

        if (phase == PHASE_END && validateSwipe()) {
          //Cancel any taps that were in progress...
          clearTimeout(singleTapTimeout);
          clearTimeout(holdTimeout);
          $element.trigger('swipe', [direction, distance, duration, fingerCount, fingerData, currentDirection]);

          if (options.swipe) {
            ret = options.swipe.call($element, event, direction, distance, duration, fingerCount, fingerData, currentDirection); //If the status cancels, then dont run the subsequent event handlers..

            if (ret === false) return false;
          } //trigger direction specific event handlers


          switch (direction) {
            case LEFT:
              $element.trigger('swipeLeft', [direction, distance, duration, fingerCount, fingerData, currentDirection]);

              if (options.swipeLeft) {
                ret = options.swipeLeft.call($element, event, direction, distance, duration, fingerCount, fingerData, currentDirection);
              }

              break;

            case RIGHT:
              $element.trigger('swipeRight', [direction, distance, duration, fingerCount, fingerData, currentDirection]);

              if (options.swipeRight) {
                ret = options.swipeRight.call($element, event, direction, distance, duration, fingerCount, fingerData, currentDirection);
              }

              break;

            case UP:
              $element.trigger('swipeUp', [direction, distance, duration, fingerCount, fingerData, currentDirection]);

              if (options.swipeUp) {
                ret = options.swipeUp.call($element, event, direction, distance, duration, fingerCount, fingerData, currentDirection);
              }

              break;

            case DOWN:
              $element.trigger('swipeDown', [direction, distance, duration, fingerCount, fingerData, currentDirection]);

              if (options.swipeDown) {
                ret = options.swipeDown.call($element, event, direction, distance, duration, fingerCount, fingerData, currentDirection);
              }

              break;
          }
        }
      } //PINCHES....


      if (gesture == PINCH) {
        $element.trigger('pinchStatus', [phase, pinchDirection || null, pinchDistance || 0, duration || 0, fingerCount, pinchZoom, fingerData]);

        if (options.pinchStatus) {
          ret = options.pinchStatus.call($element, event, phase, pinchDirection || null, pinchDistance || 0, duration || 0, fingerCount, pinchZoom, fingerData); //If the status cancels, then dont run the subsequent event handlers..

          if (ret === false) return false;
        }

        if (phase == PHASE_END && validatePinch()) {
          switch (pinchDirection) {
            case IN:
              $element.trigger('pinchIn', [pinchDirection || null, pinchDistance || 0, duration || 0, fingerCount, pinchZoom, fingerData]);

              if (options.pinchIn) {
                ret = options.pinchIn.call($element, event, pinchDirection || null, pinchDistance || 0, duration || 0, fingerCount, pinchZoom, fingerData);
              }

              break;

            case OUT:
              $element.trigger('pinchOut', [pinchDirection || null, pinchDistance || 0, duration || 0, fingerCount, pinchZoom, fingerData]);

              if (options.pinchOut) {
                ret = options.pinchOut.call($element, event, pinchDirection || null, pinchDistance || 0, duration || 0, fingerCount, pinchZoom, fingerData);
              }

              break;
          }
        }
      }

      if (gesture == TAP) {
        if (phase === PHASE_CANCEL || phase === PHASE_END) {
          clearTimeout(singleTapTimeout);
          clearTimeout(holdTimeout); //If we are also looking for doubelTaps, wait incase this is one...

          if (hasDoubleTap() && !inDoubleTap()) {
            doubleTapStartTime = getTimeStamp(); //Now wait for the double tap timeout, and trigger this single tap
            //if its not cancelled by a double tap

            singleTapTimeout = setTimeout($.proxy(function () {
              doubleTapStartTime = null;
              $element.trigger('tap', [event.target]);

              if (options.tap) {
                ret = options.tap.call($element, event, event.target);
              }
            }, this), options.doubleTapThreshold);
          } else {
            doubleTapStartTime = null;
            $element.trigger('tap', [event.target]);

            if (options.tap) {
              ret = options.tap.call($element, event, event.target);
            }
          }
        }
      } else if (gesture == DOUBLE_TAP) {
        if (phase === PHASE_CANCEL || phase === PHASE_END) {
          clearTimeout(singleTapTimeout);
          clearTimeout(holdTimeout);
          doubleTapStartTime = null;
          $element.trigger('doubletap', [event.target]);

          if (options.doubleTap) {
            ret = options.doubleTap.call($element, event, event.target);
          }
        }
      } else if (gesture == LONG_TAP) {
        if (phase === PHASE_CANCEL || phase === PHASE_END) {
          clearTimeout(singleTapTimeout);
          doubleTapStartTime = null;
          $element.trigger('longtap', [event.target]);

          if (options.longTap) {
            ret = options.longTap.call($element, event, event.target);
          }
        }
      }

      return ret;
    } //
    // GESTURE VALIDATION
    //

    /**
     * Checks the user has swipe far enough
     * @return Boolean if <code>threshold</code> has been set, return true if the threshold was met, else false.
     * If no threshold was set, then we return true.
     * @inner
     */


    function validateSwipeDistance() {
      var valid = true; //If we made it past the min swipe distance..

      if (options.threshold !== null) {
        valid = distance >= options.threshold;
      }

      return valid;
    }
    /**
     * Checks the user has swiped back to cancel.
     * @return Boolean if <code>cancelThreshold</code> has been set, return true if the cancelThreshold was met, else false.
     * If no cancelThreshold was set, then we return true.
     * @inner
     */


    function didSwipeBackToCancel() {
      var cancelled = false;

      if (options.cancelThreshold !== null && direction !== null) {
        cancelled = getMaxDistance(direction) - distance >= options.cancelThreshold;
      }

      return cancelled;
    }
    /**
     * Checks the user has pinched far enough
     * @return Boolean if <code>pinchThreshold</code> has been set, return true if the threshold was met, else false.
     * If no threshold was set, then we return true.
     * @inner
     */


    function validatePinchDistance() {
      if (options.pinchThreshold !== null) {
        return pinchDistance >= options.pinchThreshold;
      }

      return true;
    }
    /**
     * Checks that the time taken to swipe meets the minimum / maximum requirements
     * @return Boolean
     * @inner
     */


    function validateSwipeTime() {
      var result; //If no time set, then return true

      if (options.maxTimeThreshold) {
        if (duration >= options.maxTimeThreshold) {
          result = false;
        } else {
          result = true;
        }
      } else {
        result = true;
      }

      return result;
    }
    /**
     * Checks direction of the swipe and the value allowPageScroll to see if we should allow or prevent the default behaviour from occurring.
     * This will essentially allow page scrolling or not when the user is swiping on a touchSwipe object.
     * @param {object} jqEvent The normalised jQuery representation of the event object.
     * @param {string} direction The direction of the event. See {@link $.fn.swipe.directions}
     * @see $.fn.swipe.directions
     * @inner
     */


    function validateDefaultEvent(jqEvent, direction) {
      //If the option is set, allways allow the event to bubble up (let user handle weirdness)
      if (options.preventDefaultEvents === false) {
        return;
      }

      if (options.allowPageScroll === NONE) {
        jqEvent.preventDefault();
      } else {
        var auto = options.allowPageScroll === AUTO;

        switch (direction) {
          case LEFT:
            if (options.swipeLeft && auto || !auto && options.allowPageScroll != HORIZONTAL) {
              jqEvent.preventDefault();
            }

            break;

          case RIGHT:
            if (options.swipeRight && auto || !auto && options.allowPageScroll != HORIZONTAL) {
              jqEvent.preventDefault();
            }

            break;

          case UP:
            if (options.swipeUp && auto || !auto && options.allowPageScroll != VERTICAL) {
              jqEvent.preventDefault();
            }

            break;

          case DOWN:
            if (options.swipeDown && auto || !auto && options.allowPageScroll != VERTICAL) {
              jqEvent.preventDefault();
            }

            break;

          case NONE:
            break;
        }
      }
    } // PINCHES

    /**
     * Returns true of the current pinch meets the thresholds
     * @return Boolean
     * @inner
     */


    function validatePinch() {
      var hasCorrectFingerCount = validateFingers();
      var hasEndPoint = validateEndPoint();
      var hasCorrectDistance = validatePinchDistance();
      return hasCorrectFingerCount && hasEndPoint && hasCorrectDistance;
    }
    /**
     * Returns true if any Pinch events have been registered
     * @return Boolean
     * @inner
     */


    function hasPinches() {
      //Enure we dont return 0 or null for false values
      return !!(options.pinchStatus || options.pinchIn || options.pinchOut);
    }
    /**
     * Returns true if we are detecting pinches, and have one
     * @return Boolean
     * @inner
     */


    function didPinch() {
      //Enure we dont return 0 or null for false values
      return !!(validatePinch() && hasPinches());
    } // SWIPES

    /**
     * Returns true if the current swipe meets the thresholds
     * @return Boolean
     * @inner
     */


    function validateSwipe() {
      //Check validity of swipe
      var hasValidTime = validateSwipeTime();
      var hasValidDistance = validateSwipeDistance();
      var hasCorrectFingerCount = validateFingers();
      var hasEndPoint = validateEndPoint();
      var didCancel = didSwipeBackToCancel(); // if the user swiped more than the minimum length, perform the appropriate action
      // hasValidDistance is null when no distance is set

      var valid = !didCancel && hasEndPoint && hasCorrectFingerCount && hasValidDistance && hasValidTime;
      return valid;
    }
    /**
     * Returns true if any Swipe events have been registered
     * @return Boolean
     * @inner
     */


    function hasSwipes() {
      //Enure we dont return 0 or null for false values
      return !!(options.swipe || options.swipeStatus || options.swipeLeft || options.swipeRight || options.swipeUp || options.swipeDown);
    }
    /**
     * Returns true if we are detecting swipes and have one
     * @return Boolean
     * @inner
     */


    function didSwipe() {
      //Enure we dont return 0 or null for false values
      return !!(validateSwipe() && hasSwipes());
    }
    /**
     * Returns true if we have matched the number of fingers we are looking for
     * @return Boolean
     * @inner
     */


    function validateFingers() {
      //The number of fingers we want were matched, or on desktop we ignore
      return fingerCount === options.fingers || options.fingers === ALL_FINGERS || !SUPPORTS_TOUCH;
    }
    /**
     * Returns true if we have an end point for the swipe
     * @return Boolean
     * @inner
     */


    function validateEndPoint() {
      //We have an end value for the finger
      return fingerData[0].end.x !== 0;
    } // TAP / CLICK

    /**
     * Returns true if a click / tap events have been registered
     * @return Boolean
     * @inner
     */


    function hasTap() {
      //Enure we dont return 0 or null for false values
      return !!options.tap;
    }
    /**
     * Returns true if a double tap events have been registered
     * @return Boolean
     * @inner
     */


    function hasDoubleTap() {
      //Enure we dont return 0 or null for false values
      return !!options.doubleTap;
    }
    /**
     * Returns true if any long tap events have been registered
     * @return Boolean
     * @inner
     */


    function hasLongTap() {
      //Enure we dont return 0 or null for false values
      return !!options.longTap;
    }
    /**
     * Returns true if we could be in the process of a double tap (one tap has occurred, we are listening for double taps, and the threshold hasn't past.
     * @return Boolean
     * @inner
     */


    function validateDoubleTap() {
      if (doubleTapStartTime == null) {
        return false;
      }

      var now = getTimeStamp();
      return hasDoubleTap() && now - doubleTapStartTime <= options.doubleTapThreshold;
    }
    /**
     * Returns true if we could be in the process of a double tap (one tap has occurred, we are listening for double taps, and the threshold hasn't past.
     * @return Boolean
     * @inner
     */


    function inDoubleTap() {
      return validateDoubleTap();
    }
    /**
     * Returns true if we have a valid tap
     * @return Boolean
     * @inner
     */


    function validateTap() {
      return (fingerCount === 1 || !SUPPORTS_TOUCH) && (isNaN(distance) || distance < options.threshold);
    }
    /**
     * Returns true if we have a valid long tap
     * @return Boolean
     * @inner
     */


    function validateLongTap() {
      //slight threshold on moving finger
      return duration > options.longTapThreshold && distance < DOUBLE_TAP_THRESHOLD;
    }
    /**
     * Returns true if we are detecting taps and have one
     * @return Boolean
     * @inner
     */


    function didTap() {
      //Enure we dont return 0 or null for false values
      return !!(validateTap() && hasTap());
    }
    /**
     * Returns true if we are detecting double taps and have one
     * @return Boolean
     * @inner
     */


    function didDoubleTap() {
      //Enure we dont return 0 or null for false values
      return !!(validateDoubleTap() && hasDoubleTap());
    }
    /**
     * Returns true if we are detecting long taps and have one
     * @return Boolean
     * @inner
     */


    function didLongTap() {
      //Enure we dont return 0 or null for false values
      return !!(validateLongTap() && hasLongTap());
    } // MULTI FINGER TOUCH

    /**
     * Starts tracking the time between 2 finger releases, and keeps track of how many fingers we initially had up
     * @inner
     */


    function startMultiFingerRelease(event) {
      previousTouchEndTime = getTimeStamp();
      fingerCountAtRelease = event.touches.length + 1;
    }
    /**
     * Cancels the tracking of time between 2 finger releases, and resets counters
     * @inner
     */


    function cancelMultiFingerRelease() {
      previousTouchEndTime = 0;
      fingerCountAtRelease = 0;
    }
    /**
     * Checks if we are in the threshold between 2 fingers being released
     * @return Boolean
     * @inner
     */


    function inMultiFingerRelease() {
      var withinThreshold = false;

      if (previousTouchEndTime) {
        var diff = getTimeStamp() - previousTouchEndTime;

        if (diff <= options.fingerReleaseThreshold) {
          withinThreshold = true;
        }
      }

      return withinThreshold;
    }
    /**
     * gets a data flag to indicate that a touch is in progress
     * @return Boolean
     * @inner
     */


    function getTouchInProgress() {
      //strict equality to ensure only true and false are returned
      return !!($element.data(PLUGIN_NS + '_intouch') === true);
    }
    /**
     * Sets a data flag to indicate that a touch is in progress
     * @param {boolean} val The value to set the property to
     * @inner
     */


    function setTouchInProgress(val) {
      //If destroy is called in an event handler, we have no el, and we have already cleaned up, so return.
      if (!$element) {
        return;
      } //Add or remove event listeners depending on touch status


      if (val === true) {
        $element.bind(MOVE_EV, touchMove);
        $element.bind(END_EV, touchEnd); //we only have leave events on desktop, we manually calcuate leave on touch as its not supported in webkit

        if (LEAVE_EV) {
          $element.bind(LEAVE_EV, touchLeave);
        }
      } else {
        $element.unbind(MOVE_EV, touchMove, false);
        $element.unbind(END_EV, touchEnd, false); //we only have leave events on desktop, we manually calcuate leave on touch as its not supported in webkit

        if (LEAVE_EV) {
          $element.unbind(LEAVE_EV, touchLeave, false);
        }
      } //strict equality to ensure only true and false can update the value


      $element.data(PLUGIN_NS + '_intouch', val === true);
    }
    /**
     * Creates the finger data for the touch/finger in the event object.
     * @param {int} id The id to store the finger data under (usually the order the fingers were pressed)
     * @param {object} evt The event object containing finger data
     * @return finger data object
     * @inner
     */


    function createFingerData(id, evt) {
      var f = {
        start: {
          x: 0,
          y: 0
        },
        last: {
          x: 0,
          y: 0
        },
        end: {
          x: 0,
          y: 0
        }
      };
      f.start.x = f.last.x = f.end.x = evt.pageX || evt.clientX;
      f.start.y = f.last.y = f.end.y = evt.pageY || evt.clientY;
      fingerData[id] = f;
      return f;
    }
    /**
     * Updates the finger data for a particular event object
     * @param {object} evt The event object containing the touch/finger data to upadte
     * @return a finger data object.
     * @inner
     */


    function updateFingerData(evt) {
      var id = evt.identifier !== undefined ? evt.identifier : 0;
      var f = getFingerData(id);

      if (f === null) {
        f = createFingerData(id, evt);
      }

      f.last.x = f.end.x;
      f.last.y = f.end.y;
      f.end.x = evt.pageX || evt.clientX;
      f.end.y = evt.pageY || evt.clientY;
      return f;
    }
    /**
     * Returns a finger data object by its event ID.
     * Each touch event has an identifier property, which is used
     * to track repeat touches
     * @param {int} id The unique id of the finger in the sequence of touch events.
     * @return a finger data object.
     * @inner
     */


    function getFingerData(id) {
      return fingerData[id] || null;
    }
    /**
     * Sets the maximum distance swiped in the given direction.
     * If the new value is lower than the current value, the max value is not changed.
     * @param {string}  direction The direction of the swipe
     * @param {int}  distance The distance of the swipe
     * @inner
     */


    function setMaxDistance(direction, distance) {
      if (direction == NONE) return;
      distance = Math.max(distance, getMaxDistance(direction));
      maximumsMap[direction].distance = distance;
    }
    /**
     * gets the maximum distance swiped in the given direction.
     * @param {string}  direction The direction of the swipe
     * @return int  The distance of the swipe
     * @inner
     */


    function getMaxDistance(direction) {
      if (maximumsMap[direction]) return maximumsMap[direction].distance;
      return undefined;
    }
    /**
     * Creats a map of directions to maximum swiped values.
     * @return Object A dictionary of maximum values, indexed by direction.
     * @inner
     */


    function createMaximumsData() {
      var maxData = {};
      maxData[LEFT] = createMaximumVO(LEFT);
      maxData[RIGHT] = createMaximumVO(RIGHT);
      maxData[UP] = createMaximumVO(UP);
      maxData[DOWN] = createMaximumVO(DOWN);
      return maxData;
    }
    /**
     * Creates a map maximum swiped values for a given swipe direction
     * @param {string} The direction that these values will be associated with
     * @return Object Maximum values
     * @inner
     */


    function createMaximumVO(dir) {
      return {
        direction: dir,
        distance: 0
      };
    } //
    // MATHS / UTILS
    //

    /**
     * Calculate the duration of the swipe
     * @return int
     * @inner
     */


    function calculateDuration() {
      return endTime - startTime;
    }
    /**
     * Calculate the distance between 2 touches (pinch)
     * @param {point} startPoint A point object containing x and y co-ordinates
     * @param {point} endPoint A point object containing x and y co-ordinates
     * @return int;
     * @inner
     */


    function calculateTouchesDistance(startPoint, endPoint) {
      var diffX = Math.abs(startPoint.x - endPoint.x);
      var diffY = Math.abs(startPoint.y - endPoint.y);
      return Math.round(Math.sqrt(diffX * diffX + diffY * diffY));
    }
    /**
     * Calculate the zoom factor between the start and end distances
     * @param {int} startDistance Distance (between 2 fingers) the user started pinching at
     * @param {int} endDistance Distance (between 2 fingers) the user ended pinching at
     * @return float The zoom value from 0 to 1.
     * @inner
     */


    function calculatePinchZoom(startDistance, endDistance) {
      var percent = endDistance / startDistance * 1;
      return percent.toFixed(2);
    }
    /**
     * Returns the pinch direction, either IN or OUT for the given points
     * @return string Either {@link $.fn.swipe.directions.IN} or {@link $.fn.swipe.directions.OUT}
     * @see $.fn.swipe.directions
     * @inner
     */


    function calculatePinchDirection() {
      if (pinchZoom < 1) {
        return OUT;
      } else {
        return IN;
      }
    }
    /**
     * Calculate the length / distance of the swipe
     * @param {point} startPoint A point object containing x and y co-ordinates
     * @param {point} endPoint A point object containing x and y co-ordinates
     * @return int
     * @inner
     */


    function calculateDistance(startPoint, endPoint) {
      return Math.round(Math.sqrt(Math.pow(endPoint.x - startPoint.x, 2) + Math.pow(endPoint.y - startPoint.y, 2)));
    }
    /**
     * Calculate the angle of the swipe
     * @param {point} startPoint A point object containing x and y co-ordinates
     * @param {point} endPoint A point object containing x and y co-ordinates
     * @return int
     * @inner
     */


    function calculateAngle(startPoint, endPoint) {
      var x = startPoint.x - endPoint.x;
      var y = endPoint.y - startPoint.y;
      var r = Math.atan2(y, x); //radians

      var angle = Math.round(r * 180 / Math.PI); //degrees
      //ensure value is positive

      if (angle < 0) {
        angle = 360 - Math.abs(angle);
      }

      return angle;
    }
    /**
     * Calculate the direction of the swipe
     * This will also call calculateAngle to get the latest angle of swipe
     * @param {point} startPoint A point object containing x and y co-ordinates
     * @param {point} endPoint A point object containing x and y co-ordinates
     * @return string Either {@link $.fn.swipe.directions.LEFT} / {@link $.fn.swipe.directions.RIGHT} / {@link $.fn.swipe.directions.DOWN} / {@link $.fn.swipe.directions.UP}
     * @see $.fn.swipe.directions
     * @inner
     */


    function calculateDirection(startPoint, endPoint) {
      if (comparePoints(startPoint, endPoint)) {
        return NONE;
      }

      var angle = calculateAngle(startPoint, endPoint);

      if (angle <= 45 && angle >= 0) {
        return LEFT;
      } else if (angle <= 360 && angle >= 315) {
        return LEFT;
      } else if (angle >= 135 && angle <= 225) {
        return RIGHT;
      } else if (angle > 45 && angle < 135) {
        return DOWN;
      } else {
        return UP;
      }
    }
    /**
     * Returns a MS time stamp of the current time
     * @return int
     * @inner
     */


    function getTimeStamp() {
      var now = new Date();
      return now.getTime();
    }
    /**
     * Returns a bounds object with left, right, top and bottom properties for the element specified.
     * @param {DomNode} The DOM node to get the bounds for.
     */


    function getbounds(el) {
      el = $(el);
      var offset = el.offset();
      var bounds = {
        left: offset.left,
        right: offset.left + el.outerWidth(),
        top: offset.top,
        bottom: offset.top + el.outerHeight()
      };
      return bounds;
    }
    /**
     * Checks if the point object is in the bounds object.
     * @param {object} point A point object.
     * @param {int} point.x The x value of the point.
     * @param {int} point.y The x value of the point.
     * @param {object} bounds The bounds object to test
     * @param {int} bounds.left The leftmost value
     * @param {int} bounds.right The righttmost value
     * @param {int} bounds.top The topmost value
     * @param {int} bounds.bottom The bottommost value
     */


    function isInBounds(point, bounds) {
      return point.x > bounds.left && point.x < bounds.right && point.y > bounds.top && point.y < bounds.bottom;
    }

    
    /**
     * Checks if the two points are equal
     * @param {object} point A point object.
     * @param {object} point B point object.
     * @return true of the points match
     */

    function comparePoints(pointA, pointB) {
      return pointA.x == pointB.x && pointA.y == pointB.y;
    }
  }
  /**
   * A catch all handler that is triggered for all swipe directions.
   * @name $.fn.swipe#swipe
   * @event
   * @default null
   * @param {EventObject} event The original event object
   * @param {int} direction The direction the user swiped in. See {@link $.fn.swipe.directions}
   * @param {int} distance The distance the user swiped
   * @param {int} duration The duration of the swipe in milliseconds
   * @param {int} fingerCount The number of fingers used. See {@link $.fn.swipe.fingers}
   * @param {object} fingerData The coordinates of fingers in event
   * @param {string} currentDirection The current direction the user is swiping.
   */

  /**
   * A handler that is triggered for "left" swipes.
   * @name $.fn.swipe#swipeLeft
   * @event
   * @default null
   * @param {EventObject} event The original event object
   * @param {int} direction The direction the user swiped in. See {@link $.fn.swipe.directions}
   * @param {int} distance The distance the user swiped
   * @param {int} duration The duration of the swipe in milliseconds
   * @param {int} fingerCount The number of fingers used. See {@link $.fn.swipe.fingers}
   * @param {object} fingerData The coordinates of fingers in event
   * @param {string} currentDirection The current direction the user is swiping.
   */

  /**
   * A handler that is triggered for "right" swipes.
   * @name $.fn.swipe#swipeRight
   * @event
   * @default null
   * @param {EventObject} event The original event object
   * @param {int} direction The direction the user swiped in. See {@link $.fn.swipe.directions}
   * @param {int} distance The distance the user swiped
   * @param {int} duration The duration of the swipe in milliseconds
   * @param {int} fingerCount The number of fingers used. See {@link $.fn.swipe.fingers}
   * @param {object} fingerData The coordinates of fingers in event
   * @param {string} currentDirection The current direction the user is swiping.
   */

  /**
   * A handler that is triggered for "up" swipes.
   * @name $.fn.swipe#swipeUp
   * @event
   * @default null
   * @param {EventObject} event The original event object
   * @param {int} direction The direction the user swiped in. See {@link $.fn.swipe.directions}
   * @param {int} distance The distance the user swiped
   * @param {int} duration The duration of the swipe in milliseconds
   * @param {int} fingerCount The number of fingers used. See {@link $.fn.swipe.fingers}
   * @param {object} fingerData The coordinates of fingers in event
   * @param {string} currentDirection The current direction the user is swiping.
   */

  /**
   * A handler that is triggered for "down" swipes.
   * @name $.fn.swipe#swipeDown
   * @event
   * @default null
   * @param {EventObject} event The original event object
   * @param {int} direction The direction the user swiped in. See {@link $.fn.swipe.directions}
   * @param {int} distance The distance the user swiped
   * @param {int} duration The duration of the swipe in milliseconds
   * @param {int} fingerCount The number of fingers used. See {@link $.fn.swipe.fingers}
   * @param {object} fingerData The coordinates of fingers in event
   * @param {string} currentDirection The current direction the user is swiping.
   */

  /**
   * A handler triggered for every phase of the swipe. This handler is constantly fired for the duration of the pinch.
   * This is triggered regardless of swipe thresholds.
   * @name $.fn.swipe#swipeStatus
   * @event
   * @default null
   * @param {EventObject} event The original event object
   * @param {string} phase The phase of the swipe event. See {@link $.fn.swipe.phases}
   * @param {string} direction The direction the user swiped in. This is null if the user has yet to move. See {@link $.fn.swipe.directions}
   * @param {int} distance The distance the user swiped. This is 0 if the user has yet to move.
   * @param {int} duration The duration of the swipe in milliseconds
   * @param {int} fingerCount The number of fingers used. See {@link $.fn.swipe.fingers}
   * @param {object} fingerData The coordinates of fingers in event
   * @param {string} currentDirection The current direction the user is swiping.
   */

  /**
   * A handler triggered for pinch in events.
   * @name $.fn.swipe#pinchIn
   * @event
   * @default null
   * @param {EventObject} event The original event object
   * @param {int} direction The direction the user pinched in. See {@link $.fn.swipe.directions}
   * @param {int} distance The distance the user pinched
   * @param {int} duration The duration of the swipe in milliseconds
   * @param {int} fingerCount The number of fingers used. See {@link $.fn.swipe.fingers}
   * @param {int} zoom The zoom/scale level the user pinched too, 0-1.
   * @param {object} fingerData The coordinates of fingers in event
   */

  /**
   * A handler triggered for pinch out events.
   * @name $.fn.swipe#pinchOut
   * @event
   * @default null
   * @param {EventObject} event The original event object
   * @param {int} direction The direction the user pinched in. See {@link $.fn.swipe.directions}
   * @param {int} distance The distance the user pinched
   * @param {int} duration The duration of the swipe in milliseconds
   * @param {int} fingerCount The number of fingers used. See {@link $.fn.swipe.fingers}
   * @param {int} zoom The zoom/scale level the user pinched too, 0-1.
   * @param {object} fingerData The coordinates of fingers in event
   */

  /**
   * A handler triggered for all pinch events. This handler is constantly fired for the duration of the pinch. This is triggered regardless of thresholds.
   * @name $.fn.swipe#pinchStatus
   * @event
   * @default null
   * @param {EventObject} event The original event object
   * @param {int} direction The direction the user pinched in. See {@link $.fn.swipe.directions}
   * @param {int} distance The distance the user pinched
   * @param {int} duration The duration of the swipe in milliseconds
   * @param {int} fingerCount The number of fingers used. See {@link $.fn.swipe.fingers}
   * @param {int} zoom The zoom/scale level the user pinched too, 0-1.
   * @param {object} fingerData The coordinates of fingers in event
   */

  /**
   * A click handler triggered when a user simply clicks, rather than swipes on an element.
   * This is deprecated since version 1.6.2, any assignment to click will be assigned to the tap handler.
   * You cannot use <code>on</code> to bind to this event as the default jQ <code>click</code> event will be triggered.
   * Use the <code>tap</code> event instead.
   * @name $.fn.swipe#click
   * @event
   * @deprecated since version 1.6.2, please use {@link $.fn.swipe#tap} instead
   * @default null
   * @param {EventObject} event The original event object
   * @param {DomObject} target The element clicked on.
   */

  /**
   * A click / tap handler triggered when a user simply clicks or taps, rather than swipes on an element.
   * @name $.fn.swipe#tap
   * @event
   * @default null
   * @param {EventObject} event The original event object
   * @param {DomObject} target The element clicked on.
   */

  /**
   * A double tap handler triggered when a user double clicks or taps on an element.
   * You can set the time delay for a double tap with the {@link $.fn.swipe.defaults#doubleTapThreshold} property.
   * Note: If you set both <code>doubleTap</code> and <code>tap</code> handlers, the <code>tap</code> event will be delayed by the <code>doubleTapThreshold</code>
   * as the script needs to check if its a double tap.
   * @name $.fn.swipe#doubleTap
   * @see  $.fn.swipe.defaults#doubleTapThreshold
   * @event
   * @default null
   * @param {EventObject} event The original event object
   * @param {DomObject} target The element clicked on.
   */

  /**
   * A long tap handler triggered once a tap has been release if the tap was longer than the longTapThreshold.
   * You can set the time delay for a long tap with the {@link $.fn.swipe.defaults#longTapThreshold} property.
   * @name $.fn.swipe#longTap
   * @see  $.fn.swipe.defaults#longTapThreshold
   * @event
   * @default null
   * @param {EventObject} event The original event object
   * @param {DomObject} target The element clicked on.
   */

  /**
   * A hold tap handler triggered as soon as the longTapThreshold is reached
   * You can set the time delay for a long tap with the {@link $.fn.swipe.defaults#longTapThreshold} property.
   * @name $.fn.swipe#hold
   * @see  $.fn.swipe.defaults#longTapThreshold
   * @event
   * @default null
   * @param {EventObject} event The original event object
   * @param {DomObject} target The element clicked on.
   */

});

(function () {
  var isMobile = false; // variable use to determine if responsive mode is on or off

  var sticko = {
    $parent: $("body"),
    $elements: "",
    $element: "",
    $child: "",
    pOffset: "",
    pWidth: "",
    eTop: "auto",
    startPoint: "",
    newHeight: 0,
    vPort: "screen-sm",
    originalHeight: "",
    forceDisableMobileSticky: false,
    init: function init() {
      sticko.control();
      sticko.launch();
      sticko.ctrl.check();
    },
    launch: function launch() {
      sticko.$elements = $(".sticko, .sticko__md"); // get sticky elements

      if (isMobile && sticko.$element.length) {
        sticko.$elements.each(function () {
          $(this).attr('style', '');

          if (sticko.forceDisableMobileSticky) {
            $(this).find('.sticko__child').attr('style', '');
          }

          if ($(this).hasClass("sticko__md")) {
            $(this).removeClass("js--sticko");
          }
        });
        return;
      }

      sticko.$elements.each(function () {
        //go over sticky elements
        sticko.$element = $(this); // get current element

        if (sticko.$element.hasClass("sticko__md") && isMobile) {
          // check if we are in responsive view port and we have responsive element
          return; // skip responsive sticky element
        }

        sticko.$element.addClass("js--sticko"); // add class that make elements stikcy

        if (sticko.$element.closest(".sticko__parent").length) {
          // get parent element if exist
          sticko.$parent = sticko.$element.closest(".sticko__parent");
        } else {
          sticko.$parent = $("body"); // set body as prent element if parent element doesn't exist
        }

        sticko.define(); // get parents offsets and apply those dimensions

        if (sticko.$element.find(".sticko__child").length) {
          sticko.$child = sticko.$element.find(".sticko__child");
          sticko.get.height();
        }

        sticko.ads();

        if (sticko.$element.length && sticko.$element.find(".sticko__child").length) {
          // check of we have sticko element and it has sticko child
          var val = 0;
          sticko.originalHeight = sticko.newHeight;
          sticko.set.height(val, sticko.originalHeight);
          sticko.ctrl.scrolla();
        }
      });
    },
    control: function control() {
      $(document).on(sticko.vPort + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        isMobile = true;
      });
      $(document).on(sticko.vPort + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
        isMobile = false;
      });
      $(document).on('smartResize', function () {
        // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
        var hHeight = sticko.get.fixedpageElementsHeight();
        var styles = {
          top: hHeight + 10 // modify the element top

        };
        sticko.apply(sticko.$element, styles);
      });
    },
    define: function define() {
      sticko.pOffset = sticko.$parent.offset(); // get parent offset

      sticko.pLeft = sticko.pOffset.left + parseInt(sticko.$parent.css("padding-left")); // get prent's left offset

      sticko.pWidth = sticko.$parent.width(); // get parent width

      var styles = {
        width: sticko.pWidth,
        // store prent width to  be added to sticky element styles
        top: sticko.$element.css("top") // modify the element top

      };
      sticko.apply(sticko.$element, styles); // apply styles after extraction from parent element
    },
    apply: function apply(element, styles) {
      // apply styles after extraction from parent element
      element.css(styles);
    },
    ads: function ads() {},
    get: {
      height: function height() {
        var childHeight = 0;
        sticko.$element.children(":not(.sticko__child)").each(function () {
          // get elements height (except sticko child)
          childHeight = childHeight + $(this).outerHeight();
        });
        sticko.newHeight = $(window).outerHeight() - (childHeight + sticko.pOffset.top);

        if ($('body').outerHeight() <= $(window).outerHeight()) {
          sticko.newHeight = sticko.newHeight - $('.page-footer').outerHeight();
        }

        var styles = {
          height: sticko.newHeight,
          'overflow-y': "auto"
        };
        sticko.apply(sticko.$child, styles);
      },
      fixedpageElementsHeight: function fixedpageElementsHeight() {
        var elementsHeight = $('header, .pageHeader').outerHeight();

        if (!elementsHeight) {
          elementsHeight = 0;
        }

        if ($('.fixed-element').length) {
          $.each($('.fixed-element'), function (index, value) {
            if ($(value).outerHeight()) {
              elementsHeight += $(value).outerHeight();
            }
          });
        }

        return elementsHeight;
      }
    },
    set: {
      height: function height(val, originalHeight) {
        var offestYTop = window.pageYOffset; // get windows y-top offset

        var offsetBottom = offestYTop + $(window).outerHeight(); // get windows y-bottom offset

        var tabsHeight = sticko.set.variables();
        var fixedArea = $(document).outerHeight() - $("footer").outerHeight() - tabsHeight; // get break point for stickiness

        var styles = {}; // define styles varibale

        if (offsetBottom >= fixedArea) {
          // check of we reached break point
          val = offsetBottom - fixedArea; // get new height

          sticko.newHeight = originalHeight - val;
          styles = {
            height: sticko.newHeight // store new height

          };
        } else {
          styles = {
            height: originalHeight // reset original height

          };
        }

        sticko.apply(sticko.$child, styles); // apply new height

        var hHeight = sticko.get.fixedpageElementsHeight();

        if ($('.article-row-left').outerHeight() < $(window).outerHeight()) {
          if (!UX.accordion.isArticleAccordion) {
            $('.article-row-left').height($(window).outerHeight() - hHeight);
          }
        }

        if ($('.sticko__side-content').outerHeight() < $(window).outerHeight()) {
          $('.sticko__side-content').height($(window).outerHeight() - hHeight);
        }

        if ($('.dynamic-sticko').length) {
          $('.dynamic-sticko').each(function () {
            var dynamicStickyElement = $(this);
            dynamicStickyElement.css('position', 'static');
            dynamicScrollTop = $(window).scrollTop() + hHeight;
            dynamicHeight = $(window).outerHeight() - hHeight;

            if (dynamicStickyElement.find('.tab__nav').length) {
              dynamicHeight -= dynamicStickyElement.find('.tab__nav').outerHeight();
            }

            if (offsetBottom >= fixedArea) {
              // check of we reached break point
              val = offsetBottom - fixedArea; // get new height

              dynamicStickyElement.css('height', dynamicHeight - val);
              $('.sticko__child').css('height', dynamicHeight - val);
            } else {
              dynamicStickyElement.css('height', dynamicHeight);
              $('.sticko__child').css('height', dynamicHeight);
            }

            if (dynamicScrollTop >= dynamicStickyElement.offset().top) {
              dynamicStickyElement.css('position', 'fixed');
              dynamicStickyElement.css('top', hHeight);
            }
          });
        }
      },
      variables: function variables() {
        var extraMargin = 0;
        return extraMargin;
      },
      forceDisableMobileSticky: function forceDisableMobileSticky() {
        sticko.forceDisableMobileSticky = false;
      }
    },
    ctrl: {
      check: function check() {
        //check certain for action
        $(window).resize(function () {
          sticko.ctrl.resize();
        });
        $(document).on('smartResize', function () {
          // Waiting for custom event that will be triggered by controller.js to activate responsive effects
          sticko.ctrl.resize();
        });
      },
      resize: function resize() {
        sticko.launch();
      },
      scrolla: function scrolla() {
        // get the new height of sticko child when scroll to avoid overlaping the footer region
        var val = 0;
        $(window).scroll(function () {
          if (!(isMobile && sticko.forceDisableMobileSticky)) {
            sticko.set.height(val, sticko.originalHeight);
          }
        });
      }
    }
  };
  UX.sticko = sticko; // add to global namespace
})();

(function () {
  var $body = $('body');

  function offset(el) {
    var rect = el.getBoundingClientRect();
    var scrollLeft = window.pageXOffset || document.documentElement.scrollLeft;
    var scrollTop = window.pageYOffset || document.documentElement.scrollTop;
    return {
      top: rect.top + scrollTop,
      left: rect.left + scrollLeft
    };
  }

  var scrollo = {
    init: function init() {
      scrollo.control();
    },
    adjustAnchor: function adjustAnchor(e) {
      e.preventDefault();
      var $anchor = $(':target');
      var fixedElementsHeight = scrollo.get.fixedpageElementsHeight();

      if ($anchor.length > 0) {
        window.scrollTo(0, offset($anchor.get(0)).top - fixedElementsHeight);
      }
    },
    control: function control() {
      $(window).on('hashchange load', scrollo.adjustAnchor);
      $body.on('click', 'a.table-fn[href^="#"],a.ref.fn[href^="#"],.scroll-to-target a[href^="#"]', function (e) {
        if (window.location.hash === $(this).attr('href')) {
          scrollo.adjustAnchor(e);
        }
      });
      $body.on('click keydown', 'a[href^="#"].sr-only-focusable', function (e) {
        // pass click and ENTER to action
        if (e.keyCode && e.keyCode !== 13) {
          return;
        }

        if (window.location.hash === $(this).attr('href')) {
          scrollo.adjustAnchor(e);
        }
      });
    },
    get: {
      fixedpageElementsHeight: function fixedpageElementsHeight() {
        var elementsHeight = 0;
        var $fixedHeader = $('header.fixed, .pageHeader');

        if ($fixedHeader.length) {
          elementsHeight = $fixedHeader.outerHeight();
        }

        var $scrolloThenFix = $('.scrollThenFix');

        if ($scrolloThenFix.length) {
          elementsHeight = $scrolloThenFix.outerHeight();
        }

        var $stickyCoolbar = $('.coolBar.stickybar--sticky');
        var stickyCoolbarHeigh = 0;

        if ($stickyCoolbar.length) {
          stickyCoolbarHeigh = $stickyCoolbar.outerHeight();

          if (stickyCoolbarHeigh == 0) {
            stickyCoolbarHeigh = $stickyCoolbar.find('.stickybar__wrapper').outerHeight();
          }

          elementsHeight += stickyCoolbarHeigh;
        }

        if ($('.fixed-element').length) {
          $.each($('.fixed-element'), function (index, value) {
            if ($(value).outerHeight()) {
              elementsHeight += $(value).outerHeight();
            }
          });
        }

        return elementsHeight;
      }
    }
  };
  UX.scrollo = scrollo; // add to global namespace
})();

(function () {
  var controller = {
    $body: $('body'),
    active: null,
    escape: 27,
    enabled: false,
    init: function init() {
      controller.control();
      controller.check();
      controller.extra();
    },
    control: function control() {
      $(document).on('keydown', function (e) {
        // hide / close when esc key is pressed
        if ((e.keyCode || e.which) === controller.escape) {
          controller.check(e);
        }
      });
    },
    check: function check(e) {
      // check if there is open / active component
      controller.active = controller.$body.attr('data-active');

      if (controller.active != null) {
        controller.disable(e);
      } //controller.extra();

    },
    disable: function disable(e) {
      // hide / close active component
      eval("UX." + controller.active).on.hide(e);
    },
    extra: function extra() {
      controller.$body.on("click", function (e) {
        // hide / close opened components when click out side it
        controller.active = controller.$body.attr('data-active');

        if (typeof eval("UX." + controller.active) != "undefined" && typeof eval("UX." + controller.active).$section != "undefined" && typeof eval("UX." + controller.active).$controller != "undefined") {
          var container = eval("UX." + controller.active).$section;
          var target = eval("UX." + controller.active).$controller;

          if (!container.is(e.target) // if the target of the click isn't the container...
          && container.has(e.target).length === 0 && !target.is(e.target) // if the target of the click isn't the controller...
          && target.has(e.target).length === 0) // ... nor a descendant of the controller
            {
              eval("UX." + controller.active).on.hide(e);
            }
        }
      });
    }
  };
  UX.controller = controller; // add to global namespace
})();

(function () {
  var $window = $(window),
      $body = $('body');
  var sortableTable = {
    $table: null,
    $tbody: null,
    init: function init() {
      sortableTable.$table = $('.table--sortable');
      sortableTable.control();
    },
    control: function control() {
      //grab all header rows
      sortableTable.$table.find('th.sortable').each(function (column) {
        $(this).click(function () {
          var findSortKey = function findSortKey($cell) {
            return $cell.find('.sort-key').text().toUpperCase() + ' ' + $cell.text().toUpperCase();
          };

          var sortDirection = $(this).is('.sorted-asc') ? -1 : 1;
          var $tbody = $(this).closest('.table--sortable').find('tbody');
          var $rows = $(this).closest('.table--sortable').find('tbody tr').get();
          $.each($rows, function (index, row) {
            row.sortKey = findSortKey($(row).children('td').eq(column));
          }); //compare and sort the rows alphabetically or numerically

          $rows.sort(function (a, b) {
            if (a.sortKey.indexOf('-') == -1 && !isNaN(a.sortKey) && !isNaN(a.sortKey)) {
              //Rough Numeracy check
              if (parseInt(a.sortKey) < parseInt(b.sortKey)) {
                return -sortDirection;
              }

              if (parseInt(a.sortKey) > parseInt(b.sortKey)) {
                return sortDirection;
              }
            } else {
              if (a.sortKey < b.sortKey) {
                return -sortDirection;
              }

              if (a.sortKey > b.sortKey) {
                return sortDirection;
              }
            }

            return 0;
          }); //add the rows in the correct order to the bottom of the table

          $.each($rows, function (index, row) {
            $tbody.append(row);
            row.sortKey = null;
          }); //identify the collumn sort order

          $('th').removeClass('sorted-asc sorted-desc');
          var $sortHead = $('th').filter(':nth-child(' + (column + 1) + ')');
          sortDirection == 1 ? $sortHead.addClass('sorted-asc') : $sortHead.addClass('sorted-desc'); //identify the collum to be sorted by

          $('td').removeClass('sorted').filter(':nth-child(' + (column + 1) + ')').addClass('sorted');

          if (sortableTable.$table.hasClass('js-pages')) {
            sortableTable.pager.rebuild();
          }
        });
      });
    },
    pager: {
      rebuild: function rebuild() {
        var page = 0;
        var pageSize = sortableTable.$table.find("[data-page=1]").length;
        sortableTable.$table.find("[data-page]").each(function (index) {
          if (index % pageSize == 0) {
            page++;
          }

          $(this).attr('data-page', page);
        });
        var activePage = sortableTable.$table.find('.pagination__list .active').data('target-page');
        sortableTable.$table.find("[data-page]").hide();
        sortableTable.$table.find("[data-page=" + activePage + "]").show();
      }
    }
  };
  UX.sortableTable = sortableTable; // add to global namespace
})();

/*!
 * fancyBox - jQuery Plugin
 * version: 2.1.7 (Tue, 28 Feb 2017)
 * requires jQuery v1.6 or later
 *
 * Examples at http://fancyapps.com/fancybox/
 * License: www.fancyapps.com/fancybox/#license
 *
 * Copyright 2017 fancyapps.com
 *
 */


(function (window, document, $, undefined) {
  "use strict";

  var H = $("html"),
      W = $(window),
      D = $(document),
      F = $.fancybox = function () {
    F.open.apply(this, arguments);
  },
      IE = navigator.userAgent.match(/msie/i),
      didUpdate = null,
      isTouch = document.createTouch !== undefined,
      isQuery = function isQuery(obj) {
    return obj && obj.hasOwnProperty && obj instanceof $;
  },
      isString = function isString(str) {
    return str && $.type(str) === "string";
  },
      isPercentage = function isPercentage(str) {
    return isString(str) && str.indexOf('%') > 0;
  },
      isScrollable = function isScrollable(el) {
    return el && !(el.style.overflow && el.style.overflow === 'hidden') && (el.clientWidth && el.scrollWidth > el.clientWidth || el.clientHeight && el.scrollHeight > el.clientHeight);
  },
      getScalar = function getScalar(orig, dim) {
    var value = parseInt(orig, 10) || 0;

    if (dim && isPercentage(orig)) {
      value = F.getViewport()[dim] / 100 * value;
    }

    return Math.ceil(value);
  },
      getValue = function getValue(value, dim) {
    return getScalar(value, dim) + 'px';
  };

  $.extend(F, {
    // The current version of fancyBox
    version: '2.1.7',
    defaults: {
      padding: 15,
      margin: 20,
      width: 800,
      height: 600,
      minWidth: 100,
      minHeight: 100,
      maxWidth: 9999,
      maxHeight: 9999,
      pixelRatio: 1,
      // Set to 2 for retina display support
      autoSize: true,
      autoHeight: false,
      autoWidth: false,
      autoResize: true,
      autoCenter: !isTouch,
      fitToView: true,
      aspectRatio: false,
      topRatio: 0.5,
      leftRatio: 0.5,
      scrolling: 'auto',
      // 'auto', 'yes' or 'no'
      wrapCSS: '',
      arrows: true,
      closeBtn: true,
      closeClick: false,
      nextClick: false,
      mouseWheel: true,
      autoPlay: false,
      playSpeed: 3000,
      preload: 3,
      modal: false,
      loop: true,
      ajax: {
        dataType: 'html',
        headers: {
          'X-fancyBox': true
        }
      },
      iframe: {
        scrolling: 'auto',
        preload: true
      },
      swf: {
        wmode: 'transparent',
        allowfullscreen: 'true',
        allowscriptaccess: 'always'
      },
      keys: {
        next: {
          13: 'left',
          // enter
          34: 'up',
          // page down
          39: 'left',
          // right arrow
          40: 'up' // down arrow

        },
        prev: {
          8: 'right',
          // backspace
          33: 'down',
          // page up
          37: 'right',
          // left arrow
          38: 'down' // up arrow

        },
        close: [27],
        // escape key
        play: [32],
        // space - start/stop slideshow
        toggle: [70] // letter "f" - toggle fullscreen

      },
      direction: {
        next: 'left',
        prev: 'right'
      },
      scrollOutside: true,
      // Override some properties
      index: 0,
      type: null,
      href: null,
      content: null,
      title: null,
      // HTML templates
      tpl: {
        wrap: '<div class="fancybox-wrap" tabIndex="-1"><div class="fancybox-skin"><div class="fancybox-outer"><div class="fancybox-inner"></div></div></div></div>',
        image: '<img class="fancybox-image" src="{href}" alt="" />',
        iframe: '<iframe id="fancybox-frame{rnd}" name="fancybox-frame{rnd}" class="fancybox-iframe" frameborder="0" vspace="0" hspace="0" webkitAllowFullScreen mozallowfullscreen allowFullScreen' + (IE ? ' allowtransparency="true"' : '') + '></iframe>',
        error: '<p class="fancybox-error">The requested content cannot be loaded.<br/>Please try again later.</p>',
        closeBtn: '<a title="Close" class="fancybox-item fancybox-close" href="javascript:;"></a>',
        next: '<a title="Next" class="fancybox-nav fancybox-next" href="javascript:;"><span></span></a>',
        prev: '<a title="Previous" class="fancybox-nav fancybox-prev" href="javascript:;"><span></span></a>',
        loading: '<div id="fancybox-loading"><div></div></div>'
      },
      // Properties for each animation type
      // Opening fancyBox
      openEffect: 'fade',
      // 'elastic', 'fade' or 'none'
      openSpeed: 250,
      openEasing: 'swing',
      openOpacity: true,
      openMethod: 'zoomIn',
      // Closing fancyBox
      closeEffect: 'fade',
      // 'elastic', 'fade' or 'none'
      closeSpeed: 250,
      closeEasing: 'swing',
      closeOpacity: true,
      closeMethod: 'zoomOut',
      // Changing next gallery item
      nextEffect: 'elastic',
      // 'elastic', 'fade' or 'none'
      nextSpeed: 250,
      nextEasing: 'swing',
      nextMethod: 'changeIn',
      // Changing previous gallery item
      prevEffect: 'elastic',
      // 'elastic', 'fade' or 'none'
      prevSpeed: 250,
      prevEasing: 'swing',
      prevMethod: 'changeOut',
      // Enable default helpers
      helpers: {
        overlay: true,
        title: true
      },
      // Callbacks
      onCancel: $.noop,
      // If canceling
      beforeLoad: $.noop,
      // Before loading
      afterLoad: $.noop,
      // After loading
      beforeShow: $.noop,
      // Before changing in current item
      afterShow: $.noop,
      // After opening
      beforeChange: $.noop,
      // Before changing gallery item
      beforeClose: $.noop,
      // Before closing
      afterClose: $.noop // After closing

    },
    //Current state
    group: {},
    // Selected group
    opts: {},
    // Group options
    previous: null,
    // Previous element
    coming: null,
    // Element being loaded
    current: null,
    // Currently loaded element
    isActive: false,
    // Is activated
    isOpen: false,
    // Is currently open
    isOpened: false,
    // Have been fully opened at least once
    wrap: null,
    skin: null,
    outer: null,
    inner: null,
    player: {
      timer: null,
      isActive: false
    },
    // Loaders
    ajaxLoad: null,
    imgPreload: null,
    // Some collections
    transitions: {},
    helpers: {},

    /*
     *	Static methods
     */
    open: function open(group, opts) {
      if (!group) {
        return;
      }

      if (!$.isPlainObject(opts)) {
        opts = {};
      } // Close if already active


      if (false === F.close(true)) {
        return;
      } // Normalize group


      if (!$.isArray(group)) {
        group = isQuery(group) ? $(group).get() : [group];
      } // Recheck if the type of each element is `object` and set content type (image, ajax, etc)


      $.each(group, function (i, element) {
        var obj = {},
            href,
            title,
            content,
            type,
            rez,
            hrefParts,
            selector;

        if ($.type(element) === "object") {
          // Check if is DOM element
          if (element.nodeType) {
            element = $(element);
          }

          if (isQuery(element)) {
            obj = {
              href: element.data('fancybox-href') || element.attr('href'),
              title: $('<div/>').text(element.data('fancybox-title') || element.attr('title') || '').html(),
              isDom: true,
              element: element
            };

            if ($.metadata) {
              $.extend(true, obj, element.metadata());
            }
          } else {
            obj = element;
          }
        }

        href = opts.href || obj.href || (isString(element) ? element : null);
        title = opts.title !== undefined ? opts.title : obj.title || '';
        content = opts.content || obj.content;
        type = content ? 'html' : opts.type || obj.type;

        if (!type && obj.isDom) {
          type = element.data('fancybox-type');

          if (!type) {
            rez = element.prop('class').match(/fancybox\.(\w+)/);
            type = rez ? rez[1] : null;
          }
        }

        if (isString(href)) {
          // Try to guess the content type
          if (!type) {
            if (F.isImage(href)) {
              type = 'image';
            } else if (F.isSWF(href)) {
              type = 'swf';
            } else if (href.charAt(0) === '#') {
              type = 'inline';
            } else if (isString(element)) {
              type = 'html';
              content = element;
            }
          } // Split url into two pieces with source url and content selector, e.g,
          // "/mypage.html #my_id" will load "/mypage.html" and display element having id "my_id"


          if (type === 'ajax') {
            hrefParts = href.split(/\s+/, 2);
            href = hrefParts.shift();
            selector = hrefParts.shift();
          }
        }

        if (!content) {
          if (type === 'inline') {
            if (href) {
              content = $(isString(href) ? href.replace(/.*(?=#[^\s]+$)/, '') : href); //strip for ie7
            } else if (obj.isDom) {
              content = element;
            }
          } else if (type === 'html') {
            content = href;
          } else if (!type && !href && obj.isDom) {
            type = 'inline';
            content = element;
          }
        }

        $.extend(obj, {
          href: href,
          type: type,
          content: content,
          title: title,
          selector: selector
        });
        group[i] = obj;
      }); // Extend the defaults

      F.opts = $.extend(true, {}, F.defaults, opts); // All options are merged recursive except keys

      if (opts.keys !== undefined) {
        F.opts.keys = opts.keys ? $.extend({}, F.defaults.keys, opts.keys) : false;
      }

      F.group = group;
      return F._start(F.opts.index);
    },
    // Cancel image loading or abort ajax request
    cancel: function cancel() {
      var coming = F.coming;

      if (coming && false === F.trigger('onCancel')) {
        return;
      }

      F.hideLoading();

      if (!coming) {
        return;
      }

      if (F.ajaxLoad) {
        F.ajaxLoad.abort();
      }

      F.ajaxLoad = null;

      if (F.imgPreload) {
        F.imgPreload.onload = F.imgPreload.onerror = null;
      }

      if (coming.wrap) {
        coming.wrap.stop(true, true).trigger('onReset').remove();
      }

      F.coming = null; // If the first item has been canceled, then clear everything

      if (!F.current) {
        F._afterZoomOut(coming);
      }
    },
    // Start closing animation if is open; remove immediately if opening/closing
    close: function close(event) {
      F.cancel();

      if (false === F.trigger('beforeClose')) {
        return;
      }

      F.unbindEvents();

      if (!F.isActive) {
        return;
      }

      if (!F.isOpen || event === true) {
        $('.fancybox-wrap').stop(true).trigger('onReset').remove();

        F._afterZoomOut();
      } else {
        F.isOpen = F.isOpened = false;
        F.isClosing = true;
        $('.fancybox-item, .fancybox-nav').remove();
        F.wrap.stop(true, true).removeClass('fancybox-opened');
        F.transitions[F.current.closeMethod]();
      }
    },
    // Manage slideshow:
    //   $.fancybox.play(); - toggle slideshow
    //   $.fancybox.play( true ); - start
    //   $.fancybox.play( false ); - stop
    play: function play(action) {
      var clear = function clear() {
        clearTimeout(F.player.timer);
      },
          set = function set() {
        clear();

        if (F.current && F.player.isActive) {
          F.player.timer = setTimeout(F.next, F.current.playSpeed);
        }
      },
          stop = function stop() {
        clear();
        D.unbind('.player');
        F.player.isActive = false;
        F.trigger('onPlayEnd');
      },
          start = function start() {
        if (F.current && (F.current.loop || F.current.index < F.group.length - 1)) {
          F.player.isActive = true;
          D.bind({
            'onCancel.player beforeClose.player': stop,
            'onUpdate.player': set,
            'beforeLoad.player': clear
          });
          set();
          F.trigger('onPlayStart');
        }
      };

      if (action === true || !F.player.isActive && action !== false) {
        start();
      } else {
        stop();
      }
    },
    // Navigate to next gallery item
    next: function next(direction) {
      var current = F.current;

      if (current) {
        if (!isString(direction)) {
          direction = current.direction.next;
        }

        F.jumpto(current.index + 1, direction, 'next');
      }
    },
    // Navigate to previous gallery item
    prev: function prev(direction) {
      var current = F.current;

      if (current) {
        if (!isString(direction)) {
          direction = current.direction.prev;
        }

        F.jumpto(current.index - 1, direction, 'prev');
      }
    },
    // Navigate to gallery item by index
    jumpto: function jumpto(index, direction, router) {
      var current = F.current;

      if (!current) {
        return;
      }

      index = getScalar(index);
      F.direction = direction || current.direction[index >= current.index ? 'next' : 'prev'];
      F.router = router || 'jumpto';

      if (current.loop) {
        if (index < 0) {
          index = current.group.length + index % current.group.length;
        }

        index = index % current.group.length;
      }

      if (current.group[index] !== undefined) {
        F.cancel();

        F._start(index);
      }
    },
    // Center inside viewport and toggle position type to fixed or absolute if needed
    reposition: function reposition(e, onlyAbsolute) {
      var current = F.current,
          wrap = current ? current.wrap : null,
          pos;

      if (wrap) {
        pos = F._getPosition(onlyAbsolute);

        if (e && e.type === 'scroll') {
          delete pos.position;
          wrap.stop(true, true).animate(pos, 200);
        } else {
          wrap.css(pos);
          current.pos = $.extend({}, current.dim, pos);
        }
      }
    },
    update: function update(e) {
      var type = e && e.originalEvent && e.originalEvent.type,
          anyway = !type || type === 'orientationchange';

      if (anyway) {
        clearTimeout(didUpdate);
        didUpdate = null;
      }

      if (!F.isOpen || didUpdate) {
        return;
      }

      didUpdate = setTimeout(function () {
        var current = F.current;

        if (!current || F.isClosing) {
          return;
        }

        F.wrap.removeClass('fancybox-tmp');

        if (anyway || type === 'load' || type === 'resize' && current.autoResize) {
          F._setDimension();
        }

        if (!(type === 'scroll' && current.canShrink)) {
          F.reposition(e);
        }

        F.trigger('onUpdate');
        didUpdate = null;
      }, anyway && !isTouch ? 0 : 300);
    },
    // Shrink content to fit inside viewport or restore if resized
    toggle: function toggle(action) {
      if (F.isOpen) {
        F.current.fitToView = $.type(action) === "boolean" ? action : !F.current.fitToView; // Help browser to restore document dimensions

        if (isTouch) {
          F.wrap.removeAttr('style').addClass('fancybox-tmp');
          F.trigger('onUpdate');
        }

        F.update();
      }
    },
    hideLoading: function hideLoading() {
      D.unbind('.loading');
      $('#fancybox-loading').remove();
    },
    showLoading: function showLoading() {
      var el, viewport;
      F.hideLoading();
      el = $(F.opts.tpl.loading).click(F.cancel).appendTo('body'); // If user will press the escape-button, the request will be canceled

      D.bind('keydown.loading', function (e) {
        if ((e.which || e.keyCode) === 27) {
          e.preventDefault();
          F.cancel();
        }
      });

      if (!F.defaults.fixed) {
        viewport = F.getViewport();
        el.css({
          position: 'absolute',
          top: viewport.h * 0.5 + viewport.y,
          left: viewport.w * 0.5 + viewport.x
        });
      }

      F.trigger('onLoading');
    },
    getViewport: function getViewport() {
      var locked = F.current && F.current.locked || false,
          rez = {
        x: W.scrollLeft(),
        y: W.scrollTop()
      };

      if (locked && locked.length) {
        rez.w = locked[0].clientWidth;
        rez.h = locked[0].clientHeight;
      } else {
        // See http://bugs.jquery.com/ticket/6724
        rez.w = isTouch && window.innerWidth ? window.innerWidth : W.width();
        rez.h = isTouch && window.innerHeight ? window.innerHeight : W.height();
      }

      return rez;
    },
    // Unbind the keyboard / clicking actions
    unbindEvents: function unbindEvents() {
      if (F.wrap && isQuery(F.wrap)) {
        F.wrap.unbind('.fb');
      }

      D.unbind('.fb');
      W.unbind('.fb');
    },
    bindEvents: function bindEvents() {
      var current = F.current,
          keys;

      if (!current) {
        return;
      } // Changing document height on iOS devices triggers a 'resize' event,
      // that can change document height... repeating infinitely


      W.bind('orientationchange.fb' + (isTouch ? '' : ' resize.fb') + (current.autoCenter && !current.locked ? ' scroll.fb' : ''), F.update);
      keys = current.keys;

      if (keys) {
        D.bind('keydown.fb', function (e) {
          var code = e.which || e.keyCode,
              target = e.target || e.srcElement; // Skip esc key if loading, because showLoading will cancel preloading

          if (code === 27 && F.coming) {
            return false;
          } // Ignore key combinations and key events within form elements


          if (!e.ctrlKey && !e.altKey && !e.shiftKey && !e.metaKey && !(target && (target.type || $(target).is('[contenteditable]')))) {
            $.each(keys, function (i, val) {
              if (current.group.length > 1 && val[code] !== undefined) {
                F[i](val[code]);
                e.preventDefault();
                return false;
              }

              if ($.inArray(code, val) > -1) {
                F[i]();
                e.preventDefault();
                return false;
              }
            });
          }
        });
      }

      if ($.fn.mousewheel && current.mouseWheel) {
        F.wrap.bind('mousewheel.fb', function (e, delta, deltaX, deltaY) {
          var target = e.target || null,
              parent = $(target),
              canScroll = false;

          while (parent.length) {
            if (canScroll || parent.is('.fancybox-skin') || parent.is('.fancybox-wrap')) {
              break;
            }

            canScroll = isScrollable(parent[0]);
            parent = $(parent).parent();
          }

          if (delta !== 0 && !canScroll) {
            if (F.group.length > 1 && !current.canShrink) {
              if (deltaY > 0 || deltaX > 0) {
                F.prev(deltaY > 0 ? 'down' : 'left');
              } else if (deltaY < 0 || deltaX < 0) {
                F.next(deltaY < 0 ? 'up' : 'right');
              }

              e.preventDefault();
            }
          }
        });
      }
    },
    trigger: function trigger(event, o) {
      var ret,
          obj = o || F.coming || F.current;

      if (obj) {
        if ($.isFunction(obj[event])) {
          ret = obj[event].apply(obj, Array.prototype.slice.call(arguments, 1));
        }

        if (ret === false) {
          return false;
        }

        if (obj.helpers) {
          $.each(obj.helpers, function (helper, opts) {
            if (opts && F.helpers[helper] && $.isFunction(F.helpers[helper][event])) {
              F.helpers[helper][event]($.extend(true, {}, F.helpers[helper].defaults, opts), obj);
            }
          });
        }
      }

      D.trigger(event);
    },
    isImage: function isImage(str) {
      return isString(str) && str.match(/(^data:image\/.*,)|(\.(jp(e|g|eg)|gif|png|bmp|webp|svg)((\?|#).*)?$)/i);
    },
    isSWF: function isSWF(str) {
      return isString(str) && str.match(/\.(swf)((\?|#).*)?$/i);
    },
    _start: function _start(index) {
      var coming = {},
          obj,
          href,
          type,
          margin,
          padding;
      index = getScalar(index);
      obj = F.group[index] || null;

      if (!obj) {
        return false;
      }

      coming = $.extend(true, {}, F.opts, obj); // Convert margin and padding properties to array - top, right, bottom, left

      margin = coming.margin;
      padding = coming.padding;

      if ($.type(margin) === 'number') {
        coming.margin = [margin, margin, margin, margin];
      }

      if ($.type(padding) === 'number') {
        coming.padding = [padding, padding, padding, padding];
      } // 'modal' propery is just a shortcut


      if (coming.modal) {
        $.extend(true, coming, {
          closeBtn: false,
          closeClick: false,
          nextClick: false,
          arrows: false,
          mouseWheel: false,
          keys: null,
          helpers: {
            overlay: {
              closeClick: false
            }
          }
        });
      } // 'autoSize' property is a shortcut, too


      if (coming.autoSize) {
        coming.autoWidth = coming.autoHeight = true;
      }

      if (coming.width === 'auto') {
        coming.autoWidth = true;
      }

      if (coming.height === 'auto') {
        coming.autoHeight = true;
      }
      /*
       * Add reference to the group, so it`s possible to access from callbacks, example:
       * afterLoad : function() {
       *     this.title = 'Image ' + (this.index + 1) + ' of ' + this.group.length + (this.title ? ' - ' + this.title : '');
       * }
       */


      coming.group = F.group;
      coming.index = index; // Give a chance for callback or helpers to update coming item (type, title, etc)

      F.coming = coming;

      if (false === F.trigger('beforeLoad')) {
        F.coming = null;
        return;
      }

      type = coming.type;
      href = coming.href;

      if (!type) {
        F.coming = null; //If we can not determine content type then drop silently or display next/prev item if looping through gallery

        if (F.current && F.router && F.router !== 'jumpto') {
          F.current.index = index;
          return F[F.router](F.direction);
        }

        return false;
      }

      F.isActive = true;

      if (type === 'image' || type === 'swf') {
        coming.autoHeight = coming.autoWidth = false;
        coming.scrolling = 'visible';
      }

      if (type === 'image') {
        coming.aspectRatio = true;
      }

      if (type === 'iframe' && isTouch) {
        coming.scrolling = 'scroll';
      } // Build the neccessary markup


      coming.wrap = $(coming.tpl.wrap).addClass('fancybox-' + (isTouch ? 'mobile' : 'desktop') + ' fancybox-type-' + type + ' fancybox-tmp ' + coming.wrapCSS).appendTo(coming.parent || 'body');
      $.extend(coming, {
        skin: $('.fancybox-skin', coming.wrap),
        outer: $('.fancybox-outer', coming.wrap),
        inner: $('.fancybox-inner', coming.wrap)
      });
      $.each(["Top", "Right", "Bottom", "Left"], function (i, v) {
        coming.skin.css('padding' + v, getValue(coming.padding[i]));
      });
      F.trigger('onReady'); // Check before try to load; 'inline' and 'html' types need content, others - href

      if (type === 'inline' || type === 'html') {
        if (!coming.content || !coming.content.length) {
          return F._error('content');
        }
      } else if (!href) {
        return F._error('href');
      }

      if (type === 'image') {
        F._loadImage();
      } else if (type === 'ajax') {
        F._loadAjax();
      } else if (type === 'iframe') {
        F._loadIframe();
      } else {
        F._afterLoad();
      }
    },
    _error: function _error(type) {
      $.extend(F.coming, {
        type: 'html',
        autoWidth: true,
        autoHeight: true,
        minWidth: 0,
        minHeight: 0,
        scrolling: 'no',
        hasError: type,
        content: F.coming.tpl.error
      });

      F._afterLoad();
    },
    _loadImage: function _loadImage() {
      // Reset preload image so it is later possible to check "complete" property
      var img = F.imgPreload = new Image();

      img.onload = function () {
        this.onload = this.onerror = null;
        F.coming.width = this.width / F.opts.pixelRatio;
        F.coming.height = this.height / F.opts.pixelRatio;

        F._afterLoad();
      };

      img.onerror = function () {
        this.onload = this.onerror = null;

        F._error('image');
      };

      img.src = F.coming.href;

      if (img.complete !== true) {
        F.showLoading();
      }
    },
    _loadAjax: function _loadAjax() {
      var coming = F.coming;
      F.showLoading();
      F.ajaxLoad = $.ajax($.extend({}, coming.ajax, {
        url: coming.href,
        error: function error(jqXHR, textStatus) {
          if (F.coming && textStatus !== 'abort') {
            F._error('ajax', jqXHR);
          } else {
            F.hideLoading();
          }
        },
        success: function success(data, textStatus) {
          if (textStatus === 'success') {
            coming.content = data;

            F._afterLoad();
          }
        }
      }));
    },
    _loadIframe: function _loadIframe() {
      var coming = F.coming,
          iframe = $(coming.tpl.iframe.replace(/\{rnd\}/g, new Date().getTime())).attr('scrolling', isTouch ? 'auto' : coming.iframe.scrolling).attr('src', coming.href); // This helps IE

      $(coming.wrap).bind('onReset', function () {
        try {
          $(this).find('iframe').hide().attr('src', '//about:blank').end().empty();
        } catch (e) {}
      });

      if (coming.iframe.preload) {
        F.showLoading();
        iframe.one('load', function () {
          $(this).data('ready', 1); // iOS will lose scrolling if we resize

          if (!isTouch) {
            $(this).bind('load.fb', F.update);
          } // Without this trick:
          //   - iframe won't scroll on iOS devices
          //   - IE7 sometimes displays empty iframe


          $(this).parents('.fancybox-wrap').width('100%').removeClass('fancybox-tmp').show();

          F._afterLoad();
        });
      }

      coming.content = iframe.appendTo(coming.inner);

      if (!coming.iframe.preload) {
        F._afterLoad();
      }
    },
    _preloadImages: function _preloadImages() {
      var group = F.group,
          current = F.current,
          len = group.length,
          cnt = current.preload ? Math.min(current.preload, len - 1) : 0,
          item,
          i;

      for (i = 1; i <= cnt; i += 1) {
        item = group[(current.index + i) % len];

        if (item.type === 'image' && item.href) {
          new Image().src = item.href;
        }
      }
    },
    _afterLoad: function _afterLoad() {
      var coming = F.coming,
          previous = F.current,
          placeholder = 'fancybox-placeholder',
          current,
          content,
          type,
          scrolling,
          href,
          embed;
      F.hideLoading();

      if (!coming || F.isActive === false) {
        return;
      }

      if (false === F.trigger('afterLoad', coming, previous)) {
        coming.wrap.stop(true).trigger('onReset').remove();
        F.coming = null;
        return;
      }

      if (previous) {
        F.trigger('beforeChange', previous);
        previous.wrap.stop(true).removeClass('fancybox-opened').find('.fancybox-item, .fancybox-nav').remove();
      }

      F.unbindEvents();
      current = coming;
      content = coming.content;
      type = coming.type;
      scrolling = coming.scrolling;
      $.extend(F, {
        wrap: current.wrap,
        skin: current.skin,
        outer: current.outer,
        inner: current.inner,
        current: current,
        previous: previous
      });
      href = current.href;

      switch (type) {
        case 'inline':
        case 'ajax':
        case 'html':
          if (current.selector) {
            content = $('<div>').html(content).find(current.selector);
          } else if (isQuery(content)) {
            if (!content.data(placeholder)) {
              content.data(placeholder, $('<div class="' + placeholder + '"></div>').insertAfter(content).hide());
            }

            content = content.show().detach();
            current.wrap.bind('onReset', function () {
              if ($(this).find(content).length) {
                content.hide().replaceAll(content.data(placeholder)).data(placeholder, false);
              }
            });
          }

          break;

        case 'image':
          content = current.tpl.image.replace(/\{href\}/g, href);
          break;

        case 'swf':
          content = '<object id="fancybox-swf" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" width="100%" height="100%"><param name="movie" value="' + href + '"></param>';
          embed = '';
          $.each(current.swf, function (name, val) {
            content += '<param name="' + name + '" value="' + val + '"></param>';
            embed += ' ' + name + '="' + val + '"';
          });
          content += '<embed src="' + href + '" type="application/x-shockwave-flash" width="100%" height="100%"' + embed + '></embed></object>';
          break;
      }

      if (!(isQuery(content) && content.parent().is(current.inner))) {
        current.inner.append(content);
      } // Give a chance for helpers or callbacks to update elements


      F.trigger('beforeShow'); // Set scrolling before calculating dimensions

      current.inner.css('overflow', scrolling === 'yes' ? 'scroll' : scrolling === 'no' ? 'hidden' : scrolling); // Set initial dimensions and start position

      F._setDimension();

      F.reposition();
      F.isOpen = false;
      F.coming = null;
      F.bindEvents();

      if (!F.isOpened) {
        $('.fancybox-wrap').not(current.wrap).stop(true).trigger('onReset').remove();
      } else if (previous.prevMethod) {
        F.transitions[previous.prevMethod]();
      }

      F.transitions[F.isOpened ? current.nextMethod : current.openMethod]();

      F._preloadImages();
    },
    _setDimension: function _setDimension() {
      var viewport = F.getViewport(),
          steps = 0,
          canShrink = false,
          canExpand = false,
          wrap = F.wrap,
          skin = F.skin,
          inner = F.inner,
          current = F.current,
          width = current.width,
          height = current.height,
          minWidth = current.minWidth,
          minHeight = current.minHeight,
          maxWidth = current.maxWidth,
          maxHeight = current.maxHeight,
          scrolling = current.scrolling,
          scrollOut = current.scrollOutside ? current.scrollbarWidth : 0,
          margin = current.margin,
          wMargin = getScalar(margin[1] + margin[3]),
          hMargin = getScalar(margin[0] + margin[2]),
          wPadding,
          hPadding,
          wSpace,
          hSpace,
          origWidth,
          origHeight,
          origMaxWidth,
          origMaxHeight,
          ratio,
          width_,
          height_,
          maxWidth_,
          maxHeight_,
          iframe,
          body; // Reset dimensions so we could re-check actual size

      wrap.add(skin).add(inner).width('auto').height('auto').removeClass('fancybox-tmp');
      wPadding = getScalar(skin.outerWidth(true) - skin.width());
      hPadding = getScalar(skin.outerHeight(true) - skin.height()); // Any space between content and viewport (margin, padding, border, title)

      wSpace = wMargin + wPadding;
      hSpace = hMargin + hPadding;
      origWidth = isPercentage(width) ? (viewport.w - wSpace) * getScalar(width) / 100 : width;
      origHeight = isPercentage(height) ? (viewport.h - hSpace) * getScalar(height) / 100 : height;

      if (current.type === 'iframe') {
        iframe = current.content;

        if (current.autoHeight && iframe && iframe.data('ready') === 1) {
          try {
            if (iframe[0].contentWindow.document.location) {
              inner.width(origWidth).height(9999);
              body = iframe.contents().find('body');

              if (scrollOut) {
                body.css('overflow-x', 'hidden');
              }

              origHeight = body.outerHeight(true);
            }
          } catch (e) {}
        }
      } else if (current.autoWidth || current.autoHeight) {
        inner.addClass('fancybox-tmp'); // Set width or height in case we need to calculate only one dimension

        if (!current.autoWidth) {
          inner.width(origWidth);
        }

        if (!current.autoHeight) {
          inner.height(origHeight);
        }

        if (current.autoWidth) {
          origWidth = inner.width();
        }

        if (current.autoHeight) {
          origHeight = inner.height();
        }

        inner.removeClass('fancybox-tmp');
      }

      width = getScalar(origWidth);
      height = getScalar(origHeight);
      ratio = origWidth / origHeight; // Calculations for the content

      minWidth = getScalar(isPercentage(minWidth) ? getScalar(minWidth, 'w') - wSpace : minWidth);
      maxWidth = getScalar(isPercentage(maxWidth) ? getScalar(maxWidth, 'w') - wSpace : maxWidth);
      minHeight = getScalar(isPercentage(minHeight) ? getScalar(minHeight, 'h') - hSpace : minHeight);
      maxHeight = getScalar(isPercentage(maxHeight) ? getScalar(maxHeight, 'h') - hSpace : maxHeight); // These will be used to determine if wrap can fit in the viewport

      origMaxWidth = maxWidth;
      origMaxHeight = maxHeight;

      if (current.fitToView) {
        maxWidth = Math.min(viewport.w - wSpace, maxWidth);
        maxHeight = Math.min(viewport.h - hSpace, maxHeight);
      }

      maxWidth_ = viewport.w - wMargin;
      maxHeight_ = viewport.h - hMargin;

      if (current.aspectRatio) {
        if (width > maxWidth) {
          width = maxWidth;
          height = getScalar(width / ratio);
        }

        if (height > maxHeight) {
          height = maxHeight;
          width = getScalar(height * ratio);
        }

        if (width < minWidth) {
          width = minWidth;
          height = getScalar(width / ratio);
        }

        if (height < minHeight) {
          height = minHeight;
          width = getScalar(height * ratio);
        }
      } else {
        width = Math.max(minWidth, Math.min(width, maxWidth));

        if (current.autoHeight && current.type !== 'iframe') {
          inner.width(width);
          height = inner.height();
        }

        height = Math.max(minHeight, Math.min(height, maxHeight));
      } // Try to fit inside viewport (including the title)


      if (current.fitToView) {
        inner.width(width).height(height);
        wrap.width(width + wPadding); // Real wrap dimensions

        width_ = wrap.width();
        height_ = wrap.height();

        if (current.aspectRatio) {
          while ((width_ > maxWidth_ || height_ > maxHeight_) && width > minWidth && height > minHeight) {
            if (steps++ > 19) {
              break;
            }

            height = Math.max(minHeight, Math.min(maxHeight, height - 10));
            width = getScalar(height * ratio);

            if (width < minWidth) {
              width = minWidth;
              height = getScalar(width / ratio);
            }

            if (width > maxWidth) {
              width = maxWidth;
              height = getScalar(width / ratio);
            }

            inner.width(width).height(height);
            wrap.width(width + wPadding);
            width_ = wrap.width();
            height_ = wrap.height();
          }
        } else {
          width = Math.max(minWidth, Math.min(width, width - (width_ - maxWidth_)));
          height = Math.max(minHeight, Math.min(height, height - (height_ - maxHeight_)));
        }
      }

      if (scrollOut && scrolling === 'auto' && height < origHeight && width + wPadding + scrollOut < maxWidth_) {
        width += scrollOut;
      }

      inner.width(width).height(height);
      wrap.width(width + wPadding);
      width_ = wrap.width();
      height_ = wrap.height();
      canShrink = (width_ > maxWidth_ || height_ > maxHeight_) && width > minWidth && height > minHeight;
      canExpand = current.aspectRatio ? width < origMaxWidth && height < origMaxHeight && width < origWidth && height < origHeight : (width < origMaxWidth || height < origMaxHeight) && (width < origWidth || height < origHeight);
      $.extend(current, {
        dim: {
          width: getValue(width_),
          height: getValue(height_)
        },
        origWidth: origWidth,
        origHeight: origHeight,
        canShrink: canShrink,
        canExpand: canExpand,
        wPadding: wPadding,
        hPadding: hPadding,
        wrapSpace: height_ - skin.outerHeight(true),
        skinSpace: skin.height() - height
      });

      if (!iframe && current.autoHeight && height > minHeight && height < maxHeight && !canExpand) {
        inner.height('auto');
      }
    },
    _getPosition: function _getPosition(onlyAbsolute) {
      var current = F.current,
          viewport = F.getViewport(),
          margin = current.margin,
          width = F.wrap.width() + margin[1] + margin[3],
          height = F.wrap.height() + margin[0] + margin[2],
          rez = {
        position: 'absolute',
        top: margin[0],
        left: margin[3]
      };

      if (current.autoCenter && current.fixed && !onlyAbsolute && height <= viewport.h && width <= viewport.w) {
        rez.position = 'fixed';
      } else if (!current.locked) {
        rez.top += viewport.y;
        rez.left += viewport.x;
      }

      rez.top = getValue(Math.max(rez.top, rez.top + (viewport.h - height) * current.topRatio));
      rez.left = getValue(Math.max(rez.left, rez.left + (viewport.w - width) * current.leftRatio));
      return rez;
    },
    _afterZoomIn: function _afterZoomIn() {
      var current = F.current;

      if (!current) {
        return;
      }

      F.isOpen = F.isOpened = true;
      F.wrap.css('overflow', 'visible').addClass('fancybox-opened').hide().show(0);
      F.update(); // Assign a click event

      if (current.closeClick || current.nextClick && F.group.length > 1) {
        F.inner.css('cursor', 'pointer').bind('click.fb', function (e) {
          if (!$(e.target).is('a') && !$(e.target).parent().is('a')) {
            e.preventDefault();
            F[current.closeClick ? 'close' : 'next']();
          }
        });
      } // Create a close button


      if (current.closeBtn) {
        $(current.tpl.closeBtn).appendTo(F.skin).bind('click.fb', function (e) {
          e.preventDefault();
          F.close();
        });
      } // Create navigation arrows


      if (current.arrows && F.group.length > 1) {
        if (current.loop || current.index > 0) {
          $(current.tpl.prev).appendTo(F.outer).bind('click.fb', F.prev);
        }

        if (current.loop || current.index < F.group.length - 1) {
          $(current.tpl.next).appendTo(F.outer).bind('click.fb', F.next);
        }
      }

      F.trigger('afterShow'); // Stop the slideshow if this is the last item

      if (!current.loop && current.index === current.group.length - 1) {
        F.play(false);
      } else if (F.opts.autoPlay && !F.player.isActive) {
        F.opts.autoPlay = false;
        F.play(true);
      }
    },
    _afterZoomOut: function _afterZoomOut(obj) {
      obj = obj || F.current;
      $('.fancybox-wrap').trigger('onReset').remove();
      $.extend(F, {
        group: {},
        opts: {},
        router: false,
        current: null,
        isActive: false,
        isOpened: false,
        isOpen: false,
        isClosing: false,
        wrap: null,
        skin: null,
        outer: null,
        inner: null
      });
      F.trigger('afterClose', obj);
    }
  });
  /*
   *	Default transitions
   */

  F.transitions = {
    getOrigPosition: function getOrigPosition() {
      var current = F.current,
          element = current.element,
          orig = current.orig,
          pos = {},
          width = 50,
          height = 50,
          hPadding = current.hPadding,
          wPadding = current.wPadding,
          viewport = F.getViewport();

      if (!orig && current.isDom && element.is(':visible')) {
        orig = element.find('img:first');

        if (!orig.length) {
          orig = element;
        }
      }

      if (isQuery(orig)) {
        pos = orig.offset();

        if (orig.is('img')) {
          width = orig.outerWidth();
          height = orig.outerHeight();
        }
      } else {
        pos.top = viewport.y + (viewport.h - height) * current.topRatio;
        pos.left = viewport.x + (viewport.w - width) * current.leftRatio;
      }

      if (F.wrap.css('position') === 'fixed' || current.locked) {
        pos.top -= viewport.y;
        pos.left -= viewport.x;
      }

      pos = {
        top: getValue(pos.top - hPadding * current.topRatio),
        left: getValue(pos.left - wPadding * current.leftRatio),
        width: getValue(width + wPadding),
        height: getValue(height + hPadding)
      };
      return pos;
    },
    step: function step(now, fx) {
      var ratio,
          padding,
          value,
          prop = fx.prop,
          current = F.current,
          wrapSpace = current.wrapSpace,
          skinSpace = current.skinSpace;

      if (prop === 'width' || prop === 'height') {
        ratio = fx.end === fx.start ? 1 : (now - fx.start) / (fx.end - fx.start);

        if (F.isClosing) {
          ratio = 1 - ratio;
        }

        padding = prop === 'width' ? current.wPadding : current.hPadding;
        value = now - padding;
        F.skin[prop](getScalar(prop === 'width' ? value : value - wrapSpace * ratio));
        F.inner[prop](getScalar(prop === 'width' ? value : value - wrapSpace * ratio - skinSpace * ratio));
      }
    },
    zoomIn: function zoomIn() {
      var current = F.current,
          startPos = current.pos,
          effect = current.openEffect,
          elastic = effect === 'elastic',
          endPos = $.extend({
        opacity: 1
      }, startPos); // Remove "position" property that breaks older IE

      delete endPos.position;

      if (elastic) {
        startPos = this.getOrigPosition();

        if (current.openOpacity) {
          startPos.opacity = 0.1;
        }
      } else if (effect === 'fade') {
        startPos.opacity = 0.1;
      }

      F.wrap.css(startPos).animate(endPos, {
        duration: effect === 'none' ? 0 : current.openSpeed,
        easing: current.openEasing,
        step: elastic ? this.step : null,
        complete: F._afterZoomIn
      });
    },
    zoomOut: function zoomOut() {
      var current = F.current,
          effect = current.closeEffect,
          elastic = effect === 'elastic',
          endPos = {
        opacity: 0.1
      };

      if (elastic) {
        endPos = this.getOrigPosition();

        if (current.closeOpacity) {
          endPos.opacity = 0.1;
        }
      }

      F.wrap.animate(endPos, {
        duration: effect === 'none' ? 0 : current.closeSpeed,
        easing: current.closeEasing,
        step: elastic ? this.step : null,
        complete: F._afterZoomOut
      });
    },
    changeIn: function changeIn() {
      var current = F.current,
          effect = current.nextEffect,
          startPos = current.pos,
          endPos = {
        opacity: 1
      },
          direction = F.direction,
          distance = 200,
          field;
      startPos.opacity = 0.1;

      if (effect === 'elastic') {
        field = direction === 'down' || direction === 'up' ? 'top' : 'left';

        if (direction === 'down' || direction === 'right') {
          startPos[field] = getValue(getScalar(startPos[field]) - distance);
          endPos[field] = '+=' + distance + 'px';
        } else {
          startPos[field] = getValue(getScalar(startPos[field]) + distance);
          endPos[field] = '-=' + distance + 'px';
        }
      } // Workaround for http://bugs.jquery.com/ticket/12273


      if (effect === 'none') {
        F._afterZoomIn();
      } else {
        F.wrap.css(startPos).animate(endPos, {
          duration: current.nextSpeed,
          easing: current.nextEasing,
          complete: F._afterZoomIn
        });
      }
    },
    changeOut: function changeOut() {
      var previous = F.previous,
          effect = previous.prevEffect,
          endPos = {
        opacity: 0.1
      },
          direction = F.direction,
          distance = 200;

      if (effect === 'elastic') {
        endPos[direction === 'down' || direction === 'up' ? 'top' : 'left'] = (direction === 'up' || direction === 'left' ? '-' : '+') + '=' + distance + 'px';
      }

      previous.wrap.animate(endPos, {
        duration: effect === 'none' ? 0 : previous.prevSpeed,
        easing: previous.prevEasing,
        complete: function complete() {
          $(this).trigger('onReset').remove();
        }
      });
    }
  };
  /*
   *	Overlay helper
   */

  F.helpers.overlay = {
    defaults: {
      closeClick: true,
      // if true, fancyBox will be closed when user clicks on the overlay
      speedOut: 200,
      // duration of fadeOut animation
      showEarly: true,
      // indicates if should be opened immediately or wait until the content is ready
      css: {},
      // custom CSS properties
      locked: !isTouch,
      // if true, the content will be locked into overlay
      fixed: true // if false, the overlay CSS position property will not be set to "fixed"

    },
    overlay: null,
    // current handle
    fixed: false,
    // indicates if the overlay has position "fixed"
    el: $('html'),
    // element that contains "the lock"
    // Public methods
    create: function create(opts) {
      var parent;
      opts = $.extend({}, this.defaults, opts);

      if (this.overlay) {
        this.close();
      }

      parent = F.coming ? F.coming.parent : opts.parent;
      this.overlay = $('<div class="fancybox-overlay"></div>').appendTo(parent && parent.length ? parent : 'body');
      this.fixed = false;

      if (opts.fixed && F.defaults.fixed) {
        this.overlay.addClass('fancybox-overlay-fixed');
        this.fixed = true;
      }
    },
    open: function open(opts) {
      var that = this;
      opts = $.extend({}, this.defaults, opts);

      if (this.overlay) {
        this.overlay.unbind('.overlay').width('auto').height('auto');
      } else {
        this.create(opts);
      }

      if (!this.fixed) {
        W.bind('resize.overlay', $.proxy(this.update, this));
        this.update();
      }

      if (opts.closeClick) {
        this.overlay.bind('click.overlay', function (e) {
          if ($(e.target).hasClass('fancybox-overlay')) {
            if (F.isActive) {
              F.close();
            } else {
              that.close();
            }

            return false;
          }
        });
      }

      this.overlay.css(opts.css).show();
    },
    close: function close() {
      W.unbind('resize.overlay');

      if (this.el.hasClass('fancybox-lock')) {
        $('.fancybox-margin').removeClass('fancybox-margin');
        this.el.removeClass('fancybox-lock');
        W.scrollTop(this.scrollV).scrollLeft(this.scrollH);
      }

      $('.fancybox-overlay').remove().hide();
      $.extend(this, {
        overlay: null,
        fixed: false
      });
    },
    // Private, callbacks
    update: function update() {
      var width = '100%',
          offsetWidth; // Reset width/height so it will not mess

      this.overlay.width(width).height('100%'); // jQuery does not return reliable result for IE

      if (IE) {
        offsetWidth = Math.max(document.documentElement.offsetWidth, document.body.offsetWidth);

        if (D.width() > offsetWidth) {
          width = D.width();
        }
      } else if (D.width() > W.width()) {
        width = D.width();
      }

      this.overlay.width(width).height(D.height());
    },
    // This is where we can manipulate DOM, because later it would cause iframes to reload
    onReady: function onReady(opts, obj) {
      var overlay = this.overlay;
      $('.fancybox-overlay').stop(true, true);

      if (!overlay) {
        this.create(opts);
      }

      if (opts.locked && this.fixed && obj.fixed) {
        obj.locked = this.overlay.append(obj.wrap);
        obj.fixed = false;
      }

      if (opts.showEarly === true) {
        this.beforeShow.apply(this, arguments);
      }
    },
    beforeShow: function beforeShow(opts, obj) {
      if (obj.locked && !this.el.hasClass('fancybox-lock')) {
        if (this.fixPosition !== false) {
          $('*:not(object)').filter(function () {
            return $(this).css('position') === 'fixed' && !$(this).hasClass("fancybox-overlay") && !$(this).hasClass("fancybox-wrap");
          }).addClass('fancybox-margin');
        }

        this.el.addClass('fancybox-margin');
        this.scrollV = W.scrollTop();
        this.scrollH = W.scrollLeft();
        this.el.addClass('fancybox-lock');
        W.scrollTop(this.scrollV).scrollLeft(this.scrollH);
      }

      this.open(opts);
    },
    onUpdate: function onUpdate() {
      if (!this.fixed) {
        this.update();
      }
    },
    afterClose: function afterClose(opts) {
      // Remove overlay if exists and fancyBox is not opening
      // (e.g., it is not being open using afterClose callback)
      if (this.overlay && !F.coming) {
        this.overlay.fadeOut(opts.speedOut, $.proxy(this.close, this));
      }
    }
  };
  /*
   *	Title helper
   */

  F.helpers.title = {
    defaults: {
      type: 'float',
      // 'float', 'inside', 'outside' or 'over',
      position: 'bottom' // 'top' or 'bottom'

    },
    beforeShow: function beforeShow(opts) {
      var current = F.current,
          text = current.title,
          type = opts.type,
          title,
          target;

      if ($.isFunction(text)) {
        text = text.call(current.element, current);
      }

      if (!isString(text) || $.trim(text) === '') {
        return;
      }

      title = $('<div class="fancybox-title fancybox-title-' + type + '-wrap">' + text + '</div>');

      switch (type) {
        case 'inside':
          target = F.skin;
          break;

        case 'outside':
          target = F.wrap;
          break;

        case 'over':
          target = F.inner;
          break;

        default:
          // 'float'
          target = F.skin;
          title.appendTo('body');

          if (IE) {
            title.width(title.width());
          }

          title.wrapInner('<span class="child"></span>'); //Increase bottom margin so this title will also fit into viewport

          F.current.margin[2] += Math.abs(getScalar(title.css('margin-bottom')));
          break;
      }

      title[opts.position === 'top' ? 'prependTo' : 'appendTo'](target);
    }
  }; // jQuery plugin initialization

  $.fn.fancybox = function (options) {
    var index,
        that = $(this),
        selector = this.selector || '',
        run = function run(e) {
      var what = $(this).blur(),
          idx = index,
          relType,
          relVal;

      if (!(e.ctrlKey || e.altKey || e.shiftKey || e.metaKey) && !what.is('.fancybox-wrap')) {
        relType = options.groupAttr || 'data-fancybox-group';
        relVal = what.attr(relType);

        if (!relVal) {
          relType = 'rel';
          relVal = what.get(0)[relType];
        }

        if (relVal && relVal !== '' && relVal !== 'nofollow') {
          what = selector.length ? $(selector) : that;
          what = what.filter('[' + relType + '="' + relVal + '"]');
          idx = what.index(this);
        }

        options.index = idx; // Stop an event from bubbling if everything is fine

        if (F.open(what, options) !== false) {
          e.preventDefault();
        }
      }
    };

    options = options || {};
    index = options.index || 0;

    if (!selector || options.live === false) {
      that.unbind('click.fb-start').bind('click.fb-start', run);
    } else {
      D.undelegate(selector, 'click.fb-start').delegate(selector + ":not('.fancybox-item, .fancybox-nav')", 'click.fb-start', run);
    }

    this.filter('[data-fancybox-start=1]').trigger('click');
    return this;
  }; // Tests that need a body at doc ready


  D.ready(function () {
    var w1, w2;

    if ($.scrollbarWidth === undefined) {
      // http://benalman.com/projects/jquery-misc-plugins/#scrollbarwidth
      $.scrollbarWidth = function () {
        var parent = $('<div style="width:50px;height:50px;overflow:auto"><div/></div>').appendTo('body'),
            child = parent.children(),
            width = child.innerWidth() - child.height(99).innerWidth();
        parent.remove();
        return width;
      };
    }

    if ($.support.fixedPosition === undefined) {
      $.support.fixedPosition = function () {
        var elem = $('<div style="position:fixed;top:20px;"></div>').appendTo('body'),
            fixed = elem[0].offsetTop === 20 || elem[0].offsetTop === 15;
        elem.remove();
        return fixed;
      }();
    }

    $.extend(F.defaults, {
      scrollbarWidth: $.scrollbarWidth(),
      fixed: $.support.fixedPosition,
      parent: $('body')
    }); //Get real width of page scroll-bar

    w1 = $(window).width();
    H.addClass('fancybox-lock-test');
    w2 = $(window).width();
    H.removeClass('fancybox-lock-test');
    $("<style type='text/css'>.fancybox-margin{margin-right:" + (w2 - w1) + "px;}</style>").appendTo("head");
  });
})(window, document, jQuery);

(function () {
  UX.resizeImages = function (container, minRatio) {
    var $images = $('img', container);
    $images.each(function () {
      var imgW = $(this).width() || 0;
      var imgH = $(this).height() || 0;

      if (imgW > imgH * minRatio) {
        $(this).addClass('full-width-image');
      }
    });
  };
})();

(function () {
  var $body = $('body'),
      $document = $(document);
  var list = {
    init: function init() {
      list.on.build();
      list.control();
    },
    control: function control() {
      $body.on('click', '.expandable-list__toggle', function (e) {
        e.preventDefault();
        list.on.toggleList($(this));
      });
    },
    on: {
      build: function build() {
        var $wrapper = $('.expandable-list');
        var $toggle = $('.expandable-list__toggle');
        $wrapper.each(function () {
          var $target = $(this).find('.expandable-list__body');
          var $toggle = $(this).find('.expandable-list__toggle');
          $target.hide();
        });
      },
      toggleList: function toggleList(elem) {
        var $toggle = elem;
        var $wrapper = $toggle.closest('.expandable-list');
        var $target = $wrapper.find('.expandable-list__body').toggle();
        $wrapper.toggleClass('js--open');
        $toggle.find('i').toggleClass('icon-add_box icon-squared-minus');

        if ($wrapper.hasClass('js--open')) {
          $toggle.attr('aria-expanded', true);
          $target.attr('aria-hidden', false);
        } else {
          $toggle.attr('aria-expanded', false);
          $target.attr('aria-hidden', true);
        }
      },
      closeList: function closeList(elem) {
        var $wrapper = $('.expandable-list');
        $wrapper.removeClass('js--open');
        var $target = $wrapper.find('.expandable-list__body').hide();
        var $toggle = $('.expandable-list__toggle');
        $toggle.attr('aria-expanded', 'false').find('i').addClass('icon-add_box').removeClass('icon-squared-minus');
        $target.attr('aria-hidden', true);
      }
    }
  };
  UX.list = list; // add to global namespace
})();

(function () {
  var $window = $(window),
      $body = $('body');
  var pageBody = {
    contentSelectors: [],
    contentPaddingTop: 0,
    header: null,
    init: function init() {
      this.header = ".header.fixed";
      this.contentSelectors = ["main.content", ".header ~ .content"];
      pageBody.on.setContentTopPadding();
      pageBody.control();
      pageBody.extraControls();
    },
    control: function control() {
      $(document).on("eventSetContentPadding", pageBody.on.setContentTopPadding);
      $(window).on('resize', function () {
        pageBody.on.setContentTopPadding();
      }); // Resize Observer
      // TODO: If you want to use this functionality in your product, you have to import resizeObserverPolyfill from plugins in all.js

      if (typeof ResizeObserver === "function" && $(pageBody.header).length > 0) {
        var ro = new ResizeObserver(function () {
          $(document).trigger("eventSetContentPadding");
        });
        ro.observe(document.querySelector(pageBody.header));
      }
    },
    extraControls: function extraControls() {},
    on: {
      setContentTopPadding: function setContentTopPadding() {
        pageBody.contentPaddingTop = 0;

        if ($('.header.fixed, .header.auto-hide-bar').length) {
          pageBody.contentPaddingTop = $('.header.fixed, .header.auto-hide-bar').outerHeight();
        }

        if ($('.scrollThenFix.locked').length) {
          pageBody.contentPaddingTop += $('.scrollThenFix.locked').outerHeight();
        }

        if ($('.fixed-element').length) {
          $.each($('.fixed-element:not(.header)'), function (index, value) {
            if ($(value).outerHeight()) {
              pageBody.contentPaddingTop += $(value).outerHeight();
            }
          });
        }

        pageBody.setTopPadding(pageBody.contentPaddingTop);
      }
    },
    setTopPadding: function setTopPadding(value) {
      $.each(pageBody.contentSelectors, function (index, selector) {
        if ($(selector).length > 0) {
          $(selector).css('padding-top', value);
          return false;
        }
      });
    }
  };
  UX.pageBody = pageBody; // add to global namespace
})();

(function () {
  var iOS = /iPad|iPhone|iPod/.test(navigator.userAgent) && !window.MSStream;

  if (iOS) {
    $('body').addClass('iOS');
  }
})();

// Import components

function menubar$1(e, t) {
  this.$id = $("#" + e), this.$rootItems = this.$id.children("li"), this.$items = this.$id.find(".menu-item"), this.$parents = this.$id.find(".menu-parent"), this.$allItems = this.$parents.add(this.$items), this.$activeItem = null, this.vmenu = t, this.bChildOpen = !1, this.keys = {
    tab: 9,
    enter: 13,
    esc: 27,
    space: 32,
    left: 37,
    up: 38,
    right: 39,
    down: 40
  }, this.bindHandlers();
}

menubar$1.prototype.bindHandlers = function () {
  var e = this;
  this.$allItems.keydown(function (t) {
    return e.handleKeyDown($(this), t);
  }), this.$allItems.keypress(function (t) {
    return e.handleKeyPress($(this), t);
  }), this.$allItems.focus(function (t) {
    return e.handleFocus($(this), t);
  }), $(document).click(function (t) {
    return e.handleDocumentClick(t);
  });
};

menubar$1.prototype.handleFocus = function (e, t) {
  if (null == this.$activeItem) this.$activeItem = e;else if (e[0] != this.$activeItem[0]) return !0;
  var i = this.$activeItem.parentsUntil("div").filter("li");
  if (this.$allItems.removeClass("menu-focus menu-focus-checked"), this.$activeItem.is(".checked") ? this.$activeItem.addClass("menu-focus-checked") : this.$activeItem.addClass("menu-focus"), i.addClass("menu-focus"), 1 == this.vmenu) if (1 == this.bChildOpen) {
    var s = e.parent();
    s.is("#menubar") && "true" == e.attr("aria-haspopup") && e.addClass('hover').children("ul").attr("aria-hidden", "false");
  } else this.vmenu = !1;
  return !0;
};

menubar$1.prototype.handleKeyDown = function (e, t) {
  if (t.altKey || t.ctrlKey) return !0;

  switch (t.keyCode) {
    case this.keys.tab:
      this.$id.find("ul").attr("aria-hidden", "true"), this.$allItems.removeClass("menu-focus hover"), this.$activeItem = null, 0 == this.bChildOpen;
      break;

    case this.keys.esc:
      if (UX.menu.$toggle.length > 0) {
        //if (e.keyCode  === escKey) {
        //e.preventDefault();
        UX.menu.on.hide();
        UX.menu.$toggle.focus(); //}
      } else {
        var i = e.parent();
        return i.is("#menubar") ? (e.removeClass('hover').children("ul").first().attr("aria-hidden", "true"), e.focus()) : (this.$activeItem = i.parent(), e.removeClass('hover'), this.bChildOpen = !1, this.$activeItem.focus(), i.attr("aria-hidden", "true")), t.stopPropagation(), !1;
      }

    case this.keys.enter:
    case this.keys.space:
      var s = e.parent();
      return s.is("#menubar") ? (e.addClass('hover').children("ul").first().attr("aria-hidden", "false"), this.bChildOpen = !0, this.processMenuChoice(e), e.find("ul > li:first").find("a").focus()) : (this.processMenuChoice(e), this.$allItems.removeClass("menu-hover menu-hover-checked hover"), this.$allItems.removeClass("menu-focus menu-focus-checked hover"), this.$id.find("ul").not("#menubar").attr("aria-hidden", "true"), this.$activeItem = null), t.stopPropagation(), !1;

    case this.keys.left:
      return 1 == this.vmenu && i.is("#menubar") ? this.$activeItem = this.moveUp(e) : this.$activeItem = this.moveToPrevious(e), this.$activeItem.focus(), t.stopPropagation(), !1;

    case this.keys.right:
      return 1 == this.vmenu && i.is("#menubar") ? this.$activeItem = this.moveDown(e) : this.$activeItem = this.moveToNext(e), this.$activeItem.focus(), t.stopPropagation(), !1;

    case this.keys.up:
      return 1 == this.vmenu && i.is("#menubar") ? this.$activeItem = this.moveToPrevious(e) : this.$activeItem = this.moveUp(e), this.$activeItem.focus(), t.stopPropagation(), !1;

    case this.keys.down:
      return 1 == this.vmenu && i.is("#menubar") ? this.$activeItem = this.moveToNext(e) : this.$activeItem = this.moveDown(e), this.$activeItem.focus(), t.stopPropagation(), !1;
  }

  return !0;
};

menubar$1.prototype.moveToNext = function (e) {
  var t = e.parent(),
      i = t.children("li"),
      s = i.length,
      r = i.index(e),
      n = null;

  if (t.is("#menubar")) {
    if (n = s - 1 > r ? e.next() : i.first(), "true" == e.attr("aria-haspopup")) {
      e.removeClass('hover');
      var a = e.children("ul").first();
      "false" == a.attr("aria-hidden") && (a.attr("aria-hidden", "true"), this.bChildOpen = !0);
    }

    if (e.removeClass("menu-focus"), "true" == n.attr("aria-haspopup") && 1 == this.bChildOpen) {
      n.addClass('hover');
      var a = n.children("ul").first();
      a.attr("aria-hidden", "false");
    }
  } else if ("true" == e.attr("aria-haspopup")) {
    e.addClass('hover');
    var a = e.children("ul").first();
    n = a.children("li").first(), a.attr("aria-hidden", "false"), this.bChildOpen = !0;
  } else {
    if (1 == this.vmenu) return e;
    var h = null,
        o = null;

    if (h = e.parentsUntil("div").filter("ul").not("#menubar"), h.attr("aria-hidden", "true"), h.find("li").removeClass("menu-focus hover"), h.last().parent().removeClass("menu-focus hover"), o = h.last().parent(), r = this.$rootItems.index(o), n = r < this.$rootItems.length - 1 ? o.next() : this.$rootItems.first(), "true" == n.attr("aria-haspopup") && n.children("ul").length > 0) {
      n.addClass('hover');
      var a = n.children("ul").first();
      n = a.children("li").first(), a.attr("aria-hidden", "false"), this.bChildOpen = !0;
    }
  }

  return n;
};

menubar$1.prototype.moveToPrevious = function (e) {
  var t = e.parent(),
      i = t.children("li"),
      s = (i.length, i.index(e)),
      r = null;

  if (t.is("#menubar")) {
    if (r = s > 0 ? e.prev() : i.last(), "true" == e.attr("aria-haspopup")) {
      var n = e.removeClass('hover').children("ul").first();
      "false" == n.attr("aria-hidden") && (n.attr("aria-hidden", "true"), this.bChildOpen = !0);
    }

    if (e.removeClass("menu-focus hover"), "true" == r.attr("aria-haspopup") && 1 == this.bChildOpen) {
      r.addClass('hover');
      var n = r.children("ul").first();
      n.attr("aria-hidden", "false");
    }
  } else {
    var a = t.parent(),
        h = a.parent();

    if (1 != this.vmenu && h.is("#menubar")) {
      if (t.attr("aria-hidden", "true"), e.removeClass("menu-focus hover"), a.removeClass("menu-focus hover"), s = this.$rootItems.index(a), r = s > 0 ? a.prev() : this.$rootItems.last(), r.addClass("menu-focus hover"), "true" == r.attr("aria-haspopup")) {
        var n = null;
        r.children("ul").length > 0 && (n = r.addClass('hover').children("ul").first(), n.attr("aria-hidden", "false"), this.bChildOpen = !0, r = n.children("li").first());
      }
    } else r = t.parent(), t.attr("aria-hidden", "true"), e.removeClass("menu-focus hover"), r.removeClass("hover"), 1 == this.vmenu && (this.bChildOpen = !1);
  }

  return r;
};

menubar$1.prototype.moveDown = function (e, t) {
  var i = e.parent(),
      s = i.children("li").not(".separator"),
      r = s.length,
      n = s.index(e),
      a = null,
      h = null;
  if (i.is("#menubar")) return "true" != e.attr("aria-haspopup") ? e : (h = e.addClass('hover').children("ul").first(), a = h.children("li").first(), h.attr("aria-hidden", "false"), this.bChildOpen = !0, a);

  if (t) {
    var o = !1,
        u = n + 1;

    for (u == r && (u = 0); u != n;) {
      var l = s.eq(u).html().charAt(0);

      if (l.toLowerCase() == t) {
        o = !0;
        break;
      }

      u += 1, u == r && (u = 0);
    }

    return 1 == o ? (a = s.eq(u), e.removeClass("menu-focus menu-focus-checked"), a) : e;
  }

  return a = r - 1 > n ? s.eq(n + 1) : s.first(), e.removeClass("menu-focus menu-focus-checked"), a;
};

menubar$1.prototype.moveUp = function (e) {
  var t = e.parent(),
      i = t.children("li").not(".separator"),
      s = (i.length, i.index(e)),
      r = null;
  return t.is("#menubar") ? e : (r = s > 0 ? i.eq(s - 1) : i.last(), e.removeClass("menu-focus menu-focus-checked"), r);
};

menubar$1.prototype.handleKeyPress = function (e, t) {
  if (t.altKey || t.ctrlKey || t.shiftKey) return !0;

  switch (t.keyCode) {
    case this.keys.tab:
      return !0;

    case this.keys.esc:
    case this.keys.enter:
    case this.keys.space:
    case this.keys.up:
    case this.keys.down:
    case this.keys.left:
    case this.keys.right:
      return t.stopPropagation(), !1;

    default:
      var i = String.fromCharCode(t.which);
      return this.$activeItem = this.moveDown(e, i), this.$activeItem.focus(), t.stopPropagation(), !1;
  }

  return !0;
};

menubar$1.prototype.handleDocumentClick = function (e) {
  var t = this.$id.find("ul").not("#menubar");
  return t.attr("aria-hidden", "true"), this.$allItems.removeClass("menu-focus menu-focus-checked hover"), this.$activeItem = null, !0;
};

menubar$1.prototype.processMenuChoice = function (e) {
  var t = (e.parent().attr("id"), e.attr("id"), e.data("href"));
  if (null != t) if (t.toLowerCase().indexOf("legacy.") > 0) {
    var i = window.open(t, "_blank");
    i.focus();
  } else window.location.href = t;
  var s = e.find("a");
  null != s && (window.location.href = s[0].href);
};

window.menubar = menubar$1;

(function () {
  //document.activeElement
  var $body = $('body'),
      $window = $(window),
      tabKey = 9,
      shift = 16,
      escKey = 27,
      nestedMenu;
  var menu = {
    $toggle: $('[data-toggle="nav"]'),
    $target: null,
    revers: false,
    lastItem: null,
    items: null,
    vPort: ["screen-sm"],
    isMobile: false,
    // variable use to determine if responsive mode is on or off
    init: function init() {
      var menu1 = new menubar('menubar', false);
      $('.main-nav').each(function (index) {
        menu.$target = $(this);
        menu.check.viewPort(index);
        menu.responsive(index);
      });
      menu.items = $('.main-nav').find('a, button, input'); //$(".header__nav a, .header__nav button, .header__nav input");

      menu.control();
      menu.additionalControl();
    },
    responsive: function responsive(index) {
      $(document).on(menu.vPort[index] + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        menu.isMobile = true;
        $('.main-nav').each(function () {
          if ($(this).find('.drawer__nav').data('ctrl-res') == menu.vPort[index]) {
            $(this).addClass("menu--res"); // class will be used in our scss (to replace media queries)

            menu.on.rebuild.responsive(); // rebuild menu to be responsive - drawer
          }
        });
      });
      $(document).on(menu.vPort[index] + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
        menu.isMobile = false;
        $('.main-nav').each(function () {
          if ($(this).find('.drawer__nav').data('ctrl-res') == menu.vPort[index]) {
            $(this).removeClass("menu--res"); // class will be used in our scss (to replace media queries)

            menu.on.rebuild.original(); // return menu as default
          }
        });
      });
    },
    control: function control() {
      $body.on('click', '[data-toggle="nav"]', function (e) {
        e.preventDefault();
        menu.$toggle = $(this);
        menu.$target = $('#' + menu.$toggle.data('target'));
        menu.items = menu.$target.find('a, button, input'); //$(".header__nav a, .header__nav button, .header__nav input");

        menu.items.each(function (index) {
          if (index === menu.items.length - 1) {
            menu.lastItem = $(this);
          }
        });
        menu.on.show();
      });
      $body.on('click', '.js--open[data-toggle="nav"]', function (e) {
        e.preventDefault();
        menu.on.hide();
      });
      $body.on('click', function (e) {
        if (!$(e.target).closest('.dropdown__toggle').length) {
          $("a.dropdown__toggle.hover").removeClass("hover");
        }

        if (!$(e.target).hasClass("icon-arrow_r") && !$(e.target).parents('.main-nav.menu--res').length && $('.lock-screen[data-active="menu"]').length) {
          menu.on.hide();
        }
      });
      $body.on('click', '.main-nav a', function (e) {
        if ($(this).attr('href') == "#") {
          e.preventDefault();
        }
      });
      $body.on('click', '[data-toggle="dropdown"]', function (e) {
        e.preventDefault();
        nestedMenu = $(this);
        menu.on.nested(e);
      });
      $body.on('click', '.menu-header i.icon-arrow_r', function (e) {
        e.preventDefault();

        if (menu.isMobile) {
          menu.on.hideNested();
        }
      });
      $body.on('keydown', '.drawer__nav, [data-toggle="nav"]', function (e) {
        if (menu.isMobile) {
          if ((e.keyCode || e.which) === tabKey) {
            if (!menu.revers) {
              menu.on.tab();
            } else {
              menu.on.tabRevers();
            }
          }
        }
      });
      $window.on('keyup', function (e) {
        menu.revers = false;

        if (e.shiftKey && e.keyCode === tabKey) {
          menu.revers = true;
        }

        if (!menu.isMobile) {
          if ((e.keyCode || e.which) === tabKey) {
            if (!menu.revers) {
              menu.on.tabDesktop(e);
            } else {
              menu.on.tabReversDesktop(e);
            }
          }

          if ((e.keyCode || e.which) === escKey) {
            menu.on.escDesktop(e);
          }
        }
      });
    },
    additionalControl: function additionalControl() {},
    on: {
      show: function show() {
        if (typeof UX.controller != "undefined") {
          UX.controller.check();
        }

        $body.addClass('lock-screen').attr('data-active', 'menu');
        menu.$toggle.addClass('js--open');
        menu.$target.closest('.main-nav').css('top', $window.scrollTop());
        $('header').css('top', $window.scrollTop());
        $('.coolBar--res').removeClass('trans').css('top', $window.scrollTop() + $('header').height());
        $('.loi__banner.loi--res').css('top', $window.scrollTop() + $('header').height());
        menu.$target.attr("style", "display: block !important");
        menu.$toggle.focus();
        menu.on.showAdditional();
      },
      showAdditional: function showAdditional() {},
      showNested: function showNested() {
        nestedMenu.next('.dropdown__menu').toggleClass('sub-menu__opened');
        nestedMenu.parent().toggleClass('menu-parent__opened');
        nestedMenu.find('i').toggleClass('opposite-arrow');
        nestedMenu.parent().siblings('li').toggleClass('prev-items');
        nestedMenu.toggleClass('prev-items');
        var $menuTitle = nestedMenu.html();

        if ($('.menu-header').length) {
          $('.menu-header').html($menuTitle);
        }
      },
      hideNested: function hideNested() {
        var $menuHeader = $('.menu-header');
        var $parenNestedMenu;

        if (typeof nestedMenu != 'undefined') {
          $parenNestedMenu = nestedMenu.parent().parent(); // first parent list

          nestedMenu = $parenNestedMenu.parent().find('.dropdown__toggle'); // first parent dropdown toggle link

          $parenNestedMenu.find('.sub-menu__opened').removeClass('sub-menu__opened');
          $parenNestedMenu.find('.menu-parent__opened').removeClass('menu-parent__opened');
          $parenNestedMenu.find('.prev-items').removeClass('prev-items');

          if ($parenNestedMenu.hasClass('sub-menu__opened')) {
            $menuHeader.find('span').html(nestedMenu.find('span').html());
          } else {
            $menuHeader.html('HOME');
          }
        } else {
          nestedMenu = $menuHeader;
        }
      },
      hide: function hide() {
        menu.$toggle.removeClass('js--open');
        $('.main-nav, header').css('top', 0);
        $('.coolBar--res').addClass('trans').css('top', $('header').height()); // The magic number contains 1px of border and

        $('.loi__banner.loi--res').css('top', $('header').height());
        $body.removeAttr('data-active').removeClass('lock-screen');
      },
      escape: function escape() {
        menu.on.hide();
        menu.$toggle.focus();
      },
      tab: function tab() {
        menu.$toggle.off();
        menu.lastItem.off().on('focusout', function () {
          menu.$toggle.focus();
        });
      },
      tabRevers: function tabRevers() {
        menu.lastItem.off();
        menu.$toggle.off().on('focusout', function () {
          menu.lastItem.focus();
        });
      },
      tabDesktop: function tabDesktop(e) {
        if ($(e.target).hasClass("dropdown__toggle")) {
          if ($(e.target).closest(".hover").length == 0) {
            $('.dropdown__toggle').removeClass('hover');
            $('.dropdown').removeClass('js--open');
          }

          $(e.target).closest("a").addClass("hover");
        } else {
          $(e.target).closest("ul").find('.hover').each(function () {
            $(this).removeClass('hover');
          });
        }
      },
      tabReversDesktop: function tabReversDesktop(e) {
        if ($(e.target).hasClass("dropdown__toggle")) {
          if ($(e.target).closest(".hover").length == 0) {
            $('.dropdown__toggle').removeClass('hover');
          }

          $(e.target).closest("a").addClass("hover");
        } else if ($(e.target).closest(".hubpage-menu").length == 0 && $(e.target).closest(".main-nav").length == 0) {
          $('.dropdown__toggle').removeClass('hover');
        }
      },
      escDesktop: function escDesktop(e) {
        $(e.target).closest(".dropdown__toggle").removeClass("hover");
      },
      rebuild: {
        responsive: function responsive() {
          menu.on.hide();
        },
        original: function original() {
          menu.on.hide();
          menu.$target.show();
        }
      },
      nested: function nested(e) {
        //e.preventDefault();
        if (menu.isMobile) {
          menu.on.showNested();
        }
      }
    },
    check: {
      viewPort: function viewPort(index) {
        if (menu.$target.find('.drawer__nav').attr('data-ctrl-res')) {
          menu.vPort[index] = menu.$target.find('.drawer__nav').attr('data-ctrl-res');
        }

        
      }
    }
  };
  UX.menu = menu; // add to global namespace
})();

(function () {
  var coolbar = {
    sections: null,
    holder: $('.coolBar--sections .coolBar__drop'),
    vPort: "screen-sm",
    isMobile: false,
    coolbarElement: null,
    headerHeight: 0,
    isStickyBar: false,
    lock: true,
    // define lock and set default value, this lock will be used to make sure to run certain functionality and to run on every scroll event
    init: function init() {
      coolbar.coolbarElement = $(".coolBar");
      coolbar.isStickyBar = coolbar.coolbarElement.hasClass("stickybar");
      coolbar.get.sections();
      coolbar.fill.sections();
      coolbar.control();
      coolbar.addtionalControls();
    },
    control: function control() {
      if ($('.journal-home').length) {
        coolbar.vPort = "screen-md";
      }

      $(document).on(coolbar.vPort + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        $('.coolBar').addClass("coolBar--res"); // class will be used in our scss (to replace media queries)

        if (coolbar.isStickyBar) {
          $('.coolBar').addClass("fixed-element");
        }

        coolbar.headerHeight = $('header').outerHeight() || 0;
        $('.coolBar--res').addClass('trans').css('top', coolbar.headerHeight);
        setTimeout(function () {
          $(document).trigger("eventSetContentPadding");
        }, 500);
        coolbar.isMobile = true;
      });
      $(document).on(coolbar.vPort + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
        $('.coolBar').removeClass("coolBar--res");
        $('.coolBar').removeClass("fixed-element");
        $(document).trigger("eventSetContentPadding");
        coolbar.isMobile = false;

        if (typeof UX.controller !== 'undefined') {
          UX.controller.check();
        }
      });
    },
    addtionalControls: function addtionalControls() {},
    get: {
      sections: function sections() {
        coolbar.sections = $('.article__content .section__title');
      }
    },
    fill: {
      sections: function sections() {
        if ($('.coolBar--sections').length && coolbar.sections.length > 1) {
          $('.coolBar--sections').removeClass("hidden");
          var ul = $('<ul class="rlist w-slide--list"/>').appendTo(coolbar.holder);
          coolbar.sections.each(function () {
            var $this = $(this);
            var li = $('<li/>').attr('role', 'menuitem').appendTo(ul);
            var link = $('<a class="w-slide__hide"/>').attr('href', "#" + $this.attr('id')).appendTo(li);
            var spaner = $('<span/>').text($(this).text()).appendTo(link);
          });
        } else {
          $('.coolBar--sections').remove();
        }
      }
    }
  };
  UX.coolbar = coolbar; // add to global namespace
})();

(function () {
  var $window = $(window),
      $body = $('body');
  var stickybar = {
    sections: null,
    vPort: "screen-sm",
    isMobile: false,
    stickybarElement: $('.stickybar'),
    stickyElements: [],
    topPostition: 0,
    fixedElements: 0,
    toBeStickyOn: 'desktop',
    // desktop, mobile, all
    start: false,
    lock: false,
    // define lock and set default value, this lock will be used to make sure to run certain functionality and to run on every scroll event
    init: function init() {
      stickybar.load.stickyElements();
      stickybar.control();
      setTimeout(stickybar.sticky.init, 0);
    },
    control: function control() {
      $(document).on(stickybar.vPort + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        stickybar.isMobile = true;
        stickybar.sticky.on();
      });
      $(document).on(stickybar.vPort + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
        stickybar.isMobile = false;
        stickybar.sticky.on();
      });
      stickybar.sticky.on();
    },
    load: {
      stickyElements: function stickyElements() {
        $('.stickybar').each(function () {
          stickybar.stickyElements.push({
            el: $(this),
            toBeStickyOn: $(this).data('sticky-on') || stickybar.toBeStickyOn,
            start: false,
            lock: false,
            top: 0
          });
        });
      },
      fixedElements: function fixedElements(i, el) {
        stickybar.fixedElements = 0;
        $('.fixed-element:not(.stickybar__wrapper,.stickybar)').each(function () {
          stickybar.fixedElements += $(this).outerHeight();
        });
        j = 0;

        while (j < i) {
          if (stickybar.stickyElements[j].lock) stickybar.fixedElements += stickybar.stickyElements[j].el.find('.stickybar__wrapper').outerHeight();
          j++;
        } // make sure header height is added if it does not have .fixed-element class


        stickybar.fixedElements += $('header.fixed:not(.fixed-element)').outerHeight() || 0;

        if ($(".scrollThenFix").length) {
          stickybar.fixedElements = $(".scrollThenFix").height();
        }

        if ($('.auto-hide-secondary-bar.slide-up').length) {
          stickybar.fixedElements = $(".auto-hide-secondary-bar").height();
        }

        stickybar.stickyElements[i].top = stickybar.fixedElements;
      }
    },
    sticky: {
      init: function init() {
        stickybar.load.fixedElements(0);
        stickybar.sticky.get.width(); // get stickybar width

        stickybar.sticky.check();
        $window.scroll(function () {
          stickybar.sticky.check();
          stickybar.sticky.get.width();
        });
        $window.on("smartResize, load, resize", function () {
          stickybar.load.fixedElements(0);
          stickybar.sticky.get.width();
        });
      },
      check: function check() {
        // check if stickiness must be enabled
        for (var i = 0; i < stickybar.stickyElements.length; i++) {
          var offsetYTop = window.pageYOffset; // screen y offset

          var topPostition = stickybar.stickyElements[i].el.offset().top;
          stickybar.load.fixedElements(i);
          var stickyPoint = offsetYTop + stickybar.fixedElements; // get meeting point to anble stickiness

          if (stickyPoint >= topPostition && stickybar.stickyElements[i].start) {
            // check if skickiness point passed stickybar top position
            if (!stickybar.lock) {
              // prevent runing this code in every scroll event
              stickybar.stickyElements[i].el.addClass("stickybar--sticky");
              stickybar.stickyElements[i].el.find('.stickybar__wrapper').addClass("fixed-element");
              stickybar.stickyElements[i].lock = true; // lock is enabled
            }
          } else {
            stickybar.stickyElements[i].lock = false; // lock is disabled

            stickybar.stickyElements[i].el.removeClass("stickybar--sticky");
            stickybar.stickyElements[i].el.find('.stickybar__wrapper').removeClass("fixed-element");
          }
        }
      },
      on: function on() {
        for (var i = 0; i < stickybar.stickyElements.length; i++) {
          var stickyOn = stickybar.stickyElements[i].toBeStickyOn;

          switch (stickyOn) {
            case 'desktop':
              stickybar.stickyElements[i].start = !stickybar.isMobile;
              break;

            case 'mobile':
              stickybar.stickyElements[i].start = stickybar.isMobile;
              break;

            case 'all':
              stickybar.stickyElements[i].start = true;
              break;
          }
        }
      },
      get: {
        width: function width() {
          for (var i = 0; i < stickybar.stickyElements.length; i++) {
            if (stickybar.stickyElements[i].start) {
              stickybar.stickyElements[i].el.find(".stickybar__wrapper").css({
                "width": stickybar.stickyElements[i].el.width(),
                "top": stickybar.stickyElements[i].top
              });
            } else {
              stickybar.stickyElements[i].el.find(".stickybar__wrapper").css({
                "width": "auto",
                "top": "auto"
              });
            }
          }
        }
      }
    }
  };
  UX.stickybar = stickybar; // add to global namespace
})();

(function () {
  var $window = $(window),
      isMobile = false,
      $body = $('body');
  var dropBlock = {
    $controllers: $("[data-db-target-for]"),
    $controller: null,
    // Current drop down controller
    $target: null,
    // Current target down controller element
    $targets: null,
    // Holds all targets in Dom
    $parent: null,
    // Current parent element
    $parents: null,
    // Hodls all parents in Dom
    escape: 27,
    $container: $(".container"),
    switchVal: null,
    $section: $(".dropBlock__holder"),
    vPort: "screen-sm",
    init: function init() {
      dropBlock.control();
    },
    control: function control() {
      $body.on('click', '[data-db-target-for]', function (e) {
        e.preventDefault();
        var attr = $(this).is('[data-slide-target]');

        if (_typeof(attr) !== (typeof undefined === "undefined" ? "undefined" : _typeof(undefined)) && attr !== false && isMobile) {
          return;
        } else {
          dropBlock.$controller = $(this);
          dropBlock.find.target(e);
        }
      });
      $body.on('click', '.coolBar:not(.loi__banner) [data-db-target-of] a:not([data-slide-target])', function (event) {
        dropBlock.on.hide();
      });
      $body.on('click', '.js--open[data-db-target-for]', function (event) {
        dropBlock.on.hide();
      });
      $window.resize(function () {
        if (dropBlock.$parent != null) {
          dropBlock.find.dimensions();
        }
      });
      $(document).on(dropBlock.vPort + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        isMobile = true;
      });
      $(document).on(dropBlock.vPort + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
        isMobile = false;
      });
    },
    on: {
      show: function show(e) {
        // show  target element
        if (!dropBlock.$controller.closest(".dropBlock__holder").length) {
          if (typeof UX.controller != "undefined") {
            UX.controller.check(e);
          }
        }

        if (dropBlock.$target) {
          dropBlock.$target.addClass("js--open");
          dropBlock.$controller.addClass("js--open");
          dropBlock.$controller.attr("aria-expanded", "true");
          $body.attr('data-active', 'dropBlock');
          dropBlock.$target.closest("[class*='sticko']").addClass("js--open");
          dropBlock.switch.icon();
          dropBlock.$target.find('.active :tabbable').first().focus();
          setTimeout(function () {
            dropBlock.setFocus();
          }, 250);
          $(function () {
            $(document).on('keydown', '.quick-search :tabbable:not([readonly])', function (e) {
              var loop = $(this).closest('.quick-search');
              var firstTabbable = loop.find(':tabbable:not([readonly])').first();
              var lastTabbable = loop.find(':tabbable:not([readonly])').last(); // Leaving the first element with Tab : focus the last one

              if (firstTabbable.is(e.target) && e.shiftKey == true) {
                e.preventDefault();
                lastTabbable.focus();
              } // Leaving the last element with Tab : focus the first one


              if (lastTabbable.is(e.target) && e.shiftKey == false) {
                if (e.which == 13) {
                  dropBlock.on.hide();
                }

                e.preventDefault();
                firstTabbable.focus();
              }
            });
          });
          var isLoi = dropBlock.$target.find('.loi').length > 0;

          if (isLoi) {
            dropBlock.$target.find('.loi__list').each(function () {
              UX.loi.on.recalculate($(this));
            });
          }
        }
      },
      hide: function hide(e) {
        // hide target element
        if (dropBlock.$targets) {
          var resetComponent = true;
          dropBlock.$controller.attr("aria-expanded", "false");
          dropBlock.$targets.each(function () {
            var targetId = $(this).attr("data-db-target-of"); // get this dropblock holder controller

            var thisClicked = e && $(this).is($(e.target).closest('.accordion-tabbed__content'));

            if (!(dropBlock.$controller.closest($(this)).length > 0) && $(this).hasClass("js--open")) {
              //check if this is not nested drop-block
              if (!e || !thisClicked) {
                $(this).removeClass("js--open"); // close this dropblock holder

                $('[data-db-target-for=' + targetId + ']').removeClass("js--open"); // remove class from this holder
              } else {
                resetComponent = false;
              }
            } else {
              return;
            }
          });

          if (resetComponent) {
            dropBlock.$controllers = $("[data-db-target-for]"); //dropBlock.$controllers.removeClass("js--open");

            if ($body.attr('data-active') == "dropBlock") {
              $body.removeAttr('data-active');
              $('body, html').removeClass('lock-screen');
            }

            dropBlock.$target.closest("[class*='sticko']").removeClass("js--open");
            dropBlock.switch.back();
          }

          if (dropBlock.$target) {
            dropBlock.$target.find('input:focus').blur();
          }
        }
      },
      escape: function escape() {
        // hide target if user clicks escape key
        if (dropBlock.$target != null) {
          dropBlock.on.hide();
        }
      }
    },
    setFocus: function setFocus() {
      var $activePane = $(".header__quick-menu [class*=quick-search-pane]").filter('.active');

      if ($activePane.length) {
        $activePane.find(".ui-autocomplete-input").focus();
      }
    },
    find: {
      target: function target(e) {
        // get the target element if existed
        if ($("[data-db-target-of]").length) {
          dropBlock.$targets = $("[data-db-target-of]");
          dropBlock.$target = $("[data-db-target-of=" + dropBlock.$controller.attr("data-db-target-for") + "]"); //dropBlock.$section = dropBlock.$target;

          dropBlock.find.parent();
          dropBlock.on.show(e);
        }
      },
      parent: function parent() {
        // get the parent element if existed
        dropBlock.$parent = null;

        if ($("[data-db-parent-of]").length) {
          dropBlock.$parents = $("[data-db-parent-of]");

          if ($("[data-db-parent-of=" + dropBlock.$controller.attr("data-db-target-for") + "]").length) {
            dropBlock.$parent = $("[data-db-parent-of=" + dropBlock.$controller.attr("data-db-target-for") + "]");
          }

          if (dropBlock.$parent != null) {
            dropBlock.find.dimensions();
            dropBlock.find.ifContaind();
          }
        }
      },
      ifContaind: function ifContaind() {
        // check if it parent or target has container element
        if (dropBlock.$parent.find(".container").length && !dropBlock.$target.find(".container").length) {
          dropBlock.$target.wrapInner("<div class='container'></div>");
        }
      },
      dimensions: function dimensions() {
        // count the top and left position of the target element based on teh parent element
        var nHeight = dropBlock.$parent.outerHeight(),
            pOffset = dropBlock.$parent.offset(),
            pLeft = pOffset.left,
            nWidth = dropBlock.$parent.innerWidth(),
            styles = {};
        dropBlock.$container = $(".container");
        var container_offset = pOffset;

        if (dropBlock.$container.length) {
          container_offset = dropBlock.$container.offset();
        }

        var container_left = container_offset.left;
        var conteiner_base = container_left + dropBlock.$container.width();
        var parent_base = nWidth + pLeft;

        if (dropBlock.$parent.find(".scrollThenFix").length) {
          nHeight = dropBlock.$parent.find(".scrollThenFix").outerHeight();
        }

        if (dropBlock.$parent.innerWidth() == dropBlock.$controller.innerWidth()) {
          nWidth = "auto";

          if (isMobile) {
            nWidth = "100%";
          }
        }

        if (parent_base > conteiner_base) {
          styles = {
            top: nHeight,
            right: "0px",
            width: nWidth
          };
        } else {
          styles = {
            top: nHeight,
            left: "0px",
            width: nWidth
          };
        }

        dropBlock.$target.css(styles);
      }
    },
    switch: {
      icon: function icon() {
        dropBlock.switchVal = dropBlock.$controller.attr("data-db-switch");

        switch (dropBlock.switchVal) {
          case "none":
            break;

          case "rotate":
            dropBlock.$controller.find("i").addClass("js--rotated");
            break;

          default:
            dropBlock.$controller.find("i").addClass(dropBlock.switchVal);
        }
      },
      back: function back() {
        dropBlock.$controllers.each(function () {
          var temp = $(this).attr("data-db-switch");

          switch (temp) {
            case "none":
              break;

            case "rotate":
              $(this).find("i").removeClass("js--rotated");
              break;

            default:
              $(this).find("i").removeClass(temp);
          }
        });
      }
    }
  };
  UX.dropBlock = dropBlock; // add to global namespace
})();

(function () {
  var appliedFacets = {
    url: location.href,
    init: function init() {
      appliedFacets.remove.all();
      appliedFacets.setUrl.clearAll();
    },
    remove: {
      one: function one(key) {
        var baseUrl = appliedFacets.url.split('?')[0];
        var queryString = appliedFacets.url.indexOf('?') !== -1 ? appliedFacets.url.split('?')[1] : '';
        var queryStringObj = {};

        if (queryString) {
          queryString.split('&').map(function (value) {
            var keyVal = value.split('=');
            queryStringObj[keyVal[0]] = keyVal[1];
          });

          if (queryStringObj[key]) {
            delete queryStringObj[key];
          }

          queryString = Object.keys(queryStringObj).map(function (value) {
            return value + '=' + queryStringObj[value];
          }).join('&');
          appliedFacets.url = baseUrl + '?' + queryString;
        }
      },
      all: function all() {
        appliedFacets.remove.one('Year'); // reset year facet filters

        appliedFacets.remove.one('ContribStored'); // reset contribs filters

        appliedFacets.remove.one('ContribAuthorStored'); // reset contribs filters

        appliedFacets.remove.one('SeriesKey'); // reset series filters

        appliedFacets.remove.one('ContentItemType'); // reset extra filters

        appliedFacets.remove.one('KeywordStored'); // reset keywords filters

        appliedFacets.remove.one('alphabetRange'); // reset keywords filters

        appliedFacets.remove.one('PubType'); // reset Publication filters

        appliedFacets.remove.one('Ppub'); // reset Publication filters

        appliedFacets.remove.one('ConceptID'); // reset Publication filters

        appliedFacets.remove.one('publication%5B%5D'); // reset Publication filters

        appliedFacets.remove.one('publication'); // reset Publication filters

        appliedFacets.remove.one('AfterMonth'); // reset Publication filters

        appliedFacets.remove.one('AfterYear'); // reset Publication filters

        appliedFacets.remove.one('BeforeMonth'); // reset Publication filters

        appliedFacets.remove.one('BeforeYear'); // reset Publication filters
      }
    },
    setUrl: {
      // set url to clear all filters
      clearAll: function clearAll() {
        $('.search__filters__ctrl__reset').attr('href', appliedFacets.url);
      }
    }
  };
  UX.appliedFacets = appliedFacets; // add to global namespace
})();

/* ========================================================================
 * Bootstrap: modal.js v3.3.7
 * http://getbootstrap.com/javascript/#modals
 * ========================================================================
 * Copyright 2011-2016 Twitter, Inc.
 * Licensed under MIT (https://github.com/twbs/bootstrap/blob/master/LICENSE)
 * ======================================================================== */
+function ($) {
  'use strict'; // MODAL CLASS DEFINITION
  // ======================

  var Modal = function Modal(element, options) {
    this.options = options;
    this.$body = $(document.body);
    this.$element = $(element);
    this.$dialog = this.$element.find('.modal-dialog');
    this.$backdrop = null;
    this.isShown = null;
    this.originalBodyPad = null;
    this.scrollbarWidth = 0;
    this.ignoreBackdropClick = false;

    if (this.options.remote) {
      this.$element.find('.modal-content').load(this.options.remote, $.proxy(function () {
        this.$element.trigger('loaded.bs.modal');
      }, this));
    }
  };

  Modal.VERSION = '3.3.7';
  Modal.TRANSITION_DURATION = 300;
  Modal.BACKDROP_TRANSITION_DURATION = 150;
  Modal.DEFAULTS = {
    backdrop: true,
    keyboard: true,
    show: true
  };

  Modal.prototype.toggle = function (_relatedTarget) {
    return this.isShown ? this.hide() : this.show(_relatedTarget);
  };

  Modal.prototype.show = function (_relatedTarget) {
    var that = this;
    var e = $.Event('show.bs.modal', {
      relatedTarget: _relatedTarget
    });
    this.$element.trigger(e);
    if (this.isShown || e.isDefaultPrevented()) return;
    this.isShown = true;
    this.checkScrollbar();
    this.setScrollbar();
    this.$body.addClass('modal-open');
    this.escape();
    this.resize();
    this.$element.on('click.dismiss.bs.modal', '[data-dismiss="modal"]', $.proxy(this.hide, this));
    this.$dialog.on('mousedown.dismiss.bs.modal', function () {
      that.$element.one('mouseup.dismiss.bs.modal', function (e) {
        if ($(e.target).is(that.$element)) that.ignoreBackdropClick = true;
      });
    });
    this.backdrop(function () {
      var transition = $.support.transition && that.$element.hasClass('fade');

      if (!that.$element.parent().length) {
        that.$element.appendTo(that.$body); // don't move modals dom position
      }

      that.$element.show().scrollTop(0);
      that.adjustDialog();

      if (transition) {
        that.$element[0].offsetWidth; // force reflow
      }

      that.$element.addClass('in');
      that.enforceFocus();
      var e = $.Event('shown.bs.modal', {
        relatedTarget: _relatedTarget
      });
      transition ? that.$dialog // wait for modal to slide in
      .one('bsTransitionEnd', function () {
        that.$element.trigger('focus').trigger(e);
      }).emulateTransitionEnd(Modal.TRANSITION_DURATION) : that.$element.trigger('focus').trigger(e);
    });
  };

  Modal.prototype.hide = function (e) {
    if (e) e.preventDefault();
    e = $.Event('hide.bs.modal');
    this.$element.trigger(e);
    if (!this.isShown || e.isDefaultPrevented()) return;
    this.isShown = false;
    this.escape();
    this.resize();
    $(document).off('focusin.bs.modal');
    this.$element.removeClass('in').off('click.dismiss.bs.modal').off('mouseup.dismiss.bs.modal');
    this.$dialog.off('mousedown.dismiss.bs.modal');
    $.support.transition && this.$element.hasClass('fade') ? this.$element.one('bsTransitionEnd', $.proxy(this.hideModal, this)).emulateTransitionEnd(Modal.TRANSITION_DURATION) : this.hideModal();
  };

  Modal.prototype.enforceFocus = function () {
    $(document).off('focusin.bs.modal') // guard against infinite focus loop
    .on('focusin.bs.modal', $.proxy(function (e) {
      if (document !== e.target && this.$element[0] !== e.target && !this.$element.has(e.target).length) {
        this.$element.trigger('focus');
      }
    }, this));
  };

  Modal.prototype.escape = function () {
    if (this.isShown && this.options.keyboard) {
      this.$element.on('keydown.dismiss.bs.modal', $.proxy(function (e) {
        e.which == 27 && this.hide();
      }, this));
    } else if (!this.isShown) {
      this.$element.off('keydown.dismiss.bs.modal');
    }
  };

  Modal.prototype.resize = function () {
    if (this.isShown) {
      $(window).on('resize.bs.modal', $.proxy(this.handleUpdate, this));
    } else {
      $(window).off('resize.bs.modal');
    }
  };

  Modal.prototype.hideModal = function () {
    var that = this;
    this.$element.hide();
    this.backdrop(function () {
      that.$body.removeClass('modal-open');
      that.resetAdjustments();
      that.resetScrollbar();
      that.$element.trigger('hidden.bs.modal');
    });
  };

  Modal.prototype.removeBackdrop = function () {
    this.$backdrop && this.$backdrop.remove();
    this.$backdrop = null;
  };

  Modal.prototype.backdrop = function (callback) {
    var that = this;
    var animate = this.$element.hasClass('fade') ? 'fade' : '';

    if (this.isShown && this.options.backdrop) {
      var doAnimate = $.support.transition && animate;
      this.$backdrop = $(document.createElement('div')).addClass('modal-backdrop ' + animate).insertAfter(this.$element);
      this.$element.on('click.dismiss.bs.modal', $.proxy(function (e) {
        if (this.ignoreBackdropClick) {
          this.ignoreBackdropClick = false;
          return;
        }

        if (e.target !== e.currentTarget) return;
        this.options.backdrop == 'static' ? this.$element[0].focus() : this.hide();
      }, this));
      if (doAnimate) this.$backdrop[0].offsetWidth; // force reflow

      this.$backdrop.addClass('in');
      if (!callback) return;
      doAnimate ? this.$backdrop.one('bsTransitionEnd', callback).emulateTransitionEnd(Modal.BACKDROP_TRANSITION_DURATION) : callback();
    } else if (!this.isShown && this.$backdrop) {
      this.$backdrop.removeClass('in');

      var callbackRemove = function callbackRemove() {
        that.removeBackdrop();
        callback && callback();
      };

      $.support.transition && this.$element.hasClass('fade') ? this.$backdrop.one('bsTransitionEnd', callbackRemove).emulateTransitionEnd(Modal.BACKDROP_TRANSITION_DURATION) : callbackRemove();
    } else if (callback) {
      callback();
    }
  }; // these following methods are used to handle overflowing modals


  Modal.prototype.handleUpdate = function () {
    this.adjustDialog();
  };

  Modal.prototype.adjustDialog = function () {
    var modalIsOverflowing = this.$element[0].scrollHeight > document.documentElement.clientHeight;
    this.$element.css({
      paddingLeft: !this.bodyIsOverflowing && modalIsOverflowing ? this.scrollbarWidth : '',
      paddingRight: this.bodyIsOverflowing && !modalIsOverflowing ? this.scrollbarWidth : ''
    });
  };

  Modal.prototype.resetAdjustments = function () {
    this.$element.css({
      paddingLeft: '',
      paddingRight: ''
    });
  };

  Modal.prototype.checkScrollbar = function () {
    var fullWindowWidth = window.innerWidth;

    if (!fullWindowWidth) {
      // workaround for missing window.innerWidth in IE8
      var documentElementRect = document.documentElement.getBoundingClientRect();
      fullWindowWidth = documentElementRect.right - Math.abs(documentElementRect.left);
    }

    this.bodyIsOverflowing = document.body.clientWidth < fullWindowWidth;
    this.scrollbarWidth = this.measureScrollbar();
  };

  Modal.prototype.setScrollbar = function () {
    var bodyPad = parseInt(this.$body.css('padding-right') || 0, 10);
    this.originalBodyPad = document.body.style.paddingRight || '';
    if (this.bodyIsOverflowing) this.$body.css('padding-right', bodyPad + this.scrollbarWidth);
  };

  Modal.prototype.resetScrollbar = function () {
    this.$body.css('padding-right', this.originalBodyPad);
  };

  Modal.prototype.measureScrollbar = function () {
    // thx walsh
    var scrollDiv = document.createElement('div');
    scrollDiv.className = 'modal-scrollbar-measure';
    this.$body.append(scrollDiv);
    var scrollbarWidth = scrollDiv.offsetWidth - scrollDiv.clientWidth;
    this.$body[0].removeChild(scrollDiv);
    return scrollbarWidth;
  }; // MODAL PLUGIN DEFINITION
  // =======================


  function Plugin(option, _relatedTarget) {
    return this.each(function () {
      var $this = $(this);
      var data = $this.data('bs.modal');
      var options = $.extend({}, Modal.DEFAULTS, $this.data(), _typeof(option) == 'object' && option);
      if (!data) $this.data('bs.modal', data = new Modal(this, options));
      if (typeof option == 'string') data[option](_relatedTarget);else if (options.show) data.show(_relatedTarget);
    });
  }

  var old = $.fn.modal;
  $.fn.modal = Plugin;
  $.fn.modal.Constructor = Modal; // MODAL NO CONFLICT
  // =================

  $.fn.modal.noConflict = function () {
    $.fn.modal = old;
    return this;
  }; // MODAL DATA-API
  // ==============


  $(document).on('click.bs.modal.data-api', '[data-toggle="modal"]', function (e) {
    var $this = $(this);
    var href = $this.attr('href');
    var $target = $($this.attr('data-target') || href && href.replace(/.*(?=#[^\s]+$)/, '')); // strip for ie7

    var option = $target.data('bs.modal') ? 'toggle' : $.extend({
      remote: !/#/.test(href) && href
    }, $target.data(), $this.data());
    if ($this.is('a')) e.preventDefault();
    $target.one('show.bs.modal', function (showEvent) {
      if (showEvent.isDefaultPrevented()) return; // only register focus restorer if modal will actually get shown

      $target.one('hidden.bs.modal', function () {
        $this.is(':visible') && $this.trigger('focus');
      });
    });
    Plugin.call($target, option, this);
  });
}(jQuery);

(function () {
  var $body = $('body'),
      $window = $(window),
      tabKey = 9,
      shift = 16;
  var modal = {
    $toggle: $('[data-toggle="modal"]'),
    $target: null,
    revers: false,
    lastItem: null,
    items: null,
    $close: null,
    init: function init() {
      modal.$target = $(modal.$toggle.data('target'));
      modal.control();
    },
    control: function control() {
      $body.on('click', '[data-toggle="modal"]', function (e) {
        e.preventDefault();
        modal.$toggle = $(this);
        modal.$target = $(modal.$toggle.data('target'));
        modal.$close = modal.$target.find('.close');
        modal.items = modal.$target.find('a, button, input');
        modal.items.each(function (index) {
          if (index === modal.items.length - 1) {
            modal.lastItem = $(this);
          }
        });
        modal.on.show();
      });
      $body.on('click', '.modal', function (e) {
        var target = $(e.target);

        if (!target.is('.modal__dialog') && !target.closest('.modal__dialog').length > 0) {
          //e.preventDefault();
          modal.on.hide();
        }
      });
      $body.on('click', '[data-dismiss="modal"]', function (e) {
        modal.on.hide();
      });
      $('.modal').on('keydown', function (e) {
        if (e.keyCode === shift) {
          modal.revers = true;
        }

        if ((e.keyCode || e.which) === tabKey) {
          if (!modal.revers) {
            modal.on.tab();
          } else {
            modal.on.tabRevers();
          }
        }
      });
      $window.on('keyup', function (e) {
        if (e.keyCode === shift) {
          modal.revers = false;
        }
      });
    },
    on: {
      show: function show(e) {
        if (typeof UX.controller !== "undefined") {
          UX.controller.check();
        }

        setTimeout(function () {
          $body.attr('data-active', 'modal');
          var $autofocus = modal.$target.find('[autofocus]');
          if ($autofocus.length) $autofocus.focus();else modal.$close.focus();
        }, 250);
        modal.$target.closest("[class*='sticko']").addClass("js--open");
      },
      hide: function hide() {
        $body.removeAttr('data-active');
        modal.$target.closest("[class*='sticko']").removeClass("js--open");
      },
      tab: function tab() {
        modal.$close.off();
        modal.lastItem.on('focusout', function () {
          modal.$close.focus();
        });
      },
      tabRevers: function tabRevers() {
        modal.lastItem.off();
        modal.$close.on('focusout', function () {
          modal.lastItem.focus();
        });
      }
    }
  };
  UX.modal = modal; // add to global namespace
})();

/**
 * Owl Carousel v2.3.4
 * Copyright 2013-2018 David Deutsch
 * Licensed under: SEE LICENSE IN https://github.com/OwlCarousel2/OwlCarousel2/blob/master/LICENSE
 */
!function (a, b, c, d) {
  function e(b, c) {
    this.settings = null, this.options = a.extend({}, e.Defaults, c), this.$element = a(b), this._handlers = {}, this._plugins = {}, this._supress = {}, this._current = null, this._speed = null, this._coordinates = [], this._breakpoint = null, this._width = null, this._items = [], this._clones = [], this._mergers = [], this._widths = [], this._invalidated = {}, this._pipe = [], this._drag = {
      time: null,
      target: null,
      pointer: null,
      stage: {
        start: null,
        current: null
      },
      direction: null
    }, this._states = {
      current: {},
      tags: {
        initializing: ["busy"],
        animating: ["busy"],
        dragging: ["interacting"]
      }
    }, a.each(["onResize", "onThrottledResize"], a.proxy(function (b, c) {
      this._handlers[c] = a.proxy(this[c], this);
    }, this)), a.each(e.Plugins, a.proxy(function (a, b) {
      this._plugins[a.charAt(0).toLowerCase() + a.slice(1)] = new b(this);
    }, this)), a.each(e.Workers, a.proxy(function (b, c) {
      this._pipe.push({
        filter: c.filter,
        run: a.proxy(c.run, this)
      });
    }, this)), this.setup(), this.initialize();
  }

  e.Defaults = {
    items: 3,
    loop: !1,
    center: !1,
    rewind: !1,
    checkVisibility: !0,
    mouseDrag: !0,
    touchDrag: !0,
    pullDrag: !0,
    freeDrag: !1,
    margin: 0,
    stagePadding: 0,
    merge: !1,
    mergeFit: !0,
    autoWidth: !1,
    startPosition: 0,
    rtl: !1,
    smartSpeed: 250,
    fluidSpeed: !1,
    dragEndSpeed: !1,
    responsive: {},
    responsiveRefreshRate: 200,
    responsiveBaseElement: b,
    fallbackEasing: "swing",
    slideTransition: "",
    info: !1,
    nestedItemSelector: !1,
    itemElement: "div",
    stageElement: "div",
    refreshClass: "owl-refresh",
    loadedClass: "owl-loaded",
    loadingClass: "owl-loading",
    rtlClass: "owl-rtl",
    responsiveClass: "owl-responsive",
    dragClass: "owl-drag",
    itemClass: "owl-item",
    stageClass: "owl-stage",
    stageOuterClass: "owl-stage-outer",
    grabClass: "owl-grab"
  }, e.Width = {
    Default: "default",
    Inner: "inner",
    Outer: "outer"
  }, e.Type = {
    Event: "event",
    State: "state"
  }, e.Plugins = {}, e.Workers = [{
    filter: ["width", "settings"],
    run: function run() {
      this._width = this.$element.width();
    }
  }, {
    filter: ["width", "items", "settings"],
    run: function run(a) {
      a.current = this._items && this._items[this.relative(this._current)];
    }
  }, {
    filter: ["items", "settings"],
    run: function run() {
      this.$stage.children(".cloned").remove();
    }
  }, {
    filter: ["width", "items", "settings"],
    run: function run(a) {
      var b = this.settings.margin || "",
          c = !this.settings.autoWidth,
          d = this.settings.rtl,
          e = {
        width: "auto",
        "margin-left": d ? b : "",
        "margin-right": d ? "" : b
      };
      !c && this.$stage.children().css(e), a.css = e;
    }
  }, {
    filter: ["width", "items", "settings"],
    run: function run(a) {
      var b = (this.width() / this.settings.items).toFixed(3) - this.settings.margin,
          c = null,
          d = this._items.length,
          e = !this.settings.autoWidth,
          f = [];

      for (a.items = {
        merge: !1,
        width: b
      }; d--;) {
        c = this._mergers[d], c = this.settings.mergeFit && Math.min(c, this.settings.items) || c, a.items.merge = c > 1 || a.items.merge, f[d] = e ? b * c : this._items[d].width();
      }

      this._widths = f;
    }
  }, {
    filter: ["items", "settings"],
    run: function run() {
      var b = [],
          c = this._items,
          d = this.settings,
          e = Math.max(2 * d.items, 4),
          f = 2 * Math.ceil(c.length / 2),
          g = d.loop && c.length ? d.rewind ? e : Math.max(e, f) : 0,
          h = "",
          i = "";

      for (g /= 2; g > 0;) {
        b.push(this.normalize(b.length / 2, !0)), h += c[b[b.length - 1]][0].outerHTML, b.push(this.normalize(c.length - 1 - (b.length - 1) / 2, !0)), i = c[b[b.length - 1]][0].outerHTML + i, g -= 1;
      }

      this._clones = b, a(h).addClass("cloned").appendTo(this.$stage), a(i).addClass("cloned").prependTo(this.$stage);
    }
  }, {
    filter: ["width", "items", "settings"],
    run: function run() {
      for (var a = this.settings.rtl ? 1 : -1, b = this._clones.length + this._items.length, c = -1, d = 0, e = 0, f = []; ++c < b;) {
        d = f[c - 1] || 0, e = this._widths[this.relative(c)] + this.settings.margin, f.push(d + e * a);
      }

      this._coordinates = f;
    }
  }, {
    filter: ["width", "items", "settings"],
    run: function run() {
      var a = this.settings.stagePadding,
          b = this._coordinates,
          c = {
        width: Math.ceil(Math.abs(b[b.length - 1])) + 2 * a,
        "padding-left": a || "",
        "padding-right": a || ""
      };
      this.$stage.css(c);
    }
  }, {
    filter: ["width", "items", "settings"],
    run: function run(a) {
      var b = this._coordinates.length,
          c = !this.settings.autoWidth,
          d = this.$stage.children();
      if (c && a.items.merge) for (; b--;) {
        a.css.width = this._widths[this.relative(b)], d.eq(b).css(a.css);
      } else c && (a.css.width = a.items.width, d.css(a.css));
    }
  }, {
    filter: ["items"],
    run: function run() {
      this._coordinates.length < 1 && this.$stage.removeAttr("style");
    }
  }, {
    filter: ["width", "items", "settings"],
    run: function run(a) {
      a.current = a.current ? this.$stage.children().index(a.current) : 0, a.current = Math.max(this.minimum(), Math.min(this.maximum(), a.current)), this.reset(a.current);
    }
  }, {
    filter: ["position"],
    run: function run() {
      this.animate(this.coordinates(this._current));
    }
  }, {
    filter: ["width", "position", "items", "settings"],
    run: function run() {
      var a,
          b,
          c,
          d,
          e = this.settings.rtl ? 1 : -1,
          f = 2 * this.settings.stagePadding,
          g = this.coordinates(this.current()) + f,
          h = g + this.width() * e,
          i = [];

      for (c = 0, d = this._coordinates.length; c < d; c++) {
        a = this._coordinates[c - 1] || 0, b = Math.abs(this._coordinates[c]) + f * e, (this.op(a, "<=", g) && this.op(a, ">", h) || this.op(b, "<", g) && this.op(b, ">", h)) && i.push(c);
      }

      this.$stage.children(".active").removeClass("active"), this.$stage.children(":eq(" + i.join("), :eq(") + ")").addClass("active"), this.$stage.children(".center").removeClass("center"), this.settings.center && this.$stage.children().eq(this.current()).addClass("center");
    }
  }], e.prototype.initializeStage = function () {
    this.$stage = this.$element.find("." + this.settings.stageClass), this.$stage.length || (this.$element.addClass(this.options.loadingClass), this.$stage = a("<" + this.settings.stageElement + ">", {
      class: this.settings.stageClass
    }).wrap(a("<div/>", {
      class: this.settings.stageOuterClass
    })), this.$element.append(this.$stage.parent()));
  }, e.prototype.initializeItems = function () {
    var b = this.$element.find(".owl-item");
    if (b.length) return this._items = b.get().map(function (b) {
      return a(b);
    }), this._mergers = this._items.map(function () {
      return 1;
    }), void this.refresh();
    this.replace(this.$element.children().not(this.$stage.parent())), this.isVisible() ? this.refresh() : this.invalidate("width"), this.$element.removeClass(this.options.loadingClass).addClass(this.options.loadedClass);
  }, e.prototype.initialize = function () {
    if (this.enter("initializing"), this.trigger("initialize"), this.$element.toggleClass(this.settings.rtlClass, this.settings.rtl), this.settings.autoWidth && !this.is("pre-loading")) {
      var a, b, c;
      a = this.$element.find("img"), b = this.settings.nestedItemSelector ? "." + this.settings.nestedItemSelector : d, c = this.$element.children(b).width(), a.length && c <= 0 && this.preloadAutoWidthImages(a);
    }

    this.initializeStage(), this.initializeItems(), this.registerEventHandlers(), this.leave("initializing"), this.trigger("initialized");
  }, e.prototype.isVisible = function () {
    return !this.settings.checkVisibility || this.$element.is(":visible");
  }, e.prototype.setup = function () {
    var b = this.viewport(),
        c = this.options.responsive,
        d = -1,
        e = null;
    c ? (a.each(c, function (a) {
      a <= b && a > d && (d = Number(a));
    }), e = a.extend({}, this.options, c[d]), "function" == typeof e.stagePadding && (e.stagePadding = e.stagePadding()), delete e.responsive, e.responsiveClass && this.$element.attr("class", this.$element.attr("class").replace(new RegExp("(" + this.options.responsiveClass + "-)\\S+\\s", "g"), "$1" + d))) : e = a.extend({}, this.options), this.trigger("change", {
      property: {
        name: "settings",
        value: e
      }
    }), this._breakpoint = d, this.settings = e, this.invalidate("settings"), this.trigger("changed", {
      property: {
        name: "settings",
        value: this.settings
      }
    });
  }, e.prototype.optionsLogic = function () {
    this.settings.autoWidth && (this.settings.stagePadding = !1, this.settings.merge = !1);
  }, e.prototype.prepare = function (b) {
    var c = this.trigger("prepare", {
      content: b
    });
    return c.data || (c.data = a("<" + this.settings.itemElement + "/>").addClass(this.options.itemClass).append(b)), this.trigger("prepared", {
      content: c.data
    }), c.data;
  }, e.prototype.update = function () {
    for (var b = 0, c = this._pipe.length, d = a.proxy(function (a) {
      return this[a];
    }, this._invalidated), e = {}; b < c;) {
      (this._invalidated.all || a.grep(this._pipe[b].filter, d).length > 0) && this._pipe[b].run(e), b++;
    }

    this._invalidated = {}, !this.is("valid") && this.enter("valid");
  }, e.prototype.width = function (a) {
    switch (a = a || e.Width.Default) {
      case e.Width.Inner:
      case e.Width.Outer:
        return this._width;

      default:
        return this._width - 2 * this.settings.stagePadding + this.settings.margin;
    }
  }, e.prototype.refresh = function () {
    this.enter("refreshing"), this.trigger("refresh"), this.setup(), this.optionsLogic(), this.$element.addClass(this.options.refreshClass), this.update(), this.$element.removeClass(this.options.refreshClass), this.leave("refreshing"), this.trigger("refreshed");
  }, e.prototype.onThrottledResize = function () {
    b.clearTimeout(this.resizeTimer), this.resizeTimer = b.setTimeout(this._handlers.onResize, this.settings.responsiveRefreshRate);
  }, e.prototype.onResize = function () {
    return !!this._items.length && this._width !== this.$element.width() && !!this.isVisible() && (this.enter("resizing"), this.trigger("resize").isDefaultPrevented() ? (this.leave("resizing"), !1) : (this.invalidate("width"), this.refresh(), this.leave("resizing"), void this.trigger("resized")));
  }, e.prototype.registerEventHandlers = function () {
    a.support.transition && this.$stage.on(a.support.transition.end + ".owl.core", a.proxy(this.onTransitionEnd, this)), !1 !== this.settings.responsive && this.on(b, "resize", this._handlers.onThrottledResize), this.settings.mouseDrag && (this.$element.addClass(this.options.dragClass), this.$stage.on("mousedown.owl.core", a.proxy(this.onDragStart, this)), this.$stage.on("dragstart.owl.core selectstart.owl.core", function () {
      return !1;
    })), this.settings.touchDrag && (this.$stage.on("touchstart.owl.core", a.proxy(this.onDragStart, this)), this.$stage.on("touchcancel.owl.core", a.proxy(this.onDragEnd, this)));
  }, e.prototype.onDragStart = function (b) {
    var d = null;
    3 !== b.which && (a.support.transform ? (d = this.$stage.css("transform").replace(/.*\(|\)| /g, "").split(","), d = {
      x: d[16 === d.length ? 12 : 4],
      y: d[16 === d.length ? 13 : 5]
    }) : (d = this.$stage.position(), d = {
      x: this.settings.rtl ? d.left + this.$stage.width() - this.width() + this.settings.margin : d.left,
      y: d.top
    }), this.is("animating") && (a.support.transform ? this.animate(d.x) : this.$stage.stop(), this.invalidate("position")), this.$element.toggleClass(this.options.grabClass, "mousedown" === b.type), this.speed(0), this._drag.time = new Date().getTime(), this._drag.target = a(b.target), this._drag.stage.start = d, this._drag.stage.current = d, this._drag.pointer = this.pointer(b), a(c).on("mouseup.owl.core touchend.owl.core", a.proxy(this.onDragEnd, this)), a(c).one("mousemove.owl.core touchmove.owl.core", a.proxy(function (b) {
      var d = this.difference(this._drag.pointer, this.pointer(b));
      a(c).on("mousemove.owl.core touchmove.owl.core", a.proxy(this.onDragMove, this)), Math.abs(d.x) < Math.abs(d.y) && this.is("valid") || (b.preventDefault(), this.enter("dragging"), this.trigger("drag"));
    }, this)));
  }, e.prototype.onDragMove = function (a) {
    var b = null,
        c = null,
        d = null,
        e = this.difference(this._drag.pointer, this.pointer(a)),
        f = this.difference(this._drag.stage.start, e);
    this.is("dragging") && (a.preventDefault(), this.settings.loop ? (b = this.coordinates(this.minimum()), c = this.coordinates(this.maximum() + 1) - b, f.x = ((f.x - b) % c + c) % c + b) : (b = this.settings.rtl ? this.coordinates(this.maximum()) : this.coordinates(this.minimum()), c = this.settings.rtl ? this.coordinates(this.minimum()) : this.coordinates(this.maximum()), d = this.settings.pullDrag ? -1 * e.x / 5 : 0, f.x = Math.max(Math.min(f.x, b + d), c + d)), this._drag.stage.current = f, this.animate(f.x));
  }, e.prototype.onDragEnd = function (b) {
    var d = this.difference(this._drag.pointer, this.pointer(b)),
        e = this._drag.stage.current,
        f = d.x > 0 ^ this.settings.rtl ? "left" : "right";
    a(c).off(".owl.core"), this.$element.removeClass(this.options.grabClass), (0 !== d.x && this.is("dragging") || !this.is("valid")) && (this.speed(this.settings.dragEndSpeed || this.settings.smartSpeed), this.current(this.closest(e.x, 0 !== d.x ? f : this._drag.direction)), this.invalidate("position"), this.update(), this._drag.direction = f, (Math.abs(d.x) > 3 || new Date().getTime() - this._drag.time > 300) && this._drag.target.one("click.owl.core", function () {
      return !1;
    })), this.is("dragging") && (this.leave("dragging"), this.trigger("dragged"));
  }, e.prototype.closest = function (b, c) {
    var e = -1,
        f = 30,
        g = this.width(),
        h = this.coordinates();
    return this.settings.freeDrag || a.each(h, a.proxy(function (a, i) {
      return "left" === c && b > i - f && b < i + f ? e = a : "right" === c && b > i - g - f && b < i - g + f ? e = a + 1 : this.op(b, "<", i) && this.op(b, ">", h[a + 1] !== d ? h[a + 1] : i - g) && (e = "left" === c ? a + 1 : a), -1 === e;
    }, this)), this.settings.loop || (this.op(b, ">", h[this.minimum()]) ? e = b = this.minimum() : this.op(b, "<", h[this.maximum()]) && (e = b = this.maximum())), e;
  }, e.prototype.animate = function (b) {
    var c = this.speed() > 0;
    this.is("animating") && this.onTransitionEnd(), c && (this.enter("animating"), this.trigger("translate")), a.support.transform3d && a.support.transition ? this.$stage.css({
      transform: "translate3d(" + b + "px,0px,0px)",
      transition: this.speed() / 1e3 + "s" + (this.settings.slideTransition ? " " + this.settings.slideTransition : "")
    }) : c ? this.$stage.animate({
      left: b + "px"
    }, this.speed(), this.settings.fallbackEasing, a.proxy(this.onTransitionEnd, this)) : this.$stage.css({
      left: b + "px"
    });
  }, e.prototype.is = function (a) {
    return this._states.current[a] && this._states.current[a] > 0;
  }, e.prototype.current = function (a) {
    if (a === d) return this._current;
    if (0 === this._items.length) return d;

    if (a = this.normalize(a), this._current !== a) {
      var b = this.trigger("change", {
        property: {
          name: "position",
          value: a
        }
      });
      b.data !== d && (a = this.normalize(b.data)), this._current = a, this.invalidate("position"), this.trigger("changed", {
        property: {
          name: "position",
          value: this._current
        }
      });
    }

    return this._current;
  }, e.prototype.invalidate = function (b) {
    return "string" === a.type(b) && (this._invalidated[b] = !0, this.is("valid") && this.leave("valid")), a.map(this._invalidated, function (a, b) {
      return b;
    });
  }, e.prototype.reset = function (a) {
    (a = this.normalize(a)) !== d && (this._speed = 0, this._current = a, this.suppress(["translate", "translated"]), this.animate(this.coordinates(a)), this.release(["translate", "translated"]));
  }, e.prototype.normalize = function (a, b) {
    var c = this._items.length,
        e = b ? 0 : this._clones.length;
    return !this.isNumeric(a) || c < 1 ? a = d : (a < 0 || a >= c + e) && (a = ((a - e / 2) % c + c) % c + e / 2), a;
  }, e.prototype.relative = function (a) {
    return a -= this._clones.length / 2, this.normalize(a, !0);
  }, e.prototype.maximum = function (a) {
    var b,
        c,
        d,
        e = this.settings,
        f = this._coordinates.length;
    if (e.loop) f = this._clones.length / 2 + this._items.length - 1;else if (e.autoWidth || e.merge) {
      if (b = this._items.length) for (c = this._items[--b].width(), d = this.$element.width(); b-- && !((c += this._items[b].width() + this.settings.margin) > d);) {
        
      }
      f = b + 1;
    } else f = e.center ? this._items.length - 1 : this._items.length - e.items;
    return a && (f -= this._clones.length / 2), Math.max(f, 0);
  }, e.prototype.minimum = function (a) {
    return a ? 0 : this._clones.length / 2;
  }, e.prototype.items = function (a) {
    return a === d ? this._items.slice() : (a = this.normalize(a, !0), this._items[a]);
  }, e.prototype.mergers = function (a) {
    return a === d ? this._mergers.slice() : (a = this.normalize(a, !0), this._mergers[a]);
  }, e.prototype.clones = function (b) {
    var c = this._clones.length / 2,
        e = c + this._items.length,
        f = function f(a) {
      return a % 2 == 0 ? e + a / 2 : c - (a + 1) / 2;
    };

    return b === d ? a.map(this._clones, function (a, b) {
      return f(b);
    }) : a.map(this._clones, function (a, c) {
      return a === b ? f(c) : null;
    });
  }, e.prototype.speed = function (a) {
    return a !== d && (this._speed = a), this._speed;
  }, e.prototype.coordinates = function (b) {
    var c,
        e = 1,
        f = b - 1;
    return b === d ? a.map(this._coordinates, a.proxy(function (a, b) {
      return this.coordinates(b);
    }, this)) : (this.settings.center ? (this.settings.rtl && (e = -1, f = b + 1), c = this._coordinates[b], c += (this.width() - c + (this._coordinates[f] || 0)) / 2 * e) : c = this._coordinates[f] || 0, c = Math.ceil(c));
  }, e.prototype.duration = function (a, b, c) {
    return 0 === c ? 0 : Math.min(Math.max(Math.abs(b - a), 1), 6) * Math.abs(c || this.settings.smartSpeed);
  }, e.prototype.to = function (a, b) {
    var c = this.current(),
        d = null,
        e = a - this.relative(c),
        f = (e > 0) - (e < 0),
        g = this._items.length,
        h = this.minimum(),
        i = this.maximum();
    this.settings.loop ? (!this.settings.rewind && Math.abs(e) > g / 2 && (e += -1 * f * g), a = c + e, (d = ((a - h) % g + g) % g + h) !== a && d - e <= i && d - e > 0 && (c = d - e, a = d, this.reset(c))) : this.settings.rewind ? (i += 1, a = (a % i + i) % i) : a = Math.max(h, Math.min(i, a)), this.speed(this.duration(c, a, b)), this.current(a), this.isVisible() && this.update();
  }, e.prototype.next = function (a) {
    a = a || !1, this.to(this.relative(this.current()) + 1, a);
  }, e.prototype.prev = function (a) {
    a = a || !1, this.to(this.relative(this.current()) - 1, a);
  }, e.prototype.onTransitionEnd = function (a) {
    if (a !== d && (a.stopPropagation(), (a.target || a.srcElement || a.originalTarget) !== this.$stage.get(0))) return !1;
    this.leave("animating"), this.trigger("translated");
  }, e.prototype.viewport = function () {
    var d;
    return this.options.responsiveBaseElement !== b ? d = a(this.options.responsiveBaseElement).width() : b.innerWidth ? d = b.innerWidth : c.documentElement && c.documentElement.clientWidth ? d = c.documentElement.clientWidth : console.warn("Can not detect viewport width."), d;
  }, e.prototype.replace = function (b) {
    this.$stage.empty(), this._items = [], b && (b = b instanceof jQuery ? b : a(b)), this.settings.nestedItemSelector && (b = b.find("." + this.settings.nestedItemSelector)), b.filter(function () {
      return 1 === this.nodeType;
    }).each(a.proxy(function (a, b) {
      b = this.prepare(b), this.$stage.append(b), this._items.push(b), this._mergers.push(1 * b.find("[data-merge]").addBack("[data-merge]").attr("data-merge") || 1);
    }, this)), this.reset(this.isNumeric(this.settings.startPosition) ? this.settings.startPosition : 0), this.invalidate("items");
  }, e.prototype.add = function (b, c) {
    var e = this.relative(this._current);
    c = c === d ? this._items.length : this.normalize(c, !0), b = b instanceof jQuery ? b : a(b), this.trigger("add", {
      content: b,
      position: c
    }), b = this.prepare(b), 0 === this._items.length || c === this._items.length ? (0 === this._items.length && this.$stage.append(b), 0 !== this._items.length && this._items[c - 1].after(b), this._items.push(b), this._mergers.push(1 * b.find("[data-merge]").addBack("[data-merge]").attr("data-merge") || 1)) : (this._items[c].before(b), this._items.splice(c, 0, b), this._mergers.splice(c, 0, 1 * b.find("[data-merge]").addBack("[data-merge]").attr("data-merge") || 1)), this._items[e] && this.reset(this._items[e].index()), this.invalidate("items"), this.trigger("added", {
      content: b,
      position: c
    });
  }, e.prototype.remove = function (a) {
    (a = this.normalize(a, !0)) !== d && (this.trigger("remove", {
      content: this._items[a],
      position: a
    }), this._items[a].remove(), this._items.splice(a, 1), this._mergers.splice(a, 1), this.invalidate("items"), this.trigger("removed", {
      content: null,
      position: a
    }));
  }, e.prototype.preloadAutoWidthImages = function (b) {
    b.each(a.proxy(function (b, c) {
      this.enter("pre-loading"), c = a(c), a(new Image()).one("load", a.proxy(function (a) {
        c.attr("src", a.target.src), c.css("opacity", 1), this.leave("pre-loading"), !this.is("pre-loading") && !this.is("initializing") && this.refresh();
      }, this)).attr("src", c.attr("src") || c.attr("data-src") || c.attr("data-src-retina"));
    }, this));
  }, e.prototype.destroy = function () {
    this.$element.off(".owl.core"), this.$stage.off(".owl.core"), a(c).off(".owl.core"), !1 !== this.settings.responsive && (b.clearTimeout(this.resizeTimer), this.off(b, "resize", this._handlers.onThrottledResize));

    for (var d in this._plugins) {
      this._plugins[d].destroy();
    }

    this.$stage.children(".cloned").remove(), this.$stage.unwrap(), this.$stage.children().contents().unwrap(), this.$stage.children().unwrap(), this.$stage.remove(), this.$element.removeClass(this.options.refreshClass).removeClass(this.options.loadingClass).removeClass(this.options.loadedClass).removeClass(this.options.rtlClass).removeClass(this.options.dragClass).removeClass(this.options.grabClass).attr("class", this.$element.attr("class").replace(new RegExp(this.options.responsiveClass + "-\\S+\\s", "g"), "")).removeData("owl.carousel");
  }, e.prototype.op = function (a, b, c) {
    var d = this.settings.rtl;

    switch (b) {
      case "<":
        return d ? a > c : a < c;

      case ">":
        return d ? a < c : a > c;

      case ">=":
        return d ? a <= c : a >= c;

      case "<=":
        return d ? a >= c : a <= c;
    }
  }, e.prototype.on = function (a, b, c, d) {
    a.addEventListener ? a.addEventListener(b, c, d) : a.attachEvent && a.attachEvent("on" + b, c);
  }, e.prototype.off = function (a, b, c, d) {
    a.removeEventListener ? a.removeEventListener(b, c, d) : a.detachEvent && a.detachEvent("on" + b, c);
  }, e.prototype.trigger = function (b, c, d, f, g) {
    var h = {
      item: {
        count: this._items.length,
        index: this.current()
      }
    },
        i = a.camelCase(a.grep(["on", b, d], function (a) {
      return a;
    }).join("-").toLowerCase()),
        j = a.Event([b, "owl", d || "carousel"].join(".").toLowerCase(), a.extend({
      relatedTarget: this
    }, h, c));
    return this._supress[b] || (a.each(this._plugins, function (a, b) {
      b.onTrigger && b.onTrigger(j);
    }), this.register({
      type: e.Type.Event,
      name: b
    }), this.$element.trigger(j), this.settings && "function" == typeof this.settings[i] && this.settings[i].call(this, j)), j;
  }, e.prototype.enter = function (b) {
    a.each([b].concat(this._states.tags[b] || []), a.proxy(function (a, b) {
      this._states.current[b] === d && (this._states.current[b] = 0), this._states.current[b]++;
    }, this));
  }, e.prototype.leave = function (b) {
    a.each([b].concat(this._states.tags[b] || []), a.proxy(function (a, b) {
      this._states.current[b]--;
    }, this));
  }, e.prototype.register = function (b) {
    if (b.type === e.Type.Event) {
      if (a.event.special[b.name] || (a.event.special[b.name] = {}), !a.event.special[b.name].owl) {
        var c = a.event.special[b.name]._default;
        a.event.special[b.name]._default = function (a) {
          return !c || !c.apply || a.namespace && -1 !== a.namespace.indexOf("owl") ? a.namespace && a.namespace.indexOf("owl") > -1 : c.apply(this, arguments);
        }, a.event.special[b.name].owl = !0;
      }
    } else b.type === e.Type.State && (this._states.tags[b.name] ? this._states.tags[b.name] = this._states.tags[b.name].concat(b.tags) : this._states.tags[b.name] = b.tags, this._states.tags[b.name] = a.grep(this._states.tags[b.name], a.proxy(function (c, d) {
      return a.inArray(c, this._states.tags[b.name]) === d;
    }, this)));
  }, e.prototype.suppress = function (b) {
    a.each(b, a.proxy(function (a, b) {
      this._supress[b] = !0;
    }, this));
  }, e.prototype.release = function (b) {
    a.each(b, a.proxy(function (a, b) {
      delete this._supress[b];
    }, this));
  }, e.prototype.pointer = function (a) {
    var c = {
      x: null,
      y: null
    };
    return a = a.originalEvent || a || b.event, a = a.touches && a.touches.length ? a.touches[0] : a.changedTouches && a.changedTouches.length ? a.changedTouches[0] : a, a.pageX ? (c.x = a.pageX, c.y = a.pageY) : (c.x = a.clientX, c.y = a.clientY), c;
  }, e.prototype.isNumeric = function (a) {
    return !isNaN(parseFloat(a));
  }, e.prototype.difference = function (a, b) {
    return {
      x: a.x - b.x,
      y: a.y - b.y
    };
  }, a.fn.owlCarousel = function (b) {
    var c = Array.prototype.slice.call(arguments, 1);
    return this.each(function () {
      var d = a(this),
          f = d.data("owl.carousel");
      f || (f = new e(this, "object" == _typeof(b) && b), d.data("owl.carousel", f), a.each(["next", "prev", "to", "destroy", "refresh", "replace", "add", "remove"], function (b, c) {
        f.register({
          type: e.Type.Event,
          name: c
        }), f.$element.on(c + ".owl.carousel.core", a.proxy(function (a) {
          a.namespace && a.relatedTarget !== this && (this.suppress([c]), f[c].apply(this, [].slice.call(arguments, 1)), this.release([c]));
        }, f));
      })), "string" == typeof b && "_" !== b.charAt(0) && f[b].apply(f, c);
    });
  }, a.fn.owlCarousel.Constructor = e;
}(window.Zepto || window.jQuery, window, document), function (a, b, c, d) {
  var e = function e(b) {
    this._core = b, this._interval = null, this._visible = null, this._handlers = {
      "initialized.owl.carousel": a.proxy(function (a) {
        a.namespace && this._core.settings.autoRefresh && this.watch();
      }, this)
    }, this._core.options = a.extend({}, e.Defaults, this._core.options), this._core.$element.on(this._handlers);
  };

  e.Defaults = {
    autoRefresh: !0,
    autoRefreshInterval: 500
  }, e.prototype.watch = function () {
    this._interval || (this._visible = this._core.isVisible(), this._interval = b.setInterval(a.proxy(this.refresh, this), this._core.settings.autoRefreshInterval));
  }, e.prototype.refresh = function () {
    this._core.isVisible() !== this._visible && (this._visible = !this._visible, this._core.$element.toggleClass("owl-hidden", !this._visible), this._visible && this._core.invalidate("width") && this._core.refresh());
  }, e.prototype.destroy = function () {
    var a, c;
    b.clearInterval(this._interval);

    for (a in this._handlers) {
      this._core.$element.off(a, this._handlers[a]);
    }

    for (c in Object.getOwnPropertyNames(this)) {
      "function" != typeof this[c] && (this[c] = null);
    }
  }, a.fn.owlCarousel.Constructor.Plugins.AutoRefresh = e;
}(window.Zepto || window.jQuery, window, document), function (a, b, c, d) {
  var e = function e(b) {
    this._core = b, this._loaded = [], this._handlers = {
      "initialized.owl.carousel change.owl.carousel resized.owl.carousel": a.proxy(function (b) {
        if (b.namespace && this._core.settings && this._core.settings.lazyLoad && (b.property && "position" == b.property.name || "initialized" == b.type)) {
          var c = this._core.settings,
              e = c.center && Math.ceil(c.items / 2) || c.items,
              f = c.center && -1 * e || 0,
              g = (b.property && b.property.value !== d ? b.property.value : this._core.current()) + f,
              h = this._core.clones().length,
              i = a.proxy(function (a, b) {
            this.load(b);
          }, this);

          for (c.lazyLoadEager > 0 && (e += c.lazyLoadEager, c.loop && (g -= c.lazyLoadEager, e++)); f++ < e;) {
            this.load(h / 2 + this._core.relative(g)), h && a.each(this._core.clones(this._core.relative(g)), i), g++;
          }
        }
      }, this)
    }, this._core.options = a.extend({}, e.Defaults, this._core.options), this._core.$element.on(this._handlers);
  };

  e.Defaults = {
    lazyLoad: !1,
    lazyLoadEager: 0
  }, e.prototype.load = function (c) {
    var d = this._core.$stage.children().eq(c),
        e = d && d.find(".owl-lazy");

    !e || a.inArray(d.get(0), this._loaded) > -1 || (e.each(a.proxy(function (c, d) {
      var e,
          f = a(d),
          g = b.devicePixelRatio > 1 && f.attr("data-src-retina") || f.attr("data-src") || f.attr("data-srcset");
      this._core.trigger("load", {
        element: f,
        url: g
      }, "lazy"), f.is("img") ? f.one("load.owl.lazy", a.proxy(function () {
        f.css("opacity", 1), this._core.trigger("loaded", {
          element: f,
          url: g
        }, "lazy");
      }, this)).attr("src", g) : f.is("source") ? f.one("load.owl.lazy", a.proxy(function () {
        this._core.trigger("loaded", {
          element: f,
          url: g
        }, "lazy");
      }, this)).attr("srcset", g) : (e = new Image(), e.onload = a.proxy(function () {
        f.css({
          "background-image": 'url("' + g + '")',
          opacity: "1"
        }), this._core.trigger("loaded", {
          element: f,
          url: g
        }, "lazy");
      }, this), e.src = g);
    }, this)), this._loaded.push(d.get(0)));
  }, e.prototype.destroy = function () {
    var a, b;

    for (a in this.handlers) {
      this._core.$element.off(a, this.handlers[a]);
    }

    for (b in Object.getOwnPropertyNames(this)) {
      "function" != typeof this[b] && (this[b] = null);
    }
  }, a.fn.owlCarousel.Constructor.Plugins.Lazy = e;
}(window.Zepto || window.jQuery, window, document), function (a, b, c, d) {
  var e = function e(c) {
    this._core = c, this._previousHeight = null, this._handlers = {
      "initialized.owl.carousel refreshed.owl.carousel": a.proxy(function (a) {
        a.namespace && this._core.settings.autoHeight && this.update();
      }, this),
      "changed.owl.carousel": a.proxy(function (a) {
        a.namespace && this._core.settings.autoHeight && "position" === a.property.name && this.update();
      }, this),
      "loaded.owl.lazy": a.proxy(function (a) {
        a.namespace && this._core.settings.autoHeight && a.element.closest("." + this._core.settings.itemClass).index() === this._core.current() && this.update();
      }, this)
    }, this._core.options = a.extend({}, e.Defaults, this._core.options), this._core.$element.on(this._handlers), this._intervalId = null;
    var d = this;
    a(b).on("load", function () {
      d._core.settings.autoHeight && d.update();
    }), a(b).resize(function () {
      d._core.settings.autoHeight && (null != d._intervalId && clearTimeout(d._intervalId), d._intervalId = setTimeout(function () {
        d.update();
      }, 250));
    });
  };

  e.Defaults = {
    autoHeight: !1,
    autoHeightClass: "owl-height"
  }, e.prototype.update = function () {
    var b = this._core._current,
        c = b + this._core.settings.items,
        d = this._core.settings.lazyLoad,
        e = this._core.$stage.children().toArray().slice(b, c),
        f = [],
        g = 0;

    a.each(e, function (b, c) {
      f.push(a(c).height());
    }), g = Math.max.apply(null, f), g <= 1 && d && this._previousHeight && (g = this._previousHeight), this._previousHeight = g, this._core.$stage.parent().height(g).addClass(this._core.settings.autoHeightClass);
  }, e.prototype.destroy = function () {
    var a, b;

    for (a in this._handlers) {
      this._core.$element.off(a, this._handlers[a]);
    }

    for (b in Object.getOwnPropertyNames(this)) {
      "function" != typeof this[b] && (this[b] = null);
    }
  }, a.fn.owlCarousel.Constructor.Plugins.AutoHeight = e;
}(window.Zepto || window.jQuery, window, document), function (a, b, c, d) {
  var e = function e(b) {
    this._core = b, this._videos = {}, this._playing = null, this._handlers = {
      "initialized.owl.carousel": a.proxy(function (a) {
        a.namespace && this._core.register({
          type: "state",
          name: "playing",
          tags: ["interacting"]
        });
      }, this),
      "resize.owl.carousel": a.proxy(function (a) {
        a.namespace && this._core.settings.video && this.isInFullScreen() && a.preventDefault();
      }, this),
      "refreshed.owl.carousel": a.proxy(function (a) {
        a.namespace && this._core.is("resizing") && this._core.$stage.find(".cloned .owl-video-frame").remove();
      }, this),
      "changed.owl.carousel": a.proxy(function (a) {
        a.namespace && "position" === a.property.name && this._playing && this.stop();
      }, this),
      "prepared.owl.carousel": a.proxy(function (b) {
        if (b.namespace) {
          var c = a(b.content).find(".owl-video");
          c.length && (c.css("display", "none"), this.fetch(c, a(b.content)));
        }
      }, this)
    }, this._core.options = a.extend({}, e.Defaults, this._core.options), this._core.$element.on(this._handlers), this._core.$element.on("click.owl.video", ".owl-video-play-icon", a.proxy(function (a) {
      this.play(a);
    }, this));
  };

  e.Defaults = {
    video: !1,
    videoHeight: !1,
    videoWidth: !1
  }, e.prototype.fetch = function (a, b) {
    var c = function () {
      return a.attr("data-vimeo-id") ? "vimeo" : a.attr("data-vzaar-id") ? "vzaar" : "youtube";
    }(),
        d = a.attr("data-vimeo-id") || a.attr("data-youtube-id") || a.attr("data-vzaar-id"),
        e = a.attr("data-width") || this._core.settings.videoWidth,
        f = a.attr("data-height") || this._core.settings.videoHeight,
        g = a.attr("href");

    if (!g) throw new Error("Missing video URL.");
    if (d = g.match(/(http:|https:|)\/\/(player.|www.|app.)?(vimeo\.com|youtu(be\.com|\.be|be\.googleapis\.com|be\-nocookie\.com)|vzaar\.com)\/(video\/|videos\/|embed\/|channels\/.+\/|groups\/.+\/|watch\?v=|v\/)?([A-Za-z0-9._%-]*)(\&\S+)?/), d[3].indexOf("youtu") > -1) c = "youtube";else if (d[3].indexOf("vimeo") > -1) c = "vimeo";else {
      if (!(d[3].indexOf("vzaar") > -1)) throw new Error("Video URL not supported.");
      c = "vzaar";
    }
    d = d[6], this._videos[g] = {
      type: c,
      id: d,
      width: e,
      height: f
    }, b.attr("data-video", g), this.thumbnail(a, this._videos[g]);
  }, e.prototype.thumbnail = function (b, c) {
    var d,
        e,
        f,
        g = c.width && c.height ? "width:" + c.width + "px;height:" + c.height + "px;" : "",
        h = b.find("img"),
        i = "src",
        j = "",
        k = this._core.settings,
        l = function l(c) {
      e = '<div class="owl-video-play-icon"></div>', d = k.lazyLoad ? a("<div/>", {
        class: "owl-video-tn " + j,
        srcType: c
      }) : a("<div/>", {
        class: "owl-video-tn",
        style: "opacity:1;background-image:url(" + c + ")"
      }), b.after(d), b.after(e);
    };

    if (b.wrap(a("<div/>", {
      class: "owl-video-wrapper",
      style: g
    })), this._core.settings.lazyLoad && (i = "data-src", j = "owl-lazy"), h.length) return l(h.attr(i)), h.remove(), !1;
    "youtube" === c.type ? (f = "//img.youtube.com/vi/" + c.id + "/hqdefault.jpg", l(f)) : "vimeo" === c.type ? a.ajax({
      type: "GET",
      url: "//vimeo.com/api/v2/video/" + c.id + ".json",
      jsonp: "callback",
      dataType: "jsonp",
      success: function success(a) {
        f = a[0].thumbnail_large, l(f);
      }
    }) : "vzaar" === c.type && a.ajax({
      type: "GET",
      url: "//vzaar.com/api/videos/" + c.id + ".json",
      jsonp: "callback",
      dataType: "jsonp",
      success: function success(a) {
        f = a.framegrab_url, l(f);
      }
    });
  }, e.prototype.stop = function () {
    this._core.trigger("stop", null, "video"), this._playing.find(".owl-video-frame").remove(), this._playing.removeClass("owl-video-playing"), this._playing = null, this._core.leave("playing"), this._core.trigger("stopped", null, "video");
  }, e.prototype.play = function (b) {
    var c,
        d = a(b.target),
        e = d.closest("." + this._core.settings.itemClass),
        f = this._videos[e.attr("data-video")],
        g = f.width || "100%",
        h = f.height || this._core.$stage.height();

    this._playing || (this._core.enter("playing"), this._core.trigger("play", null, "video"), e = this._core.items(this._core.relative(e.index())), this._core.reset(e.index()), c = a('<iframe frameborder="0" allowfullscreen mozallowfullscreen webkitAllowFullScreen ></iframe>'), c.attr("height", h), c.attr("width", g), "youtube" === f.type ? c.attr("src", "//www.youtube.com/embed/" + f.id + "?autoplay=1&rel=0&v=" + f.id) : "vimeo" === f.type ? c.attr("src", "//player.vimeo.com/video/" + f.id + "?autoplay=1") : "vzaar" === f.type && c.attr("src", "//view.vzaar.com/" + f.id + "/player?autoplay=true"), a(c).wrap('<div class="owl-video-frame" />').insertAfter(e.find(".owl-video")), this._playing = e.addClass("owl-video-playing"));
  }, e.prototype.isInFullScreen = function () {
    var b = c.fullscreenElement || c.mozFullScreenElement || c.webkitFullscreenElement;
    return b && a(b).parent().hasClass("owl-video-frame");
  }, e.prototype.destroy = function () {
    var a, b;

    this._core.$element.off("click.owl.video");

    for (a in this._handlers) {
      this._core.$element.off(a, this._handlers[a]);
    }

    for (b in Object.getOwnPropertyNames(this)) {
      "function" != typeof this[b] && (this[b] = null);
    }
  }, a.fn.owlCarousel.Constructor.Plugins.Video = e;
}(window.Zepto || window.jQuery, window, document), function (a, b, c, d) {
  var e = function e(b) {
    this.core = b, this.core.options = a.extend({}, e.Defaults, this.core.options), this.swapping = !0, this.previous = d, this.next = d, this.handlers = {
      "change.owl.carousel": a.proxy(function (a) {
        a.namespace && "position" == a.property.name && (this.previous = this.core.current(), this.next = a.property.value);
      }, this),
      "drag.owl.carousel dragged.owl.carousel translated.owl.carousel": a.proxy(function (a) {
        a.namespace && (this.swapping = "translated" == a.type);
      }, this),
      "translate.owl.carousel": a.proxy(function (a) {
        a.namespace && this.swapping && (this.core.options.animateOut || this.core.options.animateIn) && this.swap();
      }, this)
    }, this.core.$element.on(this.handlers);
  };

  e.Defaults = {
    animateOut: !1,
    animateIn: !1
  }, e.prototype.swap = function () {
    if (1 === this.core.settings.items && a.support.animation && a.support.transition) {
      this.core.speed(0);
      var b,
          c = a.proxy(this.clear, this),
          d = this.core.$stage.children().eq(this.previous),
          e = this.core.$stage.children().eq(this.next),
          f = this.core.settings.animateIn,
          g = this.core.settings.animateOut;
      this.core.current() !== this.previous && (g && (b = this.core.coordinates(this.previous) - this.core.coordinates(this.next), d.one(a.support.animation.end, c).css({
        left: b + "px"
      }).addClass("animated owl-animated-out").addClass(g)), f && e.one(a.support.animation.end, c).addClass("animated owl-animated-in").addClass(f));
    }
  }, e.prototype.clear = function (b) {
    a(b.target).css({
      left: ""
    }).removeClass("animated owl-animated-out owl-animated-in").removeClass(this.core.settings.animateIn).removeClass(this.core.settings.animateOut), this.core.onTransitionEnd();
  }, e.prototype.destroy = function () {
    var a, b;

    for (a in this.handlers) {
      this.core.$element.off(a, this.handlers[a]);
    }

    for (b in Object.getOwnPropertyNames(this)) {
      "function" != typeof this[b] && (this[b] = null);
    }
  }, a.fn.owlCarousel.Constructor.Plugins.Animate = e;
}(window.Zepto || window.jQuery, window, document), function (a, b, c, d) {
  var e = function e(b) {
    this._core = b, this._call = null, this._time = 0, this._timeout = 0, this._paused = !0, this._handlers = {
      "changed.owl.carousel": a.proxy(function (a) {
        a.namespace && "settings" === a.property.name ? this._core.settings.autoplay ? this.play() : this.stop() : a.namespace && "position" === a.property.name && this._paused && (this._time = 0);
      }, this),
      "initialized.owl.carousel": a.proxy(function (a) {
        a.namespace && this._core.settings.autoplay && this.play();
      }, this),
      "play.owl.autoplay": a.proxy(function (a, b, c) {
        a.namespace && this.play(b, c);
      }, this),
      "stop.owl.autoplay": a.proxy(function (a) {
        a.namespace && this.stop();
      }, this),
      "mouseover.owl.autoplay": a.proxy(function () {
        this._core.settings.autoplayHoverPause && this._core.is("rotating") && this.pause();
      }, this),
      "mouseleave.owl.autoplay": a.proxy(function () {
        this._core.settings.autoplayHoverPause && this._core.is("rotating") && this.play();
      }, this),
      "touchstart.owl.core": a.proxy(function () {
        this._core.settings.autoplayHoverPause && this._core.is("rotating") && this.pause();
      }, this),
      "touchend.owl.core": a.proxy(function () {
        this._core.settings.autoplayHoverPause && this.play();
      }, this)
    }, this._core.$element.on(this._handlers), this._core.options = a.extend({}, e.Defaults, this._core.options);
  };

  e.Defaults = {
    autoplay: !1,
    autoplayTimeout: 5e3,
    autoplayHoverPause: !1,
    autoplaySpeed: !1
  }, e.prototype._next = function (d) {
    this._call = b.setTimeout(a.proxy(this._next, this, d), this._timeout * (Math.round(this.read() / this._timeout) + 1) - this.read()), this._core.is("interacting") || c.hidden || this._core.next(d || this._core.settings.autoplaySpeed);
  }, e.prototype.read = function () {
    return new Date().getTime() - this._time;
  }, e.prototype.play = function (c, d) {
    var e;
    this._core.is("rotating") || this._core.enter("rotating"), c = c || this._core.settings.autoplayTimeout, e = Math.min(this._time % (this._timeout || c), c), this._paused ? (this._time = this.read(), this._paused = !1) : b.clearTimeout(this._call), this._time += this.read() % c - e, this._timeout = c, this._call = b.setTimeout(a.proxy(this._next, this, d), c - e);
  }, e.prototype.stop = function () {
    this._core.is("rotating") && (this._time = 0, this._paused = !0, b.clearTimeout(this._call), this._core.leave("rotating"));
  }, e.prototype.pause = function () {
    this._core.is("rotating") && !this._paused && (this._time = this.read(), this._paused = !0, b.clearTimeout(this._call));
  }, e.prototype.destroy = function () {
    var a, b;
    this.stop();

    for (a in this._handlers) {
      this._core.$element.off(a, this._handlers[a]);
    }

    for (b in Object.getOwnPropertyNames(this)) {
      "function" != typeof this[b] && (this[b] = null);
    }
  }, a.fn.owlCarousel.Constructor.Plugins.autoplay = e;
}(window.Zepto || window.jQuery, window, document), function (a, b, c, d) {
  "use strict";

  var e = function e(b) {
    this._core = b, this._initialized = !1, this._pages = [], this._controls = {}, this._templates = [], this.$element = this._core.$element, this._overrides = {
      next: this._core.next,
      prev: this._core.prev,
      to: this._core.to
    }, this._handlers = {
      "prepared.owl.carousel": a.proxy(function (b) {
        b.namespace && this._core.settings.dotsData && this._templates.push('<div class="' + this._core.settings.dotClass + '">' + a(b.content).find("[data-dot]").addBack("[data-dot]").attr("data-dot") + "</div>");
      }, this),
      "added.owl.carousel": a.proxy(function (a) {
        a.namespace && this._core.settings.dotsData && this._templates.splice(a.position, 0, this._templates.pop());
      }, this),
      "remove.owl.carousel": a.proxy(function (a) {
        a.namespace && this._core.settings.dotsData && this._templates.splice(a.position, 1);
      }, this),
      "changed.owl.carousel": a.proxy(function (a) {
        a.namespace && "position" == a.property.name && this.draw();
      }, this),
      "initialized.owl.carousel": a.proxy(function (a) {
        a.namespace && !this._initialized && (this._core.trigger("initialize", null, "navigation"), this.initialize(), this.update(), this.draw(), this._initialized = !0, this._core.trigger("initialized", null, "navigation"));
      }, this),
      "refreshed.owl.carousel": a.proxy(function (a) {
        a.namespace && this._initialized && (this._core.trigger("refresh", null, "navigation"), this.update(), this.draw(), this._core.trigger("refreshed", null, "navigation"));
      }, this)
    }, this._core.options = a.extend({}, e.Defaults, this._core.options), this.$element.on(this._handlers);
  };

  e.Defaults = {
    nav: !1,
    navText: ['<span aria-label="Previous">&#x2039;</span>', '<span aria-label="Next">&#x203a;</span>'],
    navSpeed: !1,
    navElement: 'button type="button" role="presentation"',
    navContainer: !1,
    navContainerClass: "owl-nav",
    navClass: ["owl-prev", "owl-next"],
    slideBy: 1,
    dotClass: "owl-dot",
    dotsClass: "owl-dots",
    dots: !0,
    dotsEach: !1,
    dotsData: !1,
    dotsSpeed: !1,
    dotsContainer: !1
  }, e.prototype.initialize = function () {
    var b,
        c = this._core.settings;
    this._controls.$relative = (c.navContainer ? a(c.navContainer) : a("<div>").addClass(c.navContainerClass).appendTo(this.$element)).addClass("disabled"), this._controls.$previous = a("<" + c.navElement + ">").addClass(c.navClass[0]).html(c.navText[0]).prependTo(this._controls.$relative).on("click", a.proxy(function (a) {
      this.prev(c.navSpeed);
    }, this)), this._controls.$next = a("<" + c.navElement + ">").addClass(c.navClass[1]).html(c.navText[1]).appendTo(this._controls.$relative).on("click", a.proxy(function (a) {
      this.next(c.navSpeed);
    }, this)), c.dotsData || (this._templates = [a('<button role="button">').addClass(c.dotClass).append(a("<span>")).prop("outerHTML")]), this._controls.$absolute = (c.dotsContainer ? a(c.dotsContainer) : a("<div>").addClass(c.dotsClass).appendTo(this.$element)).addClass("disabled"), this._controls.$absolute.on("click", "button", a.proxy(function (b) {
      var d = a(b.target).parent().is(this._controls.$absolute) ? a(b.target).index() : a(b.target).parent().index();
      b.preventDefault(), this.to(d, c.dotsSpeed);
    }, this));

    for (b in this._overrides) {
      this._core[b] = a.proxy(this[b], this);
    }
  }, e.prototype.destroy = function () {
    var a, b, c, d, e;
    e = this._core.settings;

    for (a in this._handlers) {
      this.$element.off(a, this._handlers[a]);
    }

    for (b in this._controls) {
      "$relative" === b && e.navContainer ? this._controls[b].html("") : this._controls[b].remove();
    }

    for (d in this.overides) {
      this._core[d] = this._overrides[d];
    }

    for (c in Object.getOwnPropertyNames(this)) {
      "function" != typeof this[c] && (this[c] = null);
    }
  }, e.prototype.update = function () {
    var a,
        b,
        c,
        d = this._core.clones().length / 2,
        e = d + this._core.items().length,
        f = this._core.maximum(!0),
        g = this._core.settings,
        h = g.center || g.autoWidth || g.dotsData ? 1 : g.dotsEach || g.items;

    if ("page" !== g.slideBy && (g.slideBy = Math.min(g.slideBy, g.items)), g.dots || "page" == g.slideBy) for (this._pages = [], a = d, b = 0, c = 0; a < e; a++) {
      if (b >= h || 0 === b) {
        if (this._pages.push({
          start: Math.min(f, a - d),
          end: a - d + h - 1
        }), Math.min(f, a - d) === f) break;
        b = 0, ++c;
      }

      b += this._core.mergers(this._core.relative(a));
    }
  }, e.prototype.draw = function () {
    var b,
        c = this._core.settings,
        d = this._core.items().length <= c.items,
        e = this._core.relative(this._core.current()),
        f = c.loop || c.rewind;

    this._controls.$relative.toggleClass("disabled", !c.nav || d), c.nav && (this._controls.$previous.toggleClass("disabled", !f && e <= this._core.minimum(!0)), this._controls.$next.toggleClass("disabled", !f && e >= this._core.maximum(!0))), this._controls.$absolute.toggleClass("disabled", !c.dots || d), c.dots && (b = this._pages.length - this._controls.$absolute.children().length, c.dotsData && 0 !== b ? this._controls.$absolute.html(this._templates.join("")) : b > 0 ? this._controls.$absolute.append(new Array(b + 1).join(this._templates[0])) : b < 0 && this._controls.$absolute.children().slice(b).remove(), this._controls.$absolute.find(".active").removeClass("active"), this._controls.$absolute.children().eq(a.inArray(this.current(), this._pages)).addClass("active"));
  }, e.prototype.onTrigger = function (b) {
    var c = this._core.settings;
    b.page = {
      index: a.inArray(this.current(), this._pages),
      count: this._pages.length,
      size: c && (c.center || c.autoWidth || c.dotsData ? 1 : c.dotsEach || c.items)
    };
  }, e.prototype.current = function () {
    var b = this._core.relative(this._core.current());

    return a.grep(this._pages, a.proxy(function (a, c) {
      return a.start <= b && a.end >= b;
    }, this)).pop();
  }, e.prototype.getPosition = function (b) {
    var c,
        d,
        e = this._core.settings;
    return "page" == e.slideBy ? (c = a.inArray(this.current(), this._pages), d = this._pages.length, b ? ++c : --c, c = this._pages[(c % d + d) % d].start) : (c = this._core.relative(this._core.current()), d = this._core.items().length, b ? c += e.slideBy : c -= e.slideBy), c;
  }, e.prototype.next = function (b) {
    a.proxy(this._overrides.to, this._core)(this.getPosition(!0), b);
  }, e.prototype.prev = function (b) {
    a.proxy(this._overrides.to, this._core)(this.getPosition(!1), b);
  }, e.prototype.to = function (b, c, d) {
    var e;
    !d && this._pages.length ? (e = this._pages.length, a.proxy(this._overrides.to, this._core)(this._pages[(b % e + e) % e].start, c)) : a.proxy(this._overrides.to, this._core)(b, c);
  }, a.fn.owlCarousel.Constructor.Plugins.Navigation = e;
}(window.Zepto || window.jQuery, window, document), function (a, b, c, d) {
  "use strict";

  var e = function e(c) {
    this._core = c, this._hashes = {}, this.$element = this._core.$element, this._handlers = {
      "initialized.owl.carousel": a.proxy(function (c) {
        c.namespace && "URLHash" === this._core.settings.startPosition && a(b).trigger("hashchange.owl.navigation");
      }, this),
      "prepared.owl.carousel": a.proxy(function (b) {
        if (b.namespace) {
          var c = a(b.content).find("[data-hash]").addBack("[data-hash]").attr("data-hash");
          if (!c) return;
          this._hashes[c] = b.content;
        }
      }, this),
      "changed.owl.carousel": a.proxy(function (c) {
        if (c.namespace && "position" === c.property.name) {
          var d = this._core.items(this._core.relative(this._core.current())),
              e = a.map(this._hashes, function (a, b) {
            return a === d ? b : null;
          }).join();

          if (!e || b.location.hash.slice(1) === e) return;
          b.location.hash = e;
        }
      }, this)
    }, this._core.options = a.extend({}, e.Defaults, this._core.options), this.$element.on(this._handlers), a(b).on("hashchange.owl.navigation", a.proxy(function (a) {
      var c = b.location.hash.substring(1),
          e = this._core.$stage.children(),
          f = this._hashes[c] && e.index(this._hashes[c]);

      f !== d && f !== this._core.current() && this._core.to(this._core.relative(f), !1, !0);
    }, this));
  };

  e.Defaults = {
    URLhashListener: !1
  }, e.prototype.destroy = function () {
    var c, d;
    a(b).off("hashchange.owl.navigation");

    for (c in this._handlers) {
      this._core.$element.off(c, this._handlers[c]);
    }

    for (d in Object.getOwnPropertyNames(this)) {
      "function" != typeof this[d] && (this[d] = null);
    }
  }, a.fn.owlCarousel.Constructor.Plugins.Hash = e;
}(window.Zepto || window.jQuery, window, document), function (a, b, c, d) {
  function e(b, c) {
    var e = !1,
        f = b.charAt(0).toUpperCase() + b.slice(1);
    return a.each((b + " " + h.join(f + " ") + f).split(" "), function (a, b) {
      if (g[b] !== d) return e = !c || b, !1;
    }), e;
  }

  function f(a) {
    return e(a, !0);
  }

  var g = a("<support>").get(0).style,
      h = "Webkit Moz O ms".split(" "),
      i = {
    transition: {
      end: {
        WebkitTransition: "webkitTransitionEnd",
        MozTransition: "transitionend",
        OTransition: "oTransitionEnd",
        transition: "transitionend"
      }
    },
    animation: {
      end: {
        WebkitAnimation: "webkitAnimationEnd",
        MozAnimation: "animationend",
        OAnimation: "oAnimationEnd",
        animation: "animationend"
      }
    }
  },
      j = {
    csstransforms: function csstransforms() {
      return !!e("transform");
    },
    csstransforms3d: function csstransforms3d() {
      return !!e("perspective");
    },
    csstransitions: function csstransitions() {
      return !!e("transition");
    },
    cssanimations: function cssanimations() {
      return !!e("animation");
    }
  };
  j.csstransitions() && (a.support.transition = new String(f("transition")), a.support.transition.end = i.transition.end[a.support.transition]), j.cssanimations() && (a.support.animation = new String(f("animation")), a.support.animation.end = i.animation.end[a.support.animation]), j.csstransforms() && (a.support.transform = new String(f("transform")), a.support.transform3d = j.csstransforms3d());
}(window.Zepto || window.jQuery, window, document);

(function () {
  var $body = $('body'),
      $window = $(window),
      $document = $(document),
      isMobile = false; // variable use to determine if responsive mode is on or off

  var toggleTable = {
    vPort: "screen-xs",
    init: function init() {
      toggleTable.on.build();
      toggleTable.control();
    },
    control: function control() {
      $body.on('click', '.expandable .table__control__button', function (e) {
        e.preventDefault();

        if ($(this).closest('tr').hasClass('js--expanded')) {
          toggleTable.on.hide($(this).closest('tr'));
        } else {
          toggleTable.on.show($(this).closest('tr'));
        }
      });
      $window.on('resize', function () {
        toggleTable.on.build();
      });
      $(document).on(toggleTable.vPort + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        isMobile = true;
      });
      $(document).on(toggleTable.vPort + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
        isMobile = false;
      });
    },
    on: {
      build: function build() {
        var $toggle = $('.expandable');
        $toggle.each(function () {
          var $target = $(this).find('tr');
          var to_hide = $target.find('.to_hide');
          $target.removeClass('js--expanded');

          if (isMobile) {
            $(to_hide).hide(0);
          } else {
            $(to_hide).show(0);
          }
        });
      },
      show: function show(elem) {
        var $target = elem.find('.to_hide');
        $target.toggle();
        elem.addClass('js--expanded');
      },
      hide: function hide(elem) {
        var $target = elem.find('.to_hide');
        $target.toggle();
        elem.removeClass('js--expanded');
      }
    }
  };
  UX.toggleTable = toggleTable; // add to global namespace
})();

(function () {
  var $body = $('body'),
      $document = $(document);
  var toggle = {
    $toggle: $('.facet:not(.displayAll)'),
    init: function init() {
      toggle.on.build();
      toggle.control();
    },
    control: function control() {
      $body.on('click', '.facet .show-more', function (e) {
        e.preventDefault();
        toggle.on.toggle($(this));
      });
      $body.find('.facet .dropdown__toggle').off();
      $body.on('click', '.facet .dropdown__toggle', function (e) {
        e.preventDefault();
        toggle.on.toggleFacet($(this));
      });
    },
    on: {
      build: function build() {
        toggle.$toggle.each(function () {
          var $target = $(this).find('ul.facet__list');
          var $lis = $target.children('li');
          var $select = $(this).find('.facet__select ');
          var $options = $select.children('option');
          var lisNum = $lis.length;
          var optionsNum = $options.length;
          var isToggle = lisNum > 5;
          var moreCount = optionsNum + lisNum - 5;
          $target.closest('.facet').attr('data-more-count', moreCount);
          if (isToggle) $target.after('<a href="#" class="show-more" aria-expanded="false">More (' + moreCount + ') <i class="icon-section_arrow_d" aria-hidden="true"></i></a>');
          $select.each(function () {
            var mis = $(this).magicSuggest({
              hideTrigger: 'true',
              allowFreeEntries: 'false',
              expandOnFocus: true,
              maxSelection: 1,
              placeholder: $(this).data('placeholder')
            });
            $(mis).on('selectionchange', function (e, m, selection) {
              if (selection != undefined) {
                window.location.href = selection[0].id;
              }
            });
          });
        });
      },
      toggle: function toggle(elem) {
        var $toggle = elem.closest('.facet');
        var $target = $toggle.find('ul.facet__list');
        $target.find('.js--toggle').slideToggle();
        $toggle.find('.facet__select--hidden').toggle();
        elem.toggleClass('js--open');

        if (elem.hasClass('js--open')) {
          elem.html('Less <i class="icon-section_arrow_u" aria-hidden="true"></i>');
          elem.closest(".accordion__content").find('li:nth-child(6) a').focus();
          elem.attr('aria-expanded', true);
        } else {
          elem.html('More (' + $toggle.data('more-count') + ') <i class="icon-section_arrow_d" aria-hidden="true"></i>');
          elem.closest(".accordion__content").find('li:first-child a').blur();
          elem.attr('aria-expanded', false);
        }
      },
      toggleFacet: function toggleFacet(elem) {
        var $toggle = elem.closest('li');
        var $target = $toggle.children('ul.facet-dropdown__menu');
        $target.slideToggle();
        elem.toggleClass('js--open');
        elem.find('i').toggleClass('icon-add_box icon-squared-minus');

        if (elem.hasClass('js--open')) {
          $target.attr('aria-hidden', false);
        } else {
          $target.attr('aria-hidden', true);
        }
      }
    }
  };
  UX.toggle = toggle; // add to global namespace
})();

(function () {
  var $body = $('body');
  var $document = $(document);
  var facetDate = {
    sliderRanges: [],
    sliderValues: [],
    $rangeStart: $('.range-slider__start'),
    $rangeEnd: $('.range-slider__end'),
    url: location.href,
    init: function init() {
      facetDate.$rangeStart = $('.range-slider__start');
      facetDate.$rangeEnd = $('.range-slider__end');
      facetDate.initRange();
      facetDate.control();
    },
    initRange: function initRange() {
      $('.range-slider').each(function () {
        var $sliderRange = $(this).find('.range-slider__range');

        if (!$sliderRange.hasClass("jcf-hidden")) {
          var frequencies = $sliderRange.data('frequencies');
          var nonLinearSliderSteps = [1, 2, 5, 10];
          var allowedTotalYears = nonLinearSliderSteps.reduce(function (prev, cur) {
            return prev + cur;
          }) * 2;
          var maxVal = parseInt($sliderRange.attr('max'), 10);
          var minVal = parseInt($sliderRange.attr('min'), 10);
          var totalYears = maxVal - minVal;
          var linearSlider = $sliderRange.attr('data-slider-type') === 'linear';

          if (totalYears > allowedTotalYears && !linearSlider) {
            // non-linear slider
            var displaySteps = nonLinearSliderSteps.slice().reverse();
            var remaining = totalYears;
            var startYear = minVal;
            var startSlice = 0;
            displaySteps.forEach(function (step, i, all) {
              var oneThird = Math.floor(remaining / 3);
              var twoThirds = Math.floor(2 * oneThird);
              var remainder = twoThirds % step;

              if (remainder > 0) {
                twoThirds = twoThirds - remainder;
              }

              remaining = remaining - twoThirds;

              if (i == displaySteps.length - 1) {
                facetDate.sliderRanges.push({
                  'start': startYear,
                  'stop': maxVal,
                  'displayStep': nonLinearSliderSteps[i],
                  'slideStep': step,
                  'freq': frequencies.slice(startSlice, frequencies.length)
                });
              } else {
                facetDate.sliderRanges.push({
                  'start': startYear,
                  'stop': startYear + twoThirds,
                  'displayStep': nonLinearSliderSteps[i],
                  'slideStep': step,
                  'freq': frequencies.slice(startSlice, startSlice + twoThirds)
                });
              }

              startSlice = startSlice + twoThirds;
              startYear = startYear + twoThirds;
            });
            facetDate.sliderRanges.forEach(function (range) {
              var sliderVal = range.start;

              while (sliderVal <= range.stop) {
                if (facetDate.sliderValues.indexOf(sliderVal) < 0) {
                  facetDate.sliderValues.push(sliderVal);
                }

                sliderVal += range.slideStep;
              }
            });
          } else {
            // linear slider
            if (!facetDate.sliderValues.length > 0) {
              for (var i = minVal; i <= maxVal; i++) {
                facetDate.sliderValues.push(i);
              }
            }
          }

          $sliderRange.attr('min', 0);
          $sliderRange.attr('max', facetDate.sliderValues.length - 1);
          var initialValue = facetDate.getSelectedRange($sliderRange);
          facetDate.$rangeStart.val(initialValue[0]);
          facetDate.$rangeEnd.val(initialValue[1]);
          var initialPosition = facetDate.getSelectedRangePosition(initialValue[0], initialValue[1]);
          $sliderRange.attr('value', initialPosition.join(','));
          jcf.replace($sliderRange); // render frequencies

          if (frequencies) {
            var $rangeWrapper = $(this).find('.jcf-range-wrapper');
            var $rangeFrequencies = $('<span class="jcf-range-frequencies"></span>');

            if (totalYears > allowedTotalYears && !linearSlider) {
              // non-linear slider
              facetDate.sliderRanges.forEach(function (range) {
                for (var i = 0; i < range.freq.length; i++) {
                  var $rangeSlice = $('<span class="jcf-range-frequencies__slice" style="width: ' + 100 / range.freq.length / facetDate.sliderRanges.length + '%; opacity: ' + range.freq[i] + '"></span>');
                  $rangeFrequencies.append($rangeSlice);
                }
              });
              $rangeWrapper.prepend($rangeFrequencies);
            } else {
              // linear slider
              var rangeSliceWidth = 100 / frequencies.length;

              for (var i = 0; i < frequencies.length; i++) {
                var $rangeSlice = $('<span class="jcf-range-frequencies__slice" style="width: ' + rangeSliceWidth + '%; opacity: ' + frequencies[i] + '"></span>');
                $rangeFrequencies.append($rangeSlice);
              }

              $rangeWrapper.prepend($rangeFrequencies);
            }
          }
        }
      });
    },
    control: function control() {
      $body.on('click', '.custom-date', function (e) {
        e.preventDefault();
        facetDate.on.toggle($(this));
      });
      $(document).on("UX-attach", function () {
        facetDate.init();
      });
      $(document).on("UX-detach", function () {
        jcf.destroy($(".range-slider__range"));
      });
      $('.range-slider__range').change(function () {
        facetDate.on.setRange($(this));
      });
      facetDate.$rangeStart.on('change', function () {
        facetDate.on.setStart($(this));
      });
      facetDate.$rangeEnd.on('change', function () {
        facetDate.on.setEnd($(this));
      });
      $('.range-slider__range').on('change change:startend', function () {
        facetDate.updateUrl($(this));
      });
    },
    on: {
      toggle: function toggle(elem) {
        var $toggle = elem.closest('.facet');
        var $target = $toggle.find('.custom-date-form').slideToggle();
        elem.toggleClass('js--open');
      },
      setRange: function setRange(elem) {
        var $toggle = elem.closest('.range-slider');
        var $target = $toggle.find('.jcf-active-handle');
        var tmp = $target.attr("class").match(/jcf-index[\w-]*\b/);
        var tmp2 = tmp.toString().split('-')[2];
        $('input.index-' + tmp2).val(facetDate.getValue(elem));
      },
      setStart: function setStart(elem) {
        var $sliderRange = elem.closest('.range-slider').find('.range-slider__range');
        var minVal = parseInt($sliderRange.attr('min'), 10);
        var thisVal = facetDate.getValueFromInput(elem);
        var sliderInstance = jcf.getInstance($sliderRange);

        if (thisVal >= minVal && thisVal <= sliderInstance.values[1]) {
          sliderInstance.values[0] = thisVal.toString();
          sliderInstance.refresh();
          $sliderRange.trigger('change:startend');
        }
      },
      setEnd: function setEnd(elem) {
        var $sliderRange = elem.closest('.range-slider').find('.range-slider__range');
        var maxVal = parseInt($sliderRange.attr('max'), 10);
        var thisVal = facetDate.getValueFromInput(elem);
        var sliderInstance = jcf.getInstance($sliderRange);

        if (thisVal <= maxVal && thisVal >= sliderInstance.values[0]) {
          sliderInstance.values[1] = thisVal.toString();
          sliderInstance.refresh();
          $sliderRange.trigger('change:startend');
        }
      },
      rangeUpdate: function rangeUpdate(elem, callbackFn) {
        var $sliderRange = $(elem);
        $sliderRange.on('change change:startend', function () {
          callbackFn(facetDate.$rangeStart.val(), facetDate.$rangeEnd.val());
        });
      }
    },
    getValue: function getValue(elem) {
      var $sliderRange = elem.closest('.range-slider').find('.range-slider__range');
      var thisValIndex = parseInt(elem.val(), 10);
      var thisVal = facetDate.sliderValues[thisValIndex];
      return thisVal;
    },
    getValueFromInput: function getValueFromInput(elem) {
      var $sliderRange = elem.closest('.range-slider').find('.range-slider__range');
      var customVal = parseInt(elem.val(), 10);
      var minVal = parseInt($sliderRange.attr('data-min'), 10);
      var maxVal = parseInt($sliderRange.attr('data-max'), 10);
      var thisVal;

      if (customVal <= maxVal && customVal >= minVal) {
        if (facetDate.sliderValues.indexOf(customVal) >= 0) {
          thisVal = facetDate.sliderValues.indexOf(customVal);
        } else {
          var closest = facetDate.sliderValues.reduce(function (prev, curr) {
            return Math.abs(curr - customVal) < Math.abs(prev - customVal) ? curr : prev;
          });
          thisVal = facetDate.sliderValues.indexOf(closest);
        }
      }

      return thisVal;
    },
    removeParam: function removeParam(key) {
      var baseUrl = facetDate.url.split('?')[0];
      var queryString = facetDate.url.indexOf('?') !== -1 ? facetDate.url.split('?')[1] : '';
      var queryStringObj = {};

      if (queryString) {
        queryString.split('&').map(function (value) {
          var keyVal = value.split('=');
          queryStringObj[keyVal[0]] = keyVal[1];
        });

        if (queryStringObj[key]) {
          delete queryStringObj[key];
        }

        queryString = Object.keys(queryStringObj).map(function (value) {
          return value + '=' + queryStringObj[value];
        }).join('&');
        facetDate.url = baseUrl + (queryString ? '?' + queryString : '');
      }
    },
    getSelectedRange: function getSelectedRange(sliderRange) {
      var baseUrl = facetDate.url.split('?')[0];
      var queryString = facetDate.url.indexOf('?') !== -1 ? facetDate.url.split('?')[1] : '';
      var queryStringObj = {};

      if (queryString) {
        queryString.split('&').map(function (value) {
          var keyVal = value.split('=');
          queryStringObj[keyVal[0]] = keyVal[1];
        });

        if (queryStringObj.AfterYear && queryStringObj.BeforeYear) {
          return [queryStringObj.AfterYear, queryStringObj.BeforeYear];
        }
      }

      return [parseInt(sliderRange.attr('data-min'), 10), parseInt(sliderRange.attr('data-max'), 10)];
    },
    getSelectedRangePosition: function getSelectedRangePosition(start, end) {
      var closestStart;
      var closestEnd;

      if (facetDate.sliderValues.indexOf(start) < 0) {
        closestStart = facetDate.sliderValues.reduce(function (prev, curr) {
          return Math.abs(curr - start) < Math.abs(prev - start) ? curr : prev;
        });
      }

      if (facetDate.sliderValues.indexOf(end) < 0) {
        closestEnd = facetDate.sliderValues.reduce(function (prev, curr) {
          return Math.abs(curr - end) < Math.abs(prev - end) ? curr : prev;
        });
      }

      return [facetDate.sliderValues.indexOf(closestStart || start), facetDate.sliderValues.indexOf(closestEnd || end)];
    },
    updateUrl: function updateUrl(elem) {
      facetDate.removeParam('AfterYear');
      facetDate.removeParam('BeforeYear');
      facetDate.removeParam('queryID');
      facetDate.url += (facetDate.url.indexOf('?') > -1 ? '&' : '?') + 'AfterYear=' + facetDate.$rangeStart.val() + '&BeforeYear=' + facetDate.$rangeEnd.val() + '&queryID=' + $(elem).attr('data-queryID');
      window.location = facetDate.url;
    }
  };
  UX.facetDate = facetDate; // add to global namespace
})();

(function () {
  var $body = $('body'),
      isMobile = false;
  var accordion = {
    $elements: $('.accordion'),
    $tabbedElements: $('.accordion-tabbed'),
    $controllers: $('.accordion__control'),
    //@todo: remove ambiguous DOM searches for elements that are unused and move other into init function
    $tabbedControllers: $('.accordion-tabbed__control'),
    isMobile: false,
    isArticleAccordion: false,
    vPort: "screen-sm",
    $responsiveElements: $('[data-accordion-vport]'),
    accVport: [],
    $responsiveTarget: [],
    collapseTabs: false,
    hideAllBoolean: true,
    init: function init() {
      accordion.initResponsive();
      accordion.logic($('.accordion-tabbed'));
      accordion.control();
      accordion.additionalControls();
    },
    additionalControls: function additionalControls() {},
    control: function control() {
      $body.on('click', '.accordion__control', function (e) {
        var attr = $(this).is('[data-slide-target]'); // Check if its external link or if its slide controll and mobile view port

        if ($(this).hasClass("external") || _typeof(attr) !== (typeof undefined === "undefined" ? "undefined" : _typeof(undefined)) && attr !== false && isMobile) {
          return; // do nothing
        } else {
          e.preventDefault();
          var $this = $(this);
          accordion.on.toggle.single($this);
        }
      });
      $body.on('click', '.accordion-tabbed__control', function (e) {
        var attr = $(this).is('[data-slide-target]'); // Check if its external link or if its slide controll and mobile view port or prevent accordion behavior

        if ($(this).hasClass("external") || _typeof(attr) !== (typeof undefined === "undefined" ? "undefined" : _typeof(undefined)) && attr !== false && isMobile || accordion.preventAccordionBehavior($(this))) {
          return; // do nothing
        } else {
          e.preventDefault();
          var $this = $(this);
          accordion.on.toggle.tabbed($this);
        }
      });
      $(document).on(accordion.vPort + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        isMobile = true;
      });
      $(document).on(accordion.vPort + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
        isMobile = false;
      });
    },
    logic: function logic(elem) {
      if (accordion.hideAllBoolean) {
        accordion.hideAll();
      }

      accordion.$tabbedElements = elem;
      accordion.$tabbedElements.each(function () {
        var $this = $(this);
        $this.find(".accordion-tabbed__tab").each(function (index) {
          var $this = $(this);

          if (accordion.preventAccordionBehavior($this)) {
            return;
          }

          if (!accordion.collapseTabs && index == 0 && !$this.hasClass('accordion__closed')) {
            $this.addClass('js--open');
            $this.find('.accordion-tabbed__control').attr('aria-expanded', 'true');
            $this.find('.accordion-tabbed__content').show();

            if ($this.find('.accordion-lazy').length) {
              accordion.getAccordionContent($this.find('.accordion-lazy'));
            }
          } else {
            $this.find('.accordion-tabbed__content').hide();
          }
        });
      });
    },
    getAccordionContent: function getAccordionContent($elem) {
      var widgetId = $elem.attr('data-widgetid');
      var dropzoneId = $elem.attr('data-dropzoneid');
      var pbContext = encodeURIComponent($('meta[name=pbContext]').attr("content"));
      var $parentTab = $elem.parent();
      $.ajax({
        url: '/pb/widgets/accordion/loadTab?pbContext=' + pbContext + '&widgetId=' + widgetId + '&dropZoneId=' + dropzoneId,
        success: function success(data) {
          $elem.closest('.accordion-tabbed__tab').attr('data-ajaxLoaded', 'true');
          $elem.replaceWith(data);
          accordion.logic($parentTab.find('.accordion-tabbed'));
          $parentTab.find('.creative-work .delayLoad').show();
          $parentTab.find('.creative-work .lazy-load').remove();
        },
        error: function error() {}
      });
    },
    on: {
      toggle: {
        single: function single($this) {
          $this.next('.accordion__content').slideToggle(200, function () {
            if ($this.parent().hasClass('article-accordion')) {
              $('.article-row-left').height('auto');
              accordion.isArticleAccordion = state; // if (state) {
              //     UX.scroll.scrollToTarget($this, false)
              // }
            }
          });
          $this.toggleClass('js--open');
          var state = !($this.attr('aria-expanded') == 'true');
          $this.attr('aria-expanded', state);
        },
        tabbed: function tabbed($this) {
          var $parent = $this.closest(".accordion-tabbed__tab");
          var $opened = $this.closest('.accordion-tabbed').children('.js--open');
          var state = !($this.attr('aria-expanded') == 'true');
          $this.attr('aria-expanded', state);

          if (!$parent.hasClass('js--open')) {
            $opened.children('.accordion-tabbed__content').slideUp(200);
            $parent.children('.accordion-tabbed__content').slideDown(200, function () {
              $opened.removeClass('js--open');
              $parent.addClass('js--open');

              if ($parent.attr('data-ajaxLoaded') != 'true' && $parent.find('.accordion-lazy').length) {
                accordion.getAccordionContent($parent.find('.accordion-lazy'));
              }
            });
          } else {
            $parent.children('.accordion-tabbed__content').slideUp(200, function () {
              $opened.removeClass('js--open');
            });
          }
        }
      }
    },
    hideAll: function hideAll() {
      //Hide accordion content on load (in case of disabled JS, the accordion should be open)
      accordion.$elements.each(function () {
        var $this = $(this);
        $this.find('.accordion__control').attr('aria-expanded', 'false');

        if (!$this.find('.accordion__content').hasClass("js--open")) {
          $this.find('.accordion__content').hide();
        } else if ($this.find('.accordion__content').hasClass("js--open")) {
          $this.find('.accordion__control').attr('aria-expanded', 'true');
        } else {
          $this.find('.accordion__content').removeClass("js--open");
        }
      });
    },
    initResponsive: function initResponsive() {
      if (accordion.$responsiveElements.length) {
        accordion.$responsiveElements.each(function (index) {
          accordion.$responsiveTarget[index] = $(this);
          accordion.accVport[index] = $(this).data('accordion-vport');
          accordion.setViewports(index);
        });
      }
    },
    preventAccordionBehavior: function preventAccordionBehavior($this) {
      if ($this.parents('[data-accordion-vport]:not(.accordion-vport--res)').length) return true;
      return false;
    },
    setViewports: function setViewports(index) {
      $(document).on(accordion.accVport[index] + '-on', function () {
        var target = accordion.$responsiveTarget[index];

        if (target.data('accordion-vport') == accordion.accVport[index]) {
          target.addClass("accordion-vport--res");

          if (target.data('accordion-option') == "with-arrow") {
            target.addClass("accordion-with-arrow");
          }

          accordion.logic(accordion.$responsiveTarget[index].find('.accordion-tabbed'));
        }
      });
      $(document).on(accordion.accVport[index] + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        var target = accordion.$responsiveTarget[index];

        if (target.data('accordion-vport') == accordion.accVport[index]) {
          target.removeClass("accordion-vport--res accordion-with-arrow");
          target.find('.accordion-tabbed__content').show();
        }
      });
    }
  };
  UX.accordion = accordion; // add to global namespace
})();

(function () {
  var $body = $('body');
  var refine = {
    $target: null,
    $targets: $('.refineSearch'),
    $showController: $('.quick-search__ctrl__refine'),
    $hideController: $('.quick-search__ctrl__refine--hide'),
    $elements: $('.refineSearch__row'),
    $wrapper: null,
    escape: 27,
    init: function init() {
      refine.control();

      if ($('.quick-search').length) {
        refine.on.hide();
      }
    },
    control: function control() {
      $body.on('click', '.refineSearch__ctrl__remove', function (e) {
        e.preventDefault();
        var $this = $(this);
        refine.$target = $this.closest('.refineSearch');
        refine.$wrapper = refine.$target.find('.refineSearch__texts');
        refine.on.remove($this);
      });
      $body.on('click', '.refineSearch__ctrl__add', function (e) {
        e.preventDefault();
        var $this = $(this);
        refine.$target = $this.closest('.refineSearch');
        refine.$wrapper = refine.$target.find('.refineSearch__texts');
        refine.on.clone($this);
      });
      $body.on('click', '.quick-search__ctrl__refine', function (e) {
        e.preventDefault();

        if (refine.$targets.length) {
          refine.on.show();
        }
      });
      $body.on('click', '.quick-search__ctrl__refine--hide', function (e) {
        e.preventDefault();
        refine.on.hide();
      });
      $body.on('click', function (e) {
        if (!refine.$targets.is(e.target) // if the target of the click isn't the container...
        && refine.$targets.has(e.target).length === 0 // ... nor a descendant of the container
        && !refine.$showController.is(e.target) // if the target of the click isn't the controller...
        && refine.$showController.has(e.target).length === 0 // ... nor a descendant of the controller
        && !$(e.target).closest('.jcf-select-drop').length && !refine.$targets.closest('.search-result__refine-search').length && !$(e.target).closest('.refineSearch__ctrl__remove').length) {
          refine.on.hide();
        }
      });
      $(document).on('keydown', function (e) {
        if ((e.keyCode || e.which) === refine.escape) {
          refine.on.hide();
        }
      });
    },
    on: {
      clone: function clone($this) {
        jcf.destroyAll();
        $this.closest('.refineSearch__row').clone(true, true).find('input').attr("name", "text" + ($(".refineSearch__row").length + 1).toString()).val('').end().appendTo(refine.$wrapper);
        $this.addClass('hidden');
        $this.siblings('.refineSearch__ctrl__remove').removeClass('hidden');
        $('.jcf').each(function () {
          jcf.replace($(this));
        });
      },
      remove: function remove($this) {
        $this.closest('.refineSearch__row').remove();
      },
      show: function show() {
        refine.$showController.addClass('hidden');
        refine.$hideController.removeClass('hidden');
        refine.$targets.addClass('js--open');
        refine.$targets.show();
      },
      hide: function hide() {
        refine.$targets.each(function () {
          if ($body.attr('data-active') === 'refine') {
            $body.removeAttr('data-active');
          }

          refine.$hideController.addClass('hidden');
          refine.$showController.removeClass('hidden');
          refine.$targets.removeClass('js--open');
          refine.$targets.hide();
        });
      }
    }
  };
  UX.refine = refine; // add to global namespace
})();

(function () {
  var $section = $('.figure-viewer'),
      $window = $(window),
      $document = $(document),
      $body = $('body');
  var figureViewer = {
    options: {
      /*
      * false|classCombination|className|dataRel
      * */
      filter: false,
      filterClass: 'article__tabFigure'
    },
    $topRegHeight: $('.figure-viewer__reg__top').innerHeight(),
    vPort: "screen-md",
    $figures: null,
    $figuresToShow: null,
    $figureWidth: null,
    $currentIndex: null,
    $focusedElementBeforeOpened: null,
    $section: $section,
    $holder: $section.find('.figure-viewer__hold__fig'),
    $captionHolder: $section.find('.figure-viewer__hold__figcap'),
    $lister: $section.find('.figure-viewer__hold__list'),
    $captionRegion: $section.find('.figure-viewer__cent__right'),
    $contentRegion: $section.find('.figure-viewer__cent__left'),
    $figureNav: $section.find('.figure-viewer__ctrl__next, .figure-viewer__ctrl__prev'),
    $zoominbtn: $section.find('.zoom-in'),
    $zoomoutbtn: $section.find('.zoom-out'),
    $zoomrange: $section.find('.zoom-range'),
    $zoomreset: $section.find('.reset'),
    $image: $section.find('figure'),
    $browsebtn: $('.figure-viewer__ctrl__browse'),
    $returnbtn: $('.figure-viewer__ctrl__return'),
    isMobile: false,
    islocked: false,
    offsetY: window.pageYOffset,
    $hideList: $('.zoomSlider, .figure-viewer__label__zoom'),
    expand: function expand() {
      // preserve backward compatibility with previous buggy version - it can be removed if filterContexts would become default behavior
      if (figureViewer.options.filter) {
        figureViewer.$figures = $document.find(':not(.figure-viewer__hold__list) > figure:not(.holder), :not(.figure-viewer__hold__list) > .figure:not(.holder)');
      } else {
        figureViewer.$figures = $document.find('figure:not(.holder), .figure:not(.holder)');
      }

      figureViewer.$figures.each(function (index) {
        var $this = $(this);
        $this.data('index', index);

        if (figureViewer.options.filter) {
          $this.addClass('figure'); // add class to be sure, that correct grid styling will be there

          if (figureViewer.options.filter === 'dataRel') {
            // move data-rel to container from child
            var dataRelElement = $this.find('[data-rel]');

            if (dataRelElement.length > 0 && dataRelElement.data().rel) {
              $this.attr('data-rel', dataRelElement.data().rel);
            }
          }
        } // $this.find('.figure__image, .open-figure-link').on({
        //     click: function (event) {
        //         event.preventDefault();
        //         if (!$this.hasClass('ui-disabled') && !$this.closest('.figure-viewer__hold__fig').length && $('.figure-viewer').length) {
        //             figureViewer.on.show($this, index);
        //         }
        //     }
        // });

      });
    },

    /*
    * Filter grid view and navigation based on item opened and option provided by figureViewer.options.filter
    * */
    filter: function filter($this) {
      if (figureViewer.options.filter === 'classCombination') {
        var className = $this.attr('class');
        figureViewer.$figuresToShow = figureViewer.$figures.filter('[class="' + className + '"]');
      } else if (figureViewer.options.filter === 'className') {
        figureViewer.$figuresToShow = figureViewer.$figures.filter('.' + figureViewer.options.filterClass);
      } else if (figureViewer.options.filter === 'dataRel') {
        var dataRel = $this.data('rel');

        if (dataRel) {
          figureViewer.$figuresToShow = figureViewer.$figures.filter('[data-rel="' + dataRel + '"]');
        } else {
          figureViewer.$figuresToShow = figureViewer.$figures;
        }
      } else {
        figureViewer.$figuresToShow = figureViewer.$figures;
      }

      figureViewer.$currentIndex = figureViewer.$figuresToShow.index($this);
    },
    control: function control() {
      $(document).on(figureViewer.vPort + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        figureViewer.isMobile = true;
      });
      $(document).on(figureViewer.vPort + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
        figureViewer.isMobile = false;
      });
      $(document).on("click", '.figure__image, .open-figure-link', function (event) {
        event.preventDefault();
        var $this = $(this).closest('figure:not(.holder), .figure:not(.holder)');

        if (!$this.hasClass('ui-disabled') && !$this.closest('.figure-viewer__hold__fig').length && $('.figure-viewer').length && !$(this).parents('.figure-viewer').length) {
          figureViewer.on.show($this, $this.data('index'));
        }
      });
      var $figureViewer = $body.find('.figure-viewer');
      var $controllerElement = $figureViewer.find('a, button');
      $controllerElement.each(function () {
        var $this = $(this);
        $this.on({
          click: function click(event) {
            event.preventDefault();
            event.stopPropagation();

            if ($this.hasClass('figure-viewer__ctrl__close')) {
              // close button
              figureViewer.on.hide();
            } else if ($this.hasClass('figure-viewer__ctrl__next')) {
              // Next button
              figureViewer.next();
            } else if ($this.hasClass('figure-viewer__ctrl__prev')) {
              // Prev Button
              figureViewer.prev();
            } else if ($this.hasClass('figure-viewer__ctrl__caption')) {
              // open / close caption Button
              figureViewer.toggle($this.closest('.figure-viewer__cent__right'));
              figureViewer.toggle($('.figure-viewer__cent__left'));
              $this.toggleClass('js-open');
            } else if ($this.hasClass('figure-viewer__ctrl__browse')) {
              // browse all figures
              figureViewer.browse($(this));
            } else if ($this.hasClass('figure-viewer__ctrl__return')) {
              // browse all figures
              figureViewer.return($(this));
            }
          }
        });
      }); // preserve backward compatibility with previous buggy version - it can be removed if filterContexts would become default behavior

      if (figureViewer.options.filter) {
        $(".figure a:not(.open-figure-link)").click(function (e) {
          var $img = $(this).find("img");
          shouldDefault = $(this).hasClass('linkBehavior');

          if (!shouldDefault || $img.length !== 0) {
            e.preventDefault();
            $img.trigger("click");
          }
        });
        $(".figure a:not(.open-figure-link) img").click(function (e) {
          e.stopPropagation();
        });
      } else {
        $(".figure a:not('.ppt-figure-link')").click(function (e) {
          var $img = $(this).find("img");
          shouldDefault = $(this).hasClass('linkBehavior');

          if (!shouldDefault || $img.length !== 0) {
            //e.preventDefault();
            $img.trigger("click");
          }
        });
      }

      $('body').keydown(function (event) {
        // is figureviewer open? no? than we don't do anything
        if ($body.attr('data-active') !== 'figureViewer') {
          return;
        }

        if (event.keyCode === 37) {
          // left
          figureViewer.prev();
        } else if (event.keyCode === 39) {
          // right
          figureViewer.next();
        }
      });
      figureViewer.supplementary.control();
      figureViewer.$image.on('click', function (e) {
        var img_clicked = $(e.target).is("img");

        if (!img_clicked) {
          figureViewer.on.hide();
        }
      });
      figureViewer.resize();
      $(window).resize(function () {
        figureViewer.resize();
      });

      if (figureViewer.$figures.length == 1) {
        figureViewer.$figureNav.hide();
      }

      $(".figure-viewer__ctrl__caption").focusout(function () {
        $('.figure-viewer__ctrl__close').focus();
      });
    },
    next: function next() {
      // preserve backward compatibility with previous buggy version - it can be removed if filterContexts would become default behavior
      if (!figureViewer.options.filter) {
        figureViewer.$figuresToShow = figureViewer.$figures;
      }

      if (figureViewer.$currentIndex < figureViewer.$figuresToShow.length - 1) {
        if (!figureViewer.$figuresToShow.eq(figureViewer.$currentIndex + 1).closest('.figure-viewer').length) {
          figureViewer.$currentIndex++;
          var $next = figureViewer.$figuresToShow.eq(figureViewer.$currentIndex);
          figureViewer.replace($next);
          figureViewer.zoom.reset();
        }
      } else {
        figureViewer.$currentIndex = 0;
        var $next = figureViewer.$figuresToShow.eq(figureViewer.$currentIndex);
        figureViewer.replace($next);
        figureViewer.zoom.reset();
      }
    },
    prev: function prev() {
      // preserve backward compatibility with previous buggy version - it can be removed if filterContexts would become default behavior
      if (!figureViewer.options.filter) {
        figureViewer.$figuresToShow = figureViewer.$figures;
      }

      if (figureViewer.$currentIndex >= 1) {
        if (!figureViewer.$figuresToShow.eq(figureViewer.$currentIndex - 1).closest('.figure-viewer').length) {
          figureViewer.$currentIndex--;
          var $prev = figureViewer.$figuresToShow.eq(figureViewer.$currentIndex);
          figureViewer.replace($prev);
          figureViewer.zoom.reset();
        }
      } else {
        figureViewer.$currentIndex = figureViewer.$figuresToShow.length - 1;
        var $prev = figureViewer.$figuresToShow.eq(figureViewer.$currentIndex);
        figureViewer.replace($prev);
        figureViewer.zoom.reset();
      }
    },
    replace: function replace(element) {
      var $figure = element.find('img').clone();
      $figure.each(function () {
        var $this = $(this);
        $this.attr('src', $this.attr('data-lg-src'));
      }); // handle multiple images in one figure

      if ($figure.length > 1) {
        // return one to image viewer and create navigation
        $figure = figureViewer.supplementary.show(element, $figure);
      } else {
        figureViewer.supplementary.hide();
      }

      var $caption = element.find('figcaption, .figcaption').clone();
      var $title = $caption.find('strong').remove();
      $('.figure-viewer__title__text').text($title.text());
      figureViewer.$holder.find('img').remove();
      figureViewer.$holder.find('figure').append($figure);
      figureViewer.$captionHolder.empty();
      $caption = figureViewer.additionalBehaviorOnShow(element);
      figureViewer.$captionHolder.append($caption);
      figureViewer.$figureWidth = figureViewer.$holder.find('img').width();
      figureViewer.zoom.check();
    },
    supplementary: {
      nav: null,

      /**
       *
       * @param element
       * @param $figure
       * @public
       * @returns {jQuery} current image
       */
      show: function show(element, $figure) {
        // get current index
        var index = this.check(element);
        var $thumbnails = $figure.clone();
        var self = this; // create supplementary navigation

        if (!this.nav) {
          this.nav = $('<ul class="figure-viewer__hold__supplementary-nav"></ul>');
          this.nav.appendTo(figureViewer.$section);
        } // create navigation items


        this.nav.empty();
        $thumbnails.each(function (index) {
          var $thumb = $('<li><a href="#" title="Go to figure image ' + (index + 1) + '. of current figure."></a></li>');
          $thumb.find('a').append(this);
          $thumb.find('a').on('click', function (event) {
            event.preventDefault();
            self.toIndex(element, index);
          }); // add to nav

          self.nav.append($thumb);
        }); // set initial active class

        this.nav.find('li').eq(index).addClass('active'); // return current into view

        return $figure.eq(index);
      },

      /**
       *
       * @public
       */
      hide: function hide() {
        if (this.nav) {
          this.nav.empty();
        }
      },
      save: function save(element, index) {
        element.data('figure-viewer-display', index);
      },
      check: function check(element) {
        return element.data('figure-viewer-display') || 0;
      },
      toIndex: function toIndex(element, index) {
        var $images = element.find('img');

        if ($images.length === 1) {
          // don't do anything for one image
          return;
        } // loop on edges


        if (index >= $images.length) {
          index = 0;
        }

        if (index < 0) {
          index = $images.length - 1;
        } // append index image


        figureViewer.$holder.find('img').remove();
        figureViewer.$holder.find('figure').append($images.eq(index).clone()); // toggle active class

        this.nav.find('li').removeClass('active');
        this.nav.find('li').eq(index).addClass('active'); // save state

        this.save(element, index);
      },
      next: function next(element) {
        var index = this.check(element) + 1;
        this.toIndex(element, index);
      },
      prev: function prev(element) {
        var index = this.check(element) - 1;
        this.toIndex(element, index);
      },

      /**
       *
       * @public
       */
      control: function control() {
        $('body').keydown(function (event) {
          // is figureviewer open? no? than we don't do anything
          if ($body.attr('data-active') !== 'figureViewer') {
            return;
          } // preserve backward compatibility with previous buggy version - it can be removed if filterContexts would become default behavior


          if (!figureViewer.options.filter) {
            figureViewer.$figuresToShow = figureViewer.$figures;
          } // is there any figure to show?


          if (figureViewer.$figuresToShow && figureViewer.$figuresToShow.length < 1) {
            return;
          }

          var element = figureViewer.$figuresToShow.eq(figureViewer.$currentIndex);

          if (event.keyCode === 38) {
            // up
            figureViewer.supplementary.prev(element);
          } else if (event.keyCode === 40) {
            // down
            figureViewer.supplementary.next(element);
          }
        });
      }
    },
    browse: function browse(element) {
      figureViewer.$holder.addClass('is-hidden');
      figureViewer.$figureNav.addClass('is-hidden');
      figureViewer.$browsebtn.addClass('is-hidden');
      figureViewer.$returnbtn.removeClass('is-hidden');
      figureViewer.$captionRegion.removeClass('js-open');
      figureViewer.$contentRegion.removeClass('js-open');
      figureViewer.$captionRegion.addClass('is-hidden');
      figureViewer.$hideList.each(function () {
        $(this).addClass('is-hidden');
      });
      figureViewer.$lister.removeClass('is-hidden');
      figureViewer.supplementary.hide();
      $('.figure-viewer__hold__list').empty(); // preserve backward compatibility with previous buggy version - it can be removed if filter would become default behavior

      if (figureViewer.options.filter) {
        figureViewer.$figuresToShow.each(function () {
          var $fig = $(this).clone(true);
          var $figureExtra = $fig.find(".figure-extra");

          if ($figureExtra.length) {
            $figureExtra.remove();
          }

          $('.figure-viewer__hold__list').append($fig);
        });
      } else {
        figureViewer.$figures.each(function () {
          if ($(this).hasClass('article__tabFigure')) {
            var $fig = $(this).clone(true);
            var $figureLinks = $fig.find(".figure-links");

            if ($figureLinks.length) {
              $figureLinks.remove();
            }

            $('.figure-viewer__hold__list').append($fig);
          }
        });
      }
    },
    return: function _return() {
      figureViewer.$holder.removeClass('is-hidden');
      figureViewer.$figureNav.removeClass('is-hidden');
      figureViewer.$browsebtn.removeClass('is-hidden');
      figureViewer.$returnbtn.addClass('is-hidden'); //figureViewer.$contentRegion.addClass('js-open');

      figureViewer.$captionRegion.removeClass('is-hidden');
      figureViewer.$hideList.each(function () {
        $(this).removeClass('is-hidden');
      });
      figureViewer.$lister.addClass('is-hidden');
      $('.figure-viewer__hold__list').empty();
    },
    height: function height(element) {
      var $windowsHeight = $(window).innerHeight();
      figureViewer.$topRegHeight = $('.figure-viewer__reg__top').innerHeight();
      var $height = $windowsHeight - figureViewer.$topRegHeight - $('.figure-viewer__caption__label').innerHeight();
      $('.figure-viewer__cent__left').find('figure').height($height);
    },
    toggle: function toggle(element) {
      element.toggleClass('js-open');
      figureViewer.figcaptionSize(); //LIT-161818
    },
    on: {
      show: function show($this, index) {
        figureViewer.offsetY = $body.data('yoffset') || window.pageYOffset;
        $body.data('yoffset', figureViewer.offsetY);

        if (typeof UX.controller !== 'undefined') {
          if ($body.attr('data-active') !== 'slide') {
            // keep drop block open in publication content widget
            UX.controller.check();
          }
        }

        $body.attr('data-active', 'figureViewer');
        figureViewer.islocked = true;
        figureViewer.$currentIndex = index;
        figureViewer.replace($this);
        figureViewer.$focusedElementBeforeOpened = document.activeElement;
        $('.figure-viewer').show();
        $body.css('overflow', 'hidden'); // LIT-152707

        figureViewer.height();
        figureViewer.zoom.check();
        figureViewer.$holder.removeClass('is-hidden');
        figureViewer.$captionRegion.removeClass('is-hidden');
        figureViewer.$browsebtn.removeClass('is-hidden');
        figureViewer.$returnbtn.addClass('is-hidden');
        figureViewer.$figureNav.removeClass('is-hidden');
        figureViewer.$hideList.each(function () {
          $(this).removeClass('is-hidden');
        });
        figureViewer.$lister.addClass('is-hidden');
        $('.figure-viewer__ctrl__close').focus();

        if (figureViewer.options.filter) {
          figureViewer.filter($this);
        }
      },
      hide: function hide() {
        if (figureViewer.islocked) {
          $body.removeAttr('data-active');
        } else {
          $body.removeClass('lock-screen').removeAttr('data-active');
        }

        figureViewer.zoom.reset();
        $('.figure-viewer').hide();
        figureViewer.$focusedElementBeforeOpened.focus();
        $body.css('overflow', ''); // LIT-152707

        $(window).scrollTop(figureViewer.offsetY);
        $body.removeData('yoffset');
      }
    },
    additionalBehaviorOnShow: function additionalBehaviorOnShow($el) {
      return $el.find('figcaption, .figcaption').clone();
    },
    zoom: {
      /*init: function (element) {
       var figureViewer.$section = $('.figure-viewer');
       },*/
      reset: function reset() {
        $elem = $('.figure-viewer').find('figure');
        $elem.panzoom('reset');
      },
      check: function check() {
        figureViewer.zoom.panzoom.init();

        if ($window.width() < 992) {
          figureViewer.zoom.swap();
        }
      },
      panzoom: {
        // zoom in functionality
        init: function init() {
          if (typeof $.fn.panzoom != 'undefined') {
            figureViewer.$image.panzoom({
              $zoomIn: figureViewer.$zoominbtn,
              $zoomOut: figureViewer.$zoomoutbtn,
              $zoomRange: figureViewer.$zoomrange,
              $reset: figureViewer.$zoomreset,
              panOnlyWhenZoomed: true,
              minScale: 1
            });
            figureViewer.$image.on('panzoomchange', function (e) {
              if (figureViewer.$zoomrange.val() === '1') {
                figureViewer.$image.css('transform', 'matrix(1, 0, 0, 1, 0, 0)');
                $(this).removeClass('zoomed');
              } else {
                $(this).addClass('zoomed');
              }
            });
          }
        }
      },
      swap: function swap() {
        // swap functionality for mobile devices
        figureViewer.$section.find('img').swipe({
          //Generic swipe handler for all directions
          swipe: function swipe(event, direction, distance, duration, fingerCount, fingerData) {
            if (direction === 'left' && !figureViewer.$section.find('figure').hasClass('zoomed')) {
              figureViewer.next();
            } else if (direction === 'right' && !figureViewer.$section.find('figure').hasClass('zoomed')) {
              figureViewer.prev();
            }
          }
        });
      }
    },
    slide: function slide() {
      var $target = $body.find('div.ux3-in-slide');
      $body.removeAttr('data-ux3-show');
      setTimeout(function () {
        $target.append($slide.children('div'));
        $target.removeClass('ux3-in-slide');
      }, 250);
    },
    resize: function resize() {
      var wHeight = $window.innerHeight();

      if (figureViewer.isMobile) {
        $('.figure-viewer__reg__center').css('height', wHeight);
      } else {
        $('.figure-viewer__reg__center').css('height', '100%');
      }
    },
    figcaptionSize: function figcaptionSize() {
      var $figcaption = $('.figure-viewer__hold__figcap').find('figcaption'),
          figure_area_height = $('.figure-viewer__reg__center').height(),
          figure_title_height = $('.figure-viewer__title').height() + 30,
          padding = 30;
      $figcaption.css('max-height', figure_area_height - 2 * padding - figure_title_height);
    },
    doubleTap: function doubleTap() {
      // disable double tap zooming functionality on mobile devices
      (function ($) {
        $.fn.nodoubletapzoom = function () {
          $(this).bind('touchstart', function preventZoom(e) {
            var t2 = e.timeStamp;
            var t1 = $(this).data('lastTouch') || t2;
            var dt = t2 - t1;
            var fingers = e.originalEvent.touches.length;
            $(this).data('lastTouch', t2);

            if (!dt || dt > 500 || fingers > 1) {
              return; // not double-tap
            }

            e.preventDefault(); // double tap - prevent the zoom
            // also synthesize click events we just swallowed up

            $(e.target).trigger('click');
          });
        };
      })(jQuery);
    },
    init: function init() {
      figureViewer.expand();
      figureViewer.control();
      figureViewer.doubleTap();
      $('body').nodoubletapzoom();
    }
  };
  UX.figureViewer = figureViewer; // add to global namespace
})();

/*!
 * Lazy Load - jQuery plugin for lazy loading images
 *
 * Copyright (c) 2007-2015 Mika Tuupola
 *
 * Licensed under the MIT license:
 *   http://www.opensource.org/licenses/mit-license.php
 *
 * Project home:
 *   http://www.appelsiini.net/projects/lazyload
 *
 * Version:  1.9.7
 *
 */
(function ($, window, document, undefined) {
  var $window = $(window);

  $.fn.lazyload = function (options) {
    var elements = this;
    var $container;
    var settings = {
      threshold: 0,
      failure_limit: 0,
      event: "scroll",
      effect: "show",
      container: window,
      data_attribute: "original",
      skip_invisible: false,
      appear: null,
      load: null,
      placeholder: "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsQAAA7EAZUrDhsAAAANSURBVBhXYzh8+PB/AAffA0nNPuCLAAAAAElFTkSuQmCC"
    };

    function update() {
      var counter = 0;
      elements.each(function () {
        var $this = $(this);

        if (settings.skip_invisible && !$this.is(":visible")) {
          return;
        }

        if ($.abovethetop(this, settings) || $.leftofbegin(this, settings)) {
          /* Nothing. */
        } else if (!$.belowthefold(this, settings) && !$.rightoffold(this, settings)) {
          $this.trigger("appear");
          /* if we found an image we'll load, reset the counter */

          counter = 0;
        } else {
          if (++counter > settings.failure_limit) {
            return false;
          }
        }
      });
    }

    if (options) {
      /* Maintain BC for a couple of versions. */
      if (undefined !== options.failurelimit) {
        options.failure_limit = options.failurelimit;
        delete options.failurelimit;
      }

      if (undefined !== options.effectspeed) {
        options.effect_speed = options.effectspeed;
        delete options.effectspeed;
      }

      $.extend(settings, options);
    }
    /* Cache container as jQuery as object. */


    $container = settings.container === undefined || settings.container === window ? $window : $(settings.container);
    /* Fire one scroll event per scroll. Not one scroll event per image. */

    if (0 === settings.event.indexOf("scroll")) {
      $container.bind(settings.event, function () {
        return update();
      });
    }

    this.each(function () {
      var self = this;
      var $self = $(self);
      self.loaded = false;
      /* If no src attribute given use data:uri. */

      if ($self.attr("src") === undefined || $self.attr("src") === false) {
        if ($self.is("img")) {
          $self.attr("src", settings.placeholder);
        }
      }
      /* When appear is triggered load original image. */


      $self.one("appear", function () {
        if (!this.loaded) {
          if (settings.appear) {
            var elements_left = elements.length;
            settings.appear.call(self, elements_left, settings);
          }

          $("<img />").bind("load", function () {
            var original = $self.attr("data-" + settings.data_attribute);
            $self.hide();

            if ($self.is("img")) {
              $self.attr("src", original);
            } else {
              $self.css("background-image", "url('" + original + "')");
            }

            $self[settings.effect](settings.effect_speed);
            self.loaded = true;
            /* Remove image from array so it is not looped next time. */

            var temp = $.grep(elements, function (element) {
              return !element.loaded;
            });
            elements = $(temp);

            if (settings.load) {
              var elements_left = elements.length;
              settings.load.call(self, elements_left, settings);
            }
          }).attr("src", $self.attr("data-" + settings.data_attribute));
        }
      });
      /* When wanted event is triggered load original image */

      /* by triggering appear.                              */

      if (0 !== settings.event.indexOf("scroll")) {
        $self.bind(settings.event, function () {
          if (!self.loaded) {
            $self.trigger("appear");
          }
        });
      }
    });
    /* Check if something appears when window is resized. */

    $window.bind("resize", function () {
      update();
    });
    /* With IOS5 force loading images when navigating with back button. */

    /* Non optimal workaround. */

    if (/(?:iphone|ipod|ipad).*os 5/gi.test(navigator.appVersion)) {
      $window.bind("pageshow", function (event) {
        if (event.originalEvent && event.originalEvent.persisted) {
          elements.each(function () {
            $(this).trigger("appear");
          });
        }
      });
    }
    /* Force initial check if images should appear. */


    $(document).ready(function () {
      update();
    });
    return this;
  };
  /* Convenience methods in jQuery namespace.           */

  /* Use as  $.belowthefold(element, {threshold : 100, container : window}) */


  $.belowthefold = function (element, settings) {
    var fold;

    if (settings.container === undefined || settings.container === window) {
      fold = (window.innerHeight ? window.innerHeight : $window.height()) + $window.scrollTop();
    } else {
      fold = $(settings.container).offset().top + $(settings.container).height();
    }

    return fold <= $(element).offset().top - settings.threshold;
  };

  $.rightoffold = function (element, settings) {
    var fold;

    if (settings.container === undefined || settings.container === window) {
      fold = $window.width() + $window.scrollLeft();
    } else {
      fold = $(settings.container).offset().left + $(settings.container).width();
    }

    return fold <= $(element).offset().left - settings.threshold;
  };

  $.abovethetop = function (element, settings) {
    var fold;

    if (settings.container === undefined || settings.container === window) {
      fold = $window.scrollTop();
    } else {
      fold = $(settings.container).offset().top;
    }

    return fold >= $(element).offset().top + settings.threshold + $(element).height();
  };

  $.leftofbegin = function (element, settings) {
    var fold;

    if (settings.container === undefined || settings.container === window) {
      fold = $window.scrollLeft();
    } else {
      fold = $(settings.container).offset().left;
    }

    return fold >= $(element).offset().left + settings.threshold + $(element).width();
  };

  $.inviewport = function (element, settings) {
    return !$.rightoffold(element, settings) && !$.leftofbegin(element, settings) && !$.belowthefold(element, settings) && !$.abovethetop(element, settings);
  };
  /* Custom selectors for your convenience.   */

  /* Use as $("img:below-the-fold").something() or */

  /* $("img").filter(":below-the-fold").something() which is faster */


  $.extend($.expr[":"], {
    "below-the-fold": function belowTheFold(a) {
      return $.belowthefold(a, {
        threshold: 0
      });
    },
    "above-the-top": function aboveTheTop(a) {
      return !$.belowthefold(a, {
        threshold: 0
      });
    },
    "right-of-screen": function rightOfScreen(a) {
      return $.rightoffold(a, {
        threshold: 0
      });
    },
    "left-of-screen": function leftOfScreen(a) {
      return !$.rightoffold(a, {
        threshold: 0
      });
    },
    "in-viewport": function inViewport(a) {
      return $.inviewport(a, {
        threshold: 0
      });
    },

    /* Maintain BC for couple of versions. */
    "above-the-fold": function aboveTheFold(a) {
      return !$.belowthefold(a, {
        threshold: 0
      });
    },
    "right-of-fold": function rightOfFold(a) {
      return $.rightoffold(a, {
        threshold: 0
      });
    },
    "left-of-fold": function leftOfFold(a) {
      return !$.rightoffold(a, {
        threshold: 0
      });
    }
  });
})(jQuery, window, document);

(function ($) {
  var methods;

  function truncateText() {
    var that = this;
    var $this = $(this);
    var height = $this.height();
    var maxHeight = this.settings.lines * parseFloat($this.css('line-height'));

    if (height === 0) {
      setTimeout(function () {
        truncateText.call(that);
      }, 10);
      return;
    }

    if (height > maxHeight) {
      removeElements.call(this, $this);
    } else {
      setTimeout(function () {
        $this.addClass(that.settings.addClass);
      }, 0);
      that.settings.onComplete();
    }
  }

  function removeElements(containerEl) {
    var that = this;
    var $this = $(this);
    var height = $this.height();
    var maxHeight = this.settings.lines * Math.ceil(parseFloat($this.css('line-height')));
    var $lastRemoved;
    var $parent;
    var $seeMore;

    if (this.settings.seeMoreLink) {
      $seeMore = seeMoreLink.call(this);
    } else {
      $seeMore = ellipsis.call(this);
    }

    if (containerEl.get(0).nodeType === Node.ELEMENT_NODE) {
      while (height > maxHeight && containerEl.contents().length) {
        $lastRemoved = containerEl.contents().last().remove();
        height = $this.height();
      }

      if (height <= maxHeight && $lastRemoved) {
        containerEl.append($lastRemoved);
        height = $this.height();

        if (height > maxHeight) {
          removeElements.call(this, $lastRemoved);
        }
      } else if ($.trim(containerEl.text()) === '') {
        $parent = containerEl.parent();
        containerEl.remove();
        height = $this.height();

        if ($.trim($parent.text()) === '') {
          removeElements.call(this, $parent);
        } else if (height <= maxHeight) {
          if ($this.children().length) {
            var $lastChild = $this.children().last();

            if ($lastChild.is('br')) {
              $lastChild.after($seeMore);
            } else {
              $lastChild.parent().append($seeMore);
            }
          } else {
            $this.append($seeMore);
          }
        }
      }
    } else {
      var textContent = containerEl.text();
      var min = 0;
      var max = textContent.length - 1;
      var mid = Math.floor((min + max) / 2);

      while (min < max) {
        if (height > maxHeight) {
          //max = mid - 1;
          max = mid + parseInt((max - mid) * maxHeight / height, 10);
        } else {
          min = mid + 1;
        }

        $seeMore.remove();
        mid = Math.floor((min + max) / 2);
        containerEl.get(0).textContent = textContent.substr(0, mid);
        containerEl.parent().append($seeMore);
        height = $this.height();
      }

      while (height > maxHeight && mid > 0) {
        $seeMore.remove();
        mid = mid - 1;
        containerEl.get(0).textContent = textContent.substr(0, mid);
        containerEl.parent().append($seeMore);
        height = $this.height();
      }

      if (mid === 0) {
        $parent = containerEl.parent();
        $seeMore.remove();

        if ($.trim($parent.text()) === '') {
          removeElements.call(this, $parent);
        }
      }

      if (height <= maxHeight) {
        if (this.settings.addClass && !$this.hasClass(this.settings.addClass)) {
          setTimeout(function () {
            $this.addClass(that.settings.addClass);
          }, 0);
        }

        that.settings.onComplete();
      }
    }
  }

  function truncateList() {
    var that = this;
    var $this = $(this);
    var height = $this.height();
    var lineHeight = Math.ceil(Math.max($this.children().height(), parseFloat($this.css('line-height'))));
    var maxHeight = this.settings.lines * lineHeight;

    if ($this.children().length === 0) {
      $this.addClass(that.settings.addClass);
      that.settings.onComplete();
      return;
    }

    if (height === 0 || maxHeight === 0) {
      setTimeout(function () {
        truncateList.call(that);
      }, 10);
      return;
    }

    switch (this.settings.position) {
      case 'middle':
        if (height > maxHeight) {
          removeListItemsMiddle.call(this, $this);
        } else {
          if (this.settings.addClass && !$this.hasClass(this.settings.addClass)) {
            setTimeout(function () {
              $this.addClass(that.settings.addClass);
            }, 0);
          }

          that.settings.onComplete();
        }

        break;

      case 'end':
        if (height > maxHeight) {
          removeListItemsEnd.call(this, $this);
        } else {
          if (this.settings.addClass && !$this.hasClass(this.settings.addClass)) {
            setTimeout(function () {
              $this.addClass(that.settings.addClass);
            }, 0);
          }

          that.settings.onComplete();
        }

        break;

      case 'betweenFirstAndLast':
        removeListItemsBetweenFirstAndLast.call(this, $this);
        break;

      case 'beforeLast':
        if (height > maxHeight) {
          removeListItemsBeforeLast.call(this, $this);
        } else {
          if (this.settings.addClass && !$this.hasClass(this.settings.addClass)) {
            setTimeout(function () {
              $this.addClass(that.settings.addClass);
            }, 0);
          }

          that.settings.onComplete();
        }

        break;
    }
  }

  function removeListItemsMiddle() {
    var that = this;
    var $this = $(this);
    var height;
    var lineHeight = Math.ceil(Math.max($this.children().height(), parseFloat($this.css('line-height'))));
    var maxHeight = this.settings.lines * lineHeight;
    var $seeMore;
    var removedCount = 0;
    var $removedItems;
    var $lastRemoved;

    if (this.settings.seeMoreLink) {
      $seeMore = seeMoreMiddleLink.call(this);
    } else {
      $seeMore = ellipsis.call(this, true);
    }

    var removeItems = function removeItems() {
      height = $this.height();

      if (height > maxHeight) {
        while (height > maxHeight && $this.contents().length > 2) {
          $seeMore.remove();

          if ($removedItems && $this.find($removedItems).length) {
            $removedItems.remove();
          }

          var indexToRemove = Math.floor($this.contents().length / 2);
          $lastRemoved = $($this.contents().get(indexToRemove)).remove();

          if ($lastRemoved && $lastRemoved.get(0).nodeType === Node.ELEMENT_NODE) {
            removedCount += 1;
          }

          indexToRemove -= 1;
          height = $this.height();

          if (height > maxHeight && $this.contents().length > 2) {
            $lastRemoved = $($this.contents().get(indexToRemove)).remove();

            if ($lastRemoved && $lastRemoved.get(0).nodeType === Node.ELEMENT_NODE) {
              removedCount += 1;
            }

            indexToRemove -= 1;
          }

          if (that.settings.showRemovedCount && removedCount > 0) {
            $removedItems = removedCountMarkup(removedCount);
            $removedItems.insertAfter($($this.contents().get(indexToRemove)));
          } else {
            $seeMore.insertAfter($($this.contents().get(indexToRemove)));
          }

          height = $this.height();
        }

        setTimeout(removeItems, 1000);
      } else {
        if (that.settings.addClass && !$this.hasClass(that.settings.addClass)) {
          setTimeout(function () {
            $this.addClass(that.settings.addClass);
          }, 0);
        }

        that.settings.onComplete();
      }
    };

    removeItems();
  }

  function removeListItemsEnd() {
    var that = this;
    var $this = $(this);
    var height;
    var lineHeight = Math.ceil(Math.max($this.children().height(), parseFloat($this.css('line-height'))));
    var maxHeight = this.settings.lines * lineHeight;
    var $seeMore;
    var removedCount = 0;
    var $removedItems;
    var $lastRemoved;

    if (this.settings.seeMoreLink) {
      $seeMore = seeMoreLink.call(this);
    } else {
      $seeMore = ellipsis.call(this);
    }

    var removeItems = function removeItems() {
      height = $this.height();

      if (height > maxHeight) {
        while (height > maxHeight && $this.contents().length > 1) {
          if ($removedItems && $this.find($removedItems).length) {
            $removedItems.remove();
          }

          if ($this.find($seeMore).length) {
            $lastRemoved = $($this.contents().get($this.contents().length - 2)).remove();
          } else {
            $lastRemoved = $this.contents().last().remove();

            if (!that.settings.showRemovedCount) {
              $this.append($seeMore);
            }
          }

          if ($lastRemoved && $lastRemoved.get(0).nodeType === Node.ELEMENT_NODE) {
            removedCount += 1;
          }

          if (that.settings.showRemovedCount && removedCount > 0) {
            $removedItems = removedCountMarkup(removedCount);
            $this.append($removedItems);
          }

          height = $this.height();
        }

        setTimeout(removeItems, 1000);
      } else {
        if (that.settings.addClass && !$this.hasClass(that.settings.addClass)) {
          setTimeout(function () {
            $this.addClass(that.settings.addClass);
          }, 0);
        }

        that.settings.onComplete();
      }
    };

    removeItems();
  }

  function removeListItemsBeforeLast() {
    var that = this;
    var $this = $(this);
    var height = $this.height();
    var lineHeight = Math.ceil(Math.max($this.children().height(), parseFloat($this.css('line-height'))));
    var maxHeight = this.settings.lines * lineHeight;
    var $seeMoreLink = seeMoreMiddleLink.call(this);
    var removedCount = 0;
    var $removedItems;
    var $lastRemoved;

    var removeItems = function removeItems() {
      height = $this.height();

      if (height > maxHeight) {
        var $lastXItems = $('<div></div>');

        while ($this.children().length > 1 && $lastXItems.children().length < that.settings.lastItemsCount || $this.contents().last().get(0).nodeType === Node.TEXT_NODE) {
          $lastXItems.prepend($this.contents().last().remove());
        }

        var $lastXItemsContent = $lastXItems.contents();

        while (height > maxHeight && $this.children().length > 2) {
          if ($removedItems && $this.find($removedItems).length) {
            $removedItems.remove();
          }

          $seeMoreLink.remove();
          $lastXItemsContent.remove();
          $lastRemoved = $this.contents().last().remove();

          if ($lastRemoved && $lastRemoved.get(0).nodeType === Node.ELEMENT_NODE) {
            removedCount += 1;
          }

          if (that.settings.showRemovedCount && removedCount > 0) {
            $removedItems = removedCountMarkup(removedCount);
            $this.append($removedItems);
          } else {
            $this.append($seeMoreLink);
          }

          $this.append($lastXItemsContent);
          height = $this.height();
        }

        setTimeout(removeItems, 1000);
      } else {
        if (that.settings.addClass && !$this.hasClass(that.settings.addClass)) {
          setTimeout(function () {
            $this.addClass(that.settings.addClass);
          }, 0);
        }

        that.settings.onComplete();
      }
    };

    removeItems();
  }

  function removeListItemsBetweenFirstAndLast() {
    var that = this;
    var $this = $(this);
    var $items = $this.children();
    var $seeMore;
    var removedCount = $items.length - 2;
    var $removedItems;

    if ($items.length > 1) {
      if (this.settings.seeMoreLink) {
        $seeMore = seeMoreMiddleLink.call(this);
      } else {
        $seeMore = ellipsis.call(this, true);
      }

      if (that.settings.showRemovedCount) {
        $removedItems = removedCountMarkup(removedCount);
      }

      $this.html('');
      $this.append($items.first());

      if (that.settings.showRemovedCount && removedCount > 0) {
        $this.append($removedItems);
      } else {
        $this.append($seeMore);
      }

      $this.append($items.last());
    }

    that.settings.onComplete();
  }

  function removedCountMarkup(count) {
    return $('<a href="#" class="removed-items-count"> + ' + count + ' </a>');
  }

  function ellipsis(isLink) {
    return $('<' + (isLink ? 'a href="#"' : 'span') + ' class="ellipsis"> ' + this.settings.ellipsisChar + ' </' + (isLink ? 'a' : 'span') + '>');
  }

  function seeMoreLink() {
    var seeMore = ' <span class="ellipsis">' + this.settings.ellipsisChar + '</span> ' + this.settings.seeMoreText + ' <i class="icon-section_arrow_d"></i>';

    if (this.settings.seeMoreHtml) {
      seeMore = this.settings.seeMoreHtml;
    } else if (this.settings.isMobile) {
      seeMore = ' <span class="ellipsis">' + this.settings.ellipsisChar + '</span> ' + this.settings.seeMoreText + ' <i class="icon-arrow_r"></i>';
    }

    if (this.settings.isMobile) {
      return $('<a href="#" class="read-more w-slide__btn slide-active" data-slide-target="' + this.settings.mobileTarget + '">' + seeMore + '</a>');
    } else {
      return $('<a href="#" class="read-more">' + seeMore + '</a>');
    }
  }

  function seeMoreMiddleLink() {
    var seeMore = ' <span class="ellipsis">' + this.settings.ellipsisChar + '</span> ' + this.settings.seeMoreText + ' <i class="icon-section_arrow_d"></i> <span class="ellipsis">' + this.settings.ellipsisChar + '</span> ';

    if (this.settings.seeMoreHtml) {
      seeMore = this.settings.seeMoreHtml;
    } else if (this.settings.isMobile) {
      seeMore = ' <span class="ellipsis">' + this.settings.ellipsisChar + '</span> ' + this.settings.seeMoreText + ' <i class="icon-arrow_r"></i> <span class="ellipsis">' + this.settings.ellipsisChar + '</span> ';
    }

    if (this.settings.isMobile) {
      return $('<a href="#" class="read-more w-slide__btn slide-active" data-slide-target="' + this.settings.mobileTarget + '">' + seeMore + '</a>');
    } else {
      return $('<a href="#" class="read-more">' + seeMore + '</a>');
    }
  }

  function seeLessLink() {
    var seeLess = ' ... ' + this.settings.seeLessText + ' <i class="icon-section_arrow_u"></i>';

    if (this.settings.seeLessHtml) {
      seeLess = this.settings.seeLessHtml;
    }

    return $('<a href="#" class="read-less">' + seeLess + '</a>');
  }

  function addEventHandlers() {
    var that = this;
    var $this = $(this);
    $this.on('click', function (evt) {
      var $evtTarget = $(evt.target);

      if ($evtTarget.hasClass('ellipsis') && $evtTarget.is('a')) {
        evt.preventDefault();
        $this.data('truncatedContent', $this.html());
        $this.html($this.data('originalContent'));
        var lessLink = seeLessLink.call(that);
        $this.append(lessLink);
      }

      if ($evtTarget.hasClass('read-more') && !$evtTarget.hasClass('w-slide__btn') || $evtTarget.parent().hasClass('read-more') && !$evtTarget.parent().hasClass('w-slide__btn') || $evtTarget.hasClass('removed-items-count')) {
        evt.preventDefault();
        $this.data('truncatedContent', $this.html());
        $this.html($this.data('originalContent'));
        var lessLink = seeLessLink.call(that);
        $this.append(lessLink);
      }

      if ($evtTarget.hasClass('read-less') || $evtTarget.parent().hasClass('read-less')) {
        evt.preventDefault();
        $this.html($this.data('truncatedContent')); //var moreLink = seeMoreLink.call(that);
        //$(evt.target).replaceWith(moreLink);
      }
    });
  }

  methods = {
    init: function init(options) {
      return this.each(function () {
        var $this = $(this);
        var firstInit = true;

        if ($this.data('originalContent')) {
          $this.html($this.data('originalContent'));

          if ($this.data('settings')) {
            this.settings = $this.data('settings');
          }

          if (this.settings && this.settings.addClass) {
            $this.removeClass(this.settings.addClass);
          }

          firstInit = false;
        } else {
          $this.data('originalContent', $this.html());
        }

        if (options) {
          this.settings = $.extend({}, $.fn.truncate.defaults, options);
          $this.data('settings', this.settings);
        }

        if (this.settings && this.settings.type === 'text') {
          truncateText.call(this);
        } else if (this.settings && this.settings.type === 'list') {
          truncateList.call(this);
        }

        if (firstInit) {
          addEventHandlers.call(this);
        }
      });
    },
    destroy: function destroy() {
      return this.each(function () {
        var $this = $(this);

        if ($this.data('originalContent')) {
          $this.html($this.data('originalContent'));

          if (this.settings.addClass) {
            $this.removeClass(this.settings.addClass);
          }
        }
      });
    }
  };

  $.fn.truncate = function (method) {
    if (methods[method]) {
      return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
    } else if (_typeof(method) === 'object' || !method) {
      return methods.init.apply(this, arguments);
    } else {
      $.error('Method ' + method + ' does not exist on jQuery.truncate');
    }
  };
  /* Default truncate settings. */


  $.fn.truncate.defaults = {
    type: 'text',
    // text, list
    position: 'end',
    // end, middle, beforeLast, betweenFirstAndLast
    showRemovedCount: false,
    lines: 1,
    seeMoreLink: false,
    seeMoreText: 'See More',
    seeLessText: 'See Less',
    seeMoreHtml: '',
    seeLessHtml: '',
    ellipsisChar: '&hellip;',
    lastItemsCount: 1,
    isMobile: false,
    mobileTarget: '',
    addClass: '',
    isSliding: true,
    onComplete: function onComplete() {}
  };
})(jQuery);

/*
 *	jQuery dotdotdot 1.8.3
 *
 *	Copyright (c) Fred Heusschen
 *	www.frebsite.nl
 *
 *	Plugin website:
 *	dotdotdot.frebsite.nl
 *
 *	Licensed under the MIT license.
 *	http://en.wikipedia.org/wiki/MIT_License
 */
(function ($, undef) {
  'use strict';

  if ($.fn.dotdotdot) {
    return;
  }

  $.fn.dotdotdot = function (o) {
    if (this.length === 0) {
      $.fn.dotdotdot.debug('No element found for "' + this.selector + '".');
      return this;
    }

    if (this.length > 1) {
      return this.each(function () {
        $(this).dotdotdot(o);
      });
    }

    var $dot = this;
    var orgContent = $dot.contents();

    if ($dot.data('dotdotdot')) {
      $dot.trigger('destroy.dot');
    }

    $dot.data('dotdotdot-style', $dot.attr('style') || '');
    $dot.css('word-wrap', 'break-word');

    if ($dot.css('white-space') === 'nowrap') {
      $dot.css('white-space', 'normal');
    }

    $dot.bind_events = function () {
      $dot.bind('update.dot', function (e, c) {
        $dot.removeClass("is-truncated");
        e.preventDefault();
        e.stopPropagation();

        switch (_typeof(opts.height)) {
          case 'number':
            opts.maxHeight = opts.height;
            break;

          case 'function':
            opts.maxHeight = opts.height.call($dot[0]);
            break;

          default:
            opts.maxHeight = getTrueInnerHeight($dot);
            break;
        }

        opts.maxHeight += opts.tolerance;

        if (typeof c != 'undefined') {
          if (typeof c == 'string' || 'nodeType' in c && c.nodeType === 1) {
            c = $('<div />').append(c).contents();
          }

          if (c instanceof $) {
            orgContent = c;
          }
        }

        $inr = $dot.wrapInner('<div class="dotdotdot" />').children();
        $inr.contents().detach().end().append(orgContent.clone(true)).find('br').replaceWith('  <br />  ').end().css({
          'height': 'auto',
          'width': 'auto',
          'border': 'none',
          'padding': 0,
          'margin': 0
        });
        var after = false,
            trunc = false;

        if (conf.afterElement) {
          after = conf.afterElement.clone(true);
          after.show();
          conf.afterElement.detach();
        }

        if (test($inr, opts)) {
          if (opts.wrap == 'children') {
            trunc = children($inr, opts, after);
          } else {
            trunc = ellipsis($inr, $dot, $inr, opts, after);
          }
        }

        $inr.replaceWith($inr.contents());
        $inr = null;

        if ($.isFunction(opts.callback)) {
          opts.callback.call($dot[0], trunc, orgContent);
        }

        conf.isTruncated = trunc;
        return trunc;
      }).bind('isTruncated.dot', function (e, fn) {
        e.preventDefault();
        e.stopPropagation();

        if (typeof fn == 'function') {
          fn.call($dot[0], conf.isTruncated);
        }

        return conf.isTruncated;
      }).bind('originalContent.dot', function (e, fn) {
        e.preventDefault();
        e.stopPropagation();

        if (typeof fn == 'function') {
          fn.call($dot[0], orgContent);
        }

        return orgContent;
      }).bind('destroy.dot', function (e) {
        e.preventDefault();
        e.stopPropagation();
        $dot.unwatch().unbind_events().contents().detach().end().append(orgContent).attr('style', $dot.data('dotdotdot-style') || '').removeClass('is-truncated').data('dotdotdot', false);
      });
      return $dot;
    }; //	/bind_events


    $dot.unbind_events = function () {
      $dot.unbind('.dot');
      return $dot;
    }; //	/unbind_events


    $dot.watch = function () {
      $dot.unwatch();

      if (opts.watch == 'window') {
        var $window = $(window),
            _wWidth = $window.width(),
            _wHeight = $window.height();

        $window.bind('resize.dot' + conf.dotId, function () {
          if (_wWidth != $window.width() || _wHeight != $window.height() || !opts.windowResizeFix) {
            _wWidth = $window.width();
            _wHeight = $window.height();

            if (watchInt) {
              clearInterval(watchInt);
            }

            watchInt = setTimeout(function () {
              $dot.trigger('update.dot');
            }, 100);
          }
        });
      } else {
        watchOrg = getSizes($dot);
        watchInt = setInterval(function () {
          if ($dot.is(':visible')) {
            var watchNew = getSizes($dot);

            if (watchOrg.width != watchNew.width || watchOrg.height != watchNew.height) {
              $dot.trigger('update.dot');
              watchOrg = watchNew;
            }
          }
        }, 500);
      }

      return $dot;
    };

    $dot.unwatch = function () {
      $(window).unbind('resize.dot' + conf.dotId);

      if (watchInt) {
        clearInterval(watchInt);
      }

      return $dot;
    };

    var opts = $.extend(true, {}, $.fn.dotdotdot.defaults, o),
        conf = {},
        watchOrg = {},
        watchInt = null,
        $inr = null;

    if (!(opts.lastCharacter.remove instanceof Array)) {
      opts.lastCharacter.remove = $.fn.dotdotdot.defaultArrays.lastCharacter.remove;
    }

    if (!(opts.lastCharacter.noEllipsis instanceof Array)) {
      opts.lastCharacter.noEllipsis = $.fn.dotdotdot.defaultArrays.lastCharacter.noEllipsis;
    }

    conf.afterElement = getElement(opts.after, $dot);
    conf.isTruncated = false;
    conf.dotId = dotId++;
    $dot.data('dotdotdot', true).bind_events().trigger('update.dot');

    if (opts.watch) {
      $dot.watch();
    }

    return $dot;
  }; //	public


  $.fn.dotdotdot.defaults = {
    'ellipsis': '... ',
    'wrap': 'word',
    'fallbackToLetter': true,
    'lastCharacter': {},
    'tolerance': 0,
    'callback': null,
    'after': null,
    'height': null,
    'watch': false,
    'windowResizeFix': true,
    'maxLength': null
  };
  $.fn.dotdotdot.defaultArrays = {
    'lastCharacter': {
      'remove': [' ', "\u3000", ',', ';', '.', '!', '?'],
      'noEllipsis': []
    }
  };

  $.fn.dotdotdot.debug = function (msg) {}; //	private


  var dotId = 1;

  function children($elem, o, after) {
    var $elements = $elem.children(),
        isTruncated = false;
    $elem.empty();

    for (var a = 0, l = $elements.length; a < l; a++) {
      var $e = $elements.eq(a);
      $elem.append($e);

      if (after) {
        $elem.append(after);
      }

      if (test($elem, o)) {
        $e.remove();
        isTruncated = true;
        break;
      } else {
        if (after) {
          after.detach();
        }
      }
    }

    return isTruncated;
  }

  function ellipsis($elem, $d, $i, o, after) {
    var isTruncated = false; //	Don't put the ellipsis directly inside these elements

    var notx = 'a, table, thead, tbody, tfoot, tr, col, colgroup, object, embed, param, ol, ul, dl, blockquote, select, optgroup, option, textarea, script, style'; //	Don't remove these elements even if they are after the ellipsis

    var noty = 'script, .dotdotdot-keep';
    $elem.contents().detach().each(function () {
      var e = this,
          $e = $(e);

      if (typeof e == 'undefined') {
        return true;
      } else if ($e.is(noty)) {
        $elem.append($e);
      } else if (isTruncated) {
        return true;
      } else {
        $elem.append($e);

        if (after && !$e.is(o.after) && !$e.find(o.after).length) {
          $elem[$elem.is(notx) ? 'after' : 'append'](after);
        }

        if (test($i, o)) {
          if (e.nodeType == 3) // node is TEXT
            {
              isTruncated = ellipsisElement($e, $d, $i, o, after);
            } else {
            isTruncated = ellipsis($e, $d, $i, o, after);
          }
        }

        if (!isTruncated) {
          if (after) {
            after.detach();
          }
        }
      }
    });
    $d.addClass("is-truncated");
    return isTruncated;
  }

  function ellipsisElement($e, $d, $i, o, after) {
    var e = $e[0];

    if (!e) {
      return false;
    }

    var txt = getTextContent(e),
        space = txt.indexOf(' ') !== -1 ? ' ' : "\u3000",
        separator = o.wrap == 'letter' ? '' : space,
        textArr = txt.split(separator),
        position = -1,
        midPos = -1,
        startPos = 0,
        endPos = textArr.length - 1; //	Only one word

    if (o.fallbackToLetter && startPos === 0 && endPos === 0) {
      separator = '';
      textArr = txt.split(separator);
      endPos = textArr.length - 1;
    }

    if (o.maxLength) {
      txt = addEllipsis(txt.trim().substr(0, o.maxLength), o);
      setTextContent(e, txt);
    } else {
      while (startPos <= endPos && !(startPos === 0 && endPos === 0)) {
        var m = Math.floor((startPos + endPos) / 2);

        if (m == midPos) {
          break;
        }

        midPos = m;
        setTextContent(e, textArr.slice(0, midPos + 1).join(separator) + o.ellipsis);
        $i.children().each(function () {
          $(this).toggle().toggle();
        });

        if (!test($i, o)) {
          position = midPos;
          startPos = midPos;
        } else {
          endPos = midPos; //	Fallback to letter

          if (o.fallbackToLetter && startPos === 0 && endPos === 0) {
            separator = '';
            textArr = textArr[0].split(separator);
            position = -1;
            midPos = -1;
            startPos = 0;
            endPos = textArr.length - 1;
          }
        }
      }

      if (position != -1 && !(textArr.length === 1 && textArr[0].length === 0)) {
        txt = addEllipsis(textArr.slice(0, position + 1).join(separator), o);
        setTextContent(e, txt);
      } else {
        var $w = $e.parent();
        $e.detach();
        var afterLength = after && after.closest($w).length ? after.length : 0;

        if ($w.contents().length > afterLength) {
          e = findLastTextNode($w.contents().eq(-1 - afterLength), $d);
        } else {
          e = findLastTextNode($w, $d, true);

          if (!afterLength) {
            $w.detach();
          }
        }

        if (e) {
          txt = addEllipsis(getTextContent(e), o);
          setTextContent(e, txt);

          if (afterLength && after) {
            var $parent = after.parent();
            $(e).parent().append(after);

            if (!$.trim($parent.html())) {
              $parent.remove();
            }
          }
        }
      }
    }

    return true;
  }

  function test($i, o) {
    return $i.innerHeight() > o.maxHeight || o.maxLength && $i.text().trim().length > o.maxLength;
  }

  function addEllipsis(txt, o) {
    while ($.inArray(txt.slice(-1), o.lastCharacter.remove) > -1) {
      txt = txt.slice(0, -1);
    }

    if ($.inArray(txt.slice(-1), o.lastCharacter.noEllipsis) < 0) {
      txt += o.ellipsis;
    }

    return txt;
  }

  function getSizes($d) {
    return {
      'width': $d.innerWidth(),
      'height': $d.innerHeight()
    };
  }

  function setTextContent(e, content) {
    if (e.innerText) {
      e.innerText = content;
    } else if (e.nodeValue) {
      e.nodeValue = content;
    } else if (e.textContent) {
      e.textContent = content;
    }
  }

  function getTextContent(e) {
    if (e.innerText) {
      return e.innerText;
    } else if (e.nodeValue) {
      return e.nodeValue;
    } else if (e.textContent) {
      return e.textContent;
    } else {
      return "";
    }
  }

  function getPrevNode(n) {
    do {
      n = n.previousSibling;
    } while (n && n.nodeType !== 1 && n.nodeType !== 3);

    return n;
  }

  function findLastTextNode($el, $top, excludeCurrent) {
    var e = $el && $el[0],
        p;

    if (e) {
      if (!excludeCurrent) {
        if (e.nodeType === 3) {
          return e;
        }

        if ($.trim($el.text())) {
          return findLastTextNode($el.contents().last(), $top);
        }
      }

      p = getPrevNode(e);

      while (!p) {
        $el = $el.parent();

        if ($el.is($top) || !$el.length) {
          return false;
        }

        p = getPrevNode($el[0]);
      }

      if (p) {
        return findLastTextNode($(p), $top);
      }
    }

    return false;
  }

  function getElement(e, $i) {
    if (!e) {
      return false;
    }

    if (typeof e === 'string') {
      e = $(e, $i);
      return e.length ? e : false;
    }

    return !e.jquery ? false : e;
  }

  function getTrueInnerHeight($el) {
    var h = $el.innerHeight(),
        a = ['paddingTop', 'paddingBottom'];

    for (var z = 0, l = a.length; z < l; z++) {
      var m = parseInt($el.css(a[z]), 10);

      if (isNaN(m)) {
        m = 0;
      }

      h -= m;
    }

    return h;
  } //	override jQuery.html


  var _orgHtml = $.fn.html;

  $.fn.html = function (str) {
    if (str != undef && !$.isFunction(str) && this.data('dotdotdot')) {
      return this.trigger('update', [str]);
    }

    return _orgHtml.apply(this, arguments);
  }; //	override jQuery.text


  var _orgText = $.fn.text;

  $.fn.text = function (str) {
    if (str != undef && !$.isFunction(str) && this.data('dotdotdot')) {
      str = $('<div />').text(str).html();
      return this.trigger('update', [str]);
    }

    return _orgText.apply(this, arguments);
  };
})(jQuery);
/*

 ## Automatic parsing for CSS classes
 Contributed by [Ramil Valitov](https://github.com/rvalitov)

 ### The idea
 You can add one or several CSS classes to HTML elements to automatically invoke "jQuery.dotdotdot functionality" and some extra features. It allows to use jQuery.dotdotdot only by adding appropriate CSS classes without JS programming.

 ### Available classes and their description
 * dot-ellipsis - automatically invoke jQuery.dotdotdot to this element. This class must be included if you plan to use other classes below.
 * dot-resize-update - automatically update if window resize event occurs. It's equivalent to option `watch:'window'`.
 * dot-timer-update - automatically update at regular intervals using setInterval. It's equivalent to option `watch:true`.
 * dot-load-update - automatically update after the window has beem completely rendered. Can be useful if your content is generated dynamically using using JS and, hence, jQuery.dotdotdot can't correctly detect the height of the element before it's rendered completely.
 * dot-height-XXX - available height of content area in pixels, where XXX is a number, e.g. can be `dot-height-35` if you want to set maximum height for 35 pixels. It's equivalent to option `height:'XXX'`.

 ### Usage examples
 *Adding jQuery.dotdotdot to element*

 <div class="dot-ellipsis">
 <p>Lorem Ipsum is simply dummy text.</p>
 </div>

 *Adding jQuery.dotdotdot to element with update on window resize*

 <div class="dot-ellipsis dot-resize-update">
 <p>Lorem Ipsum is simply dummy text.</p>
 </div>

 *Adding jQuery.dotdotdot to element with predefined height of 50px*

 <div class="dot-ellipsis dot-height-50">
 <p>Lorem Ipsum is simply dummy text.</p>
 </div>

 */


jQuery(document).ready(function ($) {
  //We only invoke jQuery.dotdotdot on elements that have dot-ellipsis class
  $(".dot-ellipsis").each(function () {
    //Checking if update on window resize required
    var watch_window = $(this).hasClass("dot-resize-update"); //Checking if update on timer required

    var watch_timer = $(this).hasClass("dot-timer-update"); //Checking if height set

    var height = 0;
    var classList = $(this).attr('class').split(/\s+/);
    $.each(classList, function (index, item) {
      var matchResult = item.match(/^dot-height-(\d+)$/);
      if (matchResult !== null) height = Number(matchResult[1]);
    }); //Invoking jQuery.dotdotdot

    var x = {};
    if (watch_timer) x.watch = true;
    if (watch_window) x.watch = 'window';
    if (height > 0) x.height = height;
    $(this).dotdotdot(x);
  });
}); //Updating elements (if any) on window.load event

jQuery(window).on('load', function () {
  jQuery(".dot-ellipsis.dot-load-update").trigger("update.dot");
});

(function () {
  $(window).on('load', function () {
    $('.delayLoad').show();
    $('.lazy-load').remove();
    $('.creative-work__title').truncate({
      lines: 3,
      addClass: 'min-height'
    });
    $('.creative-work .loa').truncate({
      lines: 2,
      type: 'list',
      addClass: 'loa-height'
    });
    $('.featured .grid-item:first-child .creative-work__title').truncate({
      lines: 2,
      addClass: 'min-height'
    });
    $('.card .creative-work__title').truncate({
      lines: 2,
      addClass: 'min-height'
    });
    $('.card .creative-work .loa').truncate({
      lines: 1,
      type: 'list',
      addClass: 'loa-height'
    });
  });
  $(window).on('resize orientationchange', function () {
    $('.creative-work__title, .creative-work .loa').truncate();
  });
})();

/* ========================================================================
 * Bootstrap: tab.js v3.3.7
 * http://getbootstrap.com/javascript/#tabs
 * ========================================================================
 * Copyright 2011-2016 Twitter, Inc.
 * Licensed under MIT (https://github.com/twbs/bootstrap/blob/master/LICENSE)
 * ======================================================================== */
+function ($) {
  'use strict'; // TAB CLASS DEFINITION
  // ====================

  var Tab = function Tab(element) {
    // jscs:disable requireDollarBeforejQueryAssignment
    this.element = $(element); // jscs:enable requireDollarBeforejQueryAssignment
  };

  Tab.VERSION = '3.3.7';
  Tab.TRANSITION_DURATION = 150;

  Tab.prototype.show = function () {
    var $this = this.element;
    var $ul = $this.closest('ul:not(.dropdown-menu)');
    var selector = $this.data('target');

    if (!selector) {
      selector = $this.attr('href');
      selector = selector && selector.replace(/.*(?=#[^\s]*$)/, ''); // strip for ie7
    }

    if ($this.parent('li').hasClass('active')) return;
    var $previous = $ul.find('.active:last a');
    var hideEvent = $.Event('hide.bs.tab', {
      relatedTarget: $this[0]
    });
    var showEvent = $.Event('show.bs.tab', {
      relatedTarget: $previous[0]
    });
    $previous.trigger(hideEvent);
    $this.trigger(showEvent);
    if (showEvent.isDefaultPrevented() || hideEvent.isDefaultPrevented()) return;
    var $target = $(selector);
    this.activate($this.closest('li'), $ul);
    this.activate($target, $target.parent(), function () {
      $previous.trigger({
        type: 'hidden.bs.tab',
        relatedTarget: $this[0]
      });
      $this.trigger({
        type: 'shown.bs.tab',
        relatedTarget: $previous[0]
      });
    });
  };

  Tab.prototype.activate = function (element, container, callback) {
    var $active = container.find('> .active');
    var transition = callback && $.support.transition && ($active.length && $active.hasClass('fade') || !!container.find('> .fade').length);

    function next() {
      $active.removeClass('active').find('> .dropdown-menu > .active').removeClass('active').end().find('[data-toggle="tab"]').attr('aria-expanded', false);
      element.addClass('active').find('[data-toggle="tab"]').attr('aria-expanded', true);

      if (transition) {
        element[0].offsetWidth; // reflow for transition

        element.addClass('in');
      } else {
        element.removeClass('fade');
      }

      if (element.parent('.dropdown-menu').length) {
        element.closest('li.dropdown').addClass('active').end().find('[data-toggle="tab"]').attr('aria-expanded', true);
      }

      callback && callback();
    }

    $active.length && transition ? $active.one('bsTransitionEnd', next).emulateTransitionEnd(Tab.TRANSITION_DURATION) : next();
    $active.removeClass('in');
  }; // TAB PLUGIN DEFINITION
  // =====================


  function Plugin(option) {
    return this.each(function () {
      var $this = $(this);
      var data = $this.data('bs.tab');
      if (!data) $this.data('bs.tab', data = new Tab(this));
      if (typeof option == 'string') data[option]();
    });
  }

  var old = $.fn.tab;
  $.fn.tab = Plugin;
  $.fn.tab.Constructor = Tab; // TAB NO CONFLICT
  // ===============

  $.fn.tab.noConflict = function () {
    $.fn.tab = old;
    return this;
  }; // TAB DATA-API
  // ============


  var clickHandler = function clickHandler(e) {
    e.preventDefault();
    Plugin.call($(this), 'show');
  };

  $(document).on('click.bs.tab.data-api', '[data-toggle="tab"]', clickHandler).on('click.bs.tab.data-api', '[data-toggle="pill"]', clickHandler);
}(jQuery);

(function () {
  var $window = $(window),
      $body = $('body');
  $(document).ready(function () {
    $(".tab").each(function () {
      //the rest of this code doesnt seem to support multiple tabs on the page.. but this does
      var activeTab = $(this).find(".tab__nav").find("li.active a").attr("href");

      if (!activeTab && sessionStorage.activeTab) {
        // check "sessionStorage.activeTab" is solution for LIT-189292
        activeTab = sessionStorage.getItem("activeTab");
      }

      if ($(this).find(activeTab).length == 0) {
        activeTab = null;
      } else {
        sessionStorage.setItem("activeTab", "");
      }

      if (!activeTab) activeTab = $(this).find(".tab__nav").find("li:first-of-type a").attr("href");
      $('[href="' + activeTab + '"]').click();
      $(this).find(activeTab).addClass("active");
    });
  });
  var tab = {
    $target: null,
    $toggle: null,
    $li: null,
    $ul: $('.tab__nav'),
    $previous: null,
    $content: null,
    isTouched: false,
    //$controls: null,
    pointerPosition: 0.0,
    cumulativeShift: 0.0,
    vPort: "screen-sm",
    // default responsive break point
    isSlide: false,
    isMobile: false,
    // variable use to determine if responsive mode is on or off
    init: function init() {
      tab.isSlide = $('.tab').hasClass("tab--slide");
      tab.check.viewPort(); // get current view port activator break point
      //tab.$controls  = '<div class="swipe__controls"><span class="swipe__btn--prev"><i class="icon-arrow_l"></i></span><span class="swipe__btn--next"><i class="icon-arrow_r"></i></span></div>';

      tab.on.build();
      tab.control();
      tab.check.empty();
    },
    control: function control() {
      $body.on('click', '.tab-link', function (e) {
        e.preventDefault();
        tab.on.select.external($(this));
      });
      $body.on('click', '[data-mobile-toggle="dropdown"] a, .dropblock--tab a', function (e) {
        tab.on.select.dropdown($(this));
        if ($('.js--open[data-db-target-for]').length) UX.dropBlock.on.hide();
      });
      $body.on('click', '.tab__nav a', function () {
        var $parent = $(this).parents('.tab');

        if ($parent.hasClass('tab--lazy-load')) {
          var targetContent = $(this).attr('href');

          if ($(targetContent).attr('data-ajaxloaded') != 'true') {
            tab.getContent($(targetContent).find('.tab-lazy'));
          }
        }
      });
      $(document).on(tab.vPort + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        tab.isMobile = true;
        $('*[data-slide-target]').addClass('w-slide__btn'); //UX.slide.init()

        $('.tab').addClass("tab--res"); // class will be used in our scss (to replace media queries)

        tab.additionalControl();
        tab.on.rebuild.responsive(); // rebuild tabs to be responsive
      });
      $(document).on(tab.vPort + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
        tab.isMobile = false;
        $('*[data-slide-target]').removeClass('w-slide__btn');
        $('.tab').removeClass("tab--res");
        tab.on.rebuild.original(); // return tabs as default
      }); // Get postback active tab

      tab.setPostbackActiveTab(tab.getPostbackActiveTab());
    },
    additionalControl: function additionalControl() {},
    animate: {
      scroll: function scroll($content, $target) {
        $content.animate({
          scrollTop: $content.scrollTop() + $target.position().top - 40
        }, 600);
      }
    },
    set: {
      target: function target($content, _target, temp) {
        if (!$content.find(_target).length) {
          tab.$target = $content.find("[data-figure-id='" + temp + "']");
        } else {
          tab.$target = $content.find(_target);
        }
      }
    },
    accessibility: {
      /**
       * Accessibility - navigate between content and aside
       * @param elem
       * @param tab
       */
      externalLink: function externalLink(elem, tab) {
        // create focusable option for target
        var tabindex = tab.$target.attr('tabindex');
        tab.$target.attr('tabindex', typeof tabindex === 'undefined' ? -1 : tabindex); // create and append back button to content

        var backLink = $('<button class="btn accessibility-back">Go back to content</button>');

        if (tab.$target.is('a, ul, ol, img, table') || tab.$target.is(':input')) {
          tab.$target.after(backLink);
        } else {
          tab.$target.append(backLink);
        } // revert original state on focus out


        tab.$target.on('focusout.tablink', function (event) {
          $this = $(this);
          $this.off('focusout.tablink'); // revert tabindex to original value

          if (typeof tabindex === 'undefined') {
            $this.removeAttr('tabindex');
          } // remove backbutton if user tabbed out of target by some other means than tabbing to backlink


          if (!$(event.relatedTarget).is(backLink)) {
            backLink.remove();
          }
        }) // provide ESC support for return to content
        .on('keydown.tablink', function (event) {
          $this = $(this); // on escape, return to control

          if (event.which === 27) {
            $this.off('keydown.tablink');
            elem.focus();
            backLink.remove();
          }
        }); // go back to original element if backbutton is activated

        backLink.on('click', function () {
          elem.focus();
        }).on('focusout', function () {
          $(this).remove();
        }); // set focus to target

        tab.$target.focus();
      }
    },
    on: {
      select: {
        external: function external(elem) {
          var target = elem.attr('href'); // get target id

          target = target.split(" ")[0]; //LIT-162636

          tab.$toggle = '#' + elem.data('tab'); //get target pane

          tab.$li = $('.tab__nav [href="' + tab.$toggle + '"]'); // get target tabs nav

          var temp = target.split("#")[1];

          var animateScroll = function animateScroll() {
            tab.$content = $(tab.$toggle).parents(".tab__content");

            if (tab.isMobile) {
              //UX.slide.$toggle = $(this);
              if (tab.isSlide) {
                tab.set.target($(".w-slide__content"), target, temp);

                if (tab.$target.length) {
                  tab.animate.scroll($(".w-slide__content"), tab.$target);
                  tab.$target.attr("tab-index", "1");
                  tab.$target.focus();
                }
              }
            } else {
              tab.set.target(tab.$content, target, temp);
              tab.animate.scroll(tab.$content, tab.$target);
              tab.accessibility.externalLink(elem, tab);
            }
          };

          if ($(tab.$toggle).is(":visible")) {
            tab.$li.click(); // open target tab

            animateScroll();
          } else {
            if ($(tab.$toggle).hasClass('empty')) {
              $(tab.$toggle).on('content-loaded', function () {
                animateScroll();
              });
              tab.$li.click(); // open target tab
            } else {
              tab.$li.click(); // open target tab

              animateScroll();
            }
          }
        },
        dropdown: function dropdown(elem) {
          var dataAttr = elem.closest('ul').data('mobile-toggle');

          if (dataAttr === 'dropdown' || elem.closest('ul').hasClass('dropblock--tab')) {
            var dropdownContainer = elem.closest('.dropBlock');
            dropdownContainer.children('a').find('span').text(elem.text());
          }
        }
      },
      build: function build() {
        //setTimeout(function() {
        tab.$ul.each(function (index) {
          if ($(this).is('.swipe__list')) {
            tab.on.swipeBuild($(this));
          }

          if ($(this).is('.dropblock--tab')) {
            tab.on.dropdownBuild($(this), index);
          }
        }); //}, 200);

        $('.tab--lazy-load').each(function () {
          tab.getContent($(this).find('.tab__pane.active').find('.tab-lazy'));
        });
      },
      calculate: function calculate(elem) {
        var elemParent = elem.parent();
        var tabNavWidth = 25;
        elem.find('li').each(function (index) {
          tabNavWidth += $(this).innerWidth();
        });
        var elemParentWidth = elemParent.width();

        if (elemParentWidth < tabNavWidth) {
          if (!elem.parent().is('.scroll')) {
            tab.on.swipeBuild(elem);
          }
        } else {
          tab.on.swipeDestroy(elem);
        }
      },
      swipeBuild: function swipeBuild(elem) {
        // rebuild tabs to swipe
        var tabNavWidth = 25;
        elem.find('li').each(function (index) {
          tabNavWidth += $(this).innerWidth();
        });
        elem.width(tabNavWidth);
        elem.wrap('<div class="swipe__wrapper"><div class="scroll"></div></div>');
      },
      swipeDestroy: function swipeDestroy(elem) {
        // return tabs to default
        elem.removeAttr('style');
        elem.unwrap('.scroll').unwrap('.swipe__wrapper');
      },
      dropdownBuild: function dropdownBuild(elem, index) {
        // rebuild tabs to be as drop down
        UX.dropBlock.init();
        elem.wrap('<div class="dropBlock" data-db-parent-of="dbTab-' + index + '"></div>');
        var $dropdownContainer = elem.closest('.dropBlock');
        var $activeTab = elem.find('.active a');
        $dropdownContainer.prepend('<a href="#"class="dropBlock__link" data-db-target-for="dbTab-' + index + '"><span>' + $activeTab.text() + '</span><i class="icon-arrow_d_n" aria-hidden="true"></i></a>');
        elem.attr('data-db-target-of', 'dbTab-' + index);
      },
      dropdownDestroy: function dropdownDestroy(elem) {
        // return tabs to default
        var dropdownContainer = elem.closest('.dropBlock');
        dropdownContainer.children('a').remove();
        elem.removeAttr('data-db-target-of').removeClass('js--open').removeAttr('style').unwrap('.dropBlock');
      },
      accordionBuild: function accordionBuild(elem) {
        // rebuild tabs to be as accordion
        var $accourdionElem = elem.next('.tab__content');
        $accourdionElem.addClass('accordion-tabbed').wrap('<div class="accordion"></div>');
        elem.find('a').each(function (index) {
          var $lidiv = $(this);
          var liController = $lidiv.attr('href');
          $(liController).addClass('accordion-tabbed__tab') // transform tabs structure to accordion structure
          .removeClass('tab__pane').wrapInner('<div class="accordion-tabbed__content"></div>');
          var accordionContrl = $lidiv.clone().prependTo(liController).addClass('accordion-tabbed__control'); // clone tabs controller as accordion controller
        });
        elem.hide();
        UX.accordion.init();
        $('.tab__content.accordion-tabbed .accordion-tabbed__tab').removeClass('js--open').find('.accordion-tabbed__content').hide();
        $('.tab__content.accordion-tabbed .accordion-tabbed__tab.active').addClass('js--open').find('.accordion-tabbed__content').show();
      },
      accordionDestroy: function accordionDestroy(elem) {
        // return tabs to default
        elem.next('.accordion').find('.tab__content').removeClass('accordion-tabbed').unwrap('.accordion').find('.accordion-tabbed__tab').each(function (index) {
          var $liDiv = $(this);
          $liDiv.addClass('tab__pane').removeClass('accordion-tabbed__tab js--open');
          var content = $liDiv.find('.accordion-tabbed__content').text();
          $liDiv.html(content);
          elem.show();
        });
        var activeTap = elem.next('.tab__content').find('.active').attr('id');
        elem.find('.active').removeClass('active');
        $('[href="#' + activeTap + '"]').closest('li').addClass('active');
      },
      rebuild: {
        original: function original() {
          // return tabs to be as default
          $('*[data-slide-target]').removeClass('w-slide__btn slide-active');
          tab.$ul = $(".tab__nav");
          tab.$ul.each(function (index) {
            switch ($(this).data('mobile-toggle')) {
              case 'swipe':
                tab.on.swipeDestroy($(this));
                break;

              case 'dropdown':
                tab.on.dropdownDestroy($(this));
                break;

              case 'accordion':
                tab.on.accordionDestroy($(this));
                break;

              case 'slide':
                // rebuild tabs be as accordion
                break;

              default:
              /*if ( $(this).closest('.tab').hasClass('tab--flex') ||  $(this).closest('.tab').hasClass('loi') ||  $(this).hasClass('dropblock--tab') || $(this).closest(".advancedSearch__tabs").length ) {
                  return;
              }else {
                  tab.on.calculate($(this));
              }
              */

            }
          });
          $(document).trigger('init.bs.tab');
        },
        responsive: function responsive() {
          // rebuild tabs to be in selected responsive mode
          $('*[data-slide-target]').addClass('w-slide__btn slide-active');
          tab.$ul = $(".tab__nav");
          tab.$ul.each(function (index) {
            switch ($(this).data('mobile-toggle')) {
              case 'swipe':
                // rebuild tabs to swipe
                if (!$(this).parent().is('.scroll')) {
                  tab.on.swipeBuild($(this));
                }

                break;

              case 'dropdown':
                // rebuild tabs be as dropdown
                if (!$(this).parent().is('.dropBlock')) {
                  tab.on.dropdownBuild($(this), index);
                }

                break;

              case 'accordion':
                // rebuild tabs be as accordion
                if (!$(this).next().hasClass('accordion')) {
                  tab.on.accordionBuild($(this));
                }

                break;

              case 'slide':
                // rebuild tabs be as accordion
                break;

              default: // rebuild tabs to flex

              /*if ( $(this).closest('.tab').hasClass('tab--flex') ||  $(this).closest('.tab').hasClass('loi') ||  $(this).hasClass('dropblock--tab') || $(this).closest(".advancedSearch__tabs").length  ) {
                  return;
              }else {
                  tab.on.calculate($(this));
              }*/

            }
          });
          $(document).trigger('init.bs.tab');
        }
      }
    },
    check: {
      empty: function empty() {
        // check if tab pane is empty and hide it
        $('.tab__nav a').each(function () {
          // go through all tab nav items
          var pane = $(this).attr('href'); // get it's related pane

          if ($(this).is('a:not([href^="#"])') && !$(this).hasClass('external')) {
            return;
          }

          if (!$(this).hasClass('external') && $(pane).length && $(pane).is(':empty')) {
            // if tab nav item is not an external link and check if pane is empty
            $(pane).addClass("empty"); // add class to empty pane

            $(this).addClass("empty"); // add class to empty nav item
          }
        });
      },
      viewPort: function viewPort() {
        $('.tab').each(function () {
          if ($(this).attr('data-ctrl-res')) {
            tab.vPort = $(this).attr('data-ctrl-res');
          }

          
        });
      }
    },
    getPostbackActiveTab: function getPostbackActiveTab() {
      var param = "tabActivePane";
      param = param.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
      var regex = new RegExp("[\\?&]" + param + "=([^&#]*)");
      var results = regex.exec(location.search);
      return results == null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
    },
    setPostbackActiveTab: function setPostbackActiveTab(tabID) {
      if (tabID != "") {
        var $activeTabs = $("a[data-simple-tab-id='" + tabID + "']");

        if ($activeTabs.length > 0) {
          $activeTabs.each(function () {
            $activeTabs.trigger('click');
          });
        }
      }
    },
    getContent: function getContent($elem) {
      var tabId = $elem.attr('data-tabId');
      var widgetId = $elem.attr('data-widgetId');
      var pbContext = encodeURIComponent($('meta[name=pbContext]').attr("content"));
      var $tabBody = $elem.parents('.tab__pane');
      $.ajax({
        url: '/pb/widgets/ux3/lazyTabs/loadTab?pbContext=' + pbContext + '&tabId=' + tabId + '&widgetId=' + widgetId,
        success: function success(data) {
          $tabBody.attr('data-ajaxLoaded', 'true');
          $elem.replaceWith(data);

          if ($tabBody.find('.tab__pane.active').find('.tab-lazy').length) {
            tab.getContent($tabBody.find('.tab__pane.active').find('.tab-lazy'));
          }
        },
        error: function error() {}
      });
    }
  };
  UX.tab = tab; // add to global namespace
})();

(function () {
  var $window = $(window),
      isMobile = false,
      $body = $('body');
  var slide = {
    $slide: null,
    $target: null,
    $contents: null,
    $slideinfo: null,
    $toggle: null,
    prev: null,
    vPort: "screen-sm",
    elementvPort: null,
    back: false,
    nested: false,
    activeSlide: 0,
    oldInfo: [],
    off: null,
    clone: null,
    backLabel: 'back',
    $elements: null,
    init: function init() {
      slide.$slide = '<div class="w-slide"><div class="w-slide_head"><a href="#" class="w-slide__back"><i class=" icon-arrow_l" aria-hidden="true"></i>' + slide.backLabel + '</a><span class="w-slide__title"></span></span></div><div class="w-slide__content"></div></div>';
      slide.$elements = $(slide.$slide);

      if ($("main").length > 0) {
        $('main').append(slide.$elements);
      } else {
        $('body').append(slide.$elements);
      }

      slide.$contents = slide.$elements.find('.w-slide__content');
      slide.$slideinfo = slide.$elements.find('.w-slide__title');
      slide.$back = slide.$elements.find('.w-slide__back');
      slide.$toggle = $('.w-slide__btn');
      slide.elementvPort = slide.vPort;
      slide.vPort = [];

      if ($('.journal-home').length) {
        slide.elementvPort = "screen-md";
      }

      slide.$toggle.each(function (index) {
        slide.check.viewPort($(this), index);
        slide.responsive(index);
      });
      slide.control();
      slide.addtionalControls();

      if (typeof facetDateChart != "undefined") {
        facetDateChart.control();
      }
    },
    responsive: function responsive(index) {
      $(document).on(slide.vPort[index] + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        slide.off = false;
        $('.w-slide__btn').each(function () {
          if ($(this).data('ctrl-res') == slide.vPort[index]) {
            $(this).addClass('slide-active');
          }
        });
      });
      $(document).on(slide.vPort[index] + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        slide.off = true;
        slide.on.off();
        $('.w-slide__btn').each(function () {
          if ($(this).data('ctrl-res') == slide.vPort[index]) {
            $(this).removeClass('slide-active');
          }
        });
      });
    },
    control: function control() {
      $body.on('click', '.w-slide__btn', function (e) {
        if ($(this).hasClass('slide-active')) {
          e.stopPropagation();
          e.preventDefault();
          $(".w-slide, .w-slide__content").css('transition', 'all 250ms');
          slide.$toggle = $(this);
          slide.$target = $(slide.$toggle.data('slide-target'));
          slide.back = false;

          if ($(this).is('[id*=pane-pcw]') && UX.loader.check.empty()) {
            setTimeout(function () {
              slide.on.show();
            }, 3000);
          } else {
            slide.on.show();
          }
        }

        $(".w-slide, .w-slide__content").css('transition', 'all 0ms');
      });
      $body.on('click', '.w-slide__back, .w-slide__hide', function (e) {
        if ($(this).hasClass("w-slide__back")) {
          e.preventDefault();
        }

        $(".w-slide, .w-slide__content").css('transition', 'all 250ms');
        slide.back = true;
        slide.on.hide();
        $(".w-slide, .w-slide__content").css('transition', 'all 0ms');
      });
    },
    addtionalControls: function addtionalControls() {},
    setBackLabel: function setBackLabel() {
      slide.$back.html('<i class=" icon-arrow_l" aria-hidden="true"></i>' + slide.backLabel);
    },
    on: {
      show: function show() {
        $(document).trigger("UX-detach");

        if (typeof jcf != "undefined") {
          jcf.destroy($(".range-slider__range"));
        }

        slide.backLabel = 'back';
        slide.setBackLabel();
        slide.$slideinfo.hide().removeClass('js--open');
        slide.nested = slide.$toggle.parents(".w-slide__content").length > 0;

        if (slide.nested) {
          slide.activeSlide++;
          slide.$contents.append('<div class="w-slide__content nested--' + slide.activeSlide + '"></div>');
          slide.$contents = $('.nested--' + slide.activeSlide);
        }

        slide.$contents.attr('original-target', slide.$toggle.data('slide-target'));

        if (slide.$target.hasClass('tab__pane')) {
          slide.$target.closest('.tab__content').find('.tab__pane').removeClass('active');
          slide.$target.addClass('active');
        }

        if (slide.$toggle.is('[data-label]')) {
          var label = slide.$toggle.data('label');
        } else {
          var label = slide.$toggle.text();
        } //LIT-163835


        if (slide.$toggle.hasClass('loa') || slide.$toggle.parents('.loa.mobile-authors').length > 0) {
          label = "AUTHORS";
        }

        var clonedDiv = slide.$target.children();
        slide.on.destroyJcf(clonedDiv);

        if (slide.$toggle.is('[data-slide-clone]')) {
          slide.clone = slide.$toggle.data('slide-clone');

          if (slide.clone == 'self') {
            var clonedDiv = slide.$target;
          }
        } else {
          slide.clone = "";
        }

        slide.oldInfo.push(label);
        slide.$slideinfo.html(label);
        var isLoi = slide.$target.find('.loi').length > 0;

        if (isLoi) {
          slide.$contents.append(clonedDiv.html());
          $('.dropBlock-loi__holder .loi').remove();
          slide.$contents.find('.loi__list').each(function () {
            UX.loi.on.recalculate($(this));
          });
        } else {
          if (slide.clone == 'self') {
            if (slide.nested) {
              slide.$target.after('<div class="returnNestedDataSlideHere"></div>');
            } else {
              slide.$target.after('<div class="returnDataSlideHere"></div>');
            }
          } else {
            if (slide.nested) {
              slide.$target.append('<div class="returnNestedDataSlideHere"></div>');
            } else {
              slide.$target.append('<div class="returnDataSlideHere"></div>');
            }
          }

          slide.$contents.append(clonedDiv.clone());

          if ((clonedDiv.hasClass('addthis_toolbox') || clonedDiv.find('.addthis_toolbox').length > 0) && addthis) {
            // re-init social links on mobile
            addthis.toolbox('.addthis_toolbox');
          }

          slide.on.rebuildJcf(slide.$contents);
          clonedDiv.remove();
        }

        $body.addClass('lock-screen').attr('data-active', 'slide');
        slide.$back.focus();
        $('.coolBar').addClass('slide');
        /*
        $('.w-slide__title').truncate({
            lines: 1
        });
        */

        if (slide.$toggle.is('[data-full-screen]') && !slide.$toggle.data('[full-screen]')) {
          var slideWidth = 35;
          $body.addClass('w-slide__not-fullWidth');
        } else {
          var slideWidth = 100;
        }

        if (!slide.nested) {
          UX.slide.$elements.css('transform', 'translateX(-' + slideWidth + 'vw)'); //.on('transitionend webkitTransitionEnd oTransitionEnd', function () {
          // if (!slide.back) {

          slide.$slideinfo.show().addClass('js--open'); // }
          //});
        } else {
          slide.$contents.css('transform', 'translateX(-' + slideWidth + 'vw)'); //.on('transitionend webkitTransitionEnd oTransitionEnd', function () {
          // if (!slide.back) {

          slide.$slideinfo.show().addClass('js--open'); // }
          //});
        }

        $(document).trigger("UX-attach");
        slide.on.additionalShow();
      },
      additionalShow: function additionalShow() {},
      hide: function hide(e) {
        slide.$slideinfo.hide().removeClass('js--open');

        if (typeof e != "undefined") {
          if (!$(e.target).closest('.w-slide').length) {
            slide.back = true;
          }
        }

        if (slide.back) {
          slide.nested = true;

          if (slide.activeSlide == 0) {
            slide.nested = false;
            slide.$contents = UX.slide.$elements.children('.w-slide__content');
          } else {
            slide.$contents = $('.nested--' + slide.activeSlide);
          }

          slide.on.destroyJcf(slide.$contents);
          var originalTarget = $(slide.$contents.attr('original-target'));

          if (!originalTarget) {
            originalTarget = $body;
          }

          var isLoi = slide.$elements.find('.loi').length > 0;

          if (isLoi) {
            $('.dropBlock-loi__holder').append(slide.$contents.html());
            $('.dropBlock-loi__holder').find('.loi__list').each(function () {
              UX.loi.on.recalculate($(this));
            });
          } else {
            if (slide.clone == 'self') {
              if (slide.nested) {
                $('.returnNestedDataSlideHere').after(slide.$contents.html());
                $('.returnNestedDataSlideHere').remove();
              } else {
                $('.returnDataSlideHere').after(slide.$contents.html());
                $('.returnDataSlideHere').remove();
              }
            } else {
              if (slide.nested) {
                $('.returnNestedDataSlideHere', originalTarget).after(slide.$contents.html());
                $('.returnNestedDataSlideHere', originalTarget).remove();
              } else {
                $('.returnDataSlideHere', originalTarget).after(slide.$contents.html());
                $('.returnDataSlideHere', originalTarget).remove();
              }
            }

            slide.on.rebuildJcf(originalTarget);
          }

          slide.oldInfo.splice(slide.activeSlide, 1);
          slide.$slideinfo.html(slide.oldInfo[slide.activeSlide - 1]);

          if (slide.$toggle) {
            slide.$toggle.focus();
          }

          if (!slide.nested) {
            $('body, html').removeClass('lock-screen');
            $body.removeClass('lock-screen').removeAttr('data-active');
            $('.coolBar').removeClass('slide');
            UX.slide.$elements.css('transform', 'translateX(0vw)').on('transitionend webkitTransitionEnd oTransitionEnd', function () {
              if (slide.back && !slide.nested) {
                slide.$contents.empty();
              }
            });
          } else {
            slide.activeSlide--;
            slide.$contents.css('transform', 'translateX(0vw)').on('transitionend webkitTransitionEnd oTransitionEnd', function () {
              if (slide.back && slide.nested) {
                $(this).remove();
              }
            });
            slide.$contents = $('.nested--' + slide.activeSlide);

            if (slide.activeSlide == 0) {
              slide.$contents = UX.slide.$elements.children('.w-slide__content');
            }
          }

          slide.$slideinfo.show().addClass('js--open');
        }

        slide.backLabel = 'back';
        slide.setBackLabel();
        slide.on.additionalHide();
      },
      additionalHide: function additionalHide() {},
      off: function off() {
        slide.$slideinfo.hide().removeClass('js--open');
        var isLoi = UX.slide.$elements.find('.loi').length > 0;

        if (isLoi) {
          slide.$contents = $('.loi').closest('.w-slide__content');
          $('.dropBlock-loi__holder').append(slide.$contents.html());
          $('.dropBlock-loi__holder').find('.loi__list').each(function () {
            UX.loi.on.recalculate($(this));
          });
        }

        $('body, html').removeClass('lock-screen');
        $body.removeClass('lock-screen').removeAttr('data-active');
        $('.coolBar').removeClass('slide');
        slide.$contents = UX.slide.$elements.children('.w-slide__content');
        UX.slide.$elements.css('transform', 'translateX(0vw)').on('transitionend webkitTransitionEnd oTransitionEnd', function () {
          if (slide.off) {
            slide.$contents.empty();
          }
        });
      },
      destroyJcf: function destroyJcf($el) {
        if (typeof jcf != "undefined") {
          jcf.destroy($el.find('.jcf'));
        }
      },
      rebuildJcf: function rebuildJcf($el) {
        if (typeof jcf != "undefined") {
          jcf.replace($el.find('.jcf'));
        }
      }
    },
    check: {
      viewPort: function viewPort($el, index) {
        if (typeof $el.data('ctrl-res') != 'undefined') {
          slide.vPort[index] = $el.data('ctrl-res');
        } else {
          $el.data('ctrl-res', slide.elementvPort);
          slide.vPort[index] = slide.elementvPort;
        }
      }
    }
  };
  UX.slide = slide; // add to global namespace
})();

UX.slide.on.destroyJcf = function ($el) {};

UX.slide.on.rebuildJcf = function ($el) {};

(function () {
  var $body = $('body');
  var fieldsCtrl = {
    container: null,
    $wrapper: null,
    $toggle: null,
    $form: null,
    $terms: null,
    $markAll: null,
    maxClone: 2,
    init: function init() {
      fieldsCtrl.$toggle = $('.reproducible');
      fieldsCtrl.$wrapper = $('.reproducible__wrapper');
      fieldsCtrl.container = '.reproducible__container'; // Support for the legacy emails and phones used in account page
      //fieldsCtrl.check.terms();

      fieldsCtrl.control();
      var $lastTerm = fieldsCtrl.$wrapper.children('.reproducible').length;
      fieldsCtrl.check.lastClone($lastTerm);
      fieldsCtrl.accessibility.init();
    },
    accessibility: {
      init: function init() {
        this.radioCheckbox();
        this.selectBox();
        this.buttons();
      },
      radioCheckbox: function radioCheckbox() {
        $('.radio--primary, .checkbox--primary').each(function () {
          $(this).attr({
            tabindex: 0
          });
          $(this).on('keydown', function (event) {
            if (event.which === 13) {
              $(this).click();
            }
          });
        });
      },
      selectBox: function selectBox() {
        // JCF selectbox
        $(document).on('mousedown', '.jcf-select', function (event) {
          $(this).attr({
            tabindex: 0
          });
          $(this).focus();
        }).on('mouseup', '.jcf-select', function (event) {
          $(this).removeAttr('tabindex');
          $(this).siblings('.jcf-hidden').focus();
        });
        $(document).on('keydown', 'select.jcf-hidden', function (event) {
          if (event.which === 13) {
            event.preventDefault();
          } else if (event.which === 27 && $(this).siblings('.jcf-drop-active').length > 0) {
            event.which = 13;
            $(this).trigger(event);
          }
        });
      },
      buttons: function buttons() {
        // Remove HREF on a[role=button] as screen-reader would read whole page URL otherwise on focus
        $('[role=button]').each(function () {
          var $this = $(this);
          var href = $this.attr('href');
          href = href === '#' ? null : href;
          var target = $this.data('target');
          $this.attr({
            'data-target': target || href,
            'tabindex': 0
          });
          $this.removeAttr('href');
        }); // Enable Screen reader standard behavior on space and enter for [role=buttons] to be consistent with normal button element

        $(document).on('keydown', '[role=button]', function (event) {
          if (event.which === 32 || event.which === 13) {
            event.preventDefault();
            $(this).click();
          }
        });
      }
    },
    control: function control() {
      $body.on('keypress click', '[class*="-ctrl-field"]', function (e) {
        e.preventDefault();

        if (e.which === 13 || e.type === 'click') {
          fieldsCtrl.$wrapper = $(this).closest('.reproducible__wrapper');
          fieldsCtrl.$toggle = $(this).closest('.reproducible');
          fieldsCtrl.$terms = $(this).closest('.reproducible__wrapper').find('.reproducible'); // LIT-161778 Support for the legacy emails and phones used in account page

          if ($(fieldsCtrl.container).length == 0) {
            if ($(this).is('.add-ctrl-field')) {
              if (fieldsCtrl.$terms.length < fieldsCtrl.maxClone + 1) {
                fieldsCtrl.on.clone($(this));
              }
            } else {
              if (fieldsCtrl.$terms.length > 1) {
                fieldsCtrl.on.remove($(this));
              }
            }
          }
        }
      });
      $body.on('click', '[name="markall"]', function (e) {
        fieldsCtrl.on.markAll($(this));
      });
    },
    on: {
      clone: function clone($this) {
        jcf.destroy($('.reproducible .jcf'));
        fieldsCtrl.$toggle.clone(true, true).find('input').val('').end().appendTo(fieldsCtrl.$wrapper);
        $('.reproducible .jcf').each(function () {
          jcf.replace($(this));
        });
        fieldsCtrl.check.terms($this);
        var $lastTerm = fieldsCtrl.$wrapper.children('.reproducible').length;
        fieldsCtrl.check.lastClone($lastTerm);
      },
      remove: function remove($this) {
        fieldsCtrl.$toggle.remove();
        fieldsCtrl.check.terms($this);
        var $lastTerm = fieldsCtrl.$wrapper.children('.reproducible').length;
        fieldsCtrl.check.lastClone($lastTerm);
      },
      markAll: function markAll($el) {
        fieldsCtrl.$markAll = $el.closest('.markAll');

        if ($el.prop('checked')) {
          fieldsCtrl.$markAll.find('[type="checkbox"]').prop('checked', true);
        } else {
          fieldsCtrl.$markAll.find('[type="checkbox"]').prop('checked', false);
        }
      }
    },
    check: {
      terms: function terms($this) {
        var nameInput = $this.closest('.reproducible').find('input').attr('name');

        if (nameInput) {
          var before = nameInput.split("[");
          var after = before[1].split("]");
        }
        /*var matches = nameInput.match(/\[(.*?)\]/);
        if (matches) {
            var submatch = matches[1];
        }*/
        // Support for the legacy emails and phones used in account page


        if ($(fieldsCtrl.container).length == 0) {
          fieldsCtrl.$terms = $('.reproducible');
        } else {
          fieldsCtrl.$terms = $this.parents(fieldsCtrl.container).find('.reproducible');
        }

        var copy_from_template = 0;
        fieldsCtrl.$terms.each(function (index) {
          var $el = $(this);

          if ($el.parents('.template').length) {
            copy_from_template = 1;
          } else {
            var number = index - copy_from_template;
            $(this).find('input').attr('name', before[0] + "[" + number + "]" + after[1]);
          }
        }); // fieldsCtrl.$terms = $('.reproducible');
        //
        // fieldsCtrl.$terms.each(function (index) {
        //     var number = index;
        //
        //     $(this).find('input').attr('name', before[0] + "[" + index + "]" + after[1]);
        //
        // });
      },
      lastClone: function lastClone($this) {
        if ($this == fieldsCtrl.maxClone) {
          fieldsCtrl.$wrapper.children('.reproducible:last-child').children('.add-ctrl-field').addClass('hidden');
        } else {
          fieldsCtrl.$wrapper.children('.reproducible:last-child').children('.add-ctrl-field').removeClass('hidden');
        }
      }
    }
  };
  UX.fieldsCtrl = fieldsCtrl; // add to global namespace
})();

UX.fieldsCtrl.init = function () {
  UX.fieldsCtrl.$toggle = $('.reproducible');
  UX.fieldsCtrl.$wrapper = $('.reproducible__wrapper');
  UX.fieldsCtrl.container = '.reproducible__container'; // Support for the legacy emails and phones used in account page

  UX.fieldsCtrl.control();
  var $lastTerm = UX.fieldsCtrl.$wrapper.children('.reproducible').length;
  UX.fieldsCtrl.check.lastClone($lastTerm);
};

UX.fieldsCtrl.on.clone = function ($this) {
  UX.fieldsCtrl.$toggle.clone(true, true).find('input').val('').end().appendTo(UX.fieldsCtrl.$wrapper);
  UX.fieldsCtrl.check.terms($this);
  var $lastTerm = UX.fieldsCtrl.$wrapper.children('.reproducible').length;
  UX.fieldsCtrl.check.lastClone($lastTerm);
};

(function () {
  var $window = $(window),
      $body = $('body');
  var slider = {
    $slider: null,
    options: {},
    vPort: "always",
    // default responsive break point
    isMobile: false,
    init: function init() {
      slider.additionalInit();
      slider.on.build();
      slider.control();
      slider.additionalControls();
    },
    control: function control() {
      $body.on('click', '.owl-play', function () {
        slider.$slider = $(this).closest('.owl-carousel');
        slider.$slider.data('owl.carousel').options.autoplay = true;
        slider.$slider.trigger('refresh.owl.carousel'); //slider.$slider.trigger('play.owl.autoplay');
      });
      $body.on('click', '.owl-pause', function () {
        slider.$slider = $(this).closest('.owl-carousel');
        slider.$slider.trigger('stop.owl.autoplay');
      });
      $body.on('touchend', '.owl-pause, .owl-play, .owl-prev, .owl-next', function () {
        $(this).css('background', '#d6d6d6');
      });
      $('body').on('touchstart', '.owl-pause, .owl-play, .owl-prev, .owl-next', function () {
        $(this).css('background', '#869791');
      });
      $('.owl-carousel').each(function () {
        var $element = $(this);

        if (typeof $element.closest('.viewport-slider').data("slider-vport") != 'undefined') {
          slider.vPort = $element.closest('.viewport-slider').data("slider-vport");
          $(document).on(slider.vPort + '-on', function () {
            // Waiting for custom event that will be triggered by controller.js to activate responsive effects
            slider.isMobile = true;
            slider.get.options($element, true);
          });
          $(document).on(slider.vPort + '-off', function () {
            // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
            slider.isMobile = false;
            slider.on.destroy($element);
          });
        }
      });

      if ($('.owl-item:not(.cloned)').first().hasClass('active')) {
        $('.owl-nav .owl-next').addClass('owl-nav-active');
      }
    },
    additionalInit: function additionalInit() {},
    additionalControls: function additionalControls() {},

    /**
     * Accessibility for owl carousel
     * @namespace
     * @property {boolean} _flagChangeFocus - flag to inform translate to change focus, when we cannot pass this information in event
     */
    accessibility: {
      /**
       * @name _flagChangeFocus
       * @type Boolean
       * @default false
       * @protected
       */
      _flagChangeFocus: false,

      /**
       * Setup slider accessibility
       * @param {jQuery} $slider - jQuery object of Owl carousel container .owl-carousel
       * @public
       */
      setup: function setup($slider) {
        // make slides accessible
        this.slider($slider); // apply meta info to next and previous buttons and make them focusable

        $slider.find('.owl-prev').attr({
          'role': 'button',
          'title': 'Go to previous slide',
          'aria-label': 'Go to previous slide',
          'tabindex': '0'
        });
        $slider.find('.owl-next').attr({
          'role': 'button',
          'title': 'Go to next slide',
          'aria-label': 'Go to next slide',
          'tabindex': '0'
        });
        $slider.find('.owl-dot').each(function () {
          var $dot = $(this);
          $dot.attr({
            'role': 'button',
            'title': 'Go to slide: ' + ($dot.index() + 1),
            'aria-label': 'Go to slide: ' + ($dot.index() + 1),
            'tabindex': '0'
          });
        }); // make root element focusable

        var $root = $slider.find('.owl-stage');
        var label = $slider.data('label') || "Slideshow";
        $root.attr({
          'role': 'listbox',
          'aria-label': label,
          // @todo aria-labeled-by if we have data for it, we don't right now
          'tabindex': '0'
        });
        $slider.find('.owl-item').attr({
          'role': 'option'
        }); // make root element id and use it for aria controls

        var id = $root.attr('id');

        if (!id) {
          id = 'slider' + UX.utils.generateId();
          $root.attr('id', id);
        } // make Controls to inform screen readers what they control


        $slider.find('.owl-nav, .owl-dots, .owl-controls').attr({
          'role': 'navigation',
          'aria-label': label,
          'aria-controls': id
        }); // listen for keyboard input

        this.keyboardControls($slider); // make slider accessible by tab key

        this.keyboardTabAccess($slider); // handle autoplay carousels

        this.handleAutoplay($slider); // make dots accessible

        this.dots($slider);
      },

      /**
       * Setup keyboard navigation for slider
       * @param {jQuery} $slider - jQuery object of Owl carousel container .owl-carousel
       * @protected
       */
      keyboardControls: function keyboardControls($slider) {
        $slider.on('keydown', function (e) {
          slider.$slider = $(this);
          var $focusedElement = $(document.activeElement),
              type = e.which == 39 ? 'next' : null,
              type = e.which == 37 ? 'prev' : type,
              type = e.which == 13 ? 'enter' : type; // use left and right arrow keys to navigate

          if (type == 'next') {
            slider.accessibility._flagChangeFocus = true; // flag to change focus after change

            slider.$slider.trigger('next.owl.carousel');
          } else if (type == 'prev') {
            slider.accessibility._flagChangeFocus = true; // flag to change focus after change

            slider.$slider.trigger('prev.owl.carousel');
          } else if (type == 'enter') {
            // if the prev and next buttons are focused, catch "Enter" and navigate in the right direction
            if ($focusedElement.hasClass('owl-next')) {
              slider.$slider.trigger('next.owl.carousel');
            } else if ($focusedElement.hasClass('owl-prev')) {
              slider.$slider.trigger('prev.owl.carousel');
            } else if ($focusedElement.hasClass('owl-dot') || $focusedElement.hasClass('owl-play') || $focusedElement.hasClass('owl-pause')) {
              $focusedElement.trigger('click');
            }
          }
        });
        $slider.on('translated.owl.carousel', function (event) {
          // change focus to first tabbable element in slide
          if (slider.accessibility._flagChangeFocus) {
            slider.accessibility._flagChangeFocus = false;
            var $slide = $(event.target).find('.owl-item').eq(event.item.index);
            $slide.find(':tabbable').first().focus();
          }

          slider.accessibility.slider($slider);
        });
      },

      /**
       * Setup tab key access for slider
       * @param {jQuery} $slider - jQuery object of Owl carousel container .owl-carousel
       * @see inspired by Peppermint.js slider [https://wd.dizaina.net/en/scripts/peppermint/]
       * @protected
       */
      keyboardTabAccess: function keyboardTabAccess($slider) {
        $slider.find('.owl-item').each(function () {
          var slide = this;
          var $slide = $(slide); //IE fallback first

          slide.onfocusin = function () {
            slider.accessibility.slide($slide, 'enable');
            slider.accessibility.slide($slide, 'show');
            slider.$slider = $(this).closest('.owl-carousel');
            var oneOwl = slider.$slider.data('owl.carousel'),
                stageToReset = slider.$slider.find('.owl-stage-outer')[0],
                indexOfFocusedSlide = oneOwl.relative($(this).index()); //Reset the scroll

            stageToReset.scrollLeft = 0; //WebKit sets the scroll after the event, we need to reset it with zero timeout.
            //Keep the first reset to prevent jittering in other browsers

            setTimeout(function () {
              stageToReset.scrollLeft = 0;
            }, 0); //switch to the slide containing the event

            slider.$slider.trigger('to.owl.carousel', indexOfFocusedSlide);
          }; //Now use the function bound to `onfocusin` in a regular `addEventListener`


          if (slide.addEventListener) slide.addEventListener('focus', slide.onfocusin, true); //`true` turns on the capturing
        });
      },

      /**
       * Make dots navigation accessible
       * @param $slider
       */
      dots: function dots($slider) {
        $slider.find('.owl-dot').on('click', function () {
          /**
           * Solution for outlines here:
           *
           * Blur this, while we don't want to outline to be visible in this case
           * but we want to see outline when user cycle through page by tab key
           *
           * solution combined with CSS rule - to don't display outline, when mouse button is pressed
           *  .owl-dot:active:focus {
           *      outline: none;
           *  }
           *
           */
          $(this).blur();
          slider.accessibility._flagChangeFocus = true; // flag to change focus after change
        });
      },

      /**
       * Make controls accessible
       * @param $slider
       * @public
       */
      controls: function controls($slider) {
        $slider.find('.owl-play').attr({
          'role': 'button',
          'title': 'Play slideshow',
          'aria-label': 'Play slideshow',
          'tabindex': '0'
        }).on('click', function () {
          $slider.removeAttr('data-pause');
        });
        $slider.find('.owl-pause').attr({
          'role': 'button',
          'title': 'Pause slideshow',
          'aria-label': 'Pause slideshow',
          'tabindex': '0'
        }).on('click', function () {
          $slider.attr({
            'data-pause': 'true'
          });
        });
      },

      /**
       * Pause on focus if auto-play is enabled
       * @see aria-live documentation
       * @param {jQuery} $slider
       */
      handleAutoplay: function handleAutoplay($slider) {
        var autoplay = $slider.data('autoplay');

        if (autoplay) {
          $slider.attr({
            'aria-live': 'off'
          });
          $slider.bind('focusin', function (event) {
            $(this).attr({
              'aria-live': 'polite'
            });

            if (event.target && ($(event.target).hasClass('owl-play') || $(event.target).hasClass('owl-pause'))) {
              // don't stop autoplay on controls
              return;
            }

            $(this).trigger('stop.owl.autoplay');
          }).bind('focusout', function () {
            if (!$slider.data('pause')) {
              $(this).trigger('play.owl.autoplay');
            }

            $(this).attr({
              'aria-live': 'off'
            });
          });
        }
      },

      /**
       * Set attributes for slider based on active slide
       * This is only wrapper function to avoid necessity of finding slides in function call
       * @param {jQuery} $slider - jQuery object of Owl carousel container .owl-carousel
       * @public
       */
      slider: function slider($slider) {
        this.slides($slider.find('.owl-item'));
      },

      /**
       * Set attributes for slides based on active slide and cloned slides
       * This is the main logic for handling accessibility visibility to be correctly read by screen readers, etc.
       * @param {jQuery} $slides - jQuery collection of slides
       * @public
       */
      slides: function slides($slides) {
        // hide all
        this.slide($slides, 'hide'); // disable cloned items to skip duplicate slides

        this.slide($slides.filter('.cloned'), 'disable'); // enable clone in case it becomes active

        this.slide($slides.filter('.cloned.active'), 'enable'); // show active

        this.slide($slides.filter('.active'));
      },

      /**
       * Handle one slide - mixed methods
       * @param {jQuery} $slide - collections of slides or one slide
       * @param {('show'|'hide'|'enable'|'disable')} [action] - available methods
       * @public
       */
      slide: function slide($slide, action) {
        var actions = {
          /**
           * let screen readers know an item is active
           * set aria visible on active slide
           * @param {jQuery} $slide - collections of slides or one slide
           * @private
           */
          show: function show($slide) {
            $slide.attr('aria-selected', 'true');
            $slide.attr('aria-hidden', 'false');
          },

          /**
           * set aria hidden on all slides
           * @param {jQuery} $slide - collections of slides or one slide
           * @private
           */
          hide: function hide($slide) {
            $slide.attr('aria-selected', 'false');
            $slide.attr('aria-hidden', 'true');
          },

          /**
           * enable tab index on in case it becomes active
           * @param {jQuery} $slide - collections of slides or one slide
           * @private
           */
          enable: function enable($slide) {
            $slide.find('[data-was-tabbable]').removeAttr('tabindex').removeAttr('data-was-tabbable');
          },

          /**
           * disable tab index on items to skip duplicate slides in tab order
           * @param {jQuery} $slide - collections of slides or one slide
           * @private
           */
          disable: function disable($slide) {
            $slide.find(':tabbable').attr('data-was-tabbable', true).attr('tabindex', '-1');
          }
        }; // actions logic

        if (typeof action === 'string') {
          if (typeof actions[action] === 'undefined') {
            throw new TypeError('No method named "' + action + '" found.');
          }

          actions[action]($slide);
        } else if (actions.show) {
          // default action
          actions.show($slide);
        }
      }
    },
    get: {
      options: function options($element, pass) {
        slider.$slider = $element;
        slider.speed = slider.$slider.data('speed');
        slider.autoplay = slider.$slider.data('autoplay');
        slider.animation = slider.$slider.data('animation');
        slider.autoWidth = slider.set.autoWidth();

        if (slider.animation === 'fade') {
          slider.animation = 'fadeOut';
        } else if (slider.animation === 'slide') {
          slider.animation = '';
        } else if (slider.animation === 'none') {
          slider.animation = 'fadeOut';
          slider.speed = 0;
        }

        slider.items = slider.$slider.data('items');
        slider.set.responsive();
        slider.indicators = slider.$slider.data('indicators');
        slider.arrow = slider.$slider.data('arrow');
        slider.controls = slider.$slider.data('controls');
        slider.stagePadding = slider.$slider.data('stagepadding');
        UX.slider.loop = UX.slider.$slider.data('loop');
        UX.slider.slideBy = UX.slider.$slider.data('slideby');
        slider.options = {
          stagePadding: slider.stagePadding,
          loop: UX.slider.loop,
          items: slider.items,
          responsive: slider.responsive,
          autoplay: slider.autoplay,
          autoWidth: slider.autoWidth,
          animateOut: slider.animation,
          dots: slider.indicators,
          nav: slider.arrow,
          slideBy: UX.slider.slideBy,
          autoHeight: true,
          autoplayTimeout: slider.speed,
          autoplayHoverPause: slider.autoplay,
          navText: ["<span class='hidden-xs'>prev</span><i class='icon-arrow_l visible-xs'></i>", "<span class='hidden-xs'>next</span><i class='icon-arrow_r visible-xs'></i>"],
          onInitialized: function onInitialized() {
            // allow slider accessibility
            slider.accessibility.setup(slider.$slider);
            slider.$slider.find('.owl-item.active').first().addClass("first");

            if (slider.$slider.closest('.equal-height-slides').length) {
              //make all slide same height if slide container contains ".equal-height-slides" class
              var sliderHeight = slider.$slider.height();

              if (sliderHeight > 0) {
                slider.$slider.find('.owl-item', '.slide-item').css('height', slider.$slider.height());
                slider.$slider.find('.slide-item').css('height', '100%');
              }
            }
          }
        };
        slider.on.activate(slider.$slider, pass);

        if (slider.controls) {
          slider.on.buildControls(slider.$slider);
        }
      },
      responsiveData: function responsiveData() {
        if (slider.$slider.data('responsive')) {
          return slider.$slider.data('responsive');
        } else {
          var responsiveData = slider.$slider.closest('.responsive-slider').data("responsive");

          if (responsiveData) {
            return responsiveData;
          }
        }

        return null;
      }
    },
    set: {
      responsive: function responsive() {
        slider.responsive = slider.get.responsiveData();

        if (slider.responsive) {
          for (var key in slider.responsive) {
            switch (key) {
              case "xsMin":
                slider.responsive[0] = slider.responsive[key];
                break;

              case "smMin":
                slider.responsive[UX.grid.screenXs] = slider.responsive[key];
                break;

              case "mdMin":
                slider.responsive[UX.grid.screenSm] = slider.responsive[key];
                break;

              case "lgMin":
                slider.responsive[UX.grid.screenMd] = slider.responsive[key];
                break;
            }

            delete slider.responsive[key];
          }
        }
      },
      autoWidth: function autoWidth() {
        return false;
      }
    },
    on: {
      destroy: function destroy($element) {
        if (slider.vPort.length > 0) {
          if (!$element.hasClass('slide-removal')) {
            $element.addClass('slide-removal').trigger('destroy.owl.carousel');
            $element.find('.owl-stage-outer').children(':eq(0)').unwrap();
          }
        }
      },
      activate: function activate($element, pass) {
        if (pass || slider.vPort == "always") {
          $element.owlCarousel(slider.options);

          if ($element.hasClass('slide-removal')) {
            $element.removeClass('slide-removal');
          }
        } else {
          if (!$element.hasClass('slide-removal')) {
            $element.addClass('slide-removal');
          }
        }
      },
      build: function build() {
        $('.owl-carousel').each(function (index) {
          if (typeof $(this).closest('.viewport-slider').data("slider-vport") != 'undefined') {
            slider.vPort = $(this).closest('.viewport-slider').data("slider-vport");
          }

          slider.get.options($(this), false);
          $(this).on('changed.owl.carousel', function (e) {
            slider.on.changedSlide($(this), e);
          });
          $(this).on('translated.owl.carousel', function (e) {
            slider.on.translated($(this));
          });
        });
      },
      translated: function translated($slider) {
        $slider.find('.owl-item').removeClass('first');
        $slider.find('.owl-item.active').first().addClass('first');
      },
      changedSlide: function changedSlide($slider, e) {
        if ($slider.find('.owl-item:not(.cloned)').last().hasClass('active')) {
          $slider.find('.owl-nav .owl-next').addClass('owl-nav-active');
          $slider.find('.owl-nav .owl-prev').removeClass('owl-nav-active');
        } else if ($('.owl-item:not(.cloned)').first().hasClass('active')) {
          $slider.find('.owl-nav .owl-prev').addClass('owl-nav-active');
          $slider.find('.owl-nav .owl-next').removeClass('owl-nav-active');
        }
      },
      rebuild: {
        responsive: function responsive() {}
      },
      buildControls: function buildControls(elem) {
        var $owlContainer = elem.find('.owl-stage-outer');

        if (elem.find('.owl-controls').length == 0) {
          $owlContainer.after('<div class="owl-controls"><div class="owl-play">Play</div><div class="owl-pause">Pause</div></div>');
        }

        slider.accessibility.controls(elem);
      }
    }
  };
  UX.slider = slider; // add to global namespace

  /* if (window.PB && window.PB.$) {
   // make this module reinitializes in pageBuilder mode
   window.PB.$(document.documentElement).on("WidgetReinit.slider", slider.init);
   }*/
})();

(function () {
  var trustedPoxy = {
    init: function init() {
      trustedPoxy.control();
    },
    control: function control() {
      $(document).on('change', '.trustedProxyUserId', function () {
        this.closest('form').submit();
      });
    }
  };
  UX.trustedPoxy = trustedPoxy; // add to global namespace
})();

$(document).ready(function () {
  $('.registration__personal .registration__button').on('click', function (e) {
    e.preventDefault();
    alert('Registration magic happens'); //TODO: For testing purposes only, obviously. Delete after registration procedure is implemented

    $(this).parents('.row').slideUp(200);
    $(this).parents('.row').next().find('.accordion__control').click();
  });
});

/**
 * Multiple Selection Component for Bootstrap
 * Check nicolasbize.github.io/magicsuggest/ for latest updates.
 *
 * Author:       Nicolas Bize
 * Created:      Feb 8th 2013
 * Last Updated: Oct 16th 2014
 * Version:      2.1.4
 * Licence:      MagicSuggest is licenced under MIT licence (http://opensource.org/licenses/MIT)
 */
(function ($) {
  "use strict";

  var MagicSuggest = function MagicSuggest(element, options) {
    var ms = this;
    /**
     * Initializes the MagicSuggest component
     */

    var defaults = {
      /**********  CONFIGURATION PROPERTIES ************/

      /**
       * Restricts or allows the user to validate typed entries.
       * Defaults to true.
       */
      allowFreeEntries: true,

      /**
       * Restricts or allows the user to add the same entry more than once
       * Defaults to false.
       */
      allowDuplicates: false,

      /**
       * Additional config object passed to each $.ajax call
       */
      ajaxConfig: {},

      /**
       * If a single suggestion comes out, it is preselected.
       */
      autoSelect: true,

      /**
       * Auto select the first matching item with multiple items shown
       */
      selectFirst: false,

      /**
       * Allow customization of query parameter
       */
      queryParam: 'query',

      /**
       * A function triggered just before the ajax request is sent, similar to jQuery
       */
      beforeSend: function beforeSend() {},

      /**
       * A custom CSS class to apply to the field's underlying element.
       */
      cls: '',

      /**
       * JSON Data source used to populate the combo box. 3 options are available here:
       * No Data Source (default)
       *    When left null, the combo box will not suggest anything. It can still enable the user to enter
       *    multiple entries if allowFreeEntries is * set to true (default).
       * Static Source
       *    You can pass an array of JSON objects, an array of strings or even a single CSV string as the
       *    data source.For ex. data: [* {id:0,name:"Paris"}, {id: 1, name: "New York"}]
       *    You can also pass any json object with the results property containing the json array.
       * Url
       *     You can pass the url from which the component will fetch its JSON data.Data will be fetched
       *     using a POST ajax request that will * include the entered text as 'query' parameter. The results
       *     fetched from the server can be:
       *     - an array of JSON objects (ex: [{id:...,name:...},{...}])
       *     - a string containing an array of JSON objects ready to be parsed (ex: "[{id:...,name:...},{...}]")
       *     - a JSON object whose data will be contained in the results property
       *      (ex: {results: [{id:...,name:...},{...}]
       * Function
       *     You can pass a function which returns an array of JSON objects  (ex: [{id:...,name:...},{...}])
       *     The function can return the JSON data or it can use the first argument as function to handle the data.
       *     Only one (callback function or return value) is needed for the function to succeed.
       *     See the following example:
       *     function (response) { var myjson = [{name: 'test', id: 1}]; response(myjson); return myjson; }
       */
      data: null,

      /**
       * Additional parameters to the ajax call
       */
      dataUrlParams: {},

      /**
       * Start the component in a disabled state.
       */
      disabled: false,

      /**
       * Name of JSON object property that defines the disabled behaviour
       */
      disabledField: null,

      /**
       * Name of JSON object property displayed in the combo list
       */
      displayField: 'name',

      /**
       * Set to false if you only want mouse interaction. In that case the combo will
       * automatically expand on focus.
       */
      editable: true,

      /**
       * Set starting state for combo.
       */
      expanded: false,

      /**
       * Automatically expands combo on focus.
       */
      expandOnFocus: false,

      /**
       * JSON property by which the list should be grouped
       */
      groupBy: null,

      /**
       * Set to true to hide the trigger on the right
       */
      hideTrigger: false,

      /**
       * Set to true to highlight search input within displayed suggestions
       */
      highlight: true,

      /**
       * A custom ID for this component
       */
      id: null,

      /**
       * A class that is added to the info message appearing on the top-right part of the component
       */
      infoMsgCls: '',

      /**
       * Additional parameters passed out to the INPUT tag. Enables usage of AngularJS's custom tags for ex.
       */
      inputCfg: {},

      /**
       * The class that is applied to show that the field is invalid
       */
      invalidCls: 'ms-inv',

      /**
       * Set to true to filter data results according to case. Useless if the data is fetched remotely
       */
      matchCase: false,

      /**
       * Once expanded, the combo's height will take as much room as the # of available results.
       *    In case there are too many results displayed, this will fix the drop down height.
       */
      maxDropHeight: 290,

      /**
       * Defines how long the user free entry can be. Set to null for no limit.
       */
      maxEntryLength: null,

      /**
       * A function that defines the helper text when the max entry length has been surpassed.
       */
      maxEntryRenderer: function maxEntryRenderer(v) {
        return 'Please reduce your entry by ' + v + ' character' + (v > 1 ? 's' : '');
      },

      /**
       * The maximum number of results displayed in the combo drop down at once.
       */
      maxSuggestions: null,

      /**
       * The maximum number of items the user can select if multiple selection is allowed.
       *    Set to null to remove the limit.
       */
      maxSelection: 10,

      /**
       * A function that defines the helper text when the max selection amount has been reached. The function has a single
       *    parameter which is the number of selected elements.
       */
      maxSelectionRenderer: function maxSelectionRenderer(v) {
        return 'You cannot choose more than ' + v + ' item' + (v > 1 ? 's' : '');
      },

      /**
       * The method used by the ajax request.
       */
      method: 'POST',

      /**
       * The minimum number of characters the user must type before the combo expands and offers suggestions.
       */
      minChars: 0,

      /**
       * A function that defines the helper text when not enough letters are set. The function has a single
       *    parameter which is the difference between the required amount of letters and the current one.
       */
      minCharsRenderer: function minCharsRenderer(v) {
        return 'Please type ' + v + ' more character' + (v > 1 ? 's' : '');
      },

      /**
       * Whether or not sorting / filtering should be done remotely or locally.
       * Use either 'local' or 'remote'
       */
      mode: 'local',

      /**
       * The name used as a form element.
       */
      name: null,

      /**
       * The text displayed when there are no suggestions.
       */
      noSuggestionText: 'No suggestions',

      /**
       * The default placeholder text when nothing has been entered
       */
      placeholder: 'Type or click here',

      /**
       * A function used to define how the items will be presented in the combo
       */
      renderer: null,

      /**
       * Whether or not this field should be required
       */
      required: false,

      /**
       * Set to true to render selection as a delimited string
       */
      resultAsString: false,

      /**
       * Text delimiter to use in a delimited string.
       */
      resultAsStringDelimiter: ',',

      /**
       * Name of JSON object property that represents the list of suggested objects
       */
      resultsField: 'results',

      /**
       * A custom CSS class to add to a selected item
       */
      selectionCls: '',

      /**
       * An optional element replacement in which the selection is rendered
       */
      selectionContainer: null,

      /**
       * Where the selected items will be displayed. Only 'right', 'bottom' and 'inner' are valid values
       */
      selectionPosition: 'inner',

      /**
       * A function used to define how the items will be presented in the tag list
       */
      selectionRenderer: null,

      /**
       * Set to true to stack the selectioned items when positioned on the bottom
       *    Requires the selectionPosition to be set to 'bottom'
       */
      selectionStacked: false,

      /**
       * Direction used for sorting. Only 'asc' and 'desc' are valid values
       */
      sortDir: 'asc',

      /**
       * name of JSON object property for local result sorting.
       *    Leave null if you do not wish the results to be ordered or if they are already ordered remotely.
       */
      sortOrder: null,

      /**
       * If set to true, suggestions will have to start by user input (and not simply contain it as a substring)
       */
      strictSuggest: false,

      /**
       * Custom style added to the component container.
       */
      style: '',

      /**
       * If set to true, the combo will expand / collapse when clicked upon
       */
      toggleOnClick: false,

      /**
       * Amount (in ms) between keyboard registers.
       */
      typeDelay: 400,

      /**
       * If set to true, tab won't blur the component but will be registered as the ENTER key
       */
      useTabKey: false,

      /**
       * If set to true, using comma will validate the user's choice
       */
      useCommaKey: true,

      /**
       * Determines whether or not the results will be displayed with a zebra table style
       */
      useZebraStyle: false,

      /**
       * initial value for the field
       */
      value: null,

      /**
       * name of JSON object property that represents its underlying value
       */
      valueField: 'id',

      /**
       * regular expression to validate the values against
       */
      vregex: null,

      /**
       * type to validate against
       */
      vtype: null
    };
    var conf = $.extend({}, options);
    var cfg = $.extend(true, {}, defaults, conf);
    /**********  PUBLIC METHODS ************/

    /**
     * Add one or multiple json items to the current selection
     * @param items - json object or array of json objects
     * @param isSilent - (optional) set to true to suppress 'selectionchange' event from being triggered
     */

    this.addToSelection = function (items, isSilent) {
      if (!cfg.maxSelection || _selection.length < cfg.maxSelection) {
        if (!$.isArray(items)) {
          items = [items];
        }

        var valuechanged = false;
        $.each(items, function (index, json) {
          if (cfg.allowDuplicates || $.inArray(json[cfg.valueField], ms.getValue()) === -1) {
            _selection.push(json);

            valuechanged = true;
          }
        });

        if (valuechanged === true) {
          self._renderSelection();

          this.empty();

          if (isSilent !== true) {
            $(this).trigger('selectionchange', [this, this.getSelection()]);
          }
        }
      }

      this.input.attr('placeholder', cfg.selectionPosition === 'inner' && this.getValue().length > 0 ? '' : cfg.placeholder);
    };
    /**
     * Clears the current selection
     * @param isSilent - (optional) set to true to suppress 'selectionchange' event from being triggered
     */


    this.clear = function (isSilent) {
      this.removeFromSelection(_selection.slice(0), isSilent); // clone array to avoid concurrency issues
    };
    /**
     * Collapse the drop down part of the combo
     */


    this.collapse = function () {
      if (cfg.expanded === true) {
        this.combobox.detach();
        cfg.expanded = false;
        $(this).trigger('collapse', [this]);
      }
    };
    /**
     * Set the component in a disabled state.
     */


    this.disable = function () {
      this.container.addClass('ms-ctn-disabled');
      cfg.disabled = true;
      ms.input.attr('disabled', true);
    };
    /**
     * Empties out the combo user text
     */


    this.empty = function () {
      this.input.val('');
    };
    /**
     * Set the component in a enable state.
     */


    this.enable = function () {
      this.container.removeClass('ms-ctn-disabled');
      cfg.disabled = false;
      ms.input.attr('disabled', false);
    };
    /**
     * Expand the drop drown part of the combo.
     */


    this.expand = function () {
      if (!cfg.expanded && (this.input.val().length >= cfg.minChars || this.combobox.children().size() > 0)) {
        this.combobox.appendTo(this.container);

        self._processSuggestions();

        cfg.expanded = true;
        $(this).trigger('expand', [this]);
      }
    };
    /**
     * Retrieve component enabled status
     */


    this.isDisabled = function () {
      return cfg.disabled;
    };
    /**
     * Checks whether the field is valid or not
     * @return {boolean}
     */


    this.isValid = function () {
      var valid = cfg.required === false || _selection.length > 0;

      if (cfg.vtype || cfg.vregex) {
        $.each(_selection, function (index, item) {
          valid = valid && self._validateSingleItem(item[cfg.valueField]);
        });
      }

      return valid;
    };
    /**
     * Gets the data params for current ajax request
     */


    this.getDataUrlParams = function () {
      return cfg.dataUrlParams;
    };
    /**
     * Gets the name given to the form input
     */


    this.getName = function () {
      return cfg.name;
    };
    /**
     * Retrieve an array of selected json objects
     * @return {Array}
     */


    this.getSelection = function () {
      return _selection;
    };
    /**
     * Retrieve the current text entered by the user
     */


    this.getRawValue = function () {
      return ms.input.val();
    };
    /**
     * Retrieve an array of selected values
     */


    this.getValue = function () {
      return $.map(_selection, function (o) {
        return o[cfg.valueField];
      });
    };
    /**
     * Remove one or multiples json items from the current selection
     * @param items - json object or array of json objects
     * @param isSilent - (optional) set to true to suppress 'selectionchange' event from being triggered
     */


    this.removeFromSelection = function (items, isSilent) {
      if (!$.isArray(items)) {
        items = [items];
      }

      var valuechanged = false;
      $.each(items, function (index, json) {
        var i = $.inArray(json[cfg.valueField], ms.getValue());

        if (i > -1) {
          _selection.splice(i, 1);

          valuechanged = true;
        }
      });

      if (valuechanged === true) {
        self._renderSelection();

        if (isSilent !== true) {
          $(this).trigger('selectionchange', [this, this.getSelection()]);
        }

        if (cfg.expandOnFocus) {
          ms.expand();
        }

        if (cfg.expanded) {
          self._processSuggestions();
        }
      }

      this.input.attr('placeholder', cfg.selectionPosition === 'inner' && this.getValue().length > 0 ? '' : cfg.placeholder);
    };
    /**
     * Get current data
     */


    this.getData = function () {
      return _cbData;
    };
    /**
     * Set up some combo data after it has been rendered
     * @param data
     */


    this.setData = function (data) {
      cfg.data = data;

      self._processSuggestions();
    };
    /**
     * Sets the name for the input field so it can be fetched in the form
     * @param name
     */


    this.setName = function (name) {
      cfg.name = name;

      if (name) {
        cfg.name += name.indexOf('[]') > 0 ? '' : '[]';
      }

      if (ms._valueContainer) {
        $.each(ms._valueContainer.children(), function (i, el) {
          el.name = cfg.name;
        });
      }
    };
    /**
     * Sets the current selection with the JSON items provided
     * @param items
     */


    this.setSelection = function (items) {
      this.clear();
      this.addToSelection(items);
    };
    /**
     * Sets a value for the combo box. Value must be an array of values with data type matching valueField one.
     * @param data
     */


    this.setValue = function (values) {
      var items = [];
      $.each(values, function (index, value) {
        // first try to see if we have the full objects from our data set
        var found = false;
        $.each(_cbData, function (i, item) {
          if (item[cfg.valueField] == value) {
            items.push(item);
            found = true;
            return false;
          }
        });

        if (!found) {
          if (_typeof(value) === 'object') {
            items.push(value);
          } else {
            var json = {};
            json[cfg.valueField] = value;
            json[cfg.displayField] = value;
            items.push(json);
          }
        }
      });

      if (items.length > 0) {
        this.addToSelection(items);
      }
    };
    /**
     * Sets data params for subsequent ajax requests
     * @param params
     */


    this.setDataUrlParams = function (params) {
      cfg.dataUrlParams = $.extend({}, params);
    };
    /**********  PRIVATE ************/


    var _selection = [],
        // selected objects
    _comboItemHeight = 0,
        // height for each combo item.
    _timer,
        _hasFocus = false,
        _groups = null,
        _cbData = [],
        _ctrlDown = false,
        KEYCODES = {
      BACKSPACE: 8,
      TAB: 9,
      ENTER: 13,
      CTRL: 17,
      ESC: 27,
      SPACE: 32,
      UPARROW: 38,
      DOWNARROW: 40,
      COMMA: 188
    };

    var self = {
      /**
       * Empties the result container and refills it with the array of json results in input
       * @private
       */
      _displaySuggestions: function _displaySuggestions(data) {
        ms.combobox.show();
        ms.combobox.empty();
        var resHeight = 0,
            // total height taken by displayed results.
        nbGroups = 0;

        if (_groups === null) {
          self._renderComboItems(data);

          resHeight = _comboItemHeight * data.length;
        } else {
          for (var grpName in _groups) {
            nbGroups += 1;
            $('<div/>', {
              'class': 'ms-res-group',
              html: grpName
            }).appendTo(ms.combobox);

            self._renderComboItems(_groups[grpName].items, true);
          }

          var _groupItemHeight = ms.combobox.find('.ms-res-group').outerHeight();

          if (_groupItemHeight !== null) {
            var tmpResHeight = nbGroups * _groupItemHeight;
            resHeight = _comboItemHeight * data.length + tmpResHeight;
          } else {
            resHeight = _comboItemHeight * (data.length + nbGroups);
          }
        }

        if (resHeight < ms.combobox.height() || resHeight <= cfg.maxDropHeight) {
          ms.combobox.height(resHeight);
        } else if (resHeight >= ms.combobox.height() && resHeight > cfg.maxDropHeight) {
          ms.combobox.height(cfg.maxDropHeight);
        }

        if (data.length === 1 && cfg.autoSelect === true) {
          ms.combobox.children().filter(':not(.ms-res-item-disabled):last').addClass('ms-res-item-active');
        }

        if (cfg.selectFirst === true) {
          ms.combobox.children().filter(':not(.ms-res-item-disabled):first').addClass('ms-res-item-active');
        }

        if (data.length === 0 && ms.getRawValue() !== "") {
          var noSuggestionText = cfg.noSuggestionText.replace(/\{\{.*\}\}/, ms.input.val());

          self._updateHelper(noSuggestionText);

          ms.collapse();
        } // When free entry is off, add invalid class to input if no data matches


        if (cfg.allowFreeEntries === false) {
          if (data.length === 0) {
            $(ms.input).addClass(cfg.invalidCls);
            ms.combobox.hide();
          } else {
            $(ms.input).removeClass(cfg.invalidCls);
          }
        }
      },

      /**
       * Returns an array of json objects from an array of strings.
       * @private
       */
      _getEntriesFromStringArray: function _getEntriesFromStringArray(data) {
        var json = [];
        $.each(data, function (index, s) {
          var entry = {};
          entry[cfg.displayField] = entry[cfg.valueField] = $.trim(s);
          json.push(entry);
        });
        return json;
      },

      /**
       * Replaces html with highlighted html according to case
       * @param html
       * @private
       */
      _highlightSuggestion: function _highlightSuggestion(html) {
        var q = ms.input.val(); //escape special regex characters

        var specialCharacters = ['^', '$', '*', '+', '?', '.', '(', ')', ':', '!', '|', '{', '}', '[', ']'];
        $.each(specialCharacters, function (index, value) {
          q = q.replace(value, "\\" + value);
        });

        if (q.length === 0) {
          return html; // nothing entered as input
        }

        var glob = cfg.matchCase === true ? 'g' : 'gi';
        return html.replace(new RegExp('(' + q + ')(?!([^<]+)?>)', glob), '<em>$1</em>');
      },

      /**
       * Moves the selected cursor amongst the list item
       * @param dir - 'up' or 'down'
       * @private
       */
      _moveSelectedRow: function _moveSelectedRow(dir) {
        if (!cfg.expanded) {
          ms.expand();
        }

        var list, start, active, scrollPos;
        list = ms.combobox.find(".ms-res-item:not(.ms-res-item-disabled)");

        if (dir === 'down') {
          start = list.eq(0);
        } else {
          start = list.filter(':last');
        }

        active = ms.combobox.find('.ms-res-item-active:not(.ms-res-item-disabled):first');

        if (active.length > 0) {
          if (dir === 'down') {
            start = active.nextAll('.ms-res-item:not(.ms-res-item-disabled)').first();

            if (start.length === 0) {
              start = list.eq(0);
            }

            scrollPos = ms.combobox.scrollTop();
            ms.combobox.scrollTop(0);

            if (start[0].offsetTop + start.outerHeight() > ms.combobox.height()) {
              ms.combobox.scrollTop(scrollPos + _comboItemHeight);
            }
          } else {
            start = active.prevAll('.ms-res-item:not(.ms-res-item-disabled)').first();

            if (start.length === 0) {
              start = list.filter(':last');
              ms.combobox.scrollTop(_comboItemHeight * list.length);
            }

            if (start[0].offsetTop < ms.combobox.scrollTop()) {
              ms.combobox.scrollTop(ms.combobox.scrollTop() - _comboItemHeight);
            }
          }
        }

        list.removeClass("ms-res-item-active");
        start.addClass("ms-res-item-active");
      },

      /**
       * According to given data and query, sort and add suggestions in their container
       * @private
       */
      _processSuggestions: function _processSuggestions(source) {
        var json = null,
            data = source || cfg.data;

        if (data !== null) {
          if (typeof data === 'function') {
            data = data.call(ms, ms.getRawValue());
          }

          if (typeof data === 'string') {
            // get results from ajax
            $(ms).trigger('beforeload', [ms]);
            var queryParams = {};
            queryParams[cfg.queryParam] = ms.input.val();
            var params = $.extend(queryParams, cfg.dataUrlParams);
            $.ajax($.extend({
              type: cfg.method,
              url: data,
              data: params,
              beforeSend: cfg.beforeSend,
              success: function success(asyncData) {
                json = typeof asyncData === 'string' ? JSON.parse(asyncData) : asyncData;

                self._processSuggestions(json);

                $(ms).trigger('load', [ms, json]);

                if (self._asyncValues) {
                  ms.setValue(typeof self._asyncValues === 'string' ? JSON.parse(self._asyncValues) : self._asyncValues);

                  self._renderSelection();

                  delete self._asyncValues;
                }
              },
              error: function error() {
                throw "Could not reach server";
              }
            }, cfg.ajaxConfig));
            return;
          } else {
            // results from local array
            if (data.length > 0 && typeof data[0] === 'string') {
              // results from array of strings
              _cbData = self._getEntriesFromStringArray(data);
            } else {
              // regular json array or json object with results property
              _cbData = data[cfg.resultsField] || data;
            }
          }

          var sortedData = cfg.mode === 'remote' ? _cbData : self._sortAndTrim(_cbData);

          self._displaySuggestions(self._group(sortedData));
        }
      },

      /**
       * Render the component to the given input DOM element
       * @private
       */
      _render: function _render(el) {
        ms.setName(cfg.name); // make sure the form name is correct
        // holds the main div, will relay the focus events to the contained input element.

        ms.container = $('<div/>', {
          'class': 'ms-ctn form-control ' + (cfg.resultAsString ? 'ms-as-string ' : '') + cfg.cls + ($(el).hasClass('input-lg') ? ' input-lg' : '') + ($(el).hasClass('input-sm') ? ' input-sm' : '') + (cfg.disabled === true ? ' ms-ctn-disabled' : '') + (cfg.editable === true ? '' : ' ms-ctn-readonly') + (cfg.hideTrigger === false ? '' : ' ms-no-trigger'),
          style: cfg.style,
          id: cfg.id
        });
        ms.container.focus($.proxy(handlers._onFocus, this));
        ms.container.blur($.proxy(handlers._onBlur, this));
        ms.container.keydown($.proxy(handlers._onKeyDown, this));
        ms.container.keyup($.proxy(handlers._onKeyUp, this)); // holds the input field

        ms.input = $('<input/>', $.extend({
          type: 'text',
          'class': cfg.editable === true ? '' : ' ms-input-readonly',
          readonly: !cfg.editable,
          placeholder: cfg.placeholder,
          disabled: cfg.disabled
        }, cfg.inputCfg));
        ms.input.focus($.proxy(handlers._onInputFocus, this));
        ms.input.click($.proxy(handlers._onInputClick, this)); // holds the suggestions. will always be placed on focus

        ms.combobox = $('<div/>', {
          'class': 'ms-res-ctn dropdown-menu'
        }).height(cfg.maxDropHeight); // bind the onclick and mouseover using delegated events (needs jQuery >= 1.7)

        ms.combobox.on('click', 'div.ms-res-item', $.proxy(handlers._onComboItemSelected, this));
        ms.combobox.on('mouseover', 'div.ms-res-item', $.proxy(handlers._onComboItemMouseOver, this));

        if (cfg.selectionContainer) {
          ms.selectionContainer = cfg.selectionContainer;
          $(ms.selectionContainer).addClass('ms-sel-ctn');
        } else {
          ms.selectionContainer = $('<div/>', {
            'class': 'ms-sel-ctn'
          });
        }

        ms.selectionContainer.click($.proxy(handlers._onFocus, this));

        if (cfg.selectionPosition === 'inner' && !cfg.selectionContainer) {
          ms.selectionContainer.append(ms.input);
        } else {
          ms.container.append(ms.input);
        }

        ms.helper = $('<span/>', {
          'class': 'ms-helper ' + cfg.infoMsgCls
        });

        self._updateHelper();

        ms.container.append(ms.helper); // Render the whole thing

        $(el).replaceWith(ms.container);

        if (!cfg.selectionContainer) {
          switch (cfg.selectionPosition) {
            case 'bottom':
              ms.selectionContainer.insertAfter(ms.container);

              if (cfg.selectionStacked === true) {
                ms.selectionContainer.width(ms.container.width());
                ms.selectionContainer.addClass('ms-stacked');
              }

              break;

            case 'right':
              ms.selectionContainer.insertAfter(ms.container);
              ms.container.css('float', 'left');
              break;

            default:
              ms.container.append(ms.selectionContainer);
              break;
          }
        } // holds the trigger on the right side


        if (cfg.hideTrigger === false) {
          ms.trigger = $('<div/>', {
            'class': 'ms-trigger',
            html: '<div class="ms-trigger-ico"></div>'
          });
          ms.trigger.click($.proxy(handlers._onTriggerClick, this));
          ms.container.append(ms.trigger);
        }

        $(window).resize($.proxy(handlers._onWindowResized, this)); // do not perform an initial call if we are using ajax unless we have initial values

        if (cfg.value !== null || cfg.data !== null) {
          if (typeof cfg.data === 'string') {
            self._asyncValues = cfg.value;

            self._processSuggestions();
          } else {
            self._processSuggestions();

            if (cfg.value !== null) {
              ms.setValue(cfg.value);

              self._renderSelection();
            }
          }
        }

        $("body").click(function (e) {
          if (ms.container.hasClass('ms-ctn-focus') && ms.container.has(e.target).length === 0 && e.target.className.indexOf('ms-res-item') < 0 && e.target.className.indexOf('ms-close-btn') < 0 && ms.container[0] !== e.target) {
            handlers._onBlur();
          }
        });

        if (cfg.expanded === true) {
          cfg.expanded = false;
          ms.expand();
        }
      },

      /**
       * Renders each element within the combo box
       * @private
       */
      _renderComboItems: function _renderComboItems(items, isGrouped) {
        var ref = this,
            html = '';
        $.each(items, function (index, value) {
          var displayed = cfg.renderer !== null ? cfg.renderer.call(ref, value) : value[cfg.displayField];
          var disabled = cfg.disabledField !== null && value[cfg.disabledField] === true;
          var resultItemEl = $('<div/>', {
            'class': 'ms-res-item ' + (isGrouped ? 'ms-res-item-grouped ' : '') + (disabled ? 'ms-res-item-disabled ' : '') + (index % 2 === 1 && cfg.useZebraStyle === true ? 'ms-res-odd' : ''),
            html: cfg.highlight === true ? self._highlightSuggestion(displayed) : displayed,
            'data-json': JSON.stringify(value)
          });
          html += $('<div/>').append(resultItemEl).html();
        });
        ms.combobox.append(html);
        _comboItemHeight = ms.combobox.find('.ms-res-item:first').outerHeight();
      },

      /**
       * Renders the selected items into their container.
       * @private
       */
      _renderSelection: function _renderSelection() {
        var ref = this,
            w = 0,
            inputOffset = 0,
            items = [],
            asText = cfg.resultAsString === true && !_hasFocus;
        ms.selectionContainer.find('.ms-sel-item').remove();

        if (ms._valueContainer !== undefined) {
          ms._valueContainer.remove();
        }

        $.each(_selection, function (index, value) {
          var selectedItemEl,
              delItemEl,
              selectedItemHtml = cfg.selectionRenderer !== null ? cfg.selectionRenderer.call(ref, value) : value[cfg.displayField];
          var validCls = self._validateSingleItem(value[cfg.displayField]) ? '' : ' ms-sel-invalid'; // tag representing selected value

          if (asText === true) {
            selectedItemEl = $('<div/>', {
              'class': 'ms-sel-item ms-sel-text ' + cfg.selectionCls + validCls,
              html: selectedItemHtml + (index === _selection.length - 1 ? '' : cfg.resultAsStringDelimiter)
            }).data('json', value);
          } else {
            selectedItemEl = $('<div/>', {
              'class': 'ms-sel-item ' + cfg.selectionCls + validCls,
              html: selectedItemHtml
            }).data('json', value);

            if (cfg.disabled === false) {
              // small cross img
              delItemEl = $('<span/>', {
                'class': 'ms-close-btn'
              }).data('json', value).appendTo(selectedItemEl);
              delItemEl.click($.proxy(handlers._onTagTriggerClick, ref));
            }
          }

          items.push(selectedItemEl);
        });
        ms.selectionContainer.prepend(items); // store the values, behaviour of multiple select

        ms._valueContainer = $('<div/>', {
          style: 'display: none;'
        });
        $.each(ms.getValue(), function (i, val) {
          var el = $('<input/>', {
            type: 'hidden',
            name: cfg.name,
            value: val
          });
          el.appendTo(ms._valueContainer);
        });

        ms._valueContainer.appendTo(ms.selectionContainer);

        if (cfg.selectionPosition === 'inner' && !cfg.selectionContainer) {
          ms.input.width(0);
          inputOffset = ms.input.offset().left - ms.selectionContainer.offset().left;
          w = ms.container.width() - inputOffset - 42;
          ms.input.width(w);
        }

        if (_selection.length === cfg.maxSelection) {
          self._updateHelper(cfg.maxSelectionRenderer.call(this, _selection.length));
        } else {
          ms.helper.hide();
        }
      },

      /**
       * Select an item either through keyboard or mouse
       * @param item
       * @private
       */
      _selectItem: function _selectItem(item) {
        if (cfg.maxSelection === 1) {
          _selection = [];
        }

        ms.addToSelection(item.data('json'));
        item.removeClass('ms-res-item-active');

        if (cfg.expandOnFocus === false || _selection.length === cfg.maxSelection) {
          ms.collapse();
        }

        if (!_hasFocus) {
          ms.input.focus();
        } else if (_hasFocus && (cfg.expandOnFocus || _ctrlDown)) {
          self._processSuggestions();

          if (_ctrlDown) {
            ms.expand();
          }
        }
      },

      /**
       * Sorts the results and cut them down to max # of displayed results at once
       * @private
       */
      _sortAndTrim: function _sortAndTrim(data) {
        var q = ms.getRawValue(),
            filtered = [],
            newSuggestions = [],
            selectedValues = ms.getValue(); // filter the data according to given input

        if (q.length > 0) {
          $.each(data, function (index, obj) {
            var name = obj[cfg.displayField];

            if (cfg.matchCase === true && name.indexOf(q) > -1 || cfg.matchCase === false && name.toLowerCase().indexOf(q.toLowerCase()) > -1) {
              if (cfg.strictSuggest === false || name.toLowerCase().indexOf(q.toLowerCase()) === 0) {
                filtered.push(obj);
              }
            }
          });
        } else {
          filtered = data;
        } // take out the ones that have already been selected


        $.each(filtered, function (index, obj) {
          if (cfg.allowDuplicates || $.inArray(obj[cfg.valueField], selectedValues) === -1) {
            newSuggestions.push(obj);
          }
        }); // sort the data

        if (cfg.sortOrder !== null) {
          newSuggestions.sort(function (a, b) {
            if (a[cfg.sortOrder] < b[cfg.sortOrder]) {
              return cfg.sortDir === 'asc' ? -1 : 1;
            }

            if (a[cfg.sortOrder] > b[cfg.sortOrder]) {
              return cfg.sortDir === 'asc' ? 1 : -1;
            }

            return 0;
          });
        } // trim it down


        if (cfg.maxSuggestions && cfg.maxSuggestions > 0) {
          newSuggestions = newSuggestions.slice(0, cfg.maxSuggestions);
        }

        return newSuggestions;
      },
      _group: function _group(data) {
        // build groups
        if (cfg.groupBy !== null) {
          _groups = {};
          $.each(data, function (index, value) {
            var props = cfg.groupBy.indexOf('.') > -1 ? cfg.groupBy.split('.') : cfg.groupBy;
            var prop = value[cfg.groupBy];

            if (typeof props != 'string') {
              prop = value;

              while (props.length > 0) {
                prop = prop[props.shift()];
              }
            }

            if (_groups[prop] === undefined) {
              _groups[prop] = {
                title: prop,
                items: [value]
              };
            } else {
              _groups[prop].items.push(value);
            }
          });
        }

        return data;
      },

      /**
       * Update the helper text
       * @private
       */
      _updateHelper: function _updateHelper(html) {
        ms.helper.html(html);

        if (!ms.helper.is(":visible")) {
          ms.helper.fadeIn();
        }
      },

      /**
       * Validate an item against vtype or vregex
       * @private
       */
      _validateSingleItem: function _validateSingleItem(value) {
        if (cfg.vregex !== null && cfg.vregex instanceof RegExp) {
          return cfg.vregex.test(value);
        } else if (cfg.vtype !== null) {
          switch (cfg.vtype) {
            case 'alpha':
              return /^[a-zA-Z_]+$/.test(value);

            case 'alphanum':
              return /^[a-zA-Z0-9_]+$/.test(value);

            case 'email':
              return /^(\w+)([\-+.][\w]+)*@(\w[\-\w]*\.){1,5}([A-Za-z]){2,6}$/.test(value);

            case 'url':
              return /(((^https?)|(^ftp)):\/\/([\-\w]+\.)+\w{2,3}(\/[%\-\w]+(\.\w{2,})?)*(([\w\-\.\?\\\/+@&#;`~=%!]*)(\.\w{2,})?)*\/?)/i.test(value);

            case 'ipaddress':
              return /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/.test(value);
          }
        }

        return true;
      }
    };
    var handlers = {
      /**
       * Triggered when blurring out of the component
       * @private
       */
      _onBlur: function _onBlur() {
        ms.container.removeClass('ms-ctn-focus');
        ms.collapse();
        _hasFocus = false;

        if (ms.getRawValue() !== '' && cfg.allowFreeEntries === true) {
          var obj = {};
          obj[cfg.displayField] = obj[cfg.valueField] = ms.getRawValue().trim();
          ms.addToSelection(obj);
        }

        self._renderSelection();

        if (ms.isValid() === false) {
          ms.container.addClass(cfg.invalidCls);
        } else if (ms.input.val() !== '' && cfg.allowFreeEntries === false) {
          ms.empty();

          self._updateHelper('');
        }

        $(ms).trigger('blur', [ms]);
      },

      /**
       * Triggered when hovering an element in the combo
       * @param e
       * @private
       */
      _onComboItemMouseOver: function _onComboItemMouseOver(e) {
        var target = $(e.currentTarget);

        if (!target.hasClass('ms-res-item-disabled')) {
          ms.combobox.children().removeClass('ms-res-item-active');
          target.addClass('ms-res-item-active');
        }
      },

      /**
       * Triggered when an item is chosen from the list
       * @param e
       * @private
       */
      _onComboItemSelected: function _onComboItemSelected(e) {
        var target = $(e.currentTarget);

        if (!target.hasClass('ms-res-item-disabled')) {
          self._selectItem($(e.currentTarget));
        }
      },

      /**
       * Triggered when focusing on the container div. Will focus on the input field instead.
       * @private
       */
      _onFocus: function _onFocus() {
        ms.input.focus();
      },

      /**
       * Triggered when clicking on the input text field
       * @private
       */
      _onInputClick: function _onInputClick() {
        if (ms.isDisabled() === false && _hasFocus) {
          if (cfg.toggleOnClick === true) {
            if (cfg.expanded) {
              ms.collapse();
            } else {
              ms.expand();
            }
          }
        }
      },

      /**
       * Triggered when focusing on the input text field.
       * @private
       */
      _onInputFocus: function _onInputFocus() {
        if (ms.isDisabled() === false && !_hasFocus) {
          _hasFocus = true;
          ms.container.addClass('ms-ctn-focus');
          ms.container.removeClass(cfg.invalidCls);
          var curLength = ms.getRawValue().length;

          if (cfg.expandOnFocus === true) {
            ms.expand();
          }

          if (_selection.length === cfg.maxSelection) {
            self._updateHelper(cfg.maxSelectionRenderer.call(this, _selection.length));
          } else if (curLength < cfg.minChars) {
            self._updateHelper(cfg.minCharsRenderer.call(this, cfg.minChars - curLength));
          }

          self._renderSelection();

          $(ms).trigger('focus', [ms]);
        }
      },

      /**
       * Triggered when the user presses a key while the component has focus
       * This is where we want to handle all keys that don't require the user input field
       * since it hasn't registered the key hit yet
       * @param e keyEvent
       * @private
       */
      _onKeyDown: function _onKeyDown(e) {
        // check how tab should be handled
        var active = ms.combobox.find('.ms-res-item-active:not(.ms-res-item-disabled):first'),
            freeInput = ms.input.val();
        $(ms).trigger('keydown', [ms, e]);

        if (e.keyCode === KEYCODES.TAB && (cfg.useTabKey === false || cfg.useTabKey === true && active.length === 0 && ms.input.val().length === 0)) {
          handlers._onBlur();

          return;
        }

        switch (e.keyCode) {
          case KEYCODES.BACKSPACE:
            if (freeInput.length === 0 && ms.getSelection().length > 0 && cfg.selectionPosition === 'inner') {
              _selection.pop();

              self._renderSelection();

              $(ms).trigger('selectionchange', [ms, ms.getSelection()]);
              ms.input.attr('placeholder', cfg.selectionPosition === 'inner' && ms.getValue().length > 0 ? '' : cfg.placeholder);
              ms.input.focus();
              e.preventDefault();
            }

            break;

          case KEYCODES.TAB:
          case KEYCODES.ESC:
            e.preventDefault();
            break;

          case KEYCODES.ENTER:
            if (freeInput !== '' || cfg.expanded) {
              e.preventDefault();
            }

            break;

          case KEYCODES.COMMA:
            if (cfg.useCommaKey === true) {
              e.preventDefault();
            }

            break;

          case KEYCODES.CTRL:
            _ctrlDown = true;
            break;

          case KEYCODES.DOWNARROW:
            e.preventDefault();

            self._moveSelectedRow("down");

            break;

          case KEYCODES.UPARROW:
            e.preventDefault();

            self._moveSelectedRow("up");

            break;

          default:
            if (_selection.length === cfg.maxSelection) {
              e.preventDefault();
            }

            break;
        }
      },

      /**
       * Triggered when a key is released while the component has focus
       * @param e
       * @private
       */
      _onKeyUp: function _onKeyUp(e) {
        var freeInput = ms.getRawValue(),
            inputValid = $.trim(ms.input.val()).length > 0 && (!cfg.maxEntryLength || $.trim(ms.input.val()).length <= cfg.maxEntryLength),
            selected,
            obj = {};

        if (/(^\s$)|(\s\s+)/g.test(freeInput)) {
          return;
        }

        $(ms).trigger('keyup', [ms, e]);
        clearTimeout(_timer); // collapse if escape, but keep focus.

        if (e.keyCode === KEYCODES.ESC && cfg.expanded) {
          ms.combobox.hide();
        } // ignore a bunch of keys


        if (e.keyCode === KEYCODES.TAB && cfg.useTabKey === false || e.keyCode > KEYCODES.ENTER && e.keyCode < KEYCODES.SPACE) {
          if (e.keyCode === KEYCODES.CTRL) {
            _ctrlDown = false;
          }

          return;
        }

        switch (e.keyCode) {
          case KEYCODES.UPARROW:
          case KEYCODES.DOWNARROW:
            e.preventDefault();
            break;

          case KEYCODES.ENTER:
          case KEYCODES.TAB:
          case KEYCODES.COMMA:
            if (e.keyCode !== KEYCODES.COMMA || cfg.useCommaKey === true) {
              e.preventDefault();

              if (cfg.expanded === true) {
                // if a selection is performed, select it and reset field
                selected = ms.combobox.find('.ms-res-item-active:not(.ms-res-item-disabled):first');

                if (selected.length > 0) {
                  self._selectItem(selected);

                  return;
                }
              } // if no selection or if freetext entered and free entries allowed, add new obj to selection


              if (inputValid === true && cfg.allowFreeEntries === true) {
                obj[cfg.displayField] = obj[cfg.valueField] = freeInput.trim();
                ms.addToSelection(obj);
                ms.collapse(); // reset combo suggestions

                ms.input.focus();
              }

              break;
            }

          default:
            if (_selection.length === cfg.maxSelection) {
              self._updateHelper(cfg.maxSelectionRenderer.call(this, _selection.length));
            } else {
              if (freeInput.length < cfg.minChars) {
                self._updateHelper(cfg.minCharsRenderer.call(this, cfg.minChars - freeInput.length));

                if (cfg.expanded === true) {
                  ms.collapse();
                }
              } else if (cfg.maxEntryLength && freeInput.length > cfg.maxEntryLength) {
                self._updateHelper(cfg.maxEntryRenderer.call(this, freeInput.length - cfg.maxEntryLength));

                if (cfg.expanded === true) {
                  ms.collapse();
                }
              } else {
                ms.helper.hide();

                if (cfg.minChars <= freeInput.length) {
                  _timer = setTimeout(function () {
                    if (cfg.expanded === true) {
                      self._processSuggestions();
                    } else {
                      ms.expand();
                    }
                  }, cfg.typeDelay);
                }
              }
            }

            break;
        }
      },

      /**
       * Triggered when clicking upon cross for deletion
       * @param e
       * @private
       */
      _onTagTriggerClick: function _onTagTriggerClick(e) {
        ms.removeFromSelection($(e.currentTarget).data('json'));
      },

      /**
       * Triggered when clicking on the small trigger in the right
       * @private
       */
      _onTriggerClick: function _onTriggerClick() {
        if (ms.isDisabled() === false && !(cfg.expandOnFocus === true && _selection.length === cfg.maxSelection)) {
          $(ms).trigger('triggerclick', [ms]);

          if (cfg.expanded === true) {
            ms.collapse();
          } else {
            var curLength = ms.getRawValue().length;

            if (curLength >= cfg.minChars) {
              ms.input.focus();
              ms.expand();
            } else {
              self._updateHelper(cfg.minCharsRenderer.call(this, cfg.minChars - curLength));
            }
          }
        }
      },

      /**
       * Triggered when the browser window is resized
       * @private
       */
      _onWindowResized: function _onWindowResized() {
        self._renderSelection();
      }
    }; // startup point

    if (element !== null) {
      self._render(element);
    }
  };

  $.fn.magicSuggest = function (options) {
    var obj = $(this);

    if (obj.size() === 1 && obj.data('magicSuggest')) {
      return obj.data('magicSuggest');
    }

    obj.each(function (i) {
      // assume $(this) is an element
      var cntr = $(this); // Return early if this element already has a plugin instance

      if (cntr.data('magicSuggest')) {
        return;
      }

      if (this.nodeName.toLowerCase() === 'select') {
        // rendering from select
        options.data = [];
        options.value = [];
        $.each(this.children, function (index, child) {
          if (child.nodeName && child.nodeName.toLowerCase() === 'option') {
            options.data.push({
              id: child.value,
              name: child.text
            });

            if ($(child).attr('selected')) {
              options.value.push(child.value);
            }
          }
        });
      }

      var def = {}; // set values from DOM container element

      $.each(this.attributes, function (i, att) {
        def[att.name] = att.name === 'value' && att.value !== '' ? JSON.parse(att.value) : att.value;
      });
      var field = new MagicSuggest(this, $.extend([], $.fn.magicSuggest.defaults, options, def));
      cntr.data('magicSuggest', field);
      field.container.data('magicSuggest', field);
    });

    if (obj.size() === 1) {
      return obj.data('magicSuggest');
    }

    return obj;
  };

  $.fn.magicSuggest.defaults = {};
})(jQuery);

(function () {
  var quickSearch = {
    autoCompeteSearchUrl: "",
    suggestedData: [],
    enteredTerm: "",
    inputElem: "",
    maxWords: "",
    maxChars: "",
    confNumOfContributors: "",
    confNumOfHistoryItems: "",
    confNumOfPublicationTitles: "",
    confNumOfTopics: "",
    selectedOption: "",
    seriesKey: "",
    vPort: "screen-md",
    isMobile: false,
    init: function init() {
      quickSearch.inputElem = $('.quick-search .magicsuggest');
      quickSearch.seriesKey = $('input[name=SeriesKey]', '[name=thisJournalQuickSearch]').val();
      quickSearch.controller();
      quickSearch.additionalController();
    },
    controller: function controller() {
      $('.quick-search').find('.magicsuggest').each(function () {
        quickSearch.inputElem = $(this);
        quickSearch.maxWords = $(this).data("auto-complete-max-words");
        quickSearch.maxChars = $(this).data("auto-complete-max-chars");
        var searchType = $(this).parent();
        quickSearch.enteredTerm = $(this).val();

        if (searchType.hasClass('option-citation')) {
          quickSearch.citationSuggestions();
        } else if (searchType.hasClass('option-journal')) {
          quickSearch.journalSearchSuggestions();
        } else {
          quickSearch.searchSuggistions();
        }
      });
      $(document).on('keyup', '[name="defaultQuickSearch"],[name="citationQuickSearch"],[name="thisJournalQuickSearch"]', function (e) {
        if ((e.keyCode || e.which) === 13) {
          var $form = $(e.currentTarget);
          $form.trigger('submit');
        }
      });
      $(document).on('submit', '[name="defaultQuickSearch"],[name="citationQuickSearch"],[name="thisJournalQuickSearch"]', function (e) {
        var empty = true;
        $(this).find('input[type="text"],input[type="search"]').each(function () {
          if ($(this).val() && $(this).val() != '') {
            empty = false;
          }
        });

        if ($(this).find('.ms-sel-item').length > 0) {
          empty = false;
        }

        if (empty) {
          window.location = '/search/advanced';
          e.preventDefault();
        }
      });
    },
    additionalController: function additionalController() {},
    doSuggest: function doSuggest(sug) {
      quickSearch.inputElem.magicSuggest({
        data: sug,
        method: 'GET',
        valueField: 'value',
        autoSelect: false,
        displayField: 'label',
        cls: 'search-term',
        hideTrigger: 'true',
        beforeSend: function beforeSend(xhr, settings) {
          var enteredTerm = settings.url.substr(settings.url.indexOf('query=') + 6).replace(/[​​+]/g, ' ');

          if (enteredTerm.split(" ").length > quickSearch.maxWords || enteredTerm.length > quickSearch.maxChars || !enteredTerm.replace(/\s/g, '').length) {
            return false;
          }
        }
      });
    },
    citationSuggestions: function citationSuggestions() {
      quickSearch.confNumOfPublicationTitles = quickSearch.inputElem.data('publication-titles-conf');
      quickSearch.autoCompeteSearchUrl = '/action/doSuggest?target=title-auto-complete&pts=' + quickSearch.confNumOfPublicationTitles + '&fl=PubID';
      quickSearch.selectedOption = "citation";
      quickSearch.doSuggest(quickSearch.autoCompeteSearchUrl);
    },
    searchSuggistions: function searchSuggistions() {
      quickSearch.confNumOfPublicationTitles = quickSearch.inputElem.data('publication-titles-conf');
      quickSearch.confNumOfContributors = quickSearch.inputElem.data('contributors-conf');
      quickSearch.confNumOfTopics = quickSearch.inputElem.data('topics-conf');
      quickSearch.confNumOfHistoryItems = quickSearch.inputElem.data('history-items-conf');
      quickSearch.autoCompeteSearchUrl = '/action/doSuggest?target=auto-complete&hs=' + quickSearch.confNumOfHistoryItems + '&pts=' + quickSearch.confNumOfPublicationTitles + '&ts=' + quickSearch.confNumOfTopics + '&cs=' + quickSearch.confNumOfContributors + '&fl=PubID';
      quickSearch.doSuggest(quickSearch.autoCompeteSearchUrl);
    },
    journalSearchSuggestions: function journalSearchSuggestions() {
      quickSearch.confNumOfPublicationTitles = quickSearch.inputElem.data('publication-titles-conf');
      quickSearch.confNumOfContributors = quickSearch.inputElem.data('contributors-conf');
      quickSearch.confNumOfTopics = quickSearch.inputElem.data('topics-conf');
      quickSearch.confNumOfHistoryItems = quickSearch.inputElem.data('history-items-conf');
      quickSearch.autoCompeteSearchUrl = '/action/doSuggest?target=auto-complete&hs=' + quickSearch.confNumOfHistoryItems + '&pts=' + quickSearch.confNumOfPublicationTitles + '&ts=' + quickSearch.confNumOfTopics + '&cs=' + quickSearch.confNumOfContributors + '&fl=PubID&within=' + quickSearch.seriesKey;
      quickSearch.doSuggest(quickSearch.autoCompeteSearchUrl);
    }
  };
  UX.quickSearch = quickSearch; // add to global namespace
})();

(function () {
  var $body = $('body');
  var searchFieldsCtrl = {
    $wrapper: null,
    $form: null,
    $terms: null,
    escape: 27,
    dateRangeVal: $('#staticRangeSelect').val(),
    vPort: "screen-sm",
    // default responsive break point
    isMobile: false,
    magicSuggestTrigger: false,
    init: function init() {
      searchFieldsCtrl.$form = $('.advanced-search');
      searchFieldsCtrl.check.submitButton();
      searchFieldsCtrl.check.terms();

      if (searchFieldsCtrl.magicSuggestTrigger) {
        $('.magicsuggest').each(function () {
          searchFieldsCtrl.on.doSuggest($(this));
        });
      }

      searchFieldsCtrl.control();
      searchFieldsCtrl.addtionalControls();
      var $lastTerm = $('.advanced-search--searchIn').find('.searchIn--field:last-child');
      searchFieldsCtrl.check.lastClone($lastTerm);
      searchFieldsCtrl.select.dateRangeRadio($(this));
    },
    control: function control() {
      $body.on('click', '[class*="-ctrl-field"]', function (e) {
        e.preventDefault();
        searchFieldsCtrl.$wrapper = $(this).closest('.searchIn--field');

        if ($(this).is('.add-ctrl-field')) {
          searchFieldsCtrl.$terms = $(this).closest('.advanced-search').find('.searchIn--field');

          if (searchFieldsCtrl.$terms.length < 7) {
            searchFieldsCtrl.on.clone($(this));
          }
        } else {
          searchFieldsCtrl.on.remove($(this));
        }
      });
      $body.on('focus', '.magicsuggest', function () {
        searchFieldsCtrl.on.doSuggest($(this));
      });
      $('.time-frame').on('change', 'select', function () {
        searchFieldsCtrl.select.dateRange($(this));
      });
      $('.time-frame').on('change', 'input', function () {
        searchFieldsCtrl.select.dateRangeRadio($(this));
      });
      $body.on('keyup input', '.searchIn--field input', function () {
        searchFieldsCtrl.$form = $(this).closest('form');
        searchFieldsCtrl.check.submitButton();
      });
      searchFieldsCtrl.click.toggleSearchBlock();
      $(document).on(searchFieldsCtrl.vPort + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        searchFieldsCtrl.isMobile = true;
      });
      $(document).on(searchFieldsCtrl.vPort + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
        searchFieldsCtrl.isMobile = false;
      });
      $('.advanced-search--advancedFilters .radio--primary input').change(function () {
        $('.advanced-search--advancedFilters .radio--primary input').prop('checked', false);
        $(this).prop('checked', true);
      });
      /*$('body').on('input', '.ms-ctn input', function () {
           var $parent = $(this).closest('.ms-ctn');
          if ($(this).val() === '') {
              $parent.find('.ms-res-ctn.dropdown-menu').remove();
          }
       });*/

      $('body').on('change', '#earlyCite', function () {
        // this code added to solve LIT-190918
        var $earlyCite_hidden = $("#earlyCite_hidden");

        if ($earlyCite_hidden.val() == "") {
          $earlyCite_hidden.val("off");
          $earlyCite_hidden.prop("disabled", false);
        } else {
          $earlyCite_hidden.val("");
          $earlyCite_hidden.prop("disabled", true);
        }
      });
    },
    addtionalControls: function addtionalControls() {},
    click: {
      toggleSearchBlock: function toggleSearchBlock() {
        $body.on('click', '.search__result .advanced-search__ctrl', function (e) {
          if (!searchFieldsCtrl.isMobile) {
            e.preventDefault();
            $(this).toggleClass('js--open');
            $('.search-result__meta .advanced-search__tabs').toggle(); //UX.tab.on.calculate($('.search-result__meta .tab__nav'));
          }
        });
      }
    },
    on: {
      clone: function clone($this) {
        jcf.destroy($('.searchIn--field .jcf'));
        searchFieldsCtrl.$wrapper.clone(true, true).find('input').val('').end().appendTo('.advanced-search--searchIn');
        $this.addClass('hidden');
        $this.siblings('.remove-ctrl-field').removeClass('hidden');
        $('.searchIn--field .jcf').each(function () {
          jcf.replace($(this));
        });
        $this = $('.advanced-search--searchIn').children('.searchIn--field:last-child');
        searchFieldsCtrl.check.lastClone($this);
      },
      remove: function remove($this) {
        searchFieldsCtrl.$form = $this.closest('form');
        searchFieldsCtrl.$wrapper.remove();
        searchFieldsCtrl.check.submitButton();
        $this = $('.advanced-search--searchIn').children('.searchIn--field:last-child');
        searchFieldsCtrl.check.lastClone($this);
      },
      doSuggest: function doSuggest($elem) {
        var doSuggestTarget = $elem.data('auto-complete-target');
        var withinData = $elem.data('auto-complete-within');
        var maxWords = 200;
        var maxChars = 222;
        var name = $elem.attr('name');
        var id = $elem.attr('id');
        var values = $elem.attr('data-values') ? JSON.parse($elem.attr('data-values')) : [];

        if (withinData) {
          doSuggestTarget = doSuggestTarget + '&within=' + withinData;
        }

        var $ms = $elem.magicSuggest({
          data: '/action/doSuggest?target=' + doSuggestTarget,
          method: 'GET',
          valueField: 'value',
          autoSelect: false,
          allowFreeEntries: 'false',
          displayField: 'label',
          cls: 'search-term',
          hideTrigger: 'true',
          inputCfg: {
            'id': id,
            'name': name
          },
          beforeSend: function beforeSend(xhr, settings) {
            var enteredTerm = settings.url.substr(settings.url.indexOf('query=') + 6).replace(/[​​+]/g, ' ');

            if (enteredTerm.split(" ").length > maxWords || enteredTerm.length > maxChars || !enteredTerm.replace(/\s/g, '').length) {
              return false;
            }
          }
        });
        $ms.input.focus();

        if (values.length) {
          $ms.setSelection(values);
        }
      }
    },
    select: {
      dateRange: function dateRange($this) {
        var $radioParent = $this.closest('.time-frame');
        var radio = $radioParent.find('input[type=radio]');
        radio.trigger('click');

        if ($this.attr('id') == 'staticRangeSelect') {
          searchFieldsCtrl.dateRangeVal = $('#staticRangeSelect').find('option:contains("' + $('.jcf-select-staticRange .jcf-select-text span').text() + '")').val();
          $('#staticRangeSelect').val(searchFieldsCtrl.dateRangeVal);
        }

        searchFieldsCtrl.$form = $this.closest('form');
        searchFieldsCtrl.check.submitButton();
      },
      dateRangeRadio: function dateRangeRadio($this) {
        if (!$('#staticRange:checked').length) {
          $('#staticRangeSelect').val('');
        } else {
          searchFieldsCtrl.dateRangeVal = $('#staticRangeSelect').find('option:contains("' + $('.jcf-select-staticRange .jcf-select-text span').text() + '")').val();
          $('#staticRangeSelect').val(searchFieldsCtrl.dateRangeVal);
        }
      }
    },
    check: {
      emptyInputs: function emptyInputs(form) {
        var textInputs = $(form).find('input[type=search]');

        if (textInputs.length == 0) {
          textInputs = $(form).find('input[type=text]');
        }

        var $emptyFields = $(textInputs).filter(function () {
          return this.value === "";
        });
        return $emptyFields.length === textInputs.length;
      },
      submitButton: function submitButton() {
        if (searchFieldsCtrl.check.emptyInputs(searchFieldsCtrl.$form)) {
          $(searchFieldsCtrl.$form).find('button[type=submit]').attr('disabled', true);
        } else {
          $(searchFieldsCtrl.$form).find('button[type=submit]').removeAttr('disabled', true);
        }
      },
      terms: function terms() {
        searchFieldsCtrl.$terms = $('.advanced-search--searchIn .searchIn--field');
        searchFieldsCtrl.$terms.each(function (index) {
          var number = index + 1;
          $(this).find('select').attr('name', 'field' + number);
          $(this).find('input').attr('name', 'text' + number);
        });
      },
      lastClone: function lastClone($this) {
        if ($this.index() == 6) {
          $this.children('.add-ctrl-field').addClass('hidden');
          $this.children('.remove-ctrl-field').removeClass('hidden');
        } else {
          $this.children('.add-ctrl-field').removeClass('hidden');
          $this.children('.remove-ctrl-field').addClass('hidden');
        }

        searchFieldsCtrl.check.terms();
      }
    }
  };
  UX.searchFieldsCtrl = searchFieldsCtrl; // add to global namespace
})();

(function () {
  var $window = $(window),
      isMobile = false,
      $body = $('body');
  var searchResult = {
    url: location.href,
    init: function init() {
      //searchResult.get.url();
      searchResult.control();
      searchResult.additionalInit();
      searchResult.additionalControl();
      searchResult.set.userPublicationLayout();
    },
    control: function control() {
      $body.on('click', '#saveSearchTriggerButton', function () {
        searchResult.openSaveSearchDialog();
      });
      $body.on('submit', '#saveSearchDialog form', function (event) {
        return searchResult.onSaveSearchSubmitHandler(event);
      });
      $body.on('click', '.search__layout>span', function () {
        $(".search__layout>span").removeClass('active');
        $(this).addClass('active');

        if ($(this).hasClass('search__layout-tile')) {
          $(".search-result__body").addClass('search-result--tile');
          localStorage.setItem("userPublicationLayout", "tile");
        } else {
          $(".search-result__body").removeClass('search-result--tile');
          localStorage.setItem("userPublicationLayout", "list");
        }
      });
    },
    additionalControl: function additionalControl() {},
    additionalInit: function additionalInit() {},
    set: {
      userPublicationLayout: function userPublicationLayout() {
        if (localStorage.userPublicationLayout == "tile") {
          $('.search__layout-tile').click();
        } else if (localStorage.userPublicationLayout == "list") {
          $('.search__layout-list').click();
        }
      }
    },
    get: {
      url: function url() {},
      text: function text(name) {
        name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
        var regexS = "[\\?&]" + name + "=([^&#]*)";
        var regex = new RegExp(regexS);
        var results = regex.exec(searchResult.url);
        return results == null ? null : results[1];
      },
      value: function value() {
        $('.refineSearch').find('input').each(function () {
          if (this.attr('type' == 'text')) {}
        });
      }
    },
    openSaveSearchDialog: function openSaveSearchDialog() {
      var openDialog = searchResult.getCookie("openDialog");

      if (openDialog != null && openDialog != "") {
        var saveSearchButton = $('#saveSearchTriggerButton');

        if (saveSearchButton.length > 0) {
          document.cookie = "openDialog=;expires=Wed; 01 Jan 1970";
          saveSearchButton.click();
        }
      }
    },
    getCookie: function getCookie(name) {
      var nameEQ = name + "=";
      var ca = document.cookie.split(';');

      for (var i = 0; i < ca.length; i++) {
        var c = ca[i];

        while (c.charAt(0) == ' ') {
          c = c.substring(1);
        }

        if (c.indexOf(nameEQ) != -1) return c.substring(nameEQ.length, c.length);
      }

      return null;
    },
    onSaveSearchSubmitHandler: function onSaveSearchSubmitHandler(e) {
      $('#newSearchSaveButton').hide();
      $('.saveSearchProgress').show();
      $.ajax({
        type: "POST",
        url: "/action/doSaveSearch",
        data: $(e.target).serialize(),
        success: searchResult.saveSearchSuccessHandler,
        error: function error(data) {
          $('.error.saveSearchMsg').show('fade');
          $('#newSearchSaveButton').show();
          $('.saveSearchProgress').hide();
          $('#saveSearchDialog').modal('toggle');
        }
      });
      return false;
    },
    saveSearchSuccessHandler: function saveSearchSuccessHandler(data) {
      $('.success.saveSearchMsg').show('fade');
      $('#newSearchSaveButton').show();
      $('.saveSearchProgress').hide();
      $('#saveSearchDialog').modal('toggle');
      UX.modal.on.hide();
      searchResult.redrawSavedSearchesPanel(JSON.parse(data).favQueries);
    },
    redrawSavedSearchesPanel: function redrawSavedSearchesPanel(jsonData) {
      var savedSearchesPanel = $('.advancedSearch__tabs .saved-searches');
      var numOfMaxSavedSearches = $(savedSearchesPanel).data('queries');

      for (var i = 0; i < numOfMaxSavedSearches; i++) {
        if (jsonData[i] != undefined) {
          var item = $(savedSearchesPanel).find('tbody tr')[i];
          $(item).find('td:first-child').html(jsonData[i]["qName"]);
          var goLink = "/action/doSearch?target=saved&runSaved=" + jsonData[i]["qId"];
          $(item).find('[title="Run"]').attr('href', goLink);
          var removeLink = "/action/doDeleteSearch?queryId=" + jsonData[i]["qId"] + "&searchType=saved";
          $(item).find('[title="Delete"]').attr('href', removeLink);

          if ($(item).hasClass('hidden')) {
            $(item).removeClass('hidden');
            $('.table-responsive').parent().removeClass('hidden');
            $('.emptySavedSearches').remove(); //$(item).addClass('search-entry-row');
          }
        }
      }
    }
  };
  UX.searchResult = searchResult; // add to global namespace
})();

(function () {
  var loader = {
    element: "",
    target: "",
    $activator: "",
    doi: "",
    figure: "",
    references: "",
    related: "",
    details: "",
    tabFigure: "#pane-pcw-Figures , #pane-pcw-figures",
    tabReferences: "#pane-pcw-References, #pane-pcw-references",
    tabRelated: "#pane-pcw-Related, #pane-pcw-related",
    tabDetails: "#pane-pcw-Details, #pane-pcw-details",
    vPort: "screen-xs",
    isMobile: false,
    init: function init() {
      // show spinner
      loader.get.figures();
      loader.get.references();
      loader.get.related();
      loader.get.details();
      /*if ($('article')) {
          loader.load.details();
      }*/

      loader.truncation.init();
      loader.controller();
      loader.additionalController();
      loader.truncation.init();

      if ($('article')) {
        loader.load.articleTabs();
      }
    },
    controller: function controller() {
      /* $('body').on('click','.figures-tab',function() {
           loader.load.figures();
       });
       $('body').on('click','.references-tab',function(){
           loader.load.references();
       });
       $('body').on('click','.related-tab',function(){
           loader.load.related();
       });
       $('body').on('click','.details-tab',function(){
           loader.load.details();
       });*/
      $('body').on('click', '.boxed-text', function (e) {
        e.preventDefault();
        var $el = $(this),
            boxedContent = $el.attr('href'),
            boxedHtml = $(boxedContent).html(),
            $myModal = $('#myModal');

        if ($myModal.length === 0) {
          var modal_start = '<div class="ux-modal-container"><div id="myModal" class="modal"><div class="modal__dialog  modal--large"><div class="modal-content">',
              modal_header = '<div class="modal__header clearfix"><button type="button" data-dismiss="modal" class="close">X</button></div>',
              modal_body = '<div class="modal__body"></div>',
              modal_end = '</div></div></div></div>',
              modal = modal_start + modal_header + modal_body + modal_end;
          $('body').append(modal);
        }

        $myModal.find('.modal__body').html(boxedHtml);
        $myModal.modal('show');
      });
      $(document).on(loader.vPort + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        loader.isMobile = true;

        if ($('article')) {//loader.load.details();
        }

        loader.rebuild.responsive();
        loader.figures.accordion();
      });
      $(document).on(loader.vPort + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
        loader.isMobile = false;
        loader.rebuild.original();
        loader.figures.back();
      });

      if ($('.access-tab').length) {
        $('.access-tab').trigger('click');
      } else {
        $('.details-tab').trigger('click');
      }

      loader.get.mathjax();
    },
    additionalController: function additionalController() {},
    rebuild: {
      original: function original() {
        // return loi to be as default
        var $loaWrapper = $('.loa-wrapper');
        $loaWrapper.find('.accordion-tabbed__tab').removeClass('accordion-tabbed__tab').addClass('accordion-tabbed__tab-mobile');
        $loaWrapper.find('.delimiter').removeClass('hidden');
        var $author = $loaWrapper.find('.accordion-tabbed__control');
        $author.each(function () {
          var id = $(this).attr('data-id');
          $(this).attr('data-db-target-for', id);
          $(this).next().attr('data-db-target-of', id).removeAttr('style');
        });
      },
      responsive: function responsive() {
        // rebuild loi to be in selected responsive mode
        var $loaWrapper = $('.loa-wrapper');
        $loaWrapper.find('.accordion-tabbed__tab-mobile').removeClass('accordion-tabbed__tab-mobile').addClass('accordion-tabbed__tab ').find('.accordion-tabbed__control').removeAttr('data-db-target-for');
        $loaWrapper.find('.loa-accordion').contents().map(function () {
          if (this.nodeType === 3) {
            //Node.TEXT_NODE
            $(this).wrap('<span class="delimiter hidden"></span>');
          }

          if ($(this).hasClass('delimiter')) {
            $(this).addClass('hidden');
          }
        });
        $loaWrapper.find('.accordion-tabbed__content').removeAttr('data-db-target-of').hide();
      }
    },
    get: {
      figures: function figures() {
        // get current doi
        loader.figure = $('article').attr('data-figures');
      },
      references: function references() {
        // get current doi
        loader.references = $('article').attr('data-references');
      },
      related: function related() {
        // get current doi
        loader.related = $('article').attr('data-related');
        loader.truncation.creativeWorkMeta();
      },
      details: function details() {
        // get current doi
        loader.details = $('article').attr('data-details');
      },
      mathjax: function mathjax() {
        if ($("article").attr("data-enable-mathjax") == "true" && ($(".math-formula").length || $(".disp-formula").length || $(".inline-formula").length)) {
          var script = document.createElement("script");
          script.type = "text/javascript";
          script.src = "https:cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.0/MathJax.js?config=TeX-AMS-MML_HTMLorMML"; // use the location of your MathJax

          var config = 'MathJax.Hub.Config({' + 'CommonHTML: { linebreaks: { automatic: true } },' + '"HTML-CSS": { linebreaks: {automatic: true}},' + 'SVG: { linebreaks: { automatic: true} },' + '});';

          if (window.opera) {
            script.innerHTML = config;
          } else {
            script.text = config;
          }

          document.getElementsByTagName("head")[0].appendChild(script);
        }
      }
    },
    load: {
      articleTabs: function articleTabs() {
        loader.load.figures();
        var $articleReferences = $('.article__body .article__references');

        if ($articleReferences.length) {
          if ($('.article__body.show-references').length) {
            //copy past references
            var articlesRefCopy = $articleReferences.clone();
            articlesRefCopy.find('[id]').each(function () {
              //to remove dupliate Ids
              this.id = this.id + "_copy";
            });
            articlesRefCopy.appendTo(loader.tabReferences);
          } else {
            //cut past references
            $articleReferences.appendTo(loader.tabReferences);
            $articleReferences.show();
          }

          $(loader.tabReferences).removeClass("empty");
        } else {
          loader.load.references();
        }

        loader.load.related();
        loader.load.details();
      },
      figures: function figures() {
        // set figures pane as a target and set the requested html file
        if (loader.figure === undefined) {
          // check if figures' service url has been defined
          return false;
        }

        loader.element = loader.figure;
        loader.target = loader.tabFigure;

        if (loader.check.empty()) {
          // check if figures panes is empty
          loader.getContent('figure'); // get references content
        }
      },
      references: function references() {
        // set references pane as a target and set the requested html file
        if (loader.references === undefined) {
          // check if references' service url has been defined
          return false;
        }

        loader.element = loader.references;
        loader.target = loader.tabReferences;

        if (loader.check.empty()) {
          // check if figures panes is empty
          loader.getContent('references'); // get references content
        }
      },
      related: function related() {
        // set related pane as a target and set the requested html file
        if (loader.related === undefined) {
          // check if related' service url has been defined
          return false;
        }

        loader.element = loader.related;
        loader.target = loader.tabRelated;

        if (loader.check.empty()) {
          // check if figures panes is empty
          loader.getContent('related'); // get references content
        }

        loader.truncation.creativeWorkMeta();
      },
      details: function details() {
        // set details pane as a target and set the requested html file
        if (loader.details === undefined) {
          // check if details' service url has been defined
          return false;
        }

        loader.element = loader.details;
        loader.target = loader.tabDetails;

        if (loader.check.empty()) {
          // check if figures panes is empty
          loader.getContent('details'); // get references content
        }
      }
    },
    getContent: function getContent($elem) {
      // get content using ajax request
      $('.tab__spinner').show(); // show spinner pane

      var $loaderTarget = $(loader.target);
      if ($(loader.target).find('.contentTab').length) $loaderTarget = $(loader.target).find('.contentTab');
      $loaderTarget.load(loader.element, function (response, status, xhr) {
        if (status === "error") {
          var msg = "Sorry but there was an error: ";
          console.log(msg + xhr.status + " " + xhr.statusText); //return false; // abort
        }

        $('.tab__spinner').hide(); // hide spinner pane

        $(loader.target).removeClass("empty").trigger('content-loaded');
        loader.check.empty();
        loader.attach();
        var loaderTarget = $(this).attr('id'),
            isFigures = loader.tabFigure.indexOf(loaderTarget) != -1;

        if (isFigures && loader.isMobile) {
          loader.figures.accordion();
        }

        loader.getContentSuccess($elem);
      });
    },
    getContentSuccess: function getContentSuccess($elem) {},
    check: {
      // check if target pane is empty
      empty: function empty() {
        if (!$(loader.target).is(':empty') && $(loader.target).find('.emptyTab').length <= 0) {
          return false; // abort
        } else {
          $(loader.target).removeClass("empty");
          return true;
        }
      }
    },
    attach: function attach() {
      UX.figureViewer.expand();
    },
    figures: {
      figcaption: "figcaption",
      figureTitle: ".figure__title",
      figureCaption: ".figure__caption",
      accordionClass: "accordion",
      accordionContent: "accordion__content",
      accordionTrigger: $('<button title="Toggle figure caption" class="accordion__control"/>'),
      accordionTriggerIcon: $('<i aria-hidden="true" class="icon-section_arrow_d"/>'),
      accordionTriggerCaption: $('<span>Caption</span>'),
      accordion: function accordion() {
        //turn figures caption into accordion on mobile
        if (!$(loader.tabFigure).find(loader.figures.figcaption).hasClass(loader.figures.accordionClass)) {
          loader.figures.accordionTriggerCaption.appendTo(loader.figures.accordionTrigger);
          loader.figures.accordionTriggerIcon.appendTo(loader.figures.accordionTrigger);
          $(loader.figures.figcaption).find(loader.figures.figureCaption).before(loader.figures.accordionTrigger);
          $(loader.tabFigure).find(loader.figures.figcaption).addClass(loader.figures.accordionClass);
          $(loader.figures.figcaption).find(loader.figures.figureCaption).addClass(loader.figures.accordionContent).hide();
        }
      },
      back: function back() {
        // remove accordion features on desktop
        if ($(loader.tabFigure).find(loader.figures.figcaption).hasClass(loader.figures.accordionClass)) {
          $(loader.tabFigure).find(".accordion__control").remove();
          $(loader.tabFigure).find(loader.figures.figcaption).removeClass(loader.figures.accordionClass);
          $(loader.figures.figcaption).find(loader.figures.figureCaption).removeClass(loader.figures.accordionContent).show();
        }
      }
    },
    truncation: {
      toTrunk8: '.loa-accordion',
      toTrunk8Mobile: '.loa.mobile-authors',
      linesToShow: 3,
      showMoreText: 'Show all Authors',
      showLessText: 'Show less Authors',
      init: function init() {
        if (loader.isMobile) {
          $(loader.truncation.toTrunk8Mobile).truncate({
            lines: loader.truncation.linesToShow,
            type: 'list',
            seeMoreLink: true,
            seeMoreText: loader.truncation.showMoreText,
            seeLessText: loader.truncation.showLessText,
            isMobile: true,
            mobileTarget: '#sb-1'
          });
        } else {
          $(loader.truncation.toTrunk8).truncate({
            lines: loader.truncation.linesToShow,
            type: 'list',
            seeMoreLink: true,
            seeMoreText: loader.truncation.showMoreText,
            seeLessText: loader.truncation.showLessText
          });
        }
      },
      creativeWorkMeta: function creativeWorkMeta() {
        $('.creative-work .meta').truncate({
          lines: 1
        });
      }
    }
  };
  UX.loader = loader; // add to global namespace
})();

document.addEventListener('DOMContentLoaded', function (event) {
  var SETTINGS = {
    ENDPOINT: 'https://crossmark.crossref.org/dialog',
    SCRIPT_VERSION: 'v2.0',
    // LOGO_URL: 'http://crossmark-cdn.crossref.org/widget/v2.0/logos/crossmark-logo-square.svg',
    STYLESHEET_URL: 'https://crossmark-cdn.crossref.org/widget/v2.0/style.css'
  };
  var touchStarted = false;
  var touchArea;

  var tapEvent = function tapEvent(element, callback) {
    element.addEventListener('click', function (event) {
      if (event.ctrlKey || event.shiftKey || event.metaKey || event.which !== 1) {
        return;
      }

      return callback(event);
    }, false);
    element.addEventListener('touchstart', function (event) {
      if (event.touches.length > 1) return touchStarted = false;
      touchArea = {
        x: event.touches[0].screenX,
        y: event.touches[0].screenY
      };
      touchStarted = element;
      event.stopPropagation();
    }, false);
    window.addEventListener('touchstart', function (event) {
      touchStarted = false;
    });
    element.addEventListener('touchmove', function (event) {
      if (event.touches.length > 1) return touchStarted = false;
      var newTouchArea = {
        x: event.touches[0].screenX,
        y: event.touches[0].screenY
      };

      if (Math.pow(touchArea.x - newTouchArea.x, 2) + Math.pow(touchArea.y - newTouchArea.y, 2) > 500) {
        touchStarted = false;
      }
    }, false);
    element.addEventListener('touchend', function (event) {
      if (touchStarted) {
        touchStarted = false;
        var x = event.changedTouches[0].pageX - window.pageXOffset;
        var y = event.changedTouches[0].pageY - window.pageYOffset;
        var target = document.elementFromPoint(x, y);
        return callback(event);
      } else {
        event.preventDefault();
      }
    }, false);
  };

  var buildQueryString = function buildQueryString(data) {
    var query = [];

    for (var key in data) {
      query.push(encodeURIComponent(key) + '=' + encodeURIComponent(data[key]));
    }

    return '?' + query.join('&');
  };

  var isIos = /iPad|iPhone|iPod/.test(navigator.userAgent) && !window.MSStream; // Scan for case-insensitive.

  var getDoiMeta = function getDoiMeta() {
    var metaTags = document.querySelectorAll("meta");

    for (var i in metaTags) {
      if (metaTags.hasOwnProperty(i)) {
        var tag = metaTags[i];

        if ((tag.name || "").toLowerCase() == "dc.identifier" && tag.scheme == "doi") {
          return tag;
        }
      }
    }
  };

  var doiMeta = getDoiMeta();
  var doi = doiMeta ? doiMeta.getAttribute('content').replace(/^(info:doi\/|doi:)/, '') : null;
  if (doi == null) doi = $("#crossMark").data('doi');
  var queryData = {
    doi: doi,
    domain: window.location.hostname,
    uri_scheme: window.location.protocol,
    cm_version: SETTINGS.SCRIPT_VERSION
  };
  var css = document.createElement('link');
  css.setAttribute('href', SETTINGS.STYLESHEET_URL);
  css.setAttribute('type', 'text/css');
  css.setAttribute('rel', 'stylesheet');
  document.querySelector('head').appendChild(css);
  var widget = document.createElement('div');
  widget.setAttribute('id', 'crossmark-widget'); // Initial display none to avoid a flash on load.

  widget.style.display = 'none';
  widget.innerHTML = '<div class="crossmark-reset crossmark-overlay"></div>' + '<div class="crossmark-reset crossmark-popup">' + '<div class="crossmark-reset crossmark-popup__offset">' + '<div class="crossmark-reset crossmark-popup__inner">' + '<div class="crossmark-reset crossmark-popup__header">' + '<a target="_blank" href="http://www.crossref.org/crossmark">' + '<img class="crossmark-reset crossmark-popup__logo">' + '</a>' + '<button class="crossmark-reset crossmark-popup__btn-close"></button>' + '</div>' + '<div class="crossmark-reset crossmark-popup__content-wrapper">' + '<iframe class="crossmark-reset crossmark-popup__content"></iframe>' + '</div>' + '</div>' + '</div>' + '</div>';
  var overlay = widget.querySelector('.crossmark-overlay');
  var popup = widget.querySelector('.crossmark-popup');
  var popupOffset = widget.querySelector('.crossmark-popup__offset');
  var popupInner = widget.querySelector('.crossmark-popup__inner');
  var logo = widget.querySelector('.crossmark-popup__logo');
  var content = widget.querySelector('.crossmark-popup__content');
  var closeButton = widget.querySelector('.crossmark-popup__btn-close');
  if (isIos) popupOffset.classList.add('is-ios'); // logo.setAttribute('src', SETTINGS.LOGO_URL);

  document.body.appendChild(widget);
  [overlay, popup, closeButton].map(function (element) {
    tapEvent(element, function (event) {
      widget.style.display = 'none';
      event.preventDefault();
      event.stopPropagation();
    });
  });
  tapEvent(popupInner, function (event) {
    event.stopPropagation();
  });
  var initialised = false; // delete queryData.domain;

  var links = [].slice.call(document.querySelectorAll('[data-target=crossmark]'), 0);
  links.map(function (link) {
    link.style.cursor = 'pointer';
    link.setAttribute('href', SETTINGS.ENDPOINT + buildQueryString(queryData));
    tapEvent(link, function (event) {
      if (!initialised) {
        content.setAttribute('src', SETTINGS.ENDPOINT + buildQueryString(queryData));
        initialised = true;
      }

      widget.style.display = 'block';
      if (isIos) popupInner.style.top = window.scrollY + 'px';
      event.preventDefault();
      event.stopPropagation();
    });
  });
});

(function () {
  var adplaceholder = {
    init: function init() {
      $(".js__toggleAdForm").on("click", function (e) {
        e.preventDefault();
        var elemToToggle = "#" + $(this).data("toggle");
        $(elemToToggle).slideToggle();
      });
    }
  };
  UX.adplaceholder = adplaceholder; // add to global namespace
})();

(function () {
  var cookiePolicyPopupWidget = {
    $element: $('.cookiePolicy-popup'),
    acceptUrl: '/action/cookiePolicy?response=accept',
    init: function init() {
      cookiePolicyPopupWidget.control();
    },
    control: function control() {
      cookiePolicyPopupWidget.$element.on('click', '.cookiePolicy-popup__close', function (e) {
        e.preventDefault();
        $.get(cookiePolicyPopupWidget.acceptUrl, function () {
          console.log("Cookies Accepted!");
        });
        cookiePolicyPopupWidget.$element.slideUp('fast', function () {
          cookiePolicyPopupWidget.$element.remove();
          cookiePolicyPopupWidget.cookieRemoved();
        });
      });
    },
    cookieRemoved: function cookieRemoved() {}
  };
  UX.cookiePolicyPopupWidget = cookiePolicyPopupWidget;
})();

(function () {
  var administrators = {
    $removeBtn: $('.js__removeAdmins'),
    init: function init() {
      administrators.controller();
    },
    controller: function controller() {
      administrators.$removeBtn.on('click', function (e) {
        e.preventDefault();
        e.stopPropagation();
        administrators.form.submit();
      });
    },
    form: {
      submit: function submit() {
        var hasUserChecked = administrators.form.conflictCheck();

        if (!hasUserChecked) {
          administrators.form.error_msg();
          return;
        } else {
          administrators.$removeBtn.closest('form').submit();
        }
      },
      conflictCheck: function conflictCheck() {
        return administrators.$removeBtn.closest('form').find('[type="checkbox"]:checked').length !== 0;
      },
      error_msg: function error_msg() {
        alert('Please select an administrator to remove.');
      }
    }
  };
  UX.administrators = administrators; // add to global namespace
})();

(function () {
  var favorites = {
    actions_select: ".favoritePublicationsOptions",
    sort_select: ".sortOptions",
    actions_activator: ".js__favActions",
    sort_activator: ".js__favSort",
    tabs_nav: '.account-tab__nav a',
    $body: $('body'),
    lastModfied: '',
    vPort: '',
    type: 'Article',
    init: function init() {
      favorites.controller();
      favorites.manipulateUrl();
      favorites.additionalController();
    },
    controller: function controller() {
      $(favorites.actions_select).change(function () {
        favorites.fav_actions(this);
      });
      favorites.$body.on('click', favorites.actions_activator, function () {
        $(this).closest(favorites.actions_select).val($(this).data("value"));
        $(this).closest(favorites.actions_select).trigger("change");
      });
      $(favorites.sort_select).change(function () {
        favorites.fav_sort(this);
      });
      favorites.$body.on('click', favorites.sort_activator, function () {
        $(this).closest(favorites.sort_select).val($(this).data("value"));
        $(this).closest(favorites.sort_select).trigger("change");
      });
      favorites.$body.on('click', '[name="markall"]', function (e) {
        var $target = $(this).parents('form').find('tbody .table__mark'),
            $target_input = $target.find('[type="checkbox"]'),
            $target_jcf_span = $target.find('.jcf-checkbox'),
            check = $(this).prop('checked');
        $target_input.prop('checked', check);

        if (check) {
          $target_jcf_span.removeClass('jcf-unchecked');
          $target_jcf_span.addClass('jcf-checked');
        } else {
          $target_jcf_span.removeClass('jcf-checked');
          $target_jcf_span.addClass('jcf-unchecked');
        }
      });
      favorites.$body.on('click', favorites.tabs_nav, function () {
        favorites.type = $(this).attr('data-type');
      });
    },
    additionalController: function additionalController() {},
    error_msg: function error_msg() {
      alert('Please select one publication at least');
    },
    fav_actions: function fav_actions(el) {
      if (!$('input[type=checkbox][name="doi"]:checked').length) {
        favorites.error_msg();
        $(el).val('');
        return;
      }

      var val = $(el).val();
      var form = $(el).parents("form");
      var action = '';
      if (!val) return;

      if (val == 'alert') {
        action = '/action/doUpdateAlertSettings';
        $('option[value=' + val + ']', el).val('addJournalBookAlert');
      } else if (val == 'delete') {
        action = form.attr('action');
      } else if (val == 'publicationAddJournalBookAlert') {
        action = '/action/doUpdateAlertSettings';
        $('option[value=' + val + ']', el).val('addJournalBookAlert');
        $("input[type=checkbox][name=doi]").each(function () {
          $(this).val($(el).parent("td").attr("serialDoi"));
        });
      } else {
        action = val;
      }

      form.attr('action', action);
      var activeTab = "#" + $(el).closest("li[role='tabpanel']").attr('id');
      sessionStorage.setItem('activeTab', activeTab);
      form.get(0).submit();
    },
    fav_sort: function fav_sort(el) {
      var val = $(el).val();
      if (!val) return;
      var action = $('[name="currentUrl"]').val();
      var form = ['<form method="GET" action="' + action + '">'];
      form.push('<input type="hidden" name="' + 'menuTab' + '" value="' + 'favorites' + '"/>');
      form.push('<input type="hidden" name="' + 'sortBy' + '" value="' + val + '"/>');
      form.push('<input type="hidden" name="' + 'publicationSortBy' + '" value="' + $(".js__favSort").val() + '"/>');
      form.push('<input type="hidden" name="' + 'type' + '" value="' + favorites.type + '"/>');
      form.push('</form>');
      var activeTab = "#" + $(el).closest("li[role='tabpanel']").attr('id');
      sessionStorage.setItem('activeTab', activeTab);
      $(form.join('')).appendTo('body')[0].submit();
      form.submit();
      $(form).remove();
    },
    manipulateUrl: function manipulateUrl() {
      var pathname = favorites.getLocationUrl();
      $('[name="href"]').val(pathname);
      var strippedPathname = favorites.stripParam(pathname, 'sortBy');
      $('[name="currentUrl"]').val(strippedPathname);
      var favType = favorites.getParam(pathname, 'type');

      if (favType) {
        favorites.type = favType;

        if ($(favorites.tabs_nav + "[data-type='" + favType + "']").length) {
          $(favorites.tabs_nav + "[data-type='" + favType + "']").trigger('click');
        }
      }
    },
    getLocationUrl: function getLocationUrl() {
      var pathname = window.location.pathname,
          url = window.location.href,
          originalRequestUri = pathname + url.split(pathname)[1];
      return originalRequestUri;
    },
    stripParam: function stripParam(originalRequestUri, param) {
      var newPathname = '';
      var arr = originalRequestUri.split('&');
      $.each(arr, function (key, value) {
        var indexOfParam = this.indexOf(param);

        if (indexOfParam == 0) {
          arr[key] = '';
        }

        newPathname += arr[key];
        if (key < arr.length - 1 && indexOfParam != 0) newPathname += '&';
      });
      return newPathname;
    },
    getParam: function getParam(originalRequestUri, param) {
      var arr = originalRequestUri.split('&');
      var type = '';
      $.each(arr, function (key, value) {
        var keyVal = this.split('=');

        if (keyVal[0] === param) {
          type = keyVal[1];
          return false;
        }
      });
      return type;
    }
  };
  UX.favorites = favorites; // add to global namespace
})();

$(document).ready(function () {
  // display user login popup - loginBar
  $(document).on('click', '#indivLogin', function (event) {
    event.preventDefault();
    event.stopPropagation();
    $(this).toggleClass("active");
    $(".navigation-login-dropdown-container:not(.login-options)").toggleClass('hidden');

    if ($('.search-open').is(":visible")) {
      toggleQuickSearch();
    }
  });
  $(document).on('click', function (e) {
    if ($(e.target).attr('id') !== 'indivLogin' && !$('.navigation-login-dropdown-container').hasClass('hidden')) {
      $('.navigation-login-dropdown-container').addClass('hidden');
    }
  }); // enable sumbit btn for access token widget

  $('#accessTokenForm div.input-group input[type=text]').on('keyup input change', function () {
    !$('#accessTokenForm div.input-group #tokenAccess').val().length ? $('#accessTokenForm input[type=submit]').attr('disabled', 'disabled') : $('#accessTokenForm input[type=submit]').removeAttr('disabled');
  }); // enable sumbit btn for access token widget

  $('.registration-popup input[type=submit]').attr('disabled', 'disabled');
  $('.registration-popup input[type=text]').on('keyup input change', function () {
    !$(this).val().length ? $('.registration-form input[type=submit]').attr('disabled', 'disabled') : $('.registration-form input[type=submit]').removeAttr('disabled');
  }); // recaptcha load

  if ($('.g-recaptcha').length) {
    loadRecaptcha();
  } // display verification code hidden msg after 3m


  if ($('#check-if-exist')) {
    setTimeout(function () {
      $('#hidden-message').css('visibility', 'visible');
    }, 30000);
  } // enable sumbit btn for 2-step widget


  $('#check-if-exist input[type=input]').on('keyup input change', function () {
    !$('#check-if-exist input[type=input]').val().length ? $('#check-if-exist input[type=submit]').attr('disabled', 'disabled') : $('#check-if-exist input[type=submit]').removeAttr('disabled');
  });
});

function loadInstitutionPage(selectDom) {
  var href = $(selectDom).val();
  location.href = href;
}

window.loadInstitutionPage = loadInstitutionPage; // add to global namespace

(function () {
  var $body = $('body');
  var profileMain = {
    $select: null,
    init: function init() {
      profileMain.control();
    },
    control: function control() {
      $body.on('change', '#institutionList', function (e) {
        e.preventDefault();
        profileMain.$select = $(this);
        var href = profileMain.$select.val();
        location.href = href;
      });

      if ($("#institutionList option").length <= 2) {
        $("#institutionList").val($("#institutionList option").eq(1).val());
      } else {
        if ($("#institutionList").find("option[value='" + location.toString() + "']").length) $("#institutionList").val(location.toString());else $("#institutionList").val("#");
      }
    }
  };
  UX.profileMain = profileMain; // add to global namespace
})();

(function () {
  var $window = $(window);
  var transplant = {
    $element: null,
    $target: null,
    $order: null,
    $cloneData: null,
    init: function init() {
      var transArray = $('[data-toggle="transplant"]');
      transArray.each(function (index) {
        transplant.$element = $(this).data('transplant');
        transplant.$target = $($(this).data('target'));
        transplant.$direction = $($(this).data('direction'));
        transplant.$order = $(this).data('transplant-order');
        transplant.$remove = $(this).data('remove');
        transplant.$targetClass = $(this).data('target-class');
        transplant.$classNames = $(this).data('class-names');

        if (transplant.$direction == "to" || typeof transplant.$direction == 'undefined') {
          if (transplant.$element === 'self') {
            transplant.$element = $(this);
          } else {
            transplant.$element = $(this).find(transplant.$element);
          }

          transplant.$cloneData = transplant.$element.clone(true, true).removeAttr('data-toggle').attr('data-transplant-order', transplant.$order);
          transplant.clone();

          if (transplant.$targetClass) {
            transplant.$target.find('.transplanted-clone').addClass(transplant.$targetClass);
          }

          if (transplant.$classNames) {
            transplant.$element.addClass(transplant.$classNames);
          }

          if (transplant.$remove == true) {
            transplant.remove();
          }
        } else {
          transplant.$target = $(this);
          var array = $(this).data('target').split(",");
          $.each(array, function (index, item) {
            // go through selectors
            transplant.$element = $(item);
            transplant.$cloneData = transplant.$element.clone(true, true).attr('data-transplant-order', transplant.$order);
            transplant.clone();

            if (transplant.$targetClass) {
              transplant.$element.addClass(transplant.$targetClass);
            }

            if (transplant.$classNames) {
              transplant.$target.find(".transplanted-clone").addClass(transplant.$classNames);
            }

            if (transplant.$remove == true) {
              transplant.remove();
            }
          });
        }
      });
      transplant.order();
    },
    clone: function clone() {
      if (transplant.$element.hasClass('cloned')) return;

      if (transplant.$target.find('.transplanted-clone').length <= 0) {
        transplant.$target.append('<div class="transplanted-clone"></div>');
      }

      transplant.$target.find('.transplanted-clone').append(transplant.$cloneData);
      transplant.$element.addClass('cloned');
    },
    order: function order() {
      var clonedItems = transplant.$target.find('.transplanted-clone').children();
      clonedItems.sort(function (a, b) {
        return $(a).data("transplant-order") - $(b).data("transplant-order");
      });
      transplant.$target.find('.transplanted-clone').html(clonedItems);
    },
    remove: function remove() {
      if (transplant.$target) {
        transplant.$element.remove();
      } else {
        transplant.$source.remove();
      }
    }
  };
  UX.transplant = transplant; // add to global namespace
})();

(function () {
  var $window = $(window),
      $body = $('body'),
      isMobile = false; // variable use to determine if responsive mode is on or off

  var dropblockUl = {
    $target: null,
    $toggle: null,
    $ul: null,
    $li: null,
    vPort: "screen-sm",
    // default responsive break point
    init: function init() {
      dropblockUl.$target = $('.profile-menu');
      dropblockUl.on.build();
      dropblockUl.control();
    },
    control: function control() {
      $body.on('click', '.profile-menu--res a', function (e) {
        dropblockUl.on.select.dropdown($(this));
      });
      $(document).on(dropblockUl.vPort + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        isMobile = true;
        $('.profile-menu').addClass("profile-menu--res"); // class will be used in our scss (to replace media queries)

        dropblockUl.on.build();
      });
      $(document).on(dropblockUl.vPort + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
        isMobile = false;
        $('.profile-menu').removeClass("profile-menu--res");
        dropblockUl.on.build();
      });
    },
    on: {
      select: {
        dropdown: function dropdown(elem) {
          var dataAttr = elem.closest('ul').data('mobile-toggle');

          if (dataAttr === 'dropdown' || elem.closest('ul').hasClass('dropblock--tab')) {
            var dropdownContainer = elem.closest('.dropBlock');
            dropdownContainer.children('a').find('span').text(elem.text());
          }
        }
      },
      dropdownBuild: function dropdownBuild(elem) {
        // rebuild tabs to be as drop down
        UX.dropBlock.init();
        elem.wrap('<div class="profile-menu--dropBlock" data-db-parent-of="dbTab-profile-menu"></div>');
        var $dropdownContainer = elem.closest('.profile-menu--dropBlock');
        var $activeTab = elem.find('a.active');
        $dropdownContainer.prepend('<a href="#" data-db-target-for="dbTab-profile-menu"><span>' + $activeTab.text() + '</span><i class="icon-arrow_d_n pull-right" aria-hidden="true"></i></a>');
        elem.attr('data-db-target-of', 'dbTab-profile-menu');
      },
      dropdownDestroy: function dropdownDestroy(elem) {
        // return tabs to default
        var dropdownContainer = elem.closest('.profile-menu--dropBlock');
        dropdownContainer.children('a').remove();
        elem.removeAttr('data-db-target-of').removeClass('js--open').removeAttr('style').unwrap('.profile-menu--dropBlock');
      },
      build: function build() {
        //dropblockUl.$ul.each(function(index) {
        if (isMobile) {
          dropblockUl.on.dropdownBuild(dropblockUl.$target);
        } else {
          dropblockUl.on.dropdownDestroy(dropblockUl.$target);
        } //});

      }
    }
  };
  UX.dropblockUl = dropblockUl; // add to global namespace
})();

function setMinContentHeight() {
  $('main').css('min-height', $(window).height() - ($('footer').height() + parseInt($('footer').css('margin-top'))));
}

$(document).ready(function () {
  setMinContentHeight();
  $(window).resize(setMinContentHeight);
});

(function () {
  $(document).on('click', '.add-new-address,.cancle-new-address', function () {
    addAddress();
  });

  function addAddress() {
    $('.new-address').toggle();
    $('.user-addresses').toggle();
  }
})();

//

$(document).ready(function () {
  $('.collapsible-menu-header').on('click', function () {
    if (window.innerWidth < 992) {
      $(this).siblings(".collapsible-menu-body").slideToggle(400);
      $(this).closest('.collapsible-menu').toggleClass('js--open');
      $(this).find('.icon').toggleClass(" icon-chevron-down icon-chevron-up");
    }
  });
});

(function () {
  var scroll = {
    pageHeaderHeight: $('.pageHeader').outerHeight(),
    coolbarHeight: 0,
    pagesNavHeight: 0,
    $coolBar: $('.coolBar'),
    $pagesNav: $('.pages-nav'),
    init: function init() {
      scroll.control();
    },
    control: function control() {
      // JS code to expand support information section on click
      $("a[href$='#support-information-section']").on("click", function () {
        $(".article-section__supporting a.accordion__control").trigger("click");
      });
      $("a[href^='#references-section'], a[href^='#citedby-section']").on("click", function () {
        var myHref = $(this).attr('href');

        if (!$(myHref).closest("a.accordion__control ").hasClass("js--open")) {
          $(myHref).closest("a.accordion__control ").trigger("click");
        }

        
      });
      $('body').on('click', '[data-db-target-of=sections] a, .scrollableLink, .scrollableLinks a', function (e) {
        e.preventDefault();
        e.stopPropagation();
        $('body, html').removeClass('lock-screen');

        if ($(this).hasClass('noteLink')) {
          scroll.openFootNote(this);
        } else {
          scroll.scrollToTarget(this, true);
          $('[data-db-target-of=sections], .w-slide__back').trigger('click');
        }
      });
    },
    openFootNote: function openFootNote($el) {
      var $target = $($el.hash),
          html = $target.html(),
          closeBtn = '<button class="footNoteClose"><i class="icon-tools_close" aria-hidden="true"></i></button>',
          chevronDown = '<span class="chevronDown"></span>',
          note = '<div class="footNotePopup">' + closeBtn + html + chevronDown + '</div>';
      $('.footNotePopup').remove();
      $($el).after(note);
      var offsetTop = $($el).offset().top - $('.footNotePopup').outerHeight() - 10,
          offsetLeft = $($el).offset().left + 5;

      if ($($el).closest('.article-table-content-wrapper').length) {
        if ($($el).offset().top - $($el).closest('.article-table-content-wrapper').offset().top < $(".footNotePopup").outerHeight() + 10) {
          offsetTop = $($el).offset().top + 40;
          $('.footNotePopup').find('.chevronDown').addClass('inverse');
        }
      }

      $('.footNotePopup').offset({
        top: offsetTop
      });
      $('.footNotePopup').find('.chevronDown').offset({
        left: offsetLeft
      });
      $(".footNoteClose").on("click", function () {
        $(".footNoteClose").off('click');
        $('.footNotePopup').remove();
      });
    },
    scrollToTarget: function scrollToTarget($el, refID) {
      if (refID) {
        var target_element = document.getElementById($el.hash.slice(1)),
            target = $(target_element);
      } else {
        var target_element = $el,
            target = target_element;
      }

      var pageHeaderHeight = $('.pageHeader').outerHeight(),
          coolbarHeight = 0,
          pagesNavHeight = 0,
          $coolBar = $('.coolBar'),
          $pagesNav = $('.pages-nav');

      if ($coolBar.length) {
        coolbarHeight = $coolBar.find('.coolBar__wrapper').outerHeight();
      }

      if ($pagesNav.length && $pagesNav.find('.main-nav').length) {
        pagesNavHeight = $pagesNav.find('.main-nav').outerHeight();
      }

      if ($pagesNav.length && $pagesNav.find('.main-nav').length && !$pagesNav.hasClass('stickybar--sticky') && $pagesNav.find('.main-nav').hasClass('menu--res')) {
        pagesNavHeight = $pagesNav.find('.main-nav').outerHeight() - 52;
      }

      target = target.length ? target : $('[name="' + $el.hash.slice(1) + '"]');
      var minusHeight = pageHeaderHeight + pagesNavHeight + coolbarHeight + 10,
          offset = target.offset().top;

      if (scroll.isIE()) {
        offset = target.offset().top - 60;
      }

      if (target.length) {
        $('html,body').animate({
          scrollTop: offset - minusHeight
        }, 500, function () {
          if ($coolBar.length) {
            coolbarHeight = $coolBar.find('.coolBar__wrapper').outerHeight();
            minusHeight = pageHeaderHeight + pagesNavHeight + coolbarHeight + 10;
            $('html,body').animate({
              scrollTop: offset - minusHeight
            }, 500);
          }
        });
      }
    },
    isIE: function isIE() {
      var browsers = {
        "isIE":
        /*@cc_on!@*/
        false || !!document.documentMode
      };
      return browsers["isIE"];
    }
  };
  UX.scroll = scroll;
})();

(function () {
  var $window = $(window),
      $body = $('body');
  var setStickeyTop = {
    vPort: "screen-md",
    stickybarElement: $('.coolBar'),
    topPostition: 0,
    lock: true,
    // define lock and set default value, this lock will be used to make sure to run certain functionality and to run on every scroll event
    init: function init() {
      setStickeyTop.control();
    },
    control: function control() {
      $(document).on(setStickeyTop.vPort + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        setStickeyTop.sticky.position();
      });
      $(document).on(setStickeyTop.vPort + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        setStickeyTop.sticky.position();
      });
    },
    headerHeight: function headerHeight() {
      $('.pageHeader').height();
    },
    sticky: {
      position: function position() {
        setStickeyTop.stickybarElement.css({
          "top": setStickeyTop.headerHeight()
        });
      }
    }
  };
  UX.setStickeyTop = setStickeyTop; // add to global namespace
})();

$(window).on('load', function () {
  $('body').on('click', '[ data-db-target-for="hub-menu"]', function () {
    if ($(this).hasClass('js--open')) {
      $(this).find('span').css('top', $('.pageHeader').height() - $(this).offset().top - 20);
      $('.hubpage-menu').css('top', $('.pageHeader').height());
      $('body, html').addClass('lock-screen');
      $('.w-slide').addClass('hubMenu-slide').css('top', $('.pageHeader').height());
    } else {
      UX.slide.on.hide();
      $('body, html').removeClass('lock-screen');
      $('.w-slide').removeClass('hubMenu-slide');
    }

    $(".w-slide__back").trigger("click");
  });
  $('.hubpage-menu').removeClass("menu--res");
  $(window).on('resize', function () {
    $('.hubpage-menu').removeClass("menu--res");
  });
  $('body').on('click', '.coolBar--res [data-db-target-for], .pages-nav .menu--res [data-db-target-for], .pages-nav--res [data-db-target-for] ,.showPublications [data-db-target-for] ,.doSearch [data-db-target-for].result__ctrl__filters', function () {
    if ($(this).hasClass('js--open')) {
      $('body, html').addClass('lock-screen');
    } else {
      $('body, html').removeClass('lock-screen');
    }
  });
});

(function () {
  var popover = {
    $body: $('body'),
    container: '.popover',
    trigger: '.popover-toggle',
    content: '.popover-content',
    close: '.popover-close',
    dataOpened: 'popover-open',
    init: function init() {
      popover.on.accessible();
      popover.controller();
    },
    controller: function controller() {
      popover.$body.on('click', popover.trigger, function (e) {
        e.preventDefault();
        var isOpen = $(this).hasClass(popover.dataOpened);
        popover.on.closeAll();

        if (!isOpen) {
          popover.on.open($(this));
        }
      });
      popover.$body.on('click', popover.close, function (e) {
        e.preventDefault();
        var $el = $(this).parents(popover.container).children(popover.trigger);
        popover.on.close($el);
      });
      popover.$body.on('click', function (e) {
        var $target = $(e.target),
            shouldFocus = $target.parents(popover.container).length != 0;

        if (!shouldFocus) {
          popover.on.closeAll();
        }
      });
    },
    on: {
      accessible: function accessible() {
        $(popover.trigger).each(function () {
          var $el = $(this);
          $el.attr('aria-haspopup', true);
          $el.attr('aria-expanded', false);
          $el.attr('tabindex', 0);
        });
      },
      open: function open($el) {
        $el.attr('aria-expanded', true);
        $el.addClass(popover.dataOpened);
        $el.siblings(popover.content).focus();
      },
      close: function close($el) {
        $el.attr('aria-expanded', false);
        $el.removeClass(popover.dataOpened);
      },
      closeAll: function closeAll() {
        $(popover.trigger).each(function () {
          var $el = $(this);
          popover.on.close($el);
        });
      }
    }
  };
  UX.popover = popover; // add to global namespace
})();

UX.tab.set.target = function ($content, target, temp) {
  target = target.replace(".", "\\.");

  if (!$content.find(target).length) {
    UX.tab.$target = $content.find("[data-figure-id='" + temp + "']");
  } else {
    UX.tab.$target = $content.find(target);
  }

  if ($(target).parents('.accordion').length) {
    $(target).parents('.accordion').each(function () {
      var control = $(this).find('.accordion-tabbed__control');
      if (control.attr('aria-expanded') == 'false') control.click();
    });
  }
};

UX.tab.on.select.external = function (elem) {
  var target = elem.attr('href'); // get target id

  if (typeof target == 'undefined') {
    target = elem.children('a').attr('href');
  } // if it still is undefined output a console error


  if (typeof target != 'undefined') {
    target = target.split(" ")[0];
    UX.tab.$toggle = '#' + elem.data('tab');
    UX.tab.$li = $('.tab__nav [href="' + UX.tab.$toggle + '"]');
    UX.tab.$li.click();

    var animateScroll = function animateScroll() {
      var temp = target.split("#")[1];
      UX.tab.$content = $(UX.tab.$toggle).parents(".tab__content");

      if (UX.tab.isMobile) {
        if (UX.tab.isSlide) {
          UX.tab.set.target($(".w-slide__content"), target, temp);

          if (UX.tab.$target.length) {
            UX.tab.animate.scroll($(".w-slide__content"), UX.tab.$target);
            UX.tab.$target.attr("tab-index", "1");
            UX.tab.$target.focus();
          }
        }
      } else {
        UX.tab.set.target(UX.tab.$content, target, temp);
        UX.tab.animate.scroll(UX.tab.$content, UX.tab.$target);
      }
    };

    if ($(UX.tab.$toggle).hasClass('empty')) {
      $(UX.tab.$toggle).on('content-loaded', function () {
        animateScroll();
      });
    } else {
      animateScroll();
    }
  } else {
    console.error('No valid href found');
  }
};

UX.tab.animate.scroll = function ($content, $target) {
  var contentTop = $content.scrollTop();

  if ($content.hasClass('tab__content')) {
    contentTop = 0;
  }

  if (UX.tab.isMobile) {
    var marginTopnValue = $('.w-slide_head').outerHeight();
  } else {
    var marginTopnValue = 0;
  }

  $content.animate({
    scrollTop: contentTop + $target.position().top - marginTopnValue
  }, 600);
};

(function () {
  var email = {
    $originalEmail: $('.originalEmail'),
    $fakeEmail: $('#fakeEmail'),
    originalEmailVal: null,
    fakeEmailVal: null,
    pattern: /(.+\+(alm)[-]*.+[@].+)/ig,
    replacerPattern: /(\+(alm)[-]*.+?(?=@))/ig,
    replacer: '',
    isAml: false,
    init: function init() {
      email.originalEmailVal = email.$originalEmail.val();
      email.fakeEmailVal = email.$fakeEmail.val();
      email.isAml = email.originalEmailVal.match(email.pattern);

      if (email.isAml) {
        email.replacer = email.replacerPattern.exec(email.originalEmailVal)[0];
        email.fakeEmailVal = email.originalEmailVal.replace(email.replacerPattern, '');
        email.$fakeEmail.val(email.fakeEmailVal);
      }

      email.control();
    },
    control: function control() {
      email.$fakeEmail.on('input', function () {
        email.fakeEmailVal = $(this).val();
        email.$originalEmail.val(email.fakeEmailVal); // email.originalEmailVal = email.fakeEmailVal.split('@')[0] + email.replacer + '@' + email.fakeEmailVal.split('@')[1];
        // email.$originalEmail.val(email.originalEmailVal);
      });
    }
  };
  UX.email = email; // add to global namespace
})();

(function () {
  var $window = $(window),
      $body = $('body'); // variable use to determine if responsive mode is on or off

  var pager = {
    $pages: $('.js-pages'),
    $pager: $('.js-pager'),
    $current: null,
    $next: null,
    $prev: null,
    $first: null,
    $last: null,
    init: function init() {
      pager.build.pages(1);
      pager.$first = pager.$pager.find('li:first-child').find('a');
      pager.$last = pager.$pager.find('li:last-child').find('a');
      pager.build.pagination(1); // set pagination appearance for 1st time.

      pager.control();
    },
    control: function control() {
      $body.on('click', '.js-pager a', function (e) {
        e.preventDefault();
        pager.$pager = $(this).closest('.js-pager');
        pager.$current = $(this).closest('.js-pager').find('a.active');
        pager.$next = pager.$current.parent('li').next().find('a');
        pager.$prev = pager.$current.parent('li').prev().find('a');
        var pagesNumber = pager.$pager.find('li').length;

        if ($(this).hasClass('pagination__btn--prev')) {
          if (pager.$current.data('target-page') != 1) {
            pager.$current = pager.$prev;
            pager.select.page(pager.$current.data('target-page'), pager.$current);
          }
        } else if ($(this).hasClass('pagination__btn--next')) {
          if (pager.$current.data('target-page') != pagesNumber) {
            pager.$current = pager.$next;
            pager.select.page(pager.$current.data('target-page'), pager.$current);
          }
        } else {
          pager.select.page($(this).data('target-page'), $(this));
        }
      });
    },
    build: {
      pages: function pages(pageNumber) {
        pager.$pages.find("[data-page]").hide();
        pager.$pages.find("[data-page=" + pageNumber + "]").show();
      },
      pagination: function pagination(pageNumber) {
        var pagesNumber = pager.$pager.find('li').length;

        if (pagesNumber > 7) {
          if (pageNumber > 4 && pageNumber < pagesNumber - 3) {
            pager.$pager.find('.pagination__list li').removeClass('dotsValue');
            pager.$pager.find('.pagination__list a').addClass('hidden');
            pager.$current.removeClass('hidden');
            pager.$next.removeClass('hidden');
            pager.$prev.removeClass('hidden');
            pager.$first.removeClass('hidden');
            pager.$last.removeClass('hidden');
            pager.$next.parent('li').next().addClass('dotsValue');
            pager.$prev.parent('li').prev().addClass('dotsValue');
          } else if (pageNumber <= 4) {
            pager.$pager.find('.pagination__list li').removeClass('dotsValue');
            pager.$pager.find('.pagination__list a').removeClass('hidden');

            for (i = 7; i < pagesNumber; i++) {
              $("[data-target-page=" + i + "]").addClass('hidden');
            }
          } else if (pageNumber >= pagesNumber - 3) {
            pager.$pager.find('.pagination__list li').removeClass('dotsValue');
            pager.$pager.find('.pagination__list a').removeClass('hidden');

            for (i = 2; i < pagesNumber - 5; i++) {
              $("[data-target-page=" + i + "]").addClass('hidden');
            }
          }
        }

        UX.manageArticleSelect.clearSelectAll();
      }
    },
    select: {
      page: function page(pageNumber, current) {
        pager.$current = current;
        pager.$next = current.parent('li').next().find('a');
        pager.$prev = current.parent('li').prev().find('a');
        pager.$pages.find("[data-page]").hide();
        pager.$pages.find("[data-page=" + pageNumber + "]").show();
        pager.$pager.find('a').removeClass('active');
        pager.$current.addClass('active');
        pager.build.pagination(pageNumber);
      }
    }
  };
  UX.pager = pager; // add to global namespace
})();

UX.toggle.control = function () {
  $('body').on('click', '.facet .show-more', function (e) {
    e.preventDefault();
    UX.toggle.on.toggle($(this));
    $(this).closest(".accordion__content").find('li:nth-child(6) a').focus();
  });
  $('body').find('.facet .dropdown__toggle').off();
  $('body').on('click', '.facet .facet__toggle', function (e) {
    e.preventDefault();
    $(this).toggleClass('icon-add_box icon-squared-minus');
    UX.toggle.on.toggleFacet($(this).siblings('.dropdown__toggle'));
  });
  $('body').on('click', '.facet .author__ajax', function (e) {
    var $this = $(this);
    var $facet = $this.closest('.facet');
    var link = $this.data('link');
    var content = $this.siblings('.author__ajax-content');

    if (content.html() == "") {
      //  $this.siblings('.author__ajax-content').html(link)
      $.get(link, {
        pbContext: ';page:string:Search Result;wgroup:string:Publication Websites;pageGroup:string:Search Flow;website:website:pericles'
      }).done(function (html) {
        $this.siblings('.author__ajax-content').html(html);
        UX.toggle.$toggle = $facet;
        UX.toggle.on.build();
      }).fail(function (jqXHR, textStatus, errorThrown) {
        console.log("error occure on the server " + errorThrown);
      });
    }
  });
};

UX.dropBlock.setFocus = function () {};

$(window).on('load resize', function () {
  $('.pageHeader').css('position', 'fixed');

  if ($('.pageHeader .hubpage-menu').length) {
    $('.pageHeader').css('max-height', '100%');
  }

  $('.pageHeader').css('position', 'fixed');
  var pageBodyTop = $('.pageHeader').outerHeight();
  var coolBar = $('.coolBar');
  var additionalHeight = 0;
  var institutionWrapper = $('.institution-wrapper-mobile');
  if (coolBar.length && coolBar.hasClass('coolBar--res')) {
    additionalHeight += coolBar.find('.coolBar__wrapper').outerHeight();
  }

  var pageHeaderHeight = pageBodyTop + additionalHeight;
  $('.pageBody').css('padding-top', pageHeaderHeight);
  $('.w-slide').css('top', pageBodyTop);

  UX.cookiePolicyPopupWidget.cookieRemoved = function () {
    pageBodyTop = $('.pageHeader').outerHeight();
    var pageHeaderHeight = pageBodyTop + additionalHeight;
    $('.pageBody').css('padding-top', pageHeaderHeight);
    $('.w-slide').css('top', pageBodyTop);
  };
});

(function () {
  var $window = $(window),
      $body = $('body'),
      isMobile = false; // variable use to determine if responsive mode is on or off

  var backToTop = {
    $backBtb: $('.back-to-top'),
    left: null,
    pageScrollValue: null,
    pageHeight: null,
    vPort: "screen-md",
    // default responsive break point
    init: function init() {
      backToTop.left = $('.container').offset().left + $('.container').width() + 50;
      backToTop.$backBtb.css('left', backToTop.left);
      backToTop.pageScrollValue = $window.scrollTop() + $('.pageHeader').outerHeight();
      backToTop.pageHeight = $window.outerHeight() - $('.pageHeader').outerHeight();
      backToTop.control();
    },
    control: function control() {
      $(document).on(backToTop.vPort + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        isMobile = true;
      });
      $(document).on(backToTop.vPort + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
        isMobile = false;
      });
      $window.scroll(function () {
        backToTop.pageScrollValue = $window.scrollTop() + $('.pageHeader').outerHeight();

        if (isMobile) {
          backToTop.left = $('.container').offset().left + $('.container').width() - 50;
          backToTop.$backBtb.css('left', backToTop.left);
        } else {
          backToTop.left = $('.container').offset().left + $('.container').width() + 50;
          backToTop.$backBtb.css('left', backToTop.left);
        }

        if (backToTop.pageScrollValue > backToTop.pageHeight) {
          backToTop.$backBtb.show();
        } else {
          backToTop.$backBtb.hide();
        }
      });
      backToTop.$backBtb.on('click', function () {
        $body.stop().animate({
          scrollTop: 0
        }, 500, 'swing');
      });
    }
  };
  UX.backToTop = backToTop; // add to global namespace
})();

$(document).ready(function () {
  $('.hp-browse-by-controller').click(function (e) {
    if (window.innerWidth < 769) {
      e.preventDefault();
      $(this).find('.icon').toggleClass(" icon-chevron-down icon-chevron-up");
      $(this).siblings('.hp-browse-by-content').toggle();
    }
  });
  $('.icon-login-mobile img').click(function (e) {
    e.preventDefault();
    $(this).parent('.icon-login-mobile').siblings('.login-register-container').toggle();
  }); // check if the user non-institution

  if ($('.institution-info-wrapper').is(':empty')) {
    $('.UX3InstitutionBanner').addClass('non-institution');
  }

  $(window).on('load', function () {
    $('.subjects-container .accordion-tabbed__tab.js--open > a').click();
  });
});

$(document).ready(function () {
  if ($('.to-section').length > 1) {
    $('.to-section').each(function () {
      var section = $(this).text();
      var id = $(this).attr("id");
      $('<li role="menuitem"><a href="#' + id + '"><span>' + section + '</span></a></li>').appendTo('.sections__drop');
    });
  } else {
    $('.toc-go-section').remove();
    $('[data-db-target-for="tocSections"]').parent('li').remove();
  }
});
$(window).on('load resize orientationchange', function () {
  // if Pb is open no content truncation should take effect
  var isNotPb = $('#pb-editor [data-pb-dropzone]').length == 0;

  if (isNotPb) {
    var toTrunk8 = $('.aboutBook');

    if (toTrunk8.find('.pb-rich-text').length) {
      toTrunk8 = toTrunk8.find('.pb-rich-text');
    }

    toTrunk8.truncate({
      lines: 5,
      seeMoreLink: true,
      seeMoreText: 'Show all',
      seeLessText: 'Show less'
    });
  }
});

// Import components

(function () {
  UX.searchFieldsCtrl.magicSuggestTrigger = true;
  $(window).on('load', function (e) {
    if (window.location.hash == '#citation') {
      $('.citation-search__tab a').click();
    }

    var searchParams = new URLSearchParams(window.location.search);

    if (searchParams.has('publication')) {
      var quickLinkJournalMainLbl = $('input[name="quickLinkJournalMain"]').data('label');
      $('input[name="quickLinkJournalMain"]').val(quickLinkJournalMainLbl);
    }

    $('body').on('click', '.advanced-tips-text .accordion__control', function () {
      if ($(this).hasClass('js--open')) {
        $('body, html').addClass('lock-screen');
      } else {
        $('body, html').removeClass('lock-screen');
      }
    });
  });
})();

UX.searchFieldsCtrl.addtionalControls = function ($this) {
  $('body').on('submit', '#frmSearch', function () {
    $.each($('[name="publication[]"]'), function () {
      if ($(this).val().split('"').length > 1) {
        $(this).val($(this).val().split('"')[1]);
      }
    });
  });
};

UX.searchFieldsCtrl.select.dateRange = function ($this) {
  var $radioParent = $this.closest('.time-frame');
  var radio = $radioParent.find('input[type=radio]');
  radio.trigger('click');
};

UX.searchFieldsCtrl.select.dateRangeRadio = function ($this) {
  UX.searchFieldsCtrl.select.dateRange($this);

  if ($('#staticRange:checked').length) {
    $('#staticRangeSelect').attr('name', 'Ppub');
  } else {
    $('#staticRangeSelect').attr('name', '');
  }

  if ($('#customRange:checked').length) {
    $('.AfterMonth').attr('name', 'AfterMonth');
    $('.AfterYear').attr('name', 'AfterYear');
    $('.BeforeMonth').attr('name', 'BeforeMonth');
    $('.BeforeYear').attr('name', 'BeforeYear');
  } else {
    $('.AfterMonth').attr('name', '');
    $('.AfterYear').attr('name', '');
    $('.BeforeMonth').attr('name', '');
    $('.BeforeYear').attr('name', '');
  }
};

UX.searchFieldsCtrl.on.doSuggest = function () {
  var ms;
  $(UX.searchFieldsCtrl.$form).find('.magicsuggest').each(function () {
    if ($('.appliedFilter').length) {
      var appliedFilterVal = $(this).val().split(',');
      var appliedFilterLabel = $(this).data('label');
    }

    var doSuggestTarget = $(this).data('auto-complete-target');
    var maxWords = 200;
    var maxChars = 222;
    ms = $(this).magicSuggest({
      data: '/action/doSuggest?target=' + doSuggestTarget,
      method: 'GET',
      valueField: 'value',
      autoSelect: false,
      allowFreeEntries: 'false',
      displayField: 'label',
      cls: 'search-term',
      hideTrigger: 'true',
      beforeSend: function beforeSend(xhr, settings) {
        var enteredTerm = settings.url.substr(settings.url.indexOf('query=') + 6).replace(/[​​+]/g, ' ');

        if (enteredTerm.split(" ").length > maxWords || enteredTerm.length > maxChars || !enteredTerm.replace(/\s/g, '').length) {
          return false;
        }
      }
    });

    if ($(this).hasClass('appliedFilter')) {
      //ms.setSelection([{name:'Paris', value:1}]);
      ms.setSelection([{
        value: appliedFilterVal,
        label: appliedFilterLabel
      }]);
    }
  });
  $(ms).on('selectionchange', function () {
    var $referenceFieldsWrapper = $('.advanced-search--referenceFields');
    var selection = this.getSelection();
    var selectionParam = selection[0].param;
    var selectionParamValue = selection[0].value;
    var dataLength;
    $.ajax({
      url: '/action/specialSearchFields?' + selectionParam + '=' + selectionParamValue,
      type: "GET",
      success: function success(data) {
        //data = [{"tagId": 123, "tagLabel": "Biological Name", "tagSearchField": "BiologicalNameFieldName"}, {"tagId": 123, "tagLabel": "CAS number", "tagSearchField": "CASNumberFieldName"}] /*static data for testing*/
        dataLength = data.length;
        $.each(data, function (index, value) {
          $("<div>").addClass('referenceFields--field input-group col-md-6').append('<label for="referenceFields-' + index + '">' + value.tagLabel + '</label><input id="referenceFields-' + index + '" type="text" placeholder="" name="' + value.tagSearchField + '"/>').appendTo($referenceFieldsWrapper.find('fieldset'));
        });
      },
      complete: function complete() {
        if (dataLength) {
          $referenceFieldsWrapper.slideDown();
        }
      }
    });
  });
};

UX.searchFieldsCtrl.on.clone = function ($this) {
  UX.searchFieldsCtrl.$wrapper.clone(true, true).find('input').val('').end().appendTo('.advanced-search--searchIn');
  $this.addClass('hidden');
  $this.siblings('.remove-ctrl-field').removeClass('hidden');
  $this = $('.advanced-search--searchIn').children('.searchIn--field:last-child');
  UX.searchFieldsCtrl.check.lastClone($this);
};

UX.searchFieldsCtrl.toggleSearchBlock = function () {
  return;
};

UX.searchFieldsCtrl.click.toggleSearchBlock = function () {
  $('body').on('click', '.search__result .advanced-search__ctrl', function (e) {
    e.preventDefault();
    $(this).toggleClass('js--open');
    $('.search-result__meta .advanced-search__tabs').slideToggle(600, 'easeOutQuad');
  });
};

UX.loader.load.related = function () {};

UX.loader.load.references = function () {};

UX.loader.load.figures = function () {};

UX.loader.getContentSuccess = function ($elem) {
  if ($elem == 'related') {
    $('.delayLoad').show();
    $('.lazy-load').remove();
  }
};

function referencesBottom($this) {
  var referencesLink = $this.data('references');

  if (!$('#references-section .accordion__control').hasClass('clicked')) {
    $.get(referencesLink).done(function (html) {
      $('#references-section .accordion__control').addClass('clicked');
    }).fail(function (jqXHR, textStatus, errorThrown) {
      console.log("error occure on the server " + errorThrown);
    });
  }
}

UX.loader.additionalController = function () {
  UX.loader.abstractLangs();
  UX.loader.referencesHash();
  $(document).on('click', '[href="#citedby-section"]', function (e) {
    e.preventDefault();
    e.stopPropagation();
    UX.scroll.scrollToTarget(this, true);
    var $target = $('#citedby-section').closest('.accordion__control');

    if (!$target.hasClass('js--open')) {
      $target.click();
    }
  });
  $('body').on('click', '.related-tab', function (e) {
    if (UX.loader.related != undefined) {
      // check if related' service url has been defined
      UX.loader.element = UX.loader.related;
      UX.loader.target = UX.loader.tabRelated;

      if (UX.loader.check.empty()) {
        // check if figures panes is empty
        UX.loader.getContent('related'); // get references content

        UX.accordion.hideAllBoolean = false;
        UX.accordion.logic($('.related-tab .accordion-tabbed'));
      }
    }
  });
  $('body').on('click', '.references-tab', function (e) {
    if (UX.loader.references != undefined) {
      // check if related' service url has been defined
      UX.loader.element = UX.loader.references;
      UX.loader.target = UX.loader.tabReferences;

      if (UX.loader.check.empty()) {
        // check if figures panes is empty
        UX.loader.getContent('references'); // get references content
      }
    }
  });
  $('body').on('click', '.figures-tab', function (e) {
    if (UX.loader.figure != undefined) {
      // check if related' service url has been defined
      UX.loader.element = UX.loader.figure;
      UX.loader.target = UX.loader.tabFigure;

      if (UX.loader.check.empty()) {
        // check if figures panes is empty
        UX.loader.getContent('figure'); // get references content
      }

      setTimeout(function () {
        UX.loader.captionTruncate('.tab__content figcaption.figure__caption .figure__caption', 5, 'show', 'hide');
      }, 1000);
    }
  });
  $(document).on('click', '.abstract-group .article-section__abstract .lang', function (e) {
    e.preventDefault();
    $('.article-row-left').height('auto');
    var lang = $(this).data('lang-of');
    var langParent = $(this).closest('.abstract-group').find('[data-lang=' + lang + ']');
    $('.article-section__abstract:not(#abstract-graphical-)').hide();
    $('.lang').removeClass('active');
    langParent.find('[data-lang-of=' + lang + ']').addClass('active');
    langParent.show();

    if ($('.article-row-left').outerHeight() < $(window).outerHeight()) {
      $('.article-row-left').height($(window).outerHeight() - $('header').outerHeight());
    }
  });
  $(document).on('click', '.figure-viewer .figureLink, .figure-viewer .bibLink', function () {
    $('.figure-viewer__ctrl__close').trigger('click');
  });
  $(window).on('load ', function () {
    if ($('.coolBar').length && $('.w-slide').length) {
      $('.w-slide').addClass('padding-top');
    }

    $('.hideOnJSLoad').remove();
    $('.showOnJSLoad').removeClass('showOnJSLoad'); //LIT-188190

    $('.coolBar--accessDenail .accordion-tabbed__control').on('click', function (e) {
      if (!$(this).hasClass("external")) {
        e.preventDefault();
        e.stopPropagation();
        $(this).next(".accordion-tabbed__content").toggle();
        $(this).attr('aria-expanded', $(this).attr('aria-expanded') == 'true' ? 'false' : 'true');
        $(this).parent('.accordion-tabbed__tab').toggleClass('js--open');
      }
    });
  });
  $('.figures-tab').on("click", function () {
    UX.loader.captionTruncate('.tab__content figcaption.figure__caption .figure__caption', 5, 'show', 'hide');
  });
  $('.citation__title').on('click', '.scrollableLink', function () {
    $('.article-header__references-container .read-more').click();
  });

  if ($('.corrections-label').length > 0) {
    $('.corrections-body > ul').addClass('corrections-list');
    $('.corrections-label').addClass('w-slide__btn').attr({
      'data-slide-target': '.corrections-body',
      'data-label': 'Correction(s)'
    });
  }

  $('body').on('click', '#references-section .accordion__control:not(.js--open)', function (e) {
    referencesBottom($(this));
  });
  $(window).load(function () {
    var url = window.location.href;
    var splitURL = url.split('#');
    var referencesSection = splitURL[1];

    if (referencesSection == "references-section") {
      var firstRef = $('#references-section .accordion__control:not(.js--open)').first().click();
      referencesBottom(firstRef);
    }
  });
};

UX.slide.setBackLabel = function () {
  if (UX.slide.$toggle != null) {
    if (UX.slide.$toggle.hasClass('article-row-right__tabLinks')) {
      UX.slide.$back.html('<i class=" icon-arrow_l" aria-hidden="true"></i>About');
    } else {
      UX.slide.$back.html('<i class=" icon-arrow_l" aria-hidden="true"></i>Back');
    }
  }
};

UX.loader.abstractLangs = function () {
  var tmp = [];
  var ids = [];
  var $abs = $('.abstract-group .article-section__abstract'); //$abs.addClass('active');

  $('.article-section__abstract:not(#abstract-graphical-)').hide();
  $abs.each(function () {
    if ($(this).find('.lang').length) {
      // check if we have tow abs with the same lang
      for (var i = 0; i <= tmp.length; i++) {
        if (tmp[i] == $(this).find('.lang').html()) {
          $(this).show();
          $(this).find('.lang').remove(); //return;
        }
      }

      tmp.push($(this).find('.lang').html());
      ids.push($(this).attr('id'));
      $(this).find('.lang').remove();
      $(this).find('.article-section__header').after("<div class='lang-container'></div>");
    }
  });

  if (tmp.length <= 1) {
    $('.lang-container').remove();
    $('.article-section__abstract').show();
  }

  var lanName;

  for (var i = 0; i < tmp.length; i++) {
    switch (tmp[i]) {
      case 'en':
        lanName = "English";
        break;

      case 'fr':
        lanName = "French";
        break;

      case 'es':
        lanName = "Spanish";
        break;

      case 'de':
        lanName = "Deutsche";

      case 'kr':
        lanName = "Korean";
    }

    $('.lang-container').append("<a class='lang' href='#" + ids[i] + "' hreflang='" + tmp[i] + "' data-lang-of='" + tmp[i] + "'>" + tmp[i] + "<span>This link goes to a " + lanName + " section</span></a>");
  }

  $('.lang').show();
  $abs.find('.lang:first-child').addClass('active').show();
  $('.article-section__abstract[data-lang= ' + tmp[0] + ' ]').show();
};

UX.loader.referencesHash = function () {
  var hash = window.location.hash;

  if (hash == "#reference") {
    setTimeout(function () {
      $('.references-tab').click();
    }, 200);
  }
};

UX.loader.captionTruncate = function (elem, lineNumber, show_more, show_less) {
  $(elem).each(function () {
    var $caption = $(this);
    $caption.truncate({
      lines: lineNumber,
      seeMoreLink: true,
      seeMoreText: show_more,
      seeLessText: show_less
    }); // apply mathjax formating in the tab

    if ($(".mathStatement").length || $(".inline-equation").length && $caption.hasClass('figure__caption')) {
      MathJax.Hub.Queue(["Typeset", MathJax.Hub]);
    }
  });
};

UX.loader.get.mathjax = function () {
  if ($(".mathStatement").length || $(".inline-equation").length || $("math").length) {
    var articleBodyWidth = $(".article__body").innerWidth();
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.src = $('article').data('mathjax');
    var config = 'MathJax.Hub.Config({' + 'displayAlign: "left", ' + '"HTML-CSS": { linebreaks: {automatic: true,width: "' + articleBodyWidth + 'px"}, fonts: ["STIX-Web"]},' + '"SVG":{ linebreaks: {automatic: true},font: "STIX-Web"},' + '"fast-preview": { disabled: true },' + 'tex2jax: {inlineMath: [["\\\\(", "\\\\)"]],displayMath: [[\'\\\\[\', \'\\\\]\']],processEscapes: true},' + 'styles: {' + '"span.MathJax": {' + '"padding-right": "2px"' + '}' + '}' + '});' + 'MathJax.Hub.Startup.onload();';

    if (window.opera) {
      script.innerHTML = config;
    } else {
      script.text = config;
    }

    document.getElementsByTagName("head")[0].appendChild(script);
  }
};

UX.figureViewer.additionalBehaviorOnShow = function ($el) {
  if ($el.find('figcaption .figure__caption').data('originalContent') != undefined) {
    var content = $el.find('figcaption .figure__caption').data('originalContent');
  } else {
    var content = $el.find('figcaption, .figcaption').clone();
    content.find('strong').remove();
  }

  return content;
};

$(window).on('load resize orientationchange', function () {
  UX.loader.captionTruncate('.tab__content figcaption.figure__caption .figure__caption', 5, 'show', 'hide');
  UX.loader.captionTruncate('.disclosures', 2, 'show', 'hide');
  UX.loader.captionTruncate('.article-header__references-container:not(.no-truncate)', 1, 'More', 'Less');
  UX.loader.captionTruncate('.aboutThisBook .content', 6, 'More', 'Less');
  var toTrim = '.article-citation .loa-authors .accordion-tabbed';

  if (UX.loader.isMobile) {
    $(toTrim).truncate('destroy');
    UX.loader.rebuild.responsive();
    toTrim = '.article-citation .loa.mobile-authors';
    $(toTrim).truncate({
      lines: 2,
      type: 'list',
      seeMoreLink: true,
      seeMoreText: 'See all authors',
      seeLessText: 'See fewer authors',
      isMobile: true,
      mobileTarget: '#sb-1',
      isSliding: true
    });
  } else {
    $(toTrim).truncate({
      lines: 2,
      type: 'list',
      seeMoreLink: true,
      seeMoreText: 'See all authors',
      seeLessText: 'See fewer authors',
      isSliding: false
    });
  }
});

// check if the user non-institution
(function () {
  if ($('.institution-info-wrapper').is(':empty')) {
    $('.UX3InstitutionBanner').addClass('non-institution');
  }
})(); // to be removed

UX.quickSearch.additionalController = function () {
  if (!window.highlight) {
    window.highlight = function () {};
  }

  $(document).on(UX.quickSearch.vPort + '-on', function () {
    // Waiting for custom event that will be triggered by controller.js to activate responsive effects
    UX.quickSearch.isMobile = true;
  });
  $(document).on(UX.quickSearch.vPort + '-off', function () {
    // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
    UX.quickSearch.isMobile = false;
  });
  $(document).on('focus', '.quick-search:not(.quick-search--citation) input.fakeQSInput', function () {
    if (!$(this).closest('.expanded--quickSearch').length) {
      UX.quickSearch.open($(this));
    }
  });
  $(document).on('focus', '.expanded--quickSearch input.actualQSInput', function () {
    $(this).siblings('.search-options-wrapper').stop().slideDown(550);
  });
  $(document).on('click touchstart', function (e) {
    if (!$(e.target).closest('.main-search-field-wrapper, .search-options-wrapper').length && !$('.header-quicksearch').hasClass('expanded--quickSearch') && !$(e.target).hasClass("qsItem") && !$(e.target).closest('.qsItem').length && !$(e.target).closest('.qsaItem').length) {
      $('.quick-search input').blur();
      UX.quickSearch.close();
    }
  });
  $('#citationSearchForm').on('click', '[type="submit"]', function (e) {
    e.preventDefault();
    UX.quickSearch.submitCitationForm('#citationSearchForm');
  });
  $(document).on('keyup', function (e) {
    var keyCode = e.keyCode || e.which;

    if (keyCode == 9) {
      if ($(document.activeElement).closest('.quick-search-wrapper').length == 0) {
        UX.quickSearch.close();
      }
    }
  });
  $(document).on('click', '.quickSearchAutocomplete a', function (e) {
    $('.quick-search input').blur();
  });
  $(document).on('click', '[title="Citation"]', function (e) {
    $('.quick-search').addClass('citationSearch--open');
  });
  $(document).on('click', '.citationSearch--open [data-toggle="tab"]', function (e) {
    $('.quick-search').removeClass('citationSearch--open');
  });
  $('.quick-search__item').on('click', function (e) {
    e.preventDefault();
    var $qSearch = $(this).siblings('.quick-search');

    if ($qSearch.is(':visible')) {
      $qSearch.css('display', '');
    } else {
      $qSearch.css('display', 'block');
    }

    $(this).toggleClass('active');

    if ($qSearch.is(":visible")) {
      $qSearch.find('input').focus();
    } else {
      $qSearch.find('input').blur();
    }

    UX.quickSearch.setPosition();
  });
  $('.quick-search').on('input', '.actualQSInput', function () {
    $('.quick-search .actualQSInput').val($(this).val());
  });
  $(window).resize(function () {
    UX.quickSearch.setPosition();
  });
  $(window).on('orientationchange', function (event) {
    $('.quick-search input').blur();
    UX.quickSearch.close();
  });
  $(document).on('click', 'a[data-search-in="wileyOnlineLibrary"]', function (e) {
    var protocol = window.location.protocol;
    var hostname = window.location.host;
    var mainHostName = hostname.split('.');
    mainHostName.shift();
    $('form[name="wileyOnlineLibraryQuickSearch"]').attr('action', protocol + '//' + mainHostName.join('.') + "/action/doSearch");
  });
};

UX.quickSearch.open = function ($el) {
  if (!$el.closest('.homepage-search-wrapper').length) {
    var $qsW = $el.closest('.quick-search');
    $qsW.addClass('open');

    if ($('.pageHeader').length) {
      $('.pageHeader').addClass('searchOpen');
    }

    $('body').addClass('searchOpen-body');
    setTimeout(function () {
      if ($qsW.hasClass("open")) {
        $qsW.find('.actualQSInput').focus();
      }
    }, 120);
    setTimeout(function () {
      if ($qsW.hasClass("open")) {
        $qsW.find('.search-options-wrapper').stop().slideDown(550, function () {
          $el.closest('.main-search-field-wrapper').css('overflow', 'visible');
        });
        $('.quickSearchAutocomplete').css('padding-top', '47px');
      }
    }, 700);
  }
};

UX.quickSearch.close = function () {
  $('.quick-search').removeClass('open');
  $('.pageHeader').removeClass('searchOpen');
  $('body').removeClass('searchOpen-body');

  if (!UX.quickSearch.isMobile) {
    if ($('.quick-search').closest('.expanded--quickSearch').length) {
      $('.search-options-wrapper').stop().slideUp(500);
    } else {
      $('.main-search-field-wrapper').css('overflow', 'hidden');
      $('.search-options-wrapper').stop().hide(500);
      $('.quickSearchAutocomplete').css('padding-top', '0'); //if ($('.quick-search .actualQSInput').val())

      $('.quick-search .fakeQSInput').val($('.quick-search .actualQSInput').val());
    }
  }
};

UX.quickSearch.setPosition = function () {
  var $qSearch = $('.quick-search');

  if ($qSearch.closest('.homepage-search-wrapper').length == 0 && !$qSearch.hasClass('quick-search--citation') && UX.quickSearch.isMobile) {
    var $qSearchArrow = $('.quick-search__item__arrow');
    $qSearch.css({
      width: $(window).width(),
      left: ($('.container').outerWidth() - $(window).width()) / 2
    });
    $qSearchArrow.css('bottom', '0');
    var arrowP = $qSearch.offset().top - ($qSearchArrow.offset().top + 20);
    $qSearchArrow.css('bottom', '-' + arrowP + 'px');
  }
};

UX.quickSearch.submitCitationForm = function ($elem) {
  var errorMsg = '<p class="error"> Please enter a journal title, volume and page number or volume and citation number as a minimum requirement to run this search.</p>';
  $elem = $($elem);
  $elem.find('.error').remove();
  var volVal = $elem.find('[name="quickLinkVolume"]').val();
  var yearVal = $elem.find('[name="quickLinkYear"]').val();

  if (volVal == '' && yearVal == '') {
    $elem.find('.fields').append(errorMsg);
  } else {
    var pageVal = $elem.find('[name="quickLinkPage"]').val();
    var citationNumberVal = $elem.find('[name="quickLinkCitation"]').val();
    var jorVal = $elem.find('[name="quickLinkJournal"]').val();

    if (pageVal == '' && citationNumberVal == '') {
      $elem.find('.fields').append(errorMsg);
      return;
    }

    if (jorVal == '') {
      $elem.find('.fields').append('<p class="error">Please enter the journal title.</p>');
    } else {
      var baseURL = window.location.origin + '/action/quickLink?';
      var citationFormInputs = {
        $quickLinkJournalVal: $('[name=quickLinkJournal]').val(),
        $quickLinkYearVal: $('[name=quickLinkYear]').val(),
        $quickLinkVolumeVal: $('[name=quickLinkVolume]').val(),
        $quickLinkIssueVal: $('[name=quickLinkIssue]').val(),
        $quickLinkPageVal: $('[name=quickLinkPage]').val(),
        $quickLinkCitationVal: $('[name=quickLinkCitation]').val()
      };
      $.get(baseURL + 'quickLinkJournal=' + citationFormInputs.$quickLinkJournalVal + '&quickLinkYear=' + citationFormInputs.$quickLinkYearVal + '&quickLinkVolume=' + citationFormInputs.$quickLinkVolumeVal + '&quickLinkIssue=' + citationFormInputs.$quickLinkIssueVal + '&quickLinkPage=' + citationFormInputs.$quickLinkPageVal + '&quickLinkCitation=' + citationFormInputs.$quickLinkCitationVal).done(function (jqXHR, textStatus, errorThrown) {
        window.location = jqXHR.link;
      }).fail(function (jqXHR, textStatus, errorThrown) {
        var errorResp = jqXHR.responseJSON.error;

        if (errorResp) {
          $('.fields').append('<p class="error">' + errorResp + '</p>');
        } else {
          console.log("Error occured on the server: " + errorThrown);
        }
      });
    }
  }
};

(function () {
  //document.activeElement
  var $body = $('body'),
      $window = $(window);
  var loi = {
    $wrapper: null,
    $list: null,
    isMobile: false,
    loiPosition: null,
    vPort: "screen-md",
    // default responsive break point
    init: function init() {
      loi.$wrapper = $('.loi');
      loi.$list = $('.loi__list');
      loi.on.build();
      loi.control();
    },
    control: function control() {
      $body.on('click ', '.back-btn', function (e) {
        e.preventDefault();
        loi.$wrapper.removeClass('js--open');
      });
      $(document).on(loi.vPort + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        loi.isMobile = true;
        loi.$wrapper.addClass("loi--res"); // class will be used in our scss (to replace media queries)

        loi.$wrapper.addClass('js--open');
      });
      $(document).on(loi.vPort + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
        loi.isMobile = false;
        loi.$wrapper.removeClass("loi--res");
      });
    },
    on: {
      build: function build() {
        $('.expandable-list.js--open').find('.expandable-list__body').show();
      }
    }
  };
  UX.loi = loi; // add to global namespace
})();

(function () {
  //document.activeElement
  var $body = $('body'),
      $window = $(window);
  var sliderTabs = {
    $wrapper: null,
    $list: null,
    $controls: null,
    $nextBtn: null,
    $prevBtn: null,
    $listItem: null,
    isTouched: false,
    pointerPosition: 0.0,
    cumulativeShift: 0.0,
    init: function init() {
      sliderTabs.$wrapper = $('.swipe__wrapper');
      sliderTabs.$list = $('.swipe__wrapper .loc');
      sliderTabs.$controls = '<div class="sliderTabs-list__controls"><span class="sliderTabs__btn--prev"><i class="icon-arrow_l" aria-hidden="true"></i></span><span class="sliderTabs__btn--next"><i class="icon-arrow_r" aria-hidden="true"></i></span></div>';
      sliderTabs.on.build();
      sliderTabs.control();
      $window.resize(function () {
        sliderTabs.on.rebuild();
      });
    },
    control: function control() {
      $('.swipe__wrapper .loc').on('click', 'a', function (e) {
        sliderTabs.$listItem = $(this); //reemi

        var old = sliderTabs.$listItem.closest('.loc').find('.active').index();

        if (sliderTabs.$listItem.closest('.slider-covers--light').length) {
          sliderTabs.on.selectLight(old);
          return;
        }

        if (sliderTabs.$listItem.closest('.swipe__wrapper').find('.sliderTabs-list__controls').length) {
          sliderTabs.on.select();
        }
      });
      $body.on('click', '.sliderTabs__btn--prev', function () {
        sliderTabs.$prevBtn = $(this);
        sliderTabs.on.prev();
      });
      $body.on('click', '.sliderTabs__btn--next', function () {
        sliderTabs.$nextBtn = $(this);
        sliderTabs.on.next();
      });
      $body.on('touchmove', function (e) {
        sliderTabs.on.touch.move(e);
      });
      $(document).on(sliderTabs.vPort + '-on', function () {
        // Waiting for custom event that will be triggered by controller.js to activate responsive effects
        isMobile = true;
      });
      $(document).on(sliderTabs.vPort + '-off', function () {
        // Waiting for custom event that will be triggered by controller.js to deactivate responsive effects
        isMobile = false;
      });
    },
    on: {
      select: function select() {
        sliderTabs.$list = sliderTabs.$listItem.closest('.swipe__wrapper').find('.loc');
        sliderTabs.$nextBtn = sliderTabs.$listItem.closest('.swipe__wrapper').find('.sliderTabs__btn--next');
        sliderTabs.$prevBtn = sliderTabs.$listItem.closest('.swipe__wrapper').find('.sliderTabs__btn--prev');
        sliderTabs.$scroll = sliderTabs.$list.closest('.scroll');
        var thisLinkPosition = sliderTabs.$listItem.offset().left;
        var nextButtonPosition = sliderTabs.$nextBtn.offset().left;
        var prevButtonPosition = sliderTabs.$prevBtn.offset().left;

        if (thisLinkPosition > nextButtonPosition - sliderTabs.$listItem.outerWidth()) {
          sliderTabs.$scroll.stop().animate({
            scrollLeft: '+=' + sliderTabs.$listItem.outerWidth()
          }, 500, 'linear', function () {
            sliderTabs.on.activeArrows();
          });
        } else if (thisLinkPosition < prevButtonPosition + sliderTabs.$prevBtn.outerWidth()) {
          sliderTabs.$scroll.stop().animate({
            scrollLeft: '-=' + sliderTabs.$listItem.outerWidth()
          }, 500, 'linear', function () {
            sliderTabs.on.activeArrows();
          });
        }
      },
      selectLight: function selectLight(old) {
        sliderTabs.$list = sliderTabs.$listItem.closest('.loc');
        sliderTabs.$scroll = sliderTabs.$list.closest('.scroll');
        var current = sliderTabs.$listItem.closest('li').index();
        var wrapperWidth = parseInt(sliderTabs.$scroll.outerWidth());
        var itemWidth = parseInt(sliderTabs.$listItem.closest('li').outerWidth());
        var $itemFirst = sliderTabs.$wrapper.find('.cover-image:first-child');
        var $itemLast = sliderTabs.$wrapper.find('.cover-image:last-child');
        var marginValue = parseInt(itemWidth * current) - parseInt((wrapperWidth - itemWidth) / 2);

        if (current == 0) {
          $itemFirst.before($itemLast);
          sliderTabs.$list.css({
            left: '-=' + parseInt((wrapperWidth - itemWidth) / 2)
          });
          marginValue = 9;
        }

        $itemFirst = sliderTabs.$wrapper.find('.cover-image:first-child');
        $itemLast = sliderTabs.$wrapper.find('.cover-image:last-child');

        if (current == $itemLast.index()) {
          $itemLast.after($itemFirst);
          sliderTabs.$list.css({
            left: '+=' + parseInt((wrapperWidth - itemWidth) / 2)
          });
          marginValue = sliderTabs.$list.outerWidth() - wrapperWidth - 9;
        }

        sliderTabs.$list.stop().animate({
          left: -1 * marginValue
        }, 500, 'linear');
      },
      next: function next() {
        sliderTabs.$list = sliderTabs.$nextBtn.closest('.swipe__wrapper').find('.loc');
        sliderTabs.$prevBtn = sliderTabs.$list.closest('.sliderTabs-list__wrapper').find('.sliderTabs__btn--prev');
        sliderTabs.$scroll = sliderTabs.$list.closest('.scroll');
        var screenSize = sliderTabs.$scroll.width();
        var shiftSize = screenSize - 20; /// 3;

        if (!sliderTabs.$nextBtn.hasClass('inactive')) {
          sliderTabs.$scroll.stop().animate({
            scrollLeft: '+=' + shiftSize
          }, 500, 'linear', function () {
            sliderTabs.on.activeArrows();
          });
        }
      },
      prev: function prev() {
        sliderTabs.$list = sliderTabs.$prevBtn.closest('.swipe__wrapper').find('.loc');
        sliderTabs.$nextBtn = sliderTabs.$list.closest('.sliderTabs-list__wrapper').find('.sliderTabs__btn--next');
        sliderTabs.$scroll = sliderTabs.$list.closest('.scroll');
        var screenSize = sliderTabs.$scroll.width();
        var shiftSize = screenSize - 20; /// 3;

        sliderTabs.$scroll.stop().animate({
          scrollLeft: '-=' + shiftSize
        }, 500, 'linear', function () {
          sliderTabs.on.activeArrows();
        });
      },
      touch: {
        move: function move(e) {
          if ($(e.target).closest('.loc').length || $(e.target).hasClass('loc')) {
            sliderTabs.$list = $(e.target).closest('.loc');
            sliderTabs.$wrapper = $(e.target).closest('.sliderTabs-list__wrapper');
            sliderTabs.$nextBtn = $(e.target).closest('.sliderTabs-list__wrapper').find('.sliderTabs__btn--next');
            sliderTabs.$prevBtn = $(e.target).closest('.sliderTabs-list__wrapper').find('.sliderTabs__btn--prev');
            sliderTabs.on.activeArrows();
          }
        }
      },
      activeArrows: function activeArrows() {
        sliderTabs.$scroll = sliderTabs.$list.closest('.scroll');

        if (parseInt(sliderTabs.$scroll.scrollLeft()) > 0) {
          sliderTabs.$prevBtn.removeClass('inactive');
        } else {
          sliderTabs.$prevBtn.addClass('inactive');
        }

        var sliderSize = sliderTabs.$list.width();
        var wrapperSize = sliderTabs.$wrapper.width();

        if (parseInt(sliderTabs.$scroll.scrollLeft()) > parseInt(sliderSize - wrapperSize)) {
          sliderTabs.$nextBtn.addClass('inactive');
        } else {
          sliderTabs.$nextBtn.removeClass('inactive');
        }
      },
      recalculate: function recalculate(elem) {
        var tabNavWidth = 0;
        elem.find('li').each(function (index) {
          tabNavWidth += $(this).innerWidth();
        });
        elem.width(tabNavWidth);

        if (tabNavWidth > sliderTabs.$wrapper.width()) {
          $('.sliderTabs__btn--prev').addClass('inactive');
        } else {
          elem.closest('.swipe__wrapper').find('.sliderTabs-list__controls').remove();
        }
      },
      build: function build() {
        sliderTabs.$list.each(function (index) {
          sliderTabs.$wrapper = $(this).closest('.swipe__wrapper');
          sliderTabs.$wrapper.addClass('sliderTabs-list__wrapper');
          var sliderTabsListWidth = $(this).width();

          if (sliderTabsListWidth > sliderTabs.$wrapper.width()) {
            $(this).closest('.swipe__wrapper').prepend(sliderTabs.$controls);
          }

          $('.sliderTabs__btn--prev').addClass('inactive');
          sliderTabs.on.recalculate($(this));
        });
        sliderTabs.$nextBtn = $('.sliderTabs__btn--next');
        sliderTabs.$prevBtn = $('.sliderTabs__btn--prev');

        if (sliderTabs.$wrapper.closest('.slider-covers--light').length) {
          sliderTabs.$listItem = sliderTabs.$wrapper.find('.active');
          sliderTabs.on.selectLight(0);
        }
      },
      rebuild: function rebuild() {
        $('.sliderTabs-list__controls').remove();
        sliderTabs.$list = $('.swipe__wrapper .loc');
        sliderTabs.$list.each(function (index) {
          sliderTabs.on.recalculate($(this));
          var sliderTabsListWidth = $(this).width();

          if (sliderTabsListWidth > sliderTabs.$wrapper.width()) {
            $(this).closest('.swipe__wrapper').prepend(sliderTabs.$controls);
            $('.sliderTabs__btn--prev').addClass('inactive');
          } else {
            $(this).closest('.swipe__wrapper').find('.sliderTabs-list__controls').remove();
          }
        });
      }
    }
  };
  UX.sliderTabs = sliderTabs; // add to global namespace
})();

(function () {
  var reports = {
    $form: $("#institutionUsageReport"),
    $report_input_name: $('[name="counterIds"]'),
    $report_input_name_checked: $('[name="counterIds"]:checked'),
    $submitReport: $('.js__submitReport'),
    $markAll: $('[name="markall"]'),
    $counterToggle: $('[name="counterEnabled"]'),
    submitActor: null,
    $submitActors: null,
    startMonth: null,
    startYear: null,
    endMonth: null,
    endYear: null,
    selectedYearVal: null,
    type: "noType",
    $wrapper: $(".dataRange__wrapper"),
    monthsList: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'],
    init: function init() {
      reports.checkMarkAllValue(reports.$markAll);
      this.$submitActors = this.$form.find('button[type=submit]');
      reports.get.data();
      reports.controller();
    },
    controller: function controller() {
      reports.$submitReport.off('click');
      reports.$submitActors.click(function (event) {
        reports.submitActor = this;
      });
      reports.$markAll.on('click', function (e) {
        reports.on.markAll($(this));
      });
      reports.$counterToggle.on('click', function (e) {
        window.setTimeout(function () {
          reports.$form.find('[name="notify"]').trigger('click');
        }, 400);
      });
      reports.$submitReport.on('click', function (e) {
        e.preventDefault();
        e.stopPropagation();
        reports.on.submit();
      });
      $(".dataRange__year").on("change", function () {
        // update month list when selected year has changed
        var month = 0;
        reports.selectedYearVal = parseInt($(this).find(":selected").val());
        reports.slectedMonthVal = parseInt($(this).siblings(".dataRange__month").find(":selected").val());

        if (reports.selectedYearVal == reports.endYear) {
          reports.type = "end";
          month = reports.endMonth;
        } else if (reports.selectedYearVal == reports.startYear) {
          reports.type = "start";
          month = reports.startMonth;
        } else {
          reports.type = "noType";
          month = 0;
        }

        reports.on.update($(this), month);
      });
    },
    checkMarkAllValue: function checkMarkAllValue($el) {
      reports.$target = $el.closest('.alert__list');
      var MarkAllValue = true;
      reports.$target.find('[type="checkbox"]:not([name="markall"])').each(function () {
        MarkAllValue = MarkAllValue && $(this).prop('checked');
      });

      if (MarkAllValue) {
        $el.prop('checked', true);
      }
    },
    validate: function validate() {
      if ($(".dataRange__to .dataRange__year").find(":selected").val() < $(".dataRange__from .dataRange__year").find(":selected").val() || $(".dataRange__to .dataRange__year").find(":selected").val() == $(".dataRange__from .dataRange__year").find(":selected").val() && $(".dataRange__to .dataRange__month").find(":selected").val() < $(".dataRange__from .dataRange__month").find(":selected").val()) {
        alert('Please select valid date range');
        return false;
      } else {
        return true;
      }
    },
    on: {
      submit: function submit() {
        var numChecked = $('[name="counterIds"]:checked').length;

        if (numChecked === 0) {
          reports.on.error_msg();
          return;
        } else if (!reports.validate()) {
          return;
        } else {
          if (null === reports.submitActor) {
            // If no actor is explicitly clicked, the browser will
            // automatically choose the first in source-order
            // so we do the same here
            reports.submitActor = reports.$submitActors[0];
          }

          $('<input />').attr('type', 'hidden').attr('name', reports.submitActor.name).attr('value', "").appendTo(reports.$form);
          reports.$form.submit();
        }
      },
      markAll: function markAll($el) {
        reports.$target = $el.closest('.alert__list');

        if ($el.prop('checked')) {
          reports.$target.find('[type="checkbox"]').prop('checked', true);
        } else {
          reports.$target.find('[type="checkbox"]').prop('checked', false);
        }
      },
      error_msg: function error_msg() {
        alert('Please select one report at least');
      },
      update: function update(yearList, monthvalue) {
        // update expected month list variables
        var newVal = reports.slectedMonthVal,
            queueLength,
            // holds queue length
        i,
            // holds starting index
        $monthlist = yearList.siblings(".dataRange__month");
        $monthlist.empty();

        switch (reports.type) {
          case "start":
            // set start months list related vars
            queueLength = 11;
            i = reports.startMonth - 1;
            newVal = reports.slectedMonthVal > i ? reports.slectedMonthVal : i;

            while (i <= queueLength) {
              // iterate through expected months
              reports.fillIt(i + 1, newVal, $monthlist);
              i++;
            }

            break;

          case "end":
            // set end months list vars
            queueLength = parseInt(monthvalue);
            i = 0;
            newVal = reports.slectedMonthVal < queueLength ? reports.slectedMonthVal : queueLength;

            while (i < queueLength) {
              // iterate through expected months
              reports.fillIt(i + 1, newVal, $monthlist);
              i++;
            }

            break;

          default:
            // set 12 months list vars
            queueLength = 11;
            i = 0;

            while (i <= queueLength) {
              // iterate through expected months
              reports.fillIt(i + 1, newVal, $monthlist);
              i++;
            }

        }
      }
    },
    get: {
      data: function data() {
        reports.startMonth = parseInt(reports.$wrapper.attr("data-startMonth")), reports.startYear = parseInt(reports.$wrapper.attr("data-startYear")), reports.endMonth = parseInt(reports.$wrapper.attr("data-endMonth")), reports.endYear = parseInt(reports.$wrapper.attr("data-endYear"));
      }
    },
    fillIt: function fillIt(i, newVal, monthlist) {
      // append option with expected values
      if (i == newVal) {
        // check if current option is expected to selected
        monthlist.append('<option value=' + i + ' selected>' + reports.monthsList[i - 1] + '</option>'); // append selected option
      } else {
        monthlist.append('<option value=' + i + '>' + reports.monthsList[i - 1] + '</option>'); // append rest options
      }
    }
  };
  UX.reports = reports; // add to global namespace
})();

(function () {
  function createAndAppendInput(name, value, form) {
    var inp = document.createElement("input");
    inp.type = "hidden";
    inp.name = name;
    inp.value = value;
    form.append(inp);
  }

  var ipRanges = {
    $body: $('body'),
    trigger: '.trigger-delete',
    addSubmitBtn: $('.js__addIpRange'),
    deleteSubmitBtn: '[name="delete"]',
    updateSubmitBtn: '[name="update"]',
    forceSubmit: '[name="force"]',
    $updateForm: $('#institutionMultiIpChange'),
    $addForm: $('#institutionMultiIpAdd'),
    $modal: $('#rangeConflict'),
    $ranges: $('.smalltextfield[name^="ipRange"]'),
    $form: '',
    init: function init() {
      ipRanges.controller();
    },
    controller: function controller() {
      ipRanges.$body.on('click', ipRanges.trigger, function (e) {
        e.preventDefault();
        ipRanges.on.deleteRange($(this));
      });
      ipRanges.$updateForm.find('.smalltextfield').on('change input', function () {
        ipRanges.on.updateRange($(this));
        $(ipRanges.updateSubmitBtn).removeAttr('disabled');
      });
      $(ipRanges.updateSubmitBtn).on('click', function (e) {
        e.preventDefault();
        ipRanges.$form = ipRanges.$updateForm;
        ipRanges.on.formSubmit(false);
      });
      ipRanges.$body.on('click', '.cancelSubmit', function () {
        ipRanges.modal.cancel();
      });
      ipRanges.$body.on('click', '.continueSubmit', function () {
        ipRanges.modal.submit();
      });
      ipRanges.addSubmitBtn.on('click', function (e) {
        e.preventDefault();
        e.stopPropagation();
        ipRanges.form.submit();
      });
    },
    on: {
      deleteRange: function deleteRange($el) {
        ipRanges.on.checkboxCheck($el);
        ipRanges.$updateForm.find(ipRanges.deleteSubmitBtn).trigger('click');
      },
      updateRange: function updateRange($el) {
        ipRanges.on.checkboxCheck($el);
      },
      checkboxCheck: function checkboxCheck($el) {
        var $tr = $el.parents('tr'),
            $checkbox = $tr.find('[type="checkbox"]'),
            $jfccheckbox = $tr.find('.jcf-checkbox');
        $checkbox.attr('checked', true);
        $jfccheckbox.addClass('jcf-checked');
      },
      formSubmit: function formSubmit(force) {
        if (!force) {
          var hasConflicts = ipRanges.conflict.check();

          if (hasConflicts) {
            ipRanges.modal.show();
            return;
          }
        }

        if (ipRanges.$form === ipRanges.$addForm) {
          createAndAppendInput("add", "add", ipRanges.$addForm);
        } else {
          createAndAppendInput("update", "update", ipRanges.$updateForm);
        }

        ipRanges.$form.submit();
      }
    },
    conflict: {
      check: function check() {
        var hasConflicts = false,
            ip1 = '',
            ip2 = '',
            max = $(ipRanges.$ranges).length - 1;

        if (ipRanges.$form === ipRanges.$addForm) {
          ip1 = $(ipRanges.$ranges[max]).val();
          ipRanges.$ranges.each(function (j) {
            if (j < max) {
              ip2 = $(this).val();
              hasConflicts = ipRanges.conflict.compare(ip1, ip2, ":");
            }

            if (hasConflicts) return false;
          });
        } else {
          ipRanges.$ranges.each(function (i) {
            ip1 = $(this).val();

            if (i < max) {
              ipRanges.$ranges.each(function (j) {
                if (j < max) {
                  if (i < j) {
                    ip2 = $(this).val();
                    hasConflicts = ipRanges.conflict.compare(ip1, ip2, ":");
                  }

                  if (hasConflicts) return false;
                }
              });
              if (hasConflicts) return false;
            }
          });
        }

        return hasConflicts;
      },
      force: function force() {
        $(ipRanges.forceSubmit).prop('checked', true);
        ipRanges.on.formSubmit(true);
      },
      compare: function compare(ip1, ip2, delimiter) {
        var minIP1 = ip1.split(delimiter)[0],
            maxIP1 = ip1.split(delimiter)[1];

        if (typeof maxIP1 === 'undefined') {
          maxIP1 = minIP1;
        }

        var minIP2 = ip2.split(delimiter)[0],
            maxIP2 = ip2.split(delimiter)[1];

        if (typeof maxIP2 === 'undefined') {
          maxIP2 = minIP2;
        }

        var cmp1 = minIP1.localeCompare(maxIP2),
            cmp2 = maxIP1.localeCompare(minIP2);
        return cmp1 <= 0 && cmp2 >= 0 || cmp1 > 0 && cmp2 < 0;
      }
    },
    modal: {
      show: function show() {
        $(ipRanges.$modal).modal();
        UX.modal.$target = $(ipRanges.$modal);
        UX.modal.$close = UX.modal.$target.find('.close');
        UX.modal.items = UX.modal.$target.find('a, button, input');
        UX.modal.items.each(function (index) {
          if (index === UX.modal.items.length - 1) {
            UX.modal.lastItem = $(this);
          }
        });
        UX.modal.on.show();
      },
      cancel: function cancel() {
        $(ipRanges.$modal).modal('hide');
        $('body').removeClass('lock-screen');
      },
      submit: function submit() {
        ipRanges.conflict.force();
      }
    },
    form: {
      submit: function submit() {
        var hasInputsFiled = ipRanges.form.emptyFields();
        ipRanges.$form = ipRanges.$addForm;

        if (!hasInputsFiled) {
          ipRanges.form.error_msg();
          return;
        } else {
          ipRanges.on.formSubmit(false);
        }
      },
      emptyFields: function emptyFields() {
        var result = true,
            $inputs = ipRanges.$addForm.find('input[type="text"]');
        $inputs.each(function (index) {
          if (this.value.trim() == '') {
            result = false;
          }
        });
        return result;
      },
      error_msg: function error_msg() {
        alert('Please fill in both fields.');
      }
    }
  };
  UX.ipRanges = ipRanges; // add to global namespace
})();

(function () {
  var $window = $(window),
      $body = $('body'); // variable use to determine if responsive mode is on or off

  function createAndAppendInput(name, value, form) {
    var inp = document.createElement("input");
    inp.type = "hidden";
    inp.name = name;
    inp.value = value;
    form.append(inp);
  }

  var alerts = {
    $target: null,
    $toggle: null,
    init: function init() {
      alerts.$toggle = $("[name='markall']"); //alerts.on.build();

      alerts.control();
      $(document).ready(function () {
        var href = location.href,
            test = '?isAddCitationAlert=true';

        if (href.indexOf(test) >= 0) {
          var tabToOpen = href.split(test)[1];

          if (tabToOpen === '#citAlerts') {
            $('#pane-citation-con').trigger('click');
          }
        }
      });
    },
    control: function control() {
      $body.on('click', '[name="markall"]', function (e) {
        alerts.$target = $(this).closest('.alert__list');
        var checkboxes = alerts.$target.find('[type="checkbox"]');
        checkboxes.prop('checked', $(this).prop('checked'));
      });
      $body.on('click', '.alert__list [type="checkbox"]', function (e) {
        if (!$(this).prop('checked')) {
          var markall = $(this).closest('form').find('[name="markall"]');
          markall.prop('checked', false);
        }

        $(this).prop('checked', $(this).prop('checked'));
      });
      $body.on('click', '[name="groupAll"]', function (e) {
        alerts.$target = $(this).closest('.accordion-tabbed__tab');
        var checkboxes = alerts.$target.find('[type="checkbox"]');
        checkboxes.prop('checked', $(this).prop('checked'));
      });
      $body.on('change', '.alert__freq', function (e) {
        alerts.on.frequency_change($(this));
      });
      $body.on('change', '.alertSort', function (e) {
        alerts.on.sorting_change($(this));
      });
      $body.on('click', '.js__citActions', function (e) {
        alerts.on.checkboxCheck($(this));
        alerts.on.cit_actions_change($(this));
      });
    },
    on: {
      build: function build() {},
      error_msg: function error_msg() {
        alert('Please select one publication at least');
      },
      frequency_change: function frequency_change($el) {
        var form = $el.parents("form"),
            updateAxa = form.find("input[name=updateAxa]").length;
        form.find("input[name=action]").val(""); //clear the delete field

        if (!updateAxa) createAndAppendInput("updateAxa", "true", form); // form.submit();
      },
      sorting_change: function sorting_change($el) {
        var sortBy = $el.val();
        var activeTab = "#" + $el.closest("li[role='tabpanel']").attr('id');
        sessionStorage.setItem('activeTab', activeTab);
        $('<form action="/action/showAlertSettings">' + '<input type="hidden" name="type" value="citation" />' + '<input type="hidden" name="menuTab" value="Alerts"/>' + '<input type="hidden" name="sortBy" value="' + sortBy + '"/>' + '</form>').appendTo('body').submit();
      },
      cit_actions_change: function cit_actions_change($el) {
        var form = $el.parents("form"),
            val = $el.attr('data-value');
        if (!val) return;

        if (!$('input[type=checkbox][name="citId"]:checked').length) {
          alerts.on.error_msg();
          return;
        }

        form.find("input[name=action]").val(val);
        if ($el.parents('.dropBlock__holder').length) UX.dropBlock.on.hide();
        var activeTab = "#" + $el.closest("li[role='tabpanel']").attr('id');
        sessionStorage.setItem('activeTab', activeTab);
        form.get(0).submit();
      },
      checkboxCheck: function checkboxCheck($el) {
        var $tr = $el.parents('tr'),
            $checkbox = $tr.find('[type="checkbox"]'),
            $jfccheckbox = $tr.find('.jcf-checkbox');
        $checkbox.prop('checked', true);
        $jfccheckbox.addClass('jcf-checked');
      }
    }
  };
  UX.alerts = alerts; // add to global namespace
})();

(function () {
  var $body = $('body');
  var mrw = {
    $mrwInfo: null,
    $mrwContent: null,
    ajaxUrl: null,
    doiValue: null,
    widgetIdValue: null,
    pbContextValue: null,
    sectionHeadingValue: null,
    init: function init() {
      mrw.$mrwInfo = $(".mrw-toc-meta__info");
      mrw.ajaxUrl = mrw.$mrwInfo.data('url');
      mrw.doiValue = mrw.$mrwInfo.data('doi');
      mrw.widgetIdValue = mrw.$mrwInfo.data('widgetid');
      mrw.pbContextValue = mrw.$mrwInfo.data('pbcontext');
      mrw.control();
    },
    control: function control() {
      if ($("#nonGroupedMRWToc").length) {
        var sectionHeadingValue = "";
        mrw.$mrwContent = $("#nonGroupedMRWToc");
        mrw.getContent(mrw.$mrwContent, sectionHeadingValue, 0);
      }

      if ($("#nonGroupedChapters").length) {
        var sectionHeadingValue = $('#nonGroupedChapters').attr('data-sectionheading');
        mrw.$mrwContent = $("#nonGroupedChapters");
        mrw.getContent(mrw.$mrwContent, sectionHeadingValue, 0);
      }

      $body.on('click', '.accordion__control', function () {
        mrw.$mrwContent = $('#' + $(this).attr('aria-controls'));

        if (!$(this).hasClass('clicked')) {
          $(this).addClass('clicked');
          mrw.$mrwContent = $('#' + $(this).attr('aria-controls'));

          if (mrw.ajaxUrl !== 'undefined') {
            var sectionHeadingValue = $(this).data('sectionheading');
            mrw.getContent(mrw.$mrwContent, sectionHeadingValue, 0);
          }
        }
      });
      $body.on('click', '.pagination a', function (e) {
        var headingSectionHeight = $(this).closest('.accordion__content').prev('.accordion__control').outerHeight();
        $('body, html').animate({
          scrollTop: $(this).closest('.accordion__content').offset().top - (129 + headingSectionHeight)
        }, 300);

        if ($(this).closest('.accordion__content').length) {
          mrw.$mrwContent = $(this).closest('.accordion__content');
          var sectionHeadingValue = $('[aria-controls=' + mrw.$mrwContent.attr('id') + ']').data('sectionheading');
        } else {
          mrw.$mrwContent = $(this).closest('#nonGroupedMRWToc');
          var sectionHeadingValue = "";
        }

        var strtPage;

        if ($(this).is(':empty') && $(this).hasClass("pagination__btn--next")) {
          strtPage = parseInt($('.pagination a.active').attr('title')) - 1 + 1;
        } else if ($(this).is(':empty') && $(this).hasClass("pagination__btn--prev")) {
          strtPage = parseInt($('.pagination a.active').attr('title')) - 1 - 1;
        } else {
          strtPage = parseInt($(this).html()) - 1;
        }

        if (mrw.ajaxUrl !== 'undefined') {
          mrw.getContent(mrw.$mrwContent, sectionHeadingValue, strtPage);
        }
      });
    },
    getContent: function getContent($elem, headingValueParam, strtPage) {
      $elem.children('.inner-result-list').empty(); // Empty the div content

      $elem.children('.mrw-spinner').show(); // show spinner

      $.ajax({
        url: mrw.ajaxUrl,
        data: {
          "doi": mrw.doiValue,
          "widgetId": mrw.widgetIdValue,
          "pbContext": mrw.pbContextValue,
          "sectionHeading": headingValueParam,
          "startPage": strtPage
        },
        type: "GET",
        success: function success(data) {
          //var data = {startPage: 0, pageSize: 20, hitsLength: 200};
          var jsonData = JSON.parse(data).search;
          mrw.build.count($elem, jsonData);
          $elem.children('.inner-result-list').html(jsonData.xslt);
          mrw.build.pager($elem, jsonData);
        },
        complete: function complete() {
          $('.mrw-spinner').hide(); // hide spinner
        }
      });
    },
    build: {
      count: function count($elem, data) {
        var resultFrom = 1 + data.startPage * data.pageSize;
        var resultTo = data.hitsLength < resultFrom + data.pageSize - 1 ? data.hitsLength : resultFrom + data.pageSize - 1;

        if (data.hitsLength > data.pageSize) {
          $elem.find('.inner-result-count').html('<div class="mrw-toc-meta__info"><span class="result__current"><b>' + resultFrom + '-' + resultTo + '</b></span><span class="result__sep"> of </span><span class="result__count"><b>' + data.hitsLength + '</b> articles</span></div>');
        }
      },
      pager: function pager($elem, data) {
        if (data.hitsLength > data.pageSize) {
          var nextPageId = data.startPage + 1;
          var prevPageId = data.startPage - 1;
          var pages = parseInt(data.hitsLength / data.pageSize);

          if (data.hitsLength % data.pageSize > 0) {
            pages++;
          }

          $elem.find('.inner-result-pagination').html('<div class="pagination"></div>');
          var $pager = $elem.find('.pagination');

          if (prevPageId >= 0) {
            $pager.append('<span><a class="pagination__btn--prev" href="#"  title="Previous Page" aria-label="Previous page link"></a></span>');
          }

          $pager.append('<ul class="rlist--inline pagination__list"></ul>');
          var i = 1;

          if (pages > 1) {
            var className = i == data.startPage + 1 ? "active" : "";
            $pager.find('.pagination__list').append('<li><a href="#" title=' + i + '  class=' + className + '>' + i + '</a></li>');

            if (data.startPage >= 4 && data.startPage <= pages - 4) {
              $pager.find('.pagination__list').append('<li><a> ... </a></li>');
            }

            i = data.startPage - 4;

            if (i < 2) {
              i = 2;
            }

            for (var r = i; r < data.startPage + 7; r++) {
              var n = 6 - data.startPage;
              var m = data.startPage - (pages - 5);

              if (i < pages) {
                if (data.startPage < 4) {
                  if (i >= data.startPage - 1 && i <= data.startPage + n) {
                    className = i == data.startPage + 1 ? "active" : "";
                    $pager.find('.pagination__list').append('<li><a href="#" title=' + i + '  class=' + className + '>' + i + '</a></li>');
                  }
                } else if (data.startPage > pages - 4) {
                  if (i >= data.startPage - m && i <= pages) {
                    className = i == data.startPage + 1 ? "active" : "";
                    $pager.find('.pagination__list').append('<li><a href="#" title=' + i + '  class=' + className + '>' + i + '</a></li>');
                    m++;
                  }
                } else {
                  if (i >= data.startPage && i <= data.startPage + 2) {
                    className = i == data.startPage + 1 ? "active" : "";
                    $pager.find('.pagination__list').append('<li><a href="#" title=' + i + '  class=' + className + '>' + i + '</a></li>');
                  }
                }

                i++;
              }
            }

            if (data.startPage >= 4 && data.startPage <= pages - 4) {
              $pager.find('.pagination__list').append('<li><a> ... </a></li>');
            } //i = i > pages? pages : i


            className = i == data.startPage + 1 ? "active" : "";
            $pager.find('.pagination__list').append('<li><a href="#" title=' + i + '  class=' + className + '>' + pages + '</a></li>');
          }

          if (nextPageId < pages) {
            $pager.append('<span><a href="#" title="Next page" aria-label="Next page link" class="pagination__btn--next"></a></span>');
          }
        }
      }
    }
  };
  UX.mrw = mrw; // add to global namespace
})();

UX.favorites.additionalController = function () {
  UX.favorites.pager();
  $('body').on('click', '.delete-item', function (e) {
    e.preventDefault();
    UX.favorites.favDelete($(this));
  });
};

UX.favorites.favDelete = function ($el) {
  UX.favorites.checkboxCheck($el);
  var form = $el.parents("form"); // form.attr('action',action);

  var activeTab = "#" + $el.closest("li[role='tabpanel']").attr('id');
  sessionStorage.setItem('activeTab', activeTab);
  form.get(0).submit();
};

UX.favorites.checkboxCheck = function ($el) {
  var $tr = $el.parents('tr'),
      $checkbox = $tr.find('[type="checkbox"]'),
      $jfccheckbox = $tr.find('.jcf-checkbox');
  $checkbox.prop('checked', true);
  $jfccheckbox.addClass('jcf-checked');
};

UX.favorites.pager = function () {
  var pageSize = 3,
      currentPage = 0,
      $tr = $('.favoriteShortlist').find('tbody').find('tr');

  if (pageSize > 0) {
    $tr.each(function (index) {
      if (index % pageSize === 0) {
        currentPage++;
      }

      $(this).attr('data-page', currentPage);
      $(this).data('page', currentPage);
    });
  }
};

(function () {
  var loadAbst = {
    abst: "",
    target: "",
    init: function init() {
      $(window).on('load', function () {
        if ($('.bookSeries')) {
          loadAbst.get.bookAbst();
        }
      });
    },
    get: {
      bookAbst: function bookAbst() {
        $('.bookSeries__abst').each(function () {
          loadAbst.abst = $(this).data('abst');
          loadAbst.target = $(this).find('.accordion__content');

          if ($(loadAbst.target).is(':empty')) {
            loadAbst.getContent();
          }
        });
      }
    },
    getContent: function getContent() {
      // get content using ajax request
      $(loadAbst.target).load(loadAbst.abst, function (response, status, xhr) {
        if (status === "error") {
          var msg = "Sorry but there was an error: ";
          console.log(msg + xhr.status + " " + xhr.statusText);
          return false; // abort
        }

        $(loadAbst.target).trigger('content-loaded');
      });
    }
  };
  $(document).ready(function () {
    if ($(window).width() < 769) {
      $(".list-of-book-series").append('<a href="#" id="read-more" href="#" title=" Show all"> ...  Show all <i class="icon-section_arrow_d"></i></a>');
      $(document).on('click', '#read-more', function (event) {
        $(".list-of-book-series .topic").show();
        $("#read-more").remove();
        $(".list-of-book-series").append('<a href="#" id="read-less" href="#" title=" Show less"> Show less <i class="icon-section_arrow_u"></i></a>');
      });
      $(document).on('click', '#read-less', function (event) {
        $(".list-of-book-series .topic:nth-child(n+14)").hide();
        $("#read-less").remove();
        $(".list-of-book-series").append('<a href="#" id="read-more" href="#" title=" Show all"> ...  Show all <i class="icon-section_arrow_d"></i></a>');
      });
    }
  });
  UX.loadAbst = loadAbst; // add to global namespace
})();

(function () {
  var $window = $(window),
      $body = $('body');
  var readCubeShare = {
    $target: null,
    $toggle: null,
    $readCubePopUp: null,
    init: function init() {
      readCubeShare.$toggle = $('#share__ctrl');
      readCubeShare.$target = $('.readCube-sharing');
      readCubeShare.$readCubePopUp = $('.readCube-sharing__modal');
      readCubeShare.control();
    },
    control: function control() {
      readCubeShare.$toggle.on('click', function () {
        if (!$(this).hasClass('clicked')) {
          readCubeShare.render();
        }

        $(this).addClass('clicked');
      });
      $('#terms-and-conditions').on('change', function () {
        readCubeShare.acceptTerms($(this));
      });
      $body.on('click', '.shareable-link__btn', function (e) {
        e.preventDefault();
        readCubeShare.copyLink($(this));
      });
    },
    render: function render() {
      $.ajax({
        method: 'GET',
        url: readCubeShare.$target.data('readcube'),
        success: function success(data) {
          if (JSON.parse(data).url) {
            readCubeShare.$target.removeClass('hidden');
            readCubeShare.$readCubePopUp.find('#shareable-link__text').html(JSON.parse(data).url);
            readCubeShare.$readCubePopUp.appendTo('body');
          } else {
            readCubeShare.failed();
          }

          if (JSON.parse(data).token) readCubeShare.$target.attr('data-rc-token', JSON.parse(data).token); // adds the token as data attribute to div.readCube-sharing
        },
        fail: function fail() {
          readCubeShare.failed();
        }
      });
    },
    acceptTerms: function acceptTerms($elem) {
      if ($elem.prop('checked')) {
        readCubeShare.$readCubePopUp.find('.shareable-link__field').css('visibility', 'visible');
        readCubeShare.$readCubePopUp.find('.shareable-link__btn').attr('disabled', false);
        var $token = readCubeShare.$target.data('rc-token');

        if ($token != undefined) {
          tracking.trackEvent("readcube.share.createlink", {
            "share": {
              "create": {
                "token": $token
              }
            }
          });
        }
      }
    },
    failed: function failed() {
      readCubeShare.$target.remove();
      readCubeShare.$readCubePopUp.remove();
    },
    copyLink: function copyLink($elem) {
      var shareableLink = document.getElementById('shareable-link__text');
      var range = document.createRange();
      range.selectNodeContents(shareableLink);
      var sel = window.getSelection();
      sel.removeAllRanges();
      sel.addRange(range);
      document.execCommand("copy");
    }
  };
  UX.readCubeShare = readCubeShare; // add to global namespace
})();

(function () {
  var $body = $('body');
  var slotLicense = {
    $wrapper: null,
    init: function init() {
      slotLicense.$wrapper = $('.slot-license-usage');
      slotLicense.control();
    },
    control: function control() {
      slotLicense.$wrapper.on('click', 'tbody tr', function () {
        window.location.href = $(this).data('href');
      });
      slotLicense.$wrapper.on('click', '.licenseReportForm', function (e) {
        e.stopPropagation();
      });
      slotLicense.$wrapper.on('click', '.licenseReportBtn', function (e) {
        e.stopPropagation();
        UX.dropBlock.$controller = $(this);
        UX.dropBlock.find.target();
      });
      slotLicense.$wrapper.on('click', '.licenseReportForm [type="cancel"]', function (e) {
        e.preventDefault();
        UX.dropBlock.on.hide();
      });
      slotLicense.$wrapper.on('click', '.licenseReportForm [type="submit"]', function (e) {
        e.preventDefault();
        slotLicense.sendReport($(this));
      });
    },
    sendReport: function sendReport($el) {
      var $form = $el.closest('form');
      var ajaxUrl = $form.attr('action');
      var ajaxData = $form.serialize();
      var inputVal = $form.find('[name="emailAddress"]').val();
      var successMsg = '<span class="success"><i class="icon-checkmark" aria-hidden="true"></i>The report has been sent successfully</span>';
      var errorEmptyMsg = '<span class="error"><i class="icon-tools_close" aria-hidden="true"></i>Please enter a valid Email</span>';
      var errorMsg = '<span class="error"><i class="icon-tools_close" aria-hidden="true"></i>The report has not been sent, please try again</span>';

      if (inputVal == '') {
        slotLicense.hideForm($el, errorEmptyMsg);
        return;
      } else {
        var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

        if (!re.test(inputVal)) {
          slotLicense.hideForm($el, errorEmptyMsg);
          return;
        }
      }

      $.ajax({
        url: ajaxUrl + '&' + ajaxData,
        type: 'POST',
        success: function success() {
          slotLicense.hideForm($el, successMsg);
        },
        error: function error() {
          slotLicense.hideForm($el, errorMsg);
        }
      });
    },
    hideForm: function hideForm($el, msg) {
      UX.dropBlock.on.hide();
      UX.dropBlock.$controller = $el;
      UX.dropBlock.find.target();
      UX.dropBlock.$target.find('.infoBox').html(msg);
    }
  };
  UX.slotLicense = slotLicense;
})();

$(document).ready(function () {
  $('.raaAccountInfo input[name="marketable.value"]').on('change', function (e) {
    $('input[name="marketable.value"]').attr('checked', false);
    $(this).attr('checked', true);
    var section = $(this).parents('.marketable')[0].outerHTML,
        $form = $('.raaAccountInfo').find('form'),
        $dropzone = $form.find('.formDropZone');
    $dropzone.append('<div class="hidden">' + section + '</div>'); //$form.find('[type="submit"]').trigger('click');
  });
  $('#institutionList').change(function () {
    console.log($(this).val());
    window.location.href = $(this).val();
  });
  var $entitlements = $('#pane-series');

  if ($entitlements.length > 0) {
    paginate($entitlements);
  }

  function paginate($container) {
    var maxPerPage = 4,
        $table = $container.find('.table-responsive'),
        $tr = $table.find('tbody tr');

    if ($tr.length > maxPerPage) {
      // add pager html
      $table.addClass('js-pages');
      var pager = '<div class="pagination js-pager">\n' + '            <ul class="rlist--inline pagination__list">\n' + '                 <li><a href="#" data-target-page="1" title="1" class="active">1</a></li>\n';
      '            </ul>\n' + '        </div>';
      $table.append(pager);
      var prevPage = 1;
      $tr.each(function (index) {
        var currentPage = parseInt(index / maxPerPage) + 1; // add data-page to table tr

        $(this).attr('data-page', currentPage);

        if (currentPage > prevPage) {
          var page = '<li><a href="#" data-target-page="' + currentPage + '" title="' + currentPage + '">' + currentPage + '</a></li>';
          $table.find('.js-pager ul').append(page);
          prevPage = currentPage;
        }
      });
      UX.pager.$pages = $('.js-pages');
      UX.pager.$pager = $('.js-pager');
      UX.pager.init();
    }
  }
});

UX.searchResult.additionalInit = function () {
  $(window).on("load resize", function () {
    $('.search-results-left').css('margin-top', $('.search-result__top-section').outerHeight());
  });
  $(window).on("load", function () {
    UX.searchResult.formattingPagination();
  });
  $(document).on('click', '.search-result__about-book', function () {
    var type;
    var $elem = $(this).children('.accordion__content');

    if ($elem.is(':empty')) {
      // $elem.append('<img class="spinner" src="/products/pericles/releasedAssets/images/preloader.gif"');
      if ($elem.is('[data-aboutBook]')) type = 'data-aboutBook';
      if ($elem.is('[data-aboutIssue]')) type = 'data-aboutIssue';
      UX.searchResult.renderAbout(type, $elem);
    }
  });
  $('.result__ctrl__filters').on('click', function () {
    if ($(this).hasClass('js--open')) {
      $('.search__bottom').removeClass('scrolled').css({
        'top': 'auto'
      });
    } else {
      $('.search__bottom').addClass('scrolled').animate({
        top: 0
      }, 300);
    }
  });
};

UX.searchResult.renderAbout = function (type, $elem) {
  var aboutBookUrl = $elem.attr(type);
  $elem.load(aboutBookUrl, function (response, status, xhr) {
    if (status === "error") {
      var msg = "Sorry but there was an error: ";
      console.log(msg + xhr.status + " " + xhr.statusText); //$(this).closest(".search-result__about-book").hide();

      $elem.append('<p>' + msg + '</p>');
      return false; // abort
    } // $elem.find('.spinner').remove();

  });
};

UX.searchResult.formattingPagination = function () {
  $('.pagination__list').find('a').each(function () {
    var num = $(this).attr('title');
    num = num.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    $(this).html(num);
  });
};

(function () {
  var institutionDetails = {
    countrySelect: ".countrySelect",
    stateSelect: ".stateSelect",
    stateContainer: ".stateContainer",
    noStatesContainer: ".noStates",
    terms: '#acceptTerms',
    activateBtn: '#activateAccountBtn',
    init: function init() {
      institutionDetails.controller();
      institutionDetails.activateBtnState();
    },
    controller: function controller() {
      $(institutionDetails.countrySelect).change(function () {
        institutionDetails.country_select($(this));
      });
      $(institutionDetails.stateSelect).change(function () {
        institutionDetails.state_select($(this));
      });
      $(document).ready(function () {
        institutionDetails.country_select($(institutionDetails.countrySelect));
      });
      $(document).on('change', ".institutionalProfileActivation ", function (event) {
        institutionDetails.activateBtnState();
      });
      $(document).on('input', "form.institutionDetails ", function (event) {
        var values = false;
        var $form = $(this);
        $form.find('input:not([type="hidden"]), select').each(function () {
          if ($(this).val() && $(this).val() != -1) {
            values = true;
            return;
          }
        });

        if (values) {
          $form.find('[value="cancel"]').attr('disabled', false);
        } else {
          $form.find('[value="cancel"]').attr('disabled', true);
        }
      });
    },
    country_select: function country_select($select) {
      var value = $select.val();
      institutionDetails.disableAllStateSelect();

      if (value != '-1') {
        var $state = $('#country' + value);
        institutionDetails.showStateSelect($state);
      }
    },
    state_select: function state_select($select) {
      var value = $select.val();
      $(institutionDetails.noStatesContainer).find('input').val(value);
    },
    showStateSelect: function showStateSelect($state) {
      if ($state.length !== 0) {
        // $(institutionDetails.noStatesContainer).addClass('hidden');
        $state.parents(institutionDetails.stateContainer).removeClass('hidden');
        $state.parents(institutionDetails.stateContainer).find('select').attr('disabled', false);
      }
    },
    disableAllStateSelect: function disableAllStateSelect() {
      $(institutionDetails.stateContainer).addClass('hidden');
      $(institutionDetails.stateContainer).find('select').attr('disabled', true); // $(institutionDetails.noStatesContainer).removeClass('hidden');

      $(institutionDetails.noStatesContainer).find('input').val('');
    },
    activateBtnState: function activateBtnState() {
      var disabled = !$(institutionDetails.terms).is(":checked");
      $(institutionDetails.activateBtn).attr('disabled', disabled);
    }
  };
  UX.institutionDetails = institutionDetails; // add to global namespace
})();

(function () {
  var profileMenu = {
    menu: ".profile-menu",
    vPort: "screen-sm",
    init: function init() {
      profileMenu.controller();
    },
    controller: function controller() {
      $(document).on(profileMenu.vPort + '-on', function () {
        profileMenu.accordion.make();
      });
      $(document).on(profileMenu.vPort + '-off', function () {
        profileMenu.accordion.destroy();
      });

      if ($('.accordion').length == 0) {
        $(document).on('click', '.profileMenuAccordion .accordion__control', function (e) {
          e.preventDefault();
          UX.accordion.on.toggle.single($(this));

          if ($(this).hasClass('js--open')) {
            $('body, html').addClass('lock-screen');
          } else {
            $('body, html').removeClass('lock-screen');
          }
        });
      }
    },
    accordion: {
      make: function make() {
        var accordion = '<div class="accordion profileMenuAccordion">',
            trigger = '<a href="#" title="Menu" aria-expanded="false" aria-controls="profileMenu" class="accordion__control">' + '<span class="active-link">Profile Menu</span>' + '<i aria-hidden="true" class="icon-section_arrow_d"></i>' + '</a>',
            content = '<div id="profileMenu" class="accordion__content" style="display: none;"></div>';
        accordion += trigger + content + '</div>';
        $(profileMenu.menu).after(accordion);
        $('.profileMenuAccordion .accordion__content').append($(profileMenu.menu));
        var active = $(profileMenu.menu).find('li .active');

        if (active.length !== 0) {
          $('.active-link').text(active.text());
        }
      },
      destroy: function destroy() {
        $('.profileMenuAccordion').after($(profileMenu.menu)).remove();
      }
    }
  };
  UX.profileMenu = profileMenu; // add to global namespace
})();

(function () {
  var manageArticleSelect = {
    $removeUsersBtn: $('.js__removeUsers'),
    $confirmationModal: $('#confirmRemoveUser'),
    selectAllCheckbox: '[name="markallInPage"]',
    $body: $('body'),
    init: function init() {
      $(window).on('load', function (e) {
        if (window.location.hash == '#PERMISSIONS') $('[title="PERMISSIONS"]').click();
      });
      manageArticleSelect.controller();
    },
    controller: function controller() {
      manageArticleSelect.$removeUsersBtn.on('click', function (e) {
        e.preventDefault();
        e.stopPropagation();
        manageArticleSelect.form.submit();
      });
      manageArticleSelect.$body.on('click', manageArticleSelect.selectAllCheckbox, function (e) {
        var $targetrows = $(this).closest('.selectMenuLabel').find('~.table-responsive tr:visible');
        var checkboxes = $targetrows.find('[type="checkbox"]');
        checkboxes.prop('checked', $(this).prop('checked'));
      });
    },
    clearSelectAll: function clearSelectAll() {
      var $selectAllchk = $(manageArticleSelect.selectAllCheckbox);

      if ($selectAllchk.is(':checked')) {
        $selectAllchk.prop('checked', false);
        var $targetrows = $selectAllchk.closest('.selectMenuLabel').find('~.table-responsive tr');
        var checkboxes = $targetrows.find('[type="checkbox"]');
        checkboxes.prop('checked', false);
      }
    },
    form: {
      submit: function submit() {
        var hasUserChecked = manageArticleSelect.form.conflictCheck();

        if (!hasUserChecked) {
          manageArticleSelect.form.error_msg();
          return;
        } else {
          var usrName = [];
          manageArticleSelect.$confirmationModal.find('.usersName').html(usrName);
          manageArticleSelect.$confirmationModal.closest('form').find('[type="checkbox"][name!="markallInPage"]:checked').each(function () {
            var name = $(this).closest('tr').find('td:last-child').html();
            usrName.push(name);
          });

          for (var i in usrName) {
            if (i < usrName.length - 1) manageArticleSelect.$confirmationModal.find('.usersName').append(usrName[i] + ', ');else manageArticleSelect.$confirmationModal.find('.usersName').append(usrName[i]);
          }

          manageArticleSelect.$confirmationModal.modal('show');
        }
      },
      conflictCheck: function conflictCheck() {
        return manageArticleSelect.$removeUsersBtn.closest('form').find('[type="checkbox"]:checked').length !== 0;
      },
      error_msg: function error_msg() {
        alert('Please select at least one user.');
      }
    }
  };
  UX.manageArticleSelect = manageArticleSelect; // add to global namespace
})();

UX.sticko.ads = function () {
  if (UX.sticko.$element.closest('.sticko-ads').length) {
    UX.sticko.$element.css({
      "right": ($(document).width() - $('.container').width()) / 2 - 320,
      "left": "auto"
    });
  }

  var stickyAdElement = $('.sticko-ads').find('.sticko__md');
  var pageHeaderHeight = $('.pageHeader').outerHeight(),
      pagesNavHeight = 0,
      $pagesNav = $('.stickybar__wrapper');

  if ($pagesNav.length) {
    pagesNavHeight = $pagesNav.outerHeight();
  }

  var topPosition = pagesNavHeight + pageHeaderHeight;
  stickyAdElement.css("top", topPosition);
};

UX.slider.on.rebuild.responsive = function () {
  if ($('.slideshow--full-width-image').length) {
    if (UX.slider.isMobile) {
      $('.slideshow-caption').each(function () {
        var $sliderCaption = $(this);

        if ($sliderCaption.outerHeight() > 132) {
          $sliderCaption.outerHeight(132);
          $sliderCaption.find('.read-more-link').css('display', 'block');
        }
      });
    } else {
      $('.read-more-link').css('display', 'none');
    }
  }
};

UX.slider.additionalControls = function () {
  $('body').on('click', '.read-more-link', function () {
    var $sliderCaption = $(this).closest('.slideshow-caption');
    $sliderCaption.toggleClass('js--open');
    var heightVal = $sliderCaption.outerHeight() == 132 ? 'auto' : 132;
    $sliderCaption.css('height', heightVal);
    var text = $(this).text() == 'read less' ? 'read more' : 'read less';
    $(this).text(text);
  });
  $('body').on('click', '.owl-prev, .owl-next, .owl-dot', function () {
    UX.slider.$slider = $(this).closest('.owl-carousel');
    UX.slider.$slider.trigger('stop.owl.autoplay');
  });
};

//(function () {
var players = $('.yt-player'); // 2. This code loads the IFrame Player API code asynchronously.

var tag = document.createElement('script');
tag.src = "https://www.youtube.com/iframe_api";
var firstScriptTag = document.getElementsByTagName('script')[0];
firstScriptTag.parentNode.insertBefore(tag, firstScriptTag); // 3. This function creates an <iframe> (and YouTube player)
//    after the API code downloads.

window.onYouTubeIframeAPIReady = function () {
  players.each(function () {
    var player_data;
    player_data = $(this);
    var player_id = player_data.attr('id');
    var url = player_data.data('url');
    var autoplay = player_data.data('autoplay');
    var wmode = player_data.data('wmode');
    var videoid = YouTubeGetID(url);

    if (videoid != null) {
      console.log("video id = ", videoid);
    } else {
      console.log("The youtube url is not valid.");
    }

    new YT.Player(player_id, {
      height: '100%',
      width: '100%',
      playerVars: {
        autoplay: autoplay
      },
      wmode: wmode,
      videoId: videoid
    });
  });
}; //get youtube video id


function YouTubeGetID(url) {
  var ID = '';
  url = url.replace(/(>|<)/gi, '').split(/(vi\/|v=|\/v\/|youtu\.be\/|\/embed\/)/);

  if (url[2] !== undefined) {
    ID = url[2].split(/[^0-9a-z_\-]/i);
    ID = ID[0];
  } else {
    ID = url;
  }

  return ID;
} //})();

$(document).ready(function () {
  checkMenuItem('#authorBio');
  checkMenuItem('#bookReviews');

  if ($('.menuBook--tab').length) {
    $('.menuBook--tab').find('li:first-child a').click();
  }

  $('.abstract-preview__zoom').fancybox({
    helpers: {
      title: null
    }
  });
});
$(window).load(function () {
  UX.resizeImages('.table-of-content .abstract-preview', 1.75);
});

function checkMenuItem(id) {
  if ($(id + '-pane').length == 0) {
    $(id).remove();
  }
}

(function () {
  var accessDenial = {
    $slotLicense: $('.slotLicenseConsumption'),
    $loginTab: $('.accessDenial--tab .login-options'),
    isSlide: false,
    init: function init() {
      $('.accessDenial--tab .accordion-tabbed__tab.js--open > a').click();
      accessDenial.control();
    },
    control: function control() {
      accessDenial.$slotLicense.on('click', '.linkBtn', function (e) {
        e.preventDefault();

        if (!accessDenial.$loginTab.hasClass('js--open')) {
          accessDenial.$loginTab.find('> a').click();
        }
      });
    }
  };
  UX.accessDenial = accessDenial;
})();

(function () {
  var holdings = {
    init: function init() {
      holdings.checkRecipientEmail($('[name="customerEmail"]:checked'), $('#customer-report'));
      holdings.checkRecipientEmail($('[name="KBARTEmail"]:checked'), $('#KBART-report'));
      holdings.control();
    },
    control: function control() {
      $('[name="customerEmail"]').on('change', function () {
        holdings.checkRecipientEmail($('[name="customerEmail"]:checked'), $('#customer-report'));
      });
      $('[name="KBARTEmail"]').on('change', function () {
        holdings.checkRecipientEmail($('[name="KBARTEmail"]:checked'), $('#KBART-report'));
      });
    },
    checkRecipientEmail: function checkRecipientEmail($radio, $input) {
      $input.attr('required', $radio.val() == 'CustomEmail');
    }
  };
  UX.holdings = holdings;
})();

$(document).ready(function () {
  if ($('.addresses').length) {
    var $formButtons = $('.addresses').closest('#personalInformationForm').find('.form-btn');
    var addressState = $('.switch-address').val();

    if (!addressState) {
      $formButtons.show();
    } else {
      $formButtons.hide();
    }

    $('.switch-address').on('change', function () {
      var addressState = $('.switch-address').val();

      if (!addressState) {
        $formButtons.show();
      } else {
        $formButtons.hide();
      }
    });
    $('.edit-address').on('click', function () {
      var addressState = $('.switch-address').val();

      if (!addressState) {
        $formButtons.hide();
      } else {
        $formButtons.show();
      }
    });
  }
});
$(window).load(function () {
  var addressAccordion = $('.addresses-accordion .accordion__control');

  if ($('.accordion__content #address .label').hasClass('error')) {
    UX.accordion.on.toggle.single(addressAccordion);
  }
});

UX.menu.additionalControl = function () {
  $('body').on('click', 'li.dropdown', function (e) {
    if (!UX.menu.isMobile) {
      var isOpen = false;

      if ($(this).hasClass('js--open')) {
        isOpen = true;
      }

      $('li.dropdown').removeClass('js--open');
      $('.dropdown__toggle').removeClass('hover');

      if (!isOpen) {
        $(this).addClass('js--open').children('.dropdown__toggle').addClass('hover');
      }
    }
  });
};

UX.menu.on.showAdditional = function () {
  var isMenuOpen = $('body').data('active') == 'menu' ? true : false;

  if (isMenuOpen) {
    $('html').css('overflow', 'visible');
  }
};

$(document).on('click', '#confirm-dialog', function () {
  $('input[name="confirm"]').val('true');
  window.location.href = window.location.href + '&confirm=true';
});
$(document).on('click', '#cancel-dialog', function () {
  $('input[name="confirm"]').val('false');
  window.location.href = window.location.href + '&confirm=false';
});

$(window).load(function () {
  UX.resizeImages('.top-content .abstract-preview', 1.75);
});

(function () {
  var enquireIt = {
    init: function init() {
      // console.log("max-width:"+  (parseInt(UX.grid.screenSm) -1) +"px");
      // Responsive behavior controllers ( media query listeners )
      UX.controller.enabled = true;
      enquire.register("screen and (max-width:" + (parseInt(UX.grid.screenXs) - 1) + "px)", {
        match: function match() {
          $(document).trigger("screen-xs-on"); // screen is xs

          $(document).trigger("smartResize"); // resize have been made
        },
        unmatch: function unmatch() {
          $(document).trigger("screen-xs-off"); // screen is not xs anymore

          $(document).trigger("smartResize"); // resize have been made
        }
      }).register("screen and (max-width:" + (parseInt(UX.grid.screenSm) - 1) + "px)", {
        match: function match() {
          $(document).trigger("screen-sm-on"); // screen is sm

          $(document).trigger("smartResize"); // resize have been made
        },
        unmatch: function unmatch() {
          $(document).trigger("screen-sm-off"); // screen is not sm anymore

          $(document).trigger("smartResize"); // resize have been made
        }
      }).register("screen and (max-width:" + (parseInt(UX.grid.screenMd) - 1) + "px)", {
        match: function match() {
          $(document).trigger("screen-md-on"); // screen is md

          $(document).trigger("smartResize"); // resize have been made
        },
        unmatch: function unmatch() {
          $(document).trigger("screen-md-off"); // screen is not md anymore

          $(document).trigger("smartResize"); // resize have been made
        }
      }).register("screen and (max-width:" + (parseInt(UX.grid.screenLg) - 1) + "px)", {
        match: function match() {
          $(document).trigger("screen-lg-on"); // screen is md

          $(document).trigger("smartResize"); // resize have been made
        },
        unmatch: function unmatch() {
          $(document).trigger("screen-lg-off"); // screen is not md anymore

          $(document).trigger("smartResize"); // resize have been made
        }
      }).register("screen and (min-width:0px)", {
        match: function match() {
          $(document).trigger("screen-xlg-on"); // screen is md

          $(document).trigger("smartResize"); // resize have been made
        }
        /*unmatch : function() {
            $(document).trigger("screen-xlg-off"); // screen is not md anymore
            $(document).trigger("smartResize"); // resize have been made
         }*/

      });
    }
  };
  UX.enquireIt = enquireIt; // add to global namespace
})();

// Import components
//***** Importing UX3 Widgets Javascript as needed *****//

(function () {
  $(document).ready(function () {
    UX.controller.init();

    if (!$(".source_example").length && $(".sticko , .sticko__md, .sticko__sm").length) {
      UX.sticko.init();
    }

    if ($(".table-fn").length || $('.ref.fn').length || $(".scroll-to-target").length || $("a.sr-only-focusable").length) {
      UX.scrollo.init();
    }

    if ($('[data-toggle="nav"], .hubpage-menu').length) {
      UX.menu.init();
    }

    if ($('.coolBar').length) {
      UX.coolbar.vPort = "screen-md";
      UX.coolbar.init();
    }

    if ($('.stickybar').length) {
      UX.stickybar.vPort = "screen-md";
      UX.stickybar.init();
      UX.setStickeyTop.init();
    }

    if ($('[data-db-target-for]').length) {
      UX.dropBlock.init();
    }

    if ($('[data-toggle="modal"]').length) {
      UX.modal.init();
    }

    if ($('table').length) {
      UX.toggleTable.init();
    }

    if ($('#dateFacet .range-slider').length) {
      UX.facetDate.init();
    }

    if ($('.accordion').length) {
      UX.accordion.init();
    }

    if ($('.refineSearch').length) {
      UX.refine.init();
    }

    if ($('figure').length) {
      UX.figureViewer.init();
    }

    if ($('.tab').length) {
      UX.tab.vPort = "screen-md";
      UX.tab.init();
    }

    if ($('.owl-carousel').length) {
      UX.slider.init();
    }

    if ($('.quick-search').length) {
      UX.quickSearch.vPort = "screen-lg";
      UX.quickSearch.init();
    }

    if ($('article').length) {
      UX.loader.init();
    }

    if ($('.advanced-search').length) {
      UX.searchFieldsCtrl.init();
    }

    if ($(".search__filters__ctrl__reset").length) {
      UX.appliedFacets.init();
    }

    if ($('[data-toggle="transplant"]').length) {
      UX.transplant.init();
    }

    if ($(".expandable-list").length) {
      UX.list.init();
    }

    if ($(".loc.swipe__list").length) {
      UX.sliderTabs.init();
    }

    if ($('.usageReports').length) {
      UX.reports.init();
    }

    if ($('.popover').length) {
      UX.popover.init();
    }

    if ($('.ip-ranges').length) {
      UX.ipRanges.init();
    }

    UX.alerts.init();
    UX.searchResult.init();

    if ($('.loi').length) {
      UX.loi.init();
    }

    if ($('.favoriteShortlist').length) {
      UX.favorites.init();
    }

    if ($('.bookSeries').length) {
      UX.loadAbst.init();
    }

    if ($('.js-pager').length) {
      UX.pager.init();
    }

    if ($('.table--sortable').length) {
      UX.sortableTable.init();
    }

    UX.fieldsCtrl.init();

    if ($('.readCube-sharing').length) {
      UX.readCubeShare.init();
    }

    if ($('.slot-license-usage').length) {
      UX.slotLicense.init();
    }

    if ($('.mrw-toc-meta__info').length) {
      UX.mrw.init();
    }

    if ($('.facet').length) {
      UX.toggle.init();
    }

    if ($('.institutionDetails').length) {
      UX.institutionDetails.init();
    }

    if ($('.profile-menu').length) {
      UX.profileMenu.vPort = "screen-md";
      UX.profileMenu.init();
    }

    if ($('.js__removeUsers').length) {
      UX.manageArticleSelect.init();
    }

    if ($('.js__removeAdmins').length) {
      UX.administrators.init();
    }

    if ($('.holdingContainer').length) {
      UX.holdings.init();
    }

    if ($('.w-slide__btn').length) {
      UX.slide.vPort = "screen-md"; //UX.slide.backLabel = "About";// it effects the slide back label btn in all cases

      UX.slide.init();
    }

    if ($("#institutionUsageReport").length) {
      UX.reports.init();
    }

    if ($('.cookiePolicy-popup').length) {
      UX.cookiePolicyPopupWidget.init();
    }

    if ($("#fakeEmail").length) {
      UX.email.init();
    }

    if ($(".slotLicenseConsumption").length) {
      UX.accessDenial.init();
    }

    if ($(".back-to-top").length) {
      UX.backToTop.init();
    }

    UX.scroll.init();
    UX.enquireIt.init(); // important: keep it always last
  });
})();

}());
//# sourceMappingURL=main.bundle.js.map
